/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","os","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stopwatch","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/encodedTokenAttributes","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/macAddress","vs/base/node/nls","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/editor/common/languages","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","readline","util","minimist","assert","https","http","vs/server/node/server.main"],Ae=function(ue){for(var e=[],t=0,s=ue.length;t<s;t++)e[t]=Re[ue[t]];return e};define(Re[103],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var t;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(t||(e.LoaderEventType=t={}));class s{static get(){const k=new Map,C=new Map,A=new Map,y=new Map;function o(a,u){a.has(u.detail)||a.set(u.detail,-u.timestamp)}function D(a,u){const d=a.get(u.detail);d&&(d>=0||a.set(u.detail,d+u.timestamp))}let w=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(w=ue.getStats().slice(0).sort((a,u)=>a.timestamp-u.timestamp));for(const a of w)switch(a.type){case t.BeginLoadingScript:o(k,a);break;case t.EndLoadingScriptOK:case t.EndLoadingScriptError:D(k,a);break;case t.BeginInvokeFactory:o(C,a);break;case t.EndInvokeFactory:D(C,a);break;case t.NodeBeginNativeRequire:o(A,a);break;case t.NodeEndNativeRequire:D(A,a);break;case t.NodeBeginEvaluatingScript:o(y,a);break;case t.NodeEndEvaluatingScript:D(y,a);break}let m=0;A.forEach(a=>m+=a);function $(a){const u=[];return a.forEach((d,f)=>u.push([f,d])),u}return{amdLoad:$(k),amdInvoke:$(C),nodeRequire:$(A),nodeEval:$(y),nodeRequireTotal:m}}static toMarkdownTable(k,C){let A="";const y=[];return k.forEach((o,D)=>{y[D]=o.length}),C.forEach(o=>{o.forEach((D,w)=>{typeof D>"u"&&(D=o[w]="-");const m=D.toString().length;y[w]=Math.max(m,y[w])})}),k.forEach((o,D)=>{A+=`| ${o+" ".repeat(y[D]-o.toString().length)} `}),A+=`|
`,k.forEach((o,D)=>{A+=`| ${"-".repeat(y[D])} `}),A+=`|
`,C.forEach(o=>{o.forEach((D,w)=>{typeof D<"u"&&(A+=`| ${D+" ".repeat(y[w]-D.toString().length)} `)}),A+=`|
`}),A}}e.$S=s}),define(Re[104],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=t,e.$fb=s,e.$gb=E,e.$hb=k,e.$ib=C,e.$jb=A,e.$kb=y,e.$mb=D,e.$nb=w,e.$ob=m,e.$pb=$,e.$qb=a;function t(u,d){const f=s(u,d);if(f!==-1)return u[f]}function s(u,d,f=u.length-1){for(let v=f;v>=0;v--){const g=u[v];if(d(g))return v}return-1}function E(u,d){const f=k(u,d);return f===-1?void 0:u[f]}function k(u,d,f=0,v=u.length){let g=f,b=v;for(;g<b;){const i=Math.floor((g+b)/2);d(u[i])?g=i+1:b=i}return g-1}function C(u,d){const f=A(u,d);return f===u.length?void 0:u[f]}function A(u,d,f=0,v=u.length){let g=f,b=v;for(;g<b;){const i=Math.floor((g+b)/2);d(u[i])?b=i:g=i+1}return g}function y(u,d,f=0,v=u.length){const g=A(u,d,f,v);return g===u.length?-1:g}class o{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(o.assertInvariants){if(this.d){for(const v of this.e)if(this.d(v)&&!d(v))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const f=k(this.e,d,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$lb=o;function D(u,d){if(u.length===0)return;let f=u[0];for(let v=1;v<u.length;v++){const g=u[v];d(g,f)>0&&(f=g)}return f}function w(u,d){if(u.length===0)return;let f=u[0];for(let v=1;v<u.length;v++){const g=u[v];d(g,f)>=0&&(f=g)}return f}function m(u,d){return D(u,(f,v)=>-d(f,v))}function $(u,d){if(u.length===0)return-1;let f=0;for(let v=1;v<u.length;v++){const g=u[v];d(g,u[f])>0&&(f=v)}return f}function a(u,d){for(const f of u){const v=d(f);if(v!==void 0)return v}}}),define(Re[34],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var t;(function(s){s[s.Null=0]="Null",s[s.Backspace=8]="Backspace",s[s.Tab=9]="Tab",s[s.LineFeed=10]="LineFeed",s[s.CarriageReturn=13]="CarriageReturn",s[s.Space=32]="Space",s[s.ExclamationMark=33]="ExclamationMark",s[s.DoubleQuote=34]="DoubleQuote",s[s.Hash=35]="Hash",s[s.DollarSign=36]="DollarSign",s[s.PercentSign=37]="PercentSign",s[s.Ampersand=38]="Ampersand",s[s.SingleQuote=39]="SingleQuote",s[s.OpenParen=40]="OpenParen",s[s.CloseParen=41]="CloseParen",s[s.Asterisk=42]="Asterisk",s[s.Plus=43]="Plus",s[s.Comma=44]="Comma",s[s.Dash=45]="Dash",s[s.Period=46]="Period",s[s.Slash=47]="Slash",s[s.Digit0=48]="Digit0",s[s.Digit1=49]="Digit1",s[s.Digit2=50]="Digit2",s[s.Digit3=51]="Digit3",s[s.Digit4=52]="Digit4",s[s.Digit5=53]="Digit5",s[s.Digit6=54]="Digit6",s[s.Digit7=55]="Digit7",s[s.Digit8=56]="Digit8",s[s.Digit9=57]="Digit9",s[s.Colon=58]="Colon",s[s.Semicolon=59]="Semicolon",s[s.LessThan=60]="LessThan",s[s.Equals=61]="Equals",s[s.GreaterThan=62]="GreaterThan",s[s.QuestionMark=63]="QuestionMark",s[s.AtSign=64]="AtSign",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.OpenSquareBracket=91]="OpenSquareBracket",s[s.Backslash=92]="Backslash",s[s.CloseSquareBracket=93]="CloseSquareBracket",s[s.Caret=94]="Caret",s[s.Underline=95]="Underline",s[s.BackTick=96]="BackTick",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.OpenCurlyBrace=123]="OpenCurlyBrace",s[s.Pipe=124]="Pipe",s[s.CloseCurlyBrace=125]="CloseCurlyBrace",s[s.Tilde=126]="Tilde",s[s.NoBreakSpace=160]="NoBreakSpace",s[s.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",s[s.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",s[s.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",s[s.U_Combining_Tilde=771]="U_Combining_Tilde",s[s.U_Combining_Macron=772]="U_Combining_Macron",s[s.U_Combining_Overline=773]="U_Combining_Overline",s[s.U_Combining_Breve=774]="U_Combining_Breve",s[s.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",s[s.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",s[s.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",s[s.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",s[s.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",s[s.U_Combining_Caron=780]="U_Combining_Caron",s[s.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",s[s.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",s[s.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",s[s.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",s[s.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",s[s.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",s[s.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",s[s.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",s[s.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",s[s.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",s[s.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",s[s.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",s[s.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",s[s.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",s[s.U_Combining_Horn=795]="U_Combining_Horn",s[s.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",s[s.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",s[s.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",s[s.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",s[s.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",s[s.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",s[s.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",s[s.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",s[s.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",s[s.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",s[s.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",s[s.U_Combining_Cedilla=807]="U_Combining_Cedilla",s[s.U_Combining_Ogonek=808]="U_Combining_Ogonek",s[s.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",s[s.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",s[s.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",s[s.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",s[s.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",s[s.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",s[s.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",s[s.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",s[s.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",s[s.U_Combining_Low_Line=818]="U_Combining_Low_Line",s[s.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",s[s.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",s[s.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",s[s.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",s[s.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",s[s.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",s[s.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",s[s.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",s[s.U_Combining_Square_Below=827]="U_Combining_Square_Below",s[s.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",s[s.U_Combining_X_Above=829]="U_Combining_X_Above",s[s.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",s[s.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",s[s.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",s[s.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",s[s.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",s[s.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",s[s.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",s[s.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",s[s.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",s[s.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",s[s.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",s[s.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",s[s.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",s[s.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",s[s.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",s[s.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",s[s.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",s[s.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",s[s.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",s[s.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",s[s.U_Combining_Fermata=850]="U_Combining_Fermata",s[s.U_Combining_X_Below=851]="U_Combining_X_Below",s[s.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",s[s.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",s[s.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",s[s.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",s[s.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",s[s.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",s[s.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",s[s.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",s[s.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",s[s.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",s[s.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",s[s.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",s[s.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",s[s.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",s[s.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",s[s.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",s[s.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",s[s.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",s[s.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",s[s.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",s[s.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",s[s.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",s[s.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",s[s.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",s[s.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",s[s.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",s[s.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",s[s.LINE_SEPARATOR=8232]="LINE_SEPARATOR",s[s.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",s[s.NEXT_LINE=133]="NEXT_LINE",s[s.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",s[s.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",s[s.U_DIAERESIS=168]="U_DIAERESIS",s[s.U_MACRON=175]="U_MACRON",s[s.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",s[s.U_CEDILLA=184]="U_CEDILLA",s[s.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",s[s.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",s[s.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",s[s.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",s[s.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",s[s.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",s[s.U_BREVE=728]="U_BREVE",s[s.U_DOT_ABOVE=729]="U_DOT_ABOVE",s[s.U_RING_ABOVE=730]="U_RING_ABOVE",s[s.U_OGONEK=731]="U_OGONEK",s[s.U_SMALL_TILDE=732]="U_SMALL_TILDE",s[s.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",s[s.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",s[s.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",s[s.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",s[s.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",s[s.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",s[s.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",s[s.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",s[s.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",s[s.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",s[s.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",s[s.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",s[s.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",s[s.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",s[s.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",s[s.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",s[s.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",s[s.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",s[s.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",s[s.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",s[s.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",s[s.U_GREEK_TONOS=900]="U_GREEK_TONOS",s[s.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",s[s.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",s[s.U_GREEK_PSILI=8127]="U_GREEK_PSILI",s[s.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",s[s.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",s[s.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",s[s.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",s[s.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",s[s.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",s[s.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",s[s.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",s[s.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",s[s.U_GREEK_VARIA=8175]="U_GREEK_VARIA",s[s.U_GREEK_OXIA=8189]="U_GREEK_OXIA",s[s.U_GREEK_DASIA=8190]="U_GREEK_DASIA",s[s.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",s[s.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",s[s.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",s[s.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",s[s.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",s[s.U_OVERLINE=8254]="U_OVERLINE",s[s.UTF8_BOM=65279]="UTF8_BOM",s[s.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",s[s.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(e.CharCode=t={}))}),define(Re[156],Ae([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=s,e.$d=E,e.$e=k,e.$f=C;function s(y,o){const D=Object.create(null);for(const w of y){const m=o(w);let $=D[m];$||($=D[m]=[]),$.push(w)}return D}function E(y,o){const D=[],w=[];for(const m of y)o.has(m)||D.push(m);for(const m of o)y.has(m)||w.push(m);return{removed:D,added:w}}function k(y,o){const D=[],w=[];for(const[m,$]of y)o.has(m)||D.push($);for(const[m,$]of o)y.has(m)||w.push($);return{removed:D,added:w}}function C(y,o){const D=new Set;for(const w of o)y.has(w)&&D.add(w);return D}class A{static{t=Symbol.toStringTag}constructor(o,D){this.b=D,this.a=new Map,this[t]="SetWithKey";for(const w of o)this.add(w)}get size(){return this.a.size}add(o){const D=this.b(o);return this.a.set(D,o),this}delete(o){return this.a.delete(this.b(o))}has(o){return this.a.has(this.b(o))}*entries(){for(const o of this.a.values())yield[o,o]}keys(){return this.values()}*values(){for(const o of this.a.values())yield o}clear(){this.a.clear()}forEach(o,D){this.a.forEach(w=>o.call(D,w,w,this))}[Symbol.iterator](){return this.values()}}e.$g=A}),define(Re[77],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=s,e.$$h=E,e.$_h=k;function t(C){return(A,y,o)=>{let D=null,w=null;if(typeof o.value=="function"?(D="value",w=o.value):typeof o.get=="function"&&(D="get",w=o.get),!w)throw new Error("not supported");o[D]=C(w,y)}}function s(C,A,y){let o=null,D=null;if(typeof y.value=="function"?(o="value",D=y.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(o="get",D=y.get),!D)throw new Error("not supported");const w=`$memoize$${A}`;y[o]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,m)}),this[w]}}function E(C,A,y){return t((o,D)=>{const w=`$debounce$${D}`,m=`$debounce$result$${D}`;return function(...$){this[m]||(this[m]=y?y():void 0),clearTimeout(this[w]),A&&(this[m]=A(this[m],...$),$=[this[m]]),this[w]=setTimeout(()=>{o.apply(this,$),this[m]=y?y():void 0},C)}})}function k(C,A,y){return t((o,D)=>{const w=`$throttle$timer$${D}`,m=`$throttle$result$${D}`,$=`$throttle$lastRun$${D}`,a=`$throttle$pending$${D}`;return function(...u){if(this[m]||(this[m]=y?y():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...u)),this[a])return;const d=this[$]+C;d<=Date.now()?(this[$]=Date.now(),o.apply(this,[this[m]]),this[m]=y?y():void 0):(this[a]=!0,this[w]=setTimeout(()=>{this[a]=!1,this[$]=Date.now(),o.apply(this,[this[m]]),this[m]=y?y():void 0},d-Date.now()))}})}}),define(Re[9],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=s,e.$X=E,e.$Y=k,e.$Z=C,e.$1=A,e.$2=y,e.$3=D,e.$5=m,e.$6=$,e.$7=a,e.$9=d;class t{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?b.isErrorNoTelemetry(n)?new b(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(l=>{l(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$U=t,e.$V=new t;function s(p){e.$V.setUnexpectedErrorHandler(p)}function E(p){if(!p||typeof p!="object")return!1;const n=p;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function k(p){D(p)||e.$V.onUnexpectedError(p)}function C(p){D(p)||e.$V.onUnexpectedExternalError(p)}function A(p){if(p instanceof Error){const{name:n,message:l}=p,r=p.stacktrace||p.stack;return{$isError:!0,name:n,message:l,stack:r,noTelemetry:b.isErrorNoTelemetry(p)}}return p}function y(p){let n;return p.noTelemetry?n=new b:(n=new Error,n.name=p.name),n.message=p.message,n.stack=p.stack,n}const o="Canceled";function D(p){return p instanceof w?!0:p instanceof Error&&p.name===o&&p.message===o}class w extends Error{constructor(){super(o),this.name=this.message}}e.$4=w;function m(){const p=new Error(o);return p.name=p.message,p}function $(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}function a(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}class u extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=u;function d(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$0=f;class v extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$$=v;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=g;class b extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof b)return n;const l=new b;return l.message=n.message,l.stack=n.stack,l}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$ab=b;class i extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,i.prototype)}}e.$bb=i}),define(Re[17],Ae([1,0,9,104]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=E,e.$sb=k,e.$tb=C,e.$ub=A,e.$vb=y,e.$wb=o,e.$xb=D,e.$yb=w,e.$zb=m,e.$Ab=$,e.$Bb=a,e.$Cb=u,e.$Db=d,e.top=f,e.$Fb=v,e.$Gb=b,e.$Hb=i,e.$Ib=p,e.$Jb=n,e.$Kb=l,e.$Lb=r,e.$Mb=h,e.$Nb=c,e.$Ob=S,e.$Pb=I,e.$Qb=R,e.$Rb=L,e.$Sb=O,e.$Tb=P,e.$Ub=q,e.$Vb=K,e.$Wb=J,e.$Xb=_,e.$Yb=de,e.$Zb=ge,e.$1b=le,e.$2b=z,e.$3b=Q,e.$4b=M,e.$5b=re,e.$6b=me,e.$9b=x,e.$ac=he;function E(B,U=0){return B[B.length-(1+U)]}function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function C(B,U,H=(F,W)=>F===W){if(B===U)return!0;if(!B||!U||B.length!==U.length)return!1;for(let F=0,W=B.length;F<W;F++)if(!H(B[F],U[F]))return!1;return!0}function A(B,U){const H=B.length-1;U<H&&(B[U]=B[H]),B.pop()}function y(B,U,H){return o(B.length,F=>H(B[F],U))}function o(B,U){let H=0,F=B-1;for(;H<=F;){const W=(H+F)/2|0,Y=U(W);if(Y<0)H=W+1;else if(Y>0)F=W-1;else return W}return-(H+1)}function D(B,U,H){if(B=B|0,B>=U.length)throw new TypeError("invalid index");const F=U[Math.floor(U.length*Math.random())],W=[],Y=[],ae=[];for(const Ee of U){const Le=H(Ee,F);Le<0?W.push(Ee):Le>0?Y.push(Ee):ae.push(Ee)}return B<W.length?D(B,W,H):B<W.length+ae.length?ae[0]:D(B-(W.length+ae.length),Y,H)}function w(B,U){const H=[];let F;for(const W of B.slice(0).sort(U))!F||U(F[0],W)!==0?(F=[W],H.push(F)):F.push(W);return H}function*m(B,U){let H,F;for(const W of B)F!==void 0&&U(F,W)?H.push(W):(H&&(yield H),H=[W]),F=W;H&&(yield H)}function $(B,U){for(let H=0;H<=B.length;H++)U(H===0?void 0:B[H-1],H===B.length?void 0:B[H])}function a(B,U){for(let H=0;H<B.length;H++)U(H===0?void 0:B[H-1],B[H],H+1===B.length?void 0:B[H+1])}function u(B,U,H){const F=[];function W(Ee,Le,be){if(Le===0&&be.length===0)return;const pe=F[F.length-1];pe&&pe.start+pe.deleteCount===Ee?(pe.deleteCount+=Le,pe.toInsert.push(...be)):F.push({start:Ee,deleteCount:Le,toInsert:be})}let Y=0,ae=0;for(;;){if(Y===B.length){W(Y,0,U.slice(ae));break}if(ae===U.length){W(Y,B.length-Y,[]);break}const Ee=B[Y],Le=U[ae],be=H(Ee,Le);be===0?(Y+=1,ae+=1):be<0?(W(Y,1,[]),Y+=1):be>0&&(W(Y,0,[Le]),ae+=1)}return F}function d(B,U,H){const F=u(B,U,H),W=[],Y=[];for(const ae of F)W.push(...B.slice(ae.start,ae.start+ae.deleteCount)),Y.push(...ae.toInsert);return{removed:W,added:Y}}function f(B,U,H){if(H===0)return[];const F=B.slice(0,H).sort(U);return g(B,U,F,H,B.length),F}function v(B,U,H,F,W){return H===0?Promise.resolve([]):new Promise((Y,ae)=>{(async()=>{const Ee=B.length,Le=B.slice(0,H).sort(U);for(let be=H,pe=Math.min(H+F,Ee);be<Ee;be=pe,pe=Math.min(pe+F,Ee)){if(be>H&&await new Promise(we=>setTimeout(we)),W&&W.isCancellationRequested)throw new t.$4;g(B,U,Le,be,pe)}return Le})().then(Y,ae)})}function g(B,U,H,F,W){for(const Y=H.length;F<W;F++){const ae=B[F];if(U(ae,H[Y-1])<0){H.pop();const Ee=(0,s.$jb)(H,Le=>U(ae,Le)<0);H.splice(Ee,0,ae)}}}function b(B){return B.filter(U=>!!U)}function i(B){let U=0;for(let H=0;H<B.length;H++)B[H]&&(B[U]=B[H],U+=1);B.length=U}function p(B,U,H){B.splice(H,0,B.splice(U,1)[0])}function n(B){return!Array.isArray(B)||B.length===0}function l(B){return Array.isArray(B)&&B.length>0}function r(B,U=H=>H){const H=new Set;return B.filter(F=>{const W=U(F);return H.has(W)?!1:(H.add(W),!0)})}function h(B){const U=new Set;return H=>{const F=B(H);return U.has(F)?!1:(U.add(F),!0)}}function c(B,U){return B.length>0?B[0]:U}function S(B,U){return B.length>0?B[B.length-1]:U}function I(B,U,H=(F,W)=>F===W){let F=0;for(let W=0,Y=Math.min(B.length,U.length);W<Y&&H(B[W],U[W]);W++)F++;return F}function R(B,U){let H=typeof U=="number"?B:0;typeof U=="number"?H=B:(H=0,U=B);const F=[];if(H<=U)for(let W=H;W<U;W++)F.push(W);else for(let W=H;W>U;W--)F.push(W);return F}function L(B,U,H){return B.reduce((F,W)=>(F[U(W)]=H?H(W):W,F),Object.create(null))}function O(B,U){return B.push(U),()=>P(B,U)}function P(B,U){const H=B.indexOf(U);if(H>-1)return B.splice(H,1),U}function q(B,U,H){const F=B.slice(0,U),W=B.slice(U);return F.concat(H,W)}function K(B,U){let H;if(typeof U=="number"){let F=U;H=()=>{const W=Math.sin(F++)*179426549;return W-Math.floor(W)}}else H=Math.random;for(let F=B.length-1;F>0;F-=1){const W=Math.floor(H()*(F+1)),Y=B[F];B[F]=B[W],B[W]=Y}}function J(B,U){const H=B.indexOf(U);H>-1&&(B.splice(H,1),B.unshift(U))}function _(B,U){const H=B.indexOf(U);H>-1&&(B.splice(H,1),B.push(U))}function de(B,U){for(const H of U)B.push(H)}function ge(B,U){return Array.isArray(B)?B.map(U):U(B)}function le(B){return Array.isArray(B)?B:[B]}function z(B){return B[Math.floor(Math.random()*B.length)]}function Q(B,U,H){const F=V(B,U),W=B.length,Y=H.length;B.length=W+Y;for(let ae=W-1;ae>=F;ae--)B[ae+Y]=B[ae];for(let ae=0;ae<Y;ae++)B[ae+F]=H[ae]}function M(B,U,H,F){const W=V(B,U);let Y=B.splice(W,H);return Y===void 0&&(Y=[]),Q(B,W,F),Y}function V(B,U){return U<0?Math.max(U+B.length,0):Math.min(U,B.length)}var ne;(function(B){function U(Y){return Y<0}B.isLessThan=U;function H(Y){return Y<=0}B.isLessThanOrEqual=H;function F(Y){return Y>0}B.isGreaterThan=F;function W(Y){return Y===0}B.isNeitherLessOrGreaterThan=W,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function re(B,U){return(H,F)=>U(B(H),B(F))}function me(...B){return(U,H)=>{for(const F of B){const W=F(U,H);if(!ne.isNeitherLessOrGreaterThan(W))return W}return ne.neitherLessOrGreaterThan}}const oe=(B,U)=>B-U;e.$7b=oe;const ie=(B,U)=>(0,e.$7b)(B?1:0,U?1:0);e.$8b=ie;function x(B){return(U,H)=>-B(U,H)}class G{constructor(U){this.g=U,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(U){let H=this.c;for(;H<this.g.length&&U(this.g[H]);)H++;const F=H===this.c?null:this.g.slice(this.c,H);return this.c=H,F}takeFromEndWhile(U){let H=this.d;for(;H>=0&&U(this.g[H]);)H--;const F=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const U=this.g[this.c];return this.c++,U}removeLast(){const U=this.g[this.d];return this.d--,U}takeCount(U){const H=this.g.slice(this.c,this.c+U);return this.c+=U,H}}e.$0b=G;class T{static{this.empty=new T(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(H=>(U(H),!0))}toArray(){const U=[];return this.iterate(H=>(U.push(H),!0)),U}filter(U){return new T(H=>this.iterate(F=>U(F)?H(F):!0))}map(U){return new T(H=>this.iterate(F=>H(U(F))))}some(U){let H=!1;return this.iterate(F=>(H=U(F),!H)),H}findFirst(U){let H;return this.iterate(F=>U(F)?(H=F,!1):!0),H}findLast(U){let H;return this.iterate(F=>(U(F)&&(H=F),!0)),H}findLastMaxBy(U){let H,F=!0;return this.iterate(W=>((F||ne.isGreaterThan(U(W,H)))&&(F=!1,H=W),!0)),H}}e.$$b=T;class X{constructor(U){this.c=U}static createSortPermutation(U,H){const F=Array.from(U.keys()).sort((W,Y)=>H(U[W],U[Y]));return new X(F)}apply(U){return U.map((H,F)=>U[this.c[F]])}inverse(){const U=this.c.slice();for(let H=0;H<this.c.length;H++)U[this.c[H]]=H;return new X(U)}}e.$_b=X;async function he(B,U){return(await Promise.all(B.map(async(F,W)=>({element:F,ok:await U(F,W)})))).find(F=>F.ok)?.element}}),define(Re[105],Ae([1,0,9]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=s,e.$ed=E,e.$fd=k,e.$gd=C,e.$hd=A,e.$id=y;function s(o,D){if(!o)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}function E(o,D="Unreachable"){throw new Error(D)}function k(o,D="unexpected state"){if(!o)throw new t.$bb(`Assertion Failed: ${D}`)}function C(o){o||(0,t.$Y)(new t.$bb("Soft Assertion Failed"))}function A(o){if(!o()){debugger;o(),(0,t.$Y)(new t.$bb("Assertion Failed"))}}function y(o,D){let w=0;for(;w<o.length-1;){const m=o[w],$=o[w+1];if(!D(m,$))return!1;w++}return!0}});var Ti=this&&this.__createBinding||(Object.create?function(ue,e,t,s){s===void 0&&(s=t);var E=Object.getOwnPropertyDescriptor(e,t);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[t]}}),Object.defineProperty(ue,s,E)}:function(ue,e,t,s){s===void 0&&(s=t),ue[s]=e[t]}),Li=this&&this.__setModuleDefault||(Object.create?function(ue,e){Object.defineProperty(ue,"default",{enumerable:!0,value:e})}:function(ue,e){ue.default=e}),Ue=this&&this.__importStar||function(ue){if(ue&&ue.__esModule)return ue;var e={};if(ue!=null)for(var t in ue)t!=="default"&&Object.prototype.hasOwnProperty.call(ue,t)&&Ti(e,ue,t);return Li(e,ue),e};define(Re[157],Ae([1,0,17]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=E,e.$8c=k,e.$9c=C,e.$0c=A,e.$$c=y,e.$_c=o,t=Ue(t);const s=($,a)=>$===a;e.$6c=s;function E($=e.$6c){return(a,u)=>t.$tb(a,u,$)}function k(){return($,a)=>JSON.stringify($)===JSON.stringify(a)}function C(){return($,a)=>$.equals(a)}function A($,a,u){if(u!==void 0){const d=$;return d==null||a===void 0||a===null?a===d:u(d,a)}else{const d=$;return(f,v)=>f==null||v===void 0||v===null?v===f:d(f,v)}}function y($,a){if($===a)return!0;if(Array.isArray($)&&Array.isArray(a)){if($.length!==a.length)return!1;for(let u=0;u<$.length;u++)if(!y($[u],a[u]))return!1;return!0}if($&&typeof $=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf($)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const u=$,d=a,f=Object.keys(u),v=Object.keys(d),g=new Set(v);if(f.length!==v.length)return!1;for(const b of f)if(!g.has(b)||!y(u[b],d[b]))return!1;return!0}return!1}function o($){return JSON.stringify(m($))}let D=0;const w=new WeakMap;function m($){if(Array.isArray($))return $.map(m);if($&&typeof $=="object")if(Object.getPrototypeOf($)===Object.prototype){const a=$,u=Object.create(null);for(const d of Object.keys(a).sort())u[d]=m(a[d]);return u}else{let a=w.get($);return a===void 0&&(a=D++,w.set($,a)),a+"----2b76a038c20c4bcc"}return $}}),define(Re[78],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=t;function t(s,E){const k=this;let C=!1,A;return function(){if(C)return A;if(C=!0,E)try{A=s.apply(k,arguments)}finally{E()}else A=s.apply(k,arguments);return A}}}),define(Re[39],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var t;(function(s){function E(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}s.is=E;const k=Object.freeze([]);function C(){return k}s.empty=C;function*A(n){yield n}s.single=A;function y(n){return E(n)?n:A(n)}s.wrap=y;function o(n){return n||k}s.from=o;function*D(n){for(let l=n.length-1;l>=0;l--)yield n[l]}s.reverse=D;function w(n){return!n||n[Symbol.iterator]().next().done===!0}s.isEmpty=w;function m(n){return n[Symbol.iterator]().next().value}s.first=m;function $(n,l){let r=0;for(const h of n)if(l(h,r++))return!0;return!1}s.some=$;function a(n,l){for(const r of n)if(l(r))return r}s.find=a;function*u(n,l){for(const r of n)l(r)&&(yield r)}s.filter=u;function*d(n,l){let r=0;for(const h of n)yield l(h,r++)}s.map=d;function*f(n,l){let r=0;for(const h of n)yield*l(h,r++)}s.flatMap=f;function*v(...n){for(const l of n)yield*l}s.concat=v;function g(n,l,r){let h=r;for(const c of n)h=l(h,c);return h}s.reduce=g;function*b(n,l,r=n.length){for(l<0&&(l+=n.length),r<0?r+=n.length:r>n.length&&(r=n.length);l<r;l++)yield n[l]}s.slice=b;function i(n,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,n];const h=n[Symbol.iterator]();for(let c=0;c<l;c++){const S=h.next();if(S.done)return[r,s.empty()];r.push(S.value)}return[r,{[Symbol.iterator](){return h}}]}s.consume=i;async function p(n){const l=[];for await(const r of n)l.push(r);return Promise.resolve(l)}s.asyncToArray=p})(t||(e.Iterable=t={}))}),define(Re[42],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Wn=C,e.$Xn=w,e.$Yn=m,e.$Zn=$,e.$1n=a,e.$2n=u,e.$3n=d,e.$4n=f,e.$5n=v,e.$6n=g,e.$7n=b;var t;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(t||(e.ScanError=t={}));var s;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(s||(e.SyntaxKind=s={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function C(i,p=!1){let n=0;const l=i.length;let r="",h=0,c=s.Unknown,S=t.None;function I(J){let _=0,de=0;for(;_<J;){const ge=i.charCodeAt(n);if(ge>=D._0&&ge<=D._9)de=de*16+ge-D._0;else if(ge>=D.A&&ge<=D.F)de=de*16+ge-D.A+10;else if(ge>=D.a&&ge<=D.f)de=de*16+ge-D.a+10;else break;n++,_++}return _<J&&(de=-1),de}function R(J){n=J,r="",h=0,c=s.Unknown,S=t.None}function L(){const J=n;if(i.charCodeAt(n)===D._0)n++;else for(n++;n<i.length&&o(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===D.dot)if(n++,n<i.length&&o(i.charCodeAt(n)))for(n++;n<i.length&&o(i.charCodeAt(n));)n++;else return S=t.UnexpectedEndOfNumber,i.substring(J,n);let _=n;if(n<i.length&&(i.charCodeAt(n)===D.E||i.charCodeAt(n)===D.e))if(n++,(n<i.length&&i.charCodeAt(n)===D.plus||i.charCodeAt(n)===D.minus)&&n++,n<i.length&&o(i.charCodeAt(n))){for(n++;n<i.length&&o(i.charCodeAt(n));)n++;_=n}else S=t.UnexpectedEndOfNumber;return i.substring(J,_)}function O(){let J="",_=n;for(;;){if(n>=l){J+=i.substring(_,n),S=t.UnexpectedEndOfString;break}const de=i.charCodeAt(n);if(de===D.doubleQuote){J+=i.substring(_,n),n++;break}if(de===D.backslash){if(J+=i.substring(_,n),n++,n>=l){S=t.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case D.doubleQuote:J+='"';break;case D.backslash:J+="\\";break;case D.slash:J+="/";break;case D.b:J+="\b";break;case D.f:J+="\f";break;case D.n:J+=`
`;break;case D.r:J+="\r";break;case D.t:J+="	";break;case D.u:{const le=I(4);le>=0?J+=String.fromCharCode(le):S=t.InvalidUnicode;break}default:S=t.InvalidEscapeCharacter}_=n;continue}if(de>=0&&de<=31)if(y(de)){J+=i.substring(_,n),S=t.UnexpectedEndOfString;break}else S=t.InvalidCharacter;n++}return J}function P(){if(r="",S=t.None,h=n,n>=l)return h=l,c=s.EOF;let J=i.charCodeAt(n);if(A(J)){do n++,r+=String.fromCharCode(J),J=i.charCodeAt(n);while(A(J));return c=s.Trivia}if(y(J))return n++,r+=String.fromCharCode(J),J===D.carriageReturn&&i.charCodeAt(n)===D.lineFeed&&(n++,r+=`
`),c=s.LineBreakTrivia;switch(J){case D.openBrace:return n++,c=s.OpenBraceToken;case D.closeBrace:return n++,c=s.CloseBraceToken;case D.openBracket:return n++,c=s.OpenBracketToken;case D.closeBracket:return n++,c=s.CloseBracketToken;case D.colon:return n++,c=s.ColonToken;case D.comma:return n++,c=s.CommaToken;case D.doubleQuote:return n++,r=O(),c=s.StringLiteral;case D.slash:{const _=n-1;if(i.charCodeAt(n+1)===D.slash){for(n+=2;n<l&&!y(i.charCodeAt(n));)n++;return r=i.substring(_,n),c=s.LineCommentTrivia}if(i.charCodeAt(n+1)===D.asterisk){n+=2;const de=l-1;let ge=!1;for(;n<de;){if(i.charCodeAt(n)===D.asterisk&&i.charCodeAt(n+1)===D.slash){n+=2,ge=!0;break}n++}return ge||(n++,S=t.UnexpectedEndOfComment),r=i.substring(_,n),c=s.BlockCommentTrivia}return r+=String.fromCharCode(J),n++,c=s.Unknown}case D.minus:if(r+=String.fromCharCode(J),n++,n===l||!o(i.charCodeAt(n)))return c=s.Unknown;case D._0:case D._1:case D._2:case D._3:case D._4:case D._5:case D._6:case D._7:case D._8:case D._9:return r+=L(),c=s.NumericLiteral;default:for(;n<l&&q(J);)n++,J=i.charCodeAt(n);if(h!==n){switch(r=i.substring(h,n),r){case"true":return c=s.TrueKeyword;case"false":return c=s.FalseKeyword;case"null":return c=s.NullKeyword}return c=s.Unknown}return r+=String.fromCharCode(J),n++,c=s.Unknown}}function q(J){if(A(J)||y(J))return!1;switch(J){case D.closeBrace:case D.closeBracket:case D.openBrace:case D.openBracket:case D.doubleQuote:case D.colon:case D.comma:case D.slash:return!1}return!0}function K(){let J;do J=P();while(J>=s.LineCommentTrivia&&J<=s.Trivia);return J}return{setPosition:R,getPosition:()=>n,scan:p?K:P,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>S}}function A(i){return i===D.space||i===D.tab||i===D.verticalTab||i===D.formFeed||i===D.nonBreakingSpace||i===D.ogham||i>=D.enQuad&&i<=D.zeroWidthSpace||i===D.narrowNoBreakSpace||i===D.mathematicalSpace||i===D.ideographicSpace||i===D.byteOrderMark}function y(i){return i===D.lineFeed||i===D.carriageReturn||i===D.lineSeparator||i===D.paragraphSeparator}function o(i){return i>=D._0&&i<=D._9}var D;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(D||(D={}));function w(i,p){const n=[],l=new Object;let r;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function S(I,R,L,O){h.value=I,h.offset=R,h.length=L,h.type=O,h.colonOffset=void 0,r=h}try{g(i,{onObjectBegin:(I,R)=>{if(p<=I)throw l;r=void 0,c=p>I,n.push("")},onObjectProperty:(I,R,L)=>{if(p<R||(S(I,R,L,"property"),n[n.length-1]=I,p<=R+L))throw l},onObjectEnd:(I,R)=>{if(p<=I)throw l;r=void 0,n.pop()},onArrayBegin:(I,R)=>{if(p<=I)throw l;r=void 0,n.push(0)},onArrayEnd:(I,R)=>{if(p<=I)throw l;r=void 0,n.pop()},onLiteralValue:(I,R,L)=>{if(p<R||(S(I,R,L,b(I)),p<=R+L))throw l},onSeparator:(I,R,L)=>{if(p<=R)throw l;if(I===":"&&r&&r.type==="property")r.colonOffset=R,c=!1,r=void 0;else if(I===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(I){if(I!==l)throw I}return{path:n,previousNode:r,isAtPropertyKey:c,matches:I=>{let R=0;for(let L=0;R<I.length&&L<n.length;L++)if(I[R]===n[L]||I[R]==="*")R++;else if(I[R]!=="**")return!1;return R===I.length}}}function m(i,p=[],n=k.DEFAULT){let l=null,r=[];const h=[];function c(I){Array.isArray(r)?r.push(I):l!==null&&(r[l]=I)}return g(i,{onObjectBegin:()=>{const I={};c(I),h.push(r),r=I,l=null},onObjectProperty:I=>{l=I},onObjectEnd:()=>{r=h.pop()},onArrayBegin:()=>{const I=[];c(I),h.push(r),r=I,l=null},onArrayEnd:()=>{r=h.pop()},onLiteralValue:c,onError:(I,R,L)=>{p.push({error:I,offset:R,length:L})}},n),r[0]}function $(i,p=[],n=k.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(I){l.type==="property"&&(l.length=I-l.offset,l=l.parent)}function h(I){return l.children.push(I),I}g(i,{onObjectBegin:I=>{l=h({type:"object",offset:I,length:-1,parent:l,children:[]})},onObjectProperty:(I,R,L)=>{l=h({type:"property",offset:R,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:I,offset:R,length:L,parent:l})},onObjectEnd:(I,R)=>{l.length=I+R-l.offset,l=l.parent,r(I+R)},onArrayBegin:(I,R)=>{l=h({type:"array",offset:I,length:-1,parent:l,children:[]})},onArrayEnd:(I,R)=>{l.length=I+R-l.offset,l=l.parent,r(I+R)},onLiteralValue:(I,R,L)=>{h({type:b(I),offset:R,length:L,parent:l,value:I}),r(R+L)},onSeparator:(I,R,L)=>{l.type==="property"&&(I===":"?l.colonOffset=R:I===","&&r(R))},onError:(I,R,L)=>{p.push({error:I,offset:R,length:L})}},n);const S=l.children[0];return S&&delete S.parent,S}function a(i,p){if(!i)return;let n=i;for(const l of p)if(typeof l=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===l){n=h.children[1],r=!0;break}if(!r)return}else{const r=l;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}function u(i){if(!i.parent||!i.parent.children)return[];const p=u(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;p.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&p.push(n)}return p}function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const p=Object.create(null);for(const n of i.children){const l=n.children[1];l&&(p[n.children[0].value]=d(l))}return p}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function f(i,p,n=!1){return p>=i.offset&&p<i.offset+i.length||n&&p===i.offset+i.length}function v(i,p,n=!1){if(f(i,p,n)){const l=i.children;if(Array.isArray(l))for(let r=0;r<l.length&&l[r].offset<=p;r++){const h=v(l[r],p,n);if(h)return h}return i}}function g(i,p,n=k.DEFAULT){const l=C(i,!1);function r(re){return re?()=>re(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(re){return re?me=>re(me,l.getTokenOffset(),l.getTokenLength()):()=>!0}const c=r(p.onObjectBegin),S=h(p.onObjectProperty),I=r(p.onObjectEnd),R=r(p.onArrayBegin),L=r(p.onArrayEnd),O=h(p.onLiteralValue),P=h(p.onSeparator),q=r(p.onComment),K=h(p.onError),J=n&&n.disallowComments,_=n&&n.allowTrailingComma;function de(){for(;;){const re=l.scan();switch(l.getTokenError()){case t.InvalidUnicode:ge(E.InvalidUnicode);break;case t.InvalidEscapeCharacter:ge(E.InvalidEscapeCharacter);break;case t.UnexpectedEndOfNumber:ge(E.UnexpectedEndOfNumber);break;case t.UnexpectedEndOfComment:J||ge(E.UnexpectedEndOfComment);break;case t.UnexpectedEndOfString:ge(E.UnexpectedEndOfString);break;case t.InvalidCharacter:ge(E.InvalidCharacter);break}switch(re){case s.LineCommentTrivia:case s.BlockCommentTrivia:J?ge(E.InvalidCommentToken):q();break;case s.Unknown:ge(E.InvalidSymbol);break;case s.Trivia:case s.LineBreakTrivia:break;default:return re}}}function ge(re,me=[],oe=[]){if(K(re),me.length+oe.length>0){let ie=l.getToken();for(;ie!==s.EOF;){if(me.indexOf(ie)!==-1){de();break}else if(oe.indexOf(ie)!==-1)break;ie=de()}}}function le(re){const me=l.getTokenValue();return re?O(me):S(me),de(),!0}function z(){switch(l.getToken()){case s.NumericLiteral:{let re=0;try{re=JSON.parse(l.getTokenValue()),typeof re!="number"&&(ge(E.InvalidNumberFormat),re=0)}catch{ge(E.InvalidNumberFormat)}O(re);break}case s.NullKeyword:O(null);break;case s.TrueKeyword:O(!0);break;case s.FalseKeyword:O(!1);break;default:return!1}return de(),!0}function Q(){return l.getToken()!==s.StringLiteral?(ge(E.PropertyNameExpected,[],[s.CloseBraceToken,s.CommaToken]),!1):(le(!1),l.getToken()===s.ColonToken?(P(":"),de(),ne()||ge(E.ValueExpected,[],[s.CloseBraceToken,s.CommaToken])):ge(E.ColonExpected,[],[s.CloseBraceToken,s.CommaToken]),!0)}function M(){c(),de();let re=!1;for(;l.getToken()!==s.CloseBraceToken&&l.getToken()!==s.EOF;){if(l.getToken()===s.CommaToken){if(re||ge(E.ValueExpected,[],[]),P(","),de(),l.getToken()===s.CloseBraceToken&&_)break}else re&&ge(E.CommaExpected,[],[]);Q()||ge(E.ValueExpected,[],[s.CloseBraceToken,s.CommaToken]),re=!0}return I(),l.getToken()!==s.CloseBraceToken?ge(E.CloseBraceExpected,[s.CloseBraceToken],[]):de(),!0}function V(){R(),de();let re=!1;for(;l.getToken()!==s.CloseBracketToken&&l.getToken()!==s.EOF;){if(l.getToken()===s.CommaToken){if(re||ge(E.ValueExpected,[],[]),P(","),de(),l.getToken()===s.CloseBracketToken&&_)break}else re&&ge(E.CommaExpected,[],[]);ne()||ge(E.ValueExpected,[],[s.CloseBracketToken,s.CommaToken]),re=!0}return L(),l.getToken()!==s.CloseBracketToken?ge(E.CloseBracketExpected,[s.CloseBracketToken],[]):de(),!0}function ne(){switch(l.getToken()){case s.OpenBracketToken:return V();case s.OpenBraceToken:return M();case s.StringLiteral:return le(!0);default:return z()}}return de(),l.getToken()===s.EOF?n.allowEmptyContent?!0:(ge(E.ValueExpected,[],[]),!1):ne()?(l.getToken()!==s.EOF&&ge(E.EndOfFileExpected,[],[]),!0):(ge(E.ValueExpected,[],[]),!1)}function b(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[158],Ae([1,0,42]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=s,e.$9n=E,e.$0n=A,e.$$n=y;function s(o,D,w){let m,$,a,u,d;if(D){for(u=D.offset,d=u+D.length,a=u;a>0&&!y(o,a-1);)a--;let S=d;for(;S<o.length&&!y(o,S);)S++;$=o.substring(a,S),m=C($,w)}else $=o,m=0,a=0,u=0,d=o.length;const f=A(w,o);let v=!1,g=0,b;w.insertSpaces?b=k(" ",w.tabSize||4):b="	";const i=(0,t.$Wn)($,!1);let p=!1;function n(){return f+k(b,m+g)}function l(){let S=i.scan();for(v=!1;S===t.SyntaxKind.Trivia||S===t.SyntaxKind.LineBreakTrivia;)v=v||S===t.SyntaxKind.LineBreakTrivia,S=i.scan();return p=S===t.SyntaxKind.Unknown||i.getTokenError()!==t.ScanError.None,S}const r=[];function h(S,I,R){!p&&I<d&&R>u&&o.substring(I,R)!==S&&r.push({offset:I,length:R-I,content:S})}let c=l();if(c!==t.SyntaxKind.EOF){const S=i.getTokenOffset()+a,I=k(b,m);h(I,a,S)}for(;c!==t.SyntaxKind.EOF;){let S=i.getTokenOffset()+i.getTokenLength()+a,I=l(),R="";for(;!v&&(I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia);){const O=i.getTokenOffset()+a;h(" ",S,O),S=i.getTokenOffset()+i.getTokenLength()+a,R=I===t.SyntaxKind.LineCommentTrivia?n():"",I=l()}if(I===t.SyntaxKind.CloseBraceToken)c!==t.SyntaxKind.OpenBraceToken&&(g--,R=n());else if(I===t.SyntaxKind.CloseBracketToken)c!==t.SyntaxKind.OpenBracketToken&&(g--,R=n());else{switch(c){case t.SyntaxKind.OpenBracketToken:case t.SyntaxKind.OpenBraceToken:g++,R=n();break;case t.SyntaxKind.CommaToken:case t.SyntaxKind.LineCommentTrivia:R=n();break;case t.SyntaxKind.BlockCommentTrivia:v?R=n():R=" ";break;case t.SyntaxKind.ColonToken:R=" ";break;case t.SyntaxKind.StringLiteral:if(I===t.SyntaxKind.ColonToken){R="";break}case t.SyntaxKind.NullKeyword:case t.SyntaxKind.TrueKeyword:case t.SyntaxKind.FalseKeyword:case t.SyntaxKind.NumericLiteral:case t.SyntaxKind.CloseBraceToken:case t.SyntaxKind.CloseBracketToken:I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia?R=" ":I!==t.SyntaxKind.CommaToken&&I!==t.SyntaxKind.EOF&&(p=!0);break;case t.SyntaxKind.Unknown:p=!0;break}v&&(I===t.SyntaxKind.LineCommentTrivia||I===t.SyntaxKind.BlockCommentTrivia)&&(R=n())}const L=i.getTokenOffset()+a;h(R,S,L),c=I}return r}function E(o,D){const w=JSON.stringify(o,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?w.replace(/\r\n|\r|\n/g,D.eol):w}function k(o,D){let w="";for(let m=0;m<D;m++)w+=o;return w}function C(o,D){let w=0,m=0;const $=D.tabSize||4;for(;w<o.length;){const a=o.charAt(w);if(a===" ")m++;else if(a==="	")m+=$;else break;w++}return Math.floor(m/$)}function A(o,D){for(let w=0;w<D.length;w++){const m=D.charAt(w);if(m==="\r")return w+1<D.length&&D.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return o&&o.eol||`
`}function y(o,D){return`\r
`.indexOf(o.charAt(D))!==-1}}),define(Re[159],Ae([1,0,42,158]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=E,e.$ao=k,e.$bo=C,e.$co=A,e.$do=y;function E(o,D,w){return k(o,D,void 0,w)}function k(o,D,w,m,$){const a=D.slice(),u=[],d=(0,t.$Zn)(o,u);let f,v;for(;a.length>0&&(v=a.pop(),f=(0,t.$1n)(d,a),f===void 0&&w!==void 0);)typeof v=="string"?w={[v]:w}:w=[w];if(f)if(f.type==="object"&&typeof v=="string"&&Array.isArray(f.children)){const g=(0,t.$1n)(f,[v]);if(g!==void 0)if(w===void 0){if(!g.parent)throw new Error("Malformed AST");const b=f.children.indexOf(g.parent);let i,p=g.parent.offset+g.parent.length;if(b>0){const n=f.children[b-1];i=n.offset+n.length}else i=f.offset+1,f.children.length>1&&(p=f.children[1].offset);return C(o,{offset:i,length:p-i,content:""},m)}else return C(o,{offset:g.offset,length:g.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const b=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,i=$?$(f.children.map(n=>n.children[0].value)):f.children.length;let p;if(i>0){const n=f.children[i-1];p={offset:n.offset+n.length,length:0,content:","+b}}else f.children.length===0?p={offset:f.offset+1,length:0,content:b}:p={offset:f.offset+1,length:0,content:b+","};return C(o,p,m)}}else if(f.type==="array"&&typeof v=="number"&&Array.isArray(f.children))if(w!==void 0){const g=`${JSON.stringify(w)}`;let b;if(f.children.length===0||v===0)b={offset:f.offset+1,length:0,content:f.children.length===0?g:g+","};else{const i=v===-1||v>f.children.length?f.children.length:v,p=f.children[i-1];b={offset:p.offset+p.length,length:0,content:","+g}}return C(o,b,m)}else{const g=v,b=f.children[g];let i;if(f.children.length===1)i={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===g){const p=f.children[g-1],n=p.offset+p.length,l=f.offset+f.length;i={offset:n,length:l-2-n,content:""}}else i={offset:b.offset,length:f.children[g+1].offset-b.offset,content:""};return C(o,i,m)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${f.type}`);else return w===void 0?[]:C(o,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(w)},m)}function C(o,D,w){let m=A(o,D),$=D.offset,a=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;$>0&&!(0,s.$$n)(m,$-1);)$--;for(;a<m.length&&!(0,s.$$n)(m,a);)a++}const u=(0,s.$8n)(m,{offset:$,length:a-$},w);for(let f=u.length-1;f>=0;f--){const v=u[f];m=A(m,v),$=Math.min($,v.offset),a=Math.max(a,v.offset+v.length),a+=v.content.length-v.length}const d=o.length-(m.length-a)-$;return[{offset:$,length:d,content:m.substring($,a)}]}function A(o,D){return o.substring(0,D.offset)+D.content+o.substring(D.offset+D.length)}function y(o,D){const w=D.slice(0).sort(($,a)=>{const u=$.offset-a.offset;return u===0?$.length-a.length:u});let m=o.length;for(let $=w.length-1;$>=0;$--){const a=w[$];if(a.offset+a.length<=m)o=A(o,a);else throw new Error("Overlapping edit");m=a.offset}return o}}),define(Re[160],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=t;function t(k){let C=!1;const A=new Map,y=new Map;if(E(k,u=>{if(k===u)return!0;const d=JSON.stringify(u);if(d.length<30)return!0;const f=A.get(d);if(!f){const v={schemas:[u]};return A.set(d,v),y.set(u,v),!0}return f.schemas.push(u),y.set(u,f),C=!0,!1}),A.clear(),!C)return JSON.stringify(k);let D="$defs";for(;k.hasOwnProperty(D);)D+="_";const w=[];function m(u){return JSON.stringify(u,(d,f)=>{if(f!==u){const v=y.get(f);if(v&&v.schemas.length>1)return v.id||(v.id=`_${w.length}`,w.push(v.schemas[0])),{$ref:`#/${D}/${v.id}`}}return f})}const $=m(k),a=[];for(let u=0;u<w.length;u++)a.push(`"_${u}":${m(w[u])}`);return a.length?`${$.substring(0,$.length-1)},"${D}":{${a.join(",")}}}`:$}function s(k){return typeof k=="object"&&k!==null}function E(k,C){if(!k||typeof k!="object")return;const A=(...$)=>{for(const a of $)s(a)&&w.push(a)},y=(...$)=>{for(const a of $)if(s(a))for(const u in a){const d=a[u];s(d)&&w.push(d)}},o=(...$)=>{for(const a of $)if(Array.isArray(a))for(const u of a)s(u)&&w.push(u)},D=$=>{if(Array.isArray($))for(const a of $)s(a)&&w.push(a);else s($)&&w.push($)},w=[k];let m=w.pop();for(;m;)C(m)&&(A(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),y(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),o(m.anyOf,m.allOf,m.oneOf,m.prefixItems),D(m.items)),m=w.pop()}}),define(Re[64],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class t{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=t}),define(Re[79],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(k){this.element=k,this.next=t.Undefined,this.prev=t.Undefined}}class s{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let k=this.a;for(;k!==t.Undefined;){const C=k.next;k.prev=t.Undefined,k.next=t.Undefined,k=C}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,C){const A=new t(k);if(this.a===t.Undefined)this.a=A,this.b=A;else if(C){const o=this.b;this.b=A,A.prev=o,o.next=A}else{const o=this.a;this.a=A,A.next=o,o.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==t.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==t.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==t.Undefined&&k.next!==t.Undefined){const C=k.prev;C.next=k.next,k.next.prev=C}else k.prev===t.Undefined&&k.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):k.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):k.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==t.Undefined;)yield k.element,k=k.next}}e.$5c=s}),define(Re[25],Ae([1,0]),function(ue,e){"use strict";var t,s,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=k,e.$yc=C,e.$zc=A,e.$Ic=b;function k(i,p,n){let l=i.get(p);return l===void 0&&(l=n,i.set(p,l)),l}function C(i){const p=[];return i.forEach((n,l)=>{p.push(`${l} => ${n}`)}),`Map(${i.size}) {${p.join(", ")}}`}function A(i){const p=[];return i.forEach(n=>{p.push(n)}),`Set(${i.size}) {${p.join(", ")}}`}class y{constructor(p,n){this.uri=p,this.value=n}}function o(i){return Array.isArray(i)}class D{static{this.c=p=>p.toString()}constructor(p,n){if(this[t]="ResourceMap",p instanceof D)this.d=new Map(p.d),this.e=n??D.c;else if(o(p)){this.d=new Map,this.e=n??D.c;for(const[l,r]of p)this.set(l,r)}else this.d=new Map,this.e=p??D.c}set(p,n){return this.d.set(this.e(p),new y(p,n)),this}get(p){return this.d.get(this.e(p))?.value}has(p){return this.d.has(this.e(p))}get size(){return this.d.size}clear(){this.d.clear()}delete(p){return this.d.delete(this.e(p))}forEach(p,n){typeof n<"u"&&(p=p.bind(n));for(const[l,r]of this.d)p(r.value,r.uri,this)}*values(){for(const p of this.d.values())yield p.value}*keys(){for(const p of this.d.values())yield p.uri}*entries(){for(const p of this.d.values())yield[p.uri,p.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.d)yield[p.uri,p.value]}}e.$Ac=D;class w{constructor(p,n){this[s]="ResourceSet",!p||typeof p=="function"?this.c=new D(p):(this.c=new D(n),p.forEach(this.add,this))}get size(){return this.c.size}add(p){return this.c.set(p,p),this}clear(){this.c.clear()}delete(p){return this.c.delete(p)}forEach(p,n){this.c.forEach((l,r)=>p.call(n,r,r,this))}has(p){return this.c.has(p)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=w;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class ${constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(p){return this.c.has(p)}get(p,n=m.None){const l=this.c.get(p);if(l)return n!==m.None&&this.m(l,n),l.value}set(p,n,l=m.None){let r=this.c.get(p);if(r)r.value=n,l!==m.None&&this.m(r,l);else{switch(r={key:p,value:n,next:void 0,previous:void 0},l){case m.None:this.k(r);break;case m.AsOld:this.j(r);break;case m.AsNew:this.k(r);break;default:this.k(r);break}this.c.set(p,r),this.f++}return this}delete(p){return!!this.remove(p)}remove(p){const n=this.c.get(p);if(n)return this.c.delete(p),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const p=this.d;return this.c.delete(p.key),this.l(p),this.f--,p.value}forEach(p,n){const l=this.g;let r=this.d;for(;r;){if(n?p.bind(n)(r.value,r.key,this):p(r.value,r.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const p=this,n=this.g;let l=this.d;const r={[Symbol.iterator](){return r},next(){if(p.g!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.key,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return r}values(){const p=this,n=this.g;let l=this.d;const r={[Symbol.iterator](){return r},next(){if(p.g!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.value,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return r}entries(){const p=this,n=this.g;let l=this.d;const r={[Symbol.iterator](){return r},next(){if(p.g!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:[l.key,l.value],done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return r}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(p){if(p>=this.size)return;if(p===0){this.clear();return}let n=this.d,l=this.size;for(;n&&l>p;)this.c.delete(n.key),n=n.next,l--;this.d=n,this.f=l,n&&(n.previous=void 0),this.g++}i(p){if(p>=this.size)return;if(p===0){this.clear();return}let n=this.e,l=this.size;for(;n&&l>p;)this.c.delete(n.key),n=n.previous,l--;this.e=n,this.f=l,n&&(n.next=void 0),this.g++}j(p){if(!this.d&&!this.e)this.e=p;else if(this.d)p.next=this.d,this.d.previous=p;else throw new Error("Invalid list");this.d=p,this.g++}k(p){if(!this.d&&!this.e)this.d=p;else if(this.e)p.previous=this.e,this.e.next=p;else throw new Error("Invalid list");this.e=p,this.g++}l(p){if(p===this.d&&p===this.e)this.d=void 0,this.e=void 0;else if(p===this.d){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.d=p.next}else if(p===this.e){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.e=p.previous}else{const n=p.next,l=p.previous;if(!n||!l)throw new Error("Invalid list");n.previous=l,l.next=n}p.next=void 0,p.previous=void 0,this.g++}m(p,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==m.AsOld&&n!==m.AsNew)){if(n===m.AsOld){if(p===this.d)return;const l=p.next,r=p.previous;p===this.e?(r.next=void 0,this.e=r):(l.previous=r,r.next=l),p.previous=void 0,p.next=this.d,this.d.previous=p,this.d=p,this.g++}else if(n===m.AsNew){if(p===this.e)return;const l=p.next,r=p.previous;p===this.d?(l.previous=void 0,this.d=l):(l.previous=r,r.next=l),p.next=void 0,p.previous=this.e,this.e.next=p,this.e=p,this.g++}}}toJSON(){const p=[];return this.forEach((n,l)=>{p.push([l,n])}),p}fromJSON(p){this.clear();for(const[n,l]of p)this.set(n,l)}}e.$Cc=$;class a extends ${constructor(p,n=1){super(),this.n=p,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(p){this.n=p,this.p()}get ratio(){return this.o}set ratio(p){this.o=Math.min(Math.max(0,p),1),this.p()}get(p,n=m.AsNew){return super.get(p,n)}peek(p){return super.get(p,m.None)}set(p,n){return super.set(p,n,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class u extends a{constructor(p,n=1){super(p,n)}q(p){this.h(p)}set(p,n){return super.set(p,n),this.p(),this}}e.$Dc=u;class d extends a{constructor(p,n=1){super(p,n)}q(p){this.i(p)}set(p,n){return this.n<=this.size&&!this.has(p)&&this.q(Math.round(this.n*this.o)-1),super.set(p,n),this}}e.$Ec=d;class f{constructor(){this.c=new Map}add(p){return this.c.set(p,(this.c.get(p)||0)+1),this}delete(p){let n=this.c.get(p)||0;return n===0?!1:(n--,n===0?this.c.delete(p):this.c.set(p,n),!0)}has(p){return this.c.has(p)}}e.$Fc=f;class v{constructor(p){if(this.c=new Map,this.d=new Map,p)for(const[n,l]of p)this.set(n,l)}clear(){this.c.clear(),this.d.clear()}set(p,n){this.c.set(p,n),this.d.set(n,p)}get(p){return this.c.get(p)}getKey(p){return this.d.get(p)}delete(p){const n=this.c.get(p);return n===void 0?!1:(this.c.delete(p),this.d.delete(n),!0)}forEach(p,n){this.c.forEach((l,r)=>{p.call(n,l,r,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=v;class g{constructor(){this.c=new Map}add(p,n){let l=this.c.get(p);l||(l=new Set,this.c.set(p,l)),l.add(n)}delete(p,n){const l=this.c.get(p);l&&(l.delete(n),l.size===0&&this.c.delete(p))}forEach(p,n){const l=this.c.get(p);l&&l.forEach(n)}get(p){const n=this.c.get(p);return n||new Set}}e.$Hc=g;function b(i,p){if(i===p)return!0;if(i.size!==p.size)return!1;for(const[n,l]of i)if(!p.has(n)||p.get(n)!==l)return!1;for(const[n]of p)if(!i.has(n))return!1;return!0}}),define(Re[2],Ae([1,0,17,156,25,78,39]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=D,e.$Lc=w,e.$Mc=m,e.$Nc=u,e.$Oc=d,e.$Pc=f,e.$Qc=v,e.$Rc=g,e.$Sc=b,e.$3c=R;const A=!1;let y=null;class o{constructor(){this.b=new Map}static{this.a=0}c(P){let q=this.b.get(P);return q||(q={parent:null,source:null,isSingleton:!1,value:P,idx:o.a++},this.b.set(P,q)),q}trackDisposable(P){const q=this.c(P);q.source||(q.source=new Error().stack)}setParent(P,q){const K=this.c(P);K.parent=q}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,q){const K=q.get(P);if(K)return K;const J=P.parent?this.f(this.c(P.parent),q):P;return q.set(P,J),J}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,K])=>K.source!==null&&!this.f(K,P).isSingleton).flatMap(([K])=>K)}computeLeakingDisposables(P=10,q){let K;if(q)K=q;else{const le=new Map,z=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,le).isSingleton);if(z.length===0)return;const Q=new Set(z.map(M=>M.value));if(K=z.filter(M=>!(M.parent&&Q.has(M.parent))),K.length===0)throw new Error("There are cyclic diposable chains!")}if(!K)return;function J(le){function z(M,V){for(;M.length>0&&V.some(ne=>typeof ne=="string"?ne===M[0]:M[0].match(ne));)M.shift()}const Q=le.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return z(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const _=new E.$Hc;for(const le of K){const z=J(le);for(let Q=0;Q<=z.length;Q++)_.add(z.slice(0,Q).join(`
`),le)}K.sort((0,t.$5b)(le=>le.idx,t.$7b));let de="",ge=0;for(const le of K.slice(0,P)){ge++;const z=J(le),Q=[];for(let M=0;M<z.length;M++){let V=z[M];V=`(shared with ${_.get(z.slice(0,M+1).join(`
`)).size}/${K.length} leaks) at ${V}`;const re=_.get(z.slice(0,M).join(`
`)),me=(0,s.$c)([...re].map(oe=>J(oe)[M]),oe=>oe);delete me[z[M]];for(const[oe,ie]of Object.entries(me))Q.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${oe}`);Q.unshift(V)}de+=`


==================== Leaking disposable ${ge}/${K.length}: ${le.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return K.length>P&&(de+=`


... and ${K.length-P} more leaking disposables

`),{leaks:K,details:de}}}e.$Jc=o;function D(O){y=O}if(A){const O="__is_disposable_tracked__";D(new class{trackDisposable(P){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[O]||console.log(q)},3e3)}setParent(P,q){if(P&&P!==p.None)try{P[O]=!0}catch{}}markAsDisposed(P){if(P&&P!==p.None)try{P[O]=!0}catch{}}markAsSingleton(P){}})}function w(O){return y?.trackDisposable(O),O}function m(O){y?.markAsDisposed(O)}function $(O,P){y?.setParent(O,P)}function a(O,P){if(y)for(const q of O)y.setParent(q,P)}function u(O){return y?.markAsSingleton(O),O}function d(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function f(O){if(C.Iterable.is(O)){const P=[];for(const q of O)if(q)try{q.dispose()}catch(K){P.push(K)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function v(O){for(const P of O)d(P)&&P.dispose();return[]}function g(...O){const P=b(()=>f(O));return a(O,P),P}function b(O){const P=w({dispose:(0,k.$cb)(()=>{m(P),O()})});return P}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return $(P,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),$(P,null))}}e.$Tc=i;class p{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,w(this),$(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=p;class n{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&$(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&$(P,null),P}}e.$Vc=n;class l{constructor(P){this.a=new n,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=l;class r{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=r;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(P){let q=P;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,m(this))},this}}e.$Yc=h;class c{constructor(){this.a=new Map}acquire(P,...q){let K=this.a.get(P);K||(K={counter:0,object:this.b(P,...q)},this.a.set(P,K));const{object:J}=K,_=(0,k.$cb)(()=>{--K.counter===0&&(this.c(P,K.object),this.a.delete(P))});return K.counter++,{object:J,dispose:_}}}e.$Zc=c;class S{constructor(P){this.a=P}async acquire(P,...q){const K=this.a.acquire(P,...q);try{return{object:await K.object,dispose:()=>K.dispose()}}catch(J){throw K.dispose(),J}}}e.$1c=S;class I{constructor(P){this.object=P}dispose(){}}e.$2c=I;function R(O){const P=new i;try{O(P)}finally{P.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,q,K=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),K||this.a.get(P)?.dispose(),this.a.set(P,q)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}deleteAndLeak(P){const q=this.a.get(P);return this.a.delete(P),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=L}),function(ue,e){typeof define=="function"&&define.amd?define(Re[161],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(B,U){for(var H=0;H<U.length;H++){var F=U[H];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(B,F.key,F)}}function t(B,U,H){return U&&e(B.prototype,U),H&&e(B,H),Object.defineProperty(B,"prototype",{writable:!1}),B}function s(B,U){if(B){if(typeof B=="string")return E(B,U);var H=Object.prototype.toString.call(B).slice(8,-1);if(H==="Object"&&B.constructor&&(H=B.constructor.name),H==="Map"||H==="Set")return Array.from(B);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return E(B,U)}}function E(B,U){(U==null||U>B.length)&&(U=B.length);for(var H=0,F=new Array(U);H<U;H++)F[H]=B[H];return F}function k(B,U){var H=typeof Symbol<"u"&&B[Symbol.iterator]||B["@@iterator"];if(H)return(H=H.call(B)).next.bind(H);if(Array.isArray(B)||(H=s(B))||U&&B&&typeof B.length=="number"){H&&(B=H);var F=0;return function(){return F>=B.length?{done:!0}:{done:!1,value:B[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=C();function A(B){ue.defaults=B}var y=/[&<>"']/,o=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(U){return m[U]};function a(B,U){if(U){if(y.test(B))return B.replace(o,$)}else if(D.test(B))return B.replace(w,$);return B}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(B){return B.replace(u,function(U,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var f=/(^|[^\[])\^/g;function v(B,U){B=typeof B=="string"?B:B.source,U=U||"";var H={replace:function(W,Y){return Y=Y.source||Y,Y=Y.replace(f,"$1"),B=B.replace(W,Y),H},getRegex:function(){return new RegExp(B,U)}};return H}var g=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(B,U,H){if(B){var F;try{F=decodeURIComponent(d(H)).replace(g,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}U&&!b.test(H)&&(H=h(U,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var p={},n=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(B,U){p[" "+B]||(n.test(B)?p[" "+B]=B+"/":p[" "+B]=R(B,"/",!0)),B=p[" "+B];var H=B.indexOf(":")===-1;return U.substring(0,2)==="//"?H?U:B.replace(l,"$1")+U:U.charAt(0)==="/"?H?U:B.replace(r,"$1")+U:B+U}var c={exec:function(){}};function S(B){for(var U=1,H,F;U<arguments.length;U++){H=arguments[U];for(F in H)Object.prototype.hasOwnProperty.call(H,F)&&(B[F]=H[F])}return B}function I(B,U){var H=B.replace(/\|/g,function(Y,ae,Ee){for(var Le=!1,be=ae;--be>=0&&Ee[be]==="\\";)Le=!Le;return Le?"|":" |"}),F=H.split(/ \|/),W=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>U)F.splice(U);else for(;F.length<U;)F.push("");for(;W<F.length;W++)F[W]=F[W].trim().replace(/\\\|/g,"|");return F}function R(B,U,H){var F=B.length;if(F===0)return"";for(var W=0;W<F;){var Y=B.charAt(F-W-1);if(Y===U&&!H)W++;else if(Y!==U&&H)W++;else break}return B.slice(0,F-W)}function L(B,U){if(B.indexOf(U[1])===-1)return-1;for(var H=B.length,F=0,W=0;W<H;W++)if(B[W]==="\\")W++;else if(B[W]===U[0])F++;else if(B[W]===U[1]&&(F--,F<0))return W;return-1}function O(B){B&&B.sanitize&&!B.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(B,U){if(U<1)return"";for(var H="";U>1;)U&1&&(H+=B),U>>=1,B+=B;return H+B}function q(B,U,H,F){var W=U.href,Y=U.title?a(U.title):null,ae=B[1].replace(/\\([\[\]])/g,"$1");if(B[0].charAt(0)!=="!"){F.state.inLink=!0;var Ee={type:"link",raw:H,href:W,title:Y,text:ae,tokens:F.inlineTokens(ae)};return F.state.inLink=!1,Ee}return{type:"image",raw:H,href:W,title:Y,text:a(ae)}}function K(B,U){var H=B.match(/^(\s+)(?:```)/);if(H===null)return U;var F=H[1];return U.split(`
`).map(function(W){var Y=W.match(/^\s+/);if(Y===null)return W;var ae=Y[0];return ae.length>=F.length?W.slice(F.length):W}).join(`
`)}var J=function(){function B(H){this.options=H||ue.defaults}var U=B.prototype;return U.space=function(F){var W=this.rules.block.newline.exec(F);if(W&&W[0].length>0)return{type:"space",raw:W[0]}},U.code=function(F){var W=this.rules.block.code.exec(F);if(W){var Y=W[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:W[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:R(Y,`
`)}}},U.fences=function(F){var W=this.rules.block.fences.exec(F);if(W){var Y=W[0],ae=K(Y,W[3]||"");return{type:"code",raw:Y,lang:W[2]?W[2].trim():W[2],text:ae}}},U.heading=function(F){var W=this.rules.block.heading.exec(F);if(W){var Y=W[2].trim();if(/#$/.test(Y)){var ae=R(Y,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(Y=ae.trim())}return{type:"heading",raw:W[0],depth:W[1].length,text:Y,tokens:this.lexer.inline(Y)}}},U.hr=function(F){var W=this.rules.block.hr.exec(F);if(W)return{type:"hr",raw:W[0]}},U.blockquote=function(F){var W=this.rules.block.blockquote.exec(F);if(W){var Y=W[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:W[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},U.list=function(F){var W=this.rules.block.list.exec(F);if(W){var Y,ae,Ee,Le,be,pe,we,Te,ce,ye,ve,ze,qe=W[1].trim(),Je=qe.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Je?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Je?qe:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(ze=!1,!(!(W=Ze.exec(F))||this.rules.block.hr.test(F)));){if(Y=W[0],F=F.substring(Y.length),Te=W[2].split(`
`,1)[0],ce=F.split(`
`,1)[0],this.options.pedantic?(Le=2,ve=Te.trimLeft()):(Le=W[2].search(/[^ ]/),Le=Le>4?1:Le,ve=Te.slice(Le),Le+=W[1].length),pe=!1,!Te&&/^ *$/.test(ce)&&(Y+=ce+`
`,F=F.substring(ce.length+1),ze=!0),!ze)for(var Ye=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Le-1)+"}#");F&&(ye=F.split(`
`,1)[0],Te=ye,this.options.pedantic&&(Te=Te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(Te)||rt.test(Te)||Ye.test(Te)||it.test(F)));){if(Te.search(/[^ ]/)>=Le||!Te.trim())ve+=`
`+Te.slice(Le);else if(!pe)ve+=`
`+Te;else break;!pe&&!Te.trim()&&(pe=!0),Y+=ye+`
`,F=F.substring(ye.length+1)}Ge.loose||(we?Ge.loose=!0:/\n *\n *$/.test(Y)&&(we=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ve),ae&&(Ee=ae[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Y,task:!!ae,checked:Ee,loose:!1,text:ve}),Ge.raw+=Y}Ge.items[Ge.items.length-1].raw=Y.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var nt=Ge.items.length;for(be=0;be<nt;be++){this.lexer.state.top=!1,Ge.items[be].tokens=this.lexer.blockTokens(Ge.items[be].text,[]);var tt=Ge.items[be].tokens.filter(function(Xe){return Xe.type==="space"}),et=tt.every(function(Xe){for(var $e=Xe.raw.split(""),Ne=0,Fe=k($e),ke;!(ke=Fe()).done;){var Ce=ke.value;if(Ce===`
`&&(Ne+=1),Ne>1)return!0}return!1});!Ge.loose&&tt.length&&et&&(Ge.loose=!0,Ge.items[be].loose=!0)}return Ge}},U.html=function(F){var W=this.rules.block.html.exec(F);if(W){var Y={type:"html",raw:W[0],pre:!this.options.sanitizer&&(W[1]==="pre"||W[1]==="script"||W[1]==="style"),text:W[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(W[0]):a(W[0]);Y.type="paragraph",Y.text=ae,Y.tokens=this.lexer.inline(ae)}return Y}},U.def=function(F){var W=this.rules.block.def.exec(F);if(W){W[3]&&(W[3]=W[3].substring(1,W[3].length-1));var Y=W[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:W[0],href:W[2],title:W[3]}}},U.table=function(F){var W=this.rules.block.table.exec(F);if(W){var Y={type:"table",header:I(W[1]).map(function(we){return{text:we}}),align:W[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:W[3]&&W[3].trim()?W[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=W[0];var ae=Y.align.length,Ee,Le,be,pe;for(Ee=0;Ee<ae;Ee++)/^ *-+: *$/.test(Y.align[Ee])?Y.align[Ee]="right":/^ *:-+: *$/.test(Y.align[Ee])?Y.align[Ee]="center":/^ *:-+ *$/.test(Y.align[Ee])?Y.align[Ee]="left":Y.align[Ee]=null;for(ae=Y.rows.length,Ee=0;Ee<ae;Ee++)Y.rows[Ee]=I(Y.rows[Ee],Y.header.length).map(function(we){return{text:we}});for(ae=Y.header.length,Le=0;Le<ae;Le++)Y.header[Le].tokens=this.lexer.inline(Y.header[Le].text);for(ae=Y.rows.length,Le=0;Le<ae;Le++)for(pe=Y.rows[Le],be=0;be<pe.length;be++)pe[be].tokens=this.lexer.inline(pe[be].text);return Y}}},U.lheading=function(F){var W=this.rules.block.lheading.exec(F);if(W)return{type:"heading",raw:W[0],depth:W[2].charAt(0)==="="?1:2,text:W[1],tokens:this.lexer.inline(W[1])}},U.paragraph=function(F){var W=this.rules.block.paragraph.exec(F);if(W){var Y=W[1].charAt(W[1].length-1)===`
`?W[1].slice(0,-1):W[1];return{type:"paragraph",raw:W[0],text:Y,tokens:this.lexer.inline(Y)}}},U.text=function(F){var W=this.rules.block.text.exec(F);if(W)return{type:"text",raw:W[0],text:W[0],tokens:this.lexer.inline(W[0])}},U.escape=function(F){var W=this.rules.inline.escape.exec(F);if(W)return{type:"escape",raw:W[0],text:a(W[1])}},U.tag=function(F){var W=this.rules.inline.tag.exec(F);if(W)return!this.lexer.state.inLink&&/^<a /i.test(W[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(W[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(W[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(W[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:W[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):a(W[0]):W[0]}},U.link=function(F){var W=this.rules.inline.link.exec(F);if(W){var Y=W[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var ae=R(Y.slice(0,-1),"\\");if((Y.length-ae.length)%2===0)return}else{var Ee=L(W[2],"()");if(Ee>-1){var Le=W[0].indexOf("!")===0?5:4,be=Le+W[1].length+Ee;W[2]=W[2].substring(0,Ee),W[0]=W[0].substring(0,be).trim(),W[3]=""}}var pe=W[2],we="";if(this.options.pedantic){var Te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(pe);Te&&(pe=Te[1],we=Te[3])}else we=W[3]?W[3].slice(1,-1):"";return pe=pe.trim(),/^</.test(pe)&&(this.options.pedantic&&!/>$/.test(Y)?pe=pe.slice(1):pe=pe.slice(1,-1)),q(W,{href:pe&&pe.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},W[0],this.lexer)}},U.reflink=function(F,W){var Y;if((Y=this.rules.inline.reflink.exec(F))||(Y=this.rules.inline.nolink.exec(F))){var ae=(Y[2]||Y[1]).replace(/\s+/g," ");if(ae=W[ae.toLowerCase()],!ae||!ae.href){var Ee=Y[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return q(Y,ae,Y[0],this.lexer)}},U.emStrong=function(F,W,Y){Y===void 0&&(Y="");var ae=this.rules.inline.emStrong.lDelim.exec(F);if(ae&&!(ae[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=ae[1]||ae[2]||"";if(!Ee||Ee&&(Y===""||this.rules.inline.punctuation.exec(Y))){var Le=ae[0].length-1,be,pe,we=Le,Te=0,ce=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,W=W.slice(-1*F.length+Le);(ae=ce.exec(W))!=null;)if(be=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!be){if(pe=be.length,ae[3]||ae[4]){we+=pe;continue}else if((ae[5]||ae[6])&&Le%3&&!((Le+pe)%3)){Te+=pe;continue}if(we-=pe,!(we>0)){if(pe=Math.min(pe,pe+we+Te),Math.min(Le,pe)%2){var ye=F.slice(1,Le+ae.index+pe);return{type:"em",raw:F.slice(0,Le+ae.index+pe+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var ve=F.slice(2,Le+ae.index+pe-1);return{type:"strong",raw:F.slice(0,Le+ae.index+pe+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},U.codespan=function(F){var W=this.rules.inline.code.exec(F);if(W){var Y=W[2].replace(/\n/g," "),ae=/[^ ]/.test(Y),Ee=/^ /.test(Y)&&/ $/.test(Y);return ae&&Ee&&(Y=Y.substring(1,Y.length-1)),Y=a(Y,!0),{type:"codespan",raw:W[0],text:Y}}},U.br=function(F){var W=this.rules.inline.br.exec(F);if(W)return{type:"br",raw:W[0]}},U.del=function(F){var W=this.rules.inline.del.exec(F);if(W)return{type:"del",raw:W[0],text:W[2],tokens:this.lexer.inlineTokens(W[2])}},U.autolink=function(F,W){var Y=this.rules.inline.autolink.exec(F);if(Y){var ae,Ee;return Y[2]==="@"?(ae=a(this.options.mangle?W(Y[1]):Y[1]),Ee="mailto:"+ae):(ae=a(Y[1]),Ee=ae),{type:"link",raw:Y[0],text:ae,href:Ee,tokens:[{type:"text",raw:ae,text:ae}]}}},U.url=function(F,W){var Y;if(Y=this.rules.inline.url.exec(F)){var ae,Ee;if(Y[2]==="@")ae=a(this.options.mangle?W(Y[0]):Y[0]),Ee="mailto:"+ae;else{var Le;do Le=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(Le!==Y[0]);ae=a(Y[0]),Y[1]==="www."?Ee="http://"+ae:Ee=ae}return{type:"link",raw:Y[0],text:ae,href:Ee,tokens:[{type:"text",raw:ae,text:ae}]}}},U.inlineText=function(F,W){var Y=this.rules.inline.text.exec(F);if(Y){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):a(Y[0]):Y[0]:ae=a(this.options.smartypants?W(Y[0]):Y[0]),{type:"text",raw:Y[0],text:ae}}},B}(),_={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};_._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,_._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,_.def=v(_.def).replace("label",_._label).replace("title",_._title).getRegex(),_.bullet=/(?:[*+-]|\d{1,9}[.)])/,_.listItemStart=v(/^( *)(bull) */).replace("bull",_.bullet).getRegex(),_.list=v(_.list).replace(/bull/g,_.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+_.def.source+")").getRegex(),_._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",_._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,_.html=v(_.html,"i").replace("comment",_._comment).replace("tag",_._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),_.paragraph=v(_._paragraph).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.blockquote=v(_.blockquote).replace("paragraph",_.paragraph).getRegex(),_.normal=S({},_),_.gfm=S({},_.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),_.gfm.table=v(_.gfm.table).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.gfm.paragraph=v(_._paragraph).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",_.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.pedantic=S({},_.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",_._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:v(_.normal._paragraph).replace("hr",_.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",_.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=v(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=v(_._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=v(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=v(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=v(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=v(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=v(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=v(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=v(de.reflink).replace("label",de._label).replace("ref",_._label).getRegex(),de.nolink=v(de.nolink).replace("ref",_._label).getRegex(),de.reflinkSearch=v(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=S({},de),de.pedantic=S({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=S({},de.normal,{escape:v(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=v(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=S({},de.gfm,{br:v(de.br).replace("{2,}","*").getRegex(),text:v(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(B){return B.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function le(B){var U="",H,F,W=B.length;for(H=0;H<W;H++)F=B.charCodeAt(H),Math.random()>.5&&(F="x"+F.toString(16)),U+="&#"+F+";";return U}var z=function(){function B(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||ue.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:_.normal,inline:de.normal};this.options.pedantic?(F.block=_.pedantic,F.inline=de.pedantic):this.options.gfm&&(F.block=_.gfm,this.options.breaks?F.inline=de.breaks:F.inline=de.gfm),this.tokenizer.rules=F}B.lex=function(F,W){var Y=new B(W);return Y.lex(F)},B.lexInline=function(F,W){var Y=new B(W);return Y.inlineTokens(F)};var U=B.prototype;return U.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var W;W=this.inlineQueue.shift();)this.inlineTokens(W.src,W.tokens);return this.tokens},U.blockTokens=function(F,W){var Y=this;W===void 0&&(W=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(we,Te,ce){return Te+"    ".repeat(ce.length)});for(var ae,Ee,Le,be;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(ae=we.call({lexer:Y},F,W))?(F=F.substring(ae.raw.length),W.push(ae),!0):!1}))){if(ae=this.tokenizer.space(F)){F=F.substring(ae.raw.length),ae.raw.length===1&&W.length>0?W[W.length-1].raw+=`
`:W.push(ae);continue}if(ae=this.tokenizer.code(F)){F=F.substring(ae.raw.length),Ee=W[W.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+ae.raw,Ee.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):W.push(ae);continue}if(ae=this.tokenizer.fences(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.heading(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.hr(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.blockquote(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.list(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.html(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.def(F)){F=F.substring(ae.raw.length),Ee=W[W.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+ae.raw,Ee.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.lheading(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(Le=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Te=F.slice(1),ce=void 0;Y.options.extensions.startBlock.forEach(function(ye){ce=ye.call({lexer:this},Te),typeof ce=="number"&&ce>=0&&(we=Math.min(we,ce))}),we<1/0&&we>=0&&(Le=F.substring(0,we+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Le))){Ee=W[W.length-1],be&&Ee.type==="paragraph"?(Ee.raw+=`
`+ae.raw,Ee.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):W.push(ae),be=Le.length!==F.length,F=F.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(F)){F=F.substring(ae.raw.length),Ee=W[W.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+ae.raw,Ee.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):W.push(ae);continue}if(F){var pe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return this.state.top=!0,W},U.inline=function(F,W){return W===void 0&&(W=[]),this.inlineQueue.push({src:F,tokens:W}),W},U.inlineTokens=function(F,W){var Y=this;W===void 0&&(W=[]);var ae,Ee,Le,be=F,pe,we,Te;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(pe=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)ce.includes(pe[0].slice(pe[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,pe.index)+"["+P("a",pe[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(pe=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,pe.index)+"["+P("a",pe[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(pe=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,pe.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(we||(Te=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(ae=ve.call({lexer:Y},F,W))?(F=F.substring(ae.raw.length),W.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.tag(F)){F=F.substring(ae.raw.length),Ee=W[W.length-1],Ee&&ae.type==="text"&&Ee.type==="text"?(Ee.raw+=ae.raw,Ee.text+=ae.text):W.push(ae);continue}if(ae=this.tokenizer.link(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(ae.raw.length),Ee=W[W.length-1],Ee&&ae.type==="text"&&Ee.type==="text"?(Ee.raw+=ae.raw,Ee.text+=ae.text):W.push(ae);continue}if(ae=this.tokenizer.emStrong(F,be,Te)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.codespan(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.br(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.del(F)){F=F.substring(ae.raw.length),W.push(ae);continue}if(ae=this.tokenizer.autolink(F,le)){F=F.substring(ae.raw.length),W.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(F,le))){F=F.substring(ae.raw.length),W.push(ae);continue}if(Le=F,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,ze=F.slice(1),qe=void 0;Y.options.extensions.startInline.forEach(function(Je){qe=Je.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(ve=Math.min(ve,qe))}),ve<1/0&&ve>=0&&(Le=F.substring(0,ve+1))}(),ae=this.tokenizer.inlineText(Le,ge)){F=F.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Te=ae.raw.slice(-1)),we=!0,Ee=W[W.length-1],Ee&&Ee.type==="text"?(Ee.raw+=ae.raw,Ee.text+=ae.text):W.push(ae);continue}if(F){var ye="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return W},t(B,null,[{key:"rules",get:function(){return{block:_,inline:de}}}]),B}(),Q=function(){function B(H){this.options=H||ue.defaults}var U=B.prototype;return U.code=function(F,W,Y){var ae=(W||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(F,ae);Ee!=null&&Ee!==F&&(Y=!0,F=Ee)}return F=F.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+a(ae,!0)+'">'+(Y?F:a(F,!0))+`</code></pre>
`:"<pre><code>"+(Y?F:a(F,!0))+`</code></pre>
`},U.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},U.html=function(F){return F},U.heading=function(F,W,Y,ae){if(this.options.headerIds){var Ee=this.options.headerPrefix+ae.slug(Y);return"<h"+W+' id="'+Ee+'">'+F+"</h"+W+`>
`}return"<h"+W+">"+F+"</h"+W+`>
`},U.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},U.list=function(F,W,Y){var ae=W?"ol":"ul",Ee=W&&Y!==1?' start="'+Y+'"':"";return"<"+ae+Ee+`>
`+F+"</"+ae+`>
`},U.listitem=function(F){return"<li>"+F+`</li>
`},U.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},U.paragraph=function(F){return"<p>"+F+`</p>
`},U.table=function(F,W){return W&&(W="<tbody>"+W+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+W+`</table>
`},U.tablerow=function(F){return`<tr>
`+F+`</tr>
`},U.tablecell=function(F,W){var Y=W.header?"th":"td",ae=W.align?"<"+Y+' align="'+W.align+'">':"<"+Y+">";return ae+F+("</"+Y+`>
`)},U.strong=function(F){return"<strong>"+F+"</strong>"},U.em=function(F){return"<em>"+F+"</em>"},U.codespan=function(F){return"<code>"+F+"</code>"},U.br=function(){return this.options.xhtml?"<br/>":"<br>"},U.del=function(F){return"<del>"+F+"</del>"},U.link=function(F,W,Y){if(F=i(this.options.sanitize,this.options.baseUrl,F),F===null)return Y;var ae='<a href="'+a(F)+'"';return W&&(ae+=' title="'+W+'"'),ae+=">"+Y+"</a>",ae},U.image=function(F,W,Y){if(F=i(this.options.sanitize,this.options.baseUrl,F),F===null)return Y;var ae='<img src="'+F+'" alt="'+Y+'"';return W&&(ae+=' title="'+W+'"'),ae+=this.options.xhtml?"/>":">",ae},U.text=function(F){return F},B}(),M=function(){function B(){}var U=B.prototype;return U.strong=function(F){return F},U.em=function(F){return F},U.codespan=function(F){return F},U.del=function(F){return F},U.html=function(F){return F},U.text=function(F){return F},U.link=function(F,W,Y){return""+Y},U.image=function(F,W,Y){return""+Y},U.br=function(){return""},B}(),V=function(){function B(){this.seen={}}var U=B.prototype;return U.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},U.getNextSafeSlug=function(F,W){var Y=F,ae=0;if(this.seen.hasOwnProperty(Y)){ae=this.seen[F];do ae++,Y=F+"-"+ae;while(this.seen.hasOwnProperty(Y))}return W||(this.seen[F]=ae,this.seen[Y]=0),Y},U.slug=function(F,W){W===void 0&&(W={});var Y=this.serialize(F);return this.getNextSafeSlug(Y,W.dryrun)},B}(),ne=function(){function B(H){this.options=H||ue.defaults,this.options.renderer=this.options.renderer||new Q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new V}B.parse=function(F,W){var Y=new B(W);return Y.parse(F)},B.parseInline=function(F,W){var Y=new B(W);return Y.parseInline(F)};var U=B.prototype;return U.parse=function(F,W){W===void 0&&(W=!0);var Y="",ae,Ee,Le,be,pe,we,Te,ce,ye,ve,ze,qe,Je,Ge,Ze,Ye,it,lt,rt,nt=F.length;for(ae=0;ae<nt;ae++){if(ve=F[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(rt=this.options.extensions.renderers[ve.type].call({parser:this},ve),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){Y+=rt||"";continue}switch(ve.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,d(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ce="",Te="",be=ve.header.length,Ee=0;Ee<be;Ee++)Te+=this.renderer.tablecell(this.parseInline(ve.header[Ee].tokens),{header:!0,align:ve.align[Ee]});for(ce+=this.renderer.tablerow(Te),ye="",be=ve.rows.length,Ee=0;Ee<be;Ee++){for(we=ve.rows[Ee],Te="",pe=we.length,Le=0;Le<pe;Le++)Te+=this.renderer.tablecell(this.parseInline(we[Le].tokens),{header:!1,align:ve.align[Le]});ye+=this.renderer.tablerow(Te)}Y+=this.renderer.table(ce,ye);continue}case"blockquote":{ye=this.parse(ve.tokens),Y+=this.renderer.blockquote(ye);continue}case"list":{for(ze=ve.ordered,qe=ve.start,Je=ve.loose,be=ve.items.length,ye="",Ee=0;Ee<be;Ee++)Ze=ve.items[Ee],Ye=Ze.checked,it=Ze.task,Ge="",Ze.task&&(lt=this.renderer.checkbox(Ye),Je?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=lt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=lt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:lt}):Ge+=lt),Ge+=this.parse(Ze.tokens,Je),ye+=this.renderer.listitem(Ge,it,Ye);Y+=this.renderer.list(ye,ze,qe);continue}case"html":{Y+=this.renderer.html(ve.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ye=ve.tokens?this.parseInline(ve.tokens):ve.text;ae+1<nt&&F[ae+1].type==="text";)ve=F[++ae],ye+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);Y+=W?this.renderer.paragraph(ye):ye;continue}default:{var tt='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}}return Y},U.parseInline=function(F,W){W=W||this.renderer;var Y="",ae,Ee,Le,be=F.length;for(ae=0;ae<be;ae++){if(Ee=F[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Le=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){Y+=Le||"";continue}switch(Ee.type){case"escape":{Y+=W.text(Ee.text);break}case"html":{Y+=W.html(Ee.text);break}case"link":{Y+=W.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,W));break}case"image":{Y+=W.image(Ee.href,Ee.title,Ee.text);break}case"strong":{Y+=W.strong(this.parseInline(Ee.tokens,W));break}case"em":{Y+=W.em(this.parseInline(Ee.tokens,W));break}case"codespan":{Y+=W.codespan(Ee.text);break}case"br":{Y+=W.br();break}case"del":{Y+=W.del(this.parseInline(Ee.tokens,W));break}case"text":{Y+=W.text(Ee.text);break}default:{var pe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return Y},B}();function re(B,U,H){if(typeof B>"u"||B===null)throw new Error("marked(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");if(typeof U=="function"&&(H=U,U=null),U=S({},re.defaults,U||{}),O(U),H){var F=U.highlight,W;try{W=z.lex(B,U)}catch(be){return H(be)}var Y=function(pe){var we;if(!pe)try{U.walkTokens&&re.walkTokens(W,U.walkTokens),we=ne.parse(W,U)}catch(Te){pe=Te}return U.highlight=F,pe?H(pe):H(null,we)};if(!F||F.length<3||(delete U.highlight,!W.length))return Y();var ae=0;re.walkTokens(W,function(be){be.type==="code"&&(ae++,setTimeout(function(){F(be.text,be.lang,function(pe,we){if(pe)return Y(pe);we!=null&&we!==be.text&&(be.text=we,be.escaped=!0),ae--,ae===0&&Y()})},0))}),ae===0&&Y();return}function Ee(be){if(be.message+=`
Please report this to https://github.com/markedjs/marked.`,U.silent)return"<p>An error occurred:</p><pre>"+a(be.message+"",!0)+"</pre>";throw be}try{var Le=z.lex(B,U);if(U.walkTokens){if(U.async)return Promise.all(re.walkTokens(Le,U.walkTokens)).then(function(){return ne.parse(Le,U)}).catch(Ee);re.walkTokens(Le,U.walkTokens)}return ne.parse(Le,U)}catch(be){Ee(be)}}re.options=re.setOptions=function(B){return S(re.defaults,B),A(re.defaults),re},re.getDefaults=C,re.defaults=ue.defaults,re.use=function(){for(var B=arguments.length,U=new Array(B),H=0;H<B;H++)U[H]=arguments[H];var F=S.apply(void 0,[{}].concat(U)),W=re.defaults.extensions||{renderers:{},childTokens:{}},Y;U.forEach(function(ae){if(ae.extensions&&(Y=!0,ae.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var be=W.renderers?W.renderers[Le.name]:null;be?W.renderers[Le.name]=function(){for(var pe=arguments.length,we=new Array(pe),Te=0;Te<pe;Te++)we[Te]=arguments[Te];var ce=Le.renderer.apply(this,we);return ce===!1&&(ce=be.apply(this,we)),ce}:W.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");W[Le.level]?W[Le.level].unshift(Le.tokenizer):W[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?W.startBlock?W.startBlock.push(Le.start):W.startBlock=[Le.start]:Le.level==="inline"&&(W.startInline?W.startInline.push(Le.start):W.startInline=[Le.start]))}Le.childTokens&&(W.childTokens[Le.name]=Le.childTokens)})),ae.renderer&&function(){var Le=re.defaults.renderer||new Q,be=function(Te){var ce=Le[Te];Le[Te]=function(){for(var ye=arguments.length,ve=new Array(ye),ze=0;ze<ye;ze++)ve[ze]=arguments[ze];var qe=ae.renderer[Te].apply(Le,ve);return qe===!1&&(qe=ce.apply(Le,ve)),qe}};for(var pe in ae.renderer)be(pe);F.renderer=Le}(),ae.tokenizer&&function(){var Le=re.defaults.tokenizer||new J,be=function(Te){var ce=Le[Te];Le[Te]=function(){for(var ye=arguments.length,ve=new Array(ye),ze=0;ze<ye;ze++)ve[ze]=arguments[ze];var qe=ae.tokenizer[Te].apply(Le,ve);return qe===!1&&(qe=ce.apply(Le,ve)),qe}};for(var pe in ae.tokenizer)be(pe);F.tokenizer=Le}(),ae.walkTokens){var Ee=re.defaults.walkTokens;F.walkTokens=function(Le){var be=[];return be.push(ae.walkTokens.call(this,Le)),Ee&&(be=be.concat(Ee.call(this,Le))),be}}Y&&(F.extensions=W),re.setOptions(F)})},re.walkTokens=function(B,U){for(var H=[],F=function(){var Ee=Y.value;switch(H=H.concat(U.call(re,Ee)),Ee.type){case"table":{for(var Le=k(Ee.header),be;!(be=Le()).done;){var pe=be.value;H=H.concat(re.walkTokens(pe.tokens,U))}for(var we=k(Ee.rows),Te;!(Te=we()).done;)for(var ce=Te.value,ye=k(ce),ve;!(ve=ye()).done;){var ze=ve.value;H=H.concat(re.walkTokens(ze.tokens,U))}break}case"list":{H=H.concat(re.walkTokens(Ee.items,U));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Ee.type]?re.defaults.extensions.childTokens[Ee.type].forEach(function(qe){H=H.concat(re.walkTokens(Ee[qe],U))}):Ee.tokens&&(H=H.concat(re.walkTokens(Ee.tokens,U)))}},W=k(B),Y;!(Y=W()).done;)F();return H},re.parseInline=function(B,U){if(typeof B>"u"||B===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");U=S({},re.defaults,U||{}),O(U);try{var H=z.lexInline(B,U);return U.walkTokens&&re.walkTokens(H,U.walkTokens),ne.parseInline(H,U)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,U.silent)return"<p>An error occurred:</p><pre>"+a(F.message+"",!0)+"</pre>";throw F}},re.Parser=ne,re.parser=ne.parse,re.Renderer=Q,re.TextRenderer=M,re.Lexer=z,re.lexer=z.lex,re.Tokenizer=J,re.Slugger=V,re.parse=re;var me=re.options,oe=re.setOptions,ie=re.use,x=re.walkTokens,G=re.parseInline,T=re,X=ne.parse,he=z.lex;ue.Lexer=z,ue.Parser=ne,ue.Renderer=Q,ue.Slugger=V,ue.TextRenderer=M,ue.Tokenizer=J,ue.getDefaults=C,ue.lexer=he,ue.marked=re,ue.options=me,ue.parse=T,ue.parseInline=G,ue.parser=X,ue.setOptions=oe,ue.use=ie,ue.walkTokens=x,Object.defineProperty(ue,"__esModule",{value:!0})}),define(Re[80],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var t;(function(s){s[s.Uri=1]="Uri",s[s.Regexp=2]="Regexp",s[s.ScmResource=3]="ScmResource",s[s.ScmResourceGroup=4]="ScmResourceGroup",s[s.ScmProvider=5]="ScmProvider",s[s.CommentController=6]="CommentController",s[s.CommentThread=7]="CommentThread",s[s.CommentThreadInstance=8]="CommentThreadInstance",s[s.CommentThreadReply=9]="CommentThreadReply",s[s.CommentNode=10]="CommentNode",s[s.CommentThreadNode=11]="CommentThreadNode",s[s.TimelineActionContext=12]="TimelineActionContext",s[s.NotebookCellActionContext=13]="NotebookCellActionContext",s[s.NotebookActionContext=14]="NotebookActionContext",s[s.TerminalContext=15]="TerminalContext",s[s.TestItemContext=16]="TestItemContext",s[s.Date=17]="Date",s[s.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(e.MarshalledId=t={}))}),define(Re[162],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=t;function t(u){const d=k(u);if(d&&d.length>0)return new Uint32Array(d)}let s=0;const E=new Uint32Array(10);function k(u){if(s=0,C(u,w,y.InitialConsonant),s>0||(C(u,m,y.Vowel),s>0)||(C(u,$,y.FinalConsonant),s>0)||(C(u,a,y.CompatibilityJamo),s))return E.subarray(0,s);if(u>=44032&&u<=55203){const d=u-44032,f=d%588,v=Math.floor(d/588),g=Math.floor(f/28),b=f%28-1;if(v<w.length?C(v,w,0):y.InitialConsonant+v-y.CompatibilityJamo<a.length&&C(y.InitialConsonant+v,a,y.CompatibilityJamo),g<m.length?C(g,m,0):y.Vowel+g-y.CompatibilityJamo<a.length&&C(y.Vowel+g-y.CompatibilityJamo,a,y.CompatibilityJamo),b>=0&&(b<$.length?C(b,$,0):y.FinalConsonant+b-y.CompatibilityJamo<a.length&&C(y.FinalConsonant+b-y.CompatibilityJamo,a,y.CompatibilityJamo)),s>0)return E.subarray(0,s)}}function C(u,d,f){u>=f&&u<f+d.length&&A(d[u-f])}function A(u){u!==o.NUL&&(E[s++]=u&255,u>>8&&(E[s++]=u>>8&255),u>>16&&(E[s++]=u>>16&255))}var y;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})(y||(y={}));var o;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(o||(o={}));var D;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(D||(D={}));const w=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),m=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l]),$=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,D.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.E,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,o.Q,D.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l])}),define(Re[106],Ae([1,0,25]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=E,e.$om=C;const s=new t.$Dc(1e4);function E(o){return y(o,"NFC",s)}const k=new t.$Dc(1e4);function C(o){return y(o,"NFD",k)}const A=/[^\u0000-\u0080]/;function y(o,D,w){if(!o)return o;const m=w.get(o);if(m)return m;let $;return A.test(o)?$=o.normalize(D):$=o,w.set(o,$),$}e.$pm=function(){const o=/[\u0300-\u036f]/g;return function(D){return C(D).replace(o,"")}}()}),define(Re[163],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=t,e.rot=s,e.$Qm=A;function t(y,o,D){return Math.min(Math.max(y,o),D)}function s(y,o){return(o+y%o)%o}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=E;class k{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=k;class C{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const D=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=C;function A(y,o,D,w,m,$,a,u){const d=a-D,f=u-w,v=m-D,g=$-w,b=y-D,i=o-w,p=d*d+f*f,n=d*v+f*g,l=d*b+f*i,r=v*v+g*g,h=v*b+g*i,c=1/(p*r-n*n),S=(r*l-n*h)*c,I=(p*h-n*l)*c;return S>=0&&I>=0&&S+I<1}}),define(Re[164],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=k,e.$cd=m;class t{constructor(a,u,d){this.owner=a,this.debugNameSource=u,this.referenceFn=d}getDebugName(a){return k(a,this)}}e.$ad=t;const s=new Map,E=new WeakMap;function k($,a){const u=E.get($);if(u)return u;const d=C($,a);if(d){let f=s.get(d)??0;f++,s.set(d,f);const v=f===1?d:`${d}#${f}`;return E.set($,v),v}}function C($,a){const u=E.get($);if(u)return u;const d=a.owner?D(a.owner)+".":"";let f;const v=a.debugNameSource;if(v!==void 0)if(typeof v=="function"){if(f=v(),f!==void 0)return d+f}else return d+v;const g=a.referenceFn;if(g!==void 0&&(f=m(g),f!==void 0))return d+f;if(a.owner!==void 0){const b=A(a.owner,$);if(b!==void 0)return d+b}}function A($,a){for(const u in $)if($[u]===a)return u}const y=new Map,o=new WeakMap;function D($){const a=o.get($);if(a)return a;const u=w($);let d=y.get(u)??0;d++,y.set(u,d);const f=d===1?u:`${u}#${d}`;return o.set($,f),f}function w($){const a=$.constructor;return a?a.name:"Object"}function m($){const a=$.toString(),d=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(d?d[1]:void 0)?.trim()}}),define(Re[165],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=s,e.$Ld=E;let t;function s(u){t=u}function E(){return t}class k{constructor(){this.a=0,this.d=new WeakMap}b(d){return C([A($("|  ",this.a)),d])}c(d){return d.hadValue?d.didChange?[A(" "),o(D(d.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),o(D(d.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),o(D(d.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(d,f){console.log(...this.b([y("observable value changed"),o(d.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(d){if(d.size!==0)return o(" (changed deps: "+[...d].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(d){const f=d.handleChange;this.d.set(d,new Set),d.handleChange=(v,g)=>(this.d.get(d).add(v),f.apply(d,[v,g]))}handleDerivedRecomputed(d,f){const v=this.d.get(d);console.log(...this.b([y("derived recomputed"),o(d.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(v),{data:[{fn:d._debugNameData.referenceFn??d._computeFn}]}])),v.clear()}handleFromEventObservableTriggered(d,f){console.log(...this.b([y("observable from event triggered"),o(d.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:d._getValue}]}]))}handleAutorunCreated(d){const f=d.handleChange;this.d.set(d,new Set),d.handleChange=(v,g)=>(this.d.get(d).add(v),f.apply(d,[v,g]))}handleAutorunTriggered(d){const f=this.d.get(d);console.log(...this.b([y("autorun"),o(d.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:d._debugNameData.referenceFn??d._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(d){this.a--}handleBeginTransaction(d){let f=d.getDebugName();f===void 0&&(f=""),console.log(...this.b([y("transaction"),o(f,{color:"BlueViolet"}),{data:[{fn:d._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=k;function C(u){const d=new Array,f=[];let v="";function g(i){if("length"in i)for(const p of i)p&&g(p);else"text"in i?(v+=`%c${i.text}`,d.push(i.style),i.data&&f.push(...i.data)):"data"in i&&f.push(...i.data)}g(u);const b=[v,...d];return b.push(...f),b}function A(u){return o(u,{color:"black"})}function y(u){return o(a(`${u}: `,10),{color:"black",bold:!0})}function o(u,d={color:"black"}){function f(g){return Object.entries(g).reduce((b,[i,p])=>`${b}${i}:${p};`,"")}const v={color:d.color};return d.strikeThrough&&(v["text-decoration"]="line-through"),d.bold&&(v["font-weight"]="bold"),{text:u,style:f(v)}}function D(u,d){switch(typeof u){case"number":return""+u;case"string":return u.length+2<=d?`"${u}"`:`"${u.substr(0,d-7)}"+...`;case"boolean":return u?"true":"false";case"undefined":return"undefined";case"object":return u===null?"null":Array.isArray(u)?w(u,d):m(u,d);case"symbol":return u.toString();case"function":return`[[Function${u.name?" "+u.name:""}]]`;default:return""+u}}function w(u,d){let f="[ ",v=!0;for(const g of u){if(v||(f+=", "),f.length-5>d){f+="...";break}v=!1,f+=`${D(g,d-f.length)}`}return f+=" ]",f}function m(u,d){let f="{ ",v=!0;for(const[g,b]of Object.entries(u)){if(v||(f+=", "),f.length-5>d){f+="...";break}v=!1,f+=`${g}: ${D(b,d-f.length)}`}return f+=" }",f}function $(u,d){let f="";for(let v=1;v<=d;v++)f+=u;return f}function a(u,d){for(;u.length<d;)u+=" ";return u}}),define(Re[166],Ae([1,0,157,164,165]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=C,e.$Wd=y,e.$Xd=D,e.$1d=$,e.$2d=u,e.$3d=d,e.$4d=f,e.$6d=g,e.$8d=i;let k;function C(n){k=n}let A;function y(n){A=n}let o;function D(n){o=n}class w{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,r){const h=r===void 0?void 0:l,c=r===void 0?l:r;return o({owner:h,debugName:()=>{const S=(0,s.$cd)(c);if(S!==void 0)return S;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(c.toString());if(R)return`${this.debugName}.${R[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:c},S=>c(this.read(S),S))}flatten(){return o({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},l=>this.read(l).read(l))}recomputeInitiallyAndOnChange(l,r){return l.add(k(this,r)),this}keepObserved(l){return l.add(A(this)),this}get a(){return this.get()}}e.$Yd=w;class m extends w{constructor(){super(...arguments),this.b=new Set}addObserver(l){const r=this.b.size;this.b.add(l),r===0&&this.c()}removeObserver(l){this.b.delete(l)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=m;function $(n,l){const r=new v(n,l);try{n(r)}finally{r.finish()}}let a;function u(n){if(a)n(a);else{const l=new v(n,void 0);a=l;try{n(l)}finally{l.finish(),a=void 0}}}async function d(n,l){const r=new v(n,l);try{await n(r)}finally{r.finish()}}function f(n,l,r){n?l(n):$(l,r)}class v{constructor(l,r){this._fn=l,this.b=r,this.a=[],(0,E.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,s.$cd)(this._fn)}updateObserver(l,r){this.a.push({observer:l,observable:r}),l.beginUpdate(r)}finish(){const l=this.a;for(let r=0;r<l.length;r++){const{observer:h,observable:c}=l[r];h.endUpdate(c)}this.a=null,(0,E.$Ld)()?.handleEndTransaction()}}e.$5d=v;function g(n,l){let r;return typeof n=="string"?r=new s.$ad(void 0,n,void 0):r=new s.$ad(n,void 0,void 0),new b(r,l,t.$6c)}class b extends m{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(l,r,h){super(),this.e=l,this.g=h,this.d=r}get(){return this.d}set(l,r,h){if(h===void 0&&this.g(this.d,l))return;let c;r||(r=c=new v(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(l),(0,E.$Ld)()?.handleObservableChanged(this,{oldValue:S,newValue:l,change:h,didChange:!0,hadValue:!0});for(const I of this.b)r.updateObserver(I,this),I.handleChange(this,h)}finally{c&&c.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(l){this.d=l}}e.$7d=b;function i(n,l){let r;return typeof n=="string"?r=new s.$ad(void 0,n,void 0):r=new s.$ad(n,void 0,void 0),new p(r,l,t.$6c)}class p extends b{h(l){this.d!==l&&(this.d&&this.d.dispose(),this.d=l)}dispose(){this.d?.dispose()}}e.$9d=p}),function(){function ue(E){const k=[];typeof E=="number"&&k.push("code/timeOrigin",E);function C(y){k.push(y,Date.now())}function A(){const y=[];for(let o=0;o<k.length;o+=2)y.push({name:k[o],startTime:k[o+1]});return y}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const C of performance.getEntriesByType("mark"))k.push({name:C.name,startTime:Math.round(E+C.startTime)});return k}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function t(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var s;typeof global=="object"?s=global:typeof self=="object"?s=self:s={},typeof define=="function"?define("vs/base/common/performance",[],function(){return t(s)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=t(s):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),s.perf=t(s))}(),define(Re[3],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=p,e.$E=S,e.$K=I,e.$h="en";let t=!1,s=!1,E=!1,k=!1,C=!1,A=!1,y=!1,o=!1,D=!1,w=!1,m,$=e.$h,a=e.$h,u,d;const f=globalThis;let v;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?v=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const g=typeof v?.versions?.electron=="string",b=g&&v?.type==="renderer";if(typeof v=="object"){t=v.platform==="win32",s=v.platform==="darwin",E=v.platform==="linux",k=E&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,y=g,D=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$h,$=e.$h;const R=v.env.VSCODE_NLS_CONFIG;if(R)try{const L=JSON.parse(R);m=L.userLocale,a=L.osLocale,$=L.resolvedLanguage||e.$h,u=L.languagePack?.translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!b?(d=navigator.userAgent,t=d.indexOf("Windows")>=0,s=d.indexOf("Macintosh")>=0,o=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=d.indexOf("Linux")>=0,w=d?.indexOf("Mobi")>=0,A=!0,$=globalThis._VSCODE_NLS_LANGUAGE||e.$h,m=navigator.language.toLowerCase(),a=m):console.error("Unable to resolve platform.");var i;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(i||(e.Platform=i={}));function p(R){switch(R){case i.Web:return"Web";case i.Mac:return"Mac";case i.Linux:return"Linux";case i.Windows:return"Windows"}}let n=i.Web;s?n=i.Mac:t?n=i.Windows:E&&(n=i.Linux),e.$j=t,e.$k=s,e.$l=E,e.$m=k,e.$n=C,e.$o=y,e.$p=A,e.$q=A&&typeof f.importScripts=="function",e.$r=e.$q?f.origin:void 0,e.$s=o,e.$t=w,e.$u=D,e.$v=n,e.$w=d,e.$x=$;var l;(function(R){function L(){return e.$x}R.value=L;function O(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}R.isDefaultVariant=O;function P(){return e.$x==="en"}R.isDefault=P})(l||(e.Language=l={})),e.$y=m,e.$z=a,e.$A=u,e.$B=typeof f.postMessage=="function"&&!f.importScripts,e.$C=(()=>{if(e.$B){const R=[];f.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let P=0,q=R.length;P<q;P++){const K=R[P];if(K.id===O.data.vscodeScheduleAsyncWork){R.splice(P,1),K.callback();return}}});let L=0;return O=>{const P=++L;R.push({id:P,callback:O}),f.postMessage({vscodeScheduleAsyncWork:P},"*")}}return R=>setTimeout(R)})();var r;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=s||o?r.Macintosh:t?r.Windows:r.Linux;let h=!0,c=!1;function S(){if(!c){c=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,h=new Uint16Array(R.buffer)[0]===513}return h}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function I(R){return parseFloat(R)>=20}}),define(Re[167],Ae([1,0,39]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=void 0;const s=Symbol("unset");class E{constructor(){this.a=new C,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||t.Iterable.empty()}get entries(){return this.a.children?.entries()||t.Iterable.empty()}insert(y,o,D){this.d(y,w=>w._value=o,D)}mutate(y,o){this.d(y,D=>D._value=o(D._value===s?void 0:D._value))}mutatePath(y,o){this.d(y,()=>{},D=>o(D))}delete(y){const o=this.c(y);if(!o)return;let D=o.length-1;const w=o[D].node._value;if(w!==s){for(this.b--,o[D].node._value=s;D>0;D--){const{node:m,part:$}=o[D];if(m.children?.size||m._value!==s)break;o[D-1].node.children.delete($)}return w}}*deleteRecursive(y){const o=this.c(y);if(!o)return;const D=o[o.length-1].node;for(let w=o.length-1;w>0;w--){const m=o[w-1];if(m.node.children.delete(o[w].part),m.node.children.size>0||m.node._value!==s)break}for(const w of k(D))w._value!==s&&(this.b--,yield w._value)}find(y){let o=this.a;for(const D of y){const w=o.children?.get(D);if(!w)return;o=w}return o._value===s?void 0:o._value}hasKeyOrParent(y){let o=this.a;for(const D of y){const w=o.children?.get(D);if(!w)return!1;if(w._value!==s)return!0;o=w}return!1}hasKeyOrChildren(y){let o=this.a;for(const D of y){const w=o.children?.get(D);if(!w)return!1;o=w}return!0}hasKey(y){let o=this.a;for(const D of y){const w=o.children?.get(D);if(!w)return!1;o=w}return o._value!==s}c(y){const o=[{part:"",node:this.a}];let D=0;for(const w of y){const m=o[D].node.children?.get(w);if(!m)return;o.push({part:w,node:m}),D++}return o}d(y,o,D){let w=this.a;for(const a of y){if(w.children)if(w.children.has(a))w=w.children.get(a);else{const u=new C;w.children.set(a,u),w=u}else{const u=new C;w.children=new Map([[a,u]]),w=u}D?.(w)}const m=w._value===s?0:1;o(w);const $=w._value===s?0:1;this.b+=$-m}*values(){for(const{_value:y}of k(this.a))y!==s&&(yield y)}}e.$6I=E;function*k(A){const y=[A];for(;y.length>0;){const o=y.pop();if(yield o,o.children)for(const D of o.children.values())y.push(D)}}class C{constructor(){this._value=s}get value(){return this._value===s?void 0:this._value}set value(y){this._value=y===void 0?s:y}}}),define(Re[31],Ae([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let s;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const k=E.process;s={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?s={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:s={get platform(){return t.$j?"win32":t.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=s.cwd,e.env=s.env,e.$dc=s.platform,e.$ec=s.arch}),define(Re[8],Ae([1,0,31]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,t=Ue(t);const s=65,E=97,k=90,C=122,A=46,y=47,o=92,D=58,w=63;class m extends Error{constructor(l,r,h){let c;typeof r=="string"&&r.indexOf("not ")===0?(c="must not be",r=r.replace(/^not /,"")):c="must be";const S=l.indexOf(".")!==-1?"property":"argument";let I=`The "${l}" ${S} ${c} of type ${r}`;I+=`. Received type ${typeof h}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function $(n,l){if(n===null||typeof n!="object")throw new m(l,"Object",n)}function a(n,l){if(typeof n!="string")throw new m(l,"string",n)}const u=t.$dc==="win32";function d(n){return n===y||n===o}function f(n){return n===y}function v(n){return n>=s&&n<=k||n>=E&&n<=C}function g(n,l,r,h){let c="",S=0,I=-1,R=0,L=0;for(let O=0;O<=n.length;++O){if(O<n.length)L=n.charCodeAt(O);else{if(h(L))break;L=y}if(h(L)){if(!(I===O-1||R===1))if(R===2){if(c.length<2||S!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const P=c.lastIndexOf(r);P===-1?(c="",S=0):(c=c.slice(0,P),S=c.length-1-c.lastIndexOf(r)),I=O,R=0;continue}else if(c.length!==0){c="",S=0,I=O,R=0;continue}}l&&(c+=c.length>0?`${r}..`:"..",S=2)}else c.length>0?c+=`${r}${n.slice(I+1,O)}`:c=n.slice(I+1,O),S=O-I-1;I=O,R=0}else L===A&&R!==-1?++R:R=-1}return c}function b(n){return n?`${n[0]==="."?"":"."}${n}`:""}function i(n,l){$(l,"pathObject");const r=l.dir||l.root,h=l.base||`${l.name||""}${b(l.ext)}`;return r?r===l.root?`${r}${h}`:`${r}${n}${h}`:h}e.$fc={resolve(...n){let l="",r="",h=!1;for(let c=n.length-1;c>=-1;c--){let S;if(c>=0){if(S=n[c],a(S,`paths[${c}]`),S.length===0)continue}else l.length===0?S=t.cwd():(S=t.env[`=${l}`]||t.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==l.toLowerCase()&&S.charCodeAt(2)===o)&&(S=`${l}\\`));const I=S.length;let R=0,L="",O=!1;const P=S.charCodeAt(0);if(I===1)d(P)&&(R=1,O=!0);else if(d(P))if(O=!0,d(S.charCodeAt(1))){let q=2,K=q;for(;q<I&&!d(S.charCodeAt(q));)q++;if(q<I&&q!==K){const J=S.slice(K,q);for(K=q;q<I&&d(S.charCodeAt(q));)q++;if(q<I&&q!==K){for(K=q;q<I&&!d(S.charCodeAt(q));)q++;(q===I||q!==K)&&(L=`\\\\${J}\\${S.slice(K,q)}`,R=q)}}}else R=1;else v(P)&&S.charCodeAt(1)===D&&(L=S.slice(0,2),R=2,I>2&&d(S.charCodeAt(2))&&(O=!0,R=3));if(L.length>0)if(l.length>0){if(L.toLowerCase()!==l.toLowerCase())continue}else l=L;if(h){if(l.length>0)break}else if(r=`${S.slice(R)}\\${r}`,h=O,O&&l.length>0)break}return r=g(r,!h,"\\",d),h?`${l}\\${r}`:`${l}${r}`||"."},normalize(n){a(n,"path");const l=n.length;if(l===0)return".";let r=0,h,c=!1;const S=n.charCodeAt(0);if(l===1)return f(S)?"\\":n;if(d(S))if(c=!0,d(n.charCodeAt(1))){let R=2,L=R;for(;R<l&&!d(n.charCodeAt(R));)R++;if(R<l&&R!==L){const O=n.slice(L,R);for(L=R;R<l&&d(n.charCodeAt(R));)R++;if(R<l&&R!==L){for(L=R;R<l&&!d(n.charCodeAt(R));)R++;if(R===l)return`\\\\${O}\\${n.slice(L)}\\`;R!==L&&(h=`\\\\${O}\\${n.slice(L,R)}`,r=R)}}}else r=1;else v(S)&&n.charCodeAt(1)===D&&(h=n.slice(0,2),r=2,l>2&&d(n.charCodeAt(2))&&(c=!0,r=3));let I=r<l?g(n.slice(r),!c,"\\",d):"";return I.length===0&&!c&&(I="."),I.length>0&&d(n.charCodeAt(l-1))&&(I+="\\"),h===void 0?c?`\\${I}`:I:c?`${h}\\${I}`:`${h}${I}`},isAbsolute(n){a(n,"path");const l=n.length;if(l===0)return!1;const r=n.charCodeAt(0);return d(r)||l>2&&v(r)&&n.charCodeAt(1)===D&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let l,r;for(let S=0;S<n.length;++S){const I=n[S];a(I,"path"),I.length>0&&(l===void 0?l=r=I:l+=`\\${I}`)}if(l===void 0)return".";let h=!0,c=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++c;const S=r.length;S>1&&d(r.charCodeAt(1))&&(++c,S>2&&(d(r.charCodeAt(2))?++c:h=!1))}if(h){for(;c<l.length&&d(l.charCodeAt(c));)c++;c>=2&&(l=`\\${l.slice(c)}`)}return e.$fc.normalize(l)},relative(n,l){if(a(n,"from"),a(l,"to"),n===l)return"";const r=e.$fc.resolve(n),h=e.$fc.resolve(l);if(r===h||(n=r.toLowerCase(),l=h.toLowerCase(),n===l))return"";let c=0;for(;c<n.length&&n.charCodeAt(c)===o;)c++;let S=n.length;for(;S-1>c&&n.charCodeAt(S-1)===o;)S--;const I=S-c;let R=0;for(;R<l.length&&l.charCodeAt(R)===o;)R++;let L=l.length;for(;L-1>R&&l.charCodeAt(L-1)===o;)L--;const O=L-R,P=I<O?I:O;let q=-1,K=0;for(;K<P;K++){const _=n.charCodeAt(c+K);if(_!==l.charCodeAt(R+K))break;_===o&&(q=K)}if(K!==P){if(q===-1)return h}else{if(O>P){if(l.charCodeAt(R+K)===o)return h.slice(R+K+1);if(K===2)return h.slice(R+K)}I>P&&(n.charCodeAt(c+K)===o?q=K:K===2&&(q=3)),q===-1&&(q=0)}let J="";for(K=c+q+1;K<=S;++K)(K===S||n.charCodeAt(K)===o)&&(J+=J.length===0?"..":"\\..");return R+=q,J.length>0?`${J}${h.slice(R,L)}`:(h.charCodeAt(R)===o&&++R,h.slice(R,L))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const l=e.$fc.resolve(n);if(l.length<=2)return n;if(l.charCodeAt(0)===o){if(l.charCodeAt(1)===o){const r=l.charCodeAt(2);if(r!==w&&r!==A)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===D&&l.charCodeAt(2)===o)return`\\\\?\\${l}`;return n},dirname(n){a(n,"path");const l=n.length;if(l===0)return".";let r=-1,h=0;const c=n.charCodeAt(0);if(l===1)return d(c)?n:".";if(d(c)){if(r=h=1,d(n.charCodeAt(1))){let R=2,L=R;for(;R<l&&!d(n.charCodeAt(R));)R++;if(R<l&&R!==L){for(L=R;R<l&&d(n.charCodeAt(R));)R++;if(R<l&&R!==L){for(L=R;R<l&&!d(n.charCodeAt(R));)R++;if(R===l)return n;R!==L&&(r=h=R+1)}}}}else v(c)&&n.charCodeAt(1)===D&&(r=l>2&&d(n.charCodeAt(2))?3:2,h=r);let S=-1,I=!0;for(let R=l-1;R>=h;--R)if(d(n.charCodeAt(R))){if(!I){S=R;break}}else I=!1;if(S===-1){if(r===-1)return".";S=r}return n.slice(0,S)},basename(n,l){l!==void 0&&a(l,"suffix"),a(n,"path");let r=0,h=-1,c=!0,S;if(n.length>=2&&v(n.charCodeAt(0))&&n.charCodeAt(1)===D&&(r=2),l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let I=l.length-1,R=-1;for(S=n.length-1;S>=r;--S){const L=n.charCodeAt(S);if(d(L)){if(!c){r=S+1;break}}else R===-1&&(c=!1,R=S+1),I>=0&&(L===l.charCodeAt(I)?--I===-1&&(h=S):(I=-1,h=R))}return r===h?h=R:h===-1&&(h=n.length),n.slice(r,h)}for(S=n.length-1;S>=r;--S)if(d(n.charCodeAt(S))){if(!c){r=S+1;break}}else h===-1&&(c=!1,h=S+1);return h===-1?"":n.slice(r,h)},extname(n){a(n,"path");let l=0,r=-1,h=0,c=-1,S=!0,I=0;n.length>=2&&n.charCodeAt(1)===D&&v(n.charCodeAt(0))&&(l=h=2);for(let R=n.length-1;R>=l;--R){const L=n.charCodeAt(R);if(d(L)){if(!S){h=R+1;break}continue}c===-1&&(S=!1,c=R+1),L===A?r===-1?r=R:I!==1&&(I=1):r!==-1&&(I=-1)}return r===-1||c===-1||I===0||I===1&&r===c-1&&r===h+1?"":n.slice(r,c)},format:i.bind(null,"\\"),parse(n){a(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const r=n.length;let h=0,c=n.charCodeAt(0);if(r===1)return d(c)?(l.root=l.dir=n,l):(l.base=l.name=n,l);if(d(c)){if(h=1,d(n.charCodeAt(1))){let q=2,K=q;for(;q<r&&!d(n.charCodeAt(q));)q++;if(q<r&&q!==K){for(K=q;q<r&&d(n.charCodeAt(q));)q++;if(q<r&&q!==K){for(K=q;q<r&&!d(n.charCodeAt(q));)q++;q===r?h=q:q!==K&&(h=q+1)}}}}else if(v(c)&&n.charCodeAt(1)===D){if(r<=2)return l.root=l.dir=n,l;if(h=2,d(n.charCodeAt(2))){if(r===3)return l.root=l.dir=n,l;h=3}}h>0&&(l.root=n.slice(0,h));let S=-1,I=h,R=-1,L=!0,O=n.length-1,P=0;for(;O>=h;--O){if(c=n.charCodeAt(O),d(c)){if(!L){I=O+1;break}continue}R===-1&&(L=!1,R=O+1),c===A?S===-1?S=O:P!==1&&(P=1):S!==-1&&(P=-1)}return R!==-1&&(S===-1||P===0||P===1&&S===R-1&&S===I+1?l.base=l.name=n.slice(I,R):(l.name=n.slice(I,S),l.base=n.slice(I,R),l.ext=n.slice(S,R))),I>0&&I!==h?l.dir=n.slice(0,I-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(u){const n=/\\/g;return()=>{const l=t.cwd().replace(n,"/");return l.slice(l.indexOf("/"))}}return()=>t.cwd()})();e.$gc={resolve(...n){let l="",r=!1;for(let h=n.length-1;h>=-1&&!r;h--){const c=h>=0?n[h]:p();a(c,`paths[${h}]`),c.length!==0&&(l=`${c}/${l}`,r=c.charCodeAt(0)===y)}return l=g(l,!r,"/",f),r?`/${l}`:l.length>0?l:"."},normalize(n){if(a(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===y,r=n.charCodeAt(n.length-1)===y;return n=g(n,!l,"/",f),n.length===0?l?"/":r?"./":".":(r&&(n+="/"),l?`/${n}`:n)},isAbsolute(n){return a(n,"path"),n.length>0&&n.charCodeAt(0)===y},join(...n){if(n.length===0)return".";let l;for(let r=0;r<n.length;++r){const h=n[r];a(h,"path"),h.length>0&&(l===void 0?l=h:l+=`/${h}`)}return l===void 0?".":e.$gc.normalize(l)},relative(n,l){if(a(n,"from"),a(l,"to"),n===l||(n=e.$gc.resolve(n),l=e.$gc.resolve(l),n===l))return"";const r=1,h=n.length,c=h-r,S=1,I=l.length-S,R=c<I?c:I;let L=-1,O=0;for(;O<R;O++){const q=n.charCodeAt(r+O);if(q!==l.charCodeAt(S+O))break;q===y&&(L=O)}if(O===R)if(I>R){if(l.charCodeAt(S+O)===y)return l.slice(S+O+1);if(O===0)return l.slice(S+O)}else c>R&&(n.charCodeAt(r+O)===y?L=O:O===0&&(L=0));let P="";for(O=r+L+1;O<=h;++O)(O===h||n.charCodeAt(O)===y)&&(P+=P.length===0?"..":"/..");return`${P}${l.slice(S+L)}`},toNamespacedPath(n){return n},dirname(n){if(a(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===y;let r=-1,h=!0;for(let c=n.length-1;c>=1;--c)if(n.charCodeAt(c)===y){if(!h){r=c;break}}else h=!1;return r===-1?l?"/":".":l&&r===1?"//":n.slice(0,r)},basename(n,l){l!==void 0&&a(l,"ext"),a(n,"path");let r=0,h=-1,c=!0,S;if(l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let I=l.length-1,R=-1;for(S=n.length-1;S>=0;--S){const L=n.charCodeAt(S);if(L===y){if(!c){r=S+1;break}}else R===-1&&(c=!1,R=S+1),I>=0&&(L===l.charCodeAt(I)?--I===-1&&(h=S):(I=-1,h=R))}return r===h?h=R:h===-1&&(h=n.length),n.slice(r,h)}for(S=n.length-1;S>=0;--S)if(n.charCodeAt(S)===y){if(!c){r=S+1;break}}else h===-1&&(c=!1,h=S+1);return h===-1?"":n.slice(r,h)},extname(n){a(n,"path");let l=-1,r=0,h=-1,c=!0,S=0;for(let I=n.length-1;I>=0;--I){const R=n.charCodeAt(I);if(R===y){if(!c){r=I+1;break}continue}h===-1&&(c=!1,h=I+1),R===A?l===-1?l=I:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||h===-1||S===0||S===1&&l===h-1&&l===r+1?"":n.slice(l,h)},format:i.bind(null,"/"),parse(n){a(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const r=n.charCodeAt(0)===y;let h;r?(l.root="/",h=1):h=0;let c=-1,S=0,I=-1,R=!0,L=n.length-1,O=0;for(;L>=h;--L){const P=n.charCodeAt(L);if(P===y){if(!R){S=L+1;break}continue}I===-1&&(R=!1,I=L+1),P===A?c===-1?c=L:O!==1&&(O=1):c!==-1&&(O=-1)}if(I!==-1){const P=S===0&&r?1:S;c===-1||O===0||O===1&&c===I-1&&c===S+1?l.base=l.name=n.slice(P,I):(l.name=n.slice(P,c),l.base=n.slice(P,I),l.ext=n.slice(c,I))}return S>0?l.dir=n.slice(0,S-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Re[65],Ae([1,0,8]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0,e.$_s=k,e.$at=C,e.$bt=A,e.$ct=o,e.$$s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const s={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(D){const w=(0,t.$oc)(D),m=s[w.toLowerCase()];return m!==void 0?m:C(D)}function C(D){const w=(0,t.$oc)(D);return E[w.toLowerCase()]}function A(D){for(const w in E)if(E[w]===D)return w}const y=/^(.+)\/(.+?)(;.+)?$/;function o(D,w){const m=y.exec(D);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:D}}),define(Re[66],Ae([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=k,e.$mm=C;var s;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(s||(e.Source=s={}));var E;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function k(A,...y){const o=y.reduce((m,$)=>(m[$]=!0,m),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(m=>!o[m]).forEach(m=>{for(let $=0;$<D.length;$++)if(m.search(D[$])!==-1){delete A[m];break}})}function C(A){A&&(delete A.DEBUG,t.$l&&delete A.LD_PRELOAD)}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var t=e();for(var s in t)(typeof exports=="object"?exports:ue)[s]=t[s]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function t(s){if(e[s])return e[s].exports;var E=e[s]={i:s,l:!1,exports:{}};return ue[s].call(E.exports,E,E.exports,t),E.l=!0,E.exports}return t.m=ue,t.c=e,t.d=function(s,E,k){t.o(s,E)||Object.defineProperty(s,E,{enumerable:!0,get:k})},t.r=function(s){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(s,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(s,"__esModule",{value:!0})},t.t=function(s,E){if(1&E&&(s=t(s)),8&E||4&E&&typeof s=="object"&&s&&s.__esModule)return s;var k=Object.create(null);if(t.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:s}),2&E&&typeof s!="string")for(var C in s)t.d(k,C,function(A){return s[A]}.bind(null,C));return k},t.n=function(s){var E=s&&s.__esModule?function(){return s.default}:function(){return s};return t.d(E,"a",E),E},t.o=function(s,E){return Object.prototype.hasOwnProperty.call(s,E)},t.p="",t(t.s=0)}([function(ue,e,t){(function(s){var E;e=ue.exports=ie,E=typeof s=="object"&&s.env&&s.env.NODE_DEBUG&&/\bsemver\b/i.test(s.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],o=0,D=o++;y[D]="0|[1-9]\\d*";var w=o++;y[w]="[0-9]+";var m=o++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=o++;y[$]="("+y[D]+")\\.("+y[D]+")\\.("+y[D]+")";var a=o++;y[a]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var u=o++;y[u]="(?:"+y[D]+"|"+y[m]+")";var d=o++;y[d]="(?:"+y[w]+"|"+y[m]+")";var f=o++;y[f]="(?:-("+y[u]+"(?:\\."+y[u]+")*))";var v=o++;y[v]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var g=o++;y[g]="[0-9A-Za-z-]+";var b=o++;y[b]="(?:\\+("+y[g]+"(?:\\."+y[g]+")*))";var i=o++,p="v?"+y[$]+y[f]+"?"+y[b]+"?";y[i]="^"+p+"$";var n="[v=\\s]*"+y[a]+y[v]+"?"+y[b]+"?",l=o++;y[l]="^"+n+"$";var r=o++;y[r]="((?:<|>)?=?)";var h=o++;y[h]=y[w]+"|x|X|\\*";var c=o++;y[c]=y[D]+"|x|X|\\*";var S=o++;y[S]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[f]+")?"+y[b]+"?)?)?";var I=o++;y[I]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[v]+")?"+y[b]+"?)?)?";var R=o++;y[R]="^"+y[r]+"\\s*"+y[S]+"$";var L=o++;y[L]="^"+y[r]+"\\s*"+y[I]+"$";var O=o++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=o++;y[P]="(?:~>?)";var q=o++;y[q]="(\\s*)"+y[P]+"\\s+",A[q]=new RegExp(y[q],"g");var K=o++;y[K]="^"+y[P]+y[S]+"$";var J=o++;y[J]="^"+y[P]+y[I]+"$";var _=o++;y[_]="(?:\\^)";var de=o++;y[de]="(\\s*)"+y[_]+"\\s+",A[de]=new RegExp(y[de],"g");var ge=o++;y[ge]="^"+y[_]+y[S]+"$";var le=o++;y[le]="^"+y[_]+y[I]+"$";var z=o++;y[z]="^"+y[r]+"\\s*("+n+")$|^$";var Q=o++;y[Q]="^"+y[r]+"\\s*("+p+")$|^$";var M=o++;y[M]="(\\s*)"+y[r]+"\\s*("+n+"|"+y[S]+")",A[M]=new RegExp(y[M],"g");var V=o++;y[V]="^\\s*("+y[S]+")\\s+-\\s+("+y[S]+")\\s*$";var ne=o++;y[ne]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var re=o++;y[re]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)E(me,y[me]),A[me]||(A[me]=new RegExp(y[me]));function oe(ce,ye){if(ce instanceof ie)return ce;if(typeof ce!="string"||ce.length>k||!(ye?A[l]:A[i]).test(ce))return null;try{return new ie(ce,ye)}catch{return null}}function ie(ce,ye){if(ce instanceof ie){if(ce.loose===ye)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ie))return new ie(ce,ye);E("SemVer",ce,ye),this.loose=ye;var ve=ce.trim().match(ye?A[l]:A[i]);if(!ve)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var qe=+ze;if(qe>=0&&qe<C)return qe}return ze}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ce,ye){var ve=oe(ce,ye);return ve?ve.version:null},e.clean=function(ce,ye){var ve=oe(ce.trim().replace(/^[=v]+/,""),ye);return ve?ve.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(ce){return E("SemVer.compare",this.version,this.loose,ce),ce instanceof ie||(ce=new ie(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},ie.prototype.compareMain=function(ce){return ce instanceof ie||(ce=new ie(ce,this.loose)),G(this.major,ce.major)||G(this.minor,ce.minor)||G(this.patch,ce.patch)},ie.prototype.comparePre=function(ce){if(ce instanceof ie||(ce=new ie(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ye=0;do{var ve=this.prerelease[ye],ze=ce.prerelease[ye];if(E("prerelease compare",ye,ve,ze),ve===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ve===void 0)return-1;if(ve!==ze)return G(ve,ze)}while(++ye)},ie.prototype.inc=function(ce,ye){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ye);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ye);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ye),this.inc("pre",ye);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ye),this.inc("pre",ye);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ye&&(this.prerelease[0]===ye?isNaN(this.prerelease[1])&&(this.prerelease=[ye,0]):this.prerelease=[ye,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ye,ve,ze){typeof ve=="string"&&(ze=ve,ve=void 0);try{return new ie(ce,ve).inc(ye,ze).version}catch{return null}},e.diff=function(ce,ye){if(B(ce,ye))return null;var ve=oe(ce),ze=oe(ye);if(ve.prerelease.length||ze.prerelease.length){for(var qe in ve)if((qe==="major"||qe==="minor"||qe==="patch")&&ve[qe]!==ze[qe])return"pre"+qe;return"prerelease"}for(var qe in ve)if((qe==="major"||qe==="minor"||qe==="patch")&&ve[qe]!==ze[qe])return qe},e.compareIdentifiers=G;var x=/^[0-9]+$/;function G(ce,ye){var ve=x.test(ce),ze=x.test(ye);return ve&&ze&&(ce=+ce,ye=+ye),ve&&!ze?-1:ze&&!ve?1:ce<ye?-1:ce>ye?1:0}function T(ce,ye,ve){return new ie(ce,ve).compare(new ie(ye,ve))}function X(ce,ye,ve){return T(ce,ye,ve)>0}function he(ce,ye,ve){return T(ce,ye,ve)<0}function B(ce,ye,ve){return T(ce,ye,ve)===0}function U(ce,ye,ve){return T(ce,ye,ve)!==0}function H(ce,ye,ve){return T(ce,ye,ve)>=0}function F(ce,ye,ve){return T(ce,ye,ve)<=0}function W(ce,ye,ve,ze){var qe;switch(ye){case"===":typeof ce=="object"&&(ce=ce.version),typeof ve=="object"&&(ve=ve.version),qe=ce===ve;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ve=="object"&&(ve=ve.version),qe=ce!==ve;break;case"":case"=":case"==":qe=B(ce,ve,ze);break;case"!=":qe=U(ce,ve,ze);break;case">":qe=X(ce,ve,ze);break;case">=":qe=H(ce,ve,ze);break;case"<":qe=he(ce,ve,ze);break;case"<=":qe=F(ce,ve,ze);break;default:throw new TypeError("Invalid operator: "+ye)}return qe}function Y(ce,ye){if(ce instanceof Y){if(ce.loose===ye)return ce;ce=ce.value}if(!(this instanceof Y))return new Y(ce,ye);E("comparator",ce,ye),this.loose=ye,this.parse(ce),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(ce,ye){return G(ye,ce)},e.major=function(ce,ye){return new ie(ce,ye).major},e.minor=function(ce,ye){return new ie(ce,ye).minor},e.patch=function(ce,ye){return new ie(ce,ye).patch},e.compare=T,e.compareLoose=function(ce,ye){return T(ce,ye,!0)},e.rcompare=function(ce,ye,ve){return T(ye,ce,ve)},e.sort=function(ce,ye){return ce.sort(function(ve,ze){return e.compare(ve,ze,ye)})},e.rsort=function(ce,ye){return ce.sort(function(ve,ze){return e.rcompare(ve,ze,ye)})},e.gt=X,e.lt=he,e.eq=B,e.neq=U,e.gte=H,e.lte=F,e.cmp=W,e.Comparator=Y;var ae={};function Ee(ce,ye){if(ce instanceof Ee)return ce.loose===ye?ce:new Ee(ce.raw,ye);if(ce instanceof Y)return new Ee(ce.value,ye);if(!(this instanceof Ee))return new Ee(ce,ye);if(this.loose=ye,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Le(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function be(ce,ye,ve,ze,qe,Je,Ge,Ze,Ye,it,lt,rt,nt){return((ye=Le(ve)?"":Le(ze)?">="+ve+".0.0":Le(qe)?">="+ve+"."+ze+".0":">="+ye)+" "+(Ze=Le(Ye)?"":Le(it)?"<"+(+Ye+1)+".0.0":Le(lt)?"<"+Ye+"."+(+it+1)+".0":rt?"<="+Ye+"."+it+"."+lt+"-"+rt:"<="+Ze)).trim()}function pe(ce,ye){for(var ve=0;ve<ce.length;ve++)if(!ce[ve].test(ye))return!1;if(ye.prerelease.length){for(ve=0;ve<ce.length;ve++)if(E(ce[ve].semver),ce[ve].semver!==ae&&ce[ve].semver.prerelease.length>0){var ze=ce[ve].semver;if(ze.major===ye.major&&ze.minor===ye.minor&&ze.patch===ye.patch)return!0}return!1}return!0}function we(ce,ye,ve){try{ye=new Ee(ye,ve)}catch{return!1}return ye.test(ce)}function Te(ce,ye,ve,ze){var qe,Je,Ge,Ze,Ye;switch(ce=new ie(ce,ze),ye=new Ee(ye,ze),ve){case">":qe=X,Je=F,Ge=he,Ze=">",Ye=">=";break;case"<":qe=he,Je=H,Ge=X,Ze="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(ce,ye,ze))return!1;for(var it=0;it<ye.set.length;++it){var lt=ye.set[it],rt=null,nt=null;if(lt.forEach(function(tt){tt.semver===ae&&(tt=new Y(">=0.0.0")),rt=rt||tt,nt=nt||tt,qe(tt.semver,rt.semver,ze)?rt=tt:Ge(tt.semver,nt.semver,ze)&&(nt=tt)}),rt.operator===Ze||rt.operator===Ye||(!nt.operator||nt.operator===Ze)&&Je(ce,nt.semver)||nt.operator===Ye&&Ge(ce,nt.semver))return!1}return!0}Y.prototype.parse=function(ce){var ye=this.loose?A[z]:A[Q],ve=ce.match(ye);if(!ve)throw new TypeError("Invalid comparator: "+ce);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new ie(ve[2],this.loose):this.semver=ae},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ce){return E("Comparator.test",ce,this.loose),this.semver===ae||(typeof ce=="string"&&(ce=new ie(ce,this.loose)),W(ce,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ce,ye){if(!(ce instanceof Y))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new Ee(ce.value,ye),we(this.value,ve,ye);if(ce.operator==="")return ve=new Ee(this.value,ye),we(ce.semver,ve,ye);var ze=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Je=this.semver.version===ce.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ze=W(this.semver,"<",ce.semver,ye)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Ye=W(this.semver,">",ce.semver,ye)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return ze||qe||Je&&Ge||Ze||Ye},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ce){var ye=this.loose;ce=ce.trim(),E("range",ce,ye);var ve=ye?A[ne]:A[V];ce=ce.replace(ve,be),E("hyphen replace",ce),ce=ce.replace(A[M],"$1$2$3"),E("comparator trim",ce,A[M]),ce=(ce=(ce=ce.replace(A[q],"$1~")).replace(A[de],"$1^")).split(/\s+/).join(" ");var ze=ye?A[z]:A[Q],qe=ce.split(" ").map(function(Je){return function(Ge,Ze){return E("comp",Ge),Ge=function(Ye,it){return Ye.trim().split(/\s+/).map(function(lt){return function(rt,nt){E("caret",rt,nt);var tt=nt?A[le]:A[ge];return rt.replace(tt,function(et,Xe,$e,Ne,Fe){var ke;return E("caret",rt,et,Xe,$e,Ne,Fe),Le(Xe)?ke="":Le($e)?ke=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":Le(Ne)?ke=Xe==="0"?">="+Xe+"."+$e+".0 <"+Xe+"."+(+$e+1)+".0":">="+Xe+"."+$e+".0 <"+(+Xe+1)+".0.0":Fe?(E("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),ke=Xe==="0"?$e==="0"?">="+Xe+"."+$e+"."+Ne+Fe+" <"+Xe+"."+$e+"."+(+Ne+1):">="+Xe+"."+$e+"."+Ne+Fe+" <"+Xe+"."+(+$e+1)+".0":">="+Xe+"."+$e+"."+Ne+Fe+" <"+(+Xe+1)+".0.0"):(E("no pr"),ke=Xe==="0"?$e==="0"?">="+Xe+"."+$e+"."+Ne+" <"+Xe+"."+$e+"."+(+Ne+1):">="+Xe+"."+$e+"."+Ne+" <"+Xe+"."+(+$e+1)+".0":">="+Xe+"."+$e+"."+Ne+" <"+(+Xe+1)+".0.0"),E("caret return",ke),ke})}(lt,it)}).join(" ")}(Ge,Ze),E("caret",Ge),Ge=function(Ye,it){return Ye.trim().split(/\s+/).map(function(lt){return function(rt,nt){var tt=nt?A[J]:A[K];return rt.replace(tt,function(et,Xe,$e,Ne,Fe){var ke;return E("tilde",rt,et,Xe,$e,Ne,Fe),Le(Xe)?ke="":Le($e)?ke=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":Le(Ne)?ke=">="+Xe+"."+$e+".0 <"+Xe+"."+(+$e+1)+".0":Fe?(E("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),ke=">="+Xe+"."+$e+"."+Ne+Fe+" <"+Xe+"."+(+$e+1)+".0"):ke=">="+Xe+"."+$e+"."+Ne+" <"+Xe+"."+(+$e+1)+".0",E("tilde return",ke),ke})}(lt,it)}).join(" ")}(Ge,Ze),E("tildes",Ge),Ge=function(Ye,it){return E("replaceXRanges",Ye,it),Ye.split(/\s+/).map(function(lt){return function(rt,nt){rt=rt.trim();var tt=nt?A[L]:A[R];return rt.replace(tt,function(et,Xe,$e,Ne,Fe,ke){E("xRange",rt,et,Xe,$e,Ne,Fe,ke);var Ce=Le($e),te=Ce||Le(Ne),ee=te||Le(Fe);return Xe==="="&&ee&&(Xe=""),Ce?et=Xe===">"||Xe==="<"?"<0.0.0":"*":Xe&&ee?(te&&(Ne=0),ee&&(Fe=0),Xe===">"?(Xe=">=",te?($e=+$e+1,Ne=0,Fe=0):ee&&(Ne=+Ne+1,Fe=0)):Xe==="<="&&(Xe="<",te?$e=+$e+1:Ne=+Ne+1),et=Xe+$e+"."+Ne+"."+Fe):te?et=">="+$e+".0.0 <"+(+$e+1)+".0.0":ee&&(et=">="+$e+"."+Ne+".0 <"+$e+"."+(+Ne+1)+".0"),E("xRange return",et),et})}(lt,it)}).join(" ")}(Ge,Ze),E("xrange",Ge),Ge=function(Ye,it){return E("replaceStars",Ye,it),Ye.trim().replace(A[re],"")}(Ge,Ze),E("stars",Ge),Ge}(Je,ye)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Je){return!!Je.match(ze)})),qe=qe.map(function(Je){return new Y(Je,ye)})},Ee.prototype.intersects=function(ce,ye){if(!(ce instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(ze){return ce.set.some(function(qe){return qe.every(function(Je){return ze.intersects(Je,ye)})})})})},e.toComparators=function(ce,ye){return new Ee(ce,ye).set.map(function(ve){return ve.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new ie(ce,this.loose));for(var ye=0;ye<this.set.length;ye++)if(pe(this.set[ye],ce))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(ce,ye,ve){var ze=null,qe=null;try{var Je=new Ee(ye,ve)}catch{return null}return ce.forEach(function(Ge){Je.test(Ge)&&(ze&&qe.compare(Ge)!==-1||(qe=new ie(ze=Ge,ve)))}),ze},e.minSatisfying=function(ce,ye,ve){var ze=null,qe=null;try{var Je=new Ee(ye,ve)}catch{return null}return ce.forEach(function(Ge){Je.test(Ge)&&(ze&&qe.compare(Ge)!==1||(qe=new ie(ze=Ge,ve)))}),ze},e.validRange=function(ce,ye){try{return new Ee(ce,ye).range||"*"}catch{return null}},e.ltr=function(ce,ye,ve){return Te(ce,ye,"<",ve)},e.gtr=function(ce,ye,ve){return Te(ce,ye,">",ve)},e.outside=Te,e.prerelease=function(ce,ye){var ve=oe(ce,ye);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ce,ye,ve){return ce=new Ee(ce,ve),ye=new Ee(ye,ve),ce.intersects(ye)},e.coerce=function(ce){if(ce instanceof ie)return ce;if(typeof ce!="string")return null;var ye=ce.match(A[O]);return ye==null?null:oe((ye[1]||"0")+"."+(ye[2]||"0")+"."+(ye[3]||"0"))}}).call(this,t(1))},function(ue,e){var t,s,E=ue.exports={};function k(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(d){if(t===setTimeout)return setTimeout(d,0);if((t===k||!t)&&setTimeout)return t=setTimeout,setTimeout(d,0);try{return t(d,0)}catch{try{return t.call(null,d,0)}catch{return t.call(this,d,0)}}}(function(){try{t=typeof setTimeout=="function"?setTimeout:k}catch{t=k}try{s=typeof clearTimeout=="function"?clearTimeout:C}catch{s=C}})();var y,o=[],D=!1,w=-1;function m(){D&&y&&(D=!1,y.length?o=y.concat(o):w=-1,o.length&&$())}function $(){if(!D){var d=A(m);D=!0;for(var f=o.length;f;){for(y=o,o=[];++w<f;)y&&y[w].run();w=-1,f=o.length}y=null,D=!1,function(v){if(s===clearTimeout)return clearTimeout(v);if((s===C||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(v);try{s(v)}catch{try{return s.call(null,v)}catch{return s.call(this,v)}}}(d)}}function a(d,f){this.fun=d,this.array=f}function u(){}E.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];o.push(new a(d,f)),o.length!==1||D||A($)},a.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=u,E.addListener=u,E.once=u,E.off=u,E.removeListener=u,E.removeAllListeners=u,E.emit=u,E.prependListener=u,E.prependOnceListener=u,E.listeners=function(d){return[]},E.binding=function(d){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(d){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Re[168],Ae([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class s{constructor(A,y,o){this.level=A,this.key=y,this.value=o,this.forward=[]}}const E=void 0;class k{constructor(A,y=2**16){this.comparator=A,this[t]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new s(this.c,E,E)}get size(){return this.f}clear(){this.e=new s(this.c,E,E),this.f=0}has(A){return!!k.g(this,A,this.comparator)}get(A){return k.g(this,A,this.comparator)?.value}set(A,y){return k.h(this,A,y,this.comparator)&&(this.f+=1),this}delete(A){const y=k.k(this,A,this.comparator);return y&&(this.f-=1),y}forEach(A,y){let o=this.e.forward[0];for(;o;)A.call(y,o.value,o.key,this),o=o.forward[0]}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",y=this.e.forward[0];for(;y;)A+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return A}static g(A,y,o){let D=A.e;for(let w=A.d-1;w>=0;w--)for(;D.forward[w]&&o(D.forward[w].key,y)<0;)D=D.forward[w];if(D=D.forward[0],D&&o(D.key,y)===0)return D}static h(A,y,o,D){const w=[];let m=A.e;for(let $=A.d-1;$>=0;$--){for(;m.forward[$]&&D(m.forward[$].key,y)<0;)m=m.forward[$];w[$]=m}if(m=m.forward[0],m&&D(m.key,y)===0)return m.value=o,!1;{const $=k.j(A);if($>A.d){for(let a=A.d;a<$;a++)w[a]=A.e;A.d=$}m=new s($,y,o);for(let a=0;a<$;a++)m.forward[a]=w[a].forward[a],w[a].forward[a]=m;return!0}}static j(A,y=.5){let o=1;for(;Math.random()<y&&o<A.c;)o+=1;return o}static k(A,y,o){const D=[];let w=A.e;for(let m=A.d-1;m>=0;m--){for(;w.forward[m]&&o(w.forward[m].key,y)<0;)w=w.forward[m];D[m]=w}if(w=w.forward[0],!w||o(w.key,y)!==0)return!1;for(let m=0;m<A.d&&D[m].forward[m]===w;m++)D[m].forward[m]=w.forward[m];for(;A.d>0&&A.e.forward[A.d-1]===E;)A.d-=1;return!0}}e.$Ts=k}),define(Re[47],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class s{static create(k){return new s(k)}constructor(k){this.c=t&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=s}),define(Re[6],Ae([1,0,9,78,2,79,47]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=$;const A=!1,y=!1,o=!1;var D;(function(J){J.None=()=>E.$Uc.None;function _(pe){if(o){const{onDidAddListener:we}=pe,Te=u.create();let ce=0;pe.onDidAddListener=()=>{++ce===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),we?.()}}}function de(pe,we){return oe(pe,()=>{},0,void 0,!0,void 0,we)}J.defer=de;function ge(pe){return(we,Te=null,ce)=>{let ye=!1,ve;return ve=pe(ze=>{if(!ye)return ve?ve.dispose():ye=!0,we.call(Te,ze)},null,ce),ye&&ve.dispose(),ve}}J.once=ge;function le(pe,we,Te){return re((ce,ye=null,ve)=>pe(ze=>ce.call(ye,we(ze)),null,ve),Te)}J.map=le;function z(pe,we,Te){return re((ce,ye=null,ve)=>pe(ze=>{we(ze),ce.call(ye,ze)},null,ve),Te)}J.forEach=z;function Q(pe,we,Te){return re((ce,ye=null,ve)=>pe(ze=>we(ze)&&ce.call(ye,ze),null,ve),Te)}J.filter=Q;function M(pe){return pe}J.signal=M;function V(...pe){return(we,Te=null,ce)=>{const ye=(0,E.$Rc)(...pe.map(ve=>ve(ze=>we.call(Te,ze))));return me(ye,ce)}}J.any=V;function ne(pe,we,Te,ce){let ye=Te;return le(pe,ve=>(ye=we(ye,ve),ye),ce)}J.reduce=ne;function re(pe,we){let Te;const ce={onWillAddFirstListener(){Te=pe(ye.fire,ye)},onDidRemoveLastListener(){Te?.dispose()}};we||_(ce);const ye=new n(ce);return we?.add(ye),ye.event}function me(pe,we){return we instanceof Array?we.push(pe):we&&we.add(pe),pe}function oe(pe,we,Te=100,ce=!1,ye=!1,ve,ze){let qe,Je,Ge,Ze=0,Ye;const it={leakWarningThreshold:ve,onWillAddFirstListener(){qe=pe(rt=>{Ze++,Je=we(Je,rt),ce&&!Ge&&(lt.fire(Je),Je=void 0),Ye=()=>{const nt=Je;Je=void 0,Ge=void 0,(!ce||Ze>1)&&lt.fire(nt),Ze=0},typeof Te=="number"?(clearTimeout(Ge),Ge=setTimeout(Ye,Te)):Ge===void 0&&(Ge=0,queueMicrotask(Ye))})},onWillRemoveListener(){ye&&Ze>0&&Ye?.()},onDidRemoveLastListener(){Ye=void 0,qe.dispose()}};ze||_(it);const lt=new n(it);return ze?.add(lt),lt.event}J.debounce=oe;function ie(pe,we=0,Te){return J.debounce(pe,(ce,ye)=>ce?(ce.push(ye),ce):[ye],we,void 0,!0,void 0,Te)}J.accumulate=ie;function x(pe,we=(ce,ye)=>ce===ye,Te){let ce=!0,ye;return Q(pe,ve=>{const ze=ce||!we(ve,ye);return ce=!1,ye=ve,ze},Te)}J.latch=x;function G(pe,we,Te){return[J.filter(pe,we,Te),J.filter(pe,ce=>!we(ce),Te)]}J.split=G;function T(pe,we=!1,Te=[],ce){let ye=Te.slice(),ve=pe(Je=>{ye?ye.push(Je):qe.fire(Je)});ce&&ce.add(ve);const ze=()=>{ye?.forEach(Je=>qe.fire(Je)),ye=null},qe=new n({onWillAddFirstListener(){ve||(ve=pe(Je=>qe.fire(Je)),ce&&ce.add(ve))},onDidAddFirstListener(){ye&&(we?setTimeout(ze):ze())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return ce&&ce.add(qe),qe.event}J.buffer=T;function X(pe,we){return(ce,ye,ve)=>{const ze=we(new B);return pe(function(qe){const Je=ze.evaluate(qe);Je!==he&&ce.call(ye,Je)},void 0,ve)}}J.chain=X;const he=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Te=>(we(Te),Te)),this}filter(we){return this.f.push(Te=>we(Te)?Te:he),this}reduce(we,Te){let ce=Te;return this.f.push(ye=>(ce=we(ce,ye),ce)),this}latch(we=(Te,ce)=>Te===ce){let Te=!0,ce;return this.f.push(ye=>{const ve=Te||!we(ye,ce);return Te=!1,ce=ye,ve?ye:he}),this}evaluate(we){for(const Te of this.f)if(we=Te(we),we===he)break;return we}}function U(pe,we,Te=ce=>ce){const ce=(...qe)=>ze.fire(Te(...qe)),ye=()=>pe.on(we,ce),ve=()=>pe.removeListener(we,ce),ze=new n({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return ze.event}J.fromNodeEventEmitter=U;function H(pe,we,Te=ce=>ce){const ce=(...qe)=>ze.fire(Te(...qe)),ye=()=>pe.addEventListener(we,ce),ve=()=>pe.removeEventListener(we,ce),ze=new n({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return ze.event}J.fromDOMEventEmitter=H;function F(pe){return new Promise(we=>ge(pe)(we))}J.toPromise=F;function W(pe){const we=new n;return pe.then(Te=>{we.fire(Te)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}J.fromPromise=W;function Y(pe,we){return pe(Te=>we.fire(Te))}J.forward=Y;function ae(pe,we,Te){return we(Te),pe(ce=>we(ce))}J.runAndSubscribe=ae;class Ee{constructor(we,Te){this._observable=we,this.f=0,this.g=!1;const ce={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Te||_(ce),this.emitter=new n(ce),Te&&Te.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Te){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Le(pe,we){return new Ee(pe,we).emitter.event}J.fromObservable=Le;function be(pe){return(we,Te,ce)=>{let ye=0,ve=!1;const ze={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(pe.reportChanges(),ve&&(ve=!1,we.call(Te)))},handlePossibleChange(){},handleChange(){ve=!0}};pe.addObserver(ze),pe.reportChanges();const qe={dispose(){pe.removeObserver(ze)}};return ce instanceof E.$Tc?ce.add(qe):Array.isArray(ce)&&ce.push(qe),qe}}J.fromObservableLight=be})(D||(e.Event=D={}));class w{static{this.all=new Set}static{this.f=0}constructor(_){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${_}_${w.f++}`,w.all.add(this)}start(_){this.g=new C.$fe,this.listenerCount=_}stop(){if(this.g){const _=this.g.elapsed();this.durations.push(_),this.elapsedOverall+=_,this.invocationCount+=1,this.g=void 0}}}e.$he=w;let m=-1;function $(J){const _=m;return m=J,{dispose(){m=_}}}class a{static{this.f=1}constructor(_,de,ge=(a.f++).toString(16).padStart(3,"0")){this.j=_,this.threshold=de,this.name=ge,this.h=0}dispose(){this.g?.clear()}check(_,de){const ge=this.threshold;if(ge<=0||de<ge)return;this.g||(this.g=new Map);const le=this.g.get(_.value)||0;if(this.g.set(_.value,le+1),this.h-=1,this.h<=0){this.h=ge*.5;const[z,Q]=this.getMostFrequentStack(),M=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${Q}):`;console.warn(M),console.warn(z);const V=new d(M,z);this.j(V)}return()=>{const z=this.g.get(_.value)||0;this.g.set(_.value,z-1)}}getMostFrequentStack(){if(!this.g)return;let _,de=0;for(const[ge,le]of this.g)(!_||de<le)&&(_=[ge,le],de=le);return _}}class u{static create(){const _=new Error;return new u(_.stack??"")}constructor(_){this.value=_}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(_,de){super(_),this.name="ListenerLeakError",this.stack=de}}e.$je=d;class f extends Error{constructor(_,de){super(_),this.name="ListenerRefusalError",this.stack=de}}e.$ke=f;let v=0;class g{constructor(_){this.value=_,this.id=v++}}const b=2,i=(J,_)=>{if(J instanceof g)_(J);else for(let de=0;de<J.length;de++){const ge=J[de];ge&&_(ge)}};let p;if(A){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),p=new FinalizationRegistry(_=>{typeof _=="string"&&J.push(_)})}class n{constructor(_){this.z=0,this.f=_,this.g=m>0||this.f?.leakWarningThreshold?new a(_?.onListenerError??t.$Y,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const _=this.u;queueMicrotask(()=>{i(_,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(_,de,ge)=>{if(this.g&&this.z>this.g.threshold**2){const V=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(V);const ne=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${V}. HINT: Stack shows most frequent listener (${ne[1]}-times)`,ne[0]);return(this.f?.onListenerError||t.$Y)(re),E.$Uc.None}if(this.m)return E.$Uc.None;de&&(_=_.bind(de));const le=new g(_);let z,Q;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=u.create(),z=this.g.check(le.stack,this.z+1)),y&&(le.stack=Q??u.create()),this.u?this.u instanceof g?(this.w??=new r,this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const M=(0,E.$Sc)(()=>{p?.unregister(M),z?.(),this.A(le)});if(ge instanceof E.$Tc?ge.add(M):Array.isArray(ge)&&ge.push(M),p){const V=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ne=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(V);p.register(M,ne?.[2]??V,M)}return M},this.q}A(_){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,ge=de.indexOf(_);if(ge===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[ge]=void 0;const le=this.w.current===this;if(this.z*b<=de.length){let z=0;for(let Q=0;Q<de.length;Q++)de[Q]?de[z++]=de[Q]:le&&(this.w.end--,z<this.w.i&&this.w.i--);de.length=z}}B(_,de){if(!_)return;const ge=this.f?.onListenerError||t.$Y;if(!ge){_.value(de);return}try{_.value(de)}catch(le){ge(le)}}C(_){const de=_.current.u;for(;_.i<_.end;)this.B(de[_.i++],_.value);_.reset()}fire(_){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof g)this.B(this.u,_);else{const de=this.w;de.enqueue(this,_,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=n;const l=()=>new r;e.$me=l;class r{constructor(){this.i=-1,this.end=0}enqueue(_,de,ge){this.i=0,this.end=ge,this.current=_,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends n{async fireAsync(_,de,ge){if(this.u)for(this.h||(this.h=new k.$5c),i(this.u,le=>this.h.push([le.value,_]));this.h.size>0&&!de.isCancellationRequested;){const[le,z]=this.h.shift(),Q=[],M={...z,token:de,waitUntil:V=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");ge&&(V=ge(V,le)),Q.push(V)}};try{le(M)}catch(V){(0,t.$Y)(V);continue}Object.freeze(Q),await Promise.allSettled(Q).then(V=>{for(const ne of V)ne.status==="rejected"&&(0,t.$Y)(ne.reason)})}}}e.$ne=h;class c extends n{get isPaused(){return this.h!==0}constructor(_){super(_),this.h=0,this.s=new k.$5c,this.t=_?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const _=Array.from(this.s);this.s.clear(),super.fire(this.t(_))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(_){this.z&&(this.h!==0?this.s.push(_):super.fire(_))}}e.$oe=c;class S extends c{constructor(_){super(_),this.k=_.delay??100}fire(_){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(_)}}e.$pe=S;class I extends n{constructor(_){super(_),this.h=[],this.k=_?.merge}fire(_){this.hasListeners()&&(this.h.push(_),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$qe=I;class R{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(_){const de={event:_,listener:null};this.h.push(de),this.g&&this.m(de);const ge=()=>{this.g&&this.o(de);const le=this.h.indexOf(de);this.h.splice(le,1)};return(0,E.$Sc)((0,s.$cb)(ge))}j(){this.g=!0,this.h.forEach(_=>this.m(_))}k(){this.g=!1,this.h.forEach(_=>this.o(_))}m(_){_.listener=_.event(de=>this.f.fire(de))}o(_){_.listener?.dispose(),_.listener=null}dispose(){this.f.dispose();for(const _ of this.h)_.listener?.dispose();this.h=[]}}e.$re=R;class L{constructor(_,de,ge,le){this.f=new E.$Tc;const z=this.f.add(new R),Q=this.f.add(new E.$4c);function M(V){Q.set(V,z.add(le(V)))}for(const V of _)M(V);this.f.add(de(V=>{M(V)})),this.f.add(ge(V=>{Q.deleteAndDispose(V)})),this.event=z.event}dispose(){this.f.dispose()}}e.$se=L;class O{constructor(){this.f=[]}wrapEvent(_,de,ge){return(le,z,Q)=>_(M=>{const V=this.f[this.f.length-1];if(!de){V?V.buffers.push(()=>le.call(z,M)):le.call(z,M);return}const ne=V;if(!ne){le.call(z,de(ge,M));return}ne.items??=[],ne.items.push(M),ne.buffers.length===0&&V.buffers.push(()=>{ne.reducedResult??=ge?ne.items.reduce(de,ge):ne.items.reduce(de),le.call(z,ne.reducedResult)})},void 0,Q)}bufferEvents(_){const de={buffers:new Array};this.f.push(de);const ge=_();return this.f.pop(),de.buffers.forEach(le=>le()),ge}}e.$te=O;class P{constructor(){this.f=!1,this.g=D.None,this.h=E.$Uc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(_){this.g=_,this.f&&(this.h.dispose(),this.h=_(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=P;class q{static const(_){return new K(_)}constructor(_){this.g=_,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(_){_!==this.g&&(this.g=_,this.f.fire(void 0))}}e.$ve=q;class K{constructor(_){this.value=_,this.onDidChange=D.None}}}),define(Re[18],Ae([1,0,6]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=A;const s=Object.freeze(function(y,o){const D=setTimeout(y.bind(o),0);return{dispose(){clearTimeout(D)}}});var E;(function(y){function o(D){return D===y.None||D===y.Cancelled||D instanceof k?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}y.isCancellationToken=o,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:s})})(E||(e.CancellationToken=E={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?s:(this.b||(this.b=new t.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=E.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=E.None}}e.$we=C;function A(y){const o=new C;return y.add({dispose(){o.cancel()}}),o.token}}),define(Re[169],Ae([1,0,18]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=E;class s{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new t.$we,o=this.b(y.token);return this.a={promise:o,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$9e=s;function E(A){return A}class k{constructor(y,o){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);return this.b!==o&&(this.b=o,this.a=this.c(y)),this.a}}e.$$e=k;class C{get cachedValues(){return this.a}constructor(y,o){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);if(this.b.has(o))return this.b.get(o);const D=this.c(y);return this.a.set(y,D),this.b.set(o,D),D}}e.$_e=C}),define(Re[170],Ae([1,0,6,2]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=e.$et=e.$dt=e.ScrollbarVisibility=void 0;var E;(function($){$[$.Auto=1]="Auto",$[$.Hidden=2]="Hidden",$[$.Visible=3]="Visible"})(E||(e.ScrollbarVisibility=E={}));class k{constructor(a,u,d,f,v,g,b){this.c=a,this._scrollStateBrand=void 0,this.c&&(u=u|0,d=d|0,f=f|0,v=v|0,g=g|0,b=b|0),this.rawScrollLeft=f,this.rawScrollTop=b,u<0&&(u=0),f+u>d&&(f=d-u),f<0&&(f=0),v<0&&(v=0),b+v>g&&(b=g-v),b<0&&(b=0),this.width=u,this.scrollWidth=d,this.scrollLeft=f,this.height=v,this.scrollHeight=g,this.scrollTop=b}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,u){return new k(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,u?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,u?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new k(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,u){const d=this.width!==a.width,f=this.scrollWidth!==a.scrollWidth,v=this.scrollLeft!==a.scrollLeft,g=this.height!==a.height,b=this.scrollHeight!==a.scrollHeight,i=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:u,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:f,scrollLeftChanged:v,heightChanged:g,scrollHeightChanged:b,scrollTopChanged:i}}}e.$dt=k;class C extends s.$Uc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new t.$le),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new k(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,u){const d=this.g.withScrollDimensions(a,u);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const u=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(u,!1)}setScrollPositionSmooth(a,u){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const d=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let f;u?f=new D(this.h.from,d,this.h.startTime,this.h.duration):f=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=f}else{const d=this.g.withScrollPosition(a);this.h=D.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),u=this.g.withScrollPosition(a);if(this.n(u,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,u){const d=this.g;d.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(d,u)))}}e.$et=C;class A{constructor(a,u,d){this.scrollLeft=a,this.scrollTop=u,this.isDone=d}}e.$ft=A;function y($,a){const u=a-$;return function(d){return $+u*m(d)}}function o($,a,u){return function(d){return d<u?$(d/u):a((d-u)/(1-u))}}class D{constructor(a,u,d,f){this.from=a,this.to=u,this.duration=f,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,u,d){if(Math.abs(a-u)>2.5*d){let v,g;return a<u?(v=a+.75*d,g=u-.75*d):(v=a-.75*d,g=u+.75*d),o(y(a,v),y(g,u),.33)}return y(a,u)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const u=(a-this.startTime)/this.duration;if(u<1){const d=this.c(u),f=this.d(u);return new A(d,f,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,u,d){return D.start(a,u,d)}static start(a,u,d){d=d+10;const f=Date.now()-10;return new D(a,u,f,d)}}e.$gt=D;function w($){return Math.pow($,3)}function m($){return 1-w(1-$)}}),define(Re[55],Ae([1,0,9,2]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=E,e.$ze=k,e.$Ae=C,e.$Be=A,e.$Ce=o,e.$De=D,e.$Ee=w,e.$Fe=m,e.$Ge=$,e.$He=a,e.$Ie=u,e.$Je=d,e.$Ke=f,e.$Le=v,e.$Me=g;function E(b){const i=b;return i?typeof i.read=="function":!1}function k(b){const i=b;return i?[i.on,i.pause,i.resume,i.destroy].every(p=>typeof p=="function"):!1}function C(b){const i=b;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function A(b,i){return new y(b,i)}class y{constructor(i,p){this.e=i,this.f=p,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(p=>this.d.push(p))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(p=>p(i))}h(i){this.c.error.length===0?(0,t.$Y)(i):this.c.error.slice(0).forEach(p=>p(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,p){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(p),this.resume();break;case"end":this.c.end.push(p),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(p),this.a.flowing&&this.k();break}}removeListener(i,p){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const l=n.indexOf(p);l>=0&&n.splice(l,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const p=[...this.d];this.d.length=0,p.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(b,i){const p=[];let n;for(;(n=b.read())!==null;)p.push(n);return i(p)}function D(b,i,p){const n=[];let l;for(;(l=b.read())!==null&&n.length<p;)n.push(l);return l===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof l<"u"){const r=l;return l=void 0,r}return b.read()}}}function w(b,i){return new Promise((p,n)=>{const l=[];m(b,{onData:r=>{i&&l.push(r)},onError:r=>{i?n(r):p(void 0)},onEnd:()=>{p(i?i(l):void 0)}})})}function m(b,i,p){b.on("error",n=>{p?.isCancellationRequested||i.onError(n)}),b.on("end",()=>{p?.isCancellationRequested||i.onEnd()}),b.on("data",n=>{p?.isCancellationRequested||i.onData(n)})}function $(b,i){return new Promise((p,n)=>{const l=new s.$Tc,r=[],h=I=>{if(r.push(I),r.length>i)return l.dispose(),b.pause(),p({stream:b,buffer:r,ended:!1})},c=I=>(l.dispose(),n(I)),S=()=>(l.dispose(),p({stream:b,buffer:r,ended:!0}));l.add((0,s.$Sc)(()=>b.removeListener("error",c))),b.on("error",c),l.add((0,s.$Sc)(()=>b.removeListener("end",S))),b.on("end",S),l.add((0,s.$Sc)(()=>b.removeListener("data",h))),b.on("data",h)})}function a(b,i){const p=A(i);return p.end(b),p}function u(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}function d(b){let i=!1;return{read:()=>i?null:(i=!0,b)}}function f(b,i,p){const n=A(p);return m(b,{onData:l=>n.write(i.data(l)),onError:l=>n.error(i.error?i.error(l):l),onEnd:()=>n.end()}),n}function v(b,i,p){let n=!1;return{read:()=>{const l=i.read();return n?l:(n=!0,l!==null?p([b,l]):b)}}}function g(b,i,p){let n=!1;const l=A(p);return m(i,{onData:r=>n?l.write(r):(n=!0,l.write(p([b,r]))),onError:r=>l.error(r),onEnd:()=>{n||(n=!0,l.write(b)),l.end()}}),l}}),define(Re[14],Ae([1,0,64,55]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=o,e.$Pe=D,e.$Qe=w,e.$Re=m,e.$Se=$,e.$Te=a,e.$Ue=u,e.$Ve=d,e.$We=f,e.$Xe=v,e.$Ye=g,e.$Ze=b,e.$1e=i,e.$2e=p,e.$3e=n,e.$4e=l,e.$5e=r,e.$6e=h,e.$7e=c,e.$8e=R,s=Ue(s);const E=typeof Buffer<"u",k=new t.$T(()=>new Uint8Array(256));let C,A;class y{static alloc(O){return E?new y(Buffer.allocUnsafe(O)):new y(new Uint8Array(O))}static wrap(O){return E&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new y(O)}static fromString(O,P){return!(P?.dontUseNodeBuffer||!1)&&E?new y(Buffer.from(O)):(C||(C=new TextEncoder),new y(C.encode(O)))}static fromByteArray(O){const P=y.alloc(O.length);for(let q=0,K=O.length;q<K;q++)P.buffer[q]=O[q];return P}static concat(O,P){if(typeof P>"u"){P=0;for(let J=0,_=O.length;J<_;J++)P+=O[J].byteLength}const q=y.alloc(P);let K=0;for(let J=0,_=O.length;J<_;J++){const de=O[J];q.set(de,K),K+=de.byteLength}return q}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=y.alloc(this.byteLength);return O.set(this),O}toString(){return E?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(O,P){return new y(this.buffer.subarray(O,P))}set(O,P){if(O instanceof y)this.buffer.set(O.buffer,P);else if(O instanceof Uint8Array)this.buffer.set(O,P);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),P);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return m(this.buffer,O)}writeUInt32BE(O,P){$(this.buffer,O,P)}readUInt32LE(O){return a(this.buffer,O)}writeUInt32LE(O,P){u(this.buffer,O,P)}readUInt8(O){return d(this.buffer,O)}writeUInt8(O,P){f(this.buffer,O,P)}indexOf(O,P=0){return o(this.buffer,O instanceof y?O.buffer:O,P)}}e.$Ne=y;function o(L,O,P=0){const q=O.byteLength,K=L.byteLength;if(q===0)return 0;if(q===1)return L.indexOf(O[0]);if(q>K-P)return-1;const J=k.value;J.fill(O.length);for(let le=0;le<O.length;le++)J[O[le]]=O.length-le-1;let _=P+O.length-1,de=_,ge=-1;for(;_<K;)if(L[_]===O[de]){if(de===0){ge=_;break}_--,de--}else _+=Math.max(O.length-de,J[L[_]]),de=O.length-1;return ge}function D(L,O){return L[O+0]<<0>>>0|L[O+1]<<8>>>0}function w(L,O,P){L[P+0]=O&255,O=O>>>8,L[P+1]=O&255}function m(L,O){return L[O]*2**24+L[O+1]*2**16+L[O+2]*2**8+L[O+3]}function $(L,O,P){L[P+3]=O,O=O>>>8,L[P+2]=O,O=O>>>8,L[P+1]=O,O=O>>>8,L[P]=O}function a(L,O){return L[O+0]<<0>>>0|L[O+1]<<8>>>0|L[O+2]<<16>>>0|L[O+3]<<24>>>0}function u(L,O,P){L[P+0]=O&255,O=O>>>8,L[P+1]=O&255,O=O>>>8,L[P+2]=O&255,O=O>>>8,L[P+3]=O&255}function d(L,O){return L[O]}function f(L,O,P){L[P]=O}function v(L){return s.$Ce(L,O=>y.concat(O))}function g(L){return s.$Je(L)}function b(L){return s.$Ee(L,O=>y.concat(O))}async function i(L){return L.ended?y.concat(L.buffer):y.concat([...L.buffer,await b(L.stream)])}function p(L){return s.$He(L,O=>y.concat(O))}function n(L){return s.$Ke(L,{data:O=>typeof O=="string"?y.fromString(O):y.wrap(O)},O=>y.concat(O))}function l(L){return s.$Be(O=>y.concat(O),L)}function r(L,O){return s.$Le(L,O,P=>y.concat(P))}function h(L,O){return s.$Me(L,O,P=>y.concat(P))}function c(L){let O=0,P=0,q=0;const K=new Uint8Array(Math.floor(L.length/4*3)),J=de=>{switch(P){case 3:K[q++]=O|de,P=0;break;case 2:K[q++]=O|de>>>2,O=de<<6,P=3;break;case 1:K[q++]=O|de>>>4,O=de<<4,P=2;break;default:O=de<<2,P=1}};for(let de=0;de<L.length;de++){const ge=L.charCodeAt(de);if(ge>=65&&ge<=90)J(ge-65);else if(ge>=97&&ge<=122)J(ge-97+26);else if(ge>=48&&ge<=57)J(ge-48+52);else if(ge===43||ge===45)J(62);else if(ge===47||ge===95)J(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${L[de]}`)}}const _=q;for(;P>0;)J(0);return y.wrap(K).slice(0,_)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},O=!0,P=!1){const q=P?I:S;let K="";const J=L.byteLength%3;let _=0;for(;_<L.byteLength-J;_+=3){const de=L[_+0],ge=L[_+1],le=L[_+2];K+=q[de>>>2],K+=q[(de<<4|ge>>>4)&63],K+=q[(ge<<2|le>>>6)&63],K+=q[le&63]}if(J===1){const de=L[_+0];K+=q[de>>>2],K+=q[de<<4&63],O&&(K+="==")}else if(J===2){const de=L[_+0],ge=L[_+1];K+=q[de>>>2],K+=q[(de<<4|ge>>>4)&63],K+=q[ge<<2&63],O&&(K+="=")}return K}}),define(Re[171],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Re[10],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=t,e.$fg=s,e.$gg=E,e.$hg=k,e.$ig=C,e.$jg=A,e.$kg=y,e.$lg=o,e.$mg=D,e.$ng=w,e.$og=m,e.$pg=$,e.$qg=a,e.$rg=d,e.$sg=f,e.$tg=v,e.$ug=g,e.$vg=b,e.$wg=i;function t(p){return typeof p=="string"}function s(p){return Array.isArray(p)&&p.every(n=>t(n))}function E(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}function k(p){const n=Object.getPrototypeOf(Uint8Array);return typeof p=="object"&&p instanceof n}function C(p){return typeof p=="number"&&!isNaN(p)}function A(p){return!!p&&typeof p[Symbol.iterator]=="function"}function y(p){return p===!0||p===!1}function o(p){return typeof p>"u"}function D(p){return!w(p)}function w(p){return o(p)||p===null}function m(p,n){if(!p)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function $(p){if(w(p))throw new Error("Assertion Failed: argument is undefined or null");return p}function a(...p){const n=[];for(let l=0;l<p.length;l++){const r=p[l];if(w(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);n.push(r)}return n}const u=Object.prototype.hasOwnProperty;function d(p){if(!E(p))return!1;for(const n in p)if(u.call(p,n))return!1;return!0}function f(p){return typeof p=="function"}function v(...p){return p.length>0&&p.every(f)}function g(p,n){const l=Math.min(p.length,n.length);for(let r=0;r<l;r++)b(p[r],n[r])}function b(p,n){if(t(n)){if(typeof p!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(f(n)){try{if(p instanceof n)return}catch{}if(!w(p)&&p.constructor===n||n.length===1&&n.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function i(p){return p}}),define(Re[107],Ae([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=E,e.$1j=k;const s=Object.create(null);function E(C,A){if((0,t.$eg)(A)){const y=s[A];if(y===void 0)throw new Error(`${C} references an unknown codicon: ${A}`);A=y}return s[C]=A,{id:C}}function k(){return s}}),define(Re[172],Ae([1,0,107]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,t.$Zj)("add",6e4),plus:(0,t.$Zj)("plus",6e4),gistNew:(0,t.$Zj)("gist-new",6e4),repoCreate:(0,t.$Zj)("repo-create",6e4),lightbulb:(0,t.$Zj)("lightbulb",60001),lightBulb:(0,t.$Zj)("light-bulb",60001),repo:(0,t.$Zj)("repo",60002),repoDelete:(0,t.$Zj)("repo-delete",60002),gistFork:(0,t.$Zj)("gist-fork",60003),repoForked:(0,t.$Zj)("repo-forked",60003),gitPullRequest:(0,t.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,t.$Zj)("record-keys",60005),keyboard:(0,t.$Zj)("keyboard",60005),tag:(0,t.$Zj)("tag",60006),gitPullRequestLabel:(0,t.$Zj)("git-pull-request-label",60006),tagAdd:(0,t.$Zj)("tag-add",60006),tagRemove:(0,t.$Zj)("tag-remove",60006),person:(0,t.$Zj)("person",60007),personFollow:(0,t.$Zj)("person-follow",60007),personOutline:(0,t.$Zj)("person-outline",60007),personFilled:(0,t.$Zj)("person-filled",60007),gitBranch:(0,t.$Zj)("git-branch",60008),gitBranchCreate:(0,t.$Zj)("git-branch-create",60008),gitBranchDelete:(0,t.$Zj)("git-branch-delete",60008),sourceControl:(0,t.$Zj)("source-control",60008),mirror:(0,t.$Zj)("mirror",60009),mirrorPublic:(0,t.$Zj)("mirror-public",60009),star:(0,t.$Zj)("star",60010),starAdd:(0,t.$Zj)("star-add",60010),starDelete:(0,t.$Zj)("star-delete",60010),starEmpty:(0,t.$Zj)("star-empty",60010),comment:(0,t.$Zj)("comment",60011),commentAdd:(0,t.$Zj)("comment-add",60011),alert:(0,t.$Zj)("alert",60012),warning:(0,t.$Zj)("warning",60012),search:(0,t.$Zj)("search",60013),searchSave:(0,t.$Zj)("search-save",60013),logOut:(0,t.$Zj)("log-out",60014),signOut:(0,t.$Zj)("sign-out",60014),logIn:(0,t.$Zj)("log-in",60015),signIn:(0,t.$Zj)("sign-in",60015),eye:(0,t.$Zj)("eye",60016),eyeUnwatch:(0,t.$Zj)("eye-unwatch",60016),eyeWatch:(0,t.$Zj)("eye-watch",60016),circleFilled:(0,t.$Zj)("circle-filled",60017),primitiveDot:(0,t.$Zj)("primitive-dot",60017),closeDirty:(0,t.$Zj)("close-dirty",60017),debugBreakpoint:(0,t.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,t.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,t.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,t.$Zj)("primitive-square",60018),edit:(0,t.$Zj)("edit",60019),pencil:(0,t.$Zj)("pencil",60019),info:(0,t.$Zj)("info",60020),issueOpened:(0,t.$Zj)("issue-opened",60020),gistPrivate:(0,t.$Zj)("gist-private",60021),gitForkPrivate:(0,t.$Zj)("git-fork-private",60021),lock:(0,t.$Zj)("lock",60021),mirrorPrivate:(0,t.$Zj)("mirror-private",60021),close:(0,t.$Zj)("close",60022),removeClose:(0,t.$Zj)("remove-close",60022),x:(0,t.$Zj)("x",60022),repoSync:(0,t.$Zj)("repo-sync",60023),sync:(0,t.$Zj)("sync",60023),clone:(0,t.$Zj)("clone",60024),desktopDownload:(0,t.$Zj)("desktop-download",60024),beaker:(0,t.$Zj)("beaker",60025),microscope:(0,t.$Zj)("microscope",60025),vm:(0,t.$Zj)("vm",60026),deviceDesktop:(0,t.$Zj)("device-desktop",60026),file:(0,t.$Zj)("file",60027),fileText:(0,t.$Zj)("file-text",60027),more:(0,t.$Zj)("more",60028),ellipsis:(0,t.$Zj)("ellipsis",60028),kebabHorizontal:(0,t.$Zj)("kebab-horizontal",60028),mailReply:(0,t.$Zj)("mail-reply",60029),reply:(0,t.$Zj)("reply",60029),organization:(0,t.$Zj)("organization",60030),organizationFilled:(0,t.$Zj)("organization-filled",60030),organizationOutline:(0,t.$Zj)("organization-outline",60030),newFile:(0,t.$Zj)("new-file",60031),fileAdd:(0,t.$Zj)("file-add",60031),newFolder:(0,t.$Zj)("new-folder",60032),fileDirectoryCreate:(0,t.$Zj)("file-directory-create",60032),trash:(0,t.$Zj)("trash",60033),trashcan:(0,t.$Zj)("trashcan",60033),history:(0,t.$Zj)("history",60034),clock:(0,t.$Zj)("clock",60034),folder:(0,t.$Zj)("folder",60035),fileDirectory:(0,t.$Zj)("file-directory",60035),symbolFolder:(0,t.$Zj)("symbol-folder",60035),logoGithub:(0,t.$Zj)("logo-github",60036),markGithub:(0,t.$Zj)("mark-github",60036),github:(0,t.$Zj)("github",60036),terminal:(0,t.$Zj)("terminal",60037),console:(0,t.$Zj)("console",60037),repl:(0,t.$Zj)("repl",60037),zap:(0,t.$Zj)("zap",60038),symbolEvent:(0,t.$Zj)("symbol-event",60038),error:(0,t.$Zj)("error",60039),stop:(0,t.$Zj)("stop",60039),variable:(0,t.$Zj)("variable",60040),symbolVariable:(0,t.$Zj)("symbol-variable",60040),array:(0,t.$Zj)("array",60042),symbolArray:(0,t.$Zj)("symbol-array",60042),symbolModule:(0,t.$Zj)("symbol-module",60043),symbolPackage:(0,t.$Zj)("symbol-package",60043),symbolNamespace:(0,t.$Zj)("symbol-namespace",60043),symbolObject:(0,t.$Zj)("symbol-object",60043),symbolMethod:(0,t.$Zj)("symbol-method",60044),symbolFunction:(0,t.$Zj)("symbol-function",60044),symbolConstructor:(0,t.$Zj)("symbol-constructor",60044),symbolBoolean:(0,t.$Zj)("symbol-boolean",60047),symbolNull:(0,t.$Zj)("symbol-null",60047),symbolNumeric:(0,t.$Zj)("symbol-numeric",60048),symbolNumber:(0,t.$Zj)("symbol-number",60048),symbolStructure:(0,t.$Zj)("symbol-structure",60049),symbolStruct:(0,t.$Zj)("symbol-struct",60049),symbolParameter:(0,t.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,t.$Zj)("symbol-type-parameter",60050),symbolKey:(0,t.$Zj)("symbol-key",60051),symbolText:(0,t.$Zj)("symbol-text",60051),symbolReference:(0,t.$Zj)("symbol-reference",60052),goToFile:(0,t.$Zj)("go-to-file",60052),symbolEnum:(0,t.$Zj)("symbol-enum",60053),symbolValue:(0,t.$Zj)("symbol-value",60053),symbolRuler:(0,t.$Zj)("symbol-ruler",60054),symbolUnit:(0,t.$Zj)("symbol-unit",60054),activateBreakpoints:(0,t.$Zj)("activate-breakpoints",60055),archive:(0,t.$Zj)("archive",60056),arrowBoth:(0,t.$Zj)("arrow-both",60057),arrowDown:(0,t.$Zj)("arrow-down",60058),arrowLeft:(0,t.$Zj)("arrow-left",60059),arrowRight:(0,t.$Zj)("arrow-right",60060),arrowSmallDown:(0,t.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,t.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,t.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,t.$Zj)("arrow-small-up",60064),arrowUp:(0,t.$Zj)("arrow-up",60065),bell:(0,t.$Zj)("bell",60066),bold:(0,t.$Zj)("bold",60067),book:(0,t.$Zj)("book",60068),bookmark:(0,t.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$Zj)("briefcase",60076),broadcast:(0,t.$Zj)("broadcast",60077),browser:(0,t.$Zj)("browser",60078),bug:(0,t.$Zj)("bug",60079),calendar:(0,t.$Zj)("calendar",60080),caseSensitive:(0,t.$Zj)("case-sensitive",60081),check:(0,t.$Zj)("check",60082),checklist:(0,t.$Zj)("checklist",60083),chevronDown:(0,t.$Zj)("chevron-down",60084),chevronLeft:(0,t.$Zj)("chevron-left",60085),chevronRight:(0,t.$Zj)("chevron-right",60086),chevronUp:(0,t.$Zj)("chevron-up",60087),chromeClose:(0,t.$Zj)("chrome-close",60088),chromeMaximize:(0,t.$Zj)("chrome-maximize",60089),chromeMinimize:(0,t.$Zj)("chrome-minimize",60090),chromeRestore:(0,t.$Zj)("chrome-restore",60091),circleOutline:(0,t.$Zj)("circle-outline",60092),circle:(0,t.$Zj)("circle",60092),debugBreakpointUnverified:(0,t.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$Zj)("circle-slash",60093),circuitBoard:(0,t.$Zj)("circuit-board",60094),clearAll:(0,t.$Zj)("clear-all",60095),clippy:(0,t.$Zj)("clippy",60096),closeAll:(0,t.$Zj)("close-all",60097),cloudDownload:(0,t.$Zj)("cloud-download",60098),cloudUpload:(0,t.$Zj)("cloud-upload",60099),code:(0,t.$Zj)("code",60100),collapseAll:(0,t.$Zj)("collapse-all",60101),colorMode:(0,t.$Zj)("color-mode",60102),commentDiscussion:(0,t.$Zj)("comment-discussion",60103),creditCard:(0,t.$Zj)("credit-card",60105),dash:(0,t.$Zj)("dash",60108),dashboard:(0,t.$Zj)("dashboard",60109),database:(0,t.$Zj)("database",60110),debugContinue:(0,t.$Zj)("debug-continue",60111),debugDisconnect:(0,t.$Zj)("debug-disconnect",60112),debugPause:(0,t.$Zj)("debug-pause",60113),debugRestart:(0,t.$Zj)("debug-restart",60114),debugStart:(0,t.$Zj)("debug-start",60115),debugStepInto:(0,t.$Zj)("debug-step-into",60116),debugStepOut:(0,t.$Zj)("debug-step-out",60117),debugStepOver:(0,t.$Zj)("debug-step-over",60118),debugStop:(0,t.$Zj)("debug-stop",60119),debug:(0,t.$Zj)("debug",60120),deviceCameraVideo:(0,t.$Zj)("device-camera-video",60121),deviceCamera:(0,t.$Zj)("device-camera",60122),deviceMobile:(0,t.$Zj)("device-mobile",60123),diffAdded:(0,t.$Zj)("diff-added",60124),diffIgnored:(0,t.$Zj)("diff-ignored",60125),diffModified:(0,t.$Zj)("diff-modified",60126),diffRemoved:(0,t.$Zj)("diff-removed",60127),diffRenamed:(0,t.$Zj)("diff-renamed",60128),diff:(0,t.$Zj)("diff",60129),diffSidebyside:(0,t.$Zj)("diff-sidebyside",60129),discard:(0,t.$Zj)("discard",60130),editorLayout:(0,t.$Zj)("editor-layout",60131),emptyWindow:(0,t.$Zj)("empty-window",60132),exclude:(0,t.$Zj)("exclude",60133),extensions:(0,t.$Zj)("extensions",60134),eyeClosed:(0,t.$Zj)("eye-closed",60135),fileBinary:(0,t.$Zj)("file-binary",60136),fileCode:(0,t.$Zj)("file-code",60137),fileMedia:(0,t.$Zj)("file-media",60138),filePdf:(0,t.$Zj)("file-pdf",60139),fileSubmodule:(0,t.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,t.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$Zj)("file-symlink-file",60142),fileZip:(0,t.$Zj)("file-zip",60143),files:(0,t.$Zj)("files",60144),filter:(0,t.$Zj)("filter",60145),flame:(0,t.$Zj)("flame",60146),foldDown:(0,t.$Zj)("fold-down",60147),foldUp:(0,t.$Zj)("fold-up",60148),fold:(0,t.$Zj)("fold",60149),folderActive:(0,t.$Zj)("folder-active",60150),folderOpened:(0,t.$Zj)("folder-opened",60151),gear:(0,t.$Zj)("gear",60152),gift:(0,t.$Zj)("gift",60153),gistSecret:(0,t.$Zj)("gist-secret",60154),gist:(0,t.$Zj)("gist",60155),gitCommit:(0,t.$Zj)("git-commit",60156),gitCompare:(0,t.$Zj)("git-compare",60157),compareChanges:(0,t.$Zj)("compare-changes",60157),gitMerge:(0,t.$Zj)("git-merge",60158),githubAction:(0,t.$Zj)("github-action",60159),githubAlt:(0,t.$Zj)("github-alt",60160),globe:(0,t.$Zj)("globe",60161),grabber:(0,t.$Zj)("grabber",60162),graph:(0,t.$Zj)("graph",60163),gripper:(0,t.$Zj)("gripper",60164),heart:(0,t.$Zj)("heart",60165),home:(0,t.$Zj)("home",60166),horizontalRule:(0,t.$Zj)("horizontal-rule",60167),hubot:(0,t.$Zj)("hubot",60168),inbox:(0,t.$Zj)("inbox",60169),issueReopened:(0,t.$Zj)("issue-reopened",60171),issues:(0,t.$Zj)("issues",60172),italic:(0,t.$Zj)("italic",60173),jersey:(0,t.$Zj)("jersey",60174),json:(0,t.$Zj)("json",60175),kebabVertical:(0,t.$Zj)("kebab-vertical",60176),key:(0,t.$Zj)("key",60177),law:(0,t.$Zj)("law",60178),lightbulbAutofix:(0,t.$Zj)("lightbulb-autofix",60179),linkExternal:(0,t.$Zj)("link-external",60180),link:(0,t.$Zj)("link",60181),listOrdered:(0,t.$Zj)("list-ordered",60182),listUnordered:(0,t.$Zj)("list-unordered",60183),liveShare:(0,t.$Zj)("live-share",60184),loading:(0,t.$Zj)("loading",60185),location:(0,t.$Zj)("location",60186),mailRead:(0,t.$Zj)("mail-read",60187),mail:(0,t.$Zj)("mail",60188),markdown:(0,t.$Zj)("markdown",60189),megaphone:(0,t.$Zj)("megaphone",60190),mention:(0,t.$Zj)("mention",60191),milestone:(0,t.$Zj)("milestone",60192),gitPullRequestMilestone:(0,t.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,t.$Zj)("mortar-board",60193),move:(0,t.$Zj)("move",60194),multipleWindows:(0,t.$Zj)("multiple-windows",60195),mute:(0,t.$Zj)("mute",60196),noNewline:(0,t.$Zj)("no-newline",60197),note:(0,t.$Zj)("note",60198),octoface:(0,t.$Zj)("octoface",60199),openPreview:(0,t.$Zj)("open-preview",60200),package:(0,t.$Zj)("package",60201),paintcan:(0,t.$Zj)("paintcan",60202),pin:(0,t.$Zj)("pin",60203),play:(0,t.$Zj)("play",60204),run:(0,t.$Zj)("run",60204),plug:(0,t.$Zj)("plug",60205),preserveCase:(0,t.$Zj)("preserve-case",60206),preview:(0,t.$Zj)("preview",60207),project:(0,t.$Zj)("project",60208),pulse:(0,t.$Zj)("pulse",60209),question:(0,t.$Zj)("question",60210),quote:(0,t.$Zj)("quote",60211),radioTower:(0,t.$Zj)("radio-tower",60212),reactions:(0,t.$Zj)("reactions",60213),references:(0,t.$Zj)("references",60214),refresh:(0,t.$Zj)("refresh",60215),regex:(0,t.$Zj)("regex",60216),remoteExplorer:(0,t.$Zj)("remote-explorer",60217),remote:(0,t.$Zj)("remote",60218),remove:(0,t.$Zj)("remove",60219),replaceAll:(0,t.$Zj)("replace-all",60220),replace:(0,t.$Zj)("replace",60221),repoClone:(0,t.$Zj)("repo-clone",60222),repoForcePush:(0,t.$Zj)("repo-force-push",60223),repoPull:(0,t.$Zj)("repo-pull",60224),repoPush:(0,t.$Zj)("repo-push",60225),report:(0,t.$Zj)("report",60226),requestChanges:(0,t.$Zj)("request-changes",60227),rocket:(0,t.$Zj)("rocket",60228),rootFolderOpened:(0,t.$Zj)("root-folder-opened",60229),rootFolder:(0,t.$Zj)("root-folder",60230),rss:(0,t.$Zj)("rss",60231),ruby:(0,t.$Zj)("ruby",60232),saveAll:(0,t.$Zj)("save-all",60233),saveAs:(0,t.$Zj)("save-as",60234),save:(0,t.$Zj)("save",60235),screenFull:(0,t.$Zj)("screen-full",60236),screenNormal:(0,t.$Zj)("screen-normal",60237),searchStop:(0,t.$Zj)("search-stop",60238),server:(0,t.$Zj)("server",60240),settingsGear:(0,t.$Zj)("settings-gear",60241),settings:(0,t.$Zj)("settings",60242),shield:(0,t.$Zj)("shield",60243),smiley:(0,t.$Zj)("smiley",60244),sortPrecedence:(0,t.$Zj)("sort-precedence",60245),splitHorizontal:(0,t.$Zj)("split-horizontal",60246),splitVertical:(0,t.$Zj)("split-vertical",60247),squirrel:(0,t.$Zj)("squirrel",60248),starFull:(0,t.$Zj)("star-full",60249),starHalf:(0,t.$Zj)("star-half",60250),symbolClass:(0,t.$Zj)("symbol-class",60251),symbolColor:(0,t.$Zj)("symbol-color",60252),symbolConstant:(0,t.$Zj)("symbol-constant",60253),symbolEnumMember:(0,t.$Zj)("symbol-enum-member",60254),symbolField:(0,t.$Zj)("symbol-field",60255),symbolFile:(0,t.$Zj)("symbol-file",60256),symbolInterface:(0,t.$Zj)("symbol-interface",60257),symbolKeyword:(0,t.$Zj)("symbol-keyword",60258),symbolMisc:(0,t.$Zj)("symbol-misc",60259),symbolOperator:(0,t.$Zj)("symbol-operator",60260),symbolProperty:(0,t.$Zj)("symbol-property",60261),wrench:(0,t.$Zj)("wrench",60261),wrenchSubaction:(0,t.$Zj)("wrench-subaction",60261),symbolSnippet:(0,t.$Zj)("symbol-snippet",60262),tasklist:(0,t.$Zj)("tasklist",60263),telescope:(0,t.$Zj)("telescope",60264),textSize:(0,t.$Zj)("text-size",60265),threeBars:(0,t.$Zj)("three-bars",60266),thumbsdown:(0,t.$Zj)("thumbsdown",60267),thumbsup:(0,t.$Zj)("thumbsup",60268),tools:(0,t.$Zj)("tools",60269),triangleDown:(0,t.$Zj)("triangle-down",60270),triangleLeft:(0,t.$Zj)("triangle-left",60271),triangleRight:(0,t.$Zj)("triangle-right",60272),triangleUp:(0,t.$Zj)("triangle-up",60273),twitter:(0,t.$Zj)("twitter",60274),unfold:(0,t.$Zj)("unfold",60275),unlock:(0,t.$Zj)("unlock",60276),unmute:(0,t.$Zj)("unmute",60277),unverified:(0,t.$Zj)("unverified",60278),verified:(0,t.$Zj)("verified",60279),versions:(0,t.$Zj)("versions",60280),vmActive:(0,t.$Zj)("vm-active",60281),vmOutline:(0,t.$Zj)("vm-outline",60282),vmRunning:(0,t.$Zj)("vm-running",60283),watch:(0,t.$Zj)("watch",60284),whitespace:(0,t.$Zj)("whitespace",60285),wholeWord:(0,t.$Zj)("whole-word",60286),window:(0,t.$Zj)("window",60287),wordWrap:(0,t.$Zj)("word-wrap",60288),zoomIn:(0,t.$Zj)("zoom-in",60289),zoomOut:(0,t.$Zj)("zoom-out",60290),listFilter:(0,t.$Zj)("list-filter",60291),listFlat:(0,t.$Zj)("list-flat",60292),listSelection:(0,t.$Zj)("list-selection",60293),selection:(0,t.$Zj)("selection",60293),listTree:(0,t.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,t.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,t.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,t.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$Zj)("symbol-string",60301),debugReverseContinue:(0,t.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,t.$Zj)("debug-step-back",60303),debugRestartFrame:(0,t.$Zj)("debug-restart-frame",60304),debugAlt:(0,t.$Zj)("debug-alt",60305),callIncoming:(0,t.$Zj)("call-incoming",60306),callOutgoing:(0,t.$Zj)("call-outgoing",60307),menu:(0,t.$Zj)("menu",60308),expandAll:(0,t.$Zj)("expand-all",60309),feedback:(0,t.$Zj)("feedback",60310),gitPullRequestReviewer:(0,t.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,t.$Zj)("ungroup-by-ref-type",60312),account:(0,t.$Zj)("account",60313),gitPullRequestAssignee:(0,t.$Zj)("git-pull-request-assignee",60313),bellDot:(0,t.$Zj)("bell-dot",60314),debugConsole:(0,t.$Zj)("debug-console",60315),library:(0,t.$Zj)("library",60316),output:(0,t.$Zj)("output",60317),runAll:(0,t.$Zj)("run-all",60318),syncIgnored:(0,t.$Zj)("sync-ignored",60319),pinned:(0,t.$Zj)("pinned",60320),githubInverted:(0,t.$Zj)("github-inverted",60321),serverProcess:(0,t.$Zj)("server-process",60322),serverEnvironment:(0,t.$Zj)("server-environment",60323),pass:(0,t.$Zj)("pass",60324),issueClosed:(0,t.$Zj)("issue-closed",60324),stopCircle:(0,t.$Zj)("stop-circle",60325),playCircle:(0,t.$Zj)("play-circle",60326),record:(0,t.$Zj)("record",60327),debugAltSmall:(0,t.$Zj)("debug-alt-small",60328),vmConnect:(0,t.$Zj)("vm-connect",60329),cloud:(0,t.$Zj)("cloud",60330),merge:(0,t.$Zj)("merge",60331),export:(0,t.$Zj)("export",60332),graphLeft:(0,t.$Zj)("graph-left",60333),magnet:(0,t.$Zj)("magnet",60334),notebook:(0,t.$Zj)("notebook",60335),redo:(0,t.$Zj)("redo",60336),checkAll:(0,t.$Zj)("check-all",60337),pinnedDirty:(0,t.$Zj)("pinned-dirty",60338),passFilled:(0,t.$Zj)("pass-filled",60339),circleLargeFilled:(0,t.$Zj)("circle-large-filled",60340),circleLarge:(0,t.$Zj)("circle-large",60341),circleLargeOutline:(0,t.$Zj)("circle-large-outline",60341),combine:(0,t.$Zj)("combine",60342),gather:(0,t.$Zj)("gather",60342),table:(0,t.$Zj)("table",60343),variableGroup:(0,t.$Zj)("variable-group",60344),typeHierarchy:(0,t.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,t.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$Zj)("git-pull-request-create",60348),runAbove:(0,t.$Zj)("run-above",60349),runBelow:(0,t.$Zj)("run-below",60350),notebookTemplate:(0,t.$Zj)("notebook-template",60351),debugRerun:(0,t.$Zj)("debug-rerun",60352),workspaceTrusted:(0,t.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,t.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,t.$Zj)("workspace-unknown",60355),terminalCmd:(0,t.$Zj)("terminal-cmd",60356),terminalDebian:(0,t.$Zj)("terminal-debian",60357),terminalLinux:(0,t.$Zj)("terminal-linux",60358),terminalPowershell:(0,t.$Zj)("terminal-powershell",60359),terminalTmux:(0,t.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,t.$Zj)("terminal-ubuntu",60361),terminalBash:(0,t.$Zj)("terminal-bash",60362),arrowSwap:(0,t.$Zj)("arrow-swap",60363),copy:(0,t.$Zj)("copy",60364),personAdd:(0,t.$Zj)("person-add",60365),filterFilled:(0,t.$Zj)("filter-filled",60366),wand:(0,t.$Zj)("wand",60367),debugLineByLine:(0,t.$Zj)("debug-line-by-line",60368),inspect:(0,t.$Zj)("inspect",60369),layers:(0,t.$Zj)("layers",60370),layersDot:(0,t.$Zj)("layers-dot",60371),layersActive:(0,t.$Zj)("layers-active",60372),compass:(0,t.$Zj)("compass",60373),compassDot:(0,t.$Zj)("compass-dot",60374),compassActive:(0,t.$Zj)("compass-active",60375),azure:(0,t.$Zj)("azure",60376),issueDraft:(0,t.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,t.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$Zj)("git-pull-request-draft",60379),debugAll:(0,t.$Zj)("debug-all",60380),debugCoverage:(0,t.$Zj)("debug-coverage",60381),runErrors:(0,t.$Zj)("run-errors",60382),folderLibrary:(0,t.$Zj)("folder-library",60383),debugContinueSmall:(0,t.$Zj)("debug-continue-small",60384),beakerStop:(0,t.$Zj)("beaker-stop",60385),graphLine:(0,t.$Zj)("graph-line",60386),graphScatter:(0,t.$Zj)("graph-scatter",60387),pieChart:(0,t.$Zj)("pie-chart",60388),bracket:(0,t.$Zj)("bracket",60175),bracketDot:(0,t.$Zj)("bracket-dot",60389),bracketError:(0,t.$Zj)("bracket-error",60390),lockSmall:(0,t.$Zj)("lock-small",60391),azureDevops:(0,t.$Zj)("azure-devops",60392),verifiedFilled:(0,t.$Zj)("verified-filled",60393),newline:(0,t.$Zj)("newline",60394),layout:(0,t.$Zj)("layout",60395),layoutActivitybarLeft:(0,t.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,t.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,t.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,t.$Zj)("layout-panel-right",60401),layoutPanel:(0,t.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,t.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$Zj)("layout-statusbar",60405),layoutMenubar:(0,t.$Zj)("layout-menubar",60406),layoutCentered:(0,t.$Zj)("layout-centered",60407),target:(0,t.$Zj)("target",60408),indent:(0,t.$Zj)("indent",60409),recordSmall:(0,t.$Zj)("record-small",60410),errorSmall:(0,t.$Zj)("error-small",60411),terminalDecorationError:(0,t.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,t.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,t.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$Zj)("layout-sidebar-left-off",60418),blank:(0,t.$Zj)("blank",60419),heartFilled:(0,t.$Zj)("heart-filled",60420),map:(0,t.$Zj)("map",60421),mapHorizontal:(0,t.$Zj)("map-horizontal",60421),foldHorizontal:(0,t.$Zj)("fold-horizontal",60421),mapFilled:(0,t.$Zj)("map-filled",60422),mapHorizontalFilled:(0,t.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,t.$Zj)("circle-small",60423),bellSlash:(0,t.$Zj)("bell-slash",60424),bellSlashDot:(0,t.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,t.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$Zj)("search-fuzzy",60429),commentDraft:(0,t.$Zj)("comment-draft",60430),send:(0,t.$Zj)("send",60431),sparkle:(0,t.$Zj)("sparkle",60432),insert:(0,t.$Zj)("insert",60433),mic:(0,t.$Zj)("mic",60434),thumbsdownFilled:(0,t.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$Zj)("thumbsup-filled",60436),coffee:(0,t.$Zj)("coffee",60437),snake:(0,t.$Zj)("snake",60438),game:(0,t.$Zj)("game",60439),vr:(0,t.$Zj)("vr",60440),chip:(0,t.$Zj)("chip",60441),piano:(0,t.$Zj)("piano",60442),music:(0,t.$Zj)("music",60443),micFilled:(0,t.$Zj)("mic-filled",60444),repoFetch:(0,t.$Zj)("repo-fetch",60445),copilot:(0,t.$Zj)("copilot",60446),lightbulbSparkle:(0,t.$Zj)("lightbulb-sparkle",60447),robot:(0,t.$Zj)("robot",60448),sparkleFilled:(0,t.$Zj)("sparkle-filled",60449),diffSingle:(0,t.$Zj)("diff-single",60450),diffMultiple:(0,t.$Zj)("diff-multiple",60451),surroundWith:(0,t.$Zj)("surround-with",60452),share:(0,t.$Zj)("share",60453),gitStash:(0,t.$Zj)("git-stash",60454),gitStashApply:(0,t.$Zj)("git-stash-apply",60455),gitStashPop:(0,t.$Zj)("git-stash-pop",60456),vscode:(0,t.$Zj)("vscode",60457),vscodeInsiders:(0,t.$Zj)("vscode-insiders",60458),codeOss:(0,t.$Zj)("code-oss",60459),runCoverage:(0,t.$Zj)("run-coverage",60460),runAllCoverage:(0,t.$Zj)("run-all-coverage",60461),coverage:(0,t.$Zj)("coverage",60462),githubProject:(0,t.$Zj)("github-project",60463),mapVertical:(0,t.$Zj)("map-vertical",60464),foldVertical:(0,t.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,t.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$Zj)("fold-vertical-filled",60465),goToSearch:(0,t.$Zj)("go-to-search",60466),percentage:(0,t.$Zj)("percentage",60467),sortPercentage:(0,t.$Zj)("sort-percentage",60467),attach:(0,t.$Zj)("attach",60468)}}),define(Re[56],Ae([1,0,107,172]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=E;function E(){return Object.values(e.$5j)}e.$4j={dialogError:(0,t.$Zj)("dialog-error","error"),dialogWarning:(0,t.$Zj)("dialog-warning","warning"),dialogInfo:(0,t.$Zj)("dialog-info","info"),dialogClose:(0,t.$Zj)("dialog-close","close"),treeItemExpanded:(0,t.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,t.$Zj)("tree-item-loading","loading"),menuSelection:(0,t.$Zj)("menu-selection","check"),menuSubmenu:(0,t.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,t.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,t.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$Zj)("toolbar-more","more"),quickInputBack:(0,t.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,t.$Zj)("drop-down-button",60084),symbolCustomColor:(0,t.$Zj)("symbol-customcolor",60252),exportIcon:(0,t.$Zj)("export",60332),workspaceUnspecified:(0,t.$Zj)("workspace-unspecified",60355),newLine:(0,t.$Zj)("newline",60394),thumbsDownFilled:(0,t.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$Zj)("thumbsup-filled",60436),gitFetch:(0,t.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...s.$2j,...e.$4j}}),define(Re[20],Ae([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=s,e.$fo=E,e.$go=C,e.$ho=y,e.$io=o,e.$jo=D,e.$ko=w,e.$lo=m,e.$mo=$,e.$no=a,e.$oo=u,e.$po=d,e.$qo=f;function s(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const g=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([b,i])=>{g[b]=i&&typeof i=="object"?s(i):i}),g}function E(v){if(!v||typeof v!="object")return v;const g=[v];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const i in b)if(k.call(b,i)){const p=b[i];typeof p=="object"&&!Object.isFrozen(p)&&!(0,t.$hg)(p)&&g.push(p)}}return v}const k=Object.prototype.hasOwnProperty;function C(v,g){return A(v,g,new Set)}function A(v,g,b){if((0,t.$ng)(v))return v;const i=g(v);if(typeof i<"u")return i;if(Array.isArray(v)){const p=[];for(const n of v)p.push(A(n,g,b));return p}if((0,t.$gg)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const p={};for(const n in v)k.call(v,n)&&(p[n]=A(v[n],g,b));return b.delete(v),p}return v}function y(v,g,b=!0){return(0,t.$gg)(v)?((0,t.$gg)(g)&&Object.keys(g).forEach(i=>{i in v?b&&((0,t.$gg)(v[i])&&(0,t.$gg)(g[i])?y(v[i],g[i],b):v[i]=g[i]):v[i]=g[i]}),v):g}function o(v,g){if(v===g)return!0;if(v==null||g===null||g===void 0||typeof v!=typeof g||typeof v!="object"||Array.isArray(v)!==Array.isArray(g))return!1;let b,i;if(Array.isArray(v)){if(v.length!==g.length)return!1;for(b=0;b<v.length;b++)if(!o(v[b],g[b]))return!1}else{const p=[];for(i in v)p.push(i);p.sort();const n=[];for(i in g)n.push(i);if(n.sort(),!o(p,n))return!1;for(b=0;b<p.length;b++)if(!o(v[p[b]],g[p[b]]))return!1}return!0}function D(v){const g=new Set;return JSON.stringify(v,(b,i)=>{if((0,t.$gg)(i)||Array.isArray(i)){if(g.has(i))return"[Circular]";g.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function w(v,g){const b=Object.create(null);return!v||!g||Object.keys(g).forEach(p=>{const n=v[p],l=g[p];o(n,l)||(b[p]=l)}),b}function m(v,g){const b=g.toLowerCase(),i=Object.keys(v).find(p=>p.toLowerCase()===b);return i?v[i]:v[g]}function $(v,g){const b=Object.create(null);for(const[i,p]of Object.entries(v))g(i,p)&&(b[i]=p);return b}function a(v){let g=[];for(;Object.prototype!==v;)g=g.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return g}function u(v){const g=[];for(const b of a(v))typeof v[b]=="function"&&g.push(b);return g}function d(v,g){const b=p=>function(){const n=Array.prototype.slice.call(arguments,0);return g(p,n)},i={};for(const p of v)i[p]=b(p);return i}function f(v,g){const b={};for(const[i,p]of Object.entries(v))b[i]=g(p,i);return b}}),define(Re[81],Ae([1,0,56]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=E;var s;(function(C){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}C.isThemeColor=A})(s||(e.ThemeColor=s={}));function E(C){return{id:C}}var k;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function y(v){const g=A.exec(v.id);if(!g)return y(t.$5j.error);const[,b,i]=g,p=["codicon","codicon-"+b];return i&&p.push("codicon-modifier-"+i.substring(1)),p}C.asClassNameArray=y;function o(v){return y(v).join(" ")}C.asClassName=o;function D(v){return"."+y(v).join(".")}C.asCSSSelector=D;function w(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color>"u"||s.isThemeColor(v.color))}C.isThemeIcon=w;const m=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function $(v){const g=m.exec(v);if(!g)return;const[,b]=g;return{id:b}}C.fromString=$;function a(v){return{id:v}}C.fromId=a;function u(v,g){let b=v.id;const i=b.lastIndexOf("~");return i!==-1&&(b=b.substring(0,i)),g&&(b=`${b}~${g}`),{id:b}}C.modify=u;function d(v){const g=v.id.lastIndexOf("~");if(g!==-1)return v.id.substring(g+1)}C.getModifier=d;function f(v,g){return v.id===g.id&&v.color?.id===g.color?.id}C.isEqual=f})(k||(e.ThemeIcon=k={}))}),define(Re[108],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=s,e.$bf=E;var t;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(e.Constants=t={}));function s(k){return k<0?0:k>t.MAX_UINT_8?t.MAX_UINT_8:k|0}function E(k){return k<0?0:k>t.MAX_UINT_32?t.MAX_UINT_32:k|0}}),define(Re[16],Ae([1,0,169,34,64,108]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=C,e.$df=y,e.$ef=D,e.$ff=w,e.$gf=m,e.$hf=$,e.$if=a,e.$jf=u,e.$kf=d,e.$lf=f,e.$mf=v,e.$nf=g,e.$of=b,e.$pf=i,e.$qf=p,e.$rf=n,e.$sf=l,e.$tf=r,e.$uf=h,e.$vf=c,e.$wf=S,e.$xf=I,e.$yf=R,e.$zf=L,e.$Af=O,e.$Bf=P,e.$Cf=q,e.$Df=K,e.$Ef=J,e.$Ff=_,e.$Gf=de,e.$Hf=ge,e.$If=le,e.$Jf=z,e.$Kf=Q,e.$Lf=M,e.$Mf=V,e.$Pf=oe,e.$Qf=ie,e.$Rf=x,e.$Sf=G,e.$Tf=he,e.$Uf=U,e.$Wf=H,e.$Xf=F,e.$Yf=W,e.$Zf=Y,e.$1f=Ee,e.$2f=Le,e.$3f=pe,e.$5f=we,e.$6f=Te,e.$7f=ce,e.$8f=ye,e.$9f=ve,e.$0f=ze,e.$$f=qe,e.$_f=Je,e.$ag=lt;function C($e){return!$e||typeof $e!="string"?!0:$e.trim().length===0}const A=/{(\d+)}/g;function y($e,...Ne){return Ne.length===0?$e:$e.replace(A,function(Fe,ke){const Ce=parseInt(ke,10);return isNaN(Ce)||Ce<0||Ce>=Ne.length?Fe:Ne[Ce]})}const o=/{([^}]+)}/g;function D($e,Ne){return Object.keys(Ne).length===0?$e:$e.replace(o,(Fe,ke)=>Ne[ke]??Fe)}function w($e){return $e.replace(/[<>"'&]/g,Ne=>{switch(Ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ne})}function m($e){return $e.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}function $($e){return $e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a($e,Ne){let Fe=0,ke=$e.indexOf(Ne);for(;ke!==-1;)Fe++,ke=$e.indexOf(Ne,ke+Ne.length);return Fe}function u($e,Ne,Fe="\u2026"){return $e.length<=Ne?$e:`${$e.substr(0,Ne)}${Fe}`}function d($e,Ne,Fe="\u2026"){if($e.length<=Ne)return $e;const ke=Math.ceil(Ne/2)-Fe.length/2,Ce=Math.floor(Ne/2)-Fe.length/2;return`${$e.substr(0,ke)}${Fe}${$e.substr($e.length-Ce)}`}function f($e,Ne=" "){const Fe=v($e,Ne);return g(Fe,Ne)}function v($e,Ne){if(!$e||!Ne)return $e;const Fe=Ne.length;if(Fe===0||$e.length===0)return $e;let ke=0;for(;$e.indexOf(Ne,ke)===ke;)ke=ke+Fe;return $e.substring(ke)}function g($e,Ne){if(!$e||!Ne)return $e;const Fe=Ne.length,ke=$e.length;if(Fe===0||ke===0)return $e;let Ce=ke,te=-1;for(;te=$e.lastIndexOf(Ne,Ce-1),!(te===-1||te+Fe!==Ce);){if(te===0)return"";Ce=te}return $e.substring(0,Ce)}function b($e){return $e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i($e){return $e.replace(/\*/g,"")}function p($e,Ne,Fe={}){if(!$e)throw new Error("Cannot create regex from empty string");Ne||($e=$($e)),Fe.wholeWord&&(/\B/.test($e.charAt(0))||($e="\\b"+$e),/\B/.test($e.charAt($e.length-1))||($e=$e+"\\b"));let ke="";return Fe.global&&(ke+="g"),Fe.matchCase||(ke+="i"),Fe.multiline&&(ke+="m"),Fe.unicode&&(ke+="u"),new RegExp($e,ke)}function n($e){return $e.source==="^"||$e.source==="^$"||$e.source==="$"||$e.source==="^\\s*$"?!1:!!($e.exec("")&&$e.lastIndex===0)}function l($e){return $e.split(/\r\n|\r|\n/)}function r($e){const Ne=[],Fe=$e.split(/(\r\n|\r|\n)/);for(let ke=0;ke<Math.ceil(Fe.length/2);ke++)Ne.push(Fe[2*ke]+(Fe[2*ke+1]??""));return Ne}function h($e){for(let Ne=0,Fe=$e.length;Ne<Fe;Ne++){const ke=$e.charCodeAt(Ne);if(ke!==s.CharCode.Space&&ke!==s.CharCode.Tab)return Ne}return-1}function c($e,Ne=0,Fe=$e.length){for(let ke=Ne;ke<Fe;ke++){const Ce=$e.charCodeAt(ke);if(Ce!==s.CharCode.Space&&Ce!==s.CharCode.Tab)return $e.substring(Ne,ke)}return $e.substring(Ne,Fe)}function S($e,Ne=$e.length-1){for(let Fe=Ne;Fe>=0;Fe--){const ke=$e.charCodeAt(Fe);if(ke!==s.CharCode.Space&&ke!==s.CharCode.Tab)return Fe}return-1}function I($e,Ne,Fe){const ke=[];let Ce=0;for(const te of $e.matchAll(Ne)){if(ke.push($e.slice(Ce,te.index)),te.index===void 0)throw new Error("match.index should be defined");Ce=te.index+te[0].length,ke.push(Fe(te[0],...te.slice(1),te.index,$e,te.groups))}return ke.push($e.slice(Ce)),Promise.all(ke).then(te=>te.join(""))}function R($e,Ne){return $e<Ne?-1:$e>Ne?1:0}function L($e,Ne,Fe=0,ke=$e.length,Ce=0,te=Ne.length){for(;Fe<ke&&Ce<te;Fe++,Ce++){const We=$e.charCodeAt(Fe),Ke=Ne.charCodeAt(Ce);if(We<Ke)return-1;if(We>Ke)return 1}const ee=ke-Fe,Se=te-Ce;return ee<Se?-1:ee>Se?1:0}function O($e,Ne){return P($e,Ne,0,$e.length,0,Ne.length)}function P($e,Ne,Fe=0,ke=$e.length,Ce=0,te=Ne.length){for(;Fe<ke&&Ce<te;Fe++,Ce++){let We=$e.charCodeAt(Fe),Ke=Ne.charCodeAt(Ce);if(We===Ke)continue;if(We>=128||Ke>=128)return L($e.toLowerCase(),Ne.toLowerCase(),Fe,ke,Ce,te);K(We)&&(We-=32),K(Ke)&&(Ke-=32);const _e=We-Ke;if(_e!==0)return _e}const ee=ke-Fe,Se=te-Ce;return ee<Se?-1:ee>Se?1:0}function q($e){return $e>=s.CharCode.Digit0&&$e<=s.CharCode.Digit9}function K($e){return $e>=s.CharCode.a&&$e<=s.CharCode.z}function J($e){return $e>=s.CharCode.A&&$e<=s.CharCode.Z}function _($e,Ne){return $e.length===Ne.length&&P($e,Ne)===0}function de($e,Ne){const Fe=Ne.length;return Ne.length>$e.length?!1:P($e,Ne,0,Fe)===0}function ge($e,Ne){const Fe=Math.min($e.length,Ne.length);let ke;for(ke=0;ke<Fe;ke++)if($e.charCodeAt(ke)!==Ne.charCodeAt(ke))return ke;return Fe}function le($e,Ne){const Fe=Math.min($e.length,Ne.length);let ke;const Ce=$e.length-1,te=Ne.length-1;for(ke=0;ke<Fe;ke++)if($e.charCodeAt(Ce-ke)!==Ne.charCodeAt(te-ke))return ke;return Fe}function z($e){return 55296<=$e&&$e<=56319}function Q($e){return 56320<=$e&&$e<=57343}function M($e,Ne){return($e-55296<<10)+(Ne-56320)+65536}function V($e,Ne,Fe){const ke=$e.charCodeAt(Fe);if(z(ke)&&Fe+1<Ne){const Ce=$e.charCodeAt(Fe+1);if(Q(Ce))return M(ke,Ce)}return ke}function ne($e,Ne){const Fe=$e.charCodeAt(Ne-1);if(Q(Fe)&&Ne>1){const ke=$e.charCodeAt(Ne-2);if(z(ke))return M(ke,Fe)}return Fe}class re{get offset(){return this.e}constructor(Ne,Fe=0){this.c=Ne,this.d=Ne.length,this.e=Fe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=ne(this.c,this.e);return this.e-=Ne>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ne}nextCodePoint(){const Ne=V(this.c,this.d,this.e);return this.e+=Ne>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ne}eol(){return this.e>=this.d}}e.$Nf=re;class me{get offset(){return this.c.offset}constructor(Ne,Fe=0){this.c=new re(Ne,Fe)}nextGraphemeLength(){const Ne=Ye.getInstance(),Fe=this.c,ke=Fe.offset;let Ce=Ne.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const te=Fe.offset,ee=Ne.getGraphemeBreakType(Fe.nextCodePoint());if(Ge(Ce,ee)){Fe.setOffset(te);break}Ce=ee}return Fe.offset-ke}prevGraphemeLength(){const Ne=Ye.getInstance(),Fe=this.c,ke=Fe.offset;let Ce=Ne.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const te=Fe.offset,ee=Ne.getGraphemeBreakType(Fe.prevCodePoint());if(Ge(ee,Ce)){Fe.setOffset(te);break}Ce=ee}return ke-Fe.offset}eol(){return this.c.eol()}}e.$Of=me;function oe($e,Ne){return new me($e,Ne).nextGraphemeLength()}function ie($e,Ne){return new me($e,Ne).prevGraphemeLength()}function x($e,Ne){Ne>0&&Q($e.charCodeAt(Ne))&&Ne--;const Fe=Ne+oe($e,Ne);return[Fe-ie($e,Fe),Fe]}function G($e){const Ne=new me($e);let Fe=0;for(;!Ne.eol();)Fe++,Ne.nextGraphemeLength();return Fe}let T;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he($e){return T||(T=X()),T.test($e)}const B=/^[\t\n\r\x20-\x7E]*$/;function U($e){return B.test($e)}e.$Vf=/[\u2028\u2029]/;function H($e){return e.$Vf.test($e)}function F($e){return $e>=11904&&$e<=55215||$e>=63744&&$e<=64255||$e>=65281&&$e<=65374}function W($e){return $e>=127462&&$e<=127487||$e===8986||$e===8987||$e===9200||$e===9203||$e>=9728&&$e<=10175||$e===11088||$e===11093||$e>=127744&&$e<=128591||$e>=128640&&$e<=128764||$e>=128992&&$e<=129008||$e>=129280&&$e<=129535||$e>=129648&&$e<=129782}function Y($e,Ne,Fe=""){const ke=$e.trimStart();if(ke.length<Ne)return ke;const Ce=/\b/g;let te=0;for(;Ce.test(ke)&&!(ke.length-Ce.lastIndex<Ne);)te=Ce.lastIndex,Ce.lastIndex+=1;return te===0?ke:Fe+ke.substring(te).trimStart()}const ae=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ee($e){let Ne=0;for(const Fe of $e.matchAll(ae))Ne!==Fe.index&&(yield{isCode:!1,str:$e.substring(Ne,Fe.index)}),yield{isCode:!0,str:Fe[0]},Ne=Fe.index+Fe[0].length;Ne!==$e.length&&(yield{isCode:!1,str:$e.substring(Ne)})}function Le($e){return $e&&($e=$e.replace(ae,"")),$e}const be=/\\\[.*?\\\]/g;function pe($e){return Le($e).replace(be,"")}e.$4f=String.fromCharCode(s.CharCode.UTF8_BOM);function we($e){return!!($e&&$e.length>0&&$e.charCodeAt(0)===s.CharCode.UTF8_BOM)}function Te($e){return we($e)?$e.substr(1):$e}function ce($e,Ne){if(!$e||!Ne||$e.length<Ne.length)return!1;const Fe=Ne.length,ke=$e.toLowerCase();let Ce=0,te=-1;for(;Ce<Fe;){const ee=ke.indexOf(Ne[Ce],te+1);if(ee<0)return!1;te=ee,Ce++}return!0}function ye($e,Ne=!1){return $e?(Ne&&($e=$e.replace(/\\./g,"")),$e.toLowerCase()!==$e):!1}function ve($e){return $e.charAt(0).toUpperCase()+$e.slice(1)}function ze($e,Ne=1){if(Ne===0)return"";let Fe=-1;do Fe=$e.indexOf(`
`,Fe+1),Ne--;while(Ne>0&&Fe>=0);return Fe===-1?$e:($e[Fe-1]==="\r"&&Fe--,$e.substr(0,Fe))}function qe($e){const Ne=s.CharCode.Z-s.CharCode.A+1;return $e=$e%(2*Ne),$e<Ne?String.fromCharCode(s.CharCode.a+$e):String.fromCharCode(s.CharCode.A+$e-Ne)}function Je($e){return Ye.getInstance().getGraphemeBreakType($e)}function Ge($e,Ne){return $e===Ze.Other?Ne!==Ze.Extend&&Ne!==Ze.SpacingMark:$e===Ze.CR&&Ne===Ze.LF?!1:$e===Ze.Control||$e===Ze.CR||$e===Ze.LF||Ne===Ze.Control||Ne===Ze.CR||Ne===Ze.LF?!0:!($e===Ze.L&&(Ne===Ze.L||Ne===Ze.V||Ne===Ze.LV||Ne===Ze.LVT)||($e===Ze.LV||$e===Ze.V)&&(Ne===Ze.V||Ne===Ze.T)||($e===Ze.LVT||$e===Ze.T)&&Ne===Ze.T||Ne===Ze.Extend||Ne===Ze.ZWJ||Ne===Ze.SpacingMark||$e===Ze.Prepend||$e===Ze.ZWJ&&Ne===Ze.Extended_Pictographic||$e===Ze.Regional_Indicator&&Ne===Ze.Regional_Indicator)}var Ze;(function($e){$e[$e.Other=0]="Other",$e[$e.Prepend=1]="Prepend",$e[$e.CR=2]="CR",$e[$e.LF=3]="LF",$e[$e.Control=4]="Control",$e[$e.Extend=5]="Extend",$e[$e.Regional_Indicator=6]="Regional_Indicator",$e[$e.SpacingMark=7]="SpacingMark",$e[$e.L=8]="L",$e[$e.V=9]="V",$e[$e.T=10]="T",$e[$e.LV=11]="LV",$e[$e.LVT=12]="LVT",$e[$e.ZWJ=13]="ZWJ",$e[$e.Extended_Pictographic=14]="Extended_Pictographic"})(Ze||(e.GraphemeBreakType=Ze={}));class Ye{static{this.c=null}static getInstance(){return Ye.c||(Ye.c=new Ye),Ye.c}constructor(){this.d=it()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===s.CharCode.LineFeed?Ze.LF:Ne===s.CharCode.CarriageReturn?Ze.CR:Ze.Control;if(Ne<127)return Ze.Other;const Fe=this.d,ke=Fe.length/3;let Ce=1;for(;Ce<=ke;)if(Ne<Fe[3*Ce])Ce=2*Ce;else if(Ne>Fe[3*Ce+1])Ce=2*Ce+1;else return Fe[3*Ce+2];return Ze.Other}}function it(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function lt($e,Ne){if($e===0)return 0;const Fe=rt($e,Ne);if(Fe!==void 0)return Fe;const ke=new re(Ne,$e);return ke.prevCodePoint(),ke.offset}function rt($e,Ne){const Fe=new re(Ne,$e);let ke=Fe.prevCodePoint();for(;nt(ke)||ke===tt.emojiVariantSelector||ke===tt.enclosingKeyCap;){if(Fe.offset===0)return;ke=Fe.prevCodePoint()}if(!W(ke))return;let Ce=Fe.offset;return Ce>0&&Fe.prevCodePoint()===tt.zwj&&(Ce=Fe.offset),Ce}function nt($e){return 127995<=$e&&$e<=127999}var tt;(function($e){$e[$e.zwj=8205]="zwj",$e[$e.emojiVariantSelector=65039]="emojiVariantSelector",$e[$e.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.$bg="\xA0";class et{static{this.c=new E.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$$e({getCacheKey:JSON.stringify},Ne=>{function Fe(_e){const st=new Map;for(let ut=0;ut<_e.length;ut+=2)st.set(_e[ut],_e[ut+1]);return st}function ke(_e,st){const ut=new Map(_e);for(const[gt,wt]of st)ut.set(gt,wt);return ut}function Ce(_e,st){if(!_e)return st;const ut=new Map;for(const[gt,wt]of _e)st.has(gt)&&ut.set(gt,wt);return ut}const te=this.c.value;let ee=Ne.filter(_e=>!_e.startsWith("_")&&_e in te);ee.length===0&&(ee=["_default"]);let Se;for(const _e of ee){const st=Fe(te[_e]);Se=Ce(Se,st)}const We=Fe(te._common),Ke=ke(We,Se);return new et(Ke)})}static getInstance(Ne){return et.d.get(Array.from(Ne))}static{this.e=new E.$T(()=>Object.keys(et.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return et.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}containsAmbiguousCharacter(Ne){for(let Fe=0;Fe<Ne.length;Fe++){const ke=Ne.codePointAt(Fe);if(typeof ke=="number"&&this.isAmbiguous(ke))return!0}return!1}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=et;class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(Ne){return Xe.e().has(Ne)}static containsInvisibleCharacter(Ne){for(let Fe=0;Fe<Ne.length;Fe++){const ke=Ne.codePointAt(Fe);if(typeof ke=="number"&&Xe.isInvisibleCharacter(ke))return!0}return!1}static get codePoints(){return Xe.e()}}e.$dg=Xe}),define(Re[36],Ae([1,0,34,8,3,16,10]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=A,e.$yg=y,e.$zg=o,e.$Ag=D,e.$Bg=w,e.$Cg=u,e.$Dg=d,e.$Eg=f,e.$Fg=v,e.$Gg=g,e.$Hg=b,e.$Ig=i,e.$Jg=p,e.$Kg=n,e.$Lg=l,e.$Mg=r,e.$Ng=S;function A(I){return I===t.CharCode.Slash||I===t.CharCode.Backslash}function y(I){return I.replace(/[\\/]/g,s.$gc.sep)}function o(I){return I.indexOf("/")===-1&&(I=y(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function D(I,R=s.$gc.sep){if(!I)return"";const L=I.length,O=I.charCodeAt(0);if(A(O)){if(A(I.charCodeAt(1))&&!A(I.charCodeAt(2))){let q=3;const K=q;for(;q<L&&!A(I.charCodeAt(q));q++);if(K!==q&&!A(I.charCodeAt(q+1))){for(q+=1;q<L;q++)if(A(I.charCodeAt(q)))return I.slice(0,q+1).replace(/[\\/]/g,R)}}return R}else if(v(O)&&I.charCodeAt(1)===t.CharCode.Colon)return A(I.charCodeAt(2))?I.slice(0,2)+R:I.slice(0,2);let P=I.indexOf("://");if(P!==-1){for(P+=3;P<L;P++)if(A(I.charCodeAt(P)))return I.slice(0,P+1)}return""}function w(I){if(!E.$j||!I||I.length<5)return!1;let R=I.charCodeAt(0);if(R!==t.CharCode.Backslash||(R=I.charCodeAt(1),R!==t.CharCode.Backslash))return!1;let L=2;const O=L;for(;L<I.length&&(R=I.charCodeAt(L),R!==t.CharCode.Backslash);L++);return!(O===L||(R=I.charCodeAt(L+1),isNaN(R)||R===t.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,$=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(I,R=E.$j){const L=R?m:$;return!(!I||I.length===0||/^\s+$/.test(I)||(L.lastIndex=0,L.test(I))||R&&a.test(I)||I==="."||I===".."||R&&I[I.length-1]==="."||R&&I.length!==I.trim().length||I.length>255)}function d(I,R,L){const O=I===R;return!L||O?O:!I||!R?!1:(0,k.$Ff)(I,R)}function f(I,R,L,O=s.sep){if(I===R)return!0;if(!I||!R||R.length>I.length)return!1;if(L){if(!(0,k.$Gf)(I,R))return!1;if(R.length===I.length)return!0;let q=R.length;return R.charAt(R.length-1)===O&&q--,I.charAt(q)===O}return R.charAt(R.length-1)!==O&&(R+=O),I.indexOf(R)===0}function v(I){return I>=t.CharCode.A&&I<=t.CharCode.Z||I>=t.CharCode.a&&I<=t.CharCode.z}function g(I,R){return E.$j&&I.endsWith(":")&&(I+=s.sep),(0,s.$ic)(I)||(I=(0,s.$jc)(R,I)),I=(0,s.$hc)(I),b(I)}function b(I){return E.$j?(I=(0,k.$nf)(I,s.sep),I.endsWith(":")&&(I+=s.sep)):(I=(0,k.$nf)(I,s.sep),I||(I=s.sep)),I}function i(I){const R=(0,s.$hc)(I);return E.$j?I.length>3?!1:p(R)&&(I.length===2||R.charCodeAt(2)===t.CharCode.Backslash):R===s.$gc.sep}function p(I,R=E.$j){return R?v(I.charCodeAt(0))&&I.charCodeAt(1)===t.CharCode.Colon:!1}function n(I,R=E.$j){return p(I,R)?I[0]:void 0}function l(I,R,L){return R.length>I.length?-1:I===R?0:(L&&(I=I.toLowerCase(),R=R.toLowerCase()),I.indexOf(R))}function r(I){const R=I.split(":");let L,O,P;for(const q of R){const K=Number(q);(0,C.$ig)(K)?O===void 0?O=K:P===void 0&&(P=K):L=L?[L,q].join(":"):q}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:O!==void 0?O:void 0,column:P!==void 0?P:O!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(I,R,L=8){let O="";for(let q=0;q<L;q++){let K;q===0&&E.$j&&!R&&(L===3||L===4)?K=c:K=h,O+=K.charAt(Math.floor(Math.random()*K.length))}let P;return R?P=`${R}-${O}`:P=O,I?(0,s.$jc)(I,P):P}}),define(Re[173],Ae([1,0,34,25,162,16]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=C,e.$Jk=y,e.$Kk=o,e.$Lk=m,e.$Mk=S,e.$Nk=I,e.$Ok=K,e.$Pk=J,e.$Qk=_,e.$Rk=de,e.$Sk=X,e.$Uk=H,e.$Vk=Y,e.$Wk=ae,k=Ue(k);function C(...be){return function(pe,we){for(let Te=0,ce=be.length;Te<ce;Te++){const ye=be[Te](pe,we);if(ye)return ye}return null}}e.$Hk=A.bind(void 0,!1),e.$Ik=A.bind(void 0,!0);function A(be,pe,we){if(!we||we.length<pe.length)return null;let Te;return be?Te=k.$Gf(we,pe):Te=we.indexOf(pe)===0,Te?pe.length>0?[{start:0,end:pe.length}]:[]:null}function y(be,pe){const we=pe.toLowerCase().indexOf(be.toLowerCase());return we===-1?null:[{start:we,end:we+be.length}]}function o(be,pe){return D(be.toLowerCase(),pe.toLowerCase(),0,0)}function D(be,pe,we,Te){if(we===be.length)return[];if(Te===pe.length)return null;if(be[we]===pe[Te]){let ce=null;return(ce=D(be,pe,we+1,Te+1))?i({start:Te,end:Te+1},ce):null}return D(be,pe,we,Te+1)}function w(be){return t.CharCode.a<=be&&be<=t.CharCode.z}function m(be){return t.CharCode.A<=be&&be<=t.CharCode.Z}function $(be){return t.CharCode.Digit0<=be&&be<=t.CharCode.Digit9}function a(be){return be===t.CharCode.Space||be===t.CharCode.Tab||be===t.CharCode.LineFeed||be===t.CharCode.CarriageReturn}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>u.add(be.charCodeAt(0)));function d(be){return a(be)||u.has(be)}function f(be,pe){return be===pe||d(be)&&d(pe)}const v=new Map;function g(be){if(v.has(be))return v.get(be);let pe;const we=(0,E.$Fk)(be);return we&&(pe=we),v.set(be,pe),pe}function b(be){return w(be)||m(be)||$(be)}function i(be,pe){return pe.length===0?pe=[be]:be.end===pe[0].start?pe[0].start=be.start:pe.unshift(be),pe}function p(be,pe){for(let we=pe;we<be.length;we++){const Te=be.charCodeAt(we);if(m(Te)||$(Te)||we>0&&!b(be.charCodeAt(we-1)))return we}return be.length}function n(be,pe,we,Te){if(we===be.length)return[];if(Te===pe.length)return null;if(be[we]!==pe[Te].toLowerCase())return null;{let ce=null,ye=Te+1;for(ce=n(be,pe,we+1,Te+1);!ce&&(ye=p(pe,ye))<pe.length;)ce=n(be,pe,we+1,ye),ye++;return ce===null?null:i({start:Te,end:Te+1},ce)}}function l(be){let pe=0,we=0,Te=0,ce=0,ye=0;for(let Ge=0;Ge<be.length;Ge++)ye=be.charCodeAt(Ge),m(ye)&&pe++,w(ye)&&we++,b(ye)&&Te++,$(ye)&&ce++;const ve=pe/be.length,ze=we/be.length,qe=Te/be.length,Je=ce/be.length;return{upperPercent:ve,lowerPercent:ze,alphaPercent:qe,numericPercent:Je}}function r(be){const{upperPercent:pe,lowerPercent:we}=be;return we===0&&pe>.6}function h(be){const{upperPercent:pe,lowerPercent:we,alphaPercent:Te,numericPercent:ce}=be;return we>.2&&pe<.8&&Te>.6&&ce<.2}function c(be){let pe=0,we=0,Te=0,ce=0;for(let ye=0;ye<be.length;ye++)Te=be.charCodeAt(ye),m(Te)&&pe++,w(Te)&&we++,a(Te)&&ce++;return(pe===0||we===0)&&ce===0?be.length<=30:pe<=5}function S(be,pe){if(!pe||(pe=pe.trim(),pe.length===0)||!c(be))return null;pe.length>60&&(pe=pe.substring(0,60));const we=l(pe);if(!h(we)){if(!r(we))return null;pe=pe.toLowerCase()}let Te=null,ce=0;for(be=be.toLowerCase();ce<pe.length&&(Te=n(be,pe,0,ce))===null;)ce=p(pe,ce+1);return Te}function I(be,pe,we=!1){if(!pe||pe.length===0)return null;let Te=null,ce=0;for(be=be.toLowerCase(),pe=pe.toLowerCase();ce<pe.length&&(Te=R(be,pe,0,ce,we),Te===null);)ce=L(pe,ce+1);return Te}function R(be,pe,we,Te,ce){let ye=0;if(we===be.length)return[];if(Te===pe.length)return null;if(!f(be.charCodeAt(we),pe.charCodeAt(Te))){const qe=g(be.charCodeAt(we));if(!qe)return null;for(let Je=0;Je<qe.length;Je++)if(!f(qe[Je],pe.charCodeAt(Te+Je)))return null;ye+=qe.length-1}let ve=null,ze=Te+ye+1;if(ve=R(be,pe,we+1,ze,ce),!ce)for(;!ve&&(ze=L(pe,ze))<pe.length;)ve=R(be,pe,we+1,ze,ce),ze++;if(!ve)return null;if(be.charCodeAt(we)!==pe.charCodeAt(Te)){const qe=g(be.charCodeAt(we));if(!qe)return ve;for(let Je=0;Je<qe.length;Je++)if(qe[Je]!==pe.charCodeAt(Te+Je))return ve}return i({start:Te,end:Te+ye+1},ve)}function L(be,pe){for(let we=pe;we<be.length;we++)if(d(be.charCodeAt(we))||we>0&&d(be.charCodeAt(we-1)))return we;return be.length}const O=C(e.$Ik,S,y),P=C(e.$Ik,S,o),q=new s.$Dc(1e4);function K(be,pe,we=!1){if(typeof be!="string"||typeof pe!="string")return null;let Te=q.get(be);Te||(Te=new RegExp(k.$of(be),"i"),q.set(be,Te));const ce=Te.exec(pe);return ce?[{start:ce.index,end:ce.index+ce[0].length}]:we?P(be,pe):O(be,pe)}function J(be,pe){const we=H(be,be.toLowerCase(),0,pe,pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?de(we):null}function _(be,pe,we,Te,ce,ye){const ve=Math.min(13,be.length);for(;we<ve;we++){const ze=H(be,pe,we,Te,ce,ye,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ze)return ze}return[0,ye]}function de(be){if(typeof be>"u")return[];const pe=[],we=be[1];for(let Te=be.length-1;Te>1;Te--){const ce=be[Te]+we,ye=pe[pe.length-1];ye&&ye.end===ce?ye.end=ce+1:pe.push({start:ce,end:ce+1})}return pe}const ge=128;function le(){const be=[],pe=[];for(let we=0;we<=ge;we++)pe[we]=0;for(let we=0;we<=ge;we++)be.push(pe.slice(0));return be}function z(be){const pe=[];for(let we=0;we<=be;we++)pe[we]=0;return pe}const Q=z(2*ge),M=z(2*ge),V=le(),ne=le(),re=le(),me=!1;function oe(be,pe,we,Te,ce){function ye(ze,qe,Je=" "){for(;ze.length<qe;)ze=Je+ze;return ze}let ve=` |   |${Te.split("").map(ze=>ye(ze,3)).join("|")}
`;for(let ze=0;ze<=we;ze++)ze===0?ve+=" |":ve+=`${pe[ze-1]}|`,ve+=be[ze].slice(0,ce+1).map(qe=>ye(qe.toString(),3)).join("|")+`
`;return ve}function ie(be,pe,we,Te){be=be.substr(pe),we=we.substr(Te),console.log(oe(ne,be,be.length,we,we.length)),console.log(oe(re,be,be.length,we,we.length)),console.log(oe(V,be,be.length,we,we.length))}function x(be,pe){if(pe<0||pe>=be.length)return!1;const we=be.codePointAt(pe);switch(we){case t.CharCode.Underline:case t.CharCode.Dash:case t.CharCode.Period:case t.CharCode.Space:case t.CharCode.Slash:case t.CharCode.Backslash:case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.Colon:case t.CharCode.DollarSign:case t.CharCode.LessThan:case t.CharCode.GreaterThan:case t.CharCode.OpenParen:case t.CharCode.CloseParen:case t.CharCode.OpenSquareBracket:case t.CharCode.CloseSquareBracket:case t.CharCode.OpenCurlyBrace:case t.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!k.$Yf(we)}}function G(be,pe){if(pe<0||pe>=be.length)return!1;switch(be.charCodeAt(pe)){case t.CharCode.Space:case t.CharCode.Tab:return!0;default:return!1}}function T(be,pe,we){return pe[be]!==we[be]}function X(be,pe,we,Te,ce,ye,ve=!1){for(;pe<we&&ce<ye;)be[pe]===Te[ce]&&(ve&&(Q[pe]=ce),pe+=1),ce+=1;return pe===we}var he;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(he||(he={}));var B;(function(be){be.Default=[-100,0];function pe(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}be.isDefault=pe})(B||(e.FuzzyScore=B={}));class U{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(pe,we){this.firstMatchCanBeWeak=pe,this.boostFullMatch=we}}e.$Tk=U;function H(be,pe,we,Te,ce,ye,ve=U.default){const ze=be.length>ge?ge:be.length,qe=Te.length>ge?ge:Te.length;if(we>=ze||ye>=qe||ze-we>qe-ye||!X(pe,we,ze,ce,ye,qe,!0))return;F(ze,qe,we,ye,pe,ce);let Je=1,Ge=1,Ze=we,Ye=ye;const it=[!1];for(Je=1,Ze=we;Ze<ze;Je++,Ze++){const et=Q[Ze],Xe=M[Ze],$e=Ze+1<ze?M[Ze+1]:qe;for(Ge=et-ye+1,Ye=et;Ye<$e;Ge++,Ye++){let Ne=Number.MIN_SAFE_INTEGER,Fe=!1;Ye<=Xe&&(Ne=W(be,pe,Ze,we,Te,ce,Ye,qe,ye,V[Je-1][Ge-1]===0,it));let ke=0;Ne!==Number.MAX_SAFE_INTEGER&&(Fe=!0,ke=Ne+ne[Je-1][Ge-1]);const Ce=Ye>et,te=Ce?ne[Je][Ge-1]+(V[Je][Ge-1]>0?-5:0):0,ee=Ye>et+1&&V[Je][Ge-1]>0,Se=ee?ne[Je][Ge-2]+(V[Je][Ge-2]>0?-5:0):0;if(ee&&(!Ce||Se>=te)&&(!Fe||Se>=ke))ne[Je][Ge]=Se,re[Je][Ge]=he.LeftLeft,V[Je][Ge]=0;else if(Ce&&(!Fe||te>=ke))ne[Je][Ge]=te,re[Je][Ge]=he.Left,V[Je][Ge]=0;else if(Fe)ne[Je][Ge]=ke,re[Je][Ge]=he.Diag,V[Je][Ge]=V[Je-1][Ge-1]+1;else throw new Error("not possible")}}if(me&&ie(be,we,Te,ye),!it[0]&&!ve.firstMatchCanBeWeak)return;Je--,Ge--;const lt=[ne[Je][Ge],ye];let rt=0,nt=0;for(;Je>=1;){let et=Ge;do{const Xe=re[Je][et];if(Xe===he.LeftLeft)et=et-2;else if(Xe===he.Left)et=et-1;else break}while(et>=1);rt>1&&pe[we+Je-1]===ce[ye+Ge-1]&&!T(et+ye-1,Te,ce)&&rt+1>V[Je][et]&&(et=Ge),et===Ge?rt++:rt=1,nt||(nt=et),Je--,Ge=et-1,lt.push(Ge)}qe-ye===ze&&ve.boostFullMatch&&(lt[0]+=2);const tt=nt-ze;return lt[0]-=tt,lt}function F(be,pe,we,Te,ce,ye){let ve=be-1,ze=pe-1;for(;ve>=we&&ze>=Te;)ce[ve]===ye[ze]&&(M[ve]=ze,ve--),ze--}function W(be,pe,we,Te,ce,ye,ve,ze,qe,Je,Ge){if(pe[we]!==ye[ve])return Number.MIN_SAFE_INTEGER;let Ze=1,Ye=!1;return ve===we-Te?Ze=be[we]===ce[ve]?7:5:T(ve,ce,ye)&&(ve===0||!T(ve-1,ce,ye))?(Ze=be[we]===ce[ve]?7:5,Ye=!0):x(ye,ve)&&(ve===0||!x(ye,ve-1))?Ze=5:(x(ye,ve-1)||G(ye,ve-1))&&(Ze=5,Ye=!0),Ze>1&&we===Te&&(Ge[0]=!0),Ye||(Ye=T(ve,ce,ye)||x(ye,ve-1)||G(ye,ve-1)),we===Te?ve>qe&&(Ze-=Ye?3:5):Je?Ze+=Ye?2:0:Ze+=Ye?0:1,ve+1===ze&&(Ze-=Ye?3:5),Ze}function Y(be,pe,we,Te,ce,ye,ve){return Ee(be,pe,we,Te,ce,ye,!0,ve)}function ae(be,pe,we,Te,ce,ye,ve){return Ee(be,pe,we,Te,ce,ye,!1,ve)}function Ee(be,pe,we,Te,ce,ye,ve,ze){let qe=H(be,pe,we,Te,ce,ye,ze);if(qe&&!ve)return qe;if(be.length>=3){const Je=Math.min(7,be.length-1);for(let Ge=we+1;Ge<Je;Ge++){const Ze=Le(be,Ge);if(Ze){const Ye=H(Ze,Ze.toLowerCase(),we,Te,ce,ye,ze);Ye&&(Ye[0]-=3,(!qe||Ye[0]>qe[0])&&(qe=Ye))}}}return qe}function Le(be,pe){if(pe+1>=be.length)return;const we=be[pe],Te=be[pe+1];if(we!==Te)return be.slice(0,pe)+Te+we+be.slice(pe+2)}}),define(Re[67],Ae([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=s,e.$uj=E,e.$vj=k,e.$wj=A,e.$yj=u,t=Ue(t);function s(f){return E(f,0)}function E(f,v){switch(typeof f){case"object":return f===null?k(349,v):Array.isArray(f)?y(f,v):o(f,v);case"string":return A(f,v);case"boolean":return C(f,v);case"number":return k(f,v);case"undefined":return k(937,v);default:return k(617,v)}}function k(f,v){return(v<<5)-v+f|0}function C(f,v){return k(f?433:863,v)}function A(f,v){v=k(149417,v);for(let g=0,b=f.length;g<b;g++)v=k(f.charCodeAt(g),v);return v}function y(f,v){return v=k(104579,v),f.reduce((g,b)=>E(b,g),v)}function o(f,v){return v=k(181387,v),Object.keys(f).sort().reduce((g,b)=>(g=A(b,g),E(f[b],g)),v)}class D{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=E(v,this.g),this.g}}e.$xj=D;var w;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(f,v,g=32){const b=g-v,i=~((1<<b)-1);return(f<<v|(i&f)>>>b)>>>0}function $(f,v=0,g=f.byteLength,b=0){for(let i=0;i<g;i++)f[v+i]=b}function a(f,v,g="0"){for(;f.length<v;)f=g+f;return f}function u(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(g=>g.toString(16).padStart(2,"0")).join(""):a((f>>>0).toString(16),v/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(w.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const g=v.length;if(g===0)return;const b=this.p;let i=this.r,p=this.u,n,l;for(p!==0?(n=p,l=-1,p=0):(n=v.charCodeAt(0),l=0);;){let r=n;if(t.$Jf(n))if(l+1<g){const h=v.charCodeAt(l+1);t.$Kf(h)?(l++,r=t.$Lf(n,h)):r=w.UNICODE_REPLACEMENT}else{p=n;break}else t.$Kf(n)&&(r=w.UNICODE_REPLACEMENT);if(i=this.w(b,i,r),l++,l<g)n=v.charCodeAt(l);else break}this.r=i,this.u=p}w(v,g,b){return b<128?v[g++]=b:b<2048?(v[g++]=192|(b&1984)>>>6,v[g++]=128|(b&63)>>>0):b<65536?(v[g++]=224|(b&61440)>>>12,v[g++]=128|(b&4032)>>>6,v[g++]=128|(b&63)>>>0):(v[g++]=240|(b&1835008)>>>18,v[g++]=128|(b&258048)>>>12,v[g++]=128|(b&4032)>>>6,v[g++]=128|(b&63)>>>0),g>=w.BLOCK_SIZE&&(this.y(),g-=w.BLOCK_SIZE,this.t+=w.BLOCK_SIZE,v[0]=v[w.BLOCK_SIZE+0],v[1]=v[w.BLOCK_SIZE+1],v[2]=v[w.BLOCK_SIZE+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,w.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=d.g,g=this.q;for(let S=0;S<64;S+=4)v.setUint32(S,g.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)v.setUint32(S,m(v.getUint32(S-12,!1)^v.getUint32(S-32,!1)^v.getUint32(S-56,!1)^v.getUint32(S-64,!1),1),!1);let b=this.h,i=this.l,p=this.m,n=this.n,l=this.o,r,h,c;for(let S=0;S<80;S++)S<20?(r=i&p|~i&n,h=1518500249):S<40?(r=i^p^n,h=1859775393):S<60?(r=i&p|i&n|p&n,h=2400959708):(r=i^p^n,h=3395469782),c=m(b,5)+r+l+h+v.getUint32(S*4,!1)&4294967295,l=n,n=p,p=m(i,30),i=b,b=c;this.h=this.h+b&4294967295,this.l=this.l+i&4294967295,this.m=this.m+p&4294967295,this.n=this.n+n&4294967295,this.o=this.o+l&4294967295}}e.$zj=d}),define(Re[174],Ae([1,0,173,16,81]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=y,e.$Yk=D,e.$Zk=m,e.$1k=$,e.$2k=u,e.$3k=d;const k="$(",C=new RegExp(`\\$\\(${E.ThemeIcon.iconNameExpression}(?:${E.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function y(f){return f.replace(A,(v,g)=>g?v:`\\${v}`)}const o=new RegExp(`\\\\${C.source}`,"g");function D(f){return f.replace(o,v=>`\\${v}`)}const w=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function m(f){return f.indexOf(k)===-1?f:f.replace(w,(v,g,b,i)=>b?v:g||i||"")}function $(f){return f?f.replace(/\$\((.*?)\)/g,(v,g)=>` ${g} `).trim():""}const a=new RegExp(`\\$\\(${E.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(f){a.lastIndex=0;let v="";const g=[];let b=0;for(;;){const i=a.lastIndex,p=a.exec(f),n=f.substring(i,p?.index);if(n.length>0){v+=n;for(let l=0;l<n.length;l++)g.push(b)}if(!p)break;b+=p[0].length}return{text:v,iconOffsets:g}}function d(f,v,g=!1){const{text:b,iconOffsets:i}=v;if(!i||i.length===0)return(0,t.$Ok)(f,b,g);const p=(0,s.$mf)(b," "),n=b.length-p.length,l=(0,t.$Ok)(f,p,g);if(l)for(const r of l){const h=i[r.start+n]+n;r.start+=h,r.end+=h}return l}}),define(Re[57],Ae([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),t=Ue(t);var s;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(s||(s={})),function(E){const k="error",C="warning",A="warn",y="info",o="ignore";function D(m){return m?t.$Ff(k,m)?E.Error:t.$Ff(C,m)||t.$Ff(A,m)?E.Warning:t.$Ff(y,m)?E.Info:E.Ignore:E.Ignore}E.fromValue=D;function w(m){switch(m){case E.Error:return k;case E.Warning:return C;case E.Info:return y;default:return o}}E.toString=w}(s||(s={})),e.default=s}),define(Re[68],Ae([1,0,17,34,16]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class k{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const u=a.charCodeAt(0),d=this.b.charCodeAt(this.c);return u-d}value(){return this.b[this.c]}}e.$Hi=k;class C{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===s.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,E.$zf)(a,this.b,0,a.length,this.c,this.d):(0,E.$Bf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=C;class A{constructor(a=!0,u=!0){this.f=a,this.g=u}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let u=a.length-1;u>=0;u--,this.c--){const d=this.b.charCodeAt(u);if(!(d===s.CharCode.Slash||this.f&&d===s.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===s.CharCode.Slash||this.f&&u===s.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,E.$zf)(a,this.b,0,a.length,this.d,this.e):(0,E.$Bf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=A;var y;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(y||(y={}));class o{constructor(a,u){this.f=a,this.g=u,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new A(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(y.Path)),this.g(a)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===y.Scheme)return(0,E.$Af)(a,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,E.$Af)(a,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(a);if(this.d[this.e]===y.Query)return(0,E.$yf)(a,this.c.query);if(this.d[this.e]===y.Fragment)return(0,E.$yf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}e.$Ki=o;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(w||(w={}));class m{static forUris(a=()=>!1,u=()=>!1){return new m(new o(a,u))}static forPaths(a=!1){return new m(new A(void 0,!a))}static forStrings(){return new m(new k)}static forConfigKeys(){return new m(new C)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,u){if(u){const d=u.slice(0);(0,t.$Vb)(d);for(const f of d)this.set(f,a)}else{const d=a.slice(0);(0,t.$Vb)(d);for(const f of d)this.set(f[0],f[1])}}set(a,u){const d=this.b.reset(a);let f;this.c||(this.c=new D,this.c.segment=d.value());const v=[];for(f=this.c;;){const b=d.cmp(f.segment);if(b>0)f.left||(f.left=new D,f.left.segment=d.value()),v.push([w.Left,f]),f=f.left;else if(b<0)f.right||(f.right=new D,f.right.segment=d.value()),v.push([w.Right,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new D,f.mid.segment=d.value()),v.push([w.Mid,f]),f=f.mid;else break}const g=f.value;f.value=u,f.key=a;for(let b=v.length-1;b>=0;b--){const i=v[b][1];i.updateHeight();const p=i.balanceFactor();if(p<-1||p>1){const n=v[b][0],l=v[b+1][0];if(n===w.Right&&l===w.Right)v[b][1]=i.rotateLeft();else if(n===w.Left&&l===w.Left)v[b][1]=i.rotateRight();else if(n===w.Right&&l===w.Left)i.right=v[b+1][1]=v[b+1][1].rotateRight(),v[b][1]=i.rotateLeft();else if(n===w.Left&&l===w.Right)i.left=v[b+1][1]=v[b+1][1].rotateLeft(),v[b][1]=i.rotateRight();else throw new Error;if(b>0)switch(v[b-1][0]){case w.Left:v[b-1][1].left=v[b][1];break;case w.Right:v[b-1][1].right=v[b][1];break;case w.Mid:v[b-1][1].mid=v[b][1];break}else this.c=v[0][1]}}return g}get(a){return this.d(a)?.value}d(a){const u=this.b.reset(a);let d=this.c;for(;d;){const f=u.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(u.hasNext())u.next(),d=d.mid;else break}return d}has(a){const u=this.d(a);return!(u?.value===void 0&&u?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,u){const d=this.b.reset(a),f=[];let v=this.c;for(;v;){const g=d.cmp(v.segment);if(g>0)f.push([w.Left,v]),v=v.left;else if(g<0)f.push([w.Right,v]),v=v.right;else if(d.hasNext())d.next(),f.push([w.Mid,v]),v=v.mid;else break}if(v){if(u?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const g=this.f(v.right);if(g.key){const{key:b,value:i,segment:p}=g;this.e(g.key,!1),v.key=b,v.value=i,v.segment=p}}else{const g=v.left??v.right;if(f.length>0){const[b,i]=f[f.length-1];switch(b){case w.Left:i.left=g;break;case w.Mid:i.mid=g;break;case w.Right:i.right=g;break}}else this.c=g}for(let g=f.length-1;g>=0;g--){const b=f[g][1];b.updateHeight();const i=b.balanceFactor();if(i>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),f[g][1]=b.rotateLeft()):i<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),f[g][1]=b.rotateRight()),g>0)switch(f[g-1][0]){case w.Left:f[g-1][1].left=f[g][1];break;case w.Right:f[g-1][1].right=f[g][1];break;case w.Mid:f[g-1][1].mid=f[g][1];break}else this.c=f[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const u=this.b.reset(a);let d=this.c,f;for(;d;){const v=u.cmp(d.segment);if(v>0)d=d.left;else if(v<0)d=d.right;else if(u.hasNext())u.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(a){return this.g(a,!1)}g(a,u){const d=this.b.reset(a);let f=this.c;for(;f;){const v=d.cmp(f.segment);if(v>0)f=f.left;else if(v<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this.h(f.mid):u?f.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[u,d]of this)a(d,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const u=[];return this.j(a,u),u[Symbol.iterator]()}j(a,u){a&&(a.left&&this.j(a.left,u),a.value&&u.push([a.key,a.value]),a.mid&&this.j(a.mid,u),a.right&&this.j(a.right,u))}_isBalanced(){const a=u=>{if(!u)return!0;const d=u.balanceFactor();return d<-1||d>1?!1:a(u.left)&&a(u.right)};return a(this.c)}}e.$Li=m}),define(Re[4],Ae([1,0,34,80,8,3]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=d,e.$wc=p,E=Ue(E);const C=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function o(c,S){if(!c.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!C.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(c,S){return!c&&!S?"file":c}function w(c,S){switch(c){case"https":case"http":case"file":S?S[0]!==$&&(S=$+S):S=$;break}return S}const m="",$="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(S){return S instanceof u?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,I,R,L,O,P=!1){typeof S=="object"?(this.scheme=S.scheme||m,this.authority=S.authority||m,this.path=S.path||m,this.query=S.query||m,this.fragment=S.fragment||m):(this.scheme=D(S,P),this.authority=I||m,this.path=w(this.scheme,R||m),this.query=L||m,this.fragment=O||m,o(this,P))}get fsPath(){return p(this,!1)}with(S){if(!S)return this;let{scheme:I,authority:R,path:L,query:O,fragment:P}=S;return I===void 0?I=this.scheme:I===null&&(I=m),R===void 0?R=this.authority:R===null&&(R=m),L===void 0?L=this.path:L===null&&(L=m),O===void 0?O=this.query:O===null&&(O=m),P===void 0?P=this.fragment:P===null&&(P=m),I===this.scheme&&R===this.authority&&L===this.path&&O===this.query&&P===this.fragment?this:new v(I,R,L,O,P)}static parse(S,I=!1){const R=a.exec(S);return R?new v(R[2]||m,h(R[4]||m),h(R[5]||m),h(R[7]||m),h(R[9]||m),I):new v(m,m,m,m,m)}static file(S){let I=m;if(k.$j&&(S=S.replace(/\\/g,$)),S[0]===$&&S[1]===$){const R=S.indexOf($,2);R===-1?(I=S.substring(2),S=$):(I=S.substring(2,R),S=S.substring(R)||$)}return new v("file",I,S,m,m)}static from(S,I){return new v(S.scheme,S.authority,S.path,S.query,S.fragment,I)}static joinPath(S,...I){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return k.$j&&S.scheme==="file"?R=u.file(E.$fc.join(p(S,!0),...I)).path:R=E.$gc.join(S.path,...I),S.with({path:R})}toString(S=!1){return n(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof u)return S;{const I=new v(S);return I._formatted=S.external??null,I._fsPath=S._sep===f?S.fsPath??null:null,I}}else return S}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=u;function d(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const f=k.$j?1:void 0;class v extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(S=!1){return S?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const S={$mid:s.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=f),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const g={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function b(c,S,I){let R,L=-1;for(let O=0;O<c.length;O++){const P=c.charCodeAt(O);if(P>=t.CharCode.a&&P<=t.CharCode.z||P>=t.CharCode.A&&P<=t.CharCode.Z||P>=t.CharCode.Digit0&&P<=t.CharCode.Digit9||P===t.CharCode.Dash||P===t.CharCode.Period||P===t.CharCode.Underline||P===t.CharCode.Tilde||S&&P===t.CharCode.Slash||I&&P===t.CharCode.OpenSquareBracket||I&&P===t.CharCode.CloseSquareBracket||I&&P===t.CharCode.Colon)L!==-1&&(R+=encodeURIComponent(c.substring(L,O)),L=-1),R!==void 0&&(R+=c.charAt(O));else{R===void 0&&(R=c.substr(0,O));const q=g[P];q!==void 0?(L!==-1&&(R+=encodeURIComponent(c.substring(L,O)),L=-1),R+=q):L===-1&&(L=O)}}return L!==-1&&(R+=encodeURIComponent(c.substring(L))),R!==void 0?R:c}function i(c){let S;for(let I=0;I<c.length;I++){const R=c.charCodeAt(I);R===t.CharCode.Hash||R===t.CharCode.QuestionMark?(S===void 0&&(S=c.substr(0,I)),S+=g[R]):S!==void 0&&(S+=c[I])}return S!==void 0?S:c}function p(c,S){let I;return c.authority&&c.path.length>1&&c.scheme==="file"?I=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===t.CharCode.Slash&&(c.path.charCodeAt(1)>=t.CharCode.A&&c.path.charCodeAt(1)<=t.CharCode.Z||c.path.charCodeAt(1)>=t.CharCode.a&&c.path.charCodeAt(1)<=t.CharCode.z)&&c.path.charCodeAt(2)===t.CharCode.Colon?S?I=c.path.substr(1):I=c.path[1].toLowerCase()+c.path.substr(2):I=c.path,k.$j&&(I=I.replace(/\//g,"\\")),I}function n(c,S){const I=S?i:b;let R="",{scheme:L,authority:O,path:P,query:q,fragment:K}=c;if(L&&(R+=L,R+=":"),(O||L==="file")&&(R+=$,R+=$),O){let J=O.indexOf("@");if(J!==-1){const _=O.substr(0,J);O=O.substr(J+1),J=_.lastIndexOf(":"),J===-1?R+=I(_,!1,!1):(R+=I(_.substr(0,J),!1,!1),R+=":",R+=I(_.substr(J+1),!1,!0)),R+="@"}O=O.toLowerCase(),J=O.lastIndexOf(":"),J===-1?R+=I(O,!1,!0):(R+=I(O.substr(0,J),!1,!0),R+=O.substr(J))}if(P){if(P.length>=3&&P.charCodeAt(0)===t.CharCode.Slash&&P.charCodeAt(2)===t.CharCode.Colon){const J=P.charCodeAt(1);J>=t.CharCode.A&&J<=t.CharCode.Z&&(P=`/${String.fromCharCode(J+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===t.CharCode.Colon){const J=P.charCodeAt(0);J>=t.CharCode.A&&J<=t.CharCode.Z&&(P=`${String.fromCharCode(J+32)}:${P.substr(2)}`)}R+=I(P,!0,!1)}return q&&(R+="?",R+=I(q,!1,!1)),K&&(R+="#",R+=S?K:b(K,!1,!1)),R}function l(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+l(c.substr(3)):c}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(c){return c.match(r)?c.replace(r,S=>l(S)):c}}),define(Re[175],Ae([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=s,e.$er=E,e.$fr=k,e.log=A;function s(o){const D=o;return D&&typeof D.type=="string"&&typeof D.severity=="string"}function E(o){const D=[];let w;try{const m=JSON.parse(o.arguments),$=m[m.length-1];$&&$.__$stack&&(m.pop(),w=$.__$stack),D.push(...m)}catch{D.push("Unable to log remote console arguments",o.arguments)}return{args:D,stack:w}}function k(o){if(typeof o!="string")return k(E(o).stack);const D=o;if(D){const w=C(D),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:t.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function C(o){if(!o)return o;const D=o.indexOf(`
`);return D===-1?o:o.substring(0,D)}function A(o,D){const{args:w,stack:m}=E(o),$=typeof w[0]=="string"&&w.length===1;let a=C(m);a&&(a=`(${a.trim()})`);let u=[];if(typeof w[0]=="string"?a&&$?u=[`%c[${D}] %c${w[0]} %c${a}`,y("blue"),y(""),y("grey")]:u=[`%c[${D}] %c${w[0]}`,y("blue"),y(""),...w.slice(1)]:u=[`%c[${D}]%`,y("blue"),...w],a&&!$&&u.push(a),typeof console[o.severity]!="function")throw new Error("Unknown console method");console[o.severity].apply(console,u)}function y(o){return`color: ${o}`}}),define(Re[48],Ae([1,0,14,4,80]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=k,e.$bi=C,e.$ci=y;function k(o){return JSON.stringify(o,A)}function C(o){let D=JSON.parse(o);return D=y(D),D}function A(o,D){return D instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:D.source,flags:D.flags}:D}function y(o,D=0){if(!o||D>200)return o;if(typeof o=="object"){switch(o.$mid){case E.MarshalledId.Uri:return s.URI.revive(o);case E.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case E.MarshalledId.Date:return new Date(o.source)}if(o instanceof t.$Ne||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let w=0;w<o.length;++w)o[w]=y(o[w],D+1);else for(const w in o)Object.hasOwnProperty.call(o,w)&&(o[w]=y(o[w],D+1))}return o}}),define(Re[12],Ae([1,0,9,3,16,4,8]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=y,e.$Pg=o,e.$Tg=w,t=Ue(t),s=Ue(s),C=Ue(C);var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(A||(e.Schemas=A={}));function y(a,u){return k.URI.isUri(a)?(0,E.$Ff)(a.scheme,u):(0,E.$Gf)(a,u+":")}function o(a,...u){return u.some(d=>y(a,d))}e.$Qg="vscode-tkn",e.$Rg="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u,d){this.f=w(u,d)}getServerRootPath(){return this.f}get g(){return C.$gc.join(this.f,A.vscodeRemoteResource)}set(u,d,f){this.a[u]=d,this.b[u]=f}setConnectionToken(u,d){this.c[u]=d}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(i){return t.$Y(i),u}const d=u.authority;let f=this.a[d];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const v=this.b[d],g=this.c[d];let b=`path=${encodeURIComponent(u.path)}`;return typeof g=="string"&&(b+=`&${e.$Rg}=${encodeURIComponent(g)}`),k.URI.from({scheme:s.$p?this.d:A.vscodeRemoteResource,authority:`${f}:${v}`,path:this.g,query:b})}}e.$Sg=new D;function w(a,u){return C.$gc.join(u??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class m{static{this.a=e.$Yg}asBrowserUri(u){const d=this.b(u,ue);return this.uriToBrowserUri(d)}uriToBrowserUri(u){return u.scheme===A.vscodeRemote?e.$Sg.rewrite(u):u.scheme===A.file&&(s.$n||s.$r===`${A.vscodeFileResource}://${m.a}`)?u.with({scheme:A.vscodeFileResource,authority:u.authority||m.a,query:null,fragment:null}):u}asFileUri(u){const d=this.b(u,ue);return this.uriToFileUri(d)}uriToFileUri(u){return u.scheme===A.vscodeFileResource?u.with({scheme:A.file,authority:u.authority!==m.a?u.authority:null,query:null,fragment:null}):u}b(u,d){return k.URI.isUri(u)?u:k.URI.parse(d.toUrl(u))}}e.$Zg=new m;var $;(function(a){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(u.get("3"));const d="vscode-coi";function f(g){let b;typeof g=="string"?b=new URL(g).searchParams:g instanceof URL?b=g.searchParams:k.URI.isUri(g)&&(b=new URL(g.toString(!0)).searchParams);const i=b?.get(d);if(i)return u.get(i)}a.getHeadersFromQuery=f;function v(g,b,i){if(!globalThis.crossOriginIsolated)return;const p=b&&i?"3":i?"2":"1";g instanceof URLSearchParams?g.set(d,p):g[d]=p}a.addSearchParam=v})($||(e.COI=$={}))}),define(Re[176],Ae([1,0,103,12,3,10,4]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CE=w,e.$DE=m,E=Ue(E);class A{constructor(a,u,d){this.id=a,this.dependencies=u,this.callback=d}}class y{static{this.INSTANCE=new y}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(a,u,d)=>{typeof a!="string"&&(d=u,u=a,a=null),(typeof u!="object"||!Array.isArray(u))&&(d=u,u=null),this.c.push(new A(a,u,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(a){if(a.startsWith(window.location.origin)||a.startsWith("vscode-file://vscode-app"))return a;throw new Error(`[trusted_script_src] Invalid script url: ${a}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(a){return a}})))}async load(a){this.g();const u=await(this.a?this.i(a):this.b?this.h(a):this.j(a));if(!u)throw new Error(`Did not receive a define call from script ${a}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${a}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(a){return new Promise((u,d)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const v=()=>{f.removeEventListener("load",g),f.removeEventListener("error",b)},g=i=>{v(),u(this.c.pop())},b=i=>{v(),d(i)};f.addEventListener("load",g),f.addEventListener("error",b),this.f&&(a=this.f.createScriptURL(a)),f.setAttribute("src",a),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(a){return new Promise((u,d)=>{try{this.f&&(a=this.f.createScriptURL(a)),importScripts(a),u(this.c.pop())}catch(f){d(f)}})}async j(a){try{const u=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,v=C.URI.parse(a).fsPath,g=u.readFileSync(v).toString(),b=f.wrap(g.replace(/^#!.*/,""));return new d.Script(b).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const o=new Map;let D={};typeof globalThis.require=="object"&&(D=globalThis.require.paths??{});async function w($,a,u){if(t.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),D[$]&&($=D[$]);const d=a?`${$}/${a}`:$;if(o.has(d))return o.get(d);let f;if(/^\w[\w\d+.-]*:\/\//.test(d))f=d;else{const i=`${u&&!E.$p?s.$Wg:s.$Vg}/${d}`;f=s.$Zg.asBrowserUri(i).toString(!0)}const v=y.INSTANCE.load(f);return o.set(d,v),v}else return await new Promise((d,f)=>{ue([$],d,f)}).then(Ue)}function m($,a){(0,k.$og)(t.$R);const f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!E.$p,v=`${$}/${a}`,b=`${f?s.$Wg:s.$Vg}/${v}`;return s.$Zg.asBrowserUri(b).toString(!0)}}),define(Re[19],Ae([1,0,34,36,12,8,3,16,4]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=o,e.$ph=w,e.$qh=$,s=Ue(s),k=Ue(k);function o(a){return(0,y.$wc)(a,!0)}class D{constructor(u){this.a=u}compare(u,d,f=!1){return u===d?0:(0,A.$yf)(this.getComparisonKey(u,f),this.getComparisonKey(d,f))}isEqual(u,d,f=!1){return u===d?!0:!u||!d?!1:this.getComparisonKey(u,f)===this.getComparisonKey(d,f)}getComparisonKey(u,d=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,d,f=!1){if(u.scheme===d.scheme){if(u.scheme===E.Schemas.file)return s.$Eg(o(u),o(d),this.a(u))&&u.query===d.query&&(f||u.fragment===d.fragment);if((0,e.$lh)(u.authority,d.authority))return s.$Eg(u.path,d.path,this.a(u),"/")&&u.query===d.query&&(f||u.fragment===d.fragment)}return!1}joinPath(u,...d){return y.URI.joinPath(u,...d)}basenameOrAuthority(u){return(0,e.$dh)(u)||u.authority}basename(u){return k.$gc.basename(u.path)}extname(u){return k.$gc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let d;return u.scheme===E.Schemas.file?d=y.URI.file(k.$mc(o(u))).path:(d=k.$gc.dirname(u.path),u.authority&&d.length&&d.charCodeAt(0)!==t.CharCode.Slash&&(console.error(`dirname("${u.toString})) resulted in a relative path`),d="/")),u.with({path:d})}normalizePath(u){if(!u.path.length)return u;let d;return u.scheme===E.Schemas.file?d=y.URI.file(k.$hc(o(u))).path:d=k.$gc.normalize(u.path),u.with({path:d})}relativePath(u,d){if(u.scheme!==d.scheme||!(0,e.$lh)(u.authority,d.authority))return;if(u.scheme===E.Schemas.file){const g=k.$lc(o(u),o(d));return C.$j?s.$yg(g):g}let f=u.path||"/";const v=d.path||"/";if(this.a(u)){let g=0;for(const b=Math.min(f.length,v.length);g<b&&!(f.charCodeAt(g)!==v.charCodeAt(g)&&f.charAt(g).toLowerCase()!==v.charAt(g).toLowerCase());g++);f=v.substr(0,g)+f.substr(g)}return k.$gc.relative(f,v)}resolvePath(u,d){if(u.scheme===E.Schemas.file){const f=y.URI.file(k.$kc(o(u),d));return u.with({authority:f.authority,path:f.path})}return d=s.$zg(d),u.with({path:k.$gc.resolve(u.path,d)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,d){return u===d||u!==void 0&&d!==void 0&&(0,A.$Ff)(u,d)}hasTrailingPathSeparator(u,d=k.sep){if(u.scheme===E.Schemas.file){const f=o(u);return f.length>s.$Ag(f).length&&f[f.length-1]===d}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===t.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,d=k.sep){return(0,e.$mh)(u,d)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,d=k.sep){let f=!1;if(u.scheme===E.Schemas.file){const v=o(u);f=v!==void 0&&v.length===s.$Ag(v).length&&v[v.length-1]===d}else{d="/";const v=u.path;f=v.length===1&&v.charCodeAt(v.length-1)===t.CharCode.Slash}return!f&&!(0,e.$mh)(u,d)?u.with({path:u.path+"/"}):u}}e.$8g=D,e.$9g=new D(()=>!1),e.$0g=new D(a=>a.scheme===E.Schemas.file?!C.$l:!0),e.$$g=new D(a=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function w(a,u){const d=[];for(let f=0;f<a.length;f++){const v=u(a[f]);a.some((g,b)=>b===f?!1:(0,e.$ah)(v,u(g)))||d.push(a[f])}return d}var m;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function u(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(b=>{const[i,p]=b.split(":");i&&p&&f.set(i,p)});const g=d.path.substring(0,d.path.indexOf(";"));return g&&f.set(a.META_DATA_MIME,g),f}a.parseMetaData=u})(m||(e.DataUri=m={}));function $(a,u,d){if(u){let f=a.path;return f&&f[0]!==k.$gc.sep&&(f=k.$gc.sep+f),a.with({scheme:d,authority:u,path:f})}return a.with({scheme:d})}}),define(Re[13],Ae([1,0,18,9,6,2,19,3,171,64]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=D,e.$sh=w,e.$th=m,e.$uh=$,e.$vh=a,e.$wh=u,e.$xh=d,e.$yh=f,e.$Gh=c,e.$Hh=S,e.$Ih=I,e.$Jh=R,e.$Kh=L,e.$Zh=V,e.$8h=B;function D(H){return!!H&&typeof H.then=="function"}function w(H){const F=new t.$we,W=H(F.token),Y=new Promise((ae,Ee)=>{const Le=F.token.onCancellationRequested(()=>{Le.dispose(),Ee(new s.$4)});Promise.resolve(W).then(be=>{Le.dispose(),F.dispose(),ae(be)},be=>{Le.dispose(),F.dispose(),Ee(be)})});return new class{cancel(){F.cancel(),F.dispose()}then(ae,Ee){return Y.then(ae,Ee)}catch(ae){return this.then(void 0,ae)}finally(ae){return Y.finally(ae)}}}function m(H,F,W){return new Promise((Y,ae)=>{const Ee=F.onCancellationRequested(()=>{Ee.dispose(),Y(W)});H.then(Y,ae).finally(()=>Ee.dispose())})}function $(H,F){return new Promise((W,Y)=>{const ae=F.onCancellationRequested(()=>{ae.dispose(),Y(new s.$4)});H.then(W,Y).finally(()=>ae.dispose())})}async function a(H){let F=-1;const W=H.map((Y,ae)=>Y.then(Ee=>(F=ae,Ee)));try{return await Promise.race(W)}finally{H.forEach((Y,ae)=>{ae!==F&&Y.cancel()})}}function u(H,F,W){let Y;const ae=setTimeout(()=>{Y?.(void 0),W?.()},F);return Promise.race([H.finally(()=>clearTimeout(ae)),new Promise(Ee=>Y=Ee)])}function d(H){return new Promise((F,W)=>{const Y=H();D(Y)?Y.then(F,W):F(Y)})}function f(){let H,F;return{promise:new Promise((Y,ae)=>{H=Y,F=ae}),resolve:H,reject:F}}class v{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=F,!this.b){const W=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(W,W).then(Y)})}return new Promise((W,Y)=>{this.b.then(W,Y)})}return this.a=F(),new Promise((W,Y)=>{this.a.then(ae=>{this.a=null,W(ae)},ae=>{this.a=null,Y(ae)})})}dispose(){this.f=!0}}e.$zh=v;class g{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$Ah=g;class b{constructor(){this.a=new Map}queue(F,W){const ae=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(F)===ae&&this.a.delete(F)});return this.a.set(F,ae),ae}}e.$Bh=b;const i=(H,F)=>{let W=!0;const Y=setTimeout(()=>{W=!1,F()},H);return{isTriggered:()=>W,dispose:()=>{clearTimeout(Y),W=!1}}},p=H=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,H())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class n{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,W=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((ae,Ee)=>{this.d=ae,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=W===y.$ge?p(Y):i(W,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new s.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=n;class l{constructor(F){this.a=new n(F),this.b=new v}trigger(F,W){return this.a.trigger(()=>this.b.queue(F),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=l;class r{constructor(){this.a=!1,this.b=new Promise((F,W)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=r;class h extends r{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$Fh=h;function c(H,F){return F?new Promise((W,Y)=>{const ae=setTimeout(()=>{Ee.dispose(),W()},H),Ee=F.onCancellationRequested(()=>{clearTimeout(ae),Ee.dispose(),Y(new s.$4)})}):w(W=>c(H,W))}function S(H,F=0,W){const Y=setTimeout(()=>{H(),W&&ae.dispose()},F),ae=(0,k.$Sc)(()=>{clearTimeout(Y),W?.deleteAndLeak(ae)});return W?.add(ae),ae}function I(H){const F=[];let W=0;const Y=H.length;function ae(){return W<Y?H[W++]():null}function Ee(Le){Le!=null&&F.push(Le);const be=ae();return be?be.then(Ee):Promise.resolve(F)}return Promise.resolve(null).then(Ee)}function R(H,F=Y=>!!Y,W=null){let Y=0;const ae=H.length,Ee=()=>{if(Y>=ae)return Promise.resolve(W);const Le=H[Y++];return Promise.resolve(Le()).then(pe=>F(pe)?Promise.resolve(pe):Ee())};return Ee()}function L(H,F=Y=>!!Y,W=null){if(H.length===0)return Promise.resolve(W);let Y=H.length;const ae=()=>{Y=-1;for(const Ee of H)Ee.cancel?.()};return new Promise((Ee,Le)=>{for(const be of H)be.then(pe=>{--Y>=0&&F(pe)?(ae(),Ee(pe)):Y===0&&Ee(W)}).catch(pe=>{--Y>=0&&(ae(),Le(pe))})})}class O{constructor(F){this.a=0,this.b=!1,this.f=F,this.g=[],this.d=0,this.h=new E.$le}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(F){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((W,Y)=>{this.g.push({factory:F,c:W,e:Y}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const F=this.g.shift();this.d++;const W=F.factory();W.then(F.c,F.e),W.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=O;class P extends O{constructor(){super(1)}}e.$Mh=P;class q{constructor(){this.a=new ne,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$Nh=q;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const F=new oe;return this.b.add(F),F.p}g(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueSize(F,W=C.$9g){const Y=W.getComparisonKey(F);return this.a.get(Y)?.size??0}queueFor(F,W,Y=C.$9g){const ae=Y.getComparisonKey(F);let Ee=this.a.get(ae);if(!Ee){Ee=new P;const Le=this.f++,be=E.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(Le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$4c),this.d.set(Le,be),this.a.set(ae,Ee)}return Ee.queue(W)}h(){this.g()&&this.j()}j(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=K;class J{constructor(F,W){this.b=!1,this.a=-1,typeof F=="function"&&typeof W=="number"&&this.setIfNotSet(F,W)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,W){if(this.b)throw new s.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},W)}setIfNotSet(F,W){if(this.b)throw new s.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},W))}}e.$Ph=J;class _{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(F,W,Y=globalThis){if(this.f)throw new s.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ae=Y.setInterval(()=>{F()},W);this.d=(0,k.$Sc)(()=>{Y.clearInterval(ae),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=_;class de{constructor(F,W){this.b=-1,this.a=F,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=de;class ge{constructor(F,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=F,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=ge;class le extends de{constructor(F,W){super(F,W),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$Th=le;class z extends k.$Uc{constructor(F,W){super(),this.g=F,this.h=W,this.a=[],this.b=this.B(new k.$Vc),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of F)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(H,F)=>{(0,A.$C)(()=>{if(W)return;const Y=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$Wh=(H,F,W)=>{const Y=H.requestIdleCallback(F,typeof W=="number"?{timeout:W}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,H.cancelIdleCallback(Y))}}},e.$Vh=H=>(0,e.$Wh)(globalThis,H)}();class Q{constructor(F,W){this.g=!1,this.d=()=>{try{this.j=W()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$Wh)(F,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=Q;class M extends Q{constructor(F){super(globalThis,F)}}e.$Yh=M;async function V(H,F,W){let Y;for(let ae=0;ae<W;ae++)try{return await H()}catch(Ee){Y=Ee,await c(F)}throw Y}class ne{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,W,Y){return this.a={taskId:F,cancel:()=>Y?.(),promise:W},W.then(()=>this.d(F),()=>this.d(F)),W}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{const{promise:W,resolve:Y,reject:ae}=f();this.b={run:F,promise:W,promiseResolve:Y,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=ne;class re{constructor(F,W=()=>Date.now()){this.d=F,this.f=W,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$2h=re;var me;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(me||(me={}));class oe{get isRejected(){return this.d?.outcome===me.Rejected}get isResolved(){return this.d?.outcome===me.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===me.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((F,W)=>{this.a=F,this.b=W})}complete(F){return new Promise(W=>{this.a(F),this.d={outcome:me.Resolved,value:F},W()})}error(F){return new Promise(W=>{this.b(F),this.d={outcome:me.Rejected,value:F},W()})}cancel(){return this.error(new s.$4)}}e.$3h=oe;var ie;(function(H){async function F(Y){let ae;const Ee=await Promise.all(Y.map(Le=>Le.then(be=>be,be=>{ae||(ae=be)})));if(typeof ae<"u")throw ae;return Ee}H.settled=F;function W(Y){return new Promise(async(ae,Ee)=>{try{await Y(ae,Ee)}catch(Le){Ee(Le)}})}H.withAsyncBody=W})(ie||(e.Promises=ie={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(F){this.a=void 0,this.b=void 0,this.d=!1,this.promise=F.then(W=>(this.a=W,this.d=!0,W),W=>{throw this.b=W,this.d=!0,W})}requireValue(){if(!this.d)throw new s.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=x;class G{constructor(F){this.b=F,this.a=new o.$T(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=G;var T;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(T||(T={}));class X{static fromArray(F){return new X(W=>{W.emitMany(F)})}static fromPromise(F){return new X(async W=>{W.emitMany(await F)})}static fromPromises(F){return new X(async W=>{await Promise.all(F.map(async Y=>W.emitOne(await Y)))})}static merge(F){return new X(async W=>{await Promise.all(F.map(async Y=>{for await(const ae of Y)W.emitOne(ae)}))})}static{this.EMPTY=X.fromArray([])}constructor(F,W){this.a=T.Initial,this.b=[],this.d=null,this.f=W,this.g=new E.$le,queueMicrotask(async()=>{const Y={emitOne:ae=>this.h(ae),emitMany:ae=>this.j(ae),reject:ae=>this.l(ae)};try{await Promise.resolve(F(Y)),this.k()}catch(ae){this.l(ae)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===T.DoneError)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===T.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(F,W){return new X(async Y=>{for await(const ae of F)Y.emitOne(W(ae))})}map(F){return X.map(this,F)}static filter(F,W){return new X(async Y=>{for await(const ae of F)W(ae)&&Y.emitOne(ae)})}filter(F){return X.filter(this,F)}static coalesce(F){return X.filter(F,W=>!!W)}coalesce(){return X.coalesce(this)}static async toPromise(F){const W=[];for await(const Y of F)W.push(Y);return W}toPromise(){return X.toPromise(this)}h(F){this.a===T.Initial&&(this.b.push(F),this.g.fire())}j(F){this.a===T.Initial&&(this.b=this.b.concat(F),this.g.fire())}k(){this.a===T.Initial&&(this.a=T.DoneOK,this.g.fire())}l(F){this.a===T.Initial&&(this.a=T.DoneError,this.d=F,this.g.fire())}}e.$6h=X;class he extends X{constructor(F,W){super(W),this.m=F}cancel(){this.m.cancel()}}e.$7h=he;function B(H){const F=new t.$we,W=H(F.token);return new he(F,async Y=>{const ae=F.token.onCancellationRequested(()=>{ae.dispose(),F.dispose(),Y.reject(new s.$4)});try{for await(const Ee of W){if(F.token.isCancellationRequested)return;Y.emitOne(Ee)}ae.dispose(),F.dispose()}catch(Ee){ae.dispose(),F.dispose(),Y.reject(Ee)}})}class U{constructor(F){this.a=new oe,this.b=new X(ae=>{if(W){ae.reject(W);return}return Y&&ae.emitMany(Y),this.d=Ee=>ae.reject(Ee),this.f=Ee=>ae.emitOne(Ee),this.a.p},F);let W,Y;this.f=ae=>{Y||(Y=[]),Y.push(ae)},this.d=ae=>{W||(W=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(F){this.d(F),this.a.complete()}emitOne(F){this.f(F)}}e.$9h=U}),define(Re[82],Ae([1,0,17,13,34,36,25,8,3,16]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=D,e.$yk=u,e.$zk=q,e.$Ak=K,e.$Bk=J,e.$Ck=_,e.$Dk=de,e.$Ek=Q;function D(){return Object.create(null)}e.$wk="**",e.$xk="/";const w="[/\\\\]",m="[^/\\\\]",$=/\//g;function a(M,V){switch(M){case 0:return"";case 1:return`${m}*?`;default:return`(?:${w}|${m}+${w}${V?`|${w}${m}+`:""})*?`}}function u(M,V){if(!M)return[];const ne=[];let re=!1,me=!1,oe="";for(const ie of M){switch(ie){case V:if(!re&&!me){ne.push(oe),oe="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":me=!0;break;case"]":me=!1;break}oe+=ie}return oe&&ne.push(oe),ne}function d(M){if(!M)return"";let V="";const ne=u(M,e.$xk);if(ne.every(re=>re===e.$wk))V=".*";else{let re=!1;ne.forEach((me,oe)=>{if(me===e.$wk){if(re)return;V+=a(2,oe===ne.length-1)}else{let ie=!1,x="",G=!1,T="";for(const X of me){if(X!=="}"&&ie){x+=X;continue}if(G&&(X!=="]"||!T)){let he;X==="-"?he=X:(X==="^"||X==="!")&&!T?he="^":X===e.$xk?he="":he=(0,o.$hf)(X),T+=he;continue}switch(X){case"{":ie=!0;continue;case"[":G=!0;continue;case"}":{const B=`(?:${u(x,",").map(U=>d(U)).join("|")})`;V+=B,ie=!1,x="";break}case"]":{V+="["+T+"]",G=!1,T="";break}case"?":V+=m;continue;case"*":V+=a(1);continue;default:V+=(0,o.$hf)(X)}}oe<ne.length-1&&(ne[oe+1]!==e.$wk||oe+2<ne.length)&&(V+=w)}re=me===e.$wk})}return V}const f=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new C.$Dc(1e4),l=function(){return!1},r=function(){return null};function h(M,V){if(!M)return r;let ne;typeof M!="string"?ne=M.pattern:ne=M,ne=ne.trim();const re=`${ne}_${!!V.trimForExclusions}`;let me=n.get(re);if(me)return c(me,M);let oe;return f.test(ne)?me=I(ne.substr(4),ne):(oe=v.exec(S(ne,V)))?me=R(oe[1],ne):(V.trimForExclusions?b:g).test(ne)?me=L(ne,V):(oe=i.exec(S(ne,V)))?me=O(oe[1].substr(1),ne,!0):(oe=p.exec(S(ne,V)))?me=O(oe[1],ne,!1):me=P(ne),n.set(re,me),c(me,M)}function c(M,V){if(typeof V=="string")return M;const ne=function(re,me){return(0,k.$Eg)(re,V.base,!y.$l)?M((0,o.$mf)(re.substr(V.base.length),A.sep),me):null};return ne.allBasenames=M.allBasenames,ne.allPaths=M.allPaths,ne.basenames=M.basenames,ne.patterns=M.patterns,ne}function S(M,V){return V.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function I(M,V){return function(ne,re){return typeof ne=="string"&&ne.endsWith(M)?V:null}}function R(M,V){const ne=`/${M}`,re=`\\${M}`,me=function(ie,x){return typeof ie!="string"?null:x?x===M?V:null:ie===M||ie.endsWith(ne)||ie.endsWith(re)?V:null},oe=[M];return me.basenames=oe,me.patterns=[V],me.allBasenames=oe,me}function L(M,V){const ne=z(M.slice(1,-1).split(",").map(x=>h(x,V)).filter(x=>x!==r),M),re=ne.length;if(!re)return r;if(re===1)return ne[0];const me=function(x,G){for(let T=0,X=ne.length;T<X;T++)if(ne[T](x,G))return M;return null},oe=ne.find(x=>!!x.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ie=ne.reduce((x,G)=>G.allPaths?x.concat(G.allPaths):x,[]);return ie.length&&(me.allPaths=ie),me}function O(M,V,ne){const re=A.sep===A.$gc.sep,me=re?M:M.replace($,A.sep),oe=A.sep+me,ie=A.$gc.sep+M;let x;return ne?x=function(G,T){return typeof G=="string"&&(G===me||G.endsWith(oe)||!re&&(G===M||G.endsWith(ie)))?V:null}:x=function(G,T){return typeof G=="string"&&(G===me||!re&&G===M)?V:null},x.allPaths=[(ne?"*/":"./")+M],x}function P(M){try{const V=new RegExp(`^${d(M)}$`);return function(ne){return V.lastIndex=0,typeof ne=="string"&&V.test(ne)?M:null}}catch{return r}}function q(M,V,ne){return!M||typeof V!="string"?!1:K(M)(V,void 0,ne)}function K(M,V={}){if(!M)return l;if(typeof M=="string"||J(M)){const ne=h(M,V);if(ne===r)return l;const re=function(me,oe){return!!ne(me,oe)};return ne.allBasenames&&(re.allBasenames=ne.allBasenames),ne.allPaths&&(re.allPaths=ne.allPaths),re}return ge(M,V)}function J(M){const V=M;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function _(M){return M.allBasenames||[]}function de(M){return M.allPaths||[]}function ge(M,V){const ne=z(Object.getOwnPropertyNames(M).map(x=>le(x,M[x],V)).filter(x=>x!==r)),re=ne.length;if(!re)return r;if(!ne.some(x=>!!x.requiresSiblings)){if(re===1)return ne[0];const x=function(X,he){let B;for(let U=0,H=ne.length;U<H;U++){const F=ne[U](X,he);if(typeof F=="string")return F;(0,s.$rh)(F)&&(B||(B=[]),B.push(F))}return B?(async()=>{for(const U of B){const H=await U;if(typeof H=="string")return H}return null})():null},G=ne.find(X=>!!X.allBasenames);G&&(x.allBasenames=G.allBasenames);const T=ne.reduce((X,he)=>he.allPaths?X.concat(he.allPaths):X,[]);return T.length&&(x.allPaths=T),x}const me=function(x,G,T){let X,he;for(let B=0,U=ne.length;B<U;B++){const H=ne[B];H.requiresSiblings&&T&&(G||(G=(0,A.$nc)(x)),X||(X=G.substr(0,G.length-(0,A.$oc)(x).length)));const F=H(x,G,X,T);if(typeof F=="string")return F;(0,s.$rh)(F)&&(he||(he=[]),he.push(F))}return he?(async()=>{for(const B of he){const U=await B;if(typeof U=="string")return U}return null})():null},oe=ne.find(x=>!!x.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ie=ne.reduce((x,G)=>G.allPaths?x.concat(G.allPaths):x,[]);return ie.length&&(me.allPaths=ie),me}function le(M,V,ne){if(V===!1)return r;const re=h(M,ne);if(re===r)return r;if(typeof V=="boolean")return re;if(V){const me=V.when;if(typeof me=="string"){const oe=(ie,x,G,T)=>{if(!T||!re(ie,x))return null;const X=me.replace("$(basename)",()=>G),he=T(X);return(0,s.$rh)(he)?he.then(B=>B?M:null):he?M:null};return oe.requiresSiblings=!0,oe}}return re}function z(M,V){const ne=M.filter(x=>!!x.basenames);if(ne.length<2)return M;const re=ne.reduce((x,G)=>{const T=G.basenames;return T?x.concat(T):x},[]);let me;if(V){me=[];for(let x=0,G=re.length;x<G;x++)me.push(V)}else me=ne.reduce((x,G)=>{const T=G.patterns;return T?x.concat(T):x},[]);const oe=function(x,G){if(typeof x!="string")return null;if(!G){let X;for(X=x.length;X>0;X--){const he=x.charCodeAt(X-1);if(he===E.CharCode.Slash||he===E.CharCode.Backslash)break}G=x.substr(X)}const T=re.indexOf(G);return T!==-1?me[T]:null};oe.basenames=re,oe.patterns=me,oe.allBasenames=re;const ie=M.filter(x=>!x.basenames);return ie.push(oe),ie}function Q(M,V){return(0,t.$tb)(M,V,(ne,re)=>typeof ne=="string"&&typeof re=="string"?ne===re:typeof ne!="string"&&typeof re!="string"?ne.base===re.base&&ne.pattern===re.pattern:!1)}}),define(Re[109],Ae([1,0,9,174,19,16,4]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=o,e.$6k=D,e.$7k=w,e.$8k=m,e.$9k=$,e.$0k=a,e.$$k=u,e.$_k=d;var A;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class y{constructor(v="",g=!1){if(this.value=v,typeof this.value!="string")throw(0,t.$6)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(v,g=A.Paragraph){return this.value+=m(this.supportThemeIcons?(0,s.$Xk)(v):v).replace(/([ \t]+)/g,(b,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===A.Break?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,g){return this.value+=`
${$(g,v)}
`,this}appendLink(v,g,b){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(v),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(v,g){const b=new RegExp((0,k.$hf)(g),"g");return v.replace(b,(i,p)=>v.charAt(p-1)!=="\\"?`\\${i}`:i)}}e.$4k=y;function o(f){return D(f)?!f.value:Array.isArray(f)?f.every(o):!0}function D(f){return f instanceof y?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function w(f,v){return f===v?!0:!f||!v?!1:f.value===v.value&&f.isTrusted===v.isTrusted&&f.supportThemeIcons===v.supportThemeIcons&&f.supportHtml===v.supportHtml&&(f.baseUri===v.baseUri||!!f.baseUri&&!!v.baseUri&&(0,E.$_g)(C.URI.from(f.baseUri),C.URI.from(v.baseUri)))}function m(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function $(f,v){const g=f.match(/^`+/gm)?.reduce((i,p)=>i.length>p.length?i:p).length??0,b=g>=3?g+1:3;return[`${"`".repeat(b)}${v}`,f,`${"`".repeat(b)}`].join(`
`)}function a(f){return f.replace(/"/g,"&quot;")}function u(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function d(f){const v=[],g=f.split("|").map(i=>i.trim());f=g[0];const b=g[1];if(b){const i=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),n=i?i[1]:"",l=p?p[1]:"",r=isFinite(parseInt(l)),h=isFinite(parseInt(n));r&&v.push(`width="${l}"`),h&&v.push(`height="${n}"`)}return{href:f,dimensions:v}}}),define(Re[177],Ae([1,0,17,36,8,3,19,16]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=y,e.$1w=D,e.$2w=m,e.$3w=$,e.$4w=f,e.$5w=g,e.$6w=b,e.$7w=i,e.$8w=p,e.$9w=n;function y(r,h){const{os:c,tildify:S,relative:I}=h;if(I){const O=o(r,I,c);if(typeof O=="string")return O}let R=r.fsPath;if(c===k.OperatingSystem.Windows&&!k.$j?R=R.replace(/\//g,"\\"):c!==k.OperatingSystem.Windows&&k.$j&&(R=R.replace(/\\/g,"/")),c!==k.OperatingSystem.Windows&&S?.userHome){const O=S.userHome.fsPath;let P;r.scheme!==S.userHome.scheme&&r.path[0]===E.$gc.sep&&r.path[1]!==E.$gc.sep?P=S.userHome.with({path:r.path}).fsPath:P=R,R=m(P,O,c)}return(c===k.OperatingSystem.Windows?E.$fc:E.$gc).normalize(D(R,c===k.OperatingSystem.Windows))}function o(r,h,c){const S=c===k.OperatingSystem.Windows?E.$fc:E.$gc,I=c===k.OperatingSystem.Linux?C.$9g:C.$$g,R=h.getWorkspace(),L=(0,t.$Nb)(R.folders);if(!L)return;r.scheme!==L.uri.scheme&&r.path[0]===E.$gc.sep&&r.path[1]!==E.$gc.sep&&(r=L.uri.with({path:r.path}));const O=h.getWorkspaceFolder(r);if(!O)return;let P;if(I.isEqual(O.uri,r)?P="":P=I.relativePath(O.uri,r)??"",P&&(P=S.normalize(P)),R.folders.length>1&&!h.noPrefix){const q=O.name?O.name:I.basenameOrAuthority(O.uri);P=P?`${q} \u2022 ${P}`:q}return P}function D(r,h=k.$j){return(0,s.$Jg)(r,h)?r.charAt(0).toUpperCase()+r.slice(1):r}let w=Object.create(null);function m(r,h,c=k.OS){if(c===k.OperatingSystem.Windows||!r||!h)return r;let S=w.original===h?w.normalized:void 0;S||(S=h,k.$j&&(S=(0,s.$yg)(S)),S=`${(0,A.$nf)(S,E.$gc.sep)}${E.$gc.sep}`,w={original:h,normalized:S});let I=r;return k.$j&&(I=(0,s.$yg)(I)),(c===k.OperatingSystem.Linux?I.startsWith(S):(0,A.$Gf)(I,S))?`~/${I.substr(S.length)}`:r}function $(r,h){return r.replace(/^~($|\/|\\)/,`${h}$1`)}const a="\u2026",u="\\\\",d="~";function f(r,h=E.sep){const c=new Array(r.length);let S=!1;for(let I=0;I<r.length;I++){const R=r[I];if(R===""){c[I]=`.${h}`;continue}if(!R){c[I]=R;continue}S=!0;let L="",O=R;O.indexOf(u)===0?(L=O.substr(0,O.indexOf(u)+u.length),O=O.substr(O.indexOf(u)+u.length)):O.indexOf(h)===0?(L=O.substr(0,O.indexOf(h)+h.length),O=O.substr(O.indexOf(h)+h.length)):O.indexOf(d)===0&&(L=O.substr(0,O.indexOf(d)+d.length),O=O.substr(O.indexOf(d)+d.length));const P=O.split(h);for(let q=1;S&&q<=P.length;q++)for(let K=P.length-q;S&&K>=0;K--){S=!1;let J=P.slice(K,K+q).join(h);for(let _=0;!S&&_<r.length;_++)if(_!==I&&r[_]&&r[_].indexOf(J)>-1){const de=K+q===P.length,ge=K>0&&r[_].indexOf(h)>-1?h+J:J,le=r[_].endsWith(ge);S=!de||le}if(!S){let _="";(P[0].endsWith(":")||L!=="")&&(K===1&&(K=0,q++,J=P[0]+h+J),K>0&&(_=P[0]+h),_=L+_),K>0&&(_=_+a+h),_=_+J,K+q<P.length&&(_=_+h+a),c[I]=_}}S&&(c[I]=R)}return c}var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function g(r,h=Object.create(null)){const c=[];let S=!1,I="";for(const R of r)if(R==="$"||S&&R==="{")I&&c.push({value:I,type:v.TEXT}),I="",S=!0;else if(R==="}"&&S){const L=h[I];if(typeof L=="string")L.length&&c.push({value:L,type:v.VARIABLE});else if(L){const O=c[c.length-1];(!O||O.type!==v.SEPARATOR)&&c.push({value:L.label,type:v.SEPARATOR})}I="",S=!1}else I+=R;return I&&!S&&c.push({value:I,type:v.TEXT}),c.filter((R,L)=>{if(R.type===v.SEPARATOR){const O=c[L-1],P=c[L+1];return[O,P].every(q=>q&&(q.type===v.VARIABLE||q.type===v.TEXT)&&q.value.length>0)}return!0}).map(R=>R.value).join("")}function b(r,h){return k.$k||h?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.$k?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}function i(r,h){return k.$k||h?r.replace(/\(&&\w\)|&&/g,""):k.$j?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}function p(r){return r.replace(/&/g,"&&")}function n(r){if(r.endsWith("]")){const h=r.lastIndexOf(" [",r.length-2);if(h!==-1){const c=l(r.substring(0,h)),S=r.substring(h);return{name:c.name+S,parentPath:c.parentPath}}}return l(r)}function l(r){const h=r.indexOf("/")!==-1?E.$gc:E.$fc,c=h.basename(r),S=h.dirname(r);return c.length?{name:c,parentPath:S}:{name:S,parentPath:""}}}),define(Re[58],Ae([1,0,14,80,4]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0,e.$On=y,e.$Pn=D,e.$Qn=w;function k(m){return m.toJSON()}class C{constructor($){this.a=$}transformIncoming($){const a=this.a.transformIncoming($);return a===$?$:k(E.URI.from(a))}transformOutgoing($){const a=this.a.transformOutgoing($);return a===$?$:k(E.URI.from(a))}transformOutgoingURI($){const a=this.a.transformOutgoing($);return a===$?$:E.URI.from(a)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Mn=C,e.$Nn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function A(m,$,a){if(!m||a>200)return null;if(typeof m=="object"){if(m instanceof E.URI)return $.transformOutgoing(m);for(const u in m)if(Object.hasOwnProperty.call(m,u)){const d=A(m[u],$,a+1);d!==null&&(m[u]=d)}}return null}function y(m,$){const a=A(m,$,0);return a===null?m:a}function o(m,$,a,u){if(!m||u>200)return null;if(typeof m=="object"){if(m.$mid===s.MarshalledId.Uri)return a?E.URI.revive($.transformIncoming(m)):$.transformIncoming(m);if(m instanceof t.$Ne)return null;for(const d in m)if(Object.hasOwnProperty.call(m,d)){const f=o(m[d],$,a,u+1);f!==null&&(m[d]=f)}}return null}function D(m,$){const a=o(m,$,!1,0);return a===null?m:a}function w(m,$){const a=o(m,$,!0,0);return a===null?m:a}}),define(Re[22],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=s;const t=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function s(E){return t.test(E)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const k=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let y=0,o="";return o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o+="-",o+=C[k[y++]],o+=C[k[y++]],o+="-",o+=C[k[y++]],o+=C[k[y++]],o+="-",o+=C[k[y++]],o+=C[k[y++]],o+="-",o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o+=C[k[y++]],o}}()}),define(Re[178],Ae([1,0,17,39,22]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.$ru=void 0,e.$pu=k,e.$qu=C,e.$su=o;function k(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function C(w,m,$){const a={id:(0,E.$2g)(),name:w,uri:m,data:$};return{asString:async()=>"",asFile:()=>a,value:void 0}}class A{constructor(){this.a=new Map}get size(){let m=0;for(const $ of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const $=[...this.a.keys()];return s.Iterable.some(this,([a,u])=>u.asFile())&&$.push("files"),D(y(m),$)}get(m){return this.a.get(this.b(m))?.[0]}append(m,$){const a=this.a.get(m);a?a.push($):this.a.set(this.b(m),[$])}replace(m,$){this.a.set(this.b(m),[$])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,$]of this.a)for(const a of $)yield[m,a]}b(m){return y(m)}}e.$ru=A;function y(w){return w.toLowerCase()}function o(w,m){return D(y(w),m.map(y))}function D(w,m){if(w==="*/*")return m.length>0;if(m.includes(w))return!0;const $=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[a,u,d]=$;return d==="*"?m.some(f=>f.startsWith(u+"/")):!1}e.$tu=Object.freeze({create:w=>(0,t.$Lb)(w.map(m=>m.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.$tu.split(w).filter(m=>!m.startsWith("#"))})}),define(Re[179],Ae([1,0,32]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=k;const s=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(C){const A=C.replace(/\-/g,":").toLowerCase();return!s.has(A)}function k(){const C=(0,t.networkInterfaces)();for(const A in C){const y=C[A];if(y){for(const{mac:o}of y)if(E(o))return o}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Re[110],Ae([1,0,32,68,22,179,3]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Tn=y,e.$Un=w,e.$Vn=m,E=Ue(E),e.$Sn=new class{c($){return this.a||(this.a=s.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,a=0;const u=(0,t.networkInterfaces)();for(const d in u){const f=u[d];if(f)for(const{mac:v,internal:g}of f)g||(a+=1,this.c(v.toUpperCase())&&($+=1))}this.b=a>0?$/a:0}return this.b}};let A;async function y($){return A||(A=(async()=>await o($)||E.$2g())()),A}async function o($){try{const a=await new Promise((d,f)=>{ue(["crypto"],d,f)}).then(Ue),u=(0,k.$Rn)();return a.createHash("sha256").update(u,"utf8").digest("hex")}catch(a){$(a);return}}const D="Software\\Microsoft\\SQMClient";async function w($){if(C.$j){const a=await new Promise((u,d)=>{ue(["@vscode/windows-registry"],u,d)}).then(Ue);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(u){return $(u),""}}return""}async function m($){try{return await(await new Promise((d,f)=>{ue(["@vscode/deviceid"],d,f)}).then(Ue)).getDeviceId()}catch(a){return $(a),""}}}),function(){function ue(e,t,s){async function E(D){try{return await t.promises.access(D),!0}catch{return!1}}function k(D){const w=new Date;return t.promises.utimes(D,w,w)}async function C(D){const w=e.join(D,"languagepacks.json");try{return JSON.parse(await t.promises.readFile(w,"utf-8"))}catch{return}}function A(D,w){try{for(;w;){if(D[w])return w;const m=w.lastIndexOf("-");if(m>0)w=w.substring(0,m);else return}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function y(D,w,m){return s.mark("code/didGenerateNls"),{userLocale:D,osLocale:w,resolvedLanguage:"en",defaultMessagesFile:e.join(m,"nls.messages.json"),locale:"en",availableLanguages:{}}}async function o({userLocale:D,osLocale:w,userDataPath:m,commit:$,nlsMetadataPath:a}){if(s.mark("code/willGenerateNls"),process.env.VSCODE_DEV||D==="pseudo"||D.startsWith("en")||!$||!m)return y(D,w,a);try{const u=await C(m);if(!u)return y(D,w,a);const d=A(u,D);if(!d)return y(D,w,a);const f=u[d],v=f?.translations?.vscode;if(!f||typeof f.hash!="string"||!f.translations||typeof v!="string"||!await E(v))return y(D,w,a);const g=`${f.hash}.${d}`,b=e.join(m,"clp",g),i=e.join(b,$),p=e.join(i,"nls.messages.json"),n=e.join(b,"tcf.json"),l=e.join(b,"corrupted.info");await E(l)&&await t.promises.rm(b,{recursive:!0,force:!0,maxRetries:3});const r={userLocale:D,osLocale:w,resolvedLanguage:d,defaultMessagesFile:e.join(a,"nls.messages.json"),languagePack:{translationsConfigFile:n,messagesFile:p,corruptMarkerFile:l},locale:D,availableLanguages:{"*":d},_languagePackId:g,_languagePackSupport:!0,_translationsConfigFile:n,_cacheRoot:b,_resolvedLanguagePackCoreLocation:i,_corruptedFile:l};if(await E(i))return k(i).catch(()=>{}),s.mark("code/didGenerateNls"),r;const[,h,c,S]=await Promise.all([t.promises.mkdir(i,{recursive:!0}),JSON.parse(await t.promises.readFile(e.join(a,"nls.keys.json"),"utf-8")),JSON.parse(await t.promises.readFile(e.join(a,"nls.messages.json"),"utf-8")),JSON.parse(await t.promises.readFile(v,"utf-8"))]),I=[];let R=0;for(const[L,O]of h){const P=S.contents[L];for(const q of O)I.push(P?.[q]||c[R]),R++}return await Promise.all([t.promises.writeFile(p,JSON.stringify(I),"utf-8"),t.promises.writeFile(n,JSON.stringify(f.translations),"utf-8")]),s.mark("code/didGenerateNls"),r}catch(u){console.error("Generating translation files failed.",u)}return y(D,w,a)}return{resolveNLSConfiguration:o}}if(typeof define=="function")define(Re[180],Ae([83,23,43]),function(e,t,s){return ue(e,t,s)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("fs"),s=require("../common/performance");module.exports=ue(e,t,s)}else throw new Error("vs/base/node/nls defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Re[181],Ae([1,0,23,285,3]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=k,E=Ue(E);async function k(C){if(E.$k||E.$j)return;let A;for(const y of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{A=await t.promises.open(y,t.constants.R_OK);break}catch{}if(!A){C("Unable to retrieve release information from known identifier paths.");return}try{const y=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),o={id:"unknown"};for await(const D of(0,s.createInterface)({input:A.createReadStream(),crlfDelay:1/0})){if(!D.includes("="))continue;const w=D.split("=")[0].toUpperCase().trim();if(y.has(w)){const m=D.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?o.id=m:w==="ID_LIKE"?o.id_like=m:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(o.version_id=m)}}return o}catch(y){C(y)}}}),define(Re[26],Ae([1,0,23,32,286,13,36,106,8,3,19,4]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=g,e.whenDeleted=p,e.configureFlushOnWrite=c,e.writeFileSync=I,t=Ue(t);var m;(function(ge){ge[ge.UNLINK=0]="UNLINK",ge[ge.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function $(ge,le=m.UNLINK,z){if((0,C.$Ig)(ge))throw new Error("rimraf - will refuse to recursively delete root");return le===m.UNLINK?u(ge):a(ge,z)}async function a(ge,le=(0,C.$Ng)((0,s.tmpdir)())){try{try{await t.promises.rename(ge,le)}catch(z){return z.code==="ENOENT"?void 0:u(ge)}u(le).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function u(ge){return t.promises.rm(ge,{recursive:!0,force:!0,maxRetries:3})}function d(ge){if((0,C.$Ig)(ge))throw new Error("rimraf - will refuse to recursively delete root");t.rmSync(ge,{recursive:!0,force:!0,maxRetries:3})}async function f(ge,le){return b(await(le?v(ge):t.promises.readdir(ge)))}async function v(ge){try{return await t.promises.readdir(ge,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const le=[],z=await f(ge);for(const Q of z){let M=!1,V=!1,ne=!1;try{const re=await t.promises.lstat((0,y.$jc)(ge,Q));M=re.isFile(),V=re.isDirectory(),ne=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}le.push({name:Q,isFile:()=>M,isDirectory:()=>V,isSymbolicLink:()=>ne})}return le}function g(ge){return b(t.readdirSync(ge))}function b(ge){return ge.map(le=>typeof le=="string"?o.$k?(0,A.$nm)(le):le:(le.name=o.$k?(0,A.$nm)(le.name):le.name,le))}async function i(ge){const le=await f(ge),z=[];for(const Q of le)await n.existsDirectory((0,y.$jc)(ge,Q))&&z.push(Q);return z}function p(ge,le=1e3){return new Promise(z=>{let Q=!1;const M=setInterval(()=>{Q||(Q=!0,t.access(ge,V=>{Q=!1,V&&(clearInterval(M),z(void 0))}))},le)})}var n;(function(ge){async function le(M){let V;try{if(V=await t.promises.lstat(M),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await t.promises.stat(M),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ne){if(ne.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(o.$j&&ne.code==="EACCES")try{return{stat:await t.promises.stat(await t.promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw re}throw ne}}ge.stat=le;async function z(M){try{const{stat:V,symbolicLink:ne}=await ge.stat(M);return V.isFile()&&ne?.dangling!==!0}catch{}return!1}ge.existsFile=z;async function Q(M){try{const{stat:V,symbolicLink:ne}=await ge.stat(M);return V.isDirectory()&&ne?.dangling!==!0}catch{}return!1}ge.existsDirectory=Q})(n||(e.SymlinkSupport=n={}));const l=new k.$Oh;function r(ge,le,z){return l.queueFor(w.URI.file(ge),()=>{const Q=R(z);return new Promise((M,V)=>S(ge,le,Q,ne=>ne?V(ne):M()))},D.$0g)}let h=!0;function c(ge){h=ge}function S(ge,le,z,Q){if(!h)return t.writeFile(ge,le,{mode:z.mode,flag:z.flag},Q);t.open(ge,z.flag,z.mode,(M,V)=>{if(M)return Q(M);t.writeFile(V,le,ne=>{if(ne)return t.close(V,()=>Q(ne));t.fdatasync(V,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),c(!1)),t.close(V,me=>Q(me))))})})}function I(ge,le,z){const Q=R(z);if(!h)return t.writeFileSync(ge,le,{mode:Q.mode,flag:Q.flag});const M=t.openSync(ge,Q.flag,Q.mode);try{t.writeFileSync(M,le);try{t.fdatasyncSync(M)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),c(!1)}}finally{t.closeSync(M)}}function R(ge){return ge?{mode:typeof ge.mode=="number"?ge.mode:438,flag:typeof ge.flag=="string"?ge.flag:"w"}:{mode:438,flag:"w"}}async function L(ge,le,z=6e4){if(ge!==le)try{o.$j&&typeof z=="number"?await O(ge,le,Date.now(),z):await t.promises.rename(ge,le)}catch(Q){if(ge.toLowerCase()!==le.toLowerCase()&&Q.code==="EXDEV"||ge.endsWith("."))await P(ge,le,{preserveSymlinks:!1}),await $(ge,m.MOVE);else throw Q}}async function O(ge,le,z,Q,M=0){try{return await t.promises.rename(ge,le)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-z>=Q)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${V}`),V;if(M===0){let ne=!1;try{const{stat:re}=await n.stat(le);re.isFile()||(ne=!0)}catch{}if(ne)throw V}return await(0,k.$Gh)(Math.min(100,M*10)),O(ge,le,z,Q,M+1)}}async function P(ge,le,z){return K(ge,le,{root:{source:ge,target:le},options:z,handledSourcePaths:new Set})}const q=511;async function K(ge,le,z){if(z.handledSourcePaths.has(ge))return;z.handledSourcePaths.add(ge);const{stat:Q,symbolicLink:M}=await n.stat(ge);if(M){if(z.options.preserveSymlinks)try{return await de(ge,le,z)}catch{}if(M.dangling)return}return Q.isDirectory()?J(ge,le,Q.mode&q,z):_(ge,le,Q.mode&q)}async function J(ge,le,z,Q){await t.promises.mkdir(le,{recursive:!0,mode:z});const M=await f(ge);for(const V of M)await K((0,y.$jc)(ge,V),(0,y.$jc)(le,V),Q)}async function _(ge,le,z){await t.promises.copyFile(ge,le),await t.promises.chmod(le,z)}async function de(ge,le,z){let Q=await t.promises.readlink(ge);(0,C.$Eg)(Q,z.root.source,!o.$l)&&(Q=(0,y.$jc)(z.root.target,Q.substr(z.root.source.length+1))),await t.promises.symlink(Q,le)}e.Promises=new class{get read(){return(ge,le,z,Q,M)=>new Promise((V,ne)=>{t.read(ge,le,z,Q,M,(re,me,oe)=>re?ne(re):V({bytesRead:me,buffer:oe}))})}get write(){return(ge,le,z,Q,M)=>new Promise((V,ne)=>{t.write(ge,le,z,Q,M,(re,me,oe)=>re?ne(re):V({bytesWritten:me,buffer:oe}))})}get fdatasync(){return(0,E.promisify)(t.fdatasync)}get open(){return(0,E.promisify)(t.open)}get close(){return(0,E.promisify)(t.close)}get realpath(){return(0,E.promisify)(t.realpath)}async exists(ge){try{return await t.promises.access(ge),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return i}get writeFile(){return r}get rm(){return $}get rename(){return L}get copy(){return P}}}),define(Re[182],Ae([1,0,23,8,3,16,26]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=A,e.$mr=y,e.$nr=o,e.$or=D,t=Ue(t);function A(m){if(E.$l)return m;const $=(0,s.$mc)(m);if(m===$)return m;const a=((0,s.$nc)(m)||m).toLowerCase();try{const d=(0,C.readdirSync)($).filter(f=>f.toLowerCase()===a);if(d.length===1){const f=A($);if(f)return(0,s.$jc)(f,d[0])}else if(d.length>1){const f=d.indexOf(a);if(f>=0){const v=A($);if(v)return(0,s.$jc)(v,d[f])}}}catch{}return null}async function y(m,$){if(E.$l)return m;const a=(0,s.$mc)(m);if(m===a)return m;const u=((0,s.$nc)(m)||m).toLowerCase();try{if($?.isCancellationRequested)return null;const f=(await C.Promises.readdir(a)).filter(v=>v.toLowerCase()===u);if(f.length===1){const v=await y(a,$);if(v)return(0,s.$jc)(v,f[0])}else if(f.length>1){const v=f.indexOf(u);if(v>=0){const g=await y(a,$);if(g)return(0,s.$jc)(g,f[v])}}}catch{}return null}async function o(m){try{return await C.Promises.realpath(m)}catch{const a=w(m);return await t.promises.access(a,t.constants.R_OK),a}}function D(m){try{return t.realpathSync(m)}catch{const a=w(m);return t.accessSync(a,t.constants.R_OK),a}}function w(m){return(0,k.$nf)((0,s.$hc)(m),s.sep)}}),define(Re[183],Ae([1,0,84]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=s,e.$6g=k,t=Ue(t);function s(A,y,o,D=1){let w=!1;return new Promise(m=>{const $=setTimeout(()=>{if(!w)return w=!0,m(0)},o);E(A,y,D,a=>{if(!w)return w=!0,clearTimeout($),m(a)})})}function E(A,y,o,D){if(y===0)return D(0);const w=new t.Socket;w.once("connect",()=>(C(w),E(A+o,y-1,o,D))),w.once("data",()=>{}),w.once("error",m=>(C(w),m.code!=="ECONNREFUSED"?E(A+o,y-1,o,D):D(A))),w.connect(A,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(A,y,o,D="127.0.0.1"){let w=!1,m,$=1;const a=t.createServer({pauseOnConnect:!0});function u(d,f){w||(w=!0,a.removeAllListeners(),a.close(),m&&clearTimeout(m),f(d))}return new Promise(d=>{m=setTimeout(()=>{u(0,d)},o),a.on("listening",()=>{u(A,d)}),a.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&$<y?(A++,$++,a.listen(A,D)):u(0,d)}),a.on("close",()=>{u(0,d)}),a.listen(A,D)})}function C(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(y){console.error(y)}}}),define(Re[111],Ae([1,0,32,8,26]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=v,e.$xm=g,t=Ue(t),s=Ue(s),E=Ue(E);const k=/^\d+$/,C=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(y||(y={}));let o;switch(process.arch){case"ia32":o=y.x86;break;case"arm":case"arm64":o=y.ARM;break;default:o=y.x64;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=y.x86:D=y.x64;class w{constructor(i,p,n){this.exePath=i,this.displayName=p,this.a=n}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:b=!1}={}){return b?o===y.x64?process.env["ProgramFiles(x86)"]||null:D===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:b=!1,findPreview:i=!1}={}){const p=m({useAlternateBitness:b});if(!p)return null;const n=s.$jc(p,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let l=-1,r=null;for(const S of await E.Promises.readdir(n)){let I=-1;if(i){const L=S.indexOf("-");if(L<0)continue;const O=S.substring(0,L);if(!k.test(O)||S.substring(L+1)!=="preview")continue;I=parseInt(O,10)}else{if(!k.test(S))continue;I=parseInt(S,10)}if(I<=l)continue;const R=s.$jc(n,S,"pwsh.exe");await E.SymlinkSupport.existsFile(R)&&(r=R,l=I)}if(!r)return null;const h=p.includes("x86")?" (x86)":"",c=i?" Preview":"";return new w(r,`PowerShell${c}${h}`,!0)}async function a({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const i=s.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:p,pwshMsixName:n}=b?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const l of await E.Promises.readdir(i))if(p.test(l)){const r=s.$jc(i,l,"pwsh.exe");return new w(r,n)}return null}function u(){const b=s.$jc(t.homedir(),".dotnet","tools","pwsh.exe");return new w(b,".NET Core PowerShell Global Tool")}function d(){const b=s.$jc(process.env.windir,o===y.x86&&D!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(b,"Windows PowerShell",!0)}async function*f(){let b=await $();b&&(yield b),b=await $({useAlternateBitness:!0}),b&&(yield b),b=await a(),b&&(yield b),b=u(),b&&(yield b),b=await $({findPreview:!0}),b&&(yield b),b=await a({findPreview:!0}),b&&(yield b),b=await $({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=d(),b&&(yield b)}async function*v(){for await(const b of f())await b.exists()&&(yield b)}async function g(){for await(const b of v())return b;return null}}),define(Re[112],Ae([1,0,23,8,3,31,66,10,26]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=o,e.$zm=D,s=Ue(s),E=Ue(E),k=Ue(k),A=Ue(A),y=Ue(y),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function o(m=k.env){return m.comspec||"cmd.exe"}function D(m){let $=[],a=!1;const u=function(d){if(a){$.push(d);return}(!m.send(d,v=>{if(v&&console.error(v),a=!1,$.length>0){const g=$.slice(0);$=[],g.forEach(b=>u(b))}})||E.$j)&&(a=!0)};return{send:u}}var w;(function(m){async function $(a,u,d){if(s.$ic(a))return a;if(u===void 0&&(u=k.cwd()),s.$mc(a)!=="."||(d===void 0&&A.$eg(k.env.PATH)&&(d=k.env.PATH.split(s.$tc)),d===void 0||d.length===0))return s.$jc(u,a);async function v(g){if(await y.Promises.exists(g)){let b;try{b=await t.promises.stat(g)}catch(i){i.message.startsWith("EACCES")&&(b=await t.promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(const g of d){let b;if(s.$ic(g)?b=s.$jc(g,a):b=s.$jc(u,g,a),await v(b))return b;let i=b+".com";if(await v(i)||(i=b+".exe",await v(i)))return i}return s.$jc(u,a)}m.findExecutable=$})(w||(e.win32=w={}))}),define(Re[113],Ae([1,0,59,12]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=E;function E(C){return new Promise((A,y)=>{let o;const D=new Map;function w($,a,u,d,f){const v=D.get(a);if($===C||v){const g={name:m(u),cmd:u,pid:$,ppid:a,load:d,mem:f};D.set($,g),$===C&&(o=g),v&&(v.children||(v.children=[]),v.children.push(g),v.children.length>1&&(v.children=v.children.sort((b,i)=>b.pid-i.pid)))}}function m($){const a=/--utility-sub-type=network/i,u=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,v=/--type=([a-zA-Z-]+)/;if(u.exec($))return"electron-crash-reporter";if(d.exec($))return"winpty-agent";if(f.exec($))return"conpty-agent";let g=v.exec($);if(g&&g.length===2)return g[1]==="renderer"?"window":g[1]==="utility"?a.exec($)?"utility-network-service":"utility-process":g[1]==="extensionHost"?"extension-host":g[1];const b=/[a-zA-Z-]+\.js/g;let i="";do g=b.exec($),g&&(i+=g+" ");while(g);return i&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${i})`:$}if(process.platform==="win32"){const $=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,u)=>{ue(["@vscode/windows-process-tree"],a,u)}).then(Ue).then(a=>{a.getProcessList(C,u=>{if(!u){y(new Error(`Root process ${C} not found`));return}a.getProcessCpuUsage(u,d=>{const f=new Map;d.forEach(v=>{const g=$(v.commandLine||"");f.set(v.pid,{name:m(g),cmd:g,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),o=f.get(C),o?(f.forEach(v=>{const g=f.get(v.ppid);g&&(g.children||(g.children=[]),g.children.push(v))}),f.forEach(v=>{v.children&&(v.children=v.children.sort((g,b)=>g.pid-b.pid))}),A(o)):y(new Error(`Root process ${C} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let $=function(){let a=[o];const u=[];for(;a.length;){const f=a.shift();f&&(u.push(f.pid),f.children&&(a=a.concat(f.children)))}let d=JSON.stringify(s.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+u.join(" "),(0,t.exec)(d,{},(f,v,g)=>{if(f||g)y(f||new Error(g.toString()));else{const b=v.toString().split(`
`);for(let i=0;i<u.length;i++){const p=D.get(u[i]);p.load=parseFloat(b[i])}if(!o){y(new Error(`Root process ${C} not found`));return}A(o)}})};(0,t.exec)("which ps",{},(a,u,d)=>{if(a||d)if(process.platform!=="linux")y(a||new Error(d.toString()));else{const f=JSON.stringify(s.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,t.exec)(f,{},(v,g,b)=>{v||b?y(v||new Error(b.toString())):(k(g,w),$())})}else{const f=u.toString().trim();(0,t.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,b,i)=>{g||i&&!i.includes("screen size is bogus")?y(g||new Error(i.toString())):(k(b,w),process.platform==="linux"?$():o?A(o):y(new Error(`Root process ${C} not found`)))})}})}})}function k(C,A){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,o=C.toString().split(`
`);for(const D of o){const w=y.exec(D.trim());w&&w.length===6&&A(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(Re[114],Ae([1,0,32,3,111,112]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=C,s=Ue(s),k=Ue(k);async function C(w,m){return w===s.OperatingSystem.Windows?s.$j?D():k.$ym(m):y(w,m)}let A=null;function y(w,m){if(s.$l&&w===s.OperatingSystem.Macintosh||s.$k&&w===s.OperatingSystem.Linux)return"/bin/bash";if(!A){let $;if(s.$j)$="/bin/bash";else{if($=m.SHELL,!$)try{$=(0,t.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}A=$}return A}let o=null;async function D(){return o||(o=(await(0,E.$xm)()).exePath),o}}),function(){function ue(){function e(){return process.uncHostAllowlist}function t(y){const o=new Set;if(Array.isArray(y))for(const D of y)typeof D=="string"&&o.add(D);return Array.from(o)}function s(){const y=e();return y?Array.from(y):[]}function E(y){if(process.platform!=="win32")return;const o=e();if(o)if(typeof y=="string")o.add(y.toLowerCase());else for(const D of t(y))E(D)}function k(y){if(typeof y!="string")return;const o=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let D;for(const w of o){if(y.indexOf(w)!==0)continue;const $=y.indexOf("\\",w.length);if($===-1)continue;const a=y.substring(w.length,$);if(a){D=a;break}}return D}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function A(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:s,addUNCHostToAllowlist:E,getUNCHost:k,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:A}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Be=this&&this.__decorate||function(ue,e,t,s){var E=arguments.length,k=E<3?e:s===null?s=Object.getOwnPropertyDescriptor(e,t):s,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(ue,e,t,s);else for(var A=ue.length-1;A>=0;A--)(C=ue[A])&&(k=(E<3?C(k):E>3?C(e,t,k):C(e,t))||k);return E>3&&k&&Object.defineProperty(e,t,k),k};define(Re[49],Ae([1,0,17,13,14,18,77,9,6,2,48,16,10]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=c,e.$gi=S,e.$li=q,e.$mi=K,w=Ue(w);var $;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})($||($={}));function a(M){switch(M){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var u;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(u||(u={}));function d(M){switch(M){case u.Initialize:return"init";case u.PromiseSuccess:return"reply:";case u.PromiseError:case u.PromiseErrorObj:return"replyErr:";case u.EventFire:return"event:"}}var f;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(f||(f={}));function v(M){let V=0;for(let ne=0;;ne+=7){const re=M.read(1);if(V|=(re.buffer[0]&127)<<ne,!(re.buffer[0]&128))return V}}const g=l(0);function b(M,V){if(V===0){M.write(g);return}let ne=0;for(let me=V;me!==0;me=me>>>7)ne++;const re=E.$Ne.alloc(ne);for(let me=0;V!==0;me++)re.buffer[me]=V&127,V=V>>>7,V>0&&(re.buffer[me]|=128);M.write(re)}class i{constructor(V){this.b=V,this.a=0}read(V){const ne=this.b.slice(this.a,this.a+V);return this.a+=ne.byteLength,ne}}e.$di=i;class p{constructor(){this.a=[]}get buffer(){return E.$Ne.concat(this.a)}write(V){this.a.push(V)}}e.$ei=p;var n;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(n||(n={}));function l(M){const V=E.$Ne.alloc(1);return V.writeUInt8(M,0),V}const r={Undefined:l(n.Undefined),String:l(n.String),Buffer:l(n.Buffer),VSBuffer:l(n.VSBuffer),Array:l(n.Array),Object:l(n.Object),Uint:l(n.Int)},h=typeof Buffer<"u";function c(M,V){if(typeof V>"u")M.write(r.Undefined);else if(typeof V=="string"){const ne=E.$Ne.fromString(V);M.write(r.String),b(M,ne.byteLength),M.write(ne)}else if(h&&Buffer.isBuffer(V)){const ne=E.$Ne.wrap(V);M.write(r.Buffer),b(M,ne.byteLength),M.write(ne)}else if(V instanceof E.$Ne)M.write(r.VSBuffer),b(M,V.byteLength),M.write(V);else if(Array.isArray(V)){M.write(r.Array),b(M,V.length);for(const ne of V)c(M,ne)}else if(typeof V=="number"&&(V|0)===V)M.write(r.Uint),b(M,V);else{const ne=E.$Ne.fromString(JSON.stringify(V));M.write(r.Object),b(M,ne.byteLength),M.write(ne)}}function S(M){switch(M.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return M.read(v(M)).toString();case n.Buffer:return M.read(v(M)).buffer;case n.VSBuffer:return M.read(v(M));case n.Array:{const ne=v(M),re=[];for(let me=0;me<ne;me++)re.push(S(M));return re}case n.Object:return JSON.parse(M.read(v(M)).toString());case n.Int:return v(M)}}class I{constructor(V,ne,re=null,me=1e3){this.h=V,this.j=ne,this.k=re,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:u.Initialize})}registerChannel(V,ne){this.b.set(V,ne),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case u.Initialize:{const ne=this.o([V.type]);this.k?.logOutgoing(ne,0,R.OtherSide,d(V.type));return}case u.PromiseSuccess:case u.PromiseError:case u.EventFire:case u.PromiseErrorObj:{const ne=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ne,V.id,R.OtherSide,d(V.type),V.data);return}}}o(V,ne=void 0){const re=new p;return c(re,V),c(re,ne),this.p(re.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ne=new i(V),re=S(ne),me=S(ne),oe=re[0];switch(oe){case $.Promise:return this.k?.logIncoming(V.byteLength,re[1],R.OtherSide,`${a(oe)}: ${re[2]}.${re[3]}`,me),this.s({type:oe,id:re[1],channelName:re[2],name:re[3],arg:me});case $.EventListen:return this.k?.logIncoming(V.byteLength,re[1],R.OtherSide,`${a(oe)}: ${re[2]}.${re[3]}`,me),this.t({type:oe,id:re[1],channelName:re[2],name:re[3],arg:me});case $.PromiseCancel:return this.k?.logIncoming(V.byteLength,re[1],R.OtherSide,`${a(oe)}`),this.u({type:oe,id:re[1]});case $.EventDispose:return this.k?.logIncoming(V.byteLength,re[1],R.OtherSide,`${a(oe)}`),this.u({type:oe,id:re[1]})}}s(V){const ne=this.b.get(V.channelName);if(!ne){this.v(V);return}const re=new k.$we;let me;try{me=ne.call(this.j,V.name,V.arg,re.token)}catch(x){me=Promise.reject(x)}const oe=V.id;me.then(x=>{this.m({id:oe,data:x,type:u.PromiseSuccess})},x=>{x instanceof Error?this.m({id:oe,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split(`
`):void 0},type:u.PromiseError}):this.m({id:oe,data:x,type:u.PromiseErrorObj})}).finally(()=>{ie.dispose(),this.d.delete(V.id)});const ie=(0,o.$Sc)(()=>re.cancel());this.d.set(V.id,ie)}t(V){const ne=this.b.get(V.channelName);if(!ne){this.v(V);return}const re=V.id,oe=ne.listen(this.j,V.name,V.arg)(ie=>this.m({id:re,data:ie,type:u.EventFire}));this.d.set(V.id,oe)}u(V){const ne=this.d.get(V.id);ne&&(ne.dispose(),this.d.delete(V.id))}v(V){let ne=this.g.get(V.channelName);ne||(ne=[],this.g.set(V.channelName,ne));const re=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===$.Promise&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:u.PromiseError})},this.l);ne.push({request:V,timeoutTimer:re})}w(V){const ne=this.g.get(V);if(ne){for(const re of ne)switch(clearTimeout(re.timeoutTimer),re.request.type){case $.Promise:this.s(re.request);break;case $.EventListen:this.t(re.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,o.$Pc)(this.d.values()),this.d.clear()}}e.$hi=I;var R;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(V,ne=null){this.l=V,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ne}getChannel(V){const ne=this;return{call(re,me,oe){return ne.a?Promise.reject(new A.$4):ne.m(V,re,me,oe)},listen(re,me){return ne.a?y.Event.None:ne.o(V,re,me)}}}m(V,ne,re,me=k.CancellationToken.None){const oe=this.g++,ie=$.Promise,x={id:oe,type:ie,channelName:V,name:ne,arg:re};if(me.isCancellationRequested)return Promise.reject(new A.$4);let G;return new Promise((X,he)=>{if(me.isCancellationRequested)return he(new A.$4);const B=()=>{const W=Y=>{switch(Y.type){case u.PromiseSuccess:this.f.delete(oe),X(Y.data);break;case u.PromiseError:{this.f.delete(oe);const ae=new Error(Y.data.message);ae.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,ae.name=Y.data.name,he(ae);break}case u.PromiseErrorObj:this.f.delete(oe),he(Y.data);break}};this.f.set(oe,W),this.p(x)};let U=null;this.b===f.Idle?B():(U=(0,s.$sh)(W=>this.u()),U.then(()=>{U=null,B()}));const H=()=>{U?(U.cancel(),U=null):this.p({id:oe,type:$.PromiseCancel}),he(new A.$4)},F=me.onCancellationRequested(H);G=(0,o.$Rc)((0,o.$Sc)(H),F),this.d.add(G)}).finally(()=>{G.dispose(),this.d.delete(G)})}o(V,ne,re){const me=this.g++,oe=$.EventListen,ie={id:me,type:oe,channelName:V,name:ne,arg:re};let x=null;const G=new y.$le({onWillAddFirstListener:()=>{x=(0,s.$sh)(X=>this.u()),x.then(()=>{x=null,this.d.add(G),this.p(ie)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(G),this.p({id:me,type:$.EventDispose}))}}),T=X=>G.fire(X.data);return this.f.set(me,T),G.event}p(V){switch(V.type){case $.Promise:case $.EventListen:{const ne=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ne,V.id,R.LocalSide,`${a(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case $.PromiseCancel:case $.EventDispose:{const ne=this.q([V.type,V.id]);this.j?.logOutgoing(ne,V.id,R.LocalSide,a(V.type));return}}}q(V,ne=void 0){const re=new p;return c(re,V),c(re,ne),this.r(re.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ne=new i(V),re=S(ne),me=S(ne),oe=re[0];switch(oe){case u.Initialize:return this.j?.logIncoming(V.byteLength,0,R.LocalSide,d(oe)),this.t({type:re[0]});case u.PromiseSuccess:case u.PromiseError:case u.EventFire:case u.PromiseErrorObj:return this.j?.logIncoming(V.byteLength,re[1],R.LocalSide,d(oe),me),this.t({type:re[0],id:re[1],data:me})}}t(V){if(V.type===u.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,o.$Pc)(this.d.values()),this.d.clear()}}e.$ii=L,Be([C.$0h],L.prototype,"onDidInitializePromise",null);class O{get connections(){const V=[];return this.f.forEach(ne=>V.push(ne)),V}constructor(V,ne,re){this.a=new Map,this.f=new Set,this.g=new y.$le,this.onDidAddConnection=this.g.event,this.h=new y.$le,this.onDidRemoveConnection=this.h.event,this.j=new o.$Tc,this.j.add(V(({protocol:me,onDidClientDisconnect:oe})=>{const ie=y.Event.once(me.onMessage);this.j.add(ie(x=>{const G=new i(x),T=S(G),X=new I(me,T,ne,re),he=new L(me,ne);this.a.forEach((U,H)=>X.registerChannel(H,U));const B={channelServer:X,channelClient:he,ctx:T};this.f.add(B),this.g.fire(B),this.j.add(oe(()=>{X.dispose(),he.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,ne){const re=this;return{call(me,oe,ie){let x;if((0,m.$sg)(ne)){const T=(0,t.$2b)(re.connections.filter(ne));x=T?Promise.resolve(T):y.Event.toPromise(y.Event.filter(re.onDidAddConnection,ne))}else x=ne.routeCall(re,me,oe);const G=x.then(T=>T.channelClient.getChannel(V));return q(G).call(me,oe,ie)},listen(me,oe){if((0,m.$sg)(ne))return re.k(V,ne,me,oe);const ie=ne.routeEvent(re,me,oe).then(x=>x.channelClient.getChannel(V));return q(ie).listen(me,oe)}}}k(V,ne,re,me){const oe=this;let ie;const x=new y.$le({onWillAddFirstListener:()=>{ie=new o.$Tc;const G=new y.$re,T=new Map,X=B=>{const H=B.channelClient.getChannel(V).listen(re,me),F=G.add(H);T.set(B,F)},he=B=>{const U=T.get(B);U&&(U.dispose(),T.delete(B))};oe.connections.filter(ne).forEach(X),y.Event.filter(oe.onDidAddConnection,ne)(X,void 0,ie),oe.onDidRemoveConnection(he,void 0,ie),G.event(x.fire,x,ie),ie.add(G)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return x.event}registerChannel(V,ne){this.a.set(V,ne);for(const re of this.f)re.channelServer.registerChannel(V,ne)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=O;class P{constructor(V,ne,re=null){const me=new p;c(me,ne),V.send(me.buffer),this.a=new L(V,re),this.d=new I(V,ne,re)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ne){this.d.registerChannel(V,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=P;function q(M){return{call(V,ne,re){return M.then(me=>me.call(V,ne,re))},listen(V,ne){const re=new y.$ue;return M.then(me=>re.input=me.listen(V,ne)),re.event}}}function K(M){let V=!1;return{call(ne,re,me){return V?M.call(ne,re,me):(0,s.$Gh)(0).then(()=>V=!0).then(()=>M.call(ne,re,me))},listen(ne,re){if(V)return M.listen(ne,re);const me=new y.$ue;return(0,s.$Gh)(0).then(()=>V=!0).then(()=>me.input=M.listen(ne,re)),me.event}}}class J{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ne of V.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await y.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$ni=J;var _;(function(M){function V(oe,ie,x){const G=oe,T=x&&x.disableMarshalling,X=new Map;for(const he in G)re(he)&&X.set(he,y.Event.buffer(G[he],!0,void 0,ie));return new class{listen(he,B,U){const H=X.get(B);if(H)return H;const F=G[B];if(typeof F=="function"){if(me(B))return F.call(G,U);if(re(B))return X.set(B,y.Event.buffer(G[B],!0,void 0,ie)),X.get(B)}throw new A.$ab(`Event not found: ${B}`)}call(he,B,U){const H=G[B];if(typeof H=="function"){if(!T&&Array.isArray(U))for(let W=0;W<U.length;W++)U[W]=(0,D.$ci)(U[W]);let F=H.apply(G,U);return F instanceof Promise||(F=Promise.resolve(F)),F}throw new A.$ab(`Method not found: ${B}`)}}}M.fromService=V;function ne(oe,ie){const x=ie&&ie.disableMarshalling;return new Proxy({},{get(G,T){if(typeof T=="string")return ie?.properties?.has(T)?ie.properties.get(T):me(T)?function(X){return oe.listen(T,X)}:re(T)?oe.listen(T):async function(...X){let he;ie&&!(0,m.$ng)(ie.context)?he=[ie.context,...X]:he=X;const B=await oe.call(T,he);return x?B:(0,D.$ci)(B)};throw new A.$ab(`Property not found: ${String(T)}`)}})}M.toService=ne;function re(oe){return oe[0]==="o"&&oe[1]==="n"&&w.$Ef(oe.charCodeAt(2))}function me(oe){return/^onDynamic/.test(oe)&&w.$Ef(oe.charCodeAt(9))}})(_||(e.ProxyChannel=_={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const V=M.toString();if(V!=="[object Object]")return V}return M}function le(M){return Array.isArray(M)?M.map(ge):ge(M)}function z(M,V,ne,re,me,oe,ie){ie=le(ie);const x=de[me],G=x[re%x.length];let T=[`%c[${M}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(oe)?(T=T.concat(ie),T.push(")")):T.push(ie),console.log.apply(console,T)}class Q{constructor(V,ne){this.d=V,this.f=ne,this.a=0,this.b=0}logOutgoing(V,ne,re,me,oe){this.b+=V,z(this.d,this.b,V,ne,re,me,oe)}logIncoming(V,ne,re,me,oe){this.a+=V,z(this.f,this.a,V,ne,re,me,oe)}}e.$oi=Q}),define(Re[60],Ae([1,0,14,6,2,49]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var A;(function(r){r.enableDiagnostics=!1,r.records=[];const h=new WeakMap;let c=0;function S(R,L){if(!h.has(R)){const O=String(++c);h.set(R,O)}return h.get(R)}function I(R,L,O,P){if(!r.enableDiagnostics)return;const q=S(R,L);if(P instanceof t.$Ne||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const K=t.$Ne.alloc(P.byteLength);K.set(P),r.records.push({timestamp:Date.now(),id:q,label:L,type:O,buff:K})}else r.records.push({timestamp:Date.now(),id:q,label:L,type:O,data:P})}r.traceSocketEvent=I})(A||(e.SocketDiagnostics=A={}));var y;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let o=null;function D(){return o||(o=t.$Ne.alloc(0)),o}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,c){if(h===0)return D();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const L=this.a[0];return c&&(this.a.shift(),this.b-=h),L}if(this.a[0].byteLength>h){const L=this.a[0].slice(0,h);return c&&(this.a[0]=this.a[0].slice(h),this.b-=h),L}const S=t.$Ne.alloc(h);let I=0,R=0;for(;h>0;){const L=this.a[R];if(L.byteLength>h){const O=L.slice(0,h);S.set(O,I),I+=h,c&&(this.a[R]=L.slice(h),this.b-=h),h-=h}else S.set(L,I),I+=L.byteLength,c?(this.a.shift(),this.b-=L.byteLength):R++,h-=L.byteLength}return S}}e.$pi=w;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(m||(m={}));function $(r){switch(r){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var a;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class u{constructor(h,c,S,I){this.type=h,this.id=c,this.ack=S,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends E.$Uc{constructor(h){super(),this.f=this.B(new s.$le),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:m.None,id:0,ack:0},this.a=h,this.b=!1,this.c=new w,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent(C.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,I=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(C.ProtocolMessageRead,c),this.f.fire(new u(S,I,R,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=t.$Ne.alloc(a.HeaderLength);c.writeUInt8(h.type,0),c.writeUInt32BE(h.id,1),c.writeUInt32BE(h.ack,5),c.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent(C.ProtocolHeaderWrite,{messageType:$(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent(C.ProtocolMessageWrite,h.data),this.j(c,h.data)}g(h,c){const S=this.f===0;return this.d.push(h,c),this.f+=h.byteLength+c.byteLength,S}h(){const h=t.$Ne.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,c){this.g(h,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent(C.ProtocolWrite,{byteLength:h.byteLength}),this.c.write(h)}}class v extends E.$Uc{constructor(h){super(),this.f=new s.$le,this.onMessage=this.f.event,this.g=new s.$le,this.onDidDispose=this.g.event,this.a=h,this.b=this.B(new f(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(c=>{c.type===m.Regular&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new u(m.Regular,0,0,h))}}e.$qi=v;class g extends k.$ki{static fromSocket(h,c){return new g(new v(h),c)}get onDidDispose(){return this.b.onDidDispose}constructor(h,c,S=null){super(h,c,S),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.$ri=g;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new s.$le({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.$si=b;class i{constructor(h){this.data=h,this.next=null}}class p{constructor(){this.a=null,this.b=null}length(){let h=0,c=this.a;for(;c;)c=c.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let c=0,S=this.a;for(;S;)h[c++]=S.data,S=S.next;return h}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const c=new i(h);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const h=Date.now();for(let c=0;c<n.a;c++)this.c[c]=h-1e3*c;setInterval(()=>{for(let c=n.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),c=(1+n.a)*1e3;let S=0;for(let I=0;I<n.a;I++)h-this.c[I]<=c&&S++;return 1-S/n.a}hasHighLoad(){return this.d()>=.5}}class l{get unacknowledgedCount(){return this.d-this.f}constructor(h){this.v=new b,this.onControlMessage=this.v.event,this.w=new b,this.onMessage=this.w.event,this.x=new b,this.onDidDispose=this.x.event,this.y=new b,this.onSocketClose=this.y.event,this.z=new b,this.onSocketTimeout=this.z.event,this.t=h.loadEstimator??n.getInstance(),this.u=h.sendKeepAlive??!0,this.a=!1,this.c=new p,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Tc,this.p=h.socket,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new d(this.p)),this.s.add(this.r.onMessage(c=>this.A(c))),this.s.add(this.p.onClose(c=>this.y.fire(c))),h.initialChunk&&this.r.acceptChunk(h.initialChunk),this.u?this.m=setInterval(()=>{this.E()},a.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const h=new u(m.Disconnect,0,0,D());this.q.write(h),this.q.flush()}}sendPause(){const h=new u(m.Pause,0,0,D());this.q.write(h)}sendResume(){const h=new u(m.Resume,0,0,D());this.q.write(h)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(h,c){this.a=!0,this.s.dispose(),this.s=new E.$Tc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=h,this.q=this.s.add(new f(this.p)),this.r=this.s.add(new d(this.p)),this.s.add(this.r.onMessage(S=>this.A(S))),this.s.add(this.p.onClose(S=>this.y.fire(S))),this.r.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.j=this.h;const h=new u(m.Ack,0,this.j,D());this.q.write(h);const c=this.c.toArray();for(let S=0,I=c.length;S<I;S++)this.q.write(c[S]);this.C()}acceptDisconnect(){this.x.fire()}A(h){if(h.ack>this.f){this.f=h.ack;do{const c=this.c.peek();if(c&&c.id<=h.ack)this.c.pop();else break}while(!0)}switch(h.type){case m.None:break;case m.Regular:{if(h.id>this.h)if(h.id!==this.h+1){const c=Date.now();c-this.n>1e4&&(this.n=c,this.q.write(new u(m.ReplayRequest,0,0,D())))}else this.h=h.id,this.k=Date.now(),this.B(),this.w.fire(h.data);break}case m.Control:{this.v.fire(h.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const c=this.c.toArray();for(let S=0,I=c.length;S<I;S++)this.q.write(c[S]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(h){const c=++this.d;this.j=this.h;const S=new u(m.Regular,c,this.j,h);this.c.push(S),this.a||(this.q.write(S),this.C())}sendControl(h){const c=new u(m.Control,0,0,h);this.q.write(c)}B(){if(this.h<=this.j||this.l)return;const h=Date.now()-this.k;if(h>=a.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},a.AcknowledgeTime-h+5)}C(){if(this.d<=this.f||this.g||this.a)return;const h=this.c.peek(),c=Date.now()-h.writtenTime,S=Date.now()-this.r.lastReadTime,I=Date.now()-this.o;if(c>=a.TimeoutTime&&S>=a.TimeoutTime&&I>=a.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:S});return}const R=Math.max(a.TimeoutTime-c,a.TimeoutTime-S,a.TimeoutTime-I,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const h=new u(m.Ack,0,this.j,D());this.q.write(h)}E(){this.j=this.h;const h=new u(m.KeepAlive,0,this.j,D());this.q.write(h)}}e.$ti=l}),define(Re[115],Ae([1,0,59,13,14,18,175,9,6,2,20,112,66,49]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0,A=Ue(A);class a extends $.$hi{constructor(f){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",v=>E.$Ne.wrap(Buffer.from(v,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$hr=a;class u{constructor(f,v){this.i=f,this.j=v,this.c=new Set,this.g=new Map,this.h=new y.$le,this.onDidProcessExit=this.h.event;const g=v&&v.timeout?v.timeout:6e4;this.b=new s.$Ch(g),this.d=null,this.f=null}getChannel(f){const v=this;return{call(g,b,i){return v.k(f,g,b,i)},listen(g,b){return v.l(f,g,b)}}}k(f,v,g,b=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(A.$5());this.b.cancel();const i=this.n(f),p=(0,s.$sh)(r=>i.call(v,g,r)),n=b.onCancellationRequested(()=>p.cancel()),l=(0,o.$Sc)(()=>p.cancel());return this.c.add(l),p.finally(()=>{n.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),p}l(f,v,g){if(!this.b)return y.Event.None;this.b.cancel();let b;const i=new y.$le({onWillAddFirstListener:()=>{b=this.n(f).listen(v,g)(i.fire,i),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,D.$eo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,m.$mm)(v.env),this.d=(0,t.fork)(this.i,f,v);const g=new y.$le,i=y.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,C.$dr)(c)){(0,C.log)(c,`IPC Library: ${this.j.serverName}`);return}g.fire(E.$Ne.wrap(Buffer.from(c,"base64")))}),p=this.j.useQueue?(0,w.$zm)(this.d):this.d,n=c=>this.d&&this.d.connected&&p.send(c.buffer.toString("base64")),l=g.event,r={send:n,onMessage:l};this.f=new $.$ii(r);const h=()=>this.o();process.once("exit",h),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,S)=>{process.removeListener("exit",h),i.dispose(),this.c.forEach(I=>(0,o.$Pc)(I)),this.c.clear(),c!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:S})})}return this.f}n(f){let v=this.g.get(f);return v||(v=this.m.getChannel(f),this.g.set(f,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$ir=u}),define(Re[184],Ae([1,0,13,6,2,48,10]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.StorageState=e.StorageHint=void 0,e.$dq=y;var A;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function y(m){const $=m;return $?.changed instanceof Map||$?.deleted instanceof Set}var o;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(o||(e.StorageState=o={}));class D extends E.$Uc{static{this.a=100}constructor($,a=Object.create(null)){super(),this.r=$,this.s=a,this.b=this.B(new s.$oe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new t.$Dh(D.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((a,u)=>this.w(u,a)),$.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w($,a){if(this.c===o.Closed)return;let u=!1;(0,C.$ng)(a)?u=this.f.delete($):this.f.get($)!==a&&(this.f.set($,a),u=!0),u&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,a){const u=this.f.get($);return(0,C.$ng)(u)?a:u}getBoolean($,a){const u=this.get($);return(0,C.$ng)(u)?a:u==="true"}getNumber($,a){const u=this.get($);return(0,C.$ng)(u)?a:parseInt(u,10)}getObject($,a){const u=this.get($);return(0,C.$ng)(u)?a:(0,k.$bi)(u)}async set($,a,u=!1){if(this.c===o.Closed)return;if((0,C.$ng)(a))return this.delete($,u);const d=(0,C.$gg)(a)||Array.isArray(a)?(0,k.$ai)(a):String(a);if(this.f.get($)!==d)return this.f.set($,d),this.j.set($,d),this.h.delete($),this.b.fire({key:$,external:u}),this.D()}async delete($,a=!1){if(!(this.c===o.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:a}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===o.Closed||this.m))return this.D($)}async D($){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$eq=D;class w{constructor(){this.onDidChangeItemsExternal=s.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((a,u)=>this.a.set(u,a)),$.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$fq=w}),define(Re[85],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class t{constructor(E,k){this.lineNumber=E,this.column=k}with(E=this.lineNumber,k=this.column){return E===this.lineNumber&&k===this.column?this:new t(E,k)}delta(E=0,k=0){return this.with(this.lineNumber+E,this.column+k)}equals(E){return t.equals(this,E)}static equals(E,k){return!E&&!k?!0:!!E&&!!k&&E.lineNumber===k.lineNumber&&E.column===k.column}isBefore(E){return t.isBefore(this,E)}static isBefore(E,k){return E.lineNumber<k.lineNumber?!0:k.lineNumber<E.lineNumber?!1:E.column<k.column}isBeforeOrEqual(E){return t.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,k){return E.lineNumber<k.lineNumber?!0:k.lineNumber<E.lineNumber?!1:E.column<=k.column}static compare(E,k){const C=E.lineNumber|0,A=k.lineNumber|0;if(C===A){const y=E.column|0,o=k.column|0;return y-o}return C-A}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new t(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Nt=t}),define(Re[50],Ae([1,0,85]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class s{constructor(k,C,A,y){k>A||k===A&&C>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=C):(this.startLineNumber=k,this.startColumn=C,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return s.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return s.containsPosition(this,k)}static containsPosition(k,C){return!(C.lineNumber<k.startLineNumber||C.lineNumber>k.endLineNumber||C.lineNumber===k.startLineNumber&&C.column<k.startColumn||C.lineNumber===k.endLineNumber&&C.column>k.endColumn)}static strictContainsPosition(k,C){return!(C.lineNumber<k.startLineNumber||C.lineNumber>k.endLineNumber||C.lineNumber===k.startLineNumber&&C.column<=k.startColumn||C.lineNumber===k.endLineNumber&&C.column>=k.endColumn)}containsRange(k){return s.containsRange(this,k)}static containsRange(k,C){return!(C.startLineNumber<k.startLineNumber||C.endLineNumber<k.startLineNumber||C.startLineNumber>k.endLineNumber||C.endLineNumber>k.endLineNumber||C.startLineNumber===k.startLineNumber&&C.startColumn<k.startColumn||C.endLineNumber===k.endLineNumber&&C.endColumn>k.endColumn)}strictContainsRange(k){return s.strictContainsRange(this,k)}static strictContainsRange(k,C){return!(C.startLineNumber<k.startLineNumber||C.endLineNumber<k.startLineNumber||C.startLineNumber>k.endLineNumber||C.endLineNumber>k.endLineNumber||C.startLineNumber===k.startLineNumber&&C.startColumn<=k.startColumn||C.endLineNumber===k.endLineNumber&&C.endColumn>=k.endColumn)}plusRange(k){return s.plusRange(this,k)}static plusRange(k,C){let A,y,o,D;return C.startLineNumber<k.startLineNumber?(A=C.startLineNumber,y=C.startColumn):C.startLineNumber===k.startLineNumber?(A=C.startLineNumber,y=Math.min(C.startColumn,k.startColumn)):(A=k.startLineNumber,y=k.startColumn),C.endLineNumber>k.endLineNumber?(o=C.endLineNumber,D=C.endColumn):C.endLineNumber===k.endLineNumber?(o=C.endLineNumber,D=Math.max(C.endColumn,k.endColumn)):(o=k.endLineNumber,D=k.endColumn),new s(A,y,o,D)}intersectRanges(k){return s.intersectRanges(this,k)}static intersectRanges(k,C){let A=k.startLineNumber,y=k.startColumn,o=k.endLineNumber,D=k.endColumn;const w=C.startLineNumber,m=C.startColumn,$=C.endLineNumber,a=C.endColumn;return A<w?(A=w,y=m):A===w&&(y=Math.max(y,m)),o>$?(o=$,D=a):o===$&&(D=Math.min(D,a)),A>o||A===o&&y>D?null:new s(A,y,o,D)}equalsRange(k){return s.equalsRange(this,k)}static equalsRange(k,C){return!k&&!C?!0:!!k&&!!C&&k.startLineNumber===C.startLineNumber&&k.startColumn===C.startColumn&&k.endLineNumber===C.endLineNumber&&k.endColumn===C.endColumn}getEndPosition(){return s.getEndPosition(this)}static getEndPosition(k){return new t.$Nt(k.endLineNumber,k.endColumn)}getStartPosition(){return s.getStartPosition(this)}static getStartPosition(k){return new t.$Nt(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,C){return new s(this.startLineNumber,this.startColumn,k,C)}setStartPosition(k,C){return new s(k,C,this.endLineNumber,this.endColumn)}collapseToStart(){return s.collapseToStart(this)}static collapseToStart(k){return new s(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return s.collapseToEnd(this)}static collapseToEnd(k){return new s(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new s(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,C=k){return new s(k.lineNumber,k.column,C.lineNumber,C.column)}static lift(k){return k?new s(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,C){return!(k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<C.startColumn||C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<k.startColumn)}static areIntersecting(k,C){return!(k.endLineNumber<C.startLineNumber||k.endLineNumber===C.startLineNumber&&k.endColumn<=C.startColumn||C.endLineNumber<k.startLineNumber||C.endLineNumber===k.startLineNumber&&C.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,C){if(k&&C){const o=k.startLineNumber|0,D=C.startLineNumber|0;if(o===D){const w=k.startColumn|0,m=C.startColumn|0;if(w===m){const $=k.endLineNumber|0,a=C.endLineNumber|0;if($===a){const u=k.endColumn|0,d=C.endColumn|0;return u-d}return $-a}return w-m}return o-D}return(k?1:0)-(C?1:0)}static compareRangesUsingEnds(k,C){return k.endLineNumber===C.endLineNumber?k.endColumn===C.endColumn?k.startLineNumber===C.startLineNumber?k.startColumn-C.startColumn:k.startLineNumber-C.startLineNumber:k.endColumn-C.endColumn:k.endLineNumber-C.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.$Ot=s}),define(Re[185],Ae([1,0,50]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=void 0;class s{static insert(k,C){return{range:new t.$Ot(k.lineNumber,k.column,k.lineNumber,k.column),text:C,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,C){return{range:k,text:C}}static replaceMove(k,C){return{range:k,text:C,forceMoveMarkers:!0}}}e.$Pt=s}),define(Re[186],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$lt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[187],Ae([1,0,39,2,79]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=void 0,e.$ot=C,e.$pt=y,e.$qt=o,e.$mt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function k(w=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const $ of e.$mt)w.indexOf($)>=0||(m+="\\"+$);return m+="\\s]+)",new RegExp(m,"g")}e.$nt=k();function C(w){let m=e.$nt;if(w&&w instanceof RegExp)if(w.global)m=w;else{let $="g";w.ignoreCase&&($+="i"),w.multiline&&($+="m"),w.unicode&&($+="u"),m=new RegExp(w.source,$)}return m.lastIndex=0,m}const A=new E.$5c;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(w){const m=A.unshift(w);return(0,s.$Sc)(m)}function o(w,m,$,a,u){if(m=C(m),u||(u=t.Iterable.first(A)),$.length>u.maxLen){let b=w-u.maxLen/2;return b<0?b=0:a+=b,$=$.substring(b,w+u.maxLen/2),o(w,m,$,a,u)}const d=Date.now(),f=w-1-a;let v=-1,g=null;for(let b=1;!(Date.now()-d>=u.timeBudget);b++){const i=f-u.windowSize*b;m.lastIndex=Math.max(0,i);const p=D(m,$,f,v);if(!p&&g||(g=p,i<=0))break;v=i}if(g){const b={word:g[0],startColumn:a+1+g.index,endColumn:a+1+g.index+g[0].length};return m.lastIndex=0,b}return null}function D(w,m,$,a){let u;for(;u=w.exec(m);){const d=u.index||0;if(d<=$&&w.lastIndex>=$)return u;if(a>0&&d>a)return null}return null}}),define(Re[116],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var t;(function(y){y[y.Null=0]="Null",y[y.PlainText=1]="PlainText"})(t||(e.LanguageId=t={}));var s;(function(y){y[y.NotSet=-1]="NotSet",y[y.None=0]="None",y[y.Italic=1]="Italic",y[y.Bold=2]="Bold",y[y.Underline=4]="Underline",y[y.Strikethrough=8]="Strikethrough"})(s||(e.FontStyle=s={}));var E;(function(y){y[y.None=0]="None",y[y.DefaultForeground=1]="DefaultForeground",y[y.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var k;(function(y){y[y.Other=0]="Other",y[y.Comment=1]="Comment",y[y.String=2]="String",y[y.RegEx=3]="RegEx"})(k||(e.StandardTokenType=k={}));var C;(function(y){y[y.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",y[y.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",y[y.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",y[y.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",y[y.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",y[y.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",y[y.ITALIC_MASK=2048]="ITALIC_MASK",y[y.BOLD_MASK=4096]="BOLD_MASK",y[y.UNDERLINE_MASK=8192]="UNDERLINE_MASK",y[y.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",y[y.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",y[y.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",y[y.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",y[y.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",y[y.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",y[y.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",y[y.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",y[y.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",y[y.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",y[y.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",y[y.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",y[y.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(C||(e.MetadataConsts=C={}));class A{static getLanguageId(o){return(o&C.LANGUAGEID_MASK)>>>C.LANGUAGEID_OFFSET}static getTokenType(o){return(o&C.TOKEN_TYPE_MASK)>>>C.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(o){return(o&C.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(o){return(o&C.FONT_STYLE_MASK)>>>C.FONT_STYLE_OFFSET}static getForeground(o){return(o&C.FOREGROUND_MASK)>>>C.FOREGROUND_OFFSET}static getBackground(o){return(o&C.BACKGROUND_MASK)>>>C.BACKGROUND_OFFSET}static getClassNameFromMetadata(o){let w="mtk"+this.getForeground(o);const m=this.getFontStyle(o);return m&s.Italic&&(w+=" mtki"),m&s.Bold&&(w+=" mtkb"),m&s.Underline&&(w+=" mtku"),m&s.Strikethrough&&(w+=" mtks"),w}static getInlineStyleFromMetadata(o,D){const w=this.getForeground(o),m=this.getFontStyle(o);let $=`color: ${D[w]};`;m&s.Italic&&($+="font-style: italic;"),m&s.Bold&&($+="font-weight: bold;");let a="";return m&s.Underline&&(a+=" underline"),m&s.Strikethrough&&(a+=" line-through"),a&&($+=`text-decoration:${a};`),$}static getPresentationFromMetadata(o){const D=this.getForeground(o),w=this.getFontStyle(o);return{foreground:D,italic:!!(w&s.Italic),bold:!!(w&s.Bold),underline:!!(w&s.Underline),strikethrough:!!(w&s.Strikethrough)}}}e.$vu=A}),define(Re[188],Ae([1,0,20]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$ew=e.$dw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$fw=a,e.$jw=b;var s;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(s||(e.OverviewRulerLane=s={}));var E;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(E||(e.GlyphMarginLane=E={}));var k;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(k||(e.MinimapPosition=k={}));var C;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(C||(e.MinimapSectionHeaderStyle=C={}));var A;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var y;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(y||(e.EndOfLinePreference=y={}));var o;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(o||(e.DefaultEndOfLine=o={}));var D;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(D||(e.EndOfLineSequence=D={}));class w{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=!!p.insertSpaces,this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=!!p.trimAutoWhitespace,this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,t.$io)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.$dw=w;class m{constructor(p,n){this._findMatchBrand=void 0,this.range=p,this.matches=n}}e.$ew=m;var $;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function a(i){return i&&typeof i.read=="function"}var u;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(u||(e.PositionAffinity=u={}));var d;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d||(e.ModelConstants=d={}));class f{constructor(p,n,l,r,h,c){this.identifier=p,this.range=n,this.text=l,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=h,this._isTracked=c}}e.$gw=f;class v{constructor(p,n,l){this.regex=p,this.wordSeparators=n,this.simpleSearch=l}}e.$hw=v;class g{constructor(p,n,l){this.reverseEdits=p,this.changes=n,this.trimAutoWhitespaceLineNumbers=l}}e.$iw=g;function b(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(Re[189],Ae([1,0,6,2,116]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yu=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$le,this.onDidChange=this.c.event,this.d=null}handleChange(y){this.c.fire({changedLanguages:y,changedColorMap:!1})}register(y,o){return this.a.set(y,o),this.handleChange([y]),(0,s.$Sc)(()=>{this.a.get(y)===o&&(this.a.delete(y),this.handleChange([y]))})}get(y){return this.a.get(y)||null}registerFactory(y,o){this.b.get(y)?.dispose();const D=new C(this,y,o);return this.b.set(y,D),(0,s.$Sc)(()=>{const w=this.b.get(y);!w||w!==D||(this.b.delete(y),w.dispose())})}async getOrCreate(y){const o=this.get(y);if(o)return o;const D=this.b.get(y);return!D||D.isResolved?null:(await D.resolve(),this.get(y))}isResolved(y){if(this.get(y))return!0;const D=this.b.get(y);return!!(!D||D.isResolved)}setColorMap(y){this.d=y,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>E.ColorId.DefaultBackground?this.d[E.ColorId.DefaultBackground]:null}}e.$yu=k;class C extends s.$Uc{get isResolved(){return this.c}constructor(y,o,D){super(),this.f=y,this.g=o,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const y=await this.h.tokenizationSupport;this.c=!0,y&&!this.a&&this.B(this.f.register(this.g,y))}}}),define(Re[7],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=E,e.localize2=C;const t=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function s(A,y){let o;return y.length===0?o=A:o=A.replace(/\{(\d+)\}/g,(D,w)=>{const m=w[0],$=y[m];let a=D;return typeof $=="string"?a=$:(typeof $=="number"||typeof $=="boolean"||$===void 0||$===null)&&(a=String($)),a}),t&&(o="\uFF3B"+o.replace(/[aouei]/g,"$&$&")+"\uFF3D"),o}function E(A,y,...o){return s(typeof A=="number"?k(A,y):y,o)}function k(A,y){const o=globalThis._VSCODE_NLS_MESSAGES?.[A];if(typeof o!="string"){if(typeof y=="string")return y;throw new Error(`!!! NLS MISSING: ${A} !!!`)}return o}function C(A,y,...o){let D;typeof A=="number"?D=k(A,y):D=y;const w=s(D,o);return{value:w,original:y===D?w:s(y,o)}}}),define(Re[190],Ae([1,0,6,2,7]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=D,E=Ue(E);class k extends s.$Uc{constructor(m,$="",a="",u=!0,d){super(),this.j=this.B(new t.$le),this.onDidChange=this.j.event,this.z=!0,this.m=m,this.n=$,this.w=a,this.z=u,this.D=d}get id(){return this.m}get label(){return this.n}set label(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.j.fire({label:m}))}get tooltip(){return this.u||""}set tooltip(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.j.fire({tooltip:m}))}get class(){return this.w}set class(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.j.fire({class:m}))}get enabled(){return this.z}set enabled(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.j.fire({enabled:m}))}get checked(){return this.C}set checked(m){this.J(m)}J(m){this.C!==m&&(this.C=m,this.j.fire({checked:m}))}async run(m,$){this.D&&await this.D(m)}}e.$kj=k;class C extends s.$Uc{constructor(){super(...arguments),this.f=this.B(new t.$le),this.onWillRun=this.f.event,this.m=this.B(new t.$le),this.onDidRun=this.m.event}async run(m,$){if(!m.enabled)return;this.f.fire({action:m});let a;try{await this.u(m,$)}catch(u){a=u}this.m.fire({action:m,error:a})}async u(m,$){await m.run($)}}e.$lj=C;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let $=[];for(const a of m)a.length&&($.length?$=[...$,new A,...a]:$=a);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=A;class y{get actions(){return this.a}constructor(m,$,a,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=$,this.class=u,this.a=a}async run(){}}e.$nj=y;class o extends k{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,E.localize(13050,null),void 0,!1)}}e.$oj=o;function D(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...m)=>w.run(...m)}}}),define(Re[191],Ae([1,0,7]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=o,e.$3m=D,e.$4m=w;const s=60,E=s*60,k=E*24,C=k*7,A=k*30,y=k*365;function o(m,$,a,u){typeof m!="number"&&(m=m.getTime());const d=Math.round((new Date().getTime()-m)/1e3);if(d<-30)return(0,t.localize)(12987,null,o(new Date().getTime()+d*1e3,!1));if(!u&&d<30)return(0,t.localize)(12988,null);let f;return d<s?(f=d,$?f===1?a?(0,t.localize)(12989,null,f):(0,t.localize)(12990,null,f):a?(0,t.localize)(12991,null,f):(0,t.localize)(12992,null,f):f===1?a?(0,t.localize)(12993,null,f):(0,t.localize)(12994,null,f):a?(0,t.localize)(12995,null,f):(0,t.localize)(12996,null,f)):d<E?(f=Math.floor(d/s),$?f===1?a?(0,t.localize)(12997,null,f):(0,t.localize)(12998,null,f):a?(0,t.localize)(12999,null,f):(0,t.localize)(13e3,null,f):f===1?a?(0,t.localize)(13001,null,f):(0,t.localize)(13002,null,f):a?(0,t.localize)(13003,null,f):(0,t.localize)(13004,null,f)):d<k?(f=Math.floor(d/E),$?f===1?a?(0,t.localize)(13005,null,f):(0,t.localize)(13006,null,f):a?(0,t.localize)(13007,null,f):(0,t.localize)(13008,null,f):f===1?a?(0,t.localize)(13009,null,f):(0,t.localize)(13010,null,f):a?(0,t.localize)(13011,null,f):(0,t.localize)(13012,null,f)):d<C?(f=Math.floor(d/k),$?f===1?(0,t.localize)(13013,null,f):(0,t.localize)(13014,null,f):f===1?(0,t.localize)(13015,null,f):(0,t.localize)(13016,null,f)):d<A?(f=Math.floor(d/C),$?f===1?a?(0,t.localize)(13017,null,f):(0,t.localize)(13018,null,f):a?(0,t.localize)(13019,null,f):(0,t.localize)(13020,null,f):f===1?a?(0,t.localize)(13021,null,f):(0,t.localize)(13022,null,f):a?(0,t.localize)(13023,null,f):(0,t.localize)(13024,null,f)):d<y?(f=Math.floor(d/A),$?f===1?a?(0,t.localize)(13025,null,f):(0,t.localize)(13026,null,f):a?(0,t.localize)(13027,null,f):(0,t.localize)(13028,null,f):f===1?a?(0,t.localize)(13029,null,f):(0,t.localize)(13030,null,f):a?(0,t.localize)(13031,null,f):(0,t.localize)(13032,null,f)):(f=Math.floor(d/y),$?f===1?a?(0,t.localize)(13033,null,f):(0,t.localize)(13034,null,f):a?(0,t.localize)(13035,null,f):(0,t.localize)(13036,null,f):f===1?a?(0,t.localize)(13037,null,f):(0,t.localize)(13038,null,f):a?(0,t.localize)(13039,null,f):(0,t.localize)(13040,null,f))}function D(m,$){const a=Math.abs(m/1e3);return a<1?$?(0,t.localize)(13041,null,m):(0,t.localize)(13042,null,m):a<s?$?(0,t.localize)(13043,null,Math.round(m)/1e3):(0,t.localize)(13044,null,Math.round(m)/1e3):a<E?$?(0,t.localize)(13045,null,Math.round(m/(1e3*s))):(0,t.localize)(13046,null,Math.round(m/(1e3*s))):a<k?$?(0,t.localize)(13047,null,Math.round(m/(1e3*E))):(0,t.localize)(13048,null,Math.round(m/(1e3*E))):(0,t.localize)(13049,null,Math.round(m/(1e3*k)))}function w(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[44],Ae([1,0,17,10,7]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=y,e.$rj=o,e.$sj=D,t=Ue(t),s=Ue(s),E=Ue(E);function k(w,m){return m&&(w.stack||w.stacktrace)?E.localize(12981,null,A(w),C(w.stack)||C(w.stacktrace)):A(w)}function C(w){return Array.isArray(w)?w.join(`
`):w}function A(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?E.localize(12982,null,w.message):w.message||E.localize(12983,null)}function y(w=null,m=!1){if(!w)return E.localize(12984,null);if(Array.isArray(w)){const $=t.$Gb(w),a=y($[0],m);return $.length>1?E.localize(12985,null,a,$.length):a}if(s.$eg(w))return w;if(w.detail){const $=w.detail;if($.error)return k($.error,m);if($.exception)return k($.exception,m)}return w.stack?k(w,m):w.message?w.message:E.localize(12986,null)}function o(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}function D(w,m){let $;return typeof w=="string"?$=new Error(w):$=w,$.actions=m,$}}),define(Re[192],Ae([1,0,7,42]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=E;function E(k){switch(k){case s.ParseErrorCode.InvalidSymbol:return(0,t.localize)(12972,null);case s.ParseErrorCode.InvalidNumberFormat:return(0,t.localize)(12973,null);case s.ParseErrorCode.PropertyNameExpected:return(0,t.localize)(12974,null);case s.ParseErrorCode.ValueExpected:return(0,t.localize)(12975,null);case s.ParseErrorCode.ColonExpected:return(0,t.localize)(12976,null);case s.ParseErrorCode.CommaExpected:return(0,t.localize)(12977,null);case s.ParseErrorCode.CloseBraceExpected:return(0,t.localize)(12978,null);case s.ParseErrorCode.CloseBracketExpected:return(0,t.localize)(12979,null);case s.ParseErrorCode.EndOfFileExpected:return(0,t.localize)(12980,null);default:return""}}}),define(Re[86],Ae([1,0,23,13,8,10,26,7]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0,e.zip=d,e.$Dq=f,e.$Eq=g,E=Ue(E),A=Ue(A),e.$Aq="end of central directory record signature not found";const y=new RegExp(e.$Aq);class o extends Error{constructor(i,p){let n=p.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=p}}e.$Bq=o;function D(b){const i=b.externalFileAttributes>>16||33188;return[448,56,7].map(p=>i&p).reduce((p,n)=>p+n,i&61440)}function w(b){if(b instanceof o)return b;let i;return y.test(b.message)&&(i="CorruptZip"),new o(i,b)}function m(b,i,p,n,l,r){const h=E.$mc(i),c=E.$jc(n,h);if(!c.startsWith(n))return Promise.reject(new Error(A.localize(12949,null,i)));const S=E.$jc(n,i);let I;return r.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(t.promises.mkdir(c,{recursive:!0})).then(()=>new Promise((R,L)=>{if(!r.isCancellationRequested)try{I=(0,t.createWriteStream)(S,{mode:p}),I.once("close",()=>R()),I.once("error",L),b.once("error",L),b.pipe(I)}catch(O){L(O)}}))}function $(b,i,p,n){let l=(0,s.$sh)(()=>Promise.resolve()),r=0;const h=n.onCancellationRequested(()=>{l.cancel(),b.close()});return new Promise((c,S)=>{const I=new s.$Ah,R=L=>{L.isCancellationRequested||(r++,b.readEntry())};b.once("error",S),b.once("close",()=>l.then(()=>{n.isCancellationRequested||b.entryCount===r?c():S(new o("Incomplete",new Error(A.localize(12950,null,r,b.entryCount))))},S)),b.readEntry(),b.on("entry",L=>{if(n.isCancellationRequested)return;if(!p.sourcePathRegex.test(L.fileName)){R(n);return}const O=L.fileName.replace(p.sourcePathRegex,"");if(/\/$/.test(O)){const K=E.$jc(i,O);l=(0,s.$sh)(J=>t.promises.mkdir(K,{recursive:!0}).then(()=>R(J)).then(void 0,S));return}const P=u(b,L),q=D(L);l=(0,s.$sh)(K=>I.queue(()=>P.then(J=>m(J,O,q,i,p,K).then(()=>R(K)))).then(null,S))})}).finally(()=>h.dispose())}async function a(b,i=!1){const{open:p}=await new Promise((n,l)=>{ue(["yauzl"],n,l)}).then(Ue);return new Promise((n,l)=>{p(b,i?{lazyEntries:!0}:void 0,(r,h)=>{r?l(w(r)):n((0,k.$pg)(h))})})}function u(b,i){return new Promise((p,n)=>{b.openReadStream(i,(l,r)=>{l?n(w(l)):p((0,k.$pg)(r))})})}async function d(b,i){const{ZipFile:p}=await new Promise((n,l)=>{ue(["yazl"],n,l)}).then(Ue);return new Promise((n,l)=>{const r=new p;i.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const h=(0,t.createWriteStream)(b);r.outputStream.pipe(h),r.outputStream.once("error",l),h.once("error",l),h.once("finish",()=>n(b))})}function f(b,i,p={},n){const l=new RegExp(p.sourcePath?`^${p.sourcePath}`:"");let r=a(b,!0);return p.overwrite&&(r=r.then(h=>C.Promises.rm(i).then(()=>h))),r.then(h=>$(h,i,{sourcePathRegex:l},n))}function v(b,i){return a(b).then(p=>new Promise((n,l)=>{p.on("entry",r=>{r.fileName===i&&u(p,r).then(h=>n(h),h=>l(h))}),p.once("close",()=>l(new Error(A.localize(12951,null,i))))}))}function g(b,i){return v(b,i).then(p=>new Promise((n,l)=>{const r=[];p.once("error",l),p.on("data",h=>r.push(h)),p.on("end",()=>n(Buffer.concat(r)))}))}}),define(Re[193],Ae([1,0,56,4,185,50,189,7]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ru=e.$Qu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Pu=e.$Ou=e.SymbolKinds=e.SymbolTag=e.$Mu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Ku=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Ju=e.$Iu=e.$Hu=void 0,e.$Lu=l,e.$Nu=h;class y{constructor(V,ne,re){this.offset=V,this.type=ne,this.language=re,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Hu=y;class o{constructor(V,ne){this.tokens=V,this.endState=ne,this._tokenizationResultBrand=void 0}}e.$Iu=o;class D{constructor(V,ne){this.tokens=V,this.endState=ne,this._encodedTokenizationResultBrand=void 0}}e.$Ju=D;var w;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(w||(e.HoverVerbosityAction=w={}));var m;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(m||(e.CompletionItemKind=m={}));var $;(function(M){const V=new Map;V.set(m.Method,t.$5j.symbolMethod),V.set(m.Function,t.$5j.symbolFunction),V.set(m.Constructor,t.$5j.symbolConstructor),V.set(m.Field,t.$5j.symbolField),V.set(m.Variable,t.$5j.symbolVariable),V.set(m.Class,t.$5j.symbolClass),V.set(m.Struct,t.$5j.symbolStruct),V.set(m.Interface,t.$5j.symbolInterface),V.set(m.Module,t.$5j.symbolModule),V.set(m.Property,t.$5j.symbolProperty),V.set(m.Event,t.$5j.symbolEvent),V.set(m.Operator,t.$5j.symbolOperator),V.set(m.Unit,t.$5j.symbolUnit),V.set(m.Value,t.$5j.symbolValue),V.set(m.Enum,t.$5j.symbolEnum),V.set(m.Constant,t.$5j.symbolConstant),V.set(m.Enum,t.$5j.symbolEnum),V.set(m.EnumMember,t.$5j.symbolEnumMember),V.set(m.Keyword,t.$5j.symbolKeyword),V.set(m.Snippet,t.$5j.symbolSnippet),V.set(m.Text,t.$5j.symbolText),V.set(m.Color,t.$5j.symbolColor),V.set(m.File,t.$5j.symbolFile),V.set(m.Reference,t.$5j.symbolReference),V.set(m.Customcolor,t.$5j.symbolCustomColor),V.set(m.Folder,t.$5j.symbolFolder),V.set(m.TypeParameter,t.$5j.symbolTypeParameter),V.set(m.User,t.$5j.account),V.set(m.Issue,t.$5j.issues);function ne(oe){let ie=V.get(oe);return ie||(console.info("No codicon found for CompletionItemKind "+oe),ie=t.$5j.symbolProperty),ie}M.toIcon=ne;const re=new Map;re.set("method",m.Method),re.set("function",m.Function),re.set("constructor",m.Constructor),re.set("field",m.Field),re.set("variable",m.Variable),re.set("class",m.Class),re.set("struct",m.Struct),re.set("interface",m.Interface),re.set("module",m.Module),re.set("property",m.Property),re.set("event",m.Event),re.set("operator",m.Operator),re.set("unit",m.Unit),re.set("value",m.Value),re.set("constant",m.Constant),re.set("enum",m.Enum),re.set("enum-member",m.EnumMember),re.set("enumMember",m.EnumMember),re.set("keyword",m.Keyword),re.set("snippet",m.Snippet),re.set("text",m.Text),re.set("color",m.Color),re.set("file",m.File),re.set("reference",m.Reference),re.set("customcolor",m.Customcolor),re.set("folder",m.Folder),re.set("type-parameter",m.TypeParameter),re.set("typeParameter",m.TypeParameter),re.set("account",m.User),re.set("issue",m.Issue);function me(oe,ie){let x=re.get(oe);return typeof x>"u"&&!ie&&(x=m.Property),x}M.fromString=me})($||(e.CompletionItemKinds=$={}));var a;(function(M){M[M.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var u;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(u||(e.CompletionItemInsertTextRule=u={}));var d;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(d||(e.PartialAcceptTriggerKind=d={}));var f;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var v;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(v||(e.InlineCompletionTriggerKind=v={}));class g{constructor(V,ne,re,me){this.range=V,this.text=ne,this.completionKind=re,this.isSnippetText=me}equals(V){return k.$Ot.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}e.$Ku=g;var b;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(b||(e.CodeActionTriggerType=b={}));var i;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var p;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(p||(e.SignatureHelpTriggerKind=p={}));var n;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function l(M){return M&&s.URI.isUri(M.uri)&&k.$Ot.isIRange(M.range)&&(k.$Ot.isIRange(M.originSelectionRange)||k.$Ot.isIRange(M.targetSelectionRange))}var r;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(r||(e.SymbolKind=r={})),e.$Mu={[r.Array]:(0,A.localize)(12848,null),[r.Boolean]:(0,A.localize)(12849,null),[r.Class]:(0,A.localize)(12850,null),[r.Constant]:(0,A.localize)(12851,null),[r.Constructor]:(0,A.localize)(12852,null),[r.Enum]:(0,A.localize)(12853,null),[r.EnumMember]:(0,A.localize)(12854,null),[r.Event]:(0,A.localize)(12855,null),[r.Field]:(0,A.localize)(12856,null),[r.File]:(0,A.localize)(12857,null),[r.Function]:(0,A.localize)(12858,null),[r.Interface]:(0,A.localize)(12859,null),[r.Key]:(0,A.localize)(12860,null),[r.Method]:(0,A.localize)(12861,null),[r.Module]:(0,A.localize)(12862,null),[r.Namespace]:(0,A.localize)(12863,null),[r.Null]:(0,A.localize)(12864,null),[r.Number]:(0,A.localize)(12865,null),[r.Object]:(0,A.localize)(12866,null),[r.Operator]:(0,A.localize)(12867,null),[r.Package]:(0,A.localize)(12868,null),[r.Property]:(0,A.localize)(12869,null),[r.String]:(0,A.localize)(12870,null),[r.Struct]:(0,A.localize)(12871,null),[r.TypeParameter]:(0,A.localize)(12872,null),[r.Variable]:(0,A.localize)(12873,null)};function h(M,V){return(0,A.localize)(12874,null,M,e.$Mu[V])}var c;(function(M){M[M.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var S;(function(M){const V=new Map;V.set(r.File,t.$5j.symbolFile),V.set(r.Module,t.$5j.symbolModule),V.set(r.Namespace,t.$5j.symbolNamespace),V.set(r.Package,t.$5j.symbolPackage),V.set(r.Class,t.$5j.symbolClass),V.set(r.Method,t.$5j.symbolMethod),V.set(r.Property,t.$5j.symbolProperty),V.set(r.Field,t.$5j.symbolField),V.set(r.Constructor,t.$5j.symbolConstructor),V.set(r.Enum,t.$5j.symbolEnum),V.set(r.Interface,t.$5j.symbolInterface),V.set(r.Function,t.$5j.symbolFunction),V.set(r.Variable,t.$5j.symbolVariable),V.set(r.Constant,t.$5j.symbolConstant),V.set(r.String,t.$5j.symbolString),V.set(r.Number,t.$5j.symbolNumber),V.set(r.Boolean,t.$5j.symbolBoolean),V.set(r.Array,t.$5j.symbolArray),V.set(r.Object,t.$5j.symbolObject),V.set(r.Key,t.$5j.symbolKey),V.set(r.Null,t.$5j.symbolNull),V.set(r.EnumMember,t.$5j.symbolEnumMember),V.set(r.Struct,t.$5j.symbolStruct),V.set(r.Event,t.$5j.symbolEvent),V.set(r.Operator,t.$5j.symbolOperator),V.set(r.TypeParameter,t.$5j.symbolTypeParameter);function ne(re){let me=V.get(re);return me||(console.info("No codicon found for SymbolKind "+re),me=t.$5j.symbolProperty),me}M.toIcon=ne})(S||(e.SymbolKinds=S={}));class I{static asEditOperation(V){return E.$Pt.replace(k.$Ot.lift(V.range),V.text)}}e.$Ou=I;class R{static{this.Comment=new R("comment")}static{this.Imports=new R("imports")}static{this.Region=new R("region")}static fromValue(V){switch(V){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(V)}constructor(V){this.value=V}}e.$Pu=R;var L;(function(M){M[M.AIGenerated=1]="AIGenerated"})(L||(e.NewSymbolNameTag=L={}));var O;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(O||(e.NewSymbolNameTriggerKind=O={}));var P;(function(M){function V(ne){return!ne||typeof ne!="object"?!1:typeof ne.id=="string"&&typeof ne.title=="string"}M.is=V})(P||(e.Command=P={}));var q;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(q||(e.CommentThreadCollapsibleState=q={}));var K;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(K||(e.CommentThreadState=K={}));var J;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(J||(e.CommentThreadApplicability=J={}));var _;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(_||(e.CommentMode=_={}));var de;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(de||(e.CommentState=de={}));var ge;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(ge||(e.InlayHintKind=ge={}));class le{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Qu=le,e.$Ru=new C.$yu;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var Q;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Q||(e.InlineEditTriggerKind=Q={}))}),define(Re[194],Ae([1,0,34,9,7]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var k;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(k||(e.TokenType=k={}));function C(...D){switch(D.length){case 1:return(0,E.localize)(11585,null,D[0]);case 2:return(0,E.localize)(11586,null,D[0],D[1]);case 3:return(0,E.localize)(11587,null,D[0],D[1],D[2]);default:return}}const A=(0,E.localize)(11588,null),y=(0,E.localize)(11589,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return w.isTripleEq?"===":"==";case k.NotEq:return w.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return w.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return w.lexeme;case k.QuotedStr:return w.lexeme;case k.Error:return w.lexeme;case k.EOF:return"EOF";default:throw(0,s.$7)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case t.CharCode.OpenParen:this.k(k.LParen);break;case t.CharCode.CloseParen:this.k(k.RParen);break;case t.CharCode.ExclamationMark:if(this.h(t.CharCode.Equals)){const m=this.h(t.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:m})}else this.k(k.Neg);break;case t.CharCode.SingleQuote:this.o();break;case t.CharCode.Slash:this.q();break;case t.CharCode.Equals:if(this.h(t.CharCode.Equals)){const m=this.h(t.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:m})}else this.h(t.CharCode.Tilde)?this.k(k.RegexOp):this.l(C("==","=~"));break;case t.CharCode.LessThan:this.k(this.h(t.CharCode.Equals)?k.LtEq:k.Lt);break;case t.CharCode.GreaterThan:this.k(this.h(t.CharCode.Equals)?k.GtEq:k.Gt);break;case t.CharCode.Ampersand:this.h(t.CharCode.Ampersand)?this.k(k.And):this.l(C("&&"));break;case t.CharCode.Pipe:this.h(t.CharCode.Pipe)?this.k(k.Or):this.l(C("||"));break;case t.CharCode.Space:case t.CharCode.CarriageReturn:case t.CharCode.Tab:case t.CharCode.LineFeed:case t.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?t.CharCode.Null:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const m=this.d,$=this.c.substring(this.d,this.e),a={type:k.Error,offset:this.d,lexeme:$};this.g.push({offset:m,lexeme:$,additionalInfo:w}),this.f.push(a)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const m=this.c.substring(this.d,this.e),$=o.b.get(m);$?this.k($):this.f.push({type:k.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==t.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,m=!1,$=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(y);return}const u=this.c.charCodeAt(w);if(m)m=!1;else if(u===t.CharCode.Slash&&!$){w++;break}else u===t.CharCode.OpenSquareBracket?$=!0:u===t.CharCode.Backslash?m=!0:u===t.CharCode.CloseSquareBracket&&($=!1);w++}for(;w<this.c.length&&o.a.has(this.c.charCodeAt(w));)w++;this.e=w;const a=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=o}),define(Re[195],Ae([1,0,6,2]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=void 0;class E{constructor(){this.a=new t.$le,this.b=new t.$le,this.c=new t.$le,this.d=new t.$le}static{this.ChannelName="extensionhostdebugservice"}call(A,y,o){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:o[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:o[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:o[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:o[0],port:o[1],subId:o[2]}))}throw new Error("Method not implemented.")}listen(A,y,o){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Zo=E;class k extends s.$Uc{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,y,o){this.b.call("attach",[A,y,o])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,y){this.b.call("terminate",[A,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,y){return this.b.call("openExtensionDevelopmentHostWindow",[A,y])}}e.$1o=k}),define(Re[196],Ae([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=void 0;class s{constructor(C){this.a=C}listen(C,A,y){throw new Error("Invalid listen")}call(C,A,y){switch(A){case"download":return this.a.download(t.URI.revive(y[0]),t.URI.revive(y[1]))}throw new Error("Invalid call")}}e.$3o=s;class E{constructor(C,A){this.a=C,this.b=A}async download(C,A){const y=this.b();y&&(C=y.transformOutgoingURI(C),A=y.transformOutgoingURI(A)),await this.a.call("download",[C,A])}}e.$4o=E}),define(Re[197],Ae([1,0,191,77,12,8,31,19,4]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=D,e.$8m=w,e.$5m=/^([^.]+\..+)[:=](.+)$/;class o{get appRoot(){return(0,k.$mc)(E.$Zg.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,k.$jc)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,A.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,t.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$jc)(this.userDataPath,"logs",$)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$gh)(y.URI.file((0,k.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=C.env.VSCODE_PORTABLE;return $?y.URI.file((0,k.$jc)($,"argv.json")):(0,A.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,k.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,k.$kc)($):(0,k.$hc)((0,k.$jc)(E.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?y.URI.file((0,k.$kc)($)):y.URI.file((0,k.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,k.$kc)($);const a=C.env.VSCODE_EXTENSIONS;if(a)return a;const u=C.env.VSCODE_PORTABLE;return u?(0,k.$jc)(u,"extensions"):(0,A.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(a=>/^[^:/?#]+?:\/\//.test(a)?y.URI.parse(a):y.URI.file((0,k.$hc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?y.URI.parse($):y.URI.file((0,k.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$5m.test($))}get extensionLogLevel(){const $=[];for(const a of this.args.log||[]){const u=e.$5m.exec(a);u&&u[1]&&u[2]&&$.push([u[1],u[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,A.$gh)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=C.env.VSCODE_PORTABLE;return $?y.URI.file((0,k.$jc)($,"policy.json")):(0,A.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,a,u){this.a=$,this.b=a,this.c=u,this.editSessionId=this.args.editSessionId}}e.$6m=o,Be([s.$0h],o.prototype,"appRoot",null),Be([s.$0h],o.prototype,"userHome",null),Be([s.$0h],o.prototype,"userDataPath",null),Be([s.$0h],o.prototype,"appSettingsHome",null),Be([s.$0h],o.prototype,"tmpDir",null),Be([s.$0h],o.prototype,"cacheHome",null),Be([s.$0h],o.prototype,"stateResource",null),Be([s.$0h],o.prototype,"userRoamingDataHome",null),Be([s.$0h],o.prototype,"userDataSyncHome",null),Be([s.$0h],o.prototype,"sync",null),Be([s.$0h],o.prototype,"machineSettingsResource",null),Be([s.$0h],o.prototype,"workspaceStorageHome",null),Be([s.$0h],o.prototype,"localHistoryHome",null),Be([s.$0h],o.prototype,"keyboardLayoutResource",null),Be([s.$0h],o.prototype,"argvResource",null),Be([s.$0h],o.prototype,"isExtensionDevelopment",null),Be([s.$0h],o.prototype,"untitledWorkspacesHome",null),Be([s.$0h],o.prototype,"builtinExtensionsPath",null),Be([s.$0h],o.prototype,"extensionsPath",null),Be([s.$0h],o.prototype,"extensionDevelopmentLocationURI",null),Be([s.$0h],o.prototype,"extensionDevelopmentKind",null),Be([s.$0h],o.prototype,"extensionTestsLocationURI",null),Be([s.$0h],o.prototype,"debugExtensionHost",null),Be([s.$0h],o.prototype,"logLevel",null),Be([s.$0h],o.prototype,"extensionLogLevel",null),Be([s.$0h],o.prototype,"serviceMachineIdResource",null),Be([s.$0h],o.prototype,"disableTelemetry",null),Be([s.$0h],o.prototype,"disableWorkspaceTrust",null),Be([s.$0h],o.prototype,"useInMemorySecretStorage",null),Be([s.$0h],o.prototype,"policyFile",null);function D(m,$){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,$,m.debugId,m.extensionEnvironment)}function w(m,$,a,u,d,f){const g=Number($||m)||(u?null:a),b=g?!!$:!1;let i;if(f)try{i=JSON.parse(f)}catch{}return{port:g,break:b,debugId:d,env:i}}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[69],Ae([1,0,287,3,7]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=A,e.$Em=o,e.$Fm=$,e.$Gm=a,t=dt(t);const k={o:(0,E.localize)(11522,null),e:(0,E.localize)(11523,null),t:(0,E.localize)(11524,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(11525,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(11526,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(11527,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(11528,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(11529,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(11530,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(11531,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(11532,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11533,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(11534,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(11535,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(11536,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(11537,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(11538,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(11539,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(11540,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(11541,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(11542,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(11543,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(11544,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(11545,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(11546,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(11547,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(11548,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(11549,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(11550,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(11551,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(11552,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(11553,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(11554,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(11555,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(11556,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(11557,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(11558,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(11559,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(11560,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(u,d,f=C){const v=u.find(c=>c.length>0&&c[0]!=="-"),g={},b=["_"],i=[],p={};let n;for(const c in d){const S=d[c];S.type==="subcommand"?c===v&&(n=S):(S.alias&&(g[c]=S.alias),S.type==="string"||S.type==="string[]"?(b.push(c),S.deprecates&&b.push(...S.deprecates)):S.type==="boolean"&&(i.push(c),S.deprecates&&i.push(...S.deprecates)),S.global&&(p[c]=S))}if(n&&v){const c=p;for(const L in n.options)c[L]=n.options[L];const S=u.filter(L=>L!==v),I=f.getSubcommandReporter?f.getSubcommandReporter(v):void 0,R=A(S,c,I);return{[v]:R,_:[]}}const l=(0,t.default)(u,{string:b,boolean:i,alias:g}),r={},h=l;r._=l._.map(c=>String(c)).filter(c=>c.length>0),delete h._;for(const c in d){const S=d[c];if(S.type==="subcommand")continue;S.alias&&delete h[S.alias];let I=h[c];if(S.deprecates)for(const R of S.deprecates)h.hasOwnProperty(R)&&(I||(I=h[R],I&&f.onDeprecatedOption(R,S.deprecationMessage||(0,E.localize)(11561,null,c))),delete h[R]);if(typeof I<"u"){if(S.type==="string[]"){if(Array.isArray(I)||(I=[I]),!S.allowEmptyValue){const R=I.filter(L=>L.length>0);R.length!==I.length&&(f.onEmptyValue(c),I=R.length>0?R:void 0)}}else S.type==="string"&&(Array.isArray(I)?(I=I.pop(),f.onMultipleValues(c,I)):!I&&!S.allowEmptyValue&&(f.onEmptyValue(c),I=void 0));r[c]=I,S.deprecationMessage&&f.onDeprecatedOption(c,S.deprecationMessage)}delete h[c]}for(const c in h)f.onUnknownOption(c);return r}function y(u,d){let f="";return d.args&&(Array.isArray(d.args)?f=` <${d.args.join("> <")}>`:f=` <${d.args}>`),d.alias?`-${d.alias} --${u}${f}`:`--${u}${f}`}function o(u,d){const f=[];for(const v in u){const g=u[v],b=y(v,g);f.push([b,g.description])}return D(f,d)}function D(u,d){const v=u.reduce((i,p)=>Math.max(i,p[0].length),12)+2+1;if(d-v<25)return u.reduce((i,p)=>i.concat([`  ${p[0]}`,`      ${p[1]}`]),[]);const g=d-v-1,b=[];for(const i of u){const p=i[0],n=m(i[1],g),l=w(v-p.length-2);b.push("  "+p+l+n[0]);for(let r=1;r<n.length;r++)b.push(w(v)+n[r])}return b}function w(u){return" ".repeat(u)}function m(u,d){const f=[];for(;u.length;){const v=u.length<d?u.length:u.lastIndexOf(" ",d),g=u.slice(0,v).trim();u=u.slice(v),f.push(g)}return f}function $(u,d,f,v,g){const b=process.stdout.isTTY&&process.stdout.columns||80,i=g?.noInputFiles!==!0?`[${(0,E.localize)(11562,null)}...]`:"",p=[`${u} ${f}`];p.push(""),p.push(`${(0,E.localize)(11563,null)}: ${d} [${(0,E.localize)(11564,null)}]${i}`),p.push(""),g?.noPipe!==!0&&(s.$j?p.push((0,E.localize)(11565,null,d)):p.push((0,E.localize)(11566,null,d)),p.push(""));const n={},l=[];for(const r in v){const h=v[r];if(h.type==="subcommand")h.description&&l.push({command:r,description:h.description});else if(h.description&&h.cat){let c=n[h.cat];c||(n[h.cat]=c={}),c[r]=h}}for(const r in n){const h=r,c=n[h];c&&(p.push(k[h]),p.push(...o(c,b)),p.push(""))}return l.length&&(p.push((0,E.localize)(11567,null)),p.push(...D(l.map(r=>[r.command,r.description]),b)),p.push("")),p.join(`
`)}function a(u,d){return`${u||(0,E.localize)(11568,null)}
${d||(0,E.localize)(11569,null)}
${process.arch}`}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[198],Ae([1,0,288,7,69]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=A,e.$Im=y,e.$Jm=o,e.$Km=D,t=dt(t);function k(w,m){const $=(g,b)=>{console.warn((0,s.localize)(11516,null,g,b))},a=g=>{console.warn((0,s.localize)(11517,null,g))},u=(g,b)=>{console.warn((0,s.localize)(11518,null,g,b))},d=g=>({onUnknownOption:b=>{E.$Bm.includes(g)||console.warn((0,s.localize)(11519,null,b,g))},onMultipleValues:$,onEmptyValue:a,onDeprecatedOption:u,getSubcommandReporter:E.$Bm.includes(g)?d:void 0}),f={onUnknownOption:g=>{console.warn((0,s.localize)(11520,null,g))},onMultipleValues:$,onEmptyValue:a,onDeprecatedOption:u,getSubcommandReporter:d},v=(0,E.$Dm)(w,E.$Cm,m?f:void 0);return v.goto&&v._.forEach(g=>(0,t.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,s.localize)(11521,null))),v}function C(w){const m=w.findIndex($=>!/^-/.test($));if(m>-1)return[...w.slice(0,m),...w.slice(m+1)]}function A(w){let[,...m]=w;process.env.VSCODE_DEV&&(m=C(m)||[]);const $=!D(process.env);return k(m,$)}function y(w){let[,,...m]=w;return process.env.VSCODE_DEV&&(m=C(m)||[]),k(m,!0)}function o(w,...m){const $=w.indexOf("--");return $===-1?w.push(...m):w.splice($,0,...m),w}function D(w){return w.VSCODE_CLI==="1"}}),function(){function ue(e,t,s){function E(C,A){const y=k(C,A),o=[y];return e.isAbsolute(y)||o.unshift(s),e.resolve(...o)}function k(C,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let o=process.env.VSCODE_APPDATA;if(o)return e.join(o,A);const D=C["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(o=process.env.APPDATA,!o){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");o=e.join(w,"AppData","Roaming")}break;case"darwin":o=e.join(t.homedir(),"Library","Application Support");break;case"linux":o=process.env.XDG_CONFIG_HOME||e.join(t.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(o,A)}return{getUserDataPath:E}}if(typeof define=="function")define(Re[199],Ae([83,32,31]),function(e,t,s){return ue(e,t,s.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("os");module.exports=ue(e,t,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Re[117],Ae([1,0,32,197,199]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=C,e.$$m=A;class k extends s.$6m{constructor(o,D){super(o,{homeDir:(0,t.homedir)(),tmpDir:(0,t.tmpdir)(),userDataDir:(0,E.getUserDataPath)(o,D.nameShort)},D)}}e.$9m=k;function C(y,o){return(0,s.$8m)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,o,y.extensionEnvironment)}function A(y,o){return(0,s.$8m)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,o,y.extensionEnvironment)}}),define(Re[200],Ae([1,0,10,7]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=E;function E(C,A,y,o){try{k(C,A,y,o)}catch(D){C.error(D?.message??D)}return A}function k(C,A,y,o){const D=(w,m,$)=>{const a=w[m];if((0,t.$eg)(a)){const u=a,d=u.length;if(d>1&&u[0]==="%"&&u[d-1]==="%"){const f=u.substr(1,d-2);let v=y[f];v===void 0&&o&&(v=o[f]);const g=typeof v=="string"?v:v?.message,b=o?.[f],i=typeof b=="string"?b:b?.message;if(!g){i||C.warn(`[${A.name}]: ${(0,s.localize)(11468,null,f)}`);return}if($&&(m==="title"||m==="category")&&i&&i!==g){const p={value:g,original:i};w[m]=p}else w[m]=g}}else if((0,t.$gg)(a))for(const u in a)a.hasOwnProperty(u)&&(u==="commands"?D(a,u,!0):D(a,u,$));else if(Array.isArray(a))for(let u=0;u<a.length;u++)D(a,u,$)};for(const w in A)A.hasOwnProperty(w)&&D(A,w)}}),define(Re[118],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const t={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(t)}),define(Re[70],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class t{constructor(E,k=[],C=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=C}}e.$Ci=t}),define(Re[119],Ae([1,0,70]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Rs=k,e.$Ss=C;const s=[];var E;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function k(A,y,o){y instanceof t.$Ci||(y=new t.$Ci(y,[],!!o)),s.push([A,y])}function C(){return s}}),define(Re[201],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;class t{constructor(k,C){this.key=k,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$ur=t;class s{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const C of this.a.values())C.outgoing.size===0&&k.push(C);return k}insertEdge(k,C){const A=this.lookupOrInsertNode(k),y=this.lookupOrInsertNode(C);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(k){const C=this.b(k);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(k){const C=this.b(k);let A=this.a.get(C);return A||(A=new t(C,k),this.a.set(C,A)),A}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[C,A]of this.a)k.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,C]of this.a){const A=new Set([k]),y=this.c(C,A);if(y)return y}}c(k,C){for(const[A,y]of k.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const o=this.c(y,C);if(o)return o;C.delete(A)}}}e.$vr=s}),define(Re[5],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=E,e.$Gi=k;var t;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(t||(e._util=t={})),e.$Ei=E("instantiationService");function s(C,A,y){A[t.DI_TARGET]===A?A[t.DI_DEPENDENCIES].push({id:C,index:y}):(A[t.DI_DEPENDENCIES]=[{id:C,index:y}],A[t.DI_TARGET]=A)}function E(C){if(t.serviceIds.has(C))return t.serviceIds.get(C);const A=function(y,o,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");s(A,y,D)};return A.toString=()=>C,t.serviceIds.set(C,A),A}function k(C){return C}}),define(Re[27],Ae([1,0,10,4,5]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=k,e.$bj=C,e.$cj=y,e.$dj=o,e.$ej=D,e.$fj=w,e.$gj=m,e.$hj=a,e.$ij=u,e.$jj=d,t=Ue(t),e.$_i=(0,E.$Fi)("configurationService");function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof s.URI)}function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof s.URI)}var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function y(f){switch(f){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function o(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function D(f,v){const g=Object.create(null);for(const b in f)w(g,b,f[b],v);return g}function w(f,v,g,b){const i=v.split("."),p=i.pop();let n=f;for(let l=0;l<i.length;l++){const r=i[l];let h=n[r];switch(typeof h){case"undefined":h=n[r]=Object.create(null);break;case"object":if(h===null){b(`Ignoring ${v} as ${i.slice(0,l+1).join(".")} is null`);return}break;default:b(`Ignoring ${v} as ${i.slice(0,l+1).join(".")} is ${JSON.stringify(h)}`);return}n=h}if(typeof n=="object"&&n!==null)try{n[p]=g}catch{b(`Ignoring ${v} as ${i.join(".")} is ${JSON.stringify(n)}`)}else b(`Ignoring ${v} as ${i.join(".")} is ${JSON.stringify(n)}`)}function m(f,v){const g=v.split(".");$(f,g)}function $(f,v){const g=v.shift();if(v.length===0){delete f[g];return}if(Object.keys(f).indexOf(g)!==-1){const b=f[g];typeof b=="object"&&!Array.isArray(b)&&($(b,v),Object.keys(b).length===0&&delete f[g])}}function a(f,v,g){function b(n,l){let r=n;for(const h of l){if(typeof r!="object"||r===null)return;r=r[h]}return r}const i=v.split("."),p=b(f,i);return typeof p>"u"?g:p}function u(f,v,g){Object.keys(v).forEach(b=>{b!=="__proto__"&&(b in f?t.$gg(f[b])&&t.$gg(v[b])?u(f[b],v[b],g):g&&(f[b]=v[b]):f[b]=v[b])})}function d(f){return f.replace(/[\[\]]/g,"")}}),define(Re[41],Ae([1,0,34,3,16,194,5,7,9]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=D,e.$Ej=l,e.$Fj=r,e.$Yj=oe;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",s.$k),o.set("isLinux",s.$l),o.set("isWindows",s.$j),o.set("isWeb",s.$p),o.set("isMacNative",s.$k&&!s.$p),o.set("isEdge",s.$I),o.set("isFirefox",s.$G),o.set("isChrome",s.$F),o.set("isSafari",s.$H);function D(G,T){if(o.get(G)!==void 0)throw(0,y.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(G,T)}const w=Object.prototype.hasOwnProperty;var m;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const $={regexParsingWithErrorRecovery:!0},a=(0,A.localize)(11599,null),u=(0,A.localize)(11600,null),d=(0,A.localize)(11601,null),f=(0,A.localize)(11602,null),v=(0,A.localize)(11603,null),g=(0,A.localize)(11604,null),b=(0,A.localize)(11605,null),i=(0,A.localize)(11606,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(T=$){this.k=T,this.d=new k.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(T){if(T===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(T).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const he=this.D(),B=he.type===k.TokenType.Str?g:void 0;throw this.h.push({message:v,offset:he.offset,lexeme:k.$Aj.getLexeme(he),additionalInfo:B}),p.c}return X}catch(X){if(X!==p.c)throw X;return}}l(){return this.m()}m(){const T=[this.o()];for(;this.y(k.TokenType.Or);){const X=this.o();T.push(X)}return T.length===1?T[0]:n.or(...T)}o(){const T=[this.s()];for(;this.y(k.TokenType.And);){const X=this.s();T.push(X)}return T.length===1?T[0]:n.and(...T)}s(){if(this.y(k.TokenType.Neg)){const T=this.D();switch(T.type){case k.TokenType.True:return this.z(),c.INSTANCE;case k.TokenType.False:return this.z(),S.INSTANCE;case k.TokenType.LParen:{this.z();const X=this.l();return this.A(k.TokenType.RParen,f),X?.negate()}case k.TokenType.Str:return this.z(),q.create(T.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",T)}}return this.t()}t(){const T=this.D();switch(T.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const X=this.l();return this.A(k.TokenType.RParen,f),X}case k.TokenType.Str:{const X=T.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const B=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),B.type!==k.TokenType.RegexStr)throw this.B("REGEX",B);const U=B.lexeme,H=U.lastIndexOf("/"),F=H===U.length-1?void 0:this.w(U.substring(H+1));let W;try{W=new RegExp(U.substring(1,H),F)}catch{throw this.B("REGEX",B)}return le.create(X,W)}switch(B.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const U=[B.lexeme];this.z();let H=this.D(),F=0;for(let Le=0;Le<B.lexeme.length;Le++)B.lexeme.charCodeAt(Le)===t.CharCode.OpenParen?F++:B.lexeme.charCodeAt(Le)===t.CharCode.CloseParen&&F--;for(;!this.E()&&H.type!==k.TokenType.And&&H.type!==k.TokenType.Or;){switch(H.type){case k.TokenType.LParen:F++;break;case k.TokenType.RParen:F--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Le=0;Le<H.lexeme.length;Le++)H.lexeme.charCodeAt(Le)===t.CharCode.OpenParen?F++:B.lexeme.charCodeAt(Le)===t.CharCode.CloseParen&&F--}if(F<0)break;U.push(k.$Aj.getLexeme(H)),this.z(),H=this.D()}const W=U.join(""),Y=W.lastIndexOf("/"),ae=Y===W.length-1?void 0:this.w(W.substring(Y+1));let Ee;try{Ee=new RegExp(W.substring(1,Y),ae)}catch{throw this.B("REGEX",B)}return n.regex(X,Ee)}case k.TokenType.QuotedStr:{const U=B.lexeme;this.z();let H=null;if(!(0,E.$cf)(U)){const F=U.indexOf("/"),W=U.lastIndexOf("/");if(F!==W&&F>=0){const Y=U.slice(F+1,W),ae=U[W+1]==="i"?"i":"";try{H=new RegExp(Y,ae)}catch{throw this.B("REGEX",B)}}}if(H===null)throw this.B("REGEX",B);return le.create(X,H)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,d);const B=this.u();return n.notIn(X,B)}switch(this.D().type){case k.TokenType.Eq:{this.z();const B=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(X,B);switch(B){case"true":return n.has(X);case"false":return n.not(X);default:return n.equals(X,B)}}case k.TokenType.NotEq:{this.z();const B=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(X,B);switch(B){case"true":return n.not(X);case"false":return n.has(X);default:return n.notEquals(X,B)}}case k.TokenType.Lt:return this.z(),de.create(X,this.u());case k.TokenType.LtEq:return this.z(),ge.create(X,this.u());case k.TokenType.Gt:return this.z(),J.create(X,this.u());case k.TokenType.GtEq:return this.z(),_.create(X,this.u());case k.TokenType.In:return this.z(),n.in(X,this.u());default:return n.has(X)}}case k.TokenType.EOF:throw this.h.push({message:b,offset:T.offset,lexeme:"",additionalInfo:i}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const T=this.D();switch(T.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),T.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(T){return T.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(T){return this.C(T)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(T,X){if(this.C(T))return this.z();throw this.B(X,this.D())}B(T,X,he){const B=(0,A.localize)(11607,null,T,k.$Aj.getLexeme(X)),U=X.offset,H=k.$Aj.getLexeme(X);return this.h.push({message:B,offset:U,lexeme:H,additionalInfo:he}),p.c}C(T){return this.D().type===T}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Cj=p;class n{static false(){return c.INSTANCE}static true(){return S.INSTANCE}static has(T){return I.create(T)}static equals(T,X){return R.create(T,X)}static notEquals(T,X){return P.create(T,X)}static regex(T,X){return le.create(T,X)}static in(T,X){return L.create(T,X)}static notIn(T,X){return O.create(T,X)}static not(T){return q.create(T)}static and(...T){return M.create(T,null,!0)}static or(...T){return V.create(T,null,!0)}static greater(T,X){return J.create(T,X)}static greaterEquals(T,X){return _.create(T,X)}static smaller(T,X){return de.create(T,X)}static smallerEquals(T,X){return ge.create(T,X)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(T){return T==null?void 0:this.c.parse(T)}}e.$Dj=n;function l(G){const T=new p({regexParsingWithErrorRecovery:!1});return G.map(X=>(T.parse(X),T.lexingErrors.length>0?T.lexingErrors.map(he=>({errorMessage:he.additionalInfo?(0,A.localize)(11608,null,he.additionalInfo):(0,A.localize)(11609,null),offset:he.offset,length:he.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map(he=>({errorMessage:he.additionalInfo?`${he.message}. ${he.additionalInfo}`:he.message,offset:he.offset,length:he.lexeme.length})):[]))}function r(G,T){const X=G?G.substituteConstants():void 0,he=T?T.substituteConstants():void 0;return!X&&!he?!0:!X||!he?!1:X.equals(he)}function h(G,T){return G.cmp(T)}class c{static{this.INSTANCE=new c}constructor(){this.type=m.False}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return S.INSTANCE}}e.$Gj=c;class S{static{this.INSTANCE=new S}constructor(){this.type=m.True}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return c.INSTANCE}}e.$Hj=S;class I{static create(T,X=null){const he=o.get(T);return typeof he=="boolean"?he?S.INSTANCE:c.INSTANCE:new I(T,X)}constructor(T,X){this.key=T,this.c=X,this.type=m.Defined}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=o.get(this.key);return typeof T=="boolean"?T?S.INSTANCE:c.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Ij=I;class R{static create(T,X,he=null){if(typeof X=="boolean")return X?I.create(T,he):q.create(T,he);const B=o.get(T);return typeof B=="boolean"?X===(B?"true":"false")?S.INSTANCE:c.INSTANCE:new R(T,X,he)}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.Equals}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=o.get(this.c);if(typeof T=="boolean"){const X=T?"true":"false";return this.d===X?S.INSTANCE:c.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Jj=R;class L{static create(T,X){return new L(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=m.In,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:me(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const X=T.getValue(this.f),he=T.getValue(this.d);return Array.isArray(X)?X.includes(he):typeof he=="string"&&typeof X=="object"&&X!==null?w.call(X,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Kj=L;class O{static create(T,X){return new O(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=m.NotIn,this.c=L.create(T,X)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=O;class P{static create(T,X,he=null){if(typeof X=="boolean")return X?q.create(T,he):I.create(T,he);const B=o.get(T);return typeof B=="boolean"?X===(B?"true":"false")?c.INSTANCE:S.INSTANCE:new P(T,X,he)}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.NotEquals}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=o.get(this.c);if(typeof T=="boolean"){const X=T?"true":"false";return this.d===X?c.INSTANCE:S.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mj=P;class q{static create(T,X=null){const he=o.get(T);return typeof he=="boolean"?he?c.INSTANCE:S.INSTANCE:new q(T,X)}constructor(T,X){this.c=T,this.d=X,this.type=m.Not}cmp(T){return T.type!==this.type?this.type-T.type:re(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=o.get(this.c);return typeof T=="boolean"?T?c.INSTANCE:S.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Nj=q;function K(G,T){if(typeof G=="string"){const X=parseFloat(G);isNaN(X)||(G=X)}return typeof G=="string"||typeof G=="number"?T(G):c.INSTANCE}class J{static create(T,X,he=null){return K(X,B=>new J(T,B,he))}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.Greater}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ge.create(this.c,this.d,this)),this.f}}e.$Oj=J;class _{static create(T,X,he=null){return K(X,B=>new _(T,B,he))}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.GreaterEquals}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Pj=_;class de{static create(T,X,he=null){return K(X,B=>new de(T,B,he))}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.Smaller}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Qj=de;class ge{static create(T,X,he=null){return K(X,B=>new ge(T,B,he))}constructor(T,X,he){this.c=T,this.d=X,this.f=he,this.type=m.SmallerEquals}cmp(T){return T.type!==this.type?this.type-T.type:me(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Rj=ge;class le{static create(T,X){return new le(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=m.Regex,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const X=this.f?this.f.source:"",he=T.f?T.f.source:"";return X<he?-1:X>he?1:0}equals(T){if(T.type===this.type){const X=this.f?this.f.source:"",he=T.f?T.f.source:"";return this.d===T.d&&X===he}return!1}substituteConstants(){return this}evaluate(T){const X=T.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=z.create(this)),this.c}}e.$Sj=le;class z{static create(T){return new z(T)}constructor(T){this.c=T,this.type=m.NotRegex}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(T){return new z(this.c.map(T))}negate(){return this.c}}e.$Tj=z;function Q(G){let T=null;for(let X=0,he=G.length;X<he;X++){const B=G[X].substituteConstants();if(G[X]!==B&&T===null){T=[];for(let U=0;U<X;U++)T[U]=G[U]}T!==null&&(T[X]=B)}return T===null?G:T}class M{static create(T,X,he){return M.d(T,X,he)}constructor(T,X){this.expr=T,this.c=X,this.type=m.And}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let X=0,he=this.expr.length;X<he;X++){const B=h(this.expr[X],T.expr[X]);if(B!==0)return B}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let X=0,he=this.expr.length;X<he;X++)if(!this.expr[X].equals(T.expr[X]))return!1;return!0}return!1}substituteConstants(){const T=Q(this.expr);return T===this.expr?this:M.create(T,this.c,!1)}evaluate(T){for(let X=0,he=this.expr.length;X<he;X++)if(!this.expr[X].evaluate(T))return!1;return!0}static d(T,X,he){const B=[];let U=!1;for(const H of T)if(H){if(H.type===m.True){U=!0;continue}if(H.type===m.False)return c.INSTANCE;if(H.type===m.And){B.push(...H.expr);continue}B.push(H)}if(B.length===0&&U)return S.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(h);for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];for(;B.length>1;){const H=B[B.length-1];if(H.type!==m.Or)break;B.pop();const F=B.pop(),W=B.length===0,Y=V.create(H.expr.map(ae=>M.create([ae,F],null,he)),null,W);Y&&(B.push(Y),B.sort(h))}if(B.length===1)return B[0];if(he){for(let H=0;H<B.length;H++)for(let F=H+1;F<B.length;F++)if(B[H].negate().equals(B[F]))return c.INSTANCE;if(B.length===1)return B[0]}return new M(B,X)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const X of this.expr)T.push(...X.keys());return T}map(T){return new M(this.expr.map(X=>X.map(T)),null)}negate(){if(!this.c){const T=[];for(const X of this.expr)T.push(X.negate());this.c=V.create(T,this,!0)}return this.c}}e.$Uj=M;class V{static create(T,X,he){return V.d(T,X,he)}constructor(T,X){this.expr=T,this.c=X,this.type=m.Or}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let X=0,he=this.expr.length;X<he;X++){const B=h(this.expr[X],T.expr[X]);if(B!==0)return B}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let X=0,he=this.expr.length;X<he;X++)if(!this.expr[X].equals(T.expr[X]))return!1;return!0}return!1}substituteConstants(){const T=Q(this.expr);return T===this.expr?this:V.create(T,this.c,!1)}evaluate(T){for(let X=0,he=this.expr.length;X<he;X++)if(this.expr[X].evaluate(T))return!0;return!1}static d(T,X,he){let B=[],U=!1;if(T){for(let H=0,F=T.length;H<F;H++){const W=T[H];if(W){if(W.type===m.False){U=!0;continue}if(W.type===m.True)return S.INSTANCE;if(W.type===m.Or){B=B.concat(W.expr);continue}B.push(W)}}if(B.length===0&&U)return c.INSTANCE;B.sort(h)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if(he){for(let H=0;H<B.length;H++)for(let F=H+1;F<B.length;F++)if(B[H].negate().equals(B[F]))return S.INSTANCE;if(B.length===1)return B[0]}return new V(B,X)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const X of this.expr)T.push(...X.keys());return T}map(T){return new V(this.expr.map(X=>X.map(T)),null)}negate(){if(!this.c){const T=[];for(const X of this.expr)T.push(X.negate());for(;T.length>1;){const X=T.shift(),he=T.shift(),B=[];for(const U of x(X))for(const H of x(he))B.push(M.create([U,H],null,!1));T.unshift(V.create(B,null,!1))}this.c=V.create(T,this,!0)}return this.c}}e.$Vj=V;class ne extends I{static{this.d=[]}static all(){return ne.d.values()}constructor(T,X,he){super(T,null),this.f=X,typeof he=="object"?ne.d.push({...he,key:T}):he!==!0&&ne.d.push({key:T,description:he,type:X!=null?typeof X:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return R.create(this.key,T)}notEqualsTo(T){return P.create(this.key,T)}}e.$Wj=ne,e.$Xj=(0,C.$Fi)("contextKeyService");function re(G,T){return G<T?-1:G>T?1:0}function me(G,T,X,he){return G<X?-1:G>X?1:T<he?-1:T>he?1:0}function oe(G,T){if(G.type===m.False||T.type===m.True)return!0;if(G.type===m.Or)return T.type===m.Or?ie(G.expr,T.expr):!1;if(T.type===m.Or){for(const X of T.expr)if(oe(G,X))return!0;return!1}if(G.type===m.And){if(T.type===m.And)return ie(T.expr,G.expr);for(const X of G.expr)if(oe(X,T))return!0;return!1}return G.equals(T)}function ie(G,T){let X=0,he=0;for(;X<G.length&&he<T.length;){const B=G[X].cmp(T[he]);if(B<0)return!1;B===0&&X++,he++}return X===G.length}function x(G){return G.type===m.Or?G.expr:[G]}}),define(Re[202],Ae([1,0,41,5]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$st=e.AccessibilitySupport=e.$rt=void 0,e.$tt=k,e.$rt=(0,s.$Fi)("accessibilityService");var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Disabled=1]="Disabled",C[C.Enabled=2]="Enabled"})(E||(e.AccessibilitySupport=E={})),e.$st=new t.$Wj("accessibilityModeEnabled",!1);function k(C){return C&&typeof C=="object"&&typeof C.label=="string"&&(typeof C.role>"u"||typeof C.role=="string")}e.$ut="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[203],Ae([1,0,17,20,3,170,108,186,187,7,202]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=i,e.clampedFloat=n,e.stringSet=h,e.cursorStyleToString=K,e.filterValidationDecorations=pe,t=Ue(t),s=Ue(s),E=Ue(E),o=Ue(o);var w;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class m{constructor(ee){this.c=ee}hasChanged(ee){return this.c[ee]}}e.ConfigurationChangedEvent=m;class ${constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=$;class a{constructor(ee,Se,We,Ke){this.id=ee,this.name=Se,this.defaultValue=We,this.schema=Ke}applyUpdate(ee,Se){return d(ee,Se)}compute(ee,Se,We){return We}}class u{constructor(ee,Se){this.newValue=ee,this.didChange=Se}}e.ApplyUpdateResult=u;function d(te,ee){if(typeof te!="object"||typeof ee!="object"||!te||!ee)return new u(ee,te!==ee);if(Array.isArray(te)||Array.isArray(ee)){const We=Array.isArray(te)&&Array.isArray(ee)&&t.$tb(te,ee);return new u(ee,!We)}let Se=!1;for(const We in ee)if(ee.hasOwnProperty(We)){const Ke=d(te[We],ee[We]);Ke.didChange&&(te[We]=Ke.newValue,Se=!0)}return new u(te,Se)}class f{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Se){return d(ee,Se)}validate(ee){return this.defaultValue}}class v{constructor(ee,Se,We,Ke){this.id=ee,this.name=Se,this.defaultValue=We,this.schema=Ke}applyUpdate(ee,Se){return d(ee,Se)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Se,We){return We}}function g(te,ee){return typeof te>"u"?ee:te==="false"?!1:!!te}class b extends v{constructor(ee,Se,We,Ke=void 0){typeof Ke<"u"&&(Ke.type="boolean",Ke.default=We),super(ee,Se,We,Ke)}validate(ee){return g(ee,this.defaultValue)}}function i(te,ee,Se,We){if(typeof te>"u")return ee;let Ke=parseInt(te,10);return isNaN(Ke)?ee:(Ke=Math.max(Se,Ke),Ke=Math.min(We,Ke),Ke|0)}class p extends v{static clampedInt(ee,Se,We,Ke){return i(ee,Se,We,Ke)}constructor(ee,Se,We,Ke,_e,st=void 0){typeof st<"u"&&(st.type="integer",st.default=We,st.minimum=Ke,st.maximum=_e),super(ee,Se,We,st),this.minimum=Ke,this.maximum=_e}validate(ee){return p.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function n(te,ee,Se,We){if(typeof te>"u")return ee;const Ke=l.float(te,ee);return l.clamp(Ke,Se,We)}class l extends v{static clamp(ee,Se,We){return ee<Se?Se:ee>We?We:ee}static float(ee,Se){if(typeof ee=="number")return ee;if(typeof ee>"u")return Se;const We=parseFloat(ee);return isNaN(We)?Se:We}constructor(ee,Se,We,Ke,_e){typeof _e<"u"&&(_e.type="number",_e.default=We),super(ee,Se,We,_e),this.validationFn=Ke}validate(ee){return this.validationFn(l.float(ee,this.defaultValue))}}class r extends v{static string(ee,Se){return typeof ee!="string"?Se:ee}constructor(ee,Se,We,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.default=We),super(ee,Se,We,Ke)}validate(ee){return r.string(ee,this.defaultValue)}}function h(te,ee,Se,We){return typeof te!="string"?ee:We&&te in We?We[te]:Se.indexOf(te)===-1?ee:te}class c extends v{constructor(ee,Se,We,Ke,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ke,_e.default=We),super(ee,Se,We,_e),this.c=Ke}validate(ee){return h(ee,this.defaultValue,this.c)}}class S extends a{constructor(ee,Se,We,Ke,_e,st,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=Ke),super(ee,Se,We,ut),this.c=_e,this.d=st}validate(ee){return typeof ee!="string"?this.defaultValue:this.c.indexOf(ee)===-1?this.defaultValue:this.d(ee)}}function I(te){switch(te){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class R extends a{constructor(){super(Ce.accessibilitySupport,"accessibilitySupport",D.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(11775,null),o.localize(11776,null),o.localize(11777,null)],default:"auto",tags:["accessibility"],description:o.localize(11778,null)})}validate(ee){switch(ee){case"auto":return D.AccessibilitySupport.Unknown;case"off":return D.AccessibilitySupport.Disabled;case"on":return D.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Se,We){return We===D.AccessibilitySupport.Unknown?ee.accessibilitySupport:We}}class L extends a{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(Ce.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(11779,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(11780,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var O;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(O||(e.TextEditorCursorBlinkingStyle=O={}));function P(te){switch(te){case"blink":return O.Blink;case"smooth":return O.Smooth;case"phase":return O.Phase;case"expand":return O.Expand;case"solid":return O.Solid}}var q;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(q||(e.TextEditorCursorStyle=q={}));function K(te){switch(te){case q.Line:return"line";case q.Block:return"block";case q.Underline:return"underline";case q.LineThin:return"line-thin";case q.BlockOutline:return"block-outline";case q.UnderlineThin:return"underline-thin"}}function J(te){switch(te){case"line":return q.Line;case"block":return q.Block;case"underline":return q.Underline;case"line-thin":return q.LineThin;case"block-outline":return q.BlockOutline;case"underline-thin":return q.UnderlineThin}}class _ extends f{constructor(){super(Ce.editorClassName)}compute(ee,Se,We){const Ke=["monaco-editor"];return Se.get(Ce.extraEditorClassName)&&Ke.push(Se.get(Ce.extraEditorClassName)),ee.extraEditorClassName&&Ke.push(ee.extraEditorClassName),Se.get(Ce.mouseStyle)==="default"?Ke.push("mouse-default"):Se.get(Ce.mouseStyle)==="copy"&&Ke.push("mouse-copy"),Se.get(Ce.showUnused)&&Ke.push("showUnused"),Se.get(Ce.showDeprecated)&&Ke.push("showDeprecated"),Ke.join(" ")}}class de extends b{constructor(){super(Ce.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(11781,null)})}compute(ee,Se,We){return We&&ee.emptySelectionClipboard}}class ge extends a{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ce.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(11782,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(11783,null),o.localize(11784,null),o.localize(11785,null)],description:o.localize(11786,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(11787,null),o.localize(11788,null),o.localize(11789,null)],description:o.localize(11790,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(11791,null),included:E.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(11792,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(11793,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":h(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":h(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class le extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ce.fontLigatures,"fontLigatures",le.OFF,{anyOf:[{type:"boolean",description:o.localize(11794,null)},{type:"string",description:o.localize(11795,null)}],description:o.localize(11796,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?le.OFF:ee==="true"?le.ON:ee:ee?le.ON:le.OFF}}e.EditorFontLigatures=le;class z extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ce.fontVariations,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:o.localize(11797,null)},{type:"string",description:o.localize(11798,null)}],description:o.localize(11799,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?z.OFF:ee==="true"?z.TRANSLATE:ee:ee?z.TRANSLATE:z.OFF}compute(ee,Se,We){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class Q extends f{constructor(){super(Ce.fontInfo)}compute(ee,Se,We){return ee.fontInfo}}class M extends v{constructor(){super(Ce.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(11800,null)})}validate(ee){const Se=l.float(ee,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Se,6,100)}compute(ee,Se,We){return ee.fontInfo.fontSize}}class V extends a{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ce.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:o.localize(11801,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(11802,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(p.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class ne extends a{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(11803,null),o.localize(11804,null),o.localize(11805,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ce.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(11806,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(11807,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(11808,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:o.localize(11809,null),...Se},"editor.gotoLocation.multipleImplementations":{description:o.localize(11810,null),...Se},"editor.gotoLocation.multipleReferences":{description:o.localize(11811,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:We,description:o.localize(11812,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:We,description:o.localize(11813,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:We,description:o.localize(11814,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:We,description:o.localize(11815,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:We,description:o.localize(11816,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{multiple:h(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??h(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??h(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??h(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??h(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??h(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Se.multipleTests??h(Se.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:r.string(Se.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class re extends a{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ce.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11817,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(11818,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(11819,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(11820,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(11821,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:p.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),hidingDelay:p.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Se.above,this.defaultValue.above)}}}var me;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(me||(e.RenderMinimap=me={}));class oe extends f{constructor(){super(Ce.layoutInfo)}compute(ee,Se,We){return oe.computeLayout(Se,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Se=ee.height/ee.lineHeight,We=Math.floor(ee.paddingTop/ee.lineHeight);let Ke=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(Ke=Math.max(Ke,Se-1));const _e=(We+ee.viewLineCount+Ke)/(ee.pixelRatio*ee.height),st=Math.floor(ee.viewLineCount/_e);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Ke,desiredRatio:_e,minimapLineCount:st}}static c(ee,Se){const We=ee.outerWidth,Ke=ee.outerHeight,_e=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:me.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const st=Se.stableMinimapLayoutInput,ut=st&&ee.outerHeight===st.outerHeight&&ee.lineHeight===st.lineHeight&&ee.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ee.pixelRatio===st.pixelRatio&&ee.scrollBeyondLastLine===st.scrollBeyondLastLine&&ee.paddingTop===st.paddingTop&&ee.paddingBottom===st.paddingBottom&&ee.minimap.enabled===st.minimap.enabled&&ee.minimap.side===st.minimap.side&&ee.minimap.size===st.minimap.size&&ee.minimap.showSlider===st.minimap.showSlider&&ee.minimap.renderCharacters===st.minimap.renderCharacters&&ee.minimap.maxColumn===st.minimap.maxColumn&&ee.minimap.scale===st.minimap.scale&&ee.verticalScrollbarWidth===st.verticalScrollbarWidth&&ee.isViewportWrapping===st.isViewportWrapping,gt=ee.lineHeight,wt=ee.typicalHalfwidthCharacterWidth,Pt=ee.scrollBeyondLastLine,Mt=ee.minimap.renderCharacters;let ft=_e>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const vt=ee.minimap.maxColumn,Et=ee.minimap.size,St=ee.minimap.side,Vt=ee.verticalScrollbarWidth,Rt=ee.viewLineCount,ht=ee.remainingWidth,$t=ee.isViewportWrapping,bt=Mt?2:3;let Dt=Math.floor(_e*Ke);const zt=Dt/_e;let Ot=!1,en=!1,kt=bt*ft,Bt=ft/_e,Gt=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:xt,extraLinesBeyondLastLine:Jt,desiredRatio:Xt,minimapLineCount:Nt}=oe.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Pt,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:Ke,lineHeight:gt,pixelRatio:_e});if(Rt/Nt>1)Ot=!0,en=!0,ft=1,kt=1,Bt=ft/_e;else{let pt=!1,qt=ft+1;if(Et==="fit"){const Ft=Math.ceil((xt+Rt+Jt)*kt);$t&&ut&&ht<=Se.stableFitRemainingWidth?(pt=!0,qt=Se.stableFitMaxMinimapScale):pt=Ft>Dt}if(Et==="fill"||pt){Ot=!0;const Ft=ft;kt=Math.min(gt*_e,Math.max(1,Math.floor(1/Xt))),$t&&ut&&ht<=Se.stableFitRemainingWidth&&(qt=Se.stableFitMaxMinimapScale),ft=Math.min(qt,Math.max(1,Math.floor(kt/bt))),ft>Ft&&(Gt=Math.min(2,ft/Ft)),Bt=ft/_e/Gt,Dt=Math.ceil(Math.max(Ut,xt+Rt+Jt)*kt),$t?(Se.stableMinimapLayoutInput=ee,Se.stableFitRemainingWidth=ht,Se.stableFitMaxMinimapScale=ft):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Tt=Math.floor(vt*Bt),Lt=Math.min(Tt,Math.max(0,Math.floor((ht-Vt-2)*Bt/(wt+Bt)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(_e*Lt);const Ct=At/_e;At=Math.floor(At*Gt);const Zt=Mt?me.Text:me.Blocks,Kt=St==="left"?0:We-Lt-Vt;return{renderMinimap:Zt,minimapLeft:Kt,minimapWidth:Lt,minimapHeightIsEditorHeight:Ot,minimapIsSampling:en,minimapScale:ft,minimapLineHeight:kt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:Dt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:zt}}static computeLayout(ee,Se){const We=Se.outerWidth|0,Ke=Se.outerHeight|0,_e=Se.lineHeight|0,st=Se.lineNumbersDigitCount|0,ut=Se.typicalHalfwidthCharacterWidth,gt=Se.maxDigitWidth,wt=Se.pixelRatio,Pt=Se.viewLineCount,Mt=ee.get(Ce.wordWrapOverride2),ft=Mt==="inherit"?ee.get(Ce.wordWrapOverride1):Mt,vt=ft==="inherit"?ee.get(Ce.wordWrap):ft,Et=ee.get(Ce.wordWrapColumn),St=Se.isDominatedByLongLines,Vt=ee.get(Ce.glyphMargin),Rt=ee.get(Ce.lineNumbers).renderType!==Le.Off,ht=ee.get(Ce.lineNumbersMinChars),$t=ee.get(Ce.scrollBeyondLastLine),bt=ee.get(Ce.padding),Dt=ee.get(Ce.minimap),zt=ee.get(Ce.scrollbar),Ot=zt.verticalScrollbarSize,en=zt.verticalHasArrows,kt=zt.arrowSize,Bt=zt.horizontalScrollbarSize,Gt=ee.get(Ce.folding),Tt=ee.get(Ce.showFoldingControls)!=="never";let Lt=ee.get(Ce.lineDecorationsWidth);Gt&&Tt&&(Lt+=16);let At=0;if(Rt){const hn=Math.max(st,ht);At=Math.round(hn*gt)}let Ct=0;Vt&&(Ct=_e*Se.glyphMarginDecorationLaneCount);let Zt=0,Kt=Zt+Ct,Ut=Kt+At,xt=Ut+Lt;const Jt=We-Ct-At-Lt;let Xt=!1,Nt=!1,Ht=-1;ft==="inherit"&&St?(Xt=!0,Nt=!0):vt==="on"||vt==="bounded"?Nt=!0:vt==="wordWrapColumn"&&(Ht=Et);const pt=oe.c({outerWidth:We,outerHeight:Ke,lineHeight:_e,typicalHalfwidthCharacterWidth:ut,pixelRatio:wt,scrollBeyondLastLine:$t,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Dt,verticalScrollbarWidth:Ot,viewLineCount:Pt,remainingWidth:Jt,isViewportWrapping:Nt},Se.memory||new $);pt.renderMinimap!==me.None&&pt.minimapLeft===0&&(Zt+=pt.minimapWidth,Kt+=pt.minimapWidth,Ut+=pt.minimapWidth,xt+=pt.minimapWidth);const qt=Jt-pt.minimapWidth,Ft=Math.max(1,Math.floor((qt-Ot-2)/ut)),rn=en?kt:0;return Nt&&(Ht=Math.max(1,Ft),vt==="bounded"&&(Ht=Math.min(Ht,Et))),{width:We,height:Ke,glyphMarginLeft:Zt,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:Kt,lineNumbersWidth:At,decorationsLeft:Ut,decorationsWidth:Lt,contentLeft:xt,contentWidth:qt,minimap:pt,viewportColumn:Ft,isWordWrapMinified:Xt,isViewportWrapping:Nt,wrappingColumn:Ht,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:Bt,overviewRuler:{top:rn,width:Ot,height:Ke-2*rn,right:0}}}}e.EditorLayoutInfoComputer=oe;class ie extends a{constructor(){super(Ce.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(11822,null),o.localize(11823,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(11824,null)}})}validate(ee){return h(ee,"simple",["simple","advanced"])}compute(ee,Se,We){return Se.get(Ce.accessibilitySupport)===D.AccessibilitySupport.Enabled?"advanced":We}}var x;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(x||(e.ShowLightbulbIconMode=x={}));class G extends a{constructor(){const ee={enabled:x.On};super(Ce.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[x.Off,x.OnCode,x.On],default:ee.enabled,enumDescriptions:[o.localize(11825,null),o.localize(11826,null),o.localize(11827,null)],description:o.localize(11828,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:h(ee.enabled,this.defaultValue.enabled,[x.Off,x.OnCode,x.On])}}}class T extends a{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ce.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11829,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(11830,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(11831,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(11832,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends a{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ce.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(11833,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(11834,null),o.localize(11835,null,E.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11836,null,E.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11837,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(11838,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(11839,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(11840,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:h(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(Se.fontFamily,this.defaultValue.fontFamily),padding:g(Se.padding,this.defaultValue.padding)}}}class he extends a{constructor(){super(Ce.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):p.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Se,We){return We<0?p.clampedInt(-We*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class B extends l{constructor(){super(Ce.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>l.clamp(ee,0,150),{markdownDescription:o.localize(11841,null)})}compute(ee,Se,We){return ee.fontInfo.lineHeight}}class U extends a{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ce.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11842,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(11843,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(11844,null),o.localize(11845,null),o.localize(11846,null)],default:ee.size,description:o.localize(11847,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(11848,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(11849,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(11850,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(11851,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(11852,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(11853,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(11854,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(11855,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(11856,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),autohide:g(Se.autohide,this.defaultValue.autohide),size:h(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Se.side,this.defaultValue.side,["right","left"]),showSlider:h(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(Se.scale,1,1,3),maxColumn:p.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Se.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Se.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:l.clamp(Se.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:l.clamp(Se.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function H(te){return te==="ctrlCmd"?E.$k?"metaKey":"ctrlKey":"altKey"}class F extends a{constructor(){super(Ce.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11857,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11858,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{top:p.clampedInt(Se.top,0,0,1e3),bottom:p.clampedInt(Se.bottom,0,0,1e3)}}}class W extends a{constructor(){const ee={enabled:!0,cycle:!0};super(Ce.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11859,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(11860,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class Y extends f{constructor(){super(Ce.pixelRatio)}compute(ee,Se,We){return ee.pixelRatio}}class ae extends a{constructor(){super(Ce.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ee extends a{constructor(){const ee={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(11861,null),o.localize(11862,null),o.localize(11863,null)]}];super(Ce.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:ee.strings,description:o.localize(11864,null)},comments:{anyOf:Se,default:ee.comments,description:o.localize(11865,null)},other:{anyOf:Se,default:ee.other,description:o.localize(11866,null)}},default:ee,markdownDescription:o.localize(11867,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const wt=ee?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Se,comments:We,strings:Ke}=ee,_e=["on","inline","off"];let st,ut,gt;return typeof Se=="boolean"?st=Se?"on":"off":st=h(Se,this.defaultValue.other,_e),typeof We=="boolean"?ut=We?"on":"off":ut=h(We,this.defaultValue.comments,_e),typeof Ke=="boolean"?gt=Ke?"on":"off":gt=h(Ke,this.defaultValue.strings,_e),{other:st,comments:ut,strings:gt}}}var Le;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(Le||(e.RenderLineNumbersType=Le={}));class be extends a{constructor(){super(Ce.lineNumbers,"lineNumbers",{renderType:Le.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(11868,null),o.localize(11869,null),o.localize(11870,null),o.localize(11871,null)],default:"on",description:o.localize(11872,null)})}validate(ee){let Se=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Se=Le.Custom,We=ee):ee==="interval"?Se=Le.Interval:ee==="relative"?Se=Le.Relative:ee==="on"?Se=Le.On:Se=Le.Off),{renderType:Se,renderFn:We}}}function pe(te){const ee=te.get(Ce.renderValidationDecorations);return ee==="editable"?te.get(Ce.readOnly):ee!=="on"}class we extends a{constructor(){const ee=[],Se={type:"number",description:o.localize(11873,null)};super(Ce.rulers,"rulers",ee,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:o.localize(11874,null),format:"color-hex"}}}]},default:ee,description:o.localize(11875,null)})}validate(ee){if(Array.isArray(ee)){const Se=[];for(const We of ee)if(typeof We=="number")Se.push({column:p.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ke=We;Se.push({column:p.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return Se.sort((We,Ke)=>We.column-Ke.column),Se}return this.defaultValue}}class Te extends a{constructor(){super(Ce.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function ce(te,ee){if(typeof te!="string")return ee;switch(te){case"hidden":return k.ScrollbarVisibility.Hidden;case"visible":return k.ScrollbarVisibility.Visible;default:return k.ScrollbarVisibility.Auto}}class ye extends a{constructor(){const ee={vertical:k.ScrollbarVisibility.Auto,horizontal:k.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ce.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11876,null),o.localize(11877,null),o.localize(11878,null)],default:"auto",description:o.localize(11879,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11880,null),o.localize(11881,null),o.localize(11882,null)],default:"auto",description:o.localize(11883,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(11884,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(11885,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(11886,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(11887,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee,We=p.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=p.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ce(Se.vertical,this.defaultValue.vertical),horizontal:ce(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:p.clampedInt(Se.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:p.clampedInt(Se.verticalSliderSize,Ke,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ve extends a{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ce.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(11888,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(11889,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(11890,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(11891,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(11892,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(11893,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(11894,null)}})}applyUpdate(ee,Se){let We=!1;Se.allowedCharacters&&ee&&(s.$io(ee.allowedCharacters,Se.allowedCharacters)||(ee={...ee,allowedCharacters:Se.allowedCharacters},We=!0)),Se.allowedLocales&&ee&&(s.$io(ee.allowedLocales,Se.allowedLocales)||(ee={...ee,allowedLocales:Se.allowedLocales},We=!0));const Ke=super.applyUpdate(ee,Se);return We?new u(Ke.newValue,!0):Ke}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{nonBasicASCII:Ze(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ze(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ze(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ee.allowedLocales,this.defaultValue.allowedLocales)}}c(ee,Se){if(typeof ee!="object"||!ee)return Se;const We={};for(const[Ke,_e]of Object.entries(ee))_e===!0&&(We[Ke]=!0);return We}}class ze extends a{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ce.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11895,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11896,null),o.localize(11897,null),o.localize(11898,null)],description:o.localize(11899,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(11900,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11901,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:h(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:r.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class qe extends a{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(Ce.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11902,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11903,null),o.localize(11904,null),o.localize(11905,null)],description:o.localize(11906,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11907,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showToolbar:h(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:r.string(Se.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Se.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Je extends a{constructor(){const ee={enabled:A.$lt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$lt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ce.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11908,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(11909,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends a{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ce.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11910,null),o.localize(11911,null),o.localize(11912,null)],default:ee.bracketPairs,description:o.localize(11913,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11914,null),o.localize(11915,null),o.localize(11916,null)],default:ee.bracketPairsHorizontal,description:o.localize(11917,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(11918,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(11919,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(11920,null),o.localize(11921,null),o.localize(11922,null)],default:ee.highlightActiveIndentation,description:o.localize(11923,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{bracketPairs:Ze(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ze(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ze(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ze(te,ee,Se){const We=Se.indexOf(te);return We===-1?ee:Se[We]}class Ye extends a{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ce.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(11924,null),o.localize(11925,null)],default:ee.insertMode,description:o.localize(11926,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(11927,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(11928,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(11929,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(11930,null),o.localize(11931,null),o.localize(11932,null),o.localize(11933,null)],default:ee.selectionMode,markdownDescription:o.localize(11934,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(11935,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(11936,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(11937,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(11938,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(11939,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(11940,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(11941,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(11942,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(11943,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(11944,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(11945,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(11946,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(11947,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(11948,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(11949,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(11950,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(11951,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(11952,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(11953,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(11954,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(11955,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(11956,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(11957,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(11958,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(11959,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(11960,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(11961,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(11962,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(11963,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(11964,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(11965,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(11966,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(11967,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(11968,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(11969,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(11970,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(11971,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{insertMode:h(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:h(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class it extends a{constructor(){super(Ce.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(11972,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(11973,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class lt extends a{constructor(){const ee=[];super(Ce.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(11974,null),type:"string"},{description:o.localize(11975,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Se=[];for(const We of ee)if(typeof We=="string")try{Intl.Segmenter.supportedLocalesOf(We).length>0&&Se.push(We)}catch{}return Se}return this.defaultValue}}var rt;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class nt extends a{constructor(){super(Ce.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(11976,null),o.localize(11977,null),o.localize(11978,null),o.localize(11979,null)],description:o.localize(11980,null),default:"same"}})}validate(ee){switch(ee){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(ee,Se,We){return Se.get(Ce.accessibilitySupport)===D.AccessibilitySupport.Enabled?rt.None:We}}class tt extends f{constructor(){super(Ce.wrappingInfo)}compute(ee,Se,We){const Ke=Se.get(Ce.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}class et extends a{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(Ce.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11981,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(11982,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(11983,null),o.localize(11984,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showDropSelector:h(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends a{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(Ce.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11985,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(11986,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(11987,null),o.localize(11988,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showPasteSelector:h(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const $e="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Fe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:E.$k?Ne:E.$l?Fe:$e,fontWeight:"normal",fontSize:E.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(te){return e.editorOptionsRegistry[te.id]=te,te}var Ce;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.placeholder=88]="placeholder",te[te.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",te[te.quickSuggestions=90]="quickSuggestions",te[te.quickSuggestionsDelay=91]="quickSuggestionsDelay",te[te.readOnly=92]="readOnly",te[te.readOnlyMessage=93]="readOnlyMessage",te[te.renameOnType=94]="renameOnType",te[te.renderControlCharacters=95]="renderControlCharacters",te[te.renderFinalNewline=96]="renderFinalNewline",te[te.renderLineHighlight=97]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=99]="renderValidationDecorations",te[te.renderWhitespace=100]="renderWhitespace",te[te.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",te[te.roundedSelection=102]="roundedSelection",te[te.rulers=103]="rulers",te[te.scrollbar=104]="scrollbar",te[te.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=106]="scrollBeyondLastLine",te[te.scrollPredominantAxis=107]="scrollPredominantAxis",te[te.selectionClipboard=108]="selectionClipboard",te[te.selectionHighlight=109]="selectionHighlight",te[te.selectOnLineNumbers=110]="selectOnLineNumbers",te[te.showFoldingControls=111]="showFoldingControls",te[te.showUnused=112]="showUnused",te[te.snippetSuggestions=113]="snippetSuggestions",te[te.smartSelect=114]="smartSelect",te[te.smoothScrolling=115]="smoothScrolling",te[te.stickyScroll=116]="stickyScroll",te[te.stickyTabStops=117]="stickyTabStops",te[te.stopRenderingLineAfter=118]="stopRenderingLineAfter",te[te.suggest=119]="suggest",te[te.suggestFontSize=120]="suggestFontSize",te[te.suggestLineHeight=121]="suggestLineHeight",te[te.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",te[te.suggestSelection=123]="suggestSelection",te[te.tabCompletion=124]="tabCompletion",te[te.tabIndex=125]="tabIndex",te[te.unicodeHighlighting=126]="unicodeHighlighting",te[te.unusualLineTerminators=127]="unusualLineTerminators",te[te.useShadowDOM=128]="useShadowDOM",te[te.useTabStops=129]="useTabStops",te[te.wordBreak=130]="wordBreak",te[te.wordSegmenterLocales=131]="wordSegmenterLocales",te[te.wordSeparators=132]="wordSeparators",te[te.wordWrap=133]="wordWrap",te[te.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=136]="wordWrapColumn",te[te.wordWrapOverride1=137]="wordWrapOverride1",te[te.wordWrapOverride2=138]="wordWrapOverride2",te[te.wrappingIndent=139]="wrappingIndent",te[te.wrappingStrategy=140]="wrappingStrategy",te[te.showDeprecated=141]="showDeprecated",te[te.inlayHints=142]="inlayHints",te[te.editorClassName=143]="editorClassName",te[te.pixelRatio=144]="pixelRatio",te[te.tabFocusMode=145]="tabFocusMode",te[te.layoutInfo=146]="layoutInfo",te[te.wrappingInfo=147]="wrappingInfo",te[te.defaultColorDecorators=148]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ce||(e.EditorOption=Ce={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new b(Ce.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(11989,null)})),acceptSuggestionOnEnter:ke(new c(Ce.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(11990,null),""],markdownDescription:o.localize(11991,null)})),accessibilitySupport:ke(new R),accessibilityPageSize:ke(new p(Ce.accessibilityPageSize,"accessibilityPageSize",10,1,C.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(11992,null),tags:["accessibility"]})),ariaLabel:ke(new r(Ce.ariaLabel,"ariaLabel",o.localize(11993,null))),ariaRequired:ke(new b(Ce.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new b(Ce.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(11994,null),tags:["accessibility"]})),autoClosingBrackets:ke(new c(Ce.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11995,null),o.localize(11996,null),""],description:o.localize(11997,null)})),autoClosingComments:ke(new c(Ce.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11998,null),o.localize(11999,null),""],description:o.localize(12e3,null)})),autoClosingDelete:ke(new c(Ce.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12001,null),""],description:o.localize(12002,null)})),autoClosingOvertype:ke(new c(Ce.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(12003,null),""],description:o.localize(12004,null)})),autoClosingQuotes:ke(new c(Ce.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(12005,null),o.localize(12006,null),""],description:o.localize(12007,null)})),autoIndent:ke(new S(Ce.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],I,{enumDescriptions:[o.localize(12008,null),o.localize(12009,null),o.localize(12010,null),o.localize(12011,null),o.localize(12012,null)],description:o.localize(12013,null)})),automaticLayout:ke(new b(Ce.automaticLayout,"automaticLayout",!1)),autoSurround:ke(new c(Ce.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(12014,null),o.localize(12015,null),o.localize(12016,null),""],description:o.localize(12017,null)})),bracketPairColorization:ke(new Je),bracketPairGuides:ke(new Ge),stickyTabStops:ke(new b(Ce.stickyTabStops,"stickyTabStops",!1,{description:o.localize(12018,null)})),codeLens:ke(new b(Ce.codeLens,"codeLens",!0,{description:o.localize(12019,null)})),codeLensFontFamily:ke(new r(Ce.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(12020,null)})),codeLensFontSize:ke(new p(Ce.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(12021,null)})),colorDecorators:ke(new b(Ce.colorDecorators,"colorDecorators",!0,{description:o.localize(12022,null)})),colorDecoratorActivatedOn:ke(new c(Ce.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(12023,null),o.localize(12024,null),o.localize(12025,null)],description:o.localize(12026,null)})),colorDecoratorsLimit:ke(new p(Ce.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(12027,null)})),columnSelection:ke(new b(Ce.columnSelection,"columnSelection",!1,{description:o.localize(12028,null)})),comments:ke(new L),contextmenu:ke(new b(Ce.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new b(Ce.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(12029,null)})),cursorBlinking:ke(new S(Ce.cursorBlinking,"cursorBlinking",O.Blink,"blink",["blink","smooth","phase","expand","solid"],P,{description:o.localize(12030,null)})),cursorSmoothCaretAnimation:ke(new c(Ce.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(12031,null),o.localize(12032,null),o.localize(12033,null)],description:o.localize(12034,null)})),cursorStyle:ke(new S(Ce.cursorStyle,"cursorStyle",q.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],J,{description:o.localize(12035,null)})),cursorSurroundingLines:ke(new p(Ce.cursorSurroundingLines,"cursorSurroundingLines",0,0,C.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12036,null)})),cursorSurroundingLinesStyle:ke(new c(Ce.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(12037,null),o.localize(12038,null)],markdownDescription:o.localize(12039,null)})),cursorWidth:ke(new p(Ce.cursorWidth,"cursorWidth",0,0,C.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12040,null)})),disableLayerHinting:ke(new b(Ce.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new b(Ce.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new b(Ce.domReadOnly,"domReadOnly",!1)),dragAndDrop:ke(new b(Ce.dragAndDrop,"dragAndDrop",!0,{description:o.localize(12041,null)})),emptySelectionClipboard:ke(new de),dropIntoEditor:ke(new et),stickyScroll:ke(new T),experimentalWhitespaceRendering:ke(new c(Ce.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(12042,null),o.localize(12043,null),o.localize(12044,null)],description:o.localize(12045,null)})),extraEditorClassName:ke(new r(Ce.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(Ce.fastScrollSensitivity,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:o.localize(12046,null)})),find:ke(new ge),fixedOverflowWidgets:ke(new b(Ce.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ke(new b(Ce.folding,"folding",!0,{description:o.localize(12047,null)})),foldingStrategy:ke(new c(Ce.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(12048,null),o.localize(12049,null)],description:o.localize(12050,null)})),foldingHighlight:ke(new b(Ce.foldingHighlight,"foldingHighlight",!0,{description:o.localize(12051,null)})),foldingImportsByDefault:ke(new b(Ce.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(12052,null)})),foldingMaximumRegions:ke(new p(Ce.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(12053,null)})),unfoldOnClickAfterEndOfLine:ke(new b(Ce.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(12054,null)})),fontFamily:ke(new r(Ce.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(12055,null)})),fontInfo:ke(new Q),fontLigatures2:ke(new le),fontSize:ke(new M),fontWeight:ke(new V),fontVariations:ke(new z),formatOnPaste:ke(new b(Ce.formatOnPaste,"formatOnPaste",!1,{description:o.localize(12056,null)})),formatOnType:ke(new b(Ce.formatOnType,"formatOnType",!1,{description:o.localize(12057,null)})),glyphMargin:ke(new b(Ce.glyphMargin,"glyphMargin",!0,{description:o.localize(12058,null)})),gotoLocation:ke(new ne),hideCursorInOverviewRuler:ke(new b(Ce.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(12059,null)})),hover:ke(new re),inDiffEditor:ke(new b(Ce.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ke(new l(Ce.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>l.clamp(te,-5,20),{description:o.localize(12060,null)})),lightbulb:ke(new G),lineDecorationsWidth:ke(new he),lineHeight:ke(new B),lineNumbers:ke(new be),lineNumbersMinChars:ke(new p(Ce.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new b(Ce.linkedEditing,"linkedEditing",!1,{description:o.localize(12061,null)})),links:ke(new b(Ce.links,"links",!0,{description:o.localize(12062,null)})),matchBrackets:ke(new c(Ce.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(12063,null)})),minimap:ke(new U),mouseStyle:ke(new c(Ce.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(Ce.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:o.localize(12064,null)})),mouseWheelZoom:ke(new b(Ce.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:E.$k?o.localize(12065,null):o.localize(12066,null)})),multiCursorMergeOverlapping:ke(new b(Ce.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(12067,null)})),multiCursorModifier:ke(new S(Ce.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[o.localize(12068,null),o.localize(12069,null)],markdownDescription:o.localize(12070,null)})),multiCursorPaste:ke(new c(Ce.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(12071,null),o.localize(12072,null)],markdownDescription:o.localize(12073,null)})),multiCursorLimit:ke(new p(Ce.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(12074,null)})),occurrencesHighlight:ke(new c(Ce.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(12075,null),o.localize(12076,null),o.localize(12077,null)],markdownDescription:o.localize(12078,null)})),overviewRulerBorder:ke(new b(Ce.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(12079,null)})),overviewRulerLanes:ke(new p(Ce.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ke(new F),pasteAs:ke(new Xe),parameterHints:ke(new W),peekWidgetDefaultFocus:ke(new c(Ce.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(12080,null),o.localize(12081,null)],description:o.localize(12082,null)})),placeholder:ke(new ae),definitionLinkOpensInPeek:ke(new b(Ce.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(12083,null)})),quickSuggestions:ke(new Ee),quickSuggestionsDelay:ke(new p(Ce.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,C.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12084,null)})),readOnly:ke(new b(Ce.readOnly,"readOnly",!1)),readOnlyMessage:ke(new Te),renameOnType:ke(new b(Ce.renameOnType,"renameOnType",!1,{description:o.localize(12085,null),markdownDeprecationMessage:o.localize(12086,null)})),renderControlCharacters:ke(new b(Ce.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(12087,null),restricted:!0})),renderFinalNewline:ke(new c(Ce.renderFinalNewline,"renderFinalNewline",E.$l?"dimmed":"on",["off","on","dimmed"],{description:o.localize(12088,null)})),renderLineHighlight:ke(new c(Ce.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(12089,null)],description:o.localize(12090,null)})),renderLineHighlightOnlyWhenFocus:ke(new b(Ce.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(12091,null)})),renderValidationDecorations:ke(new c(Ce.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new c(Ce.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(12092,null),o.localize(12093,null),o.localize(12094,null),""],description:o.localize(12095,null)})),revealHorizontalRightPadding:ke(new p(Ce.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new b(Ce.roundedSelection,"roundedSelection",!0,{description:o.localize(12096,null)})),rulers:ke(new we),scrollbar:ke(new ye),scrollBeyondLastColumn:ke(new p(Ce.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,C.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12097,null)})),scrollBeyondLastLine:ke(new b(Ce.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(12098,null)})),scrollPredominantAxis:ke(new b(Ce.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(12099,null)})),selectionClipboard:ke(new b(Ce.selectionClipboard,"selectionClipboard",!0,{description:o.localize(12100,null),included:E.$l})),selectionHighlight:ke(new b(Ce.selectionHighlight,"selectionHighlight",!0,{description:o.localize(12101,null)})),selectOnLineNumbers:ke(new b(Ce.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ke(new c(Ce.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(12102,null),o.localize(12103,null),o.localize(12104,null)],description:o.localize(12105,null)})),showUnused:ke(new b(Ce.showUnused,"showUnused",!0,{description:o.localize(12106,null)})),showDeprecated:ke(new b(Ce.showDeprecated,"showDeprecated",!0,{description:o.localize(12107,null)})),inlayHints:ke(new X),snippetSuggestions:ke(new c(Ce.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(12108,null),o.localize(12109,null),o.localize(12110,null),o.localize(12111,null)],description:o.localize(12112,null)})),smartSelect:ke(new it),smoothScrolling:ke(new b(Ce.smoothScrolling,"smoothScrolling",!1,{description:o.localize(12113,null)})),stopRenderingLineAfter:ke(new p(Ce.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,C.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ke(new Ye),inlineSuggest:ke(new ze),inlineEdit:ke(new qe),inlineCompletionsAccessibilityVerbose:ke(new b(Ce.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(12114,null)})),suggestFontSize:ke(new p(Ce.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(12115,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new p(Ce.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(12116,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new b(Ce.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(12117,null)})),suggestSelection:ke(new c(Ce.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(12118,null),o.localize(12119,null),o.localize(12120,null)],description:o.localize(12121,null)})),tabCompletion:ke(new c(Ce.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(12122,null),o.localize(12123,null),o.localize(12124,null)],description:o.localize(12125,null)})),tabIndex:ke(new p(Ce.tabIndex,"tabIndex",0,-1,C.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ke(new ve),unusualLineTerminators:ke(new c(Ce.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(12126,null),o.localize(12127,null),o.localize(12128,null)],description:o.localize(12129,null)})),useShadowDOM:ke(new b(Ce.useShadowDOM,"useShadowDOM",!0)),useTabStops:ke(new b(Ce.useTabStops,"useTabStops",!0,{description:o.localize(12130,null)})),wordBreak:ke(new c(Ce.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(12131,null),o.localize(12132,null)],description:o.localize(12133,null)})),wordSegmenterLocales:ke(new lt),wordSeparators:ke(new r(Ce.wordSeparators,"wordSeparators",y.$mt,{description:o.localize(12134,null)})),wordWrap:ke(new c(Ce.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(12135,null),o.localize(12136,null),o.localize(12137,null),o.localize(12138,null)],description:o.localize(12139,null)})),wordWrapBreakAfterCharacters:ke(new r(Ce.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new r(Ce.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new p(Ce.wordWrapColumn,"wordWrapColumn",80,1,C.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12140,null)})),wordWrapOverride1:ke(new c(Ce.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new c(Ce.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new _),defaultColorDecorators:ke(new b(Ce.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(12141,null)})),pixelRatio:ke(new Y),tabFocusMode:ke(new b(Ce.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(12142,null)})),layoutInfo:ke(new oe),wrappingInfo:ke(new tt),wrappingIndent:ke(new nt),wrappingStrategy:ke(new ie)}}),define(Re[204],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=s,e.ID="diagnosticsService",e.$Tm=(0,t.$Fi)(e.ID);function s(k){return!!k.hostName&&!!k.errorMessage}class E{async getPerformanceInfo(C,A){return{}}async getSystemInfo(C,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,A){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$Vm=E}),define(Re[87],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0,e.$2o=(0,t.$Fi)("downloadService")}),define(Re[28],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,t.$Fi)("environmentService"),e.$Ni=(0,t.$Gi)(e.$Mi)}),define(Re[15],Ae([1,0,68,8,16,10,4,7,5,3,12,64]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=m,e.$cl=d,e.$dl=v,e.$el=g,e.$fl=b,e.$gl=i,e.$hl=p,e.$il=n,e.$jl=l,e.$kl=r,e.$ll=h,e.$nl=I,e.$ol=R,e.$pl=L,e.$ql=O,e.$rl=P,e.$ul=de,e.$Gl=V,e.$Hl=ne,e.$Jl=me,e.$al=(0,y.$Fi)("fileService");function m(oe){return oe.create===!0}var $;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var a;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var u;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(u||(e.FileChangeFilter=u={}));function d(oe){const ie=oe;return!!ie&&typeof ie.onDidChange=="function"}var f;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function v(oe){return!!(oe.capabilities&f.FileReadWrite)}function g(oe){return!!(oe.capabilities&f.FileFolderCopy)}function b(oe){return!!(oe.capabilities&f.FileClone)}function i(oe){return!!(oe.capabilities&f.FileOpenReadWriteClose)}function p(oe){return!!(oe.capabilities&f.FileReadStream)}function n(oe){return v(oe)?!!(oe.capabilities&f.FileAtomicRead):!1}function l(oe){return v(oe)?!!(oe.capabilities&f.FileAtomicWrite):!1}function r(oe){return!!(oe.capabilities&f.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&f.Readonly)}var c;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class S extends Error{static create(ie,x){const G=new S(ie.toString(),x);return L(G,x),G}constructor(ie,x){super(ie),this.code=x}}e.$ml=S;function I(oe,ie){return S.create(oe,ie)}function R(oe){return oe||I((0,A.localize)(11385,null),c.Unknown)}function L(oe,ie){return oe.name=ie?`${ie} (FileSystemError)`:"FileSystemError",oe}function O(oe){if(!oe)return c.Unknown;if(oe instanceof S)return oe.code;const ie=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ie)return c.Unknown;switch(ie[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function P(oe){if(oe instanceof ge)return oe.fileOperationResult;switch(O(oe)){case c.FileNotFound:return Q.FILE_NOT_FOUND;case c.FileIsADirectory:return Q.FILE_IS_DIRECTORY;case c.FileNotADirectory:return Q.FILE_NOT_DIRECTORY;case c.FileWriteLocked:return Q.FILE_WRITE_LOCKED;case c.NoPermissions:return Q.FILE_PERMISSION_DENIED;case c.FileExists:return Q.FILE_MOVE_CONFLICT;case c.FileTooLarge:return Q.FILE_TOO_LARGE;default:return Q.FILE_OTHER_ERROR}}var q;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(q||(e.FileOperation=q={}));class K{constructor(ie,x,G){this.resource=ie,this.operation=x,this.target=G}isOperation(ie){return this.operation===ie}}e.$sl=K;var J;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class _{static{this.a=null}constructor(ie,x){this.c=x,this.b=void 0,this.d=new w.$T(()=>{const G=t.$Li.forUris(()=>this.c);return G.fill(this.rawAdded.map(T=>[T,!0])),G}),this.f=new w.$T(()=>{const G=t.$Li.forUris(()=>this.c);return G.fill(this.rawUpdated.map(T=>[T,!0])),G}),this.g=new w.$T(()=>{const G=t.$Li.forUris(()=>this.c);return G.fill(this.rawDeleted.map(T=>[T,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of ie){switch(G.type){case J.ADDED:this.rawAdded.push(G.resource);break;case J.UPDATED:this.rawUpdated.push(G.resource);break;case J.DELETED:this.rawDeleted.push(G.resource);break}this.b!==_.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=_.a):this.b!==void 0&&(this.b=_.a))}}contains(ie,...x){return this.h(ie,{includeChildren:!1},...x)}affects(ie,...x){return this.h(ie,{includeChildren:!0},...x)}h(ie,x,...G){if(!ie)return!1;const T=G.length>0;return!!((!T||G.includes(J.ADDED))&&(this.d.value.get(ie)||x.includeChildren&&this.d.value.findSuperstr(ie))||(!T||G.includes(J.UPDATED))&&(this.f.value.get(ie)||x.includeChildren&&this.f.value.findSuperstr(ie))||(!T||G.includes(J.DELETED))&&(this.g.value.findSubstr(ie)||x.includeChildren&&this.g.value.findSuperstr(ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ie){return this.b===ie}hasCorrelation(){return typeof this.b=="number"}}e.$tl=_;function de(oe,ie,x){return!oe||!ie||oe===ie||ie.length>oe.length?!1:(ie.charAt(ie.length-1)!==s.sep&&(ie+=s.sep),x?(0,E.$Gf)(oe,ie):oe.indexOf(ie)===0)}class ge extends Error{constructor(ie,x,G){super(ie),this.fileOperationResult=x,this.options=G}}e.$vl=ge;class le extends ge{constructor(ie,x,G,T){super(ie,x,T),this.fileOperationResult=x,this.size=G}}e.$wl=le;class z extends ge{constructor(ie,x,G){super(ie,Q.FILE_NOT_MODIFIED_SINCE,G),this.stat=x}}e.$xl=z;var Q;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var M;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$Fl="";function V(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function ne(oe,ie){if(!ie.hasProvider(C.URI.from({scheme:oe.scheme})))return new Promise(x=>{const G=ie.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===oe.scheme&&T.added&&(G.dispose(),x())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(ie){return(0,k.$ig)(ie)||(ie=0),ie<re.KB?(0,A.localize)(11386,null,ie.toFixed(0)):ie<re.MB?(0,A.localize)(11387,null,(ie/re.KB).toFixed(2)):ie<re.GB?(0,A.localize)(11388,null,(ie/re.MB).toFixed(2)):ie<re.TB?(0,A.localize)(11389,null,(ie/re.GB).toFixed(2)):(0,A.localize)(11390,null,(ie/re.TB).toFixed(2))}}e.$Il=re;function me(oe){const ie=typeof oe=="string"||oe?.scheme===D.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===D.Schemas.file?1024*re.MB:ie?10*re.MB:o.$p?50*re.MB:1024*re.MB}}),define(Re[120],Ae([1,0,14,9,7,15]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=C;async function C(D,w,m,$,a,u){let d;try{await A(D,w,m,$,a,u)}catch(f){d=f}finally{d&&a.errorTransformer&&(d=a.errorTransformer(d)),typeof d<"u"&&m.error(d),m.end()}}async function A(D,w,m,$,a,u){y(u);const d=await D.open(w,{create:!1});try{y(u);let f=0,v=0,g=a&&typeof a.length=="number"?a.length:void 0,b=t.$Ne.alloc(Math.min(a.bufferSize,typeof g=="number"?g:a.bufferSize)),i=a&&typeof a.position=="number"?a.position:0,p=0;do v=await D.read(d,i,b.buffer,p,b.byteLength-p),i+=v,p+=v,f+=v,typeof g=="number"&&(g-=v),p===b.byteLength&&(await m.write($(b)),b=t.$Ne.alloc(Math.min(a.bufferSize,typeof g=="number"?g:a.bufferSize)),p=0);while(v>0&&(typeof g!="number"||g>0)&&y(u)&&o(f,a));if(p>0){let n=p;typeof g=="number"&&(n=Math.min(p,g)),m.write($(b.slice(0,n)))}}catch(f){throw(0,k.$ol)(f)}finally{await D.close(d)}}function y(D){if(D.isCancellationRequested)throw(0,s.$5)();return!0}function o(D,w){if(typeof w?.limits?.size=="number"&&D>w.limits.size)throw(0,k.$nl)((0,E.localize)(11384,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Re[51],Ae([1,0,82,2,8,3,4,15]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=void 0,e.$4q=y,e.$5q=o,e.$9q=$,e.$0q=a,e.$$q=u,e.$_q=d,e.$ar=v,e.$br=g;function y(b){return typeof b.correlationId=="number"}function o(b){return b.recursive===!0}class D extends s.$Uc{static{this.a=5}constructor(i,p,n,l){super(),this.h=i,this.j=p,this.m=n,this.n=l,this.c=this.B(new s.$Vc),this.f=void 0,this.g=0}s(){const i=new s.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(p=>this.h(p))),i.add(this.b.onDidLogMessage(p=>this.j(p))),i.add(this.b.onDidError(p=>this.t(p.error,p.request)))}t(i,p){this.u(i,p)?this.g<D.a&&this.f?(this.y(`restarting watcher after unexpected error: ${i}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${i}`):this.y(i)}u(i,p){return!(!this.n.restartOnError||p||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}w(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}y(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}z(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6q=D;class w extends D{constructor(i,p,n){super(i,p,n,{type:"node.js",restartOnError:!1})}}e.$7q=w;class m extends D{constructor(i,p,n){super(i,p,n,{type:"universal",restartOnError:!0})}}e.$8q=m;function $(b){return b.map(i=>({type:i.type,resource:C.URI.revive(i.resource),cId:i.cId}))}function a(b){const i=new f;for(const p of b)i.processEvent(p);return i.coalesce()}function u(b,i){return typeof i=="string"&&!i.startsWith(t.$wk)&&!(0,E.$ic)(i)?{base:b,pattern:i}:i}function d(b,i){const p=[];for(const n of i)p.push((0,t.$Ak)(u(b,n)));return p}class f{constructor(){this.a=new Set,this.b=new Map}c(i){return k.$l?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const p=this.b.get(this.c(i));let n=!1;if(p){const l=p.type,r=i.type;p.resource.fsPath!==i.resource.fsPath&&(i.type===A.FileChangeType.DELETED||i.type===A.FileChangeType.ADDED)?n=!0:l===A.FileChangeType.ADDED&&r===A.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(p)):l===A.FileChangeType.DELETED&&r===A.FileChangeType.ADDED?p.type=A.FileChangeType.UPDATED:l===A.FileChangeType.ADDED&&r===A.FileChangeType.UPDATED||(p.type=r)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],p=[];return Array.from(this.a).filter(n=>n.type!==A.FileChangeType.DELETED?(i.push(n),!1):!0).sort((n,l)=>n.resource.fsPath.length-l.resource.fsPath.length).filter(n=>p.some(l=>(0,A.$ul)(n.resource.fsPath,l,!k.$l))?!1:(p.push(n.resource.fsPath),!0)).concat(i)}}function v(b,i){if(typeof i=="number")switch(b.type){case A.FileChangeType.ADDED:return(i&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(i&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(i&A.FileChangeFilter.UPDATED)===0}return!1}function g(b){if(typeof b=="number"){const i=[];return b&A.FileChangeFilter.ADDED&&i.push("Added"),b&A.FileChangeFilter.DELETED&&i.push("Deleted"),b&A.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(Re[205],Ae([1,0,14,44,9,6,2,55,22,15,51]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=void 0,e.$sR="localFilesystem";class w extends C.$Uc{constructor($,a){super(),this.a=$,this.b=a,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$le),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$le),this.onDidWatchError=this.g.event,this.h=(0,y.$2g)(),this.j()}get capabilities(){return this.c||(this.c=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=o.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=o.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,a){const{buffer:u}=await this.a.call("readFile",[$,a]);return u}readFileStream($,a,u){const d=(0,A.$Be)(v=>t.$Ne.concat(v.map(g=>t.$Ne.wrap(g))).buffer),f=new C.$Tc;return f.add(this.a.listen("readFileStream",[$,a])(v=>{if(v instanceof t.$Ne)d.write(v.buffer);else{if(v==="end")d.end();else{let g;if(v instanceof Error)g=v;else{const b=v;g=(0,o.$nl)(b.message??(0,s.$qj)(b),b.code??o.FileSystemProviderErrorCode.Unknown)}d.error(g),d.end()}f.dispose()}})),f.add(u.onCancellationRequested(()=>{d.error((0,E.$5)()),d.end(),f.dispose()})),d}writeFile($,a,u){return this.a.call("writeFile",[$,t.$Ne.wrap(a),u])}open($,a){return this.a.call("open",[$,a])}close($){return this.a.call("close",[$])}async read($,a,u,d,f){const[v,g]=await this.a.call("read",[$,a,f]);return u.set(v.buffer.slice(0,g),d),g}write($,a,u,d,f){return this.a.call("write",[$,a,t.$Ne.wrap(u),d,f])}mkdir($){return this.a.call("mkdir",[$])}delete($,a){return this.a.call("delete",[$,a])}rename($,a,u){return this.a.call("rename",[$,a,u])}copy($,a,u){return this.a.call("copy",[$,a,u])}cloneFile($,a){return this.a.call("cloneFile",[$,a])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const a=$;this.f.fire((0,D.$9q)(a))}else{const a=$;this.g.fire(a)}}))}watch($,a){const u=(0,y.$2g)();return this.a.call("watch",[this.h,u,$,a]),(0,C.$Sc)(()=>this.a.call("unwatch",[this.h,u]))}}e.$tR=w}),define(Re[206],Ae([1,0,23,2,51,6,15,4,13]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class o extends s.$Uc{constructor(){super(),this.a=this.B(new k.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new s.$4c),this.m=new Set,this.n=this.B(new y.$Dh(this.y())),this.r=5007,this.s=new y.$3h,this.R=!1,this.B(this.f(w=>this.t(w)))}t(w){this.u(w)&&this.z(w)}u(w){return(0,E.$4q)(w)}async watch(w){this.s.isSettled||this.s.complete(),this.s=new y.$3h;try{this.h.clear(),this.g.clear();for(const m of w)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(w){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),w?this.y():0)}y(){return 800}isSuspended(w){return typeof w.correlationId!="number"?!1:this.m.has(w.correlationId)?"polling":this.j.has(w.correlationId)}async z(w){if(this.j.has(w.correlationId))return;const m=new s.$Tc;this.j.set(w.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(w,m),this.w(!0))}C(w){this.j.deleteAndDispose(w.correlationId),this.m.delete(w.correlationId),this.w(!1)}D(w,m){this.F(w,m)?(this.P(`reusing an existing recursive watcher to monitor ${w.path}`),this.m.delete(w.correlationId)):(this.G(w,m),this.m.add(w.correlationId))}F(w,m){const $=this.O?.subscribe(w.path,(a,u)=>{m.isDisposed||(a?this.D(w,m):u?.type===C.FileChangeType.ADDED&&this.H(w))});return $?(m.add($),!0):!1}G(w,m){let $=!1;const a=(u,d)=>{if(m.isDisposed)return;const f=this.I(u),v=this.I(d),g=$;$=f,!f&&(v||g)&&this.H(w)};this.P(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,t.watchFile)(w.path,{persistent:!1,interval:this.r},a)}catch(u){this.Q(`fs.watchFile() failed with error ${u} on path ${w.path} (correlationId: ${w.correlationId})`)}m.add((0,s.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,t.unwatchFile)(w.path,a)}catch(u){this.Q(`fs.unwatchFile() failed with error ${u} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}H(w){this.P(`detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const m={resource:A.URI.file(w.path),type:C.FileChangeType.ADDED,cId:w.correlationId};this.a.fire([m]),this.J(m,w),this.C(w)}I(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(w,m){if(this.R){const $=` >> normalized ${w.type===C.FileChangeType.ADDED?"[ADDED]":w.type===C.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.L($,m)}}L(w,m){this.R&&this.P(`${w}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, filter: ${(0,E.$br)(w.filter)}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}async setVerboseLogging(w){this.R=w}}e.$kr=o}),define(Re[207],Ae([1,0,23,13,18,36,2,106,8,3,19,4,182,26,15,51]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0,e.$qr=f;class d extends C.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(g,b,i,p,n,l){super(),this.s=g,this.t=b,this.u=i,this.w=p,this.y=n,this.z=l,this.c=this.B(new s.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new s.$Th(r=>this.M(r),d.b)),this.g=(0,u.$_q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,u.$_q)(this.s.path,this.s.includes):void 0,this.j=(0,u.$4q)(this.s)?this.s.filter:void 0,this.m=new E.$we,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const g=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const b=await t.promises.stat(g);if(this.m.token.isCancellationRequested)return;this.B(await this.G(g,b.isDirectory()))}catch(g){g.code!=="ENOENT"?this.O(g):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${g})`),this.D()}}D(){this.r=!0,this.w?.()}async F(g){let b=g.path;try{b=await $.Promises.realpath(g.path),g.path===b&&(b=await(0,m.$mr)(g.path,this.m.token)??g.path),g.path!==b&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${b})`)}catch{}return b}async G(g,b){const i=new C.$Tc;return this.H(g,b,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(g,b,i)),i}H(g,b,i){if(b)return!1;const p=w.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(l,r)=>{if(!i.isDisposed)if(l){const h=await this.G(g,b);i.isDisposed?h.dispose():i.add(h)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:p,type:r.type,cId:this.s.correlationId},!0)});return n?(i.add(n),!0):!1}async I(g,b,i){if(o.$k&&(0,k.$Eg)(g,"/Volumes/",!0)){this.O(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const p=new E.$we(this.m.token);i.add((0,C.$Sc)(()=>p.dispose(!0)));const n=new C.$Tc;i.add(n);try{const l=w.URI.file(this.s.path),r=(0,y.$nc)(g),h=(0,t.watch)(g);n.add((0,C.$Sc)(()=>{h.removeAllListeners(),h.close()})),this.Q(`Started watching: '${g}'`);const c=new Set;if(b)try{for(const I of await $.Promises.readdir(g))c.add(I)}catch(I){this.O(I)}if(p.token.isCancellationRequested)return;const S=new Map;n.add((0,C.$Sc)(()=>{for(const[,I]of S)I.dispose();S.clear()})),h.on("error",(I,R)=>{p.token.isCancellationRequested||(this.O(`Failed to watch ${g} for changes using fs.watch() (${I}, ${R})`),this.D())}),h.on("change",(I,R)=>{if(p.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${I}"] ${R}`);let L="";if(R&&(L=R.toString(),o.$k&&(L=(0,A.$nm)(L))),!(!L||I!=="change"&&I!=="rename"))if(b)if(I==="rename"){S.get(L)?.dispose();const O=setTimeout(async()=>{if(S.delete(L),L===r&&!await $.Promises.exists(g)){this.J(l);return}if(p.token.isCancellationRequested)return;const P=await this.N((0,y.$jc)(g,L));if(p.token.isCancellationRequested)return;let q;P?c.has(L)?q=a.FileChangeType.UPDATED:(q=a.FileChangeType.ADDED,c.add(L)):(c.delete(L),q=a.FileChangeType.DELETED),this.L({resource:(0,D.$gh)(l,L),type:q,cId:this.s.correlationId})},d.a);S.set(L,(0,C.$Sc)(()=>clearTimeout(O)))}else{let O;c.has(L)?O=a.FileChangeType.UPDATED:(O=a.FileChangeType.ADDED,c.add(L)),this.L({resource:(0,D.$gh)(l,L),type:O,cId:this.s.correlationId})}else if(I==="rename"||L!==r){const O=setTimeout(async()=>{const P=await $.Promises.exists(g);p.token.isCancellationRequested||(P?(this.L({resource:l,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(g,!1))):this.J(l))},d.a);n.clear(),n.add((0,C.$Sc)(()=>clearTimeout(O)))}else this.L({resource:l,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(l){p.token.isCancellationRequested||this.O(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`),this.D()}}J(g){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:g,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(g,b=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${g.type===a.FileChangeType.ADDED?"[ADDED]":g.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!b&&this.g.some(i=>i(g.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${g.resource.fsPath}`):!b&&this.h&&this.h.length>0&&!this.h.some(i=>i(g.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}M(g){const b=(0,u.$0q)(g),i=[];for(const n of b){if((0,u.$ar)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}i.push(n)}if(i.length===0)return;if(this.z)for(const n of i)this.R(` >> normalized ${n.type===a.FileChangeType.ADDED?"[ADDED]":n.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(g){if(o.$l)return $.Promises.exists(g);try{const b=(0,y.$nc)(g);return(await $.Promises.readdir((0,y.$mc)(g))).some(p=>p===b)}catch(b){return this.Q(b),!1}}setVerboseLogging(g){this.z=g}O(g){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}P(g){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}Q(g){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}R(g){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${g}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$pr=d;async function f(v,g,b,i,p=512){const n=await $.Promises.open(v,"r"),l=Buffer.allocUnsafe(p),r=new E.$we(i);let h,c=!1;const S={path:v,excludes:[],recursive:!1},I=new d(S,void 0,R=>{(async()=>{for(const{type:L}of R)if(L===a.FileChangeType.UPDATED){if(c)return;c=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:O}=await $.Promises.read(n,l,0,p,null);if(!O||r.token.isCancellationRequested)break;g(l.slice(0,O))}}catch(O){h=new Error(O),r.dispose(!0)}finally{c=!1}}})()});return await I.ready,b(),new Promise((R,L)=>{r.token.onCancellationRequested(async()=>{I.dispose();try{await $.Promises.close(n)}catch(O){h=new Error(O)}h?L(h):R()})})}}),define(Re[208],Ae([1,0,6,82,206,3,207,36]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class y extends E.$kr{constructor(D){super(),this.O=D,this.onDidError=t.Event.None,this.watchers=new Set}async N(D){D=this.Z(D);const w=[],m=new Set(Array.from(this.watchers));for(const $ of D){const a=this.W($);a&&(0,s.$Ek)(a.request.excludes,$.excludes)&&(0,s.$Ek)(a.request.includes,$.includes)?m.delete(a):w.push($)}w.length&&this.P(`Request to start watching: ${w.map($=>this.M($)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map($=>this.M($.request)).join(",")}`);for(const $ of m)this.Y($);for(const $ of w)this.X($)}W(D){for(const w of this.watchers)if(typeof D.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===D.correlationId)return w}else if((0,A.$Dg)(w.request.path,D.path,!k.$l))return w}X(D){const w=new C.$pr(D,this.O,$=>this.a.fire($),()=>this.c.fire(D),$=>this.b.fire($),this.R),m={request:D,instance:w};this.watchers.add(m)}async stop(){await super.stop();for(const D of this.watchers)this.Y(D)}Y(D){this.P("stopping file watcher",D),this.watchers.delete(D),D.instance.dispose()}Z(D){const w=new Map;for(const m of D){const $=k.$l?m.path:m.path.toLowerCase();let a=w.get(m.correlationId);a||(a=new Map,w.set(m.correlationId,a)),a.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),a.set($,m)}return Array.from(w.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(D){super.setVerboseLogging(D);for(const w of this.watchers)w.instance.setVerboseLogging(D)}P(D,w){this.R&&this.b.fire({type:"trace",message:this.bb(D,w)})}Q(D){this.b.fire({type:"warn",message:this.bb(D)})}bb(D,w){return w?`[File Watcher (node.js)] ${D} (${this.M(w.request)})`:`[File Watcher (node.js)] ${D}`}}e.$rr=y}),define(Re[209],Ae([1,0,51,208]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class E extends t.$7q{constructor(C,A,y){super(C,A,y),this.s()}r(C){return C.add(new s.$rr(void 0))}}e.$sr=E}),define(Re[210],Ae([1,0,12,49,115,51]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class C extends k.$8q{constructor(y,o,D){super(y,o,D),this.s()}r(y){const o=y.add(new E.$ir(t.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(o.onDidProcessExit(({code:D,signal:w})=>this.t(`terminated by itself with code ${D}, signal: ${w} (ETERM)`))),s.ProxyChannel.toService((0,s.$mi)(o.getChannel("watcher")))}}e.$jr=C}),define(Re[88],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class t{constructor(...E){this.a=new Map;for(const[k,C]of E)this.set(k,C)}set(E,k){const C=this.a.get(E);return this.a.set(E,k),C}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Di=t}),define(Re[121],Ae([1,0,13,9,2,70,201,5,88,79]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=void 0;const D=!1;class w extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class m{constructor(d=new y.$Di,f=!1,v,g=D){this.i=d,this.j=f,this.k=v,this.l=g,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Ei,this),this._globalGraph=g?v?._globalGraph??new C.$vr(b=>b):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,E.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d,f){this.m();const v=this,g=new class extends m{dispose(){v.h.delete(g),super.dispose()}}(d,this.j,this,this.l);return this.h.add(g),f?.add(g),g}invokeFunction(d,...f){this.m();const v=a.traceInvocation(this.l,d);let g=!1;try{return d({get:i=>{if(g)throw(0,s.$7)("service accessor is only valid during the invocation of its target method");const p=this.s(i,v);if(!p)throw new Error(`[invokeFunction] unknown service '${i}'`);return p}},...f)}finally{g=!0,v.stop()}}createInstance(d,...f){this.m();let v,g;return d instanceof k.$Ci?(v=a.traceCreation(this.l,d.ctor),g=this.o(d.ctor,d.staticArguments.concat(f),v)):(v=a.traceCreation(this.l,d),g=this.o(d,f,v)),v.stop(),g}o(d,f=[],v){const g=A._util.getServiceDependencies(d).sort((p,n)=>p.index-n.index),b=[];for(const p of g){const n=this.s(p.id,v);n||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${p.id}.`,!1),b.push(n)}const i=g.length>0?g[0].index:f.length;if(f.length!==i){console.trace(`[createInstance] First service dependency of ${d.name} at position ${i+1} conflicts with ${f.length} static arguments`);const p=i-f.length;p>0?f=f.concat(new Array(p)):f=f.slice(0,i)}return Reflect.construct(d,f.concat(b))}q(d,f){if(this.i.get(d)instanceof k.$Ci)this.i.set(d,f);else if(this.k)this.k.q(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const f=this.i.get(d);return!f&&this.k?this.k.r(d):f}s(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const v=this.r(d);return v instanceof k.$Ci?this.u(d,v,f.branch(d,!0)):(f.branch(d,!1),v)}u(d,f,v){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,f,v)}finally{this.t.delete(d)}}v(d,f,v){const g=new C.$vr(n=>n.id.toString());let b=0;const i=[{id:d,desc:f,_trace:v}],p=new Set;for(;i.length;){const n=i.pop();if(!p.has(String(n.id))){if(p.add(String(n.id)),g.lookupOrInsertNode(n),b++>1e3)throw new w(g);for(const l of A._util.getServiceDependencies(n.desc.ctor)){const r=this.r(l.id);if(r||this.y(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(l.id)),r instanceof k.$Ci){const h={id:l.id,desc:r,_trace:n._trace.branch(l.id,!0)};g.insertEdge(n,h),i.push(h)}}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new w(g);break}for(const{data:l}of n){if(this.r(l.id)instanceof k.$Ci){const h=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,h)}g.removeNode(l)}}return this.r(d)}w(d,f,v=[],g,b){if(this.i.get(d)instanceof k.$Ci)return this.x(d,f,v,g,b,this.g);if(this.k)return this.k.w(d,f,v,g,b);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(d,f,v=[],g,b,i){if(g){const p=new m(void 0,this.j,this,this.l);p.c=String(d);const n=new Map,l=new t.$Yh(()=>{const r=p.o(f,v,b);for(const[h,c]of n){const S=r[h];if(typeof S=="function")for(const I of c)I.disposable=S.apply(r,I.listener)}return n.clear(),i.add(r),r});return new Proxy(Object.create(null),{get(r,h){if(!l.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=n.get(h);return I||(I=new o.$5c,n.set(h,I)),(L,O,P)=>{if(l.isInitialized)return l.value[h](L,O,P);{const q={listener:[L,O,P],disposable:void 0},K=I.push(q);return(0,E.$Sc)(()=>{K(),q.disposable?.dispose()})}}}if(h in r)return r[h];const c=l.value;let S=c[h];return typeof S!="function"||(S=S.bind(c),r[h]=S),S},set(r,h,c){return l.value[h]=c,!0},getPrototypeOf(r){return f.prototype}})}else{const p=this.o(f,v,b);return i.add(p),p}}y(d,f){if(f&&console.warn(d),this.j)throw new Error(d)}}e.$wr=m;var $;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})($||($={}));class a{static{this.all=new Set}static{this.c=new class extends a{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(d,f){return d?new a($.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(d,f){return d?new a($.Creation,f.name):a.c}static{this.f=0}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const v=new a($.Branch,d.toString());return this.h.push([d,f,v]),v}stop(){const d=Date.now()-this.g;a.f+=d;let f=!1;function v(b,i){const p=[],n=new Array(b+1).join("	");for(const[l,r,h]of i.h)if(r&&h){f=!0,p.push(`${n}CREATES -> ${l}`);const c=v(b+1,h);c&&p.push(c)}else p.push(`${n}uses -> ${l}`);return p.join(`
`)}const g=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(d>2||f)&&a.all.add(g.join(`
`))}}e.$xr=a}),define(Re[211],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$sw=void 0,e.$sw=(0,t.$Fi)("labelService");var s;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(s||(e.Verbosity=s={}))}),define(Re[11],Ae([1,0,7,44,6,67,2,25,3,19,10,4,41,5]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=u,e.log=f,e.$ok=S,e.$pk=I,e.$qk=R,e.$rk=L,t=Ue(t),e.$ak=(0,$.$Fi)("logService"),e.$bk=(0,$.$Fi)("loggerService");function a(){return new Date().toISOString()}function u(O){return(0,D.$ig)(O)}var d;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$dk=d.Info;function f(O,P,q){switch(P){case d.Trace:O.trace(q);break;case d.Debug:O.debug(q);break;case d.Info:O.info(q);break;case d.Warning:O.warn(q);break;case d.Error:O.error(q);break;case d.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function v(O,P=!1){let q="";for(let K=0;K<O.length;K++){let J=O[K];if(J instanceof Error&&(J=(0,s.$qj)(J,P)),typeof J=="object")try{J=JSON.stringify(J)}catch{}q+=(K>0?" ":"")+J}return q}class g extends C.$Uc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new E.$le),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==d.Off&&this.b<=P}}e.$fk=g;class b extends g{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...q){this.f(d.Trace)&&this.g(d.Trace,v([P,...q],!0))}debug(P,...q){this.f(d.Debug)&&this.g(d.Debug,v([P,...q]))}info(P,...q){this.f(d.Info)&&this.g(d.Info,v([P,...q]))}warn(P,...q){this.f(d.Warning)&&this.g(d.Warning,v([P,...q]))}error(P,...q){if(this.f(d.Error))if(P instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=P.stack,this.g(d.Error,v(K))}else this.g(d.Error,v([P,...q]))}flush(){}}e.$gk=b;class i extends g{constructor(P=e.$dk){super(),this.setLevel(P),this.g=!y.$j}trace(P,...q){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...q):console.log(`[main ${a()}]`,P,...q))}debug(P,...q){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...q):console.log(`[main ${a()}]`,P,...q))}info(P,...q){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...q):console.log(`[main ${a()}]`,P,...q))}warn(P,...q){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,P,...q):console.warn(`[main ${a()}]`,P,...q))}error(P,...q){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,P,...q):console.error(`[main ${a()}]`,P,...q))}flush(){}}e.$hk=i;class p extends g{constructor(P=e.$dk,q=!0){super(),this.g=q,this.setLevel(P)}trace(P,...q){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...q):console.log(P,...q))}debug(P,...q){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...q):console.log(P,...q))}info(P,...q){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...q):console.log(P,...q))}warn(P,...q){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...q):console.log(P,...q))}error(P,...q){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...q):console.error(P,...q))}flush(){}}e.$ik=p;class n extends g{constructor(P,q=e.$dk){super(),this.g=P,this.setLevel(q)}trace(P,...q){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(P),...q])}debug(P,...q){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(P),...q])}info(P,...q){this.f(d.Info)&&this.g.log(d.Info,[this.h(P),...q])}warn(P,...q){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(P),...q])}error(P,...q){this.f(d.Error)&&this.g.log(d.Error,[this.h(P),...q])}h(P){return typeof P=="string"?P:(0,s.$qj)(P,this.f(d.Trace))}flush(){}}e.$jk=n;class l extends g{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const q of this.g)q.setLevel(P);super.setLevel(P)}trace(P,...q){for(const K of this.g)K.trace(P,...q)}debug(P,...q){for(const K of this.g)K.debug(P,...q)}info(P,...q){for(const K of this.g)K.info(P,...q)}warn(P,...q){for(const K of this.g)K.warn(P,...q)}error(P,...q){for(const K of this.g)K.error(P,...q)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$kk=l;class r extends C.$Uc{constructor(P,q,K){if(super(),this.h=P,this.j=q,this.b=new A.$Ac,this.c=this.B(new E.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$le),this.onDidChangeVisibility=this.g.event,K)for(const J of K)this.b.set(J.resource,{logger:void 0,info:J})}m(P){return(0,D.$eg)(P)?[...this.b.values()].find(q=>q.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,q){const K=this.n(P),J=(0,D.$eg)(P)?P:q?.id??(0,k.$tj)(K.toString()).toString(16);let _=this.b.get(K)?.logger;const de=q?.logLevel==="always"?d.Trace:q?.logLevel;_||(_=this.s(K,de??this.getLogLevel(K)??this.h,{...q,id:J}));const ge={logger:_,info:{resource:K,id:J,logLevel:de,name:q?.name,hidden:q?.hidden,extensionId:q?.extensionId,when:q?.when}};return this.registerLogger(ge.info),this.b.set(K,ge),_}n(P){return(0,D.$eg)(P)?(0,o.$gh)(this.j,`${P}.log`):P}setLogLevel(P,q){if(w.URI.isUri(P)){const K=P,J=q,_=this.b.get(K);_&&J!==_.info.logLevel&&(_.info.logLevel=J===this.h?void 0:J,_.logger?.setLevel(J),this.b.set(_.info.resource,_),this.f.fire([K,J]))}else{this.h=P;for(const[K,J]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,q){const K=this.m(P);K&&q!==!K.info.hidden&&(K.info.hidden=!q,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,q]))}getLogLevel(P){let q;return P&&(q=this.b.get(P)?.info.logLevel),q??this.h}registerLogger(P){const q=this.b.get(P.resource);q?q.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const q=this.b.get(P);q&&(q.logger&&q.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[q.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=r;class h{constructor(){this.onDidChangeLogLevel=new E.$le().event}setLevel(P){}getLevel(){return d.Info}trace(P,...q){}debug(P,...q){}info(P,...q){}warn(P,...q){}error(P,...q){}critical(P,...q){}dispose(){}flush(){}}e.$mk=h;class c extends h{}e.$nk=c;function S(O){if(O.verbose)return d.Trace;if(typeof O.logLevel=="string"){const P=L(O.logLevel.toLowerCase());if(P!==void 0)return P}return e.$dk}function I(O){switch(O){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function R(O){switch(O){case d.Trace:return{original:"Trace",value:t.localize(11318,null)};case d.Debug:return{original:"Debug",value:t.localize(11319,null)};case d.Info:return{original:"Info",value:t.localize(11320,null)};case d.Warning:return{original:"Warning",value:t.localize(11321,null)};case d.Error:return{original:"Error",value:t.localize(11322,null)};case d.Off:return{original:"Off",value:t.localize(11323,null)}}}function L(O){switch(O){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$sk=new m.$Wj("logLevel",I(d.Info))}),define(Re[212],Ae([1,0,17,13,9,6,36,2,8,51,11]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class w extends A.$Uc{constructor($,a){super(),this.a=$,this.b=a,this.c=this.B(new k.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new s.$Dh(0)),this.w=[],this.y=this.B(new s.$Dh(0))}watch($,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n($,a):this.z($,a)}n($,a){const u={path:this.J($),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},d=(0,t.$Sb)(this.j,u);return this.r(),(0,A.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,E.$Y)($))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,o.$9q)(a)),a=>this.G(a),this.a.getLevel()===D.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===D.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const a of this.j)(0,o.$5q)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const a of this.j)(0,o.$5q)(a)&&$.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,a){const u={path:this.J($),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},d=(0,t.$Sb)(this.w,u);return this.C(),(0,A.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,E.$Y)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,o.$9q)($)),$=>this.G($),this.a.getLevel()===D.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===D.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,y.$hc)($.fsPath)}J($){const a=this.I($);return(0,C.$Hg)(a)}}e.$cr=w});var je=this&&this.__param||function(ue,e){return function(t,s){e(t,s,ue)}};define(Re[122],Ae([1,0,17,13,14,18,6,67,39,2,68,12,43,19,55,7,15,120,11,9]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;let i=class extends o.$Uc{static{b=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new C.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$le),this.Y=this.B(new C.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new s.$Oh)}registerProvider(n,l){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const r=new o.$Tc;return this.h.set(n,l),this.c.fire({added:!0,scheme:n,provider:l}),r.add(l.onDidChangeFile(h=>{const c=new d.$tl(h,!this.S(l));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(h=>this.Z.fire(new Error(h)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:n}))),(0,o.$Sc)(()=>{this.c.fire({added:!1,scheme:n,provider:l}),this.h.delete(n),(0,o.$Pc)(r)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const l=[];this.f.fire({scheme:n,join(r){l.push(r)}}),!this.h.has(n)&&await s.Promises.settled(l)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,l){const r=this.h.get(n.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return y.Iterable.map(this.h,([n,l])=>({scheme:n,capabilities:l.capabilities}))}async j(n){if(!(0,$.$kh)(n))throw new d.$vl((0,u.localize)(11391,null,this.sb(n)),d.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const l=this.h.get(n.scheme);if(!l){const r=new g.$ab;throw r.message=(0,u.localize)(11392,null,n.toString()),r}return l}async m(n){const l=await this.j(n);if((0,d.$gl)(l)||(0,d.$dl)(l)||(0,d.$hl)(l))return l;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const l=await this.j(n);if((0,d.$gl)(l)||(0,d.$dl)(l))return l;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,l){try{return await this.s(n,l)}catch(r){throw(0,d.$ql)(r)===d.FileSystemProviderErrorCode.FileNotFound?new d.$vl((0,u.localize)(11393,null,this.sb(n)),d.FileOperationResult.FILE_NOT_FOUND):(0,d.$ol)(r)}}async s(n,l){const r=await this.j(n),h=this.S(r),c=l?.resolveTo,S=l?.resolveSingleChildDescendants,I=l?.resolveMetadata,R=await r.stat(n);let L;return this.t(r,n,R,void 0,!!I,(O,P)=>(L||(L=D.$Li.forUris(()=>!h),L.set(n,!0),c&&L.fill(!0,c)),L.get(O.resource)||L.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&S?P===1:!1))}async t(n,l,r,h,c,S){const{providerExtUri:I}=this.R(n),R={resource:l,name:I.basename(l),isFile:(r.type&d.FileType.File)!==0,isDirectory:(r.type&d.FileType.Directory)!==0,isSymbolicLink:(r.type&d.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&d.FilePermission.Readonly)||!!(n.capabilities&d.FileSystemProviderCapabilities.Readonly),locked:!!((r.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Gl)({mtime:r.mtime,size:r.size}),children:void 0};if(R.isDirectory&&S(R,h)){try{const L=await n.readdir(l),O=await s.Promises.settled(L.map(async([P,q])=>{try{const K=I.joinPath(l,P),J=c?await n.stat(K):{type:q};return await this.t(n,K,J,L.length,c,S)}catch(K){return this.b.trace(K),null}}));R.children=(0,t.$Gb)(O)}catch(L){this.b.trace(L),R.children=[]}return R}return R}async resolveAll(n){return s.Promises.settled(n.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(n){const l=await this.j(n),r=await l.stat(n);return this.t(l,n,r,void 0,!0,()=>!1)}async exists(n){const l=await this.j(n);try{return!!await l.stat(n)}catch{return!1}}async canCreateFile(n,l){try{await this.u(n,l)}catch(r){return r}return!0}async u(n,l){if(!l?.overwrite&&await this.exists(n))throw new d.$vl((0,u.localize)(11394,null,this.sb(n)),d.FileOperationResult.FILE_MODIFIED_SINCE,l)}async createFile(n,l=E.$Ne.fromString(""),r){await this.u(n,r);const h=await this.writeFile(n,l);return this.r.fire(new d.$sl(n,d.FileOperation.CREATE,h)),h}async writeFile(n,l,r){const h=this.qb(await this.n(n),n),{providerExtUri:c}=this.R(h);let S=r;if((0,d.$jl)(h)&&!S?.atomic){const I=h.enforceAtomicWriteFile?.(n);I&&(S={...r,atomic:I})}try{await this.w(h,n,S)||await this.U(h,c.dirname(n));let R;if((0,d.$dl)(h)&&!(l instanceof E.$Ne))if((0,a.$ze)(l)){const L=await(0,a.$Ge)(l,3);L.ended?R=E.$Ne.concat(L.buffer):R=L}else R=(0,a.$De)(l,L=>E.$Ne.concat(L),3);else R=l;!(0,d.$gl)(h)||(0,d.$dl)(h)&&R instanceof E.$Ne||(0,d.$dl)(h)&&(0,d.$jl)(h)&&S?.atomic?await this.hb(h,n,S,R):await this.db(h,n,S,R instanceof E.$Ne?(0,E.$Ye)(R):R),this.r.fire(new d.$sl(n,d.FileOperation.WRITE))}catch(I){throw new d.$vl((0,u.localize)(11395,null,this.sb(n),(0,d.$ol)(I).toString()),(0,d.$rl)(I),S)}return this.resolve(n,{resolveMetadata:!0})}async w(n,l,r){const h=!!r?.unlock;if(h&&!(n.capabilities&d.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,u.localize)(11396,null,this.sb(l)));if(!!r?.atomic){if(!(n.capabilities&d.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,u.localize)(11397,null,this.sb(l)));if(!(n.capabilities&d.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,u.localize)(11398,null,this.sb(l)));if(h)throw new Error((0,u.localize)(11399,null,this.sb(l)))}let S;try{S=await n.stat(l)}catch{return}if(S.type&d.FileType.Directory)throw new d.$vl((0,u.localize)(11400,null,this.sb(l)),d.FileOperationResult.FILE_IS_DIRECTORY,r);if(this.rb(l,S),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==d.$Fl&&typeof S.mtime=="number"&&typeof S.size=="number"&&r.mtime<S.mtime&&r.etag!==(0,d.$Gl)({mtime:r.mtime,size:S.size}))throw new d.$vl((0,u.localize)(11401,null),d.FileOperationResult.FILE_MODIFIED_SINCE,r);return S}async readFile(n,l,r){const h=await this.m(n);return l?.atomic?this.z(h,n,l,r):this.C(h,n,l,r)}async z(n,l,r,h){return new Promise((c,S)=>{this.cb.queueFor(l,async()=>{try{const I=await this.C(n,l,r,h);c(I)}catch(I){S(I)}},this.R(n).providerExtUri)})}async C(n,l,r,h){const c=await this.D(n,l,{...r,preferUnbuffered:!0},h);return{...c,value:await(0,E.$Ze)(c.value)}}async readFileStream(n,l,r){const h=await this.m(n);return this.D(h,n,l,r)}async D(n,l,r,h){const c=new k.$we(h);let S=r;(0,d.$il)(n)&&n.enforceAtomicReadFile?.(l)&&(S={...r,atomic:!0});const I=this.J(l,S).then(L=>L,L=>{throw c.dispose(!0),L});let R;try{return typeof S?.etag=="string"&&S.etag!==d.$Fl&&await I,S?.atomic&&(0,d.$il)(n)||!((0,d.$gl)(n)||(0,d.$hl)(n))||(0,d.$dl)(n)&&S?.preferUnbuffered?R=this.I(n,l,S):(0,d.$hl)(n)?R=this.G(n,l,c.token,S):R=this.H(n,l,c.token,S),R.on("end",()=>c.dispose()),R.on("error",()=>c.dispose()),{...await I,value:R}}catch(L){throw R&&await(0,a.$Ee)(R),this.F(L,l,S)}}F(n,l,r){const h=(0,u.localize)(11402,null,this.sb(l),(0,d.$ol)(n).toString());return n instanceof d.$xl?new d.$xl(h,n.stat,r):n instanceof d.$wl?new d.$wl(h,n.fileOperationResult,n.size,n.options):new d.$vl(h,(0,d.$rl)(n),r)}G(n,l,r,h=Object.create(null)){const c=n.readFileStream(l,h,r);return(0,a.$Ke)(c,{data:S=>S instanceof E.$Ne?S:E.$Ne.wrap(S),error:S=>this.F(S,l,h)},S=>E.$Ne.concat(S))}H(n,l,r,h=Object.create(null)){const c=(0,E.$4e)();return(0,f.$2q)(n,l,c,S=>S,{...h,bufferSize:this.a,errorTransformer:S=>this.F(S,l,h)},r),c}I(n,l,r){const h=(0,a.$Be)(c=>E.$Ne.concat(c));return(async()=>{try{let c;r?.atomic&&(0,d.$il)(n)?c=await n.readFile(l,{atomic:!0}):c=await n.readFile(l),typeof r?.position=="number"&&(c=c.slice(r.position)),typeof r?.length=="number"&&(c=c.slice(0,r.length)),this.L(l,c.byteLength,r),h.end(E.$Ne.wrap(c))}catch(c){h.error(c),h.end()}})(),h}async J(n,l){const r=await this.resolve(n,{resolveMetadata:!0});if(r.isDirectory)throw new d.$vl((0,u.localize)(11403,null,this.sb(n)),d.FileOperationResult.FILE_IS_DIRECTORY,l);if(typeof l?.etag=="string"&&l.etag!==d.$Fl&&l.etag===r.etag)throw new d.$xl((0,u.localize)(11404,null),r,l);return this.L(n,r.size,l),r}L(n,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new d.$wl((0,u.localize)(11405,null,this.sb(n)),d.FileOperationResult.FILE_TOO_LARGE,l,r)}async canMove(n,l,r){return this.M(n,l,"move",r)}async canCopy(n,l,r){return this.M(n,l,"copy",r)}async M(n,l,r,h){if(n.toString()!==l.toString())try{const c=r==="move"?this.qb(await this.n(n),n):await this.m(n),S=this.qb(await this.n(l),l);await this.Q(c,n,S,l,r,h)}catch(c){return c}return!0}async move(n,l,r){const h=this.qb(await this.n(n),n),c=this.qb(await this.n(l),l),S=await this.N(h,n,c,l,"move",!!r),I=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new d.$sl(n,S==="move"?d.FileOperation.MOVE:d.FileOperation.COPY,I)),I}async copy(n,l,r){const h=await this.m(n),c=this.qb(await this.n(l),l),S=await this.N(h,n,c,l,"copy",!!r),I=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new d.$sl(n,S==="copy"?d.FileOperation.COPY:d.FileOperation.MOVE,I)),I}async N(n,l,r,h,c,S){if(l.toString()===h.toString())return c;const{exists:I,isSameResourceWithDifferentPathCase:R}=await this.Q(n,l,r,h,c,S);if(I&&!R&&S&&await this.del(h,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(h)),c==="copy"){if(n===r&&(0,d.$el)(n))await n.copy(l,h,{overwrite:S});else{const L=await this.resolve(l);L.isDirectory?await this.P(n,L,r,h):await this.O(n,l,r,h)}return c}else return n===r?(await n.rename(l,h,{overwrite:S}),c):(await this.N(n,l,r,h,"copy",S),await this.del(l,{recursive:!0}),"copy")}async O(n,l,r,h){if((0,d.$gl)(n)&&(0,d.$gl)(r))return this.jb(n,l,r,h);if((0,d.$gl)(n)&&(0,d.$dl)(r))return this.pb(n,l,r,h);if((0,d.$dl)(n)&&(0,d.$gl)(r))return this.nb(n,l,r,h);if((0,d.$dl)(n)&&(0,d.$dl)(r))return this.lb(n,l,r,h)}async P(n,l,r,h){await r.mkdir(h),Array.isArray(l.children)&&await s.Promises.settled(l.children.map(async c=>{const S=this.R(r).providerExtUri.joinPath(h,c.name);return c.isDirectory?this.P(n,await this.resolve(c.resource),r,S):this.O(n,c.resource,r,S)}))}async Q(n,l,r,h,c,S){let I=!1;if(n===r){const{providerExtUri:L,isPathCaseSensitive:O}=this.R(n);if(O||(I=L.isEqual(l,h)),I&&c==="copy")throw new Error((0,u.localize)(11406,null,this.sb(l),this.sb(h)));if(!I&&L.isEqualOrParent(h,l))throw new Error((0,u.localize)(11407,null,this.sb(l),this.sb(h)))}const R=await this.exists(h);if(R&&!I){if(!S)throw new d.$vl((0,u.localize)(11408,null,this.sb(l),this.sb(h)),d.FileOperationResult.FILE_MOVE_CONFLICT);if(n===r){const{providerExtUri:L}=this.R(n);if(L.isEqualOrParent(l,h))throw new Error((0,u.localize)(11409,null,this.sb(l),this.sb(h)))}}return{exists:R,isSameResourceWithDifferentPathCase:I}}R(n){const l=this.S(n);return{providerExtUri:l?$.$9g:$.$$g,isPathCaseSensitive:l}}S(n){return!!(n.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const l=this.qb(await this.j(n),n);await this.U(l,n);const r=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new d.$sl(n,d.FileOperation.CREATE,r)),r}async U(n,l){const r=[],{providerExtUri:h}=this.R(n);for(;!h.isEqual(l,h.dirname(l));)try{if(!((await n.stat(l)).type&d.FileType.Directory))throw new Error((0,u.localize)(11410,null,this.sb(l)));break}catch(c){if((0,d.$ql)(c)!==d.FileSystemProviderErrorCode.FileNotFound)throw c;r.push(h.basename(l)),l=h.dirname(l)}for(let c=r.length-1;c>=0;c--){l=h.joinPath(l,r[c]);try{await n.mkdir(l)}catch(S){if((0,d.$ql)(S)!==d.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(n,l){try{await this.W(n,l)}catch(r){return r}return!0}async W(n,l){const r=this.qb(await this.j(n),n),h=!!l?.useTrash;if(h&&!(r.capabilities&d.FileSystemProviderCapabilities.Trash))throw new Error((0,u.localize)(11411,null,this.sb(n)));const c=l?.atomic;if(c&&!(r.capabilities&d.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,u.localize)(11412,null,this.sb(n)));if(h&&c)throw new Error((0,u.localize)(11413,null,this.sb(n)));let S;try{S=await r.stat(n)}catch{}if(S)this.rb(n,S);else throw new d.$vl((0,u.localize)(11414,null,this.sb(n)),d.FileOperationResult.FILE_NOT_FOUND);if(!!!l?.recursive){const R=await this.resolve(n);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,u.localize)(11415,null,this.sb(n)))}return r}async del(n,l){const r=await this.W(n,l);let h=l;if((0,d.$kl)(r)&&!h?.atomic){const R=r.enforceAtomicDelete?.(n);R&&(h={...l,atomic:R})}const c=!!h?.useTrash,S=!!h?.recursive,I=h?.atomic??!1;await r.delete(n,{recursive:S,useTrash:c,atomic:I}),this.r.fire(new d.$sl(n,d.FileOperation.DELETE))}async cloneFile(n,l){const r=await this.j(n),h=this.qb(await this.n(l),l);if(!(r===h&&this.R(r).providerExtUri.isEqual(n,l)))return r===h&&(0,d.$fl)(r)?r.cloneFile(n,l):(await this.U(h,this.R(h).providerExtUri.dirname(l)),r===h&&(0,d.$el)(r)?this.cb.queueFor(n,()=>r.copy(n,l,{overwrite:!0}),this.R(r).providerExtUri):this.cb.queueFor(n,()=>this.O(r,n,h,l),this.R(r).providerExtUri))}static{this.ab=0}createWatcher(n,l){return this.watch(n,{...l,correlationId:b.ab++})}watch(n,l={recursive:!1,excludes:[]}){const r=new o.$Tc;let h=!1,c=()=>{h=!0};r.add((0,o.$Sc)(()=>c())),(async()=>{try{const I=await this.bb(n,l);h?(0,o.$Pc)(I):c=()=>(0,o.$Pc)(I)}catch(I){this.b.error(I)}})();const S=l.correlationId;if(typeof S=="number"){const I=r.add(new C.$le);return r.add(this.X.event(L=>{L.correlates(S)&&I.fire(L)})),{onDidChange:I.event,dispose:()=>r.dispose()}}return r}async bb(n,l){const r=await this.j(n),h=(0,A.$tj)([this.R(r).providerExtUri.getComparisonKey(n),l]);let c=this.$.get(h);return c||(c={count:0,disposable:r.watch(n,l)},this.$.set(h,c)),c.count+=1,(0,o.$Sc)(()=>{c&&(c.count--,c.count===0&&((0,o.$Pc)(c.disposable),this.$.delete(h)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,o.$Pc)(n.disposable);this.$.clear()}async db(n,l,r,h){return this.cb.queueFor(l,async()=>{const c=await n.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,a.$ze)(h)||(0,a.$Ae)(h)?await this.eb(n,c,h):await this.fb(n,c,h)}catch(S){throw(0,d.$ol)(S)}finally{await n.close(c)}},this.R(n).providerExtUri)}async eb(n,l,r){let h=0,c;if((0,a.$Ae)(r)){if(r.buffer.length>0){const S=E.$Ne.concat(r.buffer);await this.gb(n,l,S,S.byteLength,h,0),h+=S.byteLength}if(r.ended)return;c=r.stream}else c=r;return new Promise((S,I)=>{(0,a.$Fe)(c,{onData:async R=>{c.pause();try{await this.gb(n,l,R,R.byteLength,h,0)}catch(L){return I(L)}h+=R.byteLength,setTimeout(()=>c.resume())},onError:R=>I(R),onEnd:()=>S()})})}async fb(n,l,r){let h=0,c;for(;(c=r.read())!==null;)await this.gb(n,l,c,c.byteLength,h,0),h+=c.byteLength}async gb(n,l,r,h,c,S){let I=0;for(;I<h;){const R=await n.write(l,c+I,r.buffer,S+I,h-I);I+=R}}async hb(n,l,r,h){return this.cb.queueFor(l,()=>this.ib(n,l,r,h),this.R(n).providerExtUri)}async ib(n,l,r,h){let c;h instanceof E.$Ne?c=h:(0,a.$ze)(h)?c=await(0,E.$Ze)(h):(0,a.$Ae)(h)?c=await(0,E.$1e)(h):c=(0,E.$Xe)(h),await n.writeFile(l,c.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(n,l,r,h){return this.cb.queueFor(h,()=>this.kb(n,l,r,h),this.R(r).providerExtUri)}async kb(n,l,r,h){let c,S;try{c=await n.open(l,{create:!1}),S=await r.open(h,{create:!0,unlock:!1});const I=E.$Ne.alloc(this.a);let R=0,L=0,O=0;do O=await n.read(c,R,I.buffer,L,I.byteLength-L),await this.gb(r,S,I,O,R,L),R+=O,L+=O,L===I.byteLength&&(L=0);while(O>0)}catch(I){throw(0,d.$ol)(I)}finally{await s.Promises.settled([typeof c=="number"?n.close(c):Promise.resolve(),typeof S=="number"?r.close(S):Promise.resolve()])}}async lb(n,l,r,h){return this.cb.queueFor(h,()=>this.mb(n,l,r,h),this.R(r).providerExtUri)}async mb(n,l,r,h){return r.writeFile(h,await n.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,l,r,h){return this.cb.queueFor(h,()=>this.ob(n,l,r,h),this.R(r).providerExtUri)}async ob(n,l,r,h){const c=await r.open(h,{create:!0,unlock:!1});try{const S=await n.readFile(l);await this.gb(r,c,E.$Ne.wrap(S),S.byteLength,0,0)}catch(S){throw(0,d.$ol)(S)}finally{await r.close(c)}}async pb(n,l,r,h){const c=await(0,E.$Ze)(this.H(n,l,k.CancellationToken.None));await this.hb(r,h,void 0,c)}qb(n,l){if(n.capabilities&d.FileSystemProviderCapabilities.Readonly)throw new d.$vl((0,u.localize)(11416,null,this.sb(l)),d.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,l){if((l.permissions??0)&d.FilePermission.Readonly)throw new d.$vl((0,u.localize)(11417,null,this.sb(n)),d.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}};e.$3q=i,e.$3q=i=b=Be([je(0,v.$ak)],i)}),define(Re[71],Ae([1,0,23,13,25,14,6,36,2,8,3,19,55,26,7,15,120,212,210,209]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class b extends f.$cr{static{this.L=!1}constructor(p,n){super(p,n),this.onDidChangeCapabilities=C.Event.None,this.P=new E.$Ac(l=>w.$0g.getComparisonKey(l)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=u.FileSystemProviderCapabilities.FileReadWrite|u.FileSystemProviderCapabilities.FileOpenReadWriteClose|u.FileSystemProviderCapabilities.FileReadStream|u.FileSystemProviderCapabilities.FileFolderCopy|u.FileSystemProviderCapabilities.FileWriteUnlock|u.FileSystemProviderCapabilities.FileAtomicRead|u.FileSystemProviderCapabilities.FileAtomicWrite|u.FileSystemProviderCapabilities.FileAtomicDelete|u.FileSystemProviderCapabilities.FileClone,D.$l&&(this.M|=u.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(p){try{const{stat:n,symbolicLink:l}=await $.SymlinkSupport.stat(this.I(p));return{type:this.O(n,l),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:u.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(p){try{return await this.stat(p)}catch{return}}async readdir(p){try{const n=await $.Promises.readdir(this.I(p),{withFileTypes:!0}),l=[];return await Promise.all(n.map(async r=>{try{let h;r.isSymbolicLink()?h=(await this.stat((0,w.$gh)(p,r.name))).type:h=this.O(r),l.push([r.name,h])}catch(h){this.a.trace(h)}})),l}catch(n){throw this.hb(n)}}O(p,n){let l;return n?.dangling?l=u.FileType.Unknown:p.isFile()?l=u.FileType.File:p.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,n&&(l|=u.FileType.SymbolicLink),l}async Q(p){const n=this.I(p);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let l;for(;l=this.P.get(p);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await l.wait();const r=new s.$Eh;return this.P.set(p,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,y.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(p)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(p)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(p,n){let l;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(p)})`),l=await this.Q(p));const r=this.I(p);return await t.promises.readFile(r)}catch(r){throw this.hb(r)}finally{l?.dispose()}}R(p){b.L&&this.a.trace(p)}readFileStream(p,n,l){const r=(0,m.$Be)(h=>k.$Ne.concat(h.map(c=>k.$Ne.wrap(c))).buffer);return(0,d.$2q)(this,p,r,h=>h.buffer,{...n,bufferSize:256*1024},l),r}async writeFile(p,n,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.S(p)?this.U(p,(0,w.$gh)((0,w.$fh)(p),`${(0,w.$dh)(p)}${l.atomic.postfix}`),n,l):this.W(p,n,l)}async S(p){try{const n=this.I(p),{symbolicLink:l}=await $.SymlinkSupport.stat(n);if(l)return!1}catch{}return!0}async U(p,n,l,r){const h=new y.$Tc;try{h.add(await this.Q(p)),h.add(await this.Q(n)),await this.W(n,l,r,!0);try{await this.rename(n,p,{overwrite:!0})}catch(c){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}finally{h.dispose()}}async W(p,n,l,r){let h;try{const c=this.I(p);if(!l.create||!l.overwrite){if(await $.Promises.exists(c)){if(!l.overwrite)throw(0,u.$nl)((0,a.localize)(11375,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.$nl)((0,a.localize)(11376,null),u.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(p,{create:!0,unlock:l.unlock},r),await this.write(h,0,n,0,n.byteLength)}catch(c){throw await this.ib(p,c)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(p){b.$=p}async open(p,n,l){const r=this.I(p);let h;(0,u.$bl)(n)&&!l&&(h=await this.Q(p));let c;try{if((0,u.$bl)(n)&&n.unlock)try{const{stat:I}=await $.SymlinkSupport.stat(r);I.mode&128||await t.promises.chmod(r,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let S;if((0,u.$bl)(n)){if(D.$j)try{await t.promises.truncate(r,0),S="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}S||(S="w")}else S="r";c=await $.Promises.open(r,S)}catch(S){throw h?.dispose(),(0,u.$bl)(n)?await this.ib(p,S):this.hb(S)}if(this.X.set(c,0),(0,u.$bl)(n)&&this.Z.set(c,p),h){const S=this.Y.get(c);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.Y.set(c,h),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),S.dispose())}return c}async close(p){const n=this.Y.get(p);try{if(this.X.delete(p),this.Z.delete(p)&&b.$)try{await $.Promises.fdatasync(p)}catch(l){b.configureFlushOnWrite(!1),this.a.error(l)}return await $.Promises.close(p)}catch(l){throw this.hb(l)}finally{n&&(this.Y.get(p)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${p}`),this.Y.delete(p)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${p}`),n.dispose())}}async read(p,n,l,r,h){const c=this.ab(p,n);let S=null;try{S=(await $.Promises.read(p,l,r,h,c)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(p,c,S)}return S}ab(p,n){return n===this.X.get(p)?null:n}bb(p,n,l){const r=this.X.get(p);typeof r=="number"&&(typeof n=="number"||(typeof l=="number"?this.X.set(p,r+l):this.X.delete(p)))}async write(p,n,l,r,h){return(0,s.$Zh)(()=>this.cb(p,n,l,r,h),100,3)}async cb(p,n,l,r,h){const c=this.ab(p,n);let S=null;try{S=(await $.Promises.write(p,l,r,h,c)).bytesWritten}catch(I){throw await this.ib(this.Z.get(p),I)}finally{this.bb(p,c,S)}return S}async mkdir(p){try{await t.promises.mkdir(this.I(p))}catch(n){throw this.hb(n)}}async delete(p,n){try{const l=this.I(p);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,o.$jc)((0,o.$mc)(l),`${(0,o.$nc)(l)}${n.atomic.postfix}`)),await $.Promises.rm(l,$.RimRafMode.MOVE,r)}else try{await t.promises.unlink(l)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let h=!1;try{const{stat:c,symbolicLink:S}=await $.SymlinkSupport.stat(l);h=c.isDirectory()&&!S}catch{}if(h)await t.promises.rmdir(l);else throw r}else throw r}}catch(l){throw this.hb(l)}}async rename(p,n,l){const r=this.I(p),h=this.I(n);if(r!==h)try{await this.db(p,n,"move",l.overwrite),await $.Promises.rename(r,h)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,a.localize)(11377,null,(0,o.$nc)(r),(0,o.$nc)((0,o.$mc)(h)),c.toString()))),this.hb(c)}}async copy(p,n,l){const r=this.I(p),h=this.I(n);if(r!==h)try{await this.db(p,n,"copy",l.overwrite),await $.Promises.copy(r,h,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,a.localize)(11378,null,(0,o.$nc)(r),(0,o.$nc)((0,o.$mc)(h)),c.toString()))),this.hb(c)}}async db(p,n,l,r){const h=this.I(p),c=this.I(n);let S=!1;if(!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive)||(S=(0,A.$Dg)(h,c,!0)),S){if(l==="copy")throw(0,u.$nl)((0,a.localize)(11379,null),u.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const R=await this.N(p);if(!R)throw(0,u.$nl)((0,a.localize)(11380,null),u.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(n);if(L){if(!r)throw(0,u.$nl)((0,a.localize)(11381,null),u.FileSystemProviderErrorCode.FileExists);R.type&u.FileType.File&&L.type&u.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(p,n){return this.eb(p,n,!1)}async eb(p,n,l){const r=this.I(p),h=this.I(n),c=!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(r,h,!c))return;const S=new y.$Tc;try{S.add(await this.Q(p)),S.add(await this.Q(n)),l&&await t.promises.mkdir((0,o.$mc)(h),{recursive:!0}),await t.promises.copyFile(r,h)}catch(I){if(I.code==="ENOENT"&&!l)return this.eb(p,n,!0);throw this.hb(I)}finally{S.dispose()}}t(p,n,l){return new v.$jr(r=>p(r),r=>n(r),l)}F(p,n,l){return new g.$sr(r=>p(r),r=>n(r),l)}hb(p){if(p instanceof u.$ml)return p;let n=p,l;switch(p.code){case"ENOENT":l=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=u.FileSystemProviderErrorCode.Unknown;break;default:l=u.FileSystemProviderErrorCode.Unknown}return(0,u.$nl)(n,l)}async ib(p,n){let l=this.hb(n);if(p&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.I(p));r.mode&128||(l=(0,u.$nl)(n,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return l}}e.$tr=b}),define(Re[213],Ae([1,0,6,71,2,14,55,18]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0;class y extends E.$Uc{constructor(w,m){super(),this.a=w,this.b=m,this.F=new Map,this.G=new Map}call(w,m,$){const a=this.c(w);switch(m){case"stat":return this.g(a,$[0]);case"readdir":return this.h(a,$[0]);case"open":return this.r(a,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(a,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(a,$[0],$[1],$[2]);case"rename":return this.z(a,$[0],$[1],$[2]);case"copy":return this.C(a,$[0],$[1],$[2]);case"cloneFile":return this.D(a,$[0],$[1]);case"mkdir":return this.w(a,$[0]);case"delete":return this.y(a,$[0],$[1]);case"watch":return this.I(a,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${m} not found`)}listen(w,m,$){const a=this.c(w);switch(m){case"fileChange":return this.H(a,$[0]);case"readFileStream":return this.m(a,$[0],$[1])}throw new Error(`Unknown event ${m}`)}g(w,m){const $=this.f(w,m,!0);return this.a.stat($)}h(w,m){const $=this.f(w,m);return this.a.readdir($)}async j(w,m,$){const a=this.f(w,m,!0),u=await this.a.readFile(a,$);return k.$Ne.wrap(u)}m(w,m,$){const a=this.f(w,m,!0),u=new A.$we,d=new t.$le({onDidRemoveLastListener:()=>{u.cancel()}}),f=this.a.readFileStream(a,$,u.token);return(0,C.$Fe)(f,{onData:v=>d.fire(k.$Ne.wrap(v)),onError:v=>d.fire(v),onEnd:()=>{d.fire("end"),d.dispose(),u.dispose()}}),d.event}n(w,m,$,a){const u=this.f(w,m);return this.a.writeFile(u,$.buffer,a)}r(w,m,$){const a=this.f(w,m,!0);return this.a.open(a,$)}s(w){return this.a.close(w)}async t(w,m,$){const a=k.$Ne.alloc($),d=await this.a.read(w,m,a.buffer,0,$);return[a,d]}u(w,m,$,a,u){return this.a.write(w,m,$.buffer,a,u)}w(w,m){const $=this.f(w,m);return this.a.mkdir($)}y(w,m,$){const a=this.f(w,m);return this.a.delete(a,$)}z(w,m,$,a){const u=this.f(w,m),d=this.f(w,$);return this.a.rename(u,d,a)}C(w,m,$,a){const u=this.f(w,m),d=this.f(w,$);return this.a.copy(u,d,a)}D(w,m,$){const a=this.f(w,m),u=this.f(w,$);return this.a.cloneFile(a,u)}H(w,m){const $=new t.$le({onWillAddFirstListener:()=>{this.F.set(m,this.L(w,$))},onDidRemoveLastListener:()=>{(0,E.$Pc)(this.F.get(m)),this.F.delete(m)}});return $.event}async I(w,m,$,a,u){const d=this.F.get(m);if(d){const f=this.f(w,a),v=d.watch($,f,u);this.G.set(m+$,v)}}async J(w,m){const $=w+m,a=this.G.get($);a&&((0,E.$Pc)(a),this.G.delete($))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$4s=y;class o extends E.$Uc{constructor(w,m,$,a){super(),this.c=w,this.f=$,this.g=a,this.a=new Map,this.b=this.B(new s.$tr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(m)}h(w){const m=this.B(new t.$le);this.B(m.event($=>{w.fire($.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile($=>m.fire($))),this.B(this.b.onDidWatchError($=>w.fire($)))}j(w){}m(w){}watch(w,m,$){const a=this.m(this.g);return Array.isArray(a)&&($.excludes=[...$.excludes,...a]),this.a.set(w,this.b.watch(m,$)),(0,E.$Sc)(()=>{(0,E.$Pc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$5s=o}),define(Re[123],Ae([1,0,4,6,11,2]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.$us=e.$ts=void 0;class C extends E.$lk{constructor(w,m,$,a,u){super(m,$,a),this.r=w,this.t=u,this.B(u.listen("onDidChangeLogLevel",w)(d=>{(0,E.$ck)(d)?super.setLogLevel(d):super.setLogLevel(t.URI.revive(d[0]),d[1])})),this.B(u.listen("onDidChangeVisibility",w)(([d,f])=>super.setVisibility(t.URI.revive(d),f))),this.B(u.listen("onDidChangeLoggers",w)(({added:d,removed:f})=>{for(const v of d)super.registerLogger({...v,resource:t.URI.revive(v.resource)});for(const v of f)super.deregisterLogger(v.resource)}))}createConsoleMainLogger(){return new E.$jk({log:(w,m)=>{this.t.call("consoleLog",[w,m])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,m){super.setLogLevel(w,m),this.t.call("setLogLevel",[w,m])}setVisibility(w,m){super.setVisibility(w,m),this.t.call("setVisibility",[this.n(w),m])}s(w,m,$){return new A(this.t,w,m,$,this.r)}static setLogLevel(w,m,$){return w.call("setLogLevel",[m,$])}}e.$ts=C;class A extends E.$gk{constructor(w,m,$,a,u){super(a?.logLevel==="always"),this.r=w,this.s=m,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[m,a,u]).then(()=>{this.u(this.n),this.m=!0})}g(w,m){const $=[[w,m]];this.m?this.u($):this.n.push(...$)}u(w){this.r.call("log",[this.s,w])}}class y{constructor(w,m){this.a=w,this.b=m}listen(w,m){const $=this.b(w);switch(m){case"onDidChangeLoggers":return s.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(u=>this.c(u,$)),removed:[...a.removed].map(u=>this.c(u,$))}));case"onDidChangeVisibility":return s.Event.map(this.a.onDidChangeVisibility,a=>[$.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return s.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$ck)(a)?a:[$.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${m}`)}async call(w,m,$){const a=this.b(w);switch(m){case"setLogLevel":return(0,E.$ck)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(t.URI.revive(a.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(u=>this.c(u,a)))}throw new Error(`Call not found: ${m}`)}c(w,m){return{...w,resource:m.transformOutgoingURI(w.resource)}}}e.$us=y;class o extends k.$Uc{constructor(w,m){super(),m.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel($=>m.call("setLogLevel",[$]))),m.call("getRegisteredLoggers").then($=>{for(const a of $)w.registerLogger({...a,resource:t.URI.revive(a.resource)})}),this.B(m.listen("onDidChangeVisibility")(([$,a])=>w.setVisibility(t.URI.revive($),a))),this.B(m.listen("onDidChangeLoggers")(({added:$,removed:a})=>{for(const u of $)w.registerLogger({...u,resource:t.URI.revive(u.resource)});for(const u of a)w.deregisterLogger(u.resource)}))}}e.$vs=o}),define(Re[124],Ae([1,0,2,11]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KR=void 0;class E extends t.$Uc{constructor(C,A=[]){super(),this.a=new s.$kk([C,...A]),this.B(C.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...A){this.a.trace(C,...A)}debug(C,...A){this.a.debug(C,...A)}info(C,...A){this.a.info(C,...A)}warn(C,...A){this.a.warn(C,...A)}error(C,...A){this.a.error(C,...A)}flush(){this.a.flush()}}e.$KR=E}),define(Re[214],Ae([1,0,15,11]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;var E;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(E||(E={}));async function k(o,D,w,m,$){try{const a=await new Promise((d,f)=>{ue(["@vscode/spdlog"],d,f)}).then(Ue);a.setFlushOn(E.Trace);const u=await a.createAsyncRotatingLogger(o,D,w,m);return $?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(a){console.error(a)}return null}function C(o,D,w){switch(D){case s.LogLevel.Trace:o.trace(w);break;case s.LogLevel.Debug:o.debug(w);break;case s.LogLevel.Info:o.info(w);break;case s.LogLevel.Warning:o.warn(w);break;case s.LogLevel.Error:o.error(w);break;case s.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function A(o,D){switch(D){case s.LogLevel.Trace:o.setLevel(E.Trace);break;case s.LogLevel.Debug:o.setLevel(E.Debug);break;case s.LogLevel.Info:o.setLevel(E.Info);break;case s.LogLevel.Warning:o.setLevel(E.Warning);break;case s.LogLevel.Error:o.setLevel(E.Error);break;case s.LogLevel.Off:o.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class y extends s.$gk{constructor(D,w,m,$,a){super(),this.m=[],this.setLevel(a),this.n=this.s(D,w,m,$),this.B(this.onDidChangeLogLevel(u=>{this.r&&A(this.r,u)}))}async s(D,w,m,$){const a=m?6:1,u=30/a*t.$Il.MB,d=await k(D,w,u,a,$);if(d){this.r=d,A(this.r,this.getLevel());for(const{level:f,message:v}of this.m)C(this.r,f,v);this.m=[]}}g(D,w){this.r?C(this.r,D,w):this.getLevel()<=D&&this.m.push({level:D,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$zR=y}),define(Re[125],Ae([1,0,22,11,214]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0;class k extends s.$lk{s(A,y,o){return new E.$zR((0,t.$2g)(),A.fsPath,!o?.donotRotate,!!o?.donotUseFormatters,y)}}e.$AR=k});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[215],Ae([1,0,57,7,5]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,t=dt(t);var k;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var C;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(C||(e.MarkerSeverity=C={})),function(y){function o(a,u){return u-a}y.compare=o;const D=Object.create(null);D[y.Error]=(0,s.localize)(11315,null),D[y.Warning]=(0,s.localize)(11316,null),D[y.Info]=(0,s.localize)(11317,null);function w(a){return D[a]||""}y.toString=w;function m(a){switch(a){case t.default.Error:return y.Error;case t.default.Warning:return y.Warning;case t.default.Info:return y.Info;case t.default.Ignore:return y.Hint}}y.fromSeverity=m;function $(a){switch(a){case y.Error:return t.default.Error;case y.Warning:return t.default.Warning;case y.Info:return t.default.Info;case y.Hint:return t.default.Ignore}}y.toSeverity=$}(C||(e.MarkerSeverity=C={}));var A;(function(y){const o="";function D(m){return w(m,!0)}y.makeKey=D;function w(m,$){const a=[o];return m.source?a.push(m.source.replace("\xA6","\\\xA6")):a.push(o),m.code?typeof m.code=="string"?a.push(m.code.replace("\xA6","\\\xA6")):a.push(m.code.value.replace("\xA6","\\\xA6")):a.push(o),m.severity!==void 0&&m.severity!==null?a.push(C.toString(m.severity)):a.push(o),m.message&&$?a.push(m.message.replace("\xA6","\\\xA6")):a.push(o),m.startLineNumber!==void 0&&m.startLineNumber!==null?a.push(m.startLineNumber.toString()):a.push(o),m.startColumn!==void 0&&m.startColumn!==null?a.push(m.startColumn.toString()):a.push(o),m.endLineNumber!==void 0&&m.endLineNumber!==null?a.push(m.endLineNumber.toString()):a.push(o),m.endColumn!==void 0&&m.endColumn!==null?a.push(m.endColumn.toString()):a.push(o),a.push(o),a.join("\xA6")}y.makeKeyOptionalMessage=w})(A||(e.IMarkerData=A={})),e.$Gu=(0,E.$Fi)("markerService")}),define(Re[72],Ae([1,0,6,39,2,5]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=void 0,e.$to=(0,k.$Fi)("policy");class C extends E.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new t.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(o){const D=Object.keys(this.f).length;return this.f={...o,...this.f},D!==Object.keys(this.f).length&&await this.j(o),s.Iterable.reduce(this.g.entries(),(w,[m,$])=>({...w,[m]:$}),{})}getPolicyValue(o){return this.g.get(o)}serialize(){return s.Iterable.reduce(Object.entries(this.f),(o,[D,w])=>({...o,[D]:{definition:w,value:this.g.get(D)}}),{})}}e.$uo=C;class A{constructor(){this.onDidChange=t.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vo=A}),define(Re[61],Ae([1,0,31]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const k=E.context.configuration();if(k)s=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:k.version})}}else s={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",nlsCoreBaseUrl:"https://www.vscode-unpkg.net/nls/",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-toolsai.prompty":{onFileOpen:[{pathGlob:"{**/*.prompty}",important:!1}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{descriptionOverride:"GitHub Copilot is an AI pair programmer tool that helps you write code faster and smarter."}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionsEnabledWithApiProposalVersion:["GitHub.copilot-chat"],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testRelatedCode","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentReveal","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["authGetSessions","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","activeComment","commentReveal","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authGetSessions","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive","chatParticipantPrivate","lmTools"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["contribIssueReporter","contribViewsWelcome","debugVisualization","portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipantAdditions","embeddings","languageModelSystem","lmTools"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"TeamsDevApp.ms-teams-vscode-extension":["chatParticipantAdditions","languageModelSystem"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.3",sha256:"7380a890787452f14b2db7835dfa94de538caf358ebc263f9d46dd68ac52de93",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.92.0",sha256:"e5d0a74728292423631f79d076ecb2bc129f9637bcbc2529e48a0fd53baa69cc",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.92.1",commit:"eaa41d57266683296de7d118f574d0c2652e1fc4",date:"2024-08-07T20:16:39.455Z"},Object.keys(s).length===0&&Object.assign(s,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(Re[29],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,t.$Fi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(Re[216],Ae([1,0,13,18,2,5]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.ProgressLocation=e.$xw=void 0,e.$xw=(0,k.$Fi)("progressService");var C;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(C||(e.ProgressLocation=C={})),e.$yw=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$zw=A;class y{get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const $=this.d;this.d=()=>{$?.(),m()}}):Promise.resolve()}}e.$Aw=y;let o=class extends E.$Uc{constructor(m,$){super(),this.a=new t.$3h,$.withProgress(m,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,E.$Sc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$Bw=o,e.$Bw=o=Be([je(1,e.$xw)],o);class D extends E.$Uc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new E.$Tc)}start(m){this.stop();const $=++this.a,a=new s.$we;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,E.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,E.$Sc)(()=>a.cancel())),this.b.add((0,E.$Sc)(()=>this.c?this.c.done():void 0)),{id:$,token:a.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$Cw=D,e.$Dw=(0,k.$Fi)("editorProgressService")}),define(Re[37],Ae([1,0,105,10]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,t=Ue(t),s=Ue(s);class E{constructor(){this.a=new Map}add(C,A){t.ok(s.$eg(C)),t.ok(s.$gg(A)),t.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$ro=new E}),define(Re[126],Ae([1,0,6,160,37]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,E=Ue(E),e.$so={JSONContribution:"base.contributions.json"};function k(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class C{constructor(){this.b=new t.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,D){this.a[k(o)]=D,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(o){const D=this.a[o];return D?(0,s.$8j)(D):void 0}hasSchemaContent(o){return!!this.a[o]}}const A=new C;E.$ro.add(e.$so.JSONContribution,A)}),define(Re[45],Ae([1,0,17,6,10,7,27,126,37]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.ConfigurationScope=e.$wo=e.EditPresentationTypes=void 0,e.$Ho=u,e.$Io=d,e.$Jo=f,e.$Ko=g,e.$Lo=b,e.$Mo=i,e.$No=p,E=Ue(E),k=Ue(k);var o;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$wo={Configuration:"base.contributions.configuration"};var D;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do="vscode://schemas/settings/resourceLanguage",e.$Eo="vscode://schemas/settings/configurationDefaults";const w=y.$ro.as(A.$so.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new s.$le,this.onDidSchemaChange=this.j.event,this.k=new s.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(11611,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},w.registerSchema(e.$Do,this.h),this.z()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const h=new Set;this.r(l,r,h),w.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations(l){const r=new Set;this.s(l,r),w.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:r})}updateConfigurations({add:l,remove:r}){const h=new Set;this.s(r,h),this.r(l,!1,h),w.registerSchema(e.$Do,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations(l){const r=new Set;this.l(l,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:!0})}l(l,r){this.a.push(...l);const h=[];for(const{overrides:c,source:S}of l)for(const I in c){r.add(I);const R=this.b.get(I)??this.b.set(I,{configurationDefaultOverrides:[]}).get(I),L=c[I];if(R.configurationDefaultOverrides.push({value:L,source:S}),e.$Go.test(I)){const O=this.o(I,L,S,R.configurationDefaultOverrideValue);if(!O)continue;R.configurationDefaultOverrideValue=O,this.n(I,O,S),h.push(...u(I))}else{const O=this.p(I,L,S,R.configurationDefaultOverrideValue);if(!O)continue;R.configurationDefaultOverrideValue=O;const P=this.e[I];P&&(this.A(I,P),this.w(I,P))}}this.q(h)}deregisterDefaultConfigurations(l){const r=new Set;this.m(l,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:!0})}m(l,r){for(const h of l){const c=this.a.indexOf(h);c!==-1&&this.a.splice(c,1)}for(const{overrides:h,source:c}of l)for(const S in h){const I=this.b.get(S);if(!I)continue;const R=I.configurationDefaultOverrides.findIndex(L=>c?L.source?.id===c.id:L.value===h[S]);if(R!==-1){if(I.configurationDefaultOverrides.splice(R,1),I.configurationDefaultOverrides.length===0&&this.b.delete(S),e.$Go.test(S)){let L;for(const O of I.configurationDefaultOverrides)L=this.o(S,O.value,O.source,L);L&&!E.$rg(L.value)?(I.configurationDefaultOverrideValue=L,this.n(S,L,c)):(this.b.delete(S),delete this.e[S],delete this.c.properties[S])}else{let L;for(const P of I.configurationDefaultOverrides)L=this.p(S,P.value,P.source,L);I.configurationDefaultOverrideValue=L;const O=this.e[S];O&&(this.A(S,O),this.w(S,O))}r.add(S)}}this.y()}n(l,r,h){const c={type:"object",default:r.value,description:k.localize(11612,null,(0,C.$jj)(l)),$ref:e.$Do,defaultDefaultValue:r.value,source:h,defaultValueSource:h};this.e[l]=c,this.c.properties[l]=c}o(l,r,h,c){const S=c?.value||{},I=c?.source??new Map;if(!(I instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const R of Object.keys(r)){const L=r[R];if(E.$gg(L)&&(E.$lg(S[R])||E.$gg(S[R]))){if(S[R]={...S[R]??{},...L},h)for(const P in L)I.set(`${R}.${P}`,h)}else S[R]=L,h?I.set(R,h):I.delete(R)}return{value:S,source:I}}p(l,r,h,c){const S=this.e[l],I=c?.value??S?.defaultDefaultValue;let R=h;if(E.$gg(r)&&(S!==void 0&&S.type==="object"||S===void 0&&(E.$lg(I)||E.$gg(I)))){if(R=c?.source??new Map,!(R instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const O in r)h&&R.set(`${l}.${O}`,h);r={...E.$gg(I)?I:{},...r}}return{value:r,source:R}}deltaConfiguration(l){let r=!1;const h=new Set;l.removedDefaults&&(this.m(l.removedDefaults,h),r=!0),l.addedDefaults&&(this.l(l.addedDefaults,h),r=!0),l.removedConfigurations&&this.s(l.removedConfigurations,h),l.addedConfigurations&&this.r(l.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...l){this.j.fire()}registerOverrideIdentifiers(l){this.q(l),this.j.fire()}q(l){for(const r of l)this.i.add(r);this.y()}r(l,r,h){l.forEach(c=>{this.u(c,r,c.extensionInfo,c.restrictedProperties,void 0,h),this.d.push(c),this.v(c)})}s(l,r){const h=c=>{if(c.properties)for(const S in c.properties){r.add(S);const I=this.e[S];I?.policy?.name&&this.f.delete(I.policy.name),delete this.e[S],this.x(S,c.properties[S])}c.allOf?.forEach(S=>h(S))};for(const c of l){h(c);const S=this.d.indexOf(c);S!==-1&&this.d.splice(S,1)}}u(l,r=!0,h,c,S=D.WINDOW,I){S=E.$ng(l.scope)?S:l.scope;const R=l.properties;if(R)for(const O in R){const P=R[O];if(r&&g(O,P)){delete R[O];continue}if(P.source=h,P.defaultDefaultValue=R[O].default,this.A(O,P),e.$Go.test(O)?P.scope=void 0:(P.scope=E.$ng(P.scope)?S:P.scope,P.restricted=E.$ng(P.restricted)?!!c?.includes(O):P.restricted),R[O].hasOwnProperty("included")&&!R[O].included){this.g[O]=R[O],delete R[O];continue}else this.e[O]=R[O],R[O].policy?.name&&this.f.set(R[O].policy.name,O);!R[O].deprecationMessage&&R[O].markdownDeprecationMessage&&(R[O].deprecationMessage=R[O].markdownDeprecationMessage),I.add(O)}const L=l.allOf;if(L)for(const O of L)this.u(O,r,h,c,S,I)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const l=new Map;for(const[r,h]of this.b)h.configurationDefaultOverrideValue&&l.set(r,h.configurationDefaultOverrideValue);return l}v(l){const r=h=>{const c=h.properties;if(c)for(const I in c)this.w(I,c[I]);h.allOf?.forEach(r)};r(l)}w(l,r){switch(e.$xo.properties[l]=r,r.scope){case D.APPLICATION:e.$yo.properties[l]=r;break;case D.MACHINE:e.$zo.properties[l]=r;break;case D.MACHINE_OVERRIDABLE:e.$Ao.properties[l]=r;break;case D.WINDOW:e.$Bo.properties[l]=r;break;case D.RESOURCE:e.$Co.properties[l]=r;break;case D.LANGUAGE_OVERRIDABLE:e.$Co.properties[l]=r,this.h.properties[l]=r;break}}x(l,r){switch(delete e.$xo.properties[l],r.scope){case D.APPLICATION:delete e.$yo.properties[l];break;case D.MACHINE:delete e.$zo.properties[l];break;case D.MACHINE_OVERRIDABLE:delete e.$Ao.properties[l];break;case D.WINDOW:delete e.$Bo.properties[l];break;case D.RESOURCE:case D.LANGUAGE_OVERRIDABLE:delete e.$Co.properties[l],delete this.h.properties[l];break}}y(){for(const l of this.i.values()){const r=`[${l}]`,h={type:"object",description:k.localize(11613,null),errorMessage:k.localize(11614,null),$ref:e.$Do};this.A(r,h),e.$xo.properties[r]=h,e.$yo.properties[r]=h,e.$zo.properties[r]=h,e.$Ao.properties[r]=h,e.$Bo.properties[r]=h,e.$Co.properties[r]=h}}z(){const l={type:"object",description:k.localize(11615,null),errorMessage:k.localize(11616,null),$ref:e.$Do};e.$xo.patternProperties[e.$Fo]=l,e.$yo.patternProperties[e.$Fo]=l,e.$zo.patternProperties[e.$Fo]=l,e.$Ao.patternProperties[e.$Fo]=l,e.$Bo.patternProperties[e.$Fo]=l,e.$Co.patternProperties[e.$Fo]=l,this.j.fire()}A(l,r){const h=this.b.get(l)?.configurationDefaultOverrideValue;let c,S;h&&(!r.disallowConfigurationDefault||!h.source)&&(c=h.value,S=h.source),E.$lg(c)&&(c=r.defaultDefaultValue,S=void 0),E.$lg(c)&&(c=f(r.type)),r.default=c,r.defaultValueSource=S}}const $="\\[([^\\]]+)\\]",a=new RegExp($,"g");e.$Fo=`^(${$})+$`,e.$Go=new RegExp(e.$Fo);function u(n){const l=[];if(e.$Go.test(n)){let r=a.exec(n);for(;r?.length;){const h=r[1].trim();h&&l.push(h),r=a.exec(n)}}return(0,t.$Lb)(l)}function d(n){return n.reduce((l,r)=>`${l}[${r}]`,"")}function f(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const v=new m;y.$ro.add(e.$wo.Configuration,v);function g(n,l){return n.trim()?e.$Go.test(n)?k.localize(11618,null,n):v.getConfigurationProperties()[n]!==void 0?k.localize(11619,null,n):l.policy?.name&&v.getPolicyConfigurations().get(l.policy?.name)!==void 0?k.localize(11620,null,n,l.policy?.name,v.getPolicyConfigurations().get(l.policy?.name)):null:k.localize(11617,null)}function b(){const n=[],l=v.getConfigurationProperties();for(const r of Object.keys(l))n.push([r,l[r].scope]);return n.push(["launch",D.RESOURCE]),n.push(["task",D.RESOURCE]),n}function i(n){const l={};for(const r of n){const h=r.properties;if(E.$gg(h))for(const c in h)l[c]=h[c];r.allOf&&Object.assign(l,i(r.allOf))}return l}function p(n){switch(n){case"application":return D.APPLICATION;case"machine":return D.MACHINE;case"resource":return D.RESOURCE;case"machine-overridable":return D.MACHINE_OVERRIDABLE;case"language-overridable":return D.LANGUAGE_OVERRIDABLE;default:return D.WINDOW}}}),define(Re[127],Ae([1,0,17,6,42,2,25,20,10,4,27,45,15,37]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0,e.$So=b,t=Ue(t),E=Ue(E),A=Ue(A),y=Ue(y);function a(l){return Object.isFrozen(l)?l:A.$fo(l)}class u{static createEmptyModel(r){return new u({},[],[],void 0,r)}constructor(r,h,c,S,I){this.b=r,this.c=h,this.d=c,this.raw=S,this.f=I,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(h=>{if(h instanceof u)return h;const c=new d("",this.f);return c.parseRaw(h),c.configurationModel});this.g=r.reduce((h,c)=>c===h?c:h.merge(c),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,D.$hj)(this.contents,r):this.contents}inspect(r,h){const c=this;return{get value(){return a(c.rawConfiguration.getValue(r))},get override(){return h?a(c.rawConfiguration.getOverrideValue(r,h)):void 0},get merged(){return a(h?c.rawConfiguration.override(h).getValue(r):c.rawConfiguration.getValue(r))},get overrides(){const S=[];for(const{contents:I,identifiers:R,keys:L}of c.rawConfiguration.overrides){const O=new u(I,L,[],void 0,c.f).getValue(r);O!==void 0&&S.push({identifiers:R,value:O})}return S.length?a(S):void 0}}}getOverrideValue(r,h){const c=this.j(h);return c?r?(0,D.$hj)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const h=[];for(const c of this.overrides)c.identifiers.includes(r)&&h.push(...c.keys);return t.$Lb(h)}getAllOverrideIdentifiers(){const r=[];for(const h of this.overrides)r.push(...h.identifiers);return t.$Lb(r)}override(r){let h=this.a.get(r);return h||(h=this.h(r),this.a.set(r,h)),h}merge(...r){const h=A.$eo(this.contents),c=A.$eo(this.overrides),S=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const R of r)if(I.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(h,R.contents);for(const L of R.overrides){const[O]=c.filter(P=>t.$tb(P.identifiers,L.identifiers));O?(this.i(O.contents,L.contents),O.keys.push(...L.keys),O.keys=t.$Lb(O.keys)):c.push(A.$eo(L))}for(const L of R.keys)S.indexOf(L)===-1&&S.push(L)}return new u(h,S,c,I.every(R=>R instanceof u)?void 0:I,this.f)}h(r){const h=this.j(r);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const c={};for(const S of t.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[S];const R=h[S];R&&(typeof I=="object"&&typeof R=="object"?(I=A.$eo(I),this.i(I,R)):I=R),c[S]=I}return new u(c,this.keys,this.overrides,void 0,this.f)}i(r,h){for(const c of Object.keys(h)){if(c in r&&y.$gg(r[c])&&y.$gg(h[c])){this.i(r[c],h[c]);continue}r[c]=A.$eo(h[c])}}j(r){let h=null,c=null;const S=I=>{I&&(c?this.i(c,I):c=A.$eo(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===r?h=I.contents:I.identifiers.includes(r)&&S(I.contents);return S(h),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,h){this.k(r,h,!0)}setValue(r,h){this.k(r,h,!1)}removeValue(r){const h=this.keys.indexOf(r);h!==-1&&(this.keys.splice(h,1),(0,D.$gj)(this.contents,r),w.$Go.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>t.$tb(c.identifiers,(0,w.$Ho)(r))),1))}k(r,h,c){if((0,D.$fj)(this.contents,r,h,S=>this.f.error(S)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),w.$Go.test(r)){const S=(0,w.$Ho)(r),I={identifiers:S,keys:Object.keys(this.contents[r]),contents:(0,D.$ej)(this.contents[r],L=>this.f.error(L))},R=this.overrides.findIndex(L=>t.$tb(L.identifiers,S));R!==-1?this.overrides[R]=I:this.overrides.push(I)}}}e.$Oo=u;class d{constructor(r,h){this.f=r,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||u.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,h){if(!y.$ng(r)){const c=this.h(r);this.parseRaw(c,h)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,h){this.a=r;const{contents:c,keys:S,overrides:I,restricted:R,hasExcludedProperties:L}=this.i(r,h);this.b=new u(c,S,I,L?[r]:void 0,this.g),this.c=R||[]}h(r){let h={},c=null,S=[];const I=[],R=[];function L(P){Array.isArray(S)?S.push(P):c!==null&&(S[c]=P)}const O={onObjectBegin:()=>{const P={};L(P),I.push(S),S=P,c=null},onObjectProperty:P=>{c=P},onObjectEnd:()=>{S=I.pop()},onArrayBegin:()=>{const P=[];L(P),I.push(S),S=P,c=null},onArrayEnd:()=>{S=I.pop()},onLiteralValue:L,onError:(P,q,K)=>{R.push({error:P,offset:q,length:K})}};if(r)try{E.$6n(r,O),h=S[0]||{}}catch(P){this.g.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return h}i(r,h){const c=$.$ro.as(w.$wo.Configuration).getConfigurationProperties(),S=this.j(r,c,!0,h);r=S.raw;const I=(0,D.$ej)(r,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),R=Object.keys(r),L=this.l(r,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:I,keys:R,overrides:L,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(r,h,c,S){let I=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:I};const R={},L=[];for(const O in r)if(w.$Go.test(O)&&c){const P=this.j(r[O],h,!1,S);R[O]=P.raw,I=I||P.hasExcludedProperties,L.push(...P.restricted)}else{const P=h[O],q=P?typeof P.scope<"u"?P.scope:w.ConfigurationScope.WINDOW:void 0;P?.restricted&&L.push(O),!S.exclude?.includes(O)&&(S.include?.includes(O)||(q===void 0||S.scopes===void 0||S.scopes.includes(q))&&!(S.skipRestricted&&P?.restricted))?R[O]=r[O]:I=!0}return{raw:R,restricted:L,hasExcludedProperties:I}}l(r,h){const c=[];for(const S of Object.keys(r))if(w.$Go.test(S)){const I={};for(const R in r[S])I[R]=r[S][R];c.push({identifiers:(0,w.$Ho)(S),keys:Object.keys(I),contents:(0,D.$ej)(I,h)})}return c}}e.$Po=d;class f extends k.$Uc{constructor(r,h,c,S,I){super(),this.c=r,this.f=h,this.g=S,this.h=I,this.b=this.B(new s.$le),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),I),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(s.Event.any(s.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),s.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(m.FileOperation.CREATE)||R.isOperation(m.FileOperation.COPY)||R.isOperation(m.FileOperation.DELETE)||R.isOperation(m.FileOperation.WRITE))&&c.isEqual(R.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return u.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qo=f;class v{constructor(r,h,c,S,I,R,L,O,P,q,K,J,_){this.a=r,this.b=h,this.c=c,this.overrideIdentifiers=S,this.d=I,this.f=R,this.g=L,this.h=O,this.i=P,this.j=q,this.k=K,this.l=J,this.m=_}get value(){return a(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(r,h,c,S,I,R,L,O,P,q){this.j=r,this.l=h,this.m=c,this.n=S,this.p=I,this.q=R,this.r=L,this.s=O,this.t=P,this.u=q,this.h=null,this.i=new C.$Ac,this.v=null}getValue(r,h,c){return this.w(r,h,c).getValue(r)}updateValue(r,h,c={}){let S;c.resource?(S=this.t.get(c.resource),S||(S=u.createEmptyModel(this.u),this.t.set(c.resource,S))):S=this.s,h===void 0?S.removeValue(r):S.setValue(r,h),c.resource||(this.h=null)}inspect(r,h,c){const S=this.w(r,h,c),I=this.A(h.resource,c),R=h.resource?this.t.get(h.resource)||this.s:this.s,L=new Set;for(const O of S.overrides)for(const P of O.identifiers)S.getOverrideValue(r,P)!==void 0&&L.add(P);return new v(r,h,S.getValue(r),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.q:void 0,I||void 0,R)}keys(r){const h=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,h){this.r.set(r,h),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,h){const c=[];if(!h){const{added:S,updated:I,removed:R}=p(this.j,r);h=[...S,...I,...R]}for(const S of h)for(const I of(0,w.$Ho)(S)){const R=this.j.getKeysForOverrideIdentifier(I),L=r.getKeysForOverrideIdentifier(I),O=[...L.filter(P=>R.indexOf(P)===-1),...R.filter(P=>L.indexOf(P)===-1),...R.filter(P=>!A.$io(this.j.override(I).getValue(P),r.override(I).getValue(P)))];c.push([I,O])}return this.updateDefaultConfiguration(r),{keys:h,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:h,updated:c,removed:S}=p(this.l,r),I=[...h,...c,...S];return I.length&&this.updatePolicyConfiguration(r),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:h,updated:c,removed:S,overrides:I}=p(this.applicationConfiguration,r),R=[...h,...c,...S];return R.length&&this.updateApplicationConfiguration(r),{keys:R,overrides:I}}compareAndUpdateLocalUserConfiguration(r){const{added:h,updated:c,removed:S,overrides:I}=p(this.localUserConfiguration,r),R=[...h,...c,...S];return R.length&&this.updateLocalUserConfiguration(r),{keys:R,overrides:I}}compareAndUpdateRemoteUserConfiguration(r){const{added:h,updated:c,removed:S,overrides:I}=p(this.remoteUserConfiguration,r),R=[...h,...c,...S];return R.length&&this.updateRemoteUserConfiguration(r),{keys:R,overrides:I}}compareAndUpdateWorkspaceConfiguration(r){const{added:h,updated:c,removed:S,overrides:I}=p(this.workspaceConfiguration,r),R=[...h,...c,...S];return R.length&&this.updateWorkspaceConfiguration(r),{keys:R,overrides:I}}compareAndUpdateFolderConfiguration(r,h){const c=this.folderConfigurations.get(r),{added:S,updated:I,removed:R,overrides:L}=p(c,h),O=[...S,...I,...R];return(O.length||!c)&&this.updateFolderConfiguration(r,h),{keys:O,overrides:L}}compareAndDeleteFolderConfiguration(r){const h=this.folderConfigurations.get(r);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:S,removed:I,overrides:R}=p(h,void 0);return{keys:[...c,...S,...I],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,h,c){let S=this.x(h,c);return h.overrideIdentifier&&(S=S.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(S=S.merge(this.l)),S}x({resource:r},h){let c=this.y();if(h&&r){const S=h.getFolder(r);S&&(c=this.z(S.uri)||c);const I=this.t.get(r);I&&(c=c.merge(I))}return c}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let h=this.i.get(r);if(!h){const c=this.y(),S=this.r.get(r);S?(h=c.merge(S),this.i.set(r,h)):h=c}return h}A(r,h){if(h&&r){const c=h.getFolder(r);if(c)return this.r.get(c.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,h)=>{const{contents:c,overrides:S,keys:I}=this.r.get(h);return r.push([h,{contents:c,overrides:S,keys:I}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(h=>r.add(h)),this.userConfiguration.keys.forEach(h=>r.add(h)),this.q.keys.forEach(h=>r.add(h)),this.r.forEach(h=>h.keys.forEach(c=>r.add(c))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>r.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}D(r){const h=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(c=>h.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>h.add(c)),this.q.getKeysForOverrideIdentifier(r).forEach(c=>h.add(c)),this.r.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(S=>h.add(S))),[...h.values()]}static parse(r,h){const c=this.E(r.defaults,h),S=this.E(r.policy,h),I=this.E(r.application,h),R=this.E(r.user,h),L=this.E(r.workspace,h),O=r.folders.reduce((P,q)=>(P.set(o.URI.revive(q[0]),this.E(q[1],h)),P),new C.$Ac);return new g(c,S,I,R,u.createEmptyModel(h),L,O,u.createEmptyModel(h),new C.$Ac,h)}static E(r,h){return new u(r.contents,r.keys,r.overrides,void 0,h)}}e.$Ro=g;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,h=new Map;for(const S of l)S.keys.forEach(I=>r.add(I)),S.overrides.forEach(([I,R])=>{const L=(0,C.$xc)(h,I,new Set);R.forEach(O=>L.add(O))});const c=[];return h.forEach((S,I)=>c.push([I,[...S.values()]])),{keys:[...r.values()],overrides:c}}class i{constructor(r,h,c,S,I){this.change=r,this.f=h,this.g=c,this.h=S,this.i=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of r.keys)this.affectedKeys.add(R);for(const[,R]of r.overrides)for(const L of R)this.affectedKeys.add(L);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=g.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,h){const c=this.a+r,S=this.d.indexOf(c);if(S<0)return!1;const I=S+c.length;if(I>=this.d.length)return!1;const R=this.d.charCodeAt(I);if(R!==this.b&&R!==this.c)return!1;if(h){const L=this.previousConfiguration?this.previousConfiguration.getValue(r,h,this.f?.workspace):void 0,O=this.g.getValue(r,h,this.h);return!A.$io(L,O)}return!0}}e.$To=i;function p(l,r){const{added:h,removed:c,updated:S}=n(r?.rawConfiguration,l?.rawConfiguration),I=[],R=l?.getAllOverrideIdentifiers()||[],L=r?.getAllOverrideIdentifiers()||[];if(r){const O=L.filter(P=>!R.includes(P));for(const P of O)I.push([P,r.getKeysForOverrideIdentifier(P)])}if(l){const O=R.filter(P=>!L.includes(P));for(const P of O)I.push([P,l.getKeysForOverrideIdentifier(P)])}if(r&&l){for(const O of R)if(L.includes(O)){const P=n({contents:l.getOverrideValue(void 0,O)||{},keys:l.getKeysForOverrideIdentifier(O)},{contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)});I.push([O,[...P.added,...P.removed,...P.updated]])}}return{added:h,removed:c,updated:S,overrides:I}}function n(l,r){const h=l?r?l.keys.filter(I=>r.keys.indexOf(I)===-1):[...l.keys]:[],c=r?l?r.keys.filter(I=>l.keys.indexOf(I)===-1):[...r.keys]:[],S=[];if(l&&r){for(const I of r.keys)if(l.keys.indexOf(I)!==-1){const R=(0,D.$hj)(r.contents,I),L=(0,D.$hj)(l.contents,I);A.$io(R,L)||S.push(I)}}return{added:h,removed:c,updated:S}}}),define(Re[217],Ae([1,0,17,6,2,20,10,127,45,11,72,37]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;class m extends E.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new s.$le),this.onDidChangeConfiguration=this.a.event,this.b=A.$Oo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(w.$ro.as(y.$wo.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:f})=>this.f(Array.from(d),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,f){this.j(d,w.$ro.as(y.$wo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=A.$Oo.createEmptyModel(this.c);const d=w.$ro.as(y.$wo.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,f){const v=this.g();for(const g of d){const b=v[g],i=f[g];b!==void 0?this.b.setValue(g,b):i?this.b.setValue(g,i.default):this.b.removeValue(g)}}}e.$Uo=m;class ${constructor(){this.onDidChangeConfiguration=s.Event.None,this.configurationModel=A.$Oo.createEmptyModel(new o.$nk)}async initialize(){return this.configurationModel}}e.$Vo=$;let a=class extends E.$Uc{get configurationModel(){return this.b}constructor(d,f,v){super(),this.c=d,this.f=f,this.g=v,this.a=this.B(new s.$le),this.onDidChangeConfiguration=this.a.event,this.b=A.$Oo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const f={},v=[],g=w.$ro.as(y.$wo.Configuration).getConfigurationProperties();for(const b of d){const i=g[b];if(!i){v.push(b);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}v.push(b),f[i.policy.name]={type:i.type}}}return(0,C.$rg)(f)||await this.f.updatePolicyDefinitions(f),v}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const f=w.$ro.as(y.$wo.Configuration).getPolicyConfigurations(),v=(0,t.$Gb)(d.map(g=>f.get(g)));this.m(v,!0)}m(d,f){this.g.trace("PolicyConfiguration#update",d);const v=w.$ro.as(y.$wo.Configuration).getConfigurationProperties(),g=[],b=this.b.isEmpty();for(const i of d){const p=v[i]?.policy?.name;if(p){const n=this.f.getPolicyValue(p);(b?n!==void 0:!(0,k.$io)(this.b.getValue(i),n))&&g.push([i,n])}else this.b.getValue(i)!==void 0&&g.push([i,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const i=this.b;this.b=A.$Oo.createEmptyModel(this.g);for(const p of i.keys)this.b.setValue(p,i.getValue(p));for(const[p,n]of g)n===void 0?this.b.removeValue(p):this.b.setValue(p,n);f&&this.a.fire(this.b)}}};e.$Wo=a,e.$Wo=a=Be([je(1,D.$to),je(2,o.$ak)],a)}),define(Re[128],Ae([1,0,17,13,14,6,42,159,2,25,20,3,19,27,127,45,217,15,72]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0;class g extends y.$Uc{constructor(p,n,l,r){super(),this.m=p,this.n=r,this.h=this.B(new k.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Uo(r)),this.c=l instanceof v.$vo?new d.$Vo:this.B(new d.$Wo(this.b,l,r)),this.f=this.B(new a.$Qo(this.m,{},m.$0g,n,r)),this.a=new a.$Ro(this.b.configurationModel,this.c.configurationModel,a.$Oo.createEmptyModel(r),a.$Oo.createEmptyModel(r),a.$Oo.createEmptyModel(r),a.$Oo.createEmptyModel(r),new o.$Ac,a.$Oo.createEmptyModel(r),new o.$Ac,r),this.j=new b(p,n,this),this.g=this.B(new s.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:c})=>this.s(h,c))),this.B(this.c.onDidChangeConfiguration(h=>this.t(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,n,l]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Ro(p,n,a.$Oo.createEmptyModel(this.n),l,a.$Oo.createEmptyModel(this.n),a.$Oo.createEmptyModel(this.n),new o.$Ac,a.$Oo.createEmptyModel(this.n),new o.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(p,n){const l=typeof p=="string"?p:void 0,r=(0,$.$aj)(p)?p:(0,$.$aj)(n)?n:{};return this.a.getValue(l,r,void 0)}async updateValue(p,n,l,r,h){const c=(0,$.$bj)(l)?l:(0,$.$aj)(l)?{resource:l.resource,overrideIdentifiers:l.overrideIdentifier?[l.overrideIdentifier]:void 0}:void 0,S=c?r:l;if(S!==void 0&&S!==$.ConfigurationTarget.USER_LOCAL&&S!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${p} to target ${S}.`);c?.overrideIdentifiers&&(c.overrideIdentifiers=(0,t.$Lb)(c.overrideIdentifiers),c.overrideIdentifiers=c.overrideIdentifiers.length?c.overrideIdentifiers:void 0);const I=this.inspect(p,{resource:c?.resource,overrideIdentifier:c?.overrideIdentifiers?c.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${p} because it is configured in system policy.`);if((0,D.$io)(n,I.defaultValue)&&(n=void 0),c?.overrideIdentifiers?.length&&c.overrideIdentifiers.length>1){const L=c.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(P=>(0,t.$tb)([...P.identifiers].sort(),L));O&&(c.overrideIdentifiers=O.identifiers)}const R=c?.overrideIdentifiers?.length?[(0,u.$Io)(c.overrideIdentifiers),p]:[p];await this.j.write(R,n),await this.reloadConfiguration()}inspect(p,n={}){return this.a.inspect(p,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.r(p)}r(p){const n=this.a.toData(),l=this.a.compareAndUpdateLocalUserConfiguration(p);this.u(l,n,$.ConfigurationTarget.USER)}s(p,n){const l=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(p,n);this.u(r,l,$.ConfigurationTarget.DEFAULT)}t(p){const n=this.a.toData(),l=this.a.compareAndUpdatePolicyConfiguration(p);this.u(l,n,$.ConfigurationTarget.DEFAULT)}u(p,n,l){const r=new a.$To(p,{data:n},this.a,void 0,this.n);r.source=l,this.h.fire(r)}}e.$Xo=g;class b{constructor(p,n,l){this.b=p,this.c=n,this.d=l,this.a=new s.$Mh}write(p,n){return this.a.queue(()=>this.e(p,n))}async e(p,n){let l;try{l=(await this.c.readFile(this.b)).value.toString()}catch(c){if(c.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)l="{}";else throw c}const r=[];if((0,C.$Yn)(l,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const h=this.f(l,p,n);l=(0,A.$do)(l,h),await this.c.writeFile(this.b,E.$Ne.fromString(l))}f(p,n,l){const{tabSize:r,insertSpaces:h,eol:c}=this.h;if(!n.length){const S=JSON.stringify(l,null,h?" ".repeat(r):"	");return[{content:S,length:S.length,offset:0}]}return(0,A.$ao)(p,n,l,{tabSize:r,insertSpaces:h,eol:c})}get h(){if(!this.g){let p=w.OS===w.OperatingSystem.Linux||w.OS===w.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(p=n),this.g={eol:p,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Re[89],Ae([1,0,9,5]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=o,e.$Rl=(0,s.$Fi)("remoteAuthorityResolverService");var E;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class k{constructor(w){this.id=w,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=k;class C{constructor(w,m){this.host=w,this.port=m,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=C;var A;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class y extends t.$ab{static isNotAvailable(w){return w instanceof y&&w._code===A.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof y&&w._code===A.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof y&&w._code===A.NoResolverFound}static isInvalidAuthority(w){return w instanceof y&&w._code===A.InvalidAuthority}static isHandled(w){return w instanceof y&&w.isHandled}constructor(w,m=A.Unknown,$){super(w),this._message=w,this._code=m,this._detail=$,this.isHandled=m===A.NotAvailable&&$===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Ul=y;function o(D){const w=D.indexOf("+");return w===-1?D:D.substring(0,w)}}),define(Re[218],Ae([1,0,13,14,18,9,6,2,12,43,47,22,60,89]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=I,e.$2l=R,e.$3l=O,o=Ue(o);const a=30*1e3;var u;(function(x){x[x.Management=1]="Management",x[x.ExtensionHost=2]="ExtensionHost",x[x.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function d(x){switch(x){case u.Management:return"Management";case u.ExtensionHost:return"ExtensionHost";case u.Tunnel:return"Tunnel"}}function f(x){const G=new E.$we;return setTimeout(()=>G.cancel(),x),G.token}function v(x,G){if(x.isCancellationRequested||G.isCancellationRequested)return E.CancellationToken.Cancelled;const T=new E.$we;return x.onCancellationRequested(()=>T.cancel()),G.onCancellationRequested(()=>T.cancel()),T.token}class g{get didTimeout(){return this.c==="timedout"}constructor(G){this.c="pending",this.d=new A.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,t.$yh)(),G.isCancellationRequested?this.h():this.d.add(G.onCancellationRequested(()=>this.h()))}registerDisposable(G){this.c==="pending"?this.d.add(G):G.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(G))}reject(G){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(G))}}function b(x,G){const T=new g(G);return T.registerDisposable(x.onControlMessage(X=>{const he=JSON.parse(X.toString()),B=V(he);B?T.reject(B):T.resolve(he)})),T.promise}function i(x,G,T,X,he,B,U,H){const F=new g(H),W=D.$fe.create(!1);return x.info(`Creating a socket (${U})...`),o.mark(`code/willCreateSocket/${B}`),G.connect(T,X,he,U).then(Y=>{F.didTimeout?(o.mark(`code/didCreateSocketError/${B}`),x.info(`Creating a socket (${U}) finished after ${W.elapsed()} ms, but this is too late and has timed out already.`),Y?.dispose()):(o.mark(`code/didCreateSocketOK/${B}`),x.info(`Creating a socket (${U}) was successful after ${W.elapsed()} ms.`),F.resolve(Y))},Y=>{o.mark(`code/didCreateSocketError/${B}`),x.info(`Creating a socket (${U}) returned an error after ${W.elapsed()} ms.`),x.error(Y),F.reject(Y)}),F.promise}function p(x,G){const T=new g(G);return x.then(X=>{T.didTimeout||T.resolve(X)},X=>{T.didTimeout||T.reject(X)}),T.promise}async function n(x,G,T,X){const he=oe(x,G);x.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let B;try{B=await i(x.logService,x.remoteSocketFactoryService,x.connectTo,y.$Sg.getServerRootPath(),`reconnectionToken=${x.reconnectionToken}&reconnection=${x.reconnectionProtocol?"true":"false"}`,d(G),`renderer-${d(G)}-${x.reconnectionToken}`,X)}catch(Y){throw x.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),x.logService.error(Y),Y}x.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let U,H;x.reconnectionProtocol?(x.reconnectionProtocol.beginAcceptReconnection(B,null),U=x.reconnectionProtocol,H=!1):(U=new m.$ti({socket:B}),H=!0),x.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const F=await p(x.signService.createNewMessage((0,w.$2g)()),X),W={type:"auth",auth:x.connectionToken||"00000000000000000000",data:F.data};U.sendControl(s.$Ne.fromString(JSON.stringify(W)));try{const Y=await b(U,v(X,f(1e4)));if(Y.type!=="sign"||typeof Y.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(x.logService.trace(`${he} 4/6. received SignRequest control message.`),!await p(x.signService.validate(F,Y.signedData),X)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const Ee=await p(x.signService.sign(Y.data),X),Le={type:"connectionType",commit:x.commit,signedData:Ee,desiredConnectionType:G};return T&&(Le.args=T),x.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),U.sendControl(s.$Ne.fromString(JSON.stringify(Le))),{protocol:U,ownsProtocol:H}}catch(Y){throw Y&&Y.code==="ETIMEDOUT"&&(x.logService.error(`${he} the handshake timed out. Error:`),x.logService.error(Y)),Y&&Y.code==="VSCODE_CONNECTION_ERROR"&&(x.logService.error(`${he} received error control message when negotiating connection. Error:`),x.logService.error(Y)),H&&M(U),Y}}async function l(x,G,T,X){const he=Date.now(),B=oe(x,G),{protocol:U,ownsProtocol:H}=await n(x,G,T,X),F=new g(X);return F.registerDisposable(U.onControlMessage(W=>{const Y=JSON.parse(W.toString()),ae=V(Y);ae?(x.logService.error(`${B} received error control message when negotiating connection. Error:`),x.logService.error(ae),H&&M(U),F.reject(ae)):(x.reconnectionProtocol?.endAcceptReconnection(),x.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ie(he)}!`),F.resolve({protocol:U,firstMessage:Y}))})),F.promise}async function r(x,G){const{protocol:T}=await l(x,u.Management,void 0,G);return{protocol:T}}async function h(x,G,T){const{protocol:X,firstMessage:he}=await l(x,u.ExtensionHost,G,T),B=he&&he.debugPort;return{protocol:X,debugPort:B}}async function c(x,G,T){const X=Date.now(),he=oe(x,u.Tunnel),{protocol:B}=await n(x,u.Tunnel,G,T);return x.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${ie(X)}!`),B}async function S(x,G,T){const{connectTo:X,connectionToken:he}=await x.addressProvider.getAddress();return{commit:x.commit,quality:x.quality,connectTo:X,connectionToken:he,reconnectionToken:G,reconnectionProtocol:T,remoteSocketFactoryService:x.remoteSocketFactoryService,signService:x.signService,logService:x.logService}}async function I(x,G,T){return L(x,async X=>{const{protocol:he}=await r(X,E.CancellationToken.None);return new z(x,G,T,X.reconnectionToken,he)})}async function R(x,G){return L(x,async T=>{const{protocol:X,debugPort:he}=await h(T,G,E.CancellationToken.None);return new Q(x,G,T.reconnectionToken,X,he)})}async function L(x,G){for(let X=1;;X++)try{const he=(0,w.$2g)(),B=await S(x,he,null);return await G(B)}catch(he){if(X<5)x.logService.error(`[remote-connection][attempt ${X}] An error occurred in initial connection! Will retry... Error:`),x.logService.error(he);else throw x.logService.error(`[remote-connection][attempt ${X}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),x.logService.error(he),le.triggerPermanentFailure(0,0,$.$Ul.isHandled(he)),he}}async function O(x,G,T){const X=await S(x,(0,w.$2g)(),null);return await c(X,{host:G,port:T},E.CancellationToken.None)}function P(x){return(0,t.$sh)(G=>new Promise((T,X)=>{const he=setTimeout(T,x*1e3);G.onCancellationRequested(()=>{clearTimeout(he),T()})}))}var q;(function(x){x[x.ConnectionLost=0]="ConnectionLost",x[x.ReconnectionWait=1]="ReconnectionWait",x[x.ReconnectionRunning=2]="ReconnectionRunning",x[x.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",x[x.ConnectionGain=4]="ConnectionGain"})(q||(e.PersistentConnectionEventType=q={}));class K{constructor(G,T){this.reconnectionToken=G,this.millisSinceLastIncomingData=T,this.type=q.ConnectionLost}}e.$4l=K;class J{constructor(G,T,X,he){this.reconnectionToken=G,this.millisSinceLastIncomingData=T,this.durationSeconds=X,this.c=he,this.type=q.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=J;class _{constructor(G,T,X){this.reconnectionToken=G,this.millisSinceLastIncomingData=T,this.attempt=X,this.type=q.ReconnectionRunning}}e.$6l=_;class de{constructor(G,T,X){this.reconnectionToken=G,this.millisSinceLastIncomingData=T,this.attempt=X,this.type=q.ConnectionGain}}e.$7l=de;class ge{constructor(G,T,X,he){this.reconnectionToken=G,this.millisSinceLastIncomingData=T,this.attempt=X,this.handled=he,this.type=q.ReconnectionPermanentFailure}}e.$8l=ge;class le extends A.$Uc{static triggerPermanentFailure(G,T,X){this._permanentFailure=!0,this.f=G,this.g=T,this.h=X,this.j.forEach(he=>he.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(G=>G.y())}static debugPauseSocketWriting(){this.j.forEach(G=>G.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||le._permanentFailure}constructor(G,T,X,he,B){super(),this.t=G,this.u=T,this.reconnectionToken=X,this.protocol=he,this.w=B,this.m=this.B(new C.$le),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(he.onSocketClose(U=>{const H=me(this.t,this.reconnectionToken,!0);U?U.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${H} received socket close event (hadError: ${U.hadError}).`),U.error&&this.u.logService.error(U.error)):(this.u.logService.info(`${H} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this.u.logService.error(U.event)):this.u.logService.info(`${H} received socket close event.`),this.y()})),this.B(he.onSocketTimeout(U=>{const H=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} received socket timeout event (unacknowledgedMsgCount: ${U.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${U.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${U.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,A.$Sc)(()=>{const U=le.j.indexOf(this);U>=0&&le.j.splice(U,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const G=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const he=X<T.length?T[X]:T[T.length-1];try{if(he>0){const U=P(he);this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,U)),this.u.logService.info(`${G} waiting for ${he} seconds before reconnecting...`);try{await U}catch{}}if(this.n){this.u.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this.u.logService.info(`${G} resolving connection...`);const B=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${G} connecting to ${B.connectTo}...`),await this.G(B,f(a)),this.u.logService.info(`${G} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this.u.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if($.$Ul.isTemporarilyNotAvailable(B)){this.u.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,k.$3)(B)){this.u.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof $.$Ul){this.u.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,$.$Ul.isHandled(B));break}this.u.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!this.n&&!this.s)}C(G,T,X){this.w?le.triggerPermanentFailure(G,T,X):this.D(G,T,X)}D(G,T,X){this.m.fire(new ge(this.reconnectionToken,G,T,X)),M(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=le;class z extends le{constructor(G,T,X,he,B){super(u.Management,G,he,B,!0),this.client=this.B(new m.$ri(B,{remoteAuthority:T,clientId:X},G.ipcLogger))}async G(G,T){await r(G,T)}}e.$0l=z;class Q extends le{constructor(G,T,X,he,B){super(u.ExtensionHost,G,X,he,!1),this.H=T,this.debugPort=B}async G(G,T){await h(G,this.H,T)}}e.$$l=Q;function M(x){try{x.acceptDisconnect();const G=x.getSocket();x.dispose(),G.dispose()}catch(G){(0,k.$Y)(G)}}function V(x){if(x&&x.type==="error"){const G=new Error(`Connection error: ${x.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function ne(x,G){for(;x.length<G;)x+=" ";return x}function re(x,G){return`[remote-connection][${ne(d(x),13)}][${G.substr(0,5)}\u2026]`}function me(x,G,T){return`${re(x,G)}[${T?"reconnect":"initial"}]`}function oe(x,G){return`${me(G,x.reconnectionToken,!!x.reconnectionProtocol)}[${x.connectTo}]`}function ie(x){return`${Date.now()-x} ms`}}),define(Re[219],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NR=e.$MR=void 0,e.$MR=(0,t.$Fi)("IRemoteExtensionsScannerService"),e.$NR="remoteExtensionsScanner"}),define(Re[90],Ae([1,0,12]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=s,e.$in=E,e.$jn=k,e.$kn=C;function s(y){return y.scheme===t.Schemas.vscodeRemote?y.authority:void 0}function E(y){if(!y)return;const o=y.indexOf("+");return o<0?y:y.substr(0,o)}function k(y){const{host:o,port:D}=A(y);if(typeof D>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:D}}function C(y,o){let{host:D,port:w}=A(y);return typeof w>"u"&&(w=o),{host:D,port:w}}function A(y){const o=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const D=y.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const w=y.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:y,port:void 0}}}),define(Re[21],Ae([1,0,16,5,90]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$tn=e.$sn=e.$rn=e.TargetPlatform=e.ExtensionType=e.$qn=e.$on=e.$nn=e.$mn=e.$ln=void 0,e.$pn=k,e.$un=w,e.$vn=m,e.$wn=$,e.$xn=a,e.$yn=u,e.$zn=d,t=Ue(t),e.$ln="extensions.user.cache",e.$mn="extensions.builtin.cache",e.$nn="undefined_publisher",e.$on=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$qn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(C||(e.ExtensionType=C={}));var A;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class y{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,g){if(typeof v>"u"||v===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof v=="string"||typeof g=="string"){const b=typeof v=="string"?v:v.value,i=typeof g=="string"?g:g.value;return t.$Ff(b,i)}return v._lower===g._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.$rn=y;class o{get size(){return this.c.size}constructor(v){if(this.c=new Set,v)for(const g of v)this.add(g)}add(v){this.c.add(y.toKey(v))}delete(v){return this.c.delete(y.toKey(v))}has(v){return this.c.has(y.toKey(v))}}e.$sn=o;class D{constructor(){this.c=new Map}clear(){this.c.clear()}delete(v){this.c.delete(y.toKey(v))}get(v){return this.c.get(y.toKey(v))}has(v){return this.c.has(y.toKey(v))}set(v,g){this.c.set(y.toKey(v),g)}values(){return this.c.values()}forEach(v){this.c.forEach(v)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$tn=D;function w(f){return m(f)}function m(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function $(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function a(f,v){if(v){const g=`onResolveRemoteAuthority:${(0,E.$in)(v)}`;return!!f.activationEvents?.includes(g)}return!1}function u(f){return f.map(v=>{const[g,b]=v.split("@");return{proposalName:g,version:b?parseInt(b):void 0}})}function d(f){return f.map(v=>v.split("@")[0])}e.$An=(0,s.$Fi)("IBuiltinExtensionsScannerService")}),define(Re[30],Ae([1,0,3,7,21,5]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.ExtensionManagementErrorCode=e.$mp=e.ExtensionGalleryErrorCode=e.$lp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=void 0,e.$fp=A,e.$gp=y,e.$hp=o,e.$ip=D,e.$jp=w,e.$kp=m,e.$$o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_o=new RegExp(e.$$o),e.$ap="__web_extension",e.$bp="skipWalkthrough",e.$cp="extensionInstallSource",e.$dp="dependecyOrPackExtensionInstall",e.$ep="clientTargetPlatform";var C;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(C||(e.ExtensionInstallSource=C={}));function A(i){switch(i){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function y(i){switch(i){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function o(i,p){switch(i){case t.Platform.Windows:return p==="x64"?E.TargetPlatform.WIN32_X64:p==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Linux:return p==="x64"?E.TargetPlatform.LINUX_X64:p==="arm64"?E.TargetPlatform.LINUX_ARM64:p==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return p==="x64"?E.TargetPlatform.ALPINE_X64:p==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Mac:return p==="x64"?E.TargetPlatform.DARWIN_X64:p==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Web:return E.TargetPlatform.WEB}}function D(i,p){return p===E.TargetPlatform.WEB&&!i.includes(E.TargetPlatform.WEB)}function w(i,p,n){return D(p,n)?!1:i===E.TargetPlatform.UNDEFINED||i===E.TargetPlatform.UNIVERSAL?!0:i===E.TargetPlatform.UNKNOWN?!1:i===n}function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var $;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var a;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var d;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$lp=(0,k.$Fi)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class v extends Error{constructor(p,n){super(p),this.code=n,this.name=n}}e.$mp=v;var g;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class b extends Error{constructor(p,n){super(p),this.code=n,this.name=n}}e.$np=b,e.$op=(0,k.$Fi)("extensionManagementService"),e.$pp="extensionsIdentifiers/disabled",e.$qp="extensionsIdentifiers/enabled",e.$rp=(0,k.$Fi)("IGlobalExtensionEnablementService"),e.$sp=(0,k.$Fi)("IExtensionTipsService"),e.$tp=(0,s.localize2)(11501,"Extensions"),e.$up=(0,s.localize2)(11502,"Preferences")}),define(Re[220],Ae([1,0,6,2,20,4,58,30]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0;function y(d,f){return d?k.URI.revive(f?f.transformIncoming(d):d):void 0}function o(d,f){return f?f.transformOutgoingURI(d):d}function D(d,f){f=f||C.$Nn;const v=d.manifest;return{...(0,C.$Qn)({...d,manifest:void 0},f),manifest:v}}function w(d,f){return d?.profileLocation?(0,C.$Qn)(d,f??C.$Nn):d}function m(d,f){return f?(0,E.$go)(d,v=>v instanceof k.URI?f.transformOutgoingURI(v):void 0):d}class ${constructor(f,v){this.a=f,this.b=v,this.onInstallExtension=t.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=t.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=t.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=t.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=t.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,v){const g=this.b(f);switch(v){case"onInstallExtension":return t.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,g):b.profileLocation}));case"onDidInstallExtensions":return t.Event.map(this.onDidInstallExtensions,b=>b.map(i=>({...i,local:i.local?m(i.local,g):i.local,profileLocation:i.profileLocation?o(i.profileLocation,g):i.profileLocation})));case"onUninstallExtension":return t.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,g):b.profileLocation}));case"onDidUninstallExtension":return t.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,g):b.profileLocation}));case"onDidUpdateExtensionMetadata":return t.Event.map(this.onDidUpdateExtensionMetadata,b=>({local:m(b.local,g),profileLocation:o(b.profileLocation,g)}))}throw new Error("Invalid listen")}async call(f,v,g){const b=this.b(f);switch(v){case"zip":{const i=D(g[0],b),p=await this.a.zip(i);return o(p,b)}case"install":return this.a.install(y(g[0],b),w(g[1],b));case"installFromLocation":return this.a.installFromLocation(y(g[0],b),y(g[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(g[0],y(g[1],b),y(g[2],b));case"getManifest":return this.a.getManifest(y(g[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],w(g[1],b));case"installGalleryExtensions":{const i=g[0];return this.a.installGalleryExtensions(i.map(({extension:p,options:n})=>({extension:p,options:w(n,b)??{}})))}case"uninstall":return this.a.uninstall(D(g[0],b),w(g[1],b));case"uninstallExtensions":{const i=g[0];return this.a.uninstallExtensions(i.map(({extension:p,options:n})=>({extension:D(p,b),options:w(n,b)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(D(g[0],b));case"getInstalled":return(await this.a.getInstalled(g[0],y(g[1],b),g[2])).map(p=>m(p,b));case"toggleAppliationScope":{const i=await this.a.toggleAppliationScope(D(g[0],b),y(g[1],b));return m(i,b)}case"copyExtensions":return this.a.copyExtensions(y(g[0],b),y(g[1],b));case"updateMetadata":{const i=await this.a.updateMetadata(D(g[0],b),g[1],y(g[2],b));return m(i,b)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(g[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1],g[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$xq=$;class a extends s.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new t.$le),this.f=this.B(new t.$le),this.g=this.B(new t.$le),this.h=this.B(new t.$le),this.j=this.B(new t.$le),this.B(this.m.listen("onInstallExtension")(v=>this.n(this.c,{...v,source:this.r(v.source)?k.URI.revive(v.source):v.source,profileLocation:k.URI.revive(v.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(v=>this.n(this.f,v.map(g=>({...g,local:g.local?D(g.local,null):g.local,source:this.r(g.source)?k.URI.revive(g.source):g.source,profileLocation:k.URI.revive(g.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(v=>this.n(this.g,{...v,profileLocation:k.URI.revive(v.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(v=>this.n(this.h,{...v,profileLocation:k.URI.revive(v.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(v=>this.n(this.j,{profileLocation:k.URI.revive(v.profileLocation),local:D(v.local,null)})))}n(f,v){f.fire(v)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const v=await this.getTargetPlatform();return f.allTargetPlatforms.some(g=>(0,A.$jp)(g,f.allTargetPlatforms,v))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(v=>k.URI.revive(v)))}install(f,v){return Promise.resolve(this.m.call("install",[f,v])).then(g=>D(g,null))}installFromLocation(f,v){return Promise.resolve(this.m.call("installFromLocation",[f,v])).then(g=>D(g,null))}async installExtensionsFromProfile(f,v,g){return(await this.m.call("installExtensionsFromProfile",[f,v,g])).map(i=>D(i,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,v){return Promise.resolve(this.m.call("installFromGallery",[f,v])).then(g=>D(g,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(g=>({...g,local:g.local?D(g.local,null):g.local,source:this.r(g.source)?k.URI.revive(g.source):g.source,profileLocation:k.URI.revive(g.profileLocation)}))}uninstall(f,v){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,v]))}uninstallExtensions(f){if(f.some(v=>v.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[f]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(v=>D(v,null))}getInstalled(f=null,v,g){return Promise.resolve(this.m.call("getInstalled",[f,v,g])).then(b=>b.map(i=>D(i,null)))}updateMetadata(f,v,g){return Promise.resolve(this.m.call("updateMetadata",[f,v,g])).then(b=>D(b,null))}resetPinnedStateForAllUserExtensions(f){return this.m.call("resetPinnedStateForAllUserExtensions",[f])}toggleAppliationScope(f,v){return this.m.call("toggleAppliationScope",[f,v]).then(g=>D(g,null))}copyExtensions(f,v){return this.m.call("copyExtensions",[f,v])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,v,g){const b=await this.m.call("download",[f,v,g]);return k.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$yq=a;class u{constructor(f){this.a=f}listen(f,v){throw new Error("Invalid listen")}call(f,v,g){switch(v){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$zq=u}),define(Re[129],Ae([1,0,9,21]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.$XG=void 0;class E{constructor(){this.a=new Map,this.b=new WeakMap}register(C,A){this.a.set(C,A)}readActivationEvents(C){return this.b.has(C)||this.b.set(C,this.c(C)),this.b.get(C)}createActivationEventsMap(C){const A=Object.create(null);for(const y of C){const o=this.readActivationEvents(y);o.length>0&&(A[s.$rn.toKey(y.identifier)]=o)}return A}c(C){if(typeof C.main>"u"&&typeof C.browser>"u")return[];const A=Array.isArray(C.activationEvents)?C.activationEvents.slice(0):[];for(let y=0;y<A.length;y++)A[y]==="onUri"&&(A[y]=`onUri:${s.$rn.toKey(C.identifier)}`);if(!C.contributes)return A;for(const y in C.contributes){const o=this.a.get(y);if(!o)continue;const D=C.contributes[y],w=Array.isArray(D)?D:[D];try{o(w,A)}catch(m){(0,t.$Y)(m)}}return A}}e.$XG=E,e.$YG=new E}),define(Re[221],Ae([1,0,2,21,15]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class k extends t.$Uc{constructor(A,y,o,D,w){super(),this.a=A,this.b=y,this.c=o,this.f=w,this.B(D.onDidInstallExtensions(m=>this.g(m))),this.B(D.onDidUninstallExtension(m=>this.h(m)))}g(A){for(const y of A)y.local&&this.invalidate(y.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const y of this.a.profiles)this.c.extUri.isEqual(y.extensionsResource,A)&&await this.j(y);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,s.$ln))}catch(y){(0,E.$rl)(y)!==E.FileOperationResult.FILE_NOT_FOUND&&this.f.error(y)}}}e.$Wq=k});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[73],Ae([1,0,19,57,7,62,21,118]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=D,e.$1p=w,e.$2p=m,e.$3p=$,e.$4p=a,e.$5p=u,e.$6p=d,e.$7p=f,s=dt(s),E=Ue(E),k=Ue(k);const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function D(b){return b=b.trim(),b==="*"||y.test(b)}function w(b){if(!D(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=b.match(y);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function m(b){if(!b)return null;const i=b.majorBase,p=b.majorMustEqual,n=b.minorBase;let l=b.minorMustEqual;const r=b.patchBase;let h=b.patchMustEqual;b.hasCaret&&(i===0||(l=!1),h=!1);let c=0;if(b.preRelease){const S=o.exec(b.preRelease);if(S){const[,I,R,L]=S;c=Date.UTC(Number(I),Number(R)-1,Number(L))}}return{majorBase:i,majorMustEqual:p,minorBase:n,minorMustEqual:l,patchBase:r,patchMustEqual:h,isMinimum:b.hasGreaterEquals,notBefore:c}}function $(b,i,p){let n;typeof b=="string"?n=m(w(b)):n=b;let l;i instanceof Date?l=i.getTime():typeof i=="string"&&(l=new Date(i).getTime());let r;if(typeof p=="string"?r=m(w(p)):r=p,!n||!r)return!1;const h=n.majorBase,c=n.minorBase,S=n.patchBase;let I=r.majorBase,R=r.minorBase,L=r.patchBase;const O=r.notBefore;let P=r.majorMustEqual,q=r.minorMustEqual,K=r.patchMustEqual;return r.isMinimum?h>I?!0:h<I?!1:c>R?!0:c<R||l&&l<O?!1:S>=L:(h===1&&I===0&&(!P||!q||!K)&&(I=1,R=0,L=0,P=!0,q=!1,K=!1),h<I?!1:h>I?!P:c<R?!1:c>R?!q:S<L?!1:S>L?!K:!(l&&l<O))}function a(b,i,p,n,l,r){const h=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return h.push([s.default.Error,E.localize(11432,null)]),h;if(typeof n.name!="string")return h.push([s.default.Error,E.localize(11433,null,"name")]),h;if(typeof n.version!="string")return h.push([s.default.Error,E.localize(11434,null,"version")]),h;if(!n.engines)return h.push([s.default.Error,E.localize(11435,null,"engines")]),h;if(typeof n.engines.vscode!="string")return h.push([s.default.Error,E.localize(11436,null,"engines.vscode")]),h;if(typeof n.extensionDependencies<"u"&&!g(n.extensionDependencies))return h.push([s.default.Error,E.localize(11437,null,"extensionDependencies")]),h;if(typeof n.activationEvents<"u"){if(!g(n.activationEvents))return h.push([s.default.Error,E.localize(11438,null,"activationEvents")]),h;if(typeof n.main>"u"&&typeof n.browser>"u")return h.push([s.default.Error,E.localize(11439,null,"activationEvents","main","browser")]),h}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&h.push([s.default.Warning,E.localize(11440,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return h.push([s.default.Error,E.localize(11441,null,"main")]),h;{const I=(0,t.$gh)(p,n.main);(0,t.$ah)(I,p)||h.push([s.default.Warning,E.localize(11442,null,I.path,p.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return h.push([s.default.Error,E.localize(11443,null,"browser")]),h;{const I=(0,t.$gh)(p,n.browser);(0,t.$ah)(I,p)||h.push([s.default.Warning,E.localize(11444,null,I.path,p.path)])}}if(!k.valid(n.version))return h.push([s.default.Error,E.localize(11445,null)]),h;const c=[];if(!u(b,i,n,l,c))for(const I of c)h.push([s.default.Error,I]);if(r&&n.enabledApiProposals?.length){const I=[];if(!f([...n.enabledApiProposals],I))for(const R of I)h.push([s.default.Error,R])}return h}function u(b,i,p,n,l){return n||typeof p.main>"u"&&typeof p.browser>"u"?!0:v(b,i,p.engines.vscode,l)}function d(b,i,p){return b==="*"||v(i,p,b)}function f(b,i){if(b.length===0)return!0;const p=Array.isArray(i)?i:void 0,n=(p?void 0:i)??A.allApiProposals,l=[],r=(0,C.$yn)(b);for(const{proposalName:h,version:c}of r){const S=n[h];S&&c&&S.version!==c&&l.push(E.localize(11446,null,h))}return p?.push(...l),l.length===0}function v(b,i,p,n=[]){const l=m(w(p));if(!l)return n.push(E.localize(11447,null,p)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return n.push(E.localize(11448,null,p)),!1}else if(!l.majorMustEqual)return n.push(E.localize(11449,null,p)),!1;return $(b,i,l)?!0:(n.push(E.localize(11450,null,b,p)),!1)}function g(b){if(!Array.isArray(b))return!1;for(let i=0,p=b.length;i<p;i++)if(typeof b[i]!="string")return!1;return!0}}),define(Re[91],Ae([1,0,18,2,3,7,30,5]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0,e.$$r=y;function y(D){return D.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.$_r=(0,A.$Fi)("languagePackService");let o=class extends s.$Uc{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new t.$we;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const a=m.firstPage.filter(u=>u.properties.localizedLanguages?.length&&u.tags.some(d=>d.startsWith("lp-"))).map(u=>{const d=u.properties.localizedLanguages?.[0],f=y(u);return{...this.f(f,d,u),extensionId:u.identifier.id,galleryExtension:u}});return a.push(this.f("en","English")),a}f(w,m,$){const a=m??w;let u;if(a!==w&&(u=`(${w})`),w.toLowerCase()===E.$x.toLowerCase()&&(u??="",u+=(0,k.localize)(11354,null)),$?.installCount){u??="";const d=$.installCount;let f;d>1e6?f=`${Math.floor(d/1e5)/10}M`:d>1e3?f=`${Math.floor(d/1e3)}K`:f=String(d),u+=` $(cloud-download) ${f}`}return{id:w,label:a,description:u}}};e.$as=o,e.$as=o=Be([je(0,C.$lp)],o)}),define(Re[46],Ae([1,0,14,9,2,7,45,5,11,37]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0,e.$0p=m,e.$$p=$,e.$_p=a,e.$aq=u,e.$bq=d,e.$cq=f,e.$8p=(0,A.$Fi)("requestService");class D{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const p in this.b)p.toLowerCase()==="authorization"||p.toLowerCase()==="proxy-authorization"?i[p]="*****":i[p]=this.b[p];this.a=i}return this.a}}class w extends E.$Uc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(11219,null),when:y.$sk.isEqualTo((0,y.$pk)(y.LogLevel.Trace)).serialize()})}async c(i,p,n){const l=`${i} #${++this.b}: ${p.url}`;this.a.trace(`${l} - begin`,p.type,new D(p.headers??{}));try{const r=await n();return this.a.trace(`${l} - end`,p.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${l} - error`,p.type,(0,s.$9)(r)),r}}}e.$9p=w;function m(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}function $(b){return b.res.statusCode===204}async function a(b){return $(b)?null:(await(0,t.$Ze)(b.stream)).toString()}async function u(b){if(!m(b))throw new Error("Server returned "+b.res.statusCode);return a(b)}async function d(b){if(!m(b))throw new Error("Server returned "+b.res.statusCode);if($(b))return null;const p=(await(0,t.$Ze)(b.stream)).toString();try{return JSON.parse(p)}catch(n){throw n.message+=`:
`+p,n}}function f(b){g(b)}let v;function g(b){const i=o.$ro.as(C.$wo.Configuration),p=v;v={id:"http",order:15,title:(0,k.localize)(11220,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(11221,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(11222,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(11223,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(11224,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(11225,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(11226,null),(0,k.localize)(11227,null),(0,k.localize)(11228,null),(0,k.localize)(11229,null)],default:"override",description:(0,k.localize)(11230,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11231,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(11232,null),restricted:!0}}},i.updateConfigurations({add:[v],remove:p?[p]:[]})}g(C.ConfigurationScope.APPLICATION)}),define(Re[222],Ae([1,0,18,12,15,46]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=void 0;let C=class{constructor(y,o){this.a=y,this.b=o}async download(y,o,D=t.CancellationToken.None){if(y.scheme===s.Schemas.file||y.scheme===s.Schemas.vscodeRemote){await this.b.copy(y,o);return}const w={type:"GET",url:y.toString(!0)},m=await this.a.request(w,D);if(m.res.statusCode===200)await this.b.writeFile(o,m.stream);else{const $=await(0,k.$aq)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${$}`)}}};e.$ZR=C,e.$ZR=C=Be([je(0,k.$8p),je(1,E.$al)],C)}),define(Re[223],Ae([1,0,14,18]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.$cs=void 0;class E{constructor(A){this.a=A}listen(A,y){throw new Error("Invalid listen")}call(A,y,o,D=s.CancellationToken.None){switch(y){case"request":return this.a.request(o[0],D).then(async({res:w,stream:m})=>{const $=await(0,t.$Ze)(m);return[{statusCode:w.statusCode,headers:w.headers},$]});case"resolveProxy":return this.a.resolveProxy(o[0]);case"lookupAuthorization":return this.a.lookupAuthorization(o[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(o[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$cs=E;class k{constructor(A){this.a=A}async request(A,y){const[o,D]=await this.a.call("request",[A],y);return{res:o,stream:(0,t.$2e)(D)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async lookupAuthorization(A){return this.a.call("lookupAuthorization",[A])}async lookupKerberosAuthorization(A){return this.a.call("lookupKerberosAuthorization",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ds=k}),define(Re[224],Ae([1,0,92,10]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=k;function E(C,A){return C.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:C.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function k(C,A,y={}){const o=(0,t.parse)(C),D=y.proxyUrl||E(o,A);if(!D)return null;const w=(0,t.parse)(D);if(!/^https?:$/.test(w.protocol||""))return null;const m={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,s.$kg)(y.strictSSL)?y.strictSSL:!0};if(o.protocol==="http:"){const $=await new Promise((a,u)=>{ue(["http-proxy-agent"],a,u)}).then(Ue);return new $.HttpProxyAgent(D,m)}else{const $=await new Promise((a,u)=>{ue(["https-proxy-agent"],a,u)}).then(Ue);return new $.HttpsProxyAgent(D,m)}}}),define(Re[93],Ae([1,0,59,8,7,18,44,9,3,22,114,198,13,163]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=u;let a;async function u(f,v,g,b){return g["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.$j?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Km)(b)&&!g["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Km)(b)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=m.Promises.withAsyncBody(async(i,p)=>{const n=new k.$we;let l=1e4;const r=f.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(l=(0,$.$Lm)(r,1,120)*1e3);const h=setTimeout(()=>{n.dispose(!0),p(new Error((0,E.localize)(11216,null)))},l);try{i(await d(v,n.token))}catch(c){!(0,A.$3)(c)&&!n.token.isCancellationRequested?p(new Error((0,E.localize)(11217,null,(0,C.$qj)(c)))):i({})}finally{clearTimeout(h),n.dispose()}})),a)}async function d(f,v){const g=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",g);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",b);const i=(0,o.$2g)().replace(/-/g,"").substr(0,12),p=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",n);const l=await(0,D.$Am)(y.OS,n);return f.trace("getUnixShellEnvironment#shell",l),new Promise((r,h)=>{if(v.isCancellationRequested)return h(new A.$4);const c=(0,s.$nc)(l);let S,I;const R="";/^pwsh(-preview)?$/.test(c)?(S=`& '${process.execPath}' ${R} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,I=["-Login","-Command"]):c==="nu"?(S=`^'${process.execPath}' ${R} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,I=["-i","-l","-c"]):c==="xonsh"?(S=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,I=["-i","-l","-c"]):(S=`'${process.execPath}' ${R} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,c==="tcsh"||c==="csh"?I=["-ic"]:I=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),S);const L=(0,t.spawn)(l,[...I,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});v.onCancellationRequested(()=>(L.kill(),h(new A.$4))),L.on("error",q=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,C.$qj)(q)),h(q)});const O=[];L.stdout.on("data",q=>O.push(q));const P=[];L.stderr.on("data",q=>P.push(q)),L.on("close",(q,K)=>{const J=Buffer.concat(O).toString("utf8");f.trace("getUnixShellEnvironment#raw",J);const _=Buffer.concat(P).toString("utf8");if(_.trim()&&f.trace("getUnixShellEnvironment#stderr",_),q||K)return h(new Error((0,E.localize)(11218,null,q,K)));const de=p.exec(J),ge=de?de[1]:"{}";try{const le=JSON.parse(ge);g?le.ELECTRON_RUN_AS_NODE=g:delete le.ELECTRON_RUN_AS_NODE,b?le.ELECTRON_NO_ATTACH_CONSOLE=b:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",le),r(le)}catch(le){f.error("getUnixShellEnvironment#errorCaught",(0,C.$qj)(le)),h(le)}})})}}),define(Re[225],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=void 0,e.$BR=(0,t.$Fi)("stateReadService"),e.$CR=(0,t.$Fi)("stateService")}),define(Re[226],Ae([1,0,13,14,2,10,28,15,11]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FR=e.$ER=e.$DR=e.SaveStrategy=void 0;var o;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(o||(e.SaveStrategy=o={}));class D extends E.$Uc{constructor(a,u,d,f){super(),this.h=a,this.j=u,this.m=d,this.n=f,this.a=Object.create(null),this.b="",this.c=this.B(new t.$Dh(this.j===o.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,u){const d=this.a[a];return(0,k.$ng)(d)?u:d}setItem(a,u){this.setItems([{key:a,data:u}])}setItems(a){let u=!1;for(const{key:d,data:f}of a)this.a[d]!==f&&((0,k.$ng)(f)?(0,k.$lg)(this.a[d])||(this.a[d]=void 0,u=!0):(this.a[d]=f,u=!0));u&&this.s()}removeItem(a){(0,k.$lg)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,s.$Ne.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(u){this.m.error(u)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$DR=D;let w=class extends E.$Uc{constructor(a,u,d,f){super(),this.a=this.B(new D(u.stateResource,a,d,f))}async init(){await this.a.init()}getItem(a,u){return this.a.getItem(a,u)}};e.$ER=w,e.$ER=w=Be([je(1,C.$Mi),je(2,y.$ak),je(3,A.$al)],w);class m extends w{setItem(a,u){this.a.setItem(a,u)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$FR=m}),define(Re[130],Ae([1,0,3,31,22]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=C,e.$wp=A;function k(y){if(t.$v===t.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function C(y,o,D,w,m,$,a,u,d,f){const v=Object.create(null);v["common.machineId"]=$,v["common.sqmId"]=a,v["common.devDeviceId"]=u,v.sessionID=(0,E.$2g)()+Date.now(),v.commitHash=w,v.version=m,v["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,t.$i)(t.$v),v["common.nodePlatform"]=s.$dc,v["common.nodeArch"]=D,v["common.product"]=f||"desktop",d&&(v["common.msftInternal"]=d);let g=0;const b=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),t.$m&&(v["common.snap"]="true");const i=k(o);return i&&(v["common.platformDetail"]=i),v}function A(y){const o=s.env.USERDNSDOMAIN;if(!o)return!1;const D=o.toLowerCase();return y.some(w=>D===w)}}),define(Re[227],Ae([1,0,17,9,2,20,15]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(o){function D(w,m){return w.callstack<m.callstack?-1:w.callstack>m.callstack?1:0}o.compare=D})(A||(e.ErrorEvent=A={}));class y{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(D,w=y.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new E.$Tc,this.c=D,this.d=w;const m=s.$V.addListener($=>this.j($));this.h.add((0,E.$Sc)(m)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(D){if(!D||D.code||(D.detail&&D.detail.stack&&(D=D.detail),s.$ab.isErrorNoTelemetry(D)||D instanceof C.$vl||typeof D?.message=="string"&&D.message.includes("Unable to read file")))return;const w=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,m=D.message?D.message:(0,k.$jo)(D);w&&this.k({msg:m,callstack:w})}k(D){const w=(0,t.$vb)(this.g,D,A.compare);w<0?(D.count=1,this.g.splice(~w,0,D)):(this.g[w].count||(this.g[w].count=0),this.g[w].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const D of this.g)this.c.publicLogError2("UnhandledError",D);this.g.length=0}}e.default=y}),define(Re[24],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,t.$Fi)("telemetryService"),e.$am=(0,t.$Fi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var s;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(s||(e.TelemetryLevel=s={}));var E;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(Re[228],Ae([1,0,23,32,13,42,12,8,3,47,4,110,26,113,204,15,29,24]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$Ys=g,e.$Zs=i,e.$1s=p,t=Ue(t),s=Ue(s);const v=new Map;async function g(l,r){const h=`${l}::${r.join(":")}`,c=v.get(h);if(c)return c;const S=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],I=new Map,R=new Map,L=2e4;function O(q,K,J,_){const de=K.substring(q.length+1);return E.Promises.withAsyncBody(async ge=>{let le;_.readdirCount++;try{le=await m.Promises.readdir(K,{withFileTypes:!0})}catch{ge();return}if(_.count>=L){_.count+=le.length,_.maxReached=!0,ge();return}let z=le.length;if(z===0){ge();return}let Q=le;_.count+le.length>L&&(_.maxReached=!0,z=L-_.count,Q=le.slice(0,z)),_.count+=le.length;for(const M of Q)if(M.isDirectory()){if(J.includes(M.name)||await O(q,(0,A.$jc)(K,M.name),J,_),--z===0){ge();return}}else{const V=M.name.lastIndexOf(".");if(V>=0){const ne=M.name.substring(V+1);ne&&I.set(ne,(I.get(ne)??0)+1)}for(const ne of S)ne.relativePathPattern?.test(de)!==!1&&ne.filePattern.test(M.name)&&R.set(ne.tag,(R.get(ne.tag)??0)+1);if(--z===0){ge();return}}})}const P=E.Promises.withAsyncBody(async q=>{const K={count:0,maxReached:!1,readdirCount:0},J=new o.$fe(!0);await O(l,l,r,K);const _=await p(l);q({configFiles:b(R),fileTypes:b(I),fileCount:K.count,maxFilesReached:K.maxReached,launchConfigFiles:_,totalScanTime:J.elapsed(),totalReaddirCount:K.readdirCount})});return v.set(h,P),P}function b(l){return Array.from(l.entries(),([r,h])=>({name:r,count:h})).sort((r,h)=>h.count-r.count)}function i(){const l={os:`${s.type()} ${s.arch()} ${s.release()}`,memory:`${(s.totalmem()/u.$Il.GB).toFixed(2)}GB (${(s.freemem()/u.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.$Sn.value()*100)}%`},r=s.cpus();return r&&r.length>0&&(l.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),l}async function p(l){try{const r=new Map,h=(0,A.$jc)(l,".vscode","launch.json"),c=await t.promises.readFile(h),S=[],I=(0,k.$Yn)(c.toString(),S);if(S.length)return console.log(`Unable to parse ${h}`),[];if((0,k.$7n)(I)==="object"&&I.configurations)for(const R of I.configurations){const L=R.type;L&&(r.has(L)?r.set(L,r.get(L)+1):r.set(L,1))}return b(r)}catch{return[]}}let n=class{constructor(r,h){this.c=r,this.d=h}f(r){const h=[];return h.push(`OS Version:       ${r.os}`),h.push(`CPUs:             ${r.cpus}`),h.push(`Memory (System):  ${r.memory}`),h.push(`VM:               ${r.vmHint}`),h.join(`
`)}g(r){const h=[];h.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),h.push(`OS Version:       ${s.type()} ${s.arch()} ${s.release()}`);const c=s.cpus();return c&&c.length>0&&h.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),h.push(`Memory (System):  ${(s.totalmem()/u.$Il.GB).toFixed(2)}GB (${(s.freemem()/u.$Il.GB).toFixed(2)}GB free)`),y.$j||h.push(`Load (avg):       ${s.loadavg().map(S=>Math.round(S)).join(", ")}`),h.push(`VM:               ${Math.round(w.$Sn.value()*100)}%`),h.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),h.push(`Process Argv:     ${r.mainArguments.join(" ")}`),h.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),h.join(`
`)}async getPerformanceInfo(r,h){return Promise.all([(0,$.$Xs)(r.mainPID),this.k(r)]).then(async c=>{let[S,I]=c,R=this.m(r,S);return h.forEach(L=>{if((0,a.$Um)(L))R+=`
${L.errorMessage}`,I+=`
${L.errorMessage}`;else if(R+=`

Remote: ${L.hostName}`,L.processes&&(R+=`
${this.m(r,L.processes)}`),L.workspaceMetadata){I+=`
|  Remote: ${L.hostName}`;for(const O of Object.keys(L.workspaceMetadata)){const P=L.workspaceMetadata[O];let q=`${P.fileCount} files`;P.maxFilesReached&&(q=`more than ${q}`),I+=`|    Folder (${O}): ${q}`,I+=this.h(P)}}}),{processInfo:R,workspaceInfo:I}})}async getSystemInfo(r,h){const{memory:c,vmHint:S,os:I,cpus:R}=i(),L={os:I,memory:c,cpus:R,vmHint:S,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:h};return y.$j||(L.load=`${s.loadavg().map(O=>Math.round(O)).join(", ")}`),y.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(r,h){const c=[];return(0,$.$Xs)(r.mainPID).then(async S=>(c.push(""),c.push(this.g(r)),c.push(""),c.push(this.m(r,S)),r.windows.some(I=>I.folderURIs&&I.folderURIs.length>0&&!I.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.k(r))),h.forEach(I=>{if((0,a.$Um)(I))c.push(`
${I.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${I.hostName}`),c.push(this.f(I.machineInfo)),I.processes&&c.push(this.m(r,I.processes)),I.workspaceMetadata)for(const R of Object.keys(I.workspaceMetadata)){const L=I.workspaceMetadata[R];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),c.push(`Folder (${R}): ${O}`),c.push(this.h(L))}}),c.push(""),c.push(""),c.join(`
`)))}h(r){const h=[];let S=0;const I=(P,q)=>{const K=` ${P}(${q})`;S+K.length>60?(h.push(R),R="|                 ",S=R.length):S+=K.length,R+=K};let R="|      File types:";const L=10,O=r.fileTypes.length>L?L:r.fileTypes.length;for(let P=0;P<O;P++){const q=r.fileTypes[P];I(q.name,q.count)}if(h.push(R),r.configFiles.length>=0&&(R="|      Conf files:",S=0,r.configFiles.forEach(P=>{I(P.name,P.count)}),h.push(R)),r.launchConfigFiles.length>0){let P="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{const K=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`;P+=K}),h.push(P)}return h.join(`
`)}j(r){const h=Math.max(...Object.keys(r).map(c=>c.length));return Object.keys(r).map(c=>`${c}:  ${" ".repeat(h-c.length)}  ${r[c]}`).join(`
                  `)}k(r){const h=[],c=[];return r.windows.forEach(S=>{S.folderURIs.length===0||S.remoteAuthority||(h.push(`|  Window (${S.title})`),S.folderURIs.forEach(I=>{const R=D.URI.revive(I);if(R.scheme===C.Schemas.file){const L=R.fsPath;c.push(g(L,["node_modules",".git"]).then(O=>{let P=`${O.fileCount} files`;O.maxFilesReached&&(P=`more than ${P}`),h.push(`|    Folder (${(0,A.$nc)(L)}): ${P}`),h.push(this.h(O))}).catch(O=>{h.push(`|      Error: Unable to collect workspace stats for folder ${L} (${O.toString()})`)}))}else h.push(`|    Folder (${R.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(S=>h.join(`
`)).catch(S=>`Unable to collect workspace stats: ${S}`)}m(r,h){const c=new Map;r.windows.forEach(I=>c.set(I.pid,`window [${I.id}] (${I.title})`)),r.pidToNames.forEach(({pid:I,name:R})=>c.set(I,R));const S=[];return S.push("CPU %	Mem MB	   PID	Process"),h&&this.n(r.mainPID,c,S,h,0),S.join(`
`)}n(r,h,c,S,I){const R=I===0;let L;R?L=S.pid===r?`${this.d.applicationName} main`:"remote agent":h.has(S.pid)?L=h.get(S.pid):L=`${"  ".repeat(I)} ${S.name}`;const O=process.platform==="win32"?S.mem:s.totalmem()*(S.mem/100);c.push(`${S.load.toFixed(0).padStart(5," ")}	${(O/u.$Il.MB).toFixed(0).padStart(6," ")}	${S.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(S.children)&&S.children.forEach(P=>this.n(r,h,c,P,I+1))}async getWorkspaceFileExtensions(r){const h=new Set;for(const{uri:c}of r.folders){const S=D.URI.revive(c);if(S.scheme!==C.Schemas.file)continue;const I=S.fsPath;try{(await g(I,["node_modules",".git"])).fileTypes.forEach(L=>h.add(L.name))}catch{}}return{extensions:[...h]}}async reportWorkspaceStats(r){for(const{uri:h}of r.folders){const c=D.URI.revive(h);if(c.scheme!==C.Schemas.file)continue;const S=c.fsPath;try{const I=await g(S,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),I.fileTypes.forEach(R=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:R.name,count:R.count})}),I.launchConfigFiles.forEach(R=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:R.name,count:R.count})}),I.configFiles.forEach(R=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:R.name,count:R.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:I.totalScanTime,reachedLimit:I.maxFilesReached,fileCount:I.fileCount,readdirCount:I.totalReaddirCount})}catch{}}}};e.$2s=n,e.$2s=n=Be([je(0,f.$_l),je(1,d.$tk)],n)}),define(Re[94],Ae([1,0,9,5,11,24]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.ExtensionSignatureVerificationCode=e.$tq=void 0,e.$tq=(0,s.$Fi)("IExtensionSignatureVerificationService");var C;(function(o){o.Success="Success",o.RequiredArgumentMissing="RequiredArgumentMissing",o.InvalidArgument="InvalidArgument",o.PackageIsUnreadable="PackageIsUnreadable",o.UnhandledException="UnhandledException",o.SignatureManifestIsMissing="SignatureManifestIsMissing",o.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",o.SignatureIsMissing="SignatureIsMissing",o.SignatureIsUnreadable="SignatureIsUnreadable",o.CertificateIsUnreadable="CertificateIsUnreadable",o.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",o.FileAlreadyExists="FileAlreadyExists",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",o.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",o.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",o.SignatureIsInvalid="SignatureIsInvalid",o.SignatureManifestIsInvalid="SignatureManifestIsInvalid",o.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",o.EntryIsMissing="EntryIsMissing",o.EntryIsTampered="EntryIsTampered",o.Untrusted="Untrusted",o.CertificateRevoked="CertificateRevoked",o.SignatureIsNotValid="SignatureIsNotValid",o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(C||(e.ExtensionSignatureVerificationCode=C={}));class A extends Error{constructor(D){super(D),this.code=D}}e.$uq=A;let y=class{constructor(D,w){this.b=D,this.c=w}d(){return this.a||(this.a=new Promise((D,w)=>ue(["@vscode/vsce-sign"],async m=>D(m),w))),this.a}async verify(D,w,m,$){let a;const u=D.identifier.id;try{a=await this.d()}catch(g){return this.b.error("Could not load vsce-sign module",(0,t.$9)(g)),this.b.info(`Extension signature verification is not done: ${u}`),!1}const d=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${u}...`),f=await a.verify(w,m,this.b.getLevel()===E.LogLevel.Trace)}catch(g){f={code:C.UnknownError,didExecute:!1,output:(0,t.$9)(g)}}const v=new Date().getTime()-d;if(this.b.info(`Extension signature verification result for ${u}: ${f.code}. Executed: ${f.didExecute}. Duration: ${v}ms.`),this.b.trace(`Extension signature verification output for ${u}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:u,extensionVersion:D.version,code:f.code,internalCode:f.internalCode,duration:v,didExecute:f.didExecute,clientTargetPlatform:$}),f.code===C.Success)return!0;throw new A(f.code)}};e.$vq=y,e.$vq=y=Be([je(0,E.$ak),je(1,k.$_l)],y)}),define(Re[229],Ae([1,0,2,24]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class E extends t.$Uc{constructor(C,A){super(),this.a=C,this.b=A}async call(C,A,y){switch(A){case"updateTelemetryLevel":{const{telemetryLevel:o}=y;return this.a.updateInjectedTelemetryLevel(o)}case"logTelemetry":{const{eventName:o,data:D}=y;return this.b?this.b.log(o,D):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${A} not found`)}listen(C,A,y){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(s.TelemetryLevel.NONE),super.dispose()}}e.$0s=E}),define(Re[40],Ae([1,0,20,10,90,130,24]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$Ep=D,e.$Fp=w,e.$Gp=m,e.$Hp=$,e.$Ip=u,e.$Jp=f,e.$Kp=v,e.$Lp=i;class A{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$xp=A;class y{constructor(){this.telemetryLevel=C.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yp=y,e.$zp=new y;class o{async publicLog(n,l,r){}async publicLogError(n,l,r){}}e.$Ap=o,e.$Bp="telemetry",e.$Cp="extensionTelemetryLog",e.$Dp={log:()=>null,flush:()=>Promise.resolve(null)};function D(p,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!p.enableTelemetry)}function w(p,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||p.enableTelemetry&&p.aiConfig?.ariaKey)}function m(p){const n=p.getValue(C.$im),l=p.getValue(C.$jm);if(p.getValue(C.$km)===!1||l===!1)return C.TelemetryLevel.NONE;switch(n??C.TelemetryConfiguration.ON){case C.TelemetryConfiguration.ON:return C.TelemetryLevel.USAGE;case C.TelemetryConfiguration.ERROR:return C.TelemetryLevel.ERROR;case C.TelemetryConfiguration.CRASH:return C.TelemetryLevel.CRASH;case C.TelemetryConfiguration.OFF:return C.TelemetryLevel.NONE}}function $(p){const n={},l={},r={};d(p,r);for(let h in r){h=h.length>150?h.substr(h.length-149):h;const c=r[h];typeof c=="number"?l[h]=c:typeof c=="boolean"?l[h]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${c.length}`),n[h]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(n[h]=c)}return{properties:n,measurements:l}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(p){if(!p)return"none";const n=(0,E.$in)(p);return a.has(n)?n:"other"}function d(p,n,l=0,r){if(p)for(const h of Object.getOwnPropertyNames(p)){const c=p[h],S=r?r+h:h;Array.isArray(c)?n[S]=(0,t.$jo)(c):c instanceof Date?n[S]=c.toISOString():(0,s.$gg)(c)?l<2?d(c,n,l+1,S+"."):n[S]=(0,t.$jo)(c):n[S]=c}}function f(p,n){const l=p.msftInternalDomains||[],r=n.getValue("telemetry.internalTesting");return(0,k.$wp)(l)||r}function v(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}function g(p,n){if(!p||!p.includes("/")&&!p.includes("\\"))return p;let l=p;const r=[];for(const I of n)for(;;){const R=I.exec(p);if(!R)break;r.push([R.index,I.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(l="";;){const I=c.exec(p);if(!I)break;const R=r.some(([L,O])=>I.index<O&&L<c.lastIndex);!h.test(I[0])&&!R&&(l+=p.substring(S,I.index)+"<REDACTED: user-file-path>",S=c.lastIndex)}return S<p.length&&(l+=p.substr(S)),l}function b(p){if(!p)return p;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(p))return`<REDACTED: ${l.label}>`;return p}function i(p,n){return(0,t.$go)(p,l=>{if(l instanceof A||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let r=l.replaceAll("%20"," ");r=g(r,n);for(const h of n)r=r.replace(h,"");return r=b(r),r}})}}),define(Re[38],Ae([1,0,16,30,21,3,4,9,31,40]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Np=void 0,e.$Mp=D,e.$Op=a,e.$Pp=u,e.$Qp=d,e.$Rp=f,e.$Sp=v,e.$Tp=g,e.$Up=b,e.$Wp=i,e.$Xp=n;function D(l,r){return l.uuid&&r.uuid?l.uuid===r.uuid:l.id===r.id?!0:(0,t.$Af)(l.id,r.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(r){const h=r.manifest?r.manifest.version:r.version,c=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new m(r.identifier,h,c)}static parse(r){const h=w.exec(r);return h&&h[1]&&h[2]?new m({id:h[1]},h[2],h[4]||void 0):null}constructor(r,h,c=E.TargetPlatform.UNDEFINED){this.identifier=r,this.version=h,this.targetPlatform=c,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof m?D(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$Np=m;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(l){const r=$.exec(l);return r&&r[1]?[d(r[1]),r[2]]:[d(l),void 0]}function u(l,r){return`${l}.${r}`}function d(l){return l.toLowerCase()}function f(l,r){return d(u(l??E.$nn,r))}function v(l,r){const h=[],c=S=>{for(const I of h)if(I.some(R=>D(r(R),r(S))))return I;return null};for(const S of l){const I=c(S);I?I.push(S):h.push([S])}return h}function g(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}function b(l){return{id:new o.$xp(l.identifier.id),name:new o.$xp(l.name),version:l.version,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),isSigned:l.isSigned,...l.telemetryData}}e.$Vp=new E.$rn("pprice.better-merge");function i(l,r){const h=[],c=r.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const S=c.shift();if(S&&h.every(I=>!D(I.identifier,{id:S}))){const I=l.filter(R=>D(R.identifier,{id:S}));I.length===1&&(h.push(I[0]),c.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function p(l,r){if(!k.$l)return!1;let h;try{h=(await l.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await l.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){r.debug("Error while getting the os-release file.",(0,A.$9)(S))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(l,r){const h=await p(l,r),c=(0,s.$hp)(h?"alpine":k.$v,y.$ec);return r.debug("ComputeTargetPlatform:",c),c}}),define(Re[131],Ae([1,0,18,9,12,19,62,4,7,30,38,21]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;const m=u=>(0,y.localize)(11469,null,u),$=(0,y.localize)(11470,null,"ms-dotnettools.csharp");let a=class{constructor(d,f,v){this.a=d,this.b=f,this.d=v}get f(){}async listExtensions(d,f,v){let g=await this.b.getInstalled(w.ExtensionType.User,v);const b=w.$qn.map(p=>p.toLowerCase());if(f&&f!==""){if(b.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(p=>p.manifest.categories?p.manifest.categories.map(l=>l.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),b.forEach(p=>{this.a.info(p)});return}this.f&&this.a.info((0,y.localize)(11471,null,this.f)),g=g.sort((p,n)=>p.identifier.id.localeCompare(n.identifier.id));let i;for(const p of g)i!==p.identifier.id&&(i=p.identifier.id,this.a.info(d?`${i}@${p.manifest.version}`:i))}async installExtensions(d,f,v,g){const b=[];try{d.length&&this.a.info(this.f?(0,y.localize)(11472,null,this.f):(0,y.localize)(11473,null));const i=[],p=[],n=(r,h,c)=>{p.push({id:r,version:h!=="prerelease"?h:void 0,installOptions:{...v,isBuiltin:c,installPreReleaseVersion:h==="prerelease"||v.installPreReleaseVersion}})};for(const r of d)if(r instanceof A.URI)i.push({vsix:r,installOptions:v});else{const[h,c]=(0,D.$Op)(r);n(h,c,!1)}for(const r of f)if(r instanceof A.URI)i.push({vsix:r,installOptions:{...v,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[h,c]=(0,D.$Op)(r);n(h,c,!0)}const l=await this.b.getInstalled(void 0,v.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:r,installOptions:h})=>{try{await this.h(r,h,g,l)}catch(c){this.a.error(c),b.push(r.toString())}})),p.length){const r=await this.g(p,l,g);b.push(...r)}}catch(i){throw this.a.error((0,y.localize)(11474,null,(0,s.$9)(i))),i}if(b.length)throw new Error((0,y.localize)(11475,null,b.join(", ")))}async updateExtensions(d){const f=await this.b.getInstalled(w.ExtensionType.User,d),v=[];for(const p of f)p.identifier.uuid&&v.push({...p.identifier,preRelease:p.preRelease});this.a.trace((0,y.localize)(11476,null,v.length));const g=await this.d.getExtensions(v,{compatible:!0},t.CancellationToken.None),b=[];for(const p of g)for(const n of f)(0,D.$Mp)(n.identifier,p.identifier)&&(0,C.gt)(p.version,n.manifest.version)&&b.push({extension:p,options:{operation:o.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:d,isApplicationScoped:n.isApplicationScoped}});if(!b.length){this.a.info((0,y.localize)(11477,null));return}this.a.info((0,y.localize)(11478,null,b.map(p=>p.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(b);for(const p of i)p.error?this.a.error((0,y.localize)(11479,null,p.identifier.id,(0,s.$9)(p.error))):this.a.info((0,y.localize)(11480,null,p.identifier.id,p.local?.manifest.version))}async g(d,f,v){if(d=d.filter(({id:p,version:n})=>{const l=f.find(r=>(0,D.$Mp)(r.identifier,{id:p}));if(l){if(!v&&(!n||n==="prerelease"&&l.preRelease))return this.a.info((0,y.localize)(11481,null,p,l.manifest.version,p)),!1;if(n&&l.manifest.version===n)return this.a.info((0,y.localize)(11482,null,`${p}@${n}`)),!1}return!0}),!d.length)return[];const g=[],b=[],i=await this.j(d);if(await Promise.all(d.map(async({id:p,version:n,installOptions:l})=>{const r=i.get(p.toLowerCase());if(!r){this.a.error(`${m(n?`${p}@${n}`:p)}
${$}`),g.push(p);return}try{const c=await this.d.getManifest(r,t.CancellationToken.None);if(c&&!this.k(c))return}catch(c){this.a.error(c.message||c.stack||c),g.push(p);return}const h=f.find(c=>(0,D.$Mp)(c.identifier,r.identifier));if(h){if(r.version===h.manifest.version){this.a.info((0,y.localize)(11483,null,n?`${p}@${n}`:p));return}this.a.info((0,y.localize)(11484,null,p,r.version))}l.isBuiltin?this.a.info(n?(0,y.localize)(11485,null,p,n):(0,y.localize)(11486,null,p)):this.a.info(n?(0,y.localize)(11487,null,p,n):(0,y.localize)(11488,null,p)),b.push({extension:r,options:{...l,installGivenVersion:!!n,isApplicationScoped:l.isApplicationScoped||h?.isApplicationScoped}})})),b.length){const p=await this.b.installGalleryExtensions(b);for(const n of p)n.error?(this.a.error((0,y.localize)(11489,null,n.identifier.id,(0,s.$9)(n.error))),g.push(n.identifier.id)):this.a.info((0,y.localize)(11490,null,n.identifier.id,n.local?.manifest.version))}return g}async h(d,f,v,g){const b=await this.b.getManifest(d);if(!b)throw new Error("Invalid vsix");if(await this.l(b,v,f.profileLocation,g))try{await this.b.install(d,{...f,installGivenVersion:!0}),this.a.info((0,y.localize)(11491,null,(0,k.$dh)(d)))}catch(p){if((0,s.$3)(p))this.a.info((0,y.localize)(11492,null,(0,k.$dh)(d)));else throw p}}async j(d){const f=new Map,v=d.some(i=>i.installOptions.installPreReleaseVersion),g=await this.b.getTargetPlatform(),b=[];for(const i of d)o.$_o.test(i.id)&&b.push({...i,preRelease:v});if(b.length){const i=await this.d.getExtensions(b,{targetPlatform:g},t.CancellationToken.None);for(const p of i)f.set(p.identifier.id.toLowerCase(),p)}return f}k(d){return!0}async l(d,f,v,g){if(!f){const b={id:(0,D.$Rp)(d.publisher,d.name)},i=g.find(p=>(0,D.$Mp)(b,p.identifier)&&(0,C.gt)(p.manifest.version,d.version));if(i)return this.a.info((0,y.localize)(11493,null,i.identifier.id,i.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,f,v){const g=async i=>{if(i instanceof A.URI){const p=await this.b.getManifest(i);return(0,D.$Pp)(p.publisher,p.name)}return i},b=[];for(const i of d){const p=await g(i),l=(await this.b.getInstalled(void 0,v)).filter(r=>(0,D.$Mp)(r.identifier,{id:p}));if(!l.length)throw new Error(`${this.m(p)}
${$}`);if(l.some(r=>r.type===w.ExtensionType.System)){this.a.info((0,y.localize)(11494,null,p));return}if(!f&&l.some(r=>r.isBuiltin)){this.a.info((0,y.localize)(11495,null,p));return}this.a.info((0,y.localize)(11496,null,p));for(const r of l)await this.b.uninstall(r,{profileLocation:v}),b.push(r);this.f?this.a.info((0,y.localize)(11497,null,p,this.f)):this.a.info((0,y.localize)(11498,null,p))}}async locateExtension(d){const f=await this.b.getInstalled();d.forEach(v=>{f.forEach(g=>{if(g.identifier.id===v&&g.location.scheme===E.Schemas.file){this.a.info(g.location.fsPath);return}})})}m(d){return this.f?(0,y.localize)(11499,null,d,this.f):(0,y.localize)(11500,null,d)}};e.$wq=a,e.$wq=a=Be([je(1,o.$op),je(2,o.$lp)],a)}),define(Re[230],Ae([1,0,9,6,2,25,38,21,15]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;class o extends E.$Uc{constructor(w,m,$,a,u,d,f){super(),this.f=w,this.g=m,this.h=$,this.j=a,this.m=u,this.n=d,this.r=f,this.a=this.B(new s.$le),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new E.$4c),this.s().then(null,v=>f.error("Error while initializing Extensions Watcher",(0,t.$9)(v)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(w=>this.u(w.added))),this.B(this.j.onAddExtensions(w=>this.w(w))),this.B(this.j.onDidAddExtensions(w=>this.y(w))),this.B(this.j.onRemoveExtensions(w=>this.z(w))),this.B(this.j.onDidRemoveExtensions(w=>this.C(w))),this.B(this.n.onDidFilesChange(w=>this.D(w)))}async u(w){try{w.length&&await Promise.all(w.map(m=>(this.c.set(m.id,(0,E.$Rc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(w){for(const m of w.extensions)this.I(this.L(m.identifier,m.version),w.profileLocation)}async y(w){for(const m of w.extensions){const $=this.L(m.identifier,m.version);w.error?this.J($,w.profileLocation):this.I($,w.profileLocation)}}async z(w){for(const m of w.extensions)this.J(this.L(m.identifier,m.version),w.profileLocation)}async C(w){const m=[],$=[];for(const a of w.extensions){const u=this.L(a.identifier,a.version);w.error?this.I(u,w.profileLocation):(this.J(u,w.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",a.identifier.id,a.version),$.push(this.f.scanInstalledExtensionAtLocation(a.location).then(d=>{d?m.push(d):this.r.info("Extension not found at the location",a.location.toString())},d=>this.r.error(d)))))}try{await Promise.all($),m.length&&await this.H(m)}catch(a){this.r.error(a)}}D(w){for(const m of this.h.profiles)w.contains(m.extensionsResource,y.FileChangeType.UPDATED,y.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(w){const m=[],$=[],a=await this.j.scanProfileExtensions(w),u=new Set,d=new Set;for(const[f,v]of this.b)v.has(w)&&d.add(f);for(const f of a){const v=this.L(f.identifier,f.version);u.add(v),d.has(v)||(m.push(f.identifier),this.I(v,w))}for(const f of d)if(!u.has(f)){const v=this.M(f);v&&($.push(v.identifier),this.J(f,w))}(m.length||$.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:w}:void 0,removed:$.length?{extensions:$,profileLocation:w}:void 0})}async G(w){const m=await this.j.scanProfileExtensions(w);for(const $ of m)this.I(this.L($.identifier,$.version),w)}async H(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter($=>!this.b.has(this.L($.identifier,$.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}I(w,m){let $=this.b.get(w);$||this.b.set(w,$=new k.$Bc(a=>this.m.extUri.getComparisonKey(a))),$.add(m)}J(w,m){const $=this.b.get(w);$&&$.delete(m),$?.size||this.b.delete(w)}L(w,m){return`${A.$rn.toKey(w.id)}@${m}`}M(w){const[m,$]=(0,C.$Op)(w);return $?{identifier:{id:m},version:$}:void 0}}e.$Xq=o}),define(Re[132],Ae([1,0,23,95,17,13,2,12,8,26,28,30,38,11,91,4]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,t=Ue(t);let d=class extends a.$as{constructor(b,i,p,n){super(p),this.h=b,this.j=n,this.g=this.B(new f(i,n)),this.h.registerParticipant({postInstall:async l=>this.m(l),postUninstall:async l=>this.n(l)})}async getBuiltInExtensionTranslationsUri(b,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const l=n.translations[b];return l?u.URI.file(l):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),i=Object.keys(b).map(p=>{const n=b[p];return{...this.f(p,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((p,n)=>p.label.localeCompare(n.label)),i}async m(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",b.identifier.id),await this.update())}async n(b){const i=await this.g.getLanguagePacks();Object.keys(i).some(p=>i[p]&&i[p].extensions.some(n=>(0,m.$Mp)(n.extensionIdentifier,b.identifier)))&&(this.j.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update(i);return!(0,E.$tb)(Object.keys(b),Object.keys(p))}};e.$bs=d,e.$bs=d=Be([je(0,w.$op),je(1,D.$Ni),je(2,w.$lp),je(3,$.$ak)],d);let f=class extends C.$Uc{constructor(b,i){super(),this.j=i,this.c={},this.f=(0,y.$jc)(b.userDataPath,"languagepacks.json"),this.g=new k.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.s(i=>{Object.keys(i).forEach(p=>delete i[p]),this.m(i,...b)}).then(()=>this.c)}m(b,...i){for(const p of i)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.n(b,p);Object.keys(b).forEach(p=>this.r(b[p]))}n(b,i){const p=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const l of n)if(i.location.scheme===A.Schemas.file&&v(l)){let r=b[l.languageId];r||(r={hash:"",extensions:[],translations:{},label:l.localizedLanguageName??l.languageName},b[l.languageId]=r);const h=r.extensions.filter(c=>(0,m.$Mp)(c.extensionIdentifier,p))[0];h?h.version=i.manifest.version:r.extensions.push({extensionIdentifier:p,version:i.manifest.version});for(const c of l.translations)r.translations[c.id]=(0,y.$jc)(i.location.fsPath,c.path)}}r(b){if(b){const i=(0,s.createHash)("md5");for(const p of b.extensions)i.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);b.hash=i.digest("hex")}}s(b=()=>null){return this.g.queue(()=>{let i=null;return t.promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(i=b(p),p)).then(p=>{for(const l of Object.keys(p))p[l]||delete p[l];this.c=p,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),o.Promises.writeFile(this.f,n)}).then(()=>i,p=>this.j.error(p))})}};f=Be([je(0,D.$Ni),je(1,$.$ak)],f);function v(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const b of g.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(Re[231],Ae([1,0,176,9,20,40]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=void 0;const C="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function y(D,w,m){const $=await(0,t.$CE)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,t.$CE)("@microsoft/1ds-post-js","dist/ms.post.js"),u=new $.AppInsightsCore,d=new a.PostChannel,f={instrumentationKey:D,endpointUrl:C,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(m){f.extensionConfig={};const v={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};f.extensionConfig[d.identifier]=v}return u.initialize(f,[]),u.addTelemetryInitializer(v=>{v.ext=v.ext??{},v.ext.web=v.ext.web??{},v.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',w&&(v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),u}class o{constructor(w,m,$,a,u){this.e=w,this.f=m,this.g=$,this.h=u,this.c=C,this.d=A,this.g||(this.g={}),typeof a=="function"?this.a=a():this.a=a,this.b=null}i(w){if(this.a){if(typeof this.a!="string"){w(this.a);return}this.b||(this.b=y(this.a,this.e,this.h)),this.b.then(m=>{w(m)},m=>{(0,s.$Y)(m),console.error(m)})}}log(w,m){if(!this.a)return;m=(0,E.$ho)(m,this.g),m=(0,k.$Hp)(m);const $=this.f+"/"+w;try{this.i(a=>{a.pluginVersionString=m?.properties.version??"Unknown",a.track({name:$,baseData:{name:$,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(w=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.$xR=o});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[232],Ae([1,0,2,20,3,16,7,27,45,61,29,37,24,40]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0,o=dt(o);let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,v,g){this.k=v,this.l=g,this.d={},this.i=new t.$Tc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,k.$hf)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$hf)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(m.$im)||b.affectsConfiguration(m.$km)||b.affectsConfiguration(m.$jm))&&this.m()}))}setExperimentProperty(f,v){this.d[f]=v}m(){let f=(0,$.$Gp)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const g=v.usage?m.TelemetryLevel.USAGE:v.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;f=Math.min(f,g)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,v,g){this.g<v||(g=(0,s.$ho)(g,this.d),g=(0,$.$Lp)(g,this.j),g=(0,s.$ho)(g,this.c),this.b.forEach(b=>b.log(f,g)))}publicLog(f,v){this.n(f,m.TelemetryLevel.USAGE,v)}publicLog2(f,v){this.publicLog(f,v)}publicLogError(f,v){this.h&&this.n(f,m.TelemetryLevel.ERROR,v)}publicLogError2(f,v){this.publicLogError(f,v)}};e.$hs=a,e.$hs=a=Be([je(1,A.$_i),je(2,D.$tk)],a);function u(){const d=(0,C.localize)(11197,null,o.default.nameLong),f=o.default.privacyStatementUrl?(0,C.localize)(11199,null,"https://aka.ms/vscode-telemetry",o.default.privacyStatementUrl):(0,C.localize)(11198,null,"https://aka.ms/vscode-telemetry"),v=E.$p?"":(0,C.localize)(11200,null),g=(0,C.localize)(11201,null),b=(0,C.localize)(11202,null),i=(0,C.localize)(11203,null),p=(0,C.localize)(11204,null),n=`
|       | ${g} | ${b} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,C.localize)(11205,null);return`
${d} ${f} ${v}

&nbsp;

${p}
${n}

&nbsp;

${l}
`}w.$ro.as(y.$wo.Configuration).registerConfiguration({id:m.$hm,order:1,type:"object",title:(0,C.localize)(11206,null),properties:{[m.$im]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,C.localize)(11207,null),(0,C.localize)(11208,null),(0,C.localize)(11209,null),(0,C.localize)(11210,null)],markdownDescription:u(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),w.$ro.as(y.$wo.Configuration).registerConfiguration({id:m.$hm,order:110,type:"object",title:(0,C.localize)(11211,null),properties:{[m.$km]:{type:"boolean",markdownDescription:o.default.privacyStatementUrl?(0,C.localize)(11213,null,o.default.nameLong,o.default.privacyStatementUrl):(0,C.localize)(11212,null,o.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(11214,null,`\`#${m.$im}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Re[233],Ae([1,0,27,5,29,24,232,40]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=void 0;let y=class extends C.$hs{constructor(D,w,m,$){super(D,m,$),this.o=w}publicLog(D,w){if(!(this.o<k.TelemetryLevel.USAGE))return super.publicLog(D,w)}publicLog2(D,w){return this.publicLog(D,w)}publicLogError(D,w){return this.o<k.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(D,w)}publicLogError2(D,w){return this.publicLogError(D,w)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this.o=k.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,D):D,this.o===k.TelemetryLevel.NONE&&this.dispose()}};e.$7s=y,e.$7s=y=Be([je(2,t.$_i),je(3,E.$tk)],y),e.$8s=new class extends A.$yp{async updateInjectedTelemetryLevel(){}},e.$9s=(0,s.$Gi)(k.$_l)}),define(Re[234],Ae([1,0,14,18,289,231]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0,E=Ue(E);async function C(D,w){const m=await w.request(D,s.CancellationToken.None),$=(await(0,t.$Ze)(m.stream)).toString(),a=m.res.statusCode??200;return{headers:m.res.headers,statusCode:a,responseData:$}}async function A(D){const w={method:D.type,headers:D.headers};return new Promise(($,a)=>{const u=E.request(D.url??"",w,d=>{d.on("data",function(f){$({headers:d.headers,statusCode:d.statusCode??200,responseData:f.toString()})}),d.on("error",function(f){a(f)})});u.write(D.data,d=>{d&&a(d)}),u.end()})}async function y(D,w,m){const $=typeof w.data=="string"?w.data:new TextDecoder().decode(w.data),a={type:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data).toString()},url:w.urlString,data:$};try{const u=D?await C(a,D):await A(a);m(u.statusCode,u.headers,u.responseData)}catch{m(0,{})}}class o extends k.$xR{constructor(w,m,$,a,u){const d={sendPOST:(f,v)=>{y(w,f,v)}};super(m,$,a,u,d)}}e.$yR=o});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[235],Ae([1,0,9,227]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=dt(s);class E extends s.default{i(){(0,t.setUnexpectedErrorHandler)(A=>console.error(A));const C=[];process.on("unhandledRejection",(A,y)=>{C.push(y),setTimeout(()=>{const o=C.indexOf(y);o>=0&&y.catch(D=>{C.splice(o,1),(0,t.$3)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),A&&(0,t.$Y)(A))})},1e3)}),process.on("rejectionHandled",A=>{const y=C.indexOf(A);y>=0&&C.splice(y,1)}),process.on("uncaughtException",A=>{(0,t.$X)(A)||(0,t.$Y)(A)})}}e.default=E}),define(Re[133],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var t;(function(s){s[s.Replace=1]="Replace",s[s.Append=2]="Append",s[s.Prepend=3]="Prepend"})(t||(e.EnvironmentVariableMutatorType=t={}))}),define(Re[134],Ae([1,0,3,133]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;const E=new Map([[s.EnvironmentVariableMutatorType.Append,"APPEND"],[s.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[s.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(D){this.collections=D,this.a=new Map,this.b=new Map,D.forEach((w,m)=>{this.d(w,m);const $=w.map.entries();let a=$.next();for(;!a.done;){const u=a.value[1],d=a.value[0];let f=this.a.get(d);if(f||(f=[],this.a.set(d,f)),f.length>0&&f[0].type===s.EnvironmentVariableMutatorType.Replace){a=$.next();continue}const v={extensionIdentifier:m,value:u.value,type:u.type,scope:u.scope,variable:u.variable,options:u.options};v.scope||delete v.scope,f.unshift(v),a=$.next()}})}async applyToProcessEnvironment(D,w,m){let $;t.$j&&($={},Object.keys(D).forEach(a=>$[a.toLowerCase()]=a));for(const[a,u]of this.getVariableMap(w)){const d=t.$j&&$[a.toLowerCase()]||a;for(const f of u){const v=m?await m(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case s.EnvironmentVariableMutatorType.Append:D[d]=(D[d]||"")+v;break;case s.EnvironmentVariableMutatorType.Prepend:D[d]=v+(D[d]||"");break;case s.EnvironmentVariableMutatorType.Replace:D[d]=v;break}if(f.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${E.get(f.type)}`;D[g]=(D[g]?D[g]+":":"")+a+"="+this.c(v)}}}}c(D){return D.replaceAll(":","\\x3a")}diff(D,w){const m=new Map,$=new Map,a=new Map;if(D.getVariableMap(w).forEach((u,d)=>{const f=this.getVariableMap(w).get(d),v=A(u,f);v&&m.set(d,v)}),this.getVariableMap(w).forEach((u,d)=>{const f=D.getVariableMap(w).get(d),v=A(u,f);v&&a.set(d,v)}),this.getVariableMap(w).forEach((u,d)=>{const f=D.getVariableMap(w).get(d),v=y(u,f);v&&$.set(d,v)}),!(m.size===0&&$.size===0&&a.size===0))return{added:m,changed:$,removed:a}}getVariableMap(D){const w=new Map;for(const m of this.a.values()){const $=m.filter(a=>C(a,D));$.length>0&&w.set($[0].variable,$)}return w}getDescriptionMap(D){const w=new Map;for(const m of this.b.values()){const $=m.filter(a=>C(a,D,!0));for(const a of $)w.set(a.extensionIdentifier,a.description)}return w}d(D,w){if(!D.descriptionMap)return;const m=D.descriptionMap.entries();let $=m.next();for(;!$.done;){const a=$.value[1],u=$.value[0];let d=this.b.get(u);d||(d=[],this.b.set(u,d));const f={extensionIdentifier:w,scope:a.scope,description:a.description};f.scope||delete f.scope,d.push(f),$=m.next()}}}e.$Ls=k;function C(o,D,w=!1){return o.scope?!!(o.scope.workspaceFolder&&D?.workspaceFolder&&o.scope.workspaceFolder.index===D.workspaceFolder.index):w?D===o.scope:!0}function A(o,D){if(!D)return o;const w=new Set;D.forEach($=>w.add($.extensionIdentifier));const m=[];return o.forEach($=>{w.has($.extensionIdentifier)||m.push($)}),m.length===0?void 0:m}function y(o,D){if(!D)return;const w=new Map;D.forEach($=>w.set($.extensionIdentifier,$));const m=[];return o.forEach($=>{const a=w.get($.extensionIdentifier);a&&($.type!==a.type||$.value!==a.value||$.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&m.push(a)}),m.length===0?void 0:m}}),define(Re[96],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=t,e.$Gs=s,e.$Hs=E,e.$Is=k,e.$Js=C,e.$Ks=A;function t(y){return[...y.entries()]}function s(y){return y?[...y.entries()]:[]}function E(y){return new Map(y)}function k(y){return new Map(y??[])}function C(y){return Array.from(y.entries()).map(o=>[o[0],t(o[1].map),s(o[1].descriptionMap)])}function A(y){return new Map(y.map(o=>[o[0],{map:E(o[1]),descriptionMap:k(o[2])}]))}}),define(Re[236],Ae([1,0,13,18,6,2,11]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;let A=class extends k.$Uc{constructor(o,D){super(),this.h=D,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$le),this.onCreateRequest=this.g.event,this.b=o===void 0?15e3:o,this.B((0,k.$Sc)(()=>{for(const w of this.f.values())(0,k.$Pc)(w)}))}createRequest(o){return new Promise((D,w)=>{const m=++this.a;this.c.set(m,D),this.g.fire({requestId:m,...o});const $=new s.$we;(0,t.$Gh)(this.b,$.token).then(()=>w(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,k.$Sc)(()=>$.cancel())])})}acceptReply(o,D){const w=this.c.get(o);w?(this.c.delete(o),(0,k.$Pc)(this.f.get(o)||[]),this.f.delete(o),w(D)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${o}`)}};e.$ws=A,e.$ws=A=Be([je(1,C.$ak)],A)}),define(Re[52],Ae([1,0,5,41,37]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ps=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$os=void 0,e.$os=new s.$Wj("terminalTabFocusMode",!1,!0);var k;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var C;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var A;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(A||(e.PosixShellType=A={}));var y;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(y||(e.WindowsShellType=y={}));var o;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var D;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(D||(e.TerminalIpcChannels=D={}));var w;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$ps=(0,t.$Fi)("ptyService");var m;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var $;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var u;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(u||(e.LocalReconnectConstants=u={}));var d;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var f;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var v;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(v||(e.ShellIntegrationStatus=v={}));var g;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$qs={Backend:"workbench.contributions.terminal.processBackend"};class b{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(p){const n=this.b(p.remoteAuthority);if(this.a.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this.a.set(n,p)}getTerminalBackend(p){return this.a.get(this.b(p))}b(p){return p?.toLowerCase()??""}}E.$ro.add(e.$qs.Backend,new b),e.$rs=(0,t.$Fi)("localPtyService"),e.$ss=(0,t.$Fi)("terminalLogService")}),define(Re[135],Ae([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=s,e.$bR=E,e.$cR=k,e.$dR=C;function s(A){let y=A;y.includes("\\")&&(y=y.replace(/\\/g,"\\\\"));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return y=y.replace(o,""),`'${y}'`}function E(A,y,o){if(!A)return"";if(!y)return A;y.match(/[\/\\]$/)&&(y=y.slice(0,y.length-1));const D=A.replace(/\\/g,"/").toLowerCase(),w=y.replace(/\\/g,"/").toLowerCase();return D.includes(w)?`~${o}${A.slice(y.length+1)}`:A}function k(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),t.OS===t.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function C(A){return!A.strictEnv}}),define(Re[237],Ae([1,0,56,4,7,81]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=C,e.$ys=o,e.$zs=D,e.$As=w;function C(m,$){const a=[{name:null,description:(0,E.localize)(11164,null)}];return a.push(...m.map(u=>({name:u.profileName,description:A(u)}))),$&&a.push(...$.map(u=>({name:u.title,description:y(u)}))),{values:a.map(u=>u.name),markdownDescriptions:a.map(u=>u.description)}}function A(m){let $=`$(${k.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:t.$5j.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?$+=`
- args: "${m.args}"`:$+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&($+=`
- overrideName: ${m.overrideName}`),m.color&&($+=`
- color: ${m.color}`),m.env&&($+=`
- env: ${JSON.stringify(m.env)}`),$}function y(m){return`$(${k.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:t.$5j.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function o(m,$){if(!m&&!$)return!0;if(typeof m=="string"&&typeof $=="string")return m===$;if(Array.isArray(m)&&Array.isArray($)){if(m.length!==$.length)return!1;for(let a=0;a<m.length;a++)if(m[a]!==$[a])return!1;return!0}return!1}function D(m,$){if(!m&&!$)return!0;if(!m||!$)return!1;if(k.ThemeIcon.isThemeIcon(m)&&k.ThemeIcon.isThemeIcon($))return m.id===$.id&&m.color===$.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof $=="object"&&"light"in $&&"dark"in $){const a=m,u=$;if((s.URI.isUri(a.light)||w(a.light))&&(s.URI.isUri(a.dark)||w(a.dark))&&(s.URI.isUri(u.light)||w(u.light))&&(s.URI.isUri(u.dark)||w(u.dark)))return a.light.path===u.light.path&&a.dark.path===u.dark.path}if(s.URI.isUri(m)&&s.URI.isUri($)||w(m)||w($)){const a=m,u=$;return a.path===u.path&&a.scheme===u.scheme}return!1}function w(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}}),define(Re[238],Ae([1,0,56,3,7,45,37,52,237]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=void 0,e.$Ds=a,e.$Es=d,e.$Bs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Cs={type:"string",enum:Array.from((0,t.$3j)(),f=>f.id),markdownEnumDescriptions:Array.from((0,t.$3j)(),f=>`$(${f.id})`)};const o={args:{description:(0,E.localize)(11165,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(11166,null),type:"boolean"},icon:{description:(0,E.localize)(11167,null),...e.$Cs},color:{description:(0,E.localize)(11168,null),...e.$Bs},env:{markdownDescription:(0,E.localize)(11169,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},D={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(11170,null),type:["string","array"],items:{type:"string"}},...o}},w={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(11171,null),type:["string"],items:{type:"string"}},...o}};function m(f){const v=f===s.Platform.Linux?"linux":f===s.Platform.Mac?"osx":"windows";return(0,E.localize)(11172,null,(0,s.$i)(f),'```json\n"terminal.integrated.profile.'+v+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const $={id:"terminal",order:100,title:(0,E.localize)(11173,null),type:"object",properties:{[A.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(11174,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(11175,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11176,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:m(s.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(11177,null),enum:["PowerShell","Git Bash"]},...o}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11178,null),type:"string"},id:{description:(0,E.localize)(11179,null),type:"string"},title:{description:(0,E.localize)(11180,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:m(s.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11181,null),type:"string"},id:{description:(0,E.localize)(11182,null),type:"string"},title:{description:(0,E.localize)(11183,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:m(s.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(11184,null),type:"string"},id:{description:(0,E.localize)(11185,null),type:"string"},title:{description:(0,E.localize)(11186,null),type:"string"},...o}},{type:"null"},D]}},[A.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(11187,null),type:"boolean",default:!0},[A.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,E.localize)(11188,null),type:"boolean",default:!0},[A.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(11189,null),type:"number",default:100},[A.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,E.localize)(11190,null),type:"boolean",default:!0},[A.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(11191,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){C.$ro.as(k.$wo.Configuration).registerConfiguration($),d()}let u;function d(f,v){const g=C.$ro.as(k.$wo.Configuration);let b;f&&(b=(0,y.$xs)(f?.profiles,v));const i=u;u={id:"terminal",order:100,title:(0,E.localize)(11192,null),type:"object",properties:{[A.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(11193,null),type:["string","null"],default:null,enum:f?.os===s.OperatingSystem.Linux?b?.values:void 0,markdownEnumDescriptions:f?.os===s.OperatingSystem.Linux?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(11194,null),type:["string","null"],default:null,enum:f?.os===s.OperatingSystem.Macintosh?b?.values:void 0,markdownEnumDescriptions:f?.os===s.OperatingSystem.Macintosh?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11195,null),type:["string","null"],default:null,enum:f?.os===s.OperatingSystem.Windows?b?.values:void 0,markdownEnumDescriptions:f?.os===s.OperatingSystem.Windows?b?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[u],remove:i?[i]:[]})}}),define(Re[239],Ae([1,0,2,12,115,28,117]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0;let A=class extends t.$Uc{constructor(o,D){super(),this.a=o,this.b=D}start(){const o={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:s.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},D=(0,C.$0m)(this.b.args,this.b.isBuilt);D&&(D.break&&D.port?o.debugBrk=D.port:!D.break&&D.port&&(o.debug=D.port));const w=new E.$ir(s.$Zg.asFileUri("bootstrap-fork").fsPath,o),m=new t.$Tc;return m.add(w),{client:w,store:m,onDidProcessExit:w.onDidProcessExit}}};e.$SR=A,e.$SR=A=Be([je(1,k.$Mi)],A)}),define(Re[240],Ae([1,0,32,12,20,8,3,31,16,10,26,133,96,134]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=a,e.$Ns=u,e.$Os=d,t=Ue(t),k=Ue(k),A=Ue(A),D=Ue(D);function a(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(t.release());let S=0;return c&&c.length===4&&(S=parseInt(c[3])),S}async function u(c,S,I,R=A.env,L=D.Promises.exists){if(k.$ic(c))return await L(c)?c:void 0;if(S===void 0&&(S=A.cwd()),k.$mc(c)!=="."){const K=k.$jc(S,c);return await L(K)?K:void 0}const P=(0,E.$lo)(R,"PATH");if(I===void 0&&(0,o.$eg)(P)&&(I=P.split(k.$tc)),I===void 0||I.length===0){const K=k.$jc(S,c);return await L(K)?K:void 0}for(const K of I){let J;if(k.$ic(K)?J=k.$jc(K,c):J=k.$jc(S,K,c),await L(J))return J;if(C.$j){let _=J+".com";if(await L(_)||(_=J+".exe",await L(_)))return _}}const q=k.$jc(S,c);return await L(q)?q:void 0}function d(c,S,I,R,L){const O=C.$j&&(!S.windowsEnableConpty||a()<18309);if(!S.shellIntegration.enabled||!c.executable||c.isFeatureTerminal&&!c.forceShellIntegration||c.ignoreShellIntegration||O)return;const P=c.args,q=A.$dc==="win32"?k.$nc(c.executable).toLowerCase():k.$nc(c.executable),K=k.$mc(s.$Zg.asFileUri("").fsPath);let J;const _={VSCODE_INJECTION:"1"};if(S.shellIntegration.nonce&&(_.VSCODE_NONCE=S.shellIntegration.nonce),C.$j){if(q==="pwsh.exe"||q==="powershell.exe")return!P||r(P)?J=g.get(v.WindowsPwsh):l(P)&&(J=g.get(v.WindowsPwshLogin)),J?(J=[...J],J[J.length-1]=(0,y.$df)(J[J.length-1],K,""),_.VSCODE_STABLE=L.quality==="stable"?"1":"0",S.shellIntegration.suggestEnabled&&(_.VSCODE_SUGGEST="1"),{newArgs:J,envMixin:_}):void 0;if(q==="bash.exe")return!P||P.length===0?J=g.get(v.Bash):h(P)&&(_.VSCODE_SHELL_LOGIN="1",f(S,_),J=g.get(v.Bash)),J?(J=[...J],J[J.length-1]=(0,y.$df)(J[J.length-1],K),_.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:J,envMixin:_}):void 0;R.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args);return}switch(q){case"bash":return!P||P.length===0?J=g.get(v.Bash):h(P)&&(_.VSCODE_SHELL_LOGIN="1",f(S,_),J=g.get(v.Bash)),J?(J=[...J],J[J.length-1]=(0,y.$df)(J[J.length-1],K),_.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:J,envMixin:_}):void 0;case"fish":{const de=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ge=k.$jc(K,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return _.XDG_DATA_DIRS=`${de}:${ge}`,f(S,_),{newArgs:void 0,envMixin:_}}case"pwsh":return!P||r(P)?J=g.get(v.Pwsh):l(P)&&(J=g.get(v.PwshLogin)),J?(S.shellIntegration.suggestEnabled&&(_.VSCODE_SUGGEST="1"),J=[...J],J[J.length-1]=(0,y.$df)(J[J.length-1],K,""),_.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:J,envMixin:_}):void 0;case"zsh":{if(!P||P.length===0?J=g.get(v.Zsh):h(P)?(J=g.get(v.ZshLogin),f(S,_)):(P===g.get(v.Zsh)||P===g.get(v.ZshLogin))&&(J=P),!J)return;J=[...J],J[J.length-1]=(0,y.$df)(J[J.length-1],K);let de;try{de=t.userInfo().username}catch{de="unknown"}const ge=k.$jc(t.tmpdir(),`${de}-${L.applicationName}-zsh`);_.ZDOTDIR=ge;const le=I?.ZDOTDIR??t.homedir()??"~";_.USER_ZDOTDIR=le;const z=[];return z.push({source:k.$jc(K,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.$jc(ge,".zshrc")}),z.push({source:k.$jc(K,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.$jc(ge,".zprofile")}),z.push({source:k.$jc(K,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.$jc(ge,".zshenv")}),z.push({source:k.$jc(K,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.$jc(ge,".zlogin")}),{newArgs:J,envMixin:_,filesToCopy:z}}}R.warn(`Shell integration cannot be enabled for executable "${c.executable}" and args`,c.args)}function f(c,S){if(C.$k&&c.environmentVariableCollections){const I=(0,m.$Ks)(c.environmentVariableCollections),L=new $.$Ls(I).getVariableMap({workspaceFolder:c.workspaceFolder}).get("PATH"),O=[];if(L)for(const P of L)P.type===w.EnvironmentVariableMutatorType.Prepend&&O.push(P.value);O.length>0&&(S.VSCODE_PATH_PREFIX=O.join(""))}}var v;(function(c){c.WindowsPwsh="windows-pwsh",c.WindowsPwshLogin="windows-pwsh-login",c.Pwsh="pwsh",c.PwshLogin="pwsh-login",c.Zsh="zsh",c.ZshLogin="zsh-login",c.Bash="bash"})(v||(v={}));const g=new Map;g.set(v.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(v.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(v.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(v.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(v.Zsh,["-i"]),g.set(v.ZshLogin,["-il"]),g.set(v.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],i=["--login","-l"],p=["-i","--interactive"],n=["-nol","-nologo"];function l(c){return typeof c=="string"?b.includes(c.toLowerCase()):c.length===1&&b.includes(c[0].toLowerCase())||c.length===2&&(b.includes(c[0].toLowerCase())||b.includes(c[1].toLowerCase()))&&(n.includes(c[0].toLowerCase())||n.includes(c[1].toLowerCase()))}function r(c){return typeof c=="string"?n.includes(c.toLowerCase()):c.length===0||c?.length===1&&n.includes(c[0].toLowerCase())}function h(c){return typeof c!="string"&&(c=c.filter(S=>!p.includes(S.toLowerCase()))),c==="string"&&i.includes(c.toLowerCase())||typeof c!="string"&&c.length===1&&i.includes(c[0].toLowerCase())}}),define(Re[241],Ae([1,0,23,59,56,8,3,10,26,111,52,240,83]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=d,t=Ue(t),s=Ue(s),y=Ue(y);var $;(function(I){I.UnixShellsPath="/etc/shells"})($||($={}));let a,u=!0;function d(I,R,L,O,P=process.env,q,K,J,_){return q=q||{existsFile:y.SymlinkSupport.existsFile,readFile:t.promises.readFile},C.$j?f(L,q,P,K,O.getValue(D.TerminalSettingId.UseWslProfiles)!==!1,I&&typeof I=="object"?{...I}:O.getValue(D.TerminalSettingId.ProfilesWindows),typeof R=="string"?R:O.getValue(D.TerminalSettingId.DefaultProfileWindows),_,J):h(q,K,L,I&&typeof I=="object"?{...I}:O.getValue(C.$l?D.TerminalSettingId.ProfilesLinux:D.TerminalSettingId.ProfilesMacOs),typeof R=="string"?R:O.getValue(C.$l?D.TerminalSettingId.DefaultProfileLinux:D.TerminalSettingId.DefaultProfileMacOs),_,J,P)}async function f(I,R,L,O,P,q,K,J,_){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ge=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let le=!1;(0,w.$Ms)()>=16299&&(le=!0),await i(J);const z=new Map;if(I){z.set("PowerShell",{source:D.ProfileSource.Pwsh,icon:E.$5j.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${ge}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$5j.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:D.ProfileSource.GitBash,isAutoDetected:!0}),z.set("Command Prompt",{path:`${ge}\\cmd.exe`,icon:E.$5j.terminalCmd,isAutoDetected:!0}),z.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),z.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$5j.terminalBash,isAutoDetected:!0});const M=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;z.set("Cmder",{path:`${ge}\\cmd.exe`,args:["/K",M],requiresPath:process.env.CMDER_ROOT?M:{path:M,isUnsafe:!0},isAutoDetected:!0})}c(q,z);const Q=await v(z.entries(),K,R,L,O,_);if(I&&P)try{const M=await l(`${ge}\\${le?"wsl":"bash"}.exe`,K);for(const V of M)(!q||!(V.profileName in q))&&Q.push(V)}catch{u&&(O?.trace("WSL is not installed, so could not detect WSL profiles"),u=!1)}return Q}async function v(I,R,L,O=process.env,P,q){const K=[];for(const[J,_]of I)K.push(g(J,_,R,L,O,P,q));return(await Promise.all(K)).filter(J=>!!J)}async function g(I,R,L,O,P=process.env,q,K){if(R===null)return;let J,_,de;if("source"in R&&!("path"in R)){const Q=a?.get(R.source);if(!Q)return;J=Q.paths,_=R.args||Q.args,R.icon?de=b(R.icon):Q.icon&&(de=Q.icon)}else J=Array.isArray(R.path)?R.path:[R.path],_=C.$j||Array.isArray(R.args)?R.args:void 0,de=b(R.icon);let ge;if(K){const Q=J.map(V=>typeof V=="string"?V:V.path),M=await K(Q);ge=new Array(J.length);for(let V=0;V<J.length;V++)typeof J[V]=="string"?ge[V]=M[V]:ge[V]={path:M[V],isUnsafe:!0}}else ge=J.slice();let le;if(R.requiresPath){let Q;if((0,A.$eg)(R.requiresPath)?Q=R.requiresPath:(Q=R.requiresPath.path,R.requiresPath.isUnsafe&&(le=Q)),!await O.existsFile(Q))return}const z=await S(I,L,ge,O,P,_,R.env,R.overrideName,R.isAutoDetected,le);if(!z){q?.debug("Terminal profile not validated",I,J);return}return z.isAutoDetected=R.isAutoDetected,z.icon=de,z.color=R.color,z}function b(I){return typeof I=="string"?{id:I}:I}async function i(I){if(a&&!I)return;const[R,L]=await Promise.all([p(),I||n()]);a=new Map,a.set(D.ProfileSource.GitBash,{profileName:"Git Bash",paths:R,args:["--login","-i"]}),a.set(D.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:E.$5j.terminalPowershell})}async function p(){const I=new Set,R=await(0,w.$Ns)("git.exe");if(R){const P=(0,m.dirname)(R);I.add((0,m.resolve)(P,"../.."))}function L(P,q){q&&P.add(q)}L(I,process.env.ProgramW6432),L(I,process.env.ProgramFiles),L(I,process.env["ProgramFiles(X86)"]),L(I,`${process.env.LocalAppData}\\Program`);const O=[];for(const P of I)O.push(`${P}\\Git\\bin\\bash.exe`,`${P}\\Git\\usr\\bin\\bash.exe`,`${P}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function n(){const I=[];for await(const R of(0,o.$wm)())I.push(R.exePath);return I}async function l(I,R){const L=[],O=await new Promise((K,J)=>{s.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,de)=>{if(_)return J("Problem occurred when getting wsl distros");K(de)})});if(!O)return[];const P=new RegExp(/[\r?\n]/),q=O.split(P).filter(K=>K.trim().length>0&&K!=="");for(const K of q){if(K===""||K.startsWith("docker-desktop"))continue;const J=`${K} (WSL)`,_={profileName:J,path:I,args:["-d",`${K}`],isDefault:J===R,icon:r(K),isAutoDetected:!1};L.push(_)}return L}function r(I){return I.includes("Ubuntu")?E.$5j.terminalUbuntu:I.includes("Debian")?E.$5j.terminalDebian:E.$5j.terminalLinux}async function h(I,R,L,O,P,q,K,J){const _=new Map;if(L&&await I.existsFile($.UnixShellsPath)){const de=(await I.readFile($.UnixShellsPath)).toString(),ge=(q||de.split(`
`)).map(z=>{const Q=z.indexOf("#");return Q===-1?z:z.substring(0,Q)}).filter(z=>z.trim().length>0),le=new Map;for(const z of ge){let Q=(0,k.$nc)(z),M=le.get(Q)||0;M++,M>1&&(Q=`${Q} (${M})`),le.set(Q,M),_.set(Q,{path:z,isAutoDetected:!0})}}return c(O,_),await v(_.entries(),P,I,J,R,K)}function c(I,R){if(I)for(const[L,O]of Object.entries(I))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?R.delete(L):(O.icon=O.icon||R.get(L)?.icon,R.set(L,O))}async function S(I,R,L,O,P,q,K,J,_,de){if(L.length===0)return Promise.resolve(void 0);const ge=L.shift();if(ge==="")return S(I,R,L,O,P,q,K,J,_);const le=typeof ge!="string"&&ge.isUnsafe,z=typeof ge=="string"?ge:ge.path,Q={profileName:I,path:z,args:q,env:K,overrideName:J,isAutoDetected:_,isDefault:I===R,isUnsafePath:le,requiresUnsafePath:de};if((0,k.$nc)(z)===z){const V=P.PATH?P.PATH.split(k.$tc):void 0,ne=await(0,w.$Ns)(z,void 0,V,void 0,O.existsFile);return ne?(Q.path=ne,Q.isFromPath=!0,Q):S(I,R,L,O,P,q)}return await O.existsFile((0,k.$hc)(z))?Q:S(I,R,L,O,P,q,K,J,_)}}),define(Re[242],Ae([1,0,6,2,3,49,27,11,123,93,236,52,238,241,114,47]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;var d;(function(v){v[v.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let f=class extends s.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(g,b,i,p){super(),this.M=g,this.N=b,this.O=i,this.P=p,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new t.$le),this.onPtyHostExit=this.u.event,this.w=this.B(new t.$le),this.onPtyHostStart=this.w.event,this.y=this.B(new t.$le),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new t.$le),this.onPtyHostResponsive=this.z.event,this.C=this.B(new t.$le),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new t.$le),this.onProcessData=this.D.event,this.F=this.B(new t.$le),this.onProcessReady=this.F.event,this.G=this.B(new t.$le),this.onProcessReplay=this.G.event,this.H=this.B(new t.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new t.$le),this.onDidRequestDetach=this.I.event,this.J=this.B(new t.$le),this.onDidChangeProperty=this.J.event,this.L=this.B(new t.$le),this.onProcessExit=this.L.event,(0,m.$Ds)(),this.B(this.M),this.B((0,s.$Sc)(()=>this.W())),this.j=this.B(new D.$ws(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(t.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(w.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$j)return process.env;try{return await(0,o.$Rm)(this.N,this.O,{_:[]},process.env)}catch(g){return this.O.error("ptyHost was unable to resolve shell environment",g),{}}}U(){const g=this.M.start(),b=g.client;this.O.getLevel()===A.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(b.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(g.onDidProcessExit(n=>{this.u.fire(n.code),!this.m&&!this.q.isDisposed&&(this.n<=d.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${n.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const p=k.ProxyChannel.toService(b.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(p.onProcessData(n=>this.D.fire(n))),this.B(p.onProcessReady(n=>this.F.fire(n))),this.B(p.onProcessExit(n=>this.L.fire(n))),this.B(p.onDidChangeProperty(n=>this.J.fire(n))),this.B(p.onProcessReplay(n=>this.G.fire(n))),this.B(p.onProcessOrphanQuestion(n=>this.H.fire(n))),this.B(p.onDidRequestDetach(n=>this.I.fire(n))),this.B(new y.$vs(this.P,b.getChannel(w.TerminalIpcChannels.Logger))),this.a=g,this.b=p,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async n=>{n.affectsConfiguration(w.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[g,p]}async createProcess(g,b,i,p,n,l,r,h,c,S,I){const R=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(g,b,i,p,n,l,r,h,c,S,I);return clearTimeout(R),L}updateTitle(g,b,i){return this.f.updateTitle(g,b,i)}updateIcon(g,b,i,p){return this.f.updateIcon(g,b,i,p)}attachToProcess(g){return this.f.attachToProcess(g)}detachFromProcess(g,b){return this.f.detachFromProcess(g,b)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(g){return this.f.start(g)}shutdown(g,b){return this.f.shutdown(g,b)}input(g,b){return this.f.input(g,b)}processBinary(g,b){return this.f.processBinary(g,b)}resize(g,b,i){return this.f.resize(g,b,i)}clearBuffer(g){return this.f.clearBuffer(g)}acknowledgeDataEvent(g,b){return this.f.acknowledgeDataEvent(g,b)}setUnicodeVersion(g,b){return this.f.setUnicodeVersion(g,b)}getInitialCwd(g){return this.f.getInitialCwd(g)}getCwd(g){return this.f.getCwd(g)}async getLatency(){const g=new u.$fe,b=await this.f.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...b]}orphanQuestionReply(g){return this.f.orphanQuestionReply(g)}installAutoReply(g,b){return this.f.installAutoReply(g,b)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(g){return this.f.uninstallAutoReply(g)}getDefaultSystemShell(g){return this.g?.getDefaultSystemShell(g)??(0,a.$Am)(g??E.OS,process.env)}async getProfiles(g,b,i,p=!1){const n=await this.S();return(0,$.$Ps)(b,i,p,this.N,n,void 0,this.O,this.bb.bind(this,g))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(g,b){return this.f.getWslPath(g,b)}getRevivedPtyNewId(g,b){return this.f.getRevivedPtyNewId(g,b)}setTerminalLayoutInfo(g){return this.f.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this.g?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,b){return this.f.requestDetachInstance(g,b)}async acceptDetachInstanceReply(g,b){return this.f.acceptDetachInstanceReply(g,b)}async freePortKillProcess(g){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(g)}async serializeTerminalState(g){return this.f.serializeTerminalState(g)}async reviveTerminalProcesses(g,b,i){return this.f.reviveTerminalProcesses(g,b,i)}async refreshProperty(g,b){return this.f.refreshProperty(g,b)}async updateProperty(g,b,i){return this.f.updateProperty(g,b,i)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(g){this.ab(),this.s=setTimeout(()=>this.Y(),g?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(g,b){return this.j.createRequest({workspaceId:g,originalText:b})}async acceptPtyHostResolvedVariables(g,b){this.j.acceptReply(g,b)}};e.$Qs=f,e.$Qs=f=Be([je(1,C.$_i),je(2,A.$ak),je(3,A.$bk)],f)}),define(Re[35],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,t.$Fi)("IUriIdentityService")}),define(Re[136],Ae([1,0,35,119,15,19,168,6,2]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class o{static{this._clock=0}constructor(m){this.uri=m,this.time=o._clock++}touch(){return this.time=o._clock++,this}}let D=class{constructor(m){this.g=m,this.c=new y.$Tc,this.f=2**16;const $=new Map,a=u=>{let d=$.get(u.scheme);return d===void 0&&(d=m.hasProvider(u)&&!this.g.hasCapability(u,E.FileSystemProviderCapabilities.PathCaseSensitive),$.set(u.scheme,d)),d};this.c.add(A.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(u=>{$.delete(u.scheme)})),this.extUri=new k.$8g(a),this.d=new C.$Ts((u,d)=>this.extUri.compare(u,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.$hh)(m));const $=this.d.get(m);return $?$.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new o(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((a,u)=>a[1].time<u[1].time?1:a[1].time>u[1].time?-1:0);o._clock=0,this.d.clear();const $=this.f*.5;for(let a=0;a<$;a++)this.d.set(m[a][0],m[a][1].touch())}};e.$Us=D,e.$Us=D=Be([je(0,E.$al)],D),(0,s.$Rs)(t.$Kl,D,s.InstantiationType.Delayed)}),define(Re[97],Ae([1,0,7,8,68,19,4,5,12]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=o,e.$Qi=D,e.$Ti=w,e.$Ui=m,e.$Vi=$,e.$Wi=u,e.$Xi=d,e.$1i=g,e.$6i=b,e.$7i=i,e.$9i=p,e.$0i=n,e.$$i=l,e.$Oi=(0,A.$Fi)("contextService");function o(r){const h=r;return typeof h?.id=="string"&&C.URI.isUri(h.uri)}function D(r){return typeof r?.id=="string"&&!o(r)&&!m(r)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function w(r,h){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,s.$nc)(r)}:h?e.$Ri:e.$Si;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}function m(r){const h=r;return typeof h?.id=="string"&&C.URI.isUri(h.configPath)}function $(r){const h=r;if(h?.uri)return{id:h.id,uri:C.URI.revive(h.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}var a;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function u(r){const h=r;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function d(r){const h=r;return!!(h&&typeof h=="object"&&C.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class f{constructor(h,c,S,I,R){this.h=h,this.j=S,this.k=I,this.l=R,this.c=E.$Li.forUris(this.l,()=>!0),this.folders=c}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=E.$Li.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=f;class v{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,k.$gh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=v;function g(r){return new v({uri:r,index:0,name:(0,k.$ch)(r)},{uri:r.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,t.localize)(11030,null),extensions:[e.$2i]}],e.$5i="workspace.json";function b(r,h){return k.$0g.isEqualOrParent(r,h.untitledWorkspacesHome)}function i(r){let h;return C.URI.isUri(r)?h=r:h=r.configuration,h?.scheme===y.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function p(r){return r.id===e.$8i}function n(r,h){return!b(r,h)&&!i(r)}function l(r){return(typeof r=="string"?(0,s.$oc)(r):(0,k.$eh)(r))===e.$3i}}),define(Re[33],Ae([1,0,67,6,2,19,4,7,28,15,5,11,97,25,35,13,22,16,10]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=b,e.$Nl=i,e.$Ol=p;var g;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function b(r){const h=r;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&C.URI.isUri(h.location)&&C.URI.isUri(h.globalStorageHome)&&C.URI.isUri(h.settingsResource)&&C.URI.isUri(h.keybindingsResource)&&C.URI.isUri(h.tasksResource)&&C.URI.isUri(h.snippetsHome)&&C.URI.isUri(h.extensionsResource))}e.$Ml=(0,D.$Fi)("IUserDataProfilesService");function i(r,h){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:C.URI.revive(r.location).with({scheme:h}),globalStorageHome:C.URI.revive(r.globalStorageHome).with({scheme:h}),settingsResource:C.URI.revive(r.settingsResource).with({scheme:h}),keybindingsResource:C.URI.revive(r.keybindingsResource).with({scheme:h}),tasksResource:C.URI.revive(r.tasksResource).with({scheme:h}),snippetsHome:C.URI.revive(r.snippetsHome).with({scheme:h}),extensionsResource:C.URI.revive(r.extensionsResource).with({scheme:h}),cacheHome:C.URI.revive(r.cacheHome).with({scheme:h}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function p(r,h,c,S,I,R){return{id:r,name:h,location:c,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:R&&I?.useDefaultFlags?.globalState?R.globalStorageHome:(0,k.$gh)(c,"globalStorage"),settingsResource:R&&I?.useDefaultFlags?.settings?R.settingsResource:(0,k.$gh)(c,"settings.json"),keybindingsResource:R&&I?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,k.$gh)(c,"keybindings.json"),tasksResource:R&&I?.useDefaultFlags?.tasks?R.tasksResource:(0,k.$gh)(c,"tasks.json"),snippetsHome:R&&I?.useDefaultFlags?.snippets?R.snippetsHome:(0,k.$gh)(c,"snippets"),extensionsResource:R&&I?.useDefaultFlags?.extensions?R.extensionsResource:(0,k.$gh)(c,"extensions.json"),cacheHome:(0,k.$gh)(S,r),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let n=class extends E.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,c,S,I){super(),this.t=h,this.u=c,this.w=S,this.y=I,this.f=!0,this.h=this.B(new s.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new s.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new s.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new s.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Ac,workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,k.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),c=[h];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,v.$eg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}c.push(p((0,k.$dh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},h))}}catch(R){this.y.error(R)}const S=new $.$Ac,I=new Map;if(c.length)try{const R=this.Q();if(R.workspaces)for(const[L,O]of Object.entries(R.workspaces)){const P=C.URI.parse(L),q=c.find(K=>K.id===O);q&&S.set(P,q)}if(R.emptyWindows)for(const[L,O]of Object.entries(R.emptyWindows)){const P=c.find(q=>q.id===O);P&&I.set(L,P)}}catch(R){this.y.error(R)}this.z={profiles:c,workspaces:S,emptyWindows:I}}return this.z}D(){const h=p("__default__profile__",(0,A.localize)(11077,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const c="Temp",S=new RegExp(`${(0,f.$hf)(c)}\\s(\\d+)`);let I=0;for(const L of this.profiles){const O=S.exec(L.name),P=O?parseInt(O[1]):0;I=P>I?P:I}const R=`${c} ${I+1}`;return this.createProfile((0,t.$tj)((0,d.$2g)()).toString(16),R,{transient:!0},h)}async createNamedProfile(h,c,S){return this.createProfile((0,t.$tj)((0,d.$2g)()).toString(16),h,c,S)}async createProfile(h,c,S,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(h,c,S);return I&&await this.setProfileForWorkspace(I,R),R}async F(h,c,S){if(!(0,v.$eg)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(c);return I||(I=(async()=>{try{if(this.profiles.find(P=>P.name===c||P.id===h))throw new Error(`Profile with ${c} name already exists`);const L=p(h,c,(0,k.$gh)(this.profilesHome,h),this.g,S,this.defaultProfile);await this.u.createFolder(L.location);const O=[];return this.j.fire({profile:L,join(P){O.push(P)}}),await u.Promises.settled(O),this.I([L],[],[]),L}finally{this.r.delete(c)}})(),this.r.set(c,I)),I}async updateProfile(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(I=>I.id===h.id);if(!S)throw new Error(`Profile '${h.name}' does not exist`);return S=p(S.id,c.name??S.name,S.location,this.g,{shortName:c.shortName??S.shortName,icon:c.icon===null?void 0:c.icon??S.icon,transient:c.transient??S.isTransient,useDefaultFlags:c.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(I=>I.id===h.id);if(!c)throw new Error(`Profile '${h.name}' does not exist`);const S=[];this.m.fire({profile:c,join(I){S.push(I)}});try{await Promise.allSettled(S)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(I){(0,o.$rl)(I)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(I)}}async setProfileForWorkspace(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(I=>I.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);this.L(h,S)}unsetWorkspace(h,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,c)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(c=>c.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(h.map(c=>this.removeProfile(c)))}getProfileForWorkspace(h){const c=this.G(h),S=C.URI.isUri(c)?this.C.workspaces.get(c):this.C.emptyWindows.get(c);return S||((0,m.$Pi)(h)?this.s.folders.get(h.uri):(0,m.$Ui)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,m.$Pi)(h)?h.uri:(0,m.$Ui)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,h.location))||[...this.s.folders.values()].some(c=>this.w.extUri.isEqual(c.location,h.location)))}I(h,c,S){const I=[...this.profiles,...h],R=[],L=this.s.profiles;this.s.profiles=[];for(let O of I){if(O.isDefault||c.some(q=>O.id===q.id))continue;O=S.find(q=>O.id===q.id)??O;const P=L.find(q=>O.id===q.id);if(O.isTransient)this.s.profiles.push(O);else{if(P){for(const[q,K]of this.s.emptyWindows.entries())if(O.id===K.id){this.L({id:q},O);break}for(const[q,K]of this.s.workspaces.entries())if(O.id===K.id){this.L({id:"",configPath:q},O);break}for(const[q,K]of this.s.folders.entries())if(O.id===K.id){this.L({id:"",uri:q},O);break}}R.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(h,c,S)}J(h,c,S){this.h.fire({added:h,removed:c,updated:S,all:this.profiles})}L(h,c,S){if(S=c?.isTransient?!0:S,S)(0,m.$Pi)(h)?(this.s.folders.delete(h.uri),c&&this.s.folders.set(h.uri,c)):(0,m.$Ui)(h)?(this.s.workspaces.delete(h.configPath),c&&this.s.workspaces.set(h.configPath,c)):(this.s.emptyWindows.delete(h.id),c&&this.s.emptyWindows.set(h.id,c));else{this.L(h,void 0,!0);const I=this.G(h);C.URI.isUri(I)?(this.C.workspaces.delete(I),c&&this.C.workspaces.set(I,c)):(this.C.emptyWindows.delete(I),c&&this.C.emptyWindows.set(I,c)),this.M()}}M(){const h={};for(const[S,I]of this.C.workspaces.entries())h[S.toString()]=I.id;const c={};for(const[S,I]of this.C.emptyWindows.entries())c[S.toString()]=I.id;this.R({workspaces:h,emptyWindows:c}),this.z=void 0}N(h){const c={},S=this.D();if(h.workspaces)for(const[R,L]of Object.entries(h.workspaces)){const O=C.URI.parse(L);c[R]=this.w.extUri.isEqual(O,S.location)?S.id:this.w.extUri.basename(O)}const I={};if(h.emptyWindows)for(const[R,L]of Object.entries(h.emptyWindows)){const O=C.URI.parse(L);I[R]=this.w.extUri.isEqual(O,S.location)?S.id:this.w.extUri.basename(O)}return{workspaces:c,emptyWindows:I}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Pl=n,e.$Pl=n=Be([je(0,y.$Mi),je(1,o.$al),je(2,a.$Kl),je(3,w.$ak)],n);class l extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Ql=l}),define(Re[98],Ae([1,0,17,13,18,9,6,2,25,3,10,4,7,30,38,21,73,11,29,24,35,33]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Fq=void 0,e.$Gq=n,m=Ue(m);let p=class extends A.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(c,S,I,R,L,O){super(),this.z=c,this.C=S,this.D=I,this.F=R,this.G=L,this.H=O,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new C.$le),this.s=this.B(new C.$le),this.t=this.B(new C.$le),this.u=this.B(new C.$le),this.w=this.B(new C.$le),this.y=[],this.B((0,A.$Sc)(()=>{this.j.forEach(({task:P})=>P.cancel()),this.m.forEach(P=>P.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(c){const S=await this.getTargetPlatform();return c.allTargetPlatforms.some(I=>(0,$.$jp)(I,c.allTargetPlatforms,S))}async installFromGallery(c,S={}){try{const R=(await this.installGalleryExtensions([{extension:c,options:S}])).find(({identifier:L})=>(0,a.$Mp)(L,c.identifier));if(R?.local)return R?.local;throw R?.error?R.error:new $.$np(`Unknown error while installing extension ${c.identifier.id}`,$.ExtensionManagementErrorCode.Unknown)}catch(I){throw n(I)}}async installGalleryExtensions(c){if(!this.z.isEnabled())throw new $.$np(m.localize(11503,null),$.ExtensionManagementErrorCode.NotAllowed);const S=[],I=[];return await Promise.allSettled(c.map(async({extension:R,options:L})=>{try{const O=await this.N(R,!!L?.installGivenVersion,!!L?.installPreReleaseVersion,L.productVersion??{version:this.G.version,date:this.G.date});I.push({...O,options:L})}catch(O){S.push({identifier:R.identifier,operation:$.InstallOperation.Install,source:R,error:O,profileLocation:L.profileLocation??this.W()})}})),I.length&&S.push(...await this.I(I)),S}async uninstall(c,S){return this.F.trace("ExtensionManagementService#uninstall",c.identifier.id),this.uninstallExtensions([{extension:c,options:S}])}async toggleAppliationScope(c,S){if((0,u.$un)(c.manifest)||c.isBuiltin)return c;if(c.isApplicationScoped){let I=await this.updateMetadata(c,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(S,this.H.defaultProfile.extensionsResource)||(I=await this.Z(c,this.H.defaultProfile.extensionsResource,S));for(const R of this.H.profiles){const L=(await this.getInstalled(u.ExtensionType.User,R.extensionsResource)).find(O=>(0,a.$Mp)(O.identifier,c.identifier));L?this.w.fire({local:L,profileLocation:R.extensionsResource}):this.u.fire({identifier:c.identifier,profileLocation:R.extensionsResource})}return I}else{const I=this.D.extUri.isEqual(S,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(c,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(c,S,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:I.identifier,operation:$.InstallOperation.Install,local:I,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),I}}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.g||c-this.h>1e3*60*5)&&(this.g=this.U(),this.h=c),this.g}registerParticipant(c){this.y.push(c)}async resetPinnedStateForAllUserExtensions(c){try{await this.L(this.H.profiles.map(async S=>{const I=await this.getInstalled(u.ExtensionType.User,S.extensionsResource);await this.L(I.map(async R=>{R.pinned!==c&&await this.updateMetadata(R,{pinned:c},S.extensionsResource)}))}))}catch(S){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$9)(S)),S}}async I(c){const S=new Map,I=new Map,R=[],L=(P,q)=>`${a.$Np.create(P).toString()}-${q.toString()}`,O=(P,q,K,J)=>{const _=this.X(P,q,K),de=`${(0,a.$Rp)(P.publisher,P.name)}-${K.profileLocation.toString()}`;I.set(de,{task:_,root:J}),this.n.fire({identifier:_.identifier,source:q,profileLocation:K.profileLocation}),this.F.info("Installing extension:",_.identifier.id,K),w.URI.isUri(q)||this.j.set(L(q,K.profileLocation),{task:_,waitingTasks:[]})};try{for(const{manifest:P,extension:q,options:K}of c){const J=K.isApplicationScoped||K.isBuiltin||(0,u.$un)(P),_={...K,installOnlyNewlyAddedFromExtensionPack:K.installOnlyNewlyAddedFromExtensionPack??!w.URI.isUri(q),isApplicationScoped:J,profileLocation:J?this.H.defaultProfile.extensionsResource:K.profileLocation??this.W(),productVersion:K.productVersion??{version:this.G.version,date:this.G.date}},de=w.URI.isUri(q)?void 0:this.j.get(L(q,_.profileLocation));de?(this.F.info("Extension is already requested to install",de.task.identifier.id,_.profileLocation.toString()),R.push(de.task.waitUntilTaskIsFinished())):O(P,q,_,void 0)}return await Promise.all([...I.values()].map(async({task:P})=>{if(P.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const q=await this.M(P.identifier,P.manifest,!!P.options.installOnlyNewlyAddedFromExtensionPack,!!P.options.installPreReleaseVersion,P.options.profileLocation,P.options.productVersion),K=await this.getInstalled(void 0,P.options.profileLocation,P.options.productVersion),J={...P.options,context:{...P.options.context,[$.$dp]:!0}};for(const{gallery:_,manifest:de}of(0,t.$Lb)(q,({gallery:ge})=>ge.identifier.id)){if(I.has(`${_.identifier.id.toLowerCase()}-${J.profileLocation.toString()}`))continue;const ge=this.j.get(L(_,J.profileLocation));if(ge){if(this.J(P,ge.task)){const le=ge.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,P.identifier.id,J.profileLocation.toString()),ge.waitingTasks.push(P),R.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,z=>z.some(Q=>(0,a.$Mp)(Q.identifier,le)))).then(z=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,P.identifier.id,J.profileLocation.toString()),!z.find(M=>(0,a.$Mp)(M.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else K.some(({identifier:le})=>(0,a.$Mp)(le,_.identifier))||O(de,_,J,P)}}catch(q){if(w.URI.isUri(P.source))(0,t.$Kb)(P.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",P.identifier.id,q.message),(0,t.$Kb)(P.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",P.identifier.id,q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),q}})),await this.L([...I.entries()].map(async([P,{task:q}])=>{const K=new Date().getTime();let J;try{J=await q.run(),await this.L(this.y.map(_=>_.postInstall(J,q.source,q.options,E.CancellationToken.None)),$.ExtensionManagementErrorCode.PostInstall)}catch(_){const de=n(_);throw w.URI.isUri(q.source)||l(this.C,q.operation===$.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$Up)(q.source),error:de,source:q.options.context?.[$.$cp]}),S.set(P,{error:de,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.options.profileLocation,applicationScoped:q.options.isApplicationScoped}),this.F.error("Error while installing the extension",q.identifier.id,(0,k.$9)(de),q.options.profileLocation.toString()),de}if(!w.URI.isUri(q.source)){const _=q.operation===$.InstallOperation.Update,de=_?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(l(this.C,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$Up)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:de,source:q.options.context?.[$.$cp]}),o.$p&&q.operation!==$.InstallOperation.Update)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,$.StatisticType.Install)}catch{}}S.set(P,{local:J,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.options.profileLocation,applicationScoped:J.isApplicationScoped})})),R.length&&await this.L(R),[...S.values()]}catch(P){const q=(_,de,ge)=>{const le=[];_.manifest.extensionDependencies?.length&&le.push(..._.manifest.extensionDependencies),_.manifest.extensionPack?.length&&le.push(..._.manifest.extensionPack);for(const z of le){if(ge.includes(z.toLowerCase()))continue;ge.push(z.toLowerCase());const Q=S.get(`${z.toLowerCase()}-${de.toString()}`);Q?.local&&(ge=q(Q.local,de,ge))}return ge},K=_=>({identifier:_.identifier,operation:$.InstallOperation.Install,source:_.source,context:_.options.context,profileLocation:_.options.profileLocation,error:P}),J=[];for(const[_,{task:de,root:ge}]of I){const le=S.get(_);le?le.local&&ge&&!S.get(`${ge.identifier.id.toLowerCase()}-${de.options.profileLocation.toString()}`)?.local&&(J.push(this.Y(le.local,{versionOnly:!0,profileLocation:de.options.profileLocation})),S.set(_,K(de))):(de.cancel(),S.set(_,K(de)))}for(const[_,{task:de}]of I){const ge=S.get(_);if(!ge?.local||de.options.donotIncludePackAndDependencies)continue;q(ge.local,de.options.profileLocation,[ge.local.identifier.id.toLowerCase()]).slice(1).some(z=>I.has(`${z.toLowerCase()}-${de.options.profileLocation.toString()}`)&&!S.get(`${z.toLowerCase()}-${de.options.profileLocation.toString()}`)?.local)&&(J.push(this.Y(ge.local,{versionOnly:!0,profileLocation:de.options.profileLocation})),S.set(_,K(de)))}throw J.length&&await Promise.allSettled(J.map(async _=>{try{await _.run(),this.F.info("Rollback: Uninstalled extension",_.extension.identifier.id)}catch(de){this.F.warn("Rollback: Error while uninstalling extension",_.extension.identifier.id,(0,k.$9)(de))}})),P}finally{for(const{task:P}of I.values())P.source&&!w.URI.isUri(P.source)&&this.j.delete(L(P.source,P.options.profileLocation));if(S.size){const P=[...S.values()];for(const q of P)q.local&&this.F.info("Extension installed successfully:",q.identifier.id,q.profileLocation.toString());this.s.fire(P)}}}J(c,S){for(const[,{task:I,waitingTasks:R}]of this.j.entries())if(I===c&&(R.includes(S)||R.some(L=>this.J(L,S)))||I===S&&R[0]&&!this.J(c,R[0]))return!1;return!0}async L(c,S){const I=[],R=[],L=await Promise.allSettled(c);for(const P of L)P.status==="fulfilled"?I.push(P.value):R.push(n(P.reason,S));if(!R.length)return I;if(R.length===1)throw R[0];let O=new $.$np("",$.ExtensionManagementErrorCode.Unknown);for(const P of R)O=new $.$np(O.message?`${O.message}, ${P.message}`:P.message,P.code!==$.ExtensionManagementErrorCode.Unknown&&P.code!==$.ExtensionManagementErrorCode.Internal?P.code:O.code);throw O}async M(c,S,I,R,L,O){if(!this.z.isEnabled())return[];const P=await this.getInstalled(void 0,L,O),q=[],K=[],J=async(_,de)=>{q.push(_);const ge=de.extensionDependencies||[],le=[...ge];if(de.extensionPack){const z=I?P.find(Q=>(0,a.$Mp)(Q.identifier,_)):void 0;for(const Q of de.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(M=>(0,a.$Mp)({id:M},{id:Q}))||le.every(M=>!(0,a.$Mp)({id:M},{id:Q}))&&le.push(Q)}if(le.length){const z=le.filter(Q=>q.every(M=>!(0,a.$Mp)(M,{id:Q})));if(z.length){const Q=await this.z.getExtensions(z.map(M=>({id:M,preRelease:R})),E.CancellationToken.None);for(const M of Q){if(q.find(re=>(0,a.$Mp)(re,M.identifier)))continue;const V=ge.some(re=>(0,a.$Mp)({id:re},M.identifier));let ne;try{ne=await this.N(M,!1,R,O)}catch(re){if(V)throw re;this.F.info("Skipping the packed extension as it cannot be installed",M.identifier.id,(0,k.$9)(re));continue}K.push({gallery:ne.extension,manifest:ne.manifest}),await J(ne.extension.identifier,ne.manifest)}}}};return await J(c,S),K}async N(c,S,I,R){let L;const O=await this.getExtensionsControlManifest();if(O.malicious.some(K=>(0,a.$Mp)(c.identifier,K)))throw new $.$np(m.localize(11504,null,c.identifier.id),$.ExtensionManagementErrorCode.Malicious);const P=O.deprecated[c.identifier.id.toLowerCase()];if(P?.extension?.autoMigrate){if(this.F.info(`The '${c.identifier.id}' extension is deprecated, fetching the compatible '${P.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:P.extension.id,preRelease:P.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:R},E.CancellationToken.None))[0],!L)throw new $.$np(m.localize(11505,null,c.identifier.id,P.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(c)){const K=await this.getTargetPlatform();throw new $.$np(m.localize(11506,null,c.identifier.id,this.G.nameLong,(0,$.$fp)(K)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.O(c,S,I,R),!L){const K=[];throw(0,d.$7p)(c.properties.enabledApiProposals??[],K)?!I&&c.properties.isPreReleaseVersion&&(await this.z.getExtensions([c.identifier],E.CancellationToken.None))[0]?new $.$np(m.localize(11508,null,c.displayName??c.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$np(m.localize(11509,null,c.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible):new $.$np(m.localize(11507,null,c.displayName??c.identifier.id,K[0]),$.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",L.identifier.id);const q=await this.z.getManifest(L,E.CancellationToken.None);if(q===null)throw new $.$np(`Missing manifest for extension ${L.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(q.version!==L.version)throw new $.$np(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:q}}async O(c,S,I,R){const L=await this.getTargetPlatform();let O=null;return!S&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==I&&(O=(await this.z.getExtensions([{...c.identifier,preRelease:I}],{targetPlatform:L,compatible:!0,productVersion:R},E.CancellationToken.None))[0]||null),!O&&await this.z.isExtensionCompatible(c,I,L,R)&&(O=c),O||(S?O=(await this.z.getExtensions([{...c.identifier,version:c.version}],{targetPlatform:L,compatible:!0,productVersion:R},E.CancellationToken.None))[0]||null:O=await this.z.getCompatibleExtension(c,I,L,R)),O}async uninstallExtensions(c){const S=(K,J)=>`${K.identifier.id.toLowerCase()}${J.versionOnly?`-${K.manifest.version}`:""}@${J.profileLocation.toString()}`,I=(K,J)=>{const _=this.Y(K,J);return this.m.set(S(_.extension,J),_),this.F.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,J.profileLocation.toString()),this.t.fire({identifier:K.identifier,profileLocation:J.profileLocation,applicationScoped:K.isApplicationScoped}),_},R=(K,J,_)=>{_?this.F.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,J.profileLocation.toString(),_.message):this.F.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,J.profileLocation.toString()),l(this.C,"extensionGallery:uninstall",{extensionData:(0,a.$Tp)(K),error:_}),this.u.fire({identifier:K.identifier,error:_?.code,profileLocation:J.profileLocation,applicationScoped:K.isApplicationScoped})},L=[],O=[],P=[],q=new y.$Ac;for(const{extension:K,options:J}of c){const _={...J,profileLocation:K.isApplicationScoped?this.H.defaultProfile.extensionsResource:J?.profileLocation??this.W()},de=this.m.get(S(K,_));de?(this.F.info("Extensions is already requested to uninstall",K.identifier.id),P.push(de.waitUntilTaskIsFinished())):L.push(I(K,_))}try{for(const K of L.slice(0)){let J=q.get(K.options.profileLocation);if(J||q.set(K.options.profileLocation,J=await this.getInstalled(u.ExtensionType.User,K.options.profileLocation)),K.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${K.extension.identifier.id}@${K.extension.manifest.version}`);else{const _=this.R(K.extension,J);for(const de of _)this.m.has(S(de,K.options))?this.F.info("Extensions is already requested to uninstall",de.identifier.id):L.push(I(de,K.options))}K.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${K.extension.identifier.id}@${K.extension.manifest.version}`):this.P(L.map(_=>_.extension),J,K.extension)}await this.L(L.map(async K=>{try{if(await K.run(),await this.L(this.y.map(J=>J.postUninstall(K.extension,K.options,E.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,$.StatisticType.Uninstall)}catch{}}catch(J){const _=n(J);throw R(K.extension,K.options,_),_}finally{O.push(K)}})),P.length&&await this.L(P);for(const K of L)R(K.extension,K.options)}catch(K){const J=n(K);for(const _ of L){try{_.cancel()}catch{}O.includes(_)||R(_.extension,_.options,J)}throw J}finally{for(const K of L)this.m.delete(S(K.extension,K.options))||this.F.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}P(c,S,I){for(const R of c){const L=this.S(R,S);if(L.length){const O=L.filter(P=>!c.some(q=>(0,a.$Mp)(q.identifier,P.identifier)));if(O.length)throw new Error(this.Q(R,O,I))}}}Q(c,S,I){return I===c?S.length===1?m.localize(11510,null,I.manifest.displayName||I.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?m.localize(11511,null,I.manifest.displayName||I.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):m.localize(11512,null,I.manifest.displayName||I.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):S.length===1?m.localize(11513,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,S[0].manifest.displayName||S[0].manifest.name):S.length===2?m.localize(11514,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name):m.localize(11515,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,S[0].manifest.displayName||S[0].manifest.name,S[1].manifest.displayName||S[1].manifest.name)}R(c,S,I=[]){if(I.indexOf(c)!==-1)return[];I.push(c);const R=c.manifest.extensionPack?c.manifest.extensionPack:[];if(R.length){const L=S.filter(P=>!P.isBuiltin&&R.some(q=>(0,a.$Mp)({id:q},P.identifier))),O=[];for(const P of L)O.push(...this.R(P,S,I));return[...L,...O]}return[]}S(c,S){return S.filter(I=>I.manifest.extensionDependencies&&I.manifest.extensionDependencies.some(R=>(0,a.$Mp)({id:R},c.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(c){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$9)(c)),{malicious:[],deprecated:{},search:[]}}}};e.$Fq=p,e.$Fq=p=Be([je(0,$.$lp),je(1,g.$_l),je(2,b.$Kl),je(3,f.$ak),je(4,v.$tk),je(5,i.$Ml)],p);function n(h,c){if(h instanceof $.$np)return h;let S;return h instanceof $.$mp?S=new $.$np(h.message,h.code===$.ExtensionGalleryErrorCode.DownloadFailedWriting?$.ExtensionManagementErrorCode.DownloadFailedWriting:$.ExtensionManagementErrorCode.Gallery):S=new $.$np(h.message,(0,k.$3)(h)?$.ExtensionManagementErrorCode.Cancelled:c??$.ExtensionManagementErrorCode.Internal),S.stack=h.stack,S}function l(h,c,{extensionData:S,verificationStatus:I,duration:R,error:L,source:O,durationSinceUpdate:P}){let q,K;(0,D.$mg)(I)&&(I===!0?I="Verified":(I===!1||(q=$.ExtensionManagementErrorCode.Signature,K=I),I="Unverified")),L&&(q=L.code,L.code===$.ExtensionManagementErrorCode.Signature&&(K=L.message)),h.publicLog(c,{...S,verificationStatus:I,success:!L,duration:R,errorcode:q,errorcodeDetail:K,durationSinceUpdate:P,source:O})}class r{constructor(){this.d=new s.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,s.$sh)(c=>this.h(c))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,s.$sh)(c=>new Promise((S,I)=>{const R=c.onCancellationRequested(()=>{R.dispose(),I(new k.$4)})})),this.d.open()),this.g.cancel()}}e.$Hq=r}),define(Re[53],Ae([1,0,13,14,2,6,25,4,30,38,15,5,11,33,35,10,9,24]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v||(e.ExtensionsProfileScanningErrorCode=v={}));class g extends Error{constructor(l,r){super(l),this.code=r}}e.$Iq=g,e.$Jq=(0,w.$Fi)("IExtensionsProfileScannerService");let b=class extends E.$Uc{constructor(l,r,h,c,S,I){super(),this.j=l,this.m=r,this.n=h,this.r=c,this.s=S,this.t=I,this.b=this.B(new k.$le),this.onAddExtensions=this.b.event,this.c=this.B(new k.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$le),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(l,r){return this.u(l,void 0,r)}async addExtensionsToProfile(l,r,h){const c=[],S=[];try{return await this.u(r,I=>{const R=[];if(h)R.push(...I);else for(const L of I)l.some(([O])=>(0,o.$Mp)(O.identifier,L.identifier)&&O.manifest.version!==L.version)?c.push(L):R.push(L);for(const[L,O]of l){const P=R.findIndex(K=>(0,o.$Mp)(K.identifier,L.identifier)&&K.version===L.manifest.version),q={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:O};P===-1?(S.push(q),R.push(q)):R.splice(P,1,q)}return S.length&&this.b.fire({extensions:S,profileLocation:r}),c.length&&this.f.fire({extensions:c,profileLocation:r}),R}),S.length&&this.c.fire({extensions:S,profileLocation:r}),c.length&&this.g.fire({extensions:c,profileLocation:r}),S}catch(I){throw S.length&&this.c.fire({extensions:S,error:I,profileLocation:r}),c.length&&this.g.fire({extensions:c,error:I,profileLocation:r}),I}}async updateMetadata(l,r){const h=[];return await this.u(r,c=>{const S=[];for(const I of c){const R=l.find(([L])=>(0,o.$Mp)(L.identifier,I.identifier)&&L.manifest.version===I.version);R&&(I.metadata={...I.metadata,...R[1]},h.push(I)),S.push(I)}return S}),h}async removeExtensionFromProfile(l,r){const h=[];try{await this.u(r,c=>{const S=[];for(const I of c)(0,o.$Mp)(I.identifier,l.identifier)?h.push(I):S.push(I);return h.length&&this.f.fire({extensions:h,profileLocation:r}),S}),h.length&&this.g.fire({extensions:h,profileLocation:r})}catch(c){throw h.length&&this.g.fire({extensions:h,error:c,profileLocation:r}),c}}async u(l,r,h){return this.F(l).queue(async()=>{let c=[],S;try{const I=await this.m.readFile(l);S=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,D.$rl)(I)!==D.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.r.extUri.isEqual(l,this.n.defaultProfile.extensionsResource)&&(S=await this.D()),!S&&h?.bailOutWhenFileNotFound)throw new g((0,d.$9)(I),v.ERROR_PROFILE_NOT_FOUND)}if(S){Array.isArray(S)||this.w(l);let I=!1;for(const R of S){i(R)||this.w(l);let L;if((0,u.$eg)(R.relativeLocation)&&R.relativeLocation)L=this.z(R.relativeLocation);else if((0,u.$eg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=A.URI.revive(R.location);const O=this.y(L);O&&(I=!0,R.relativeLocation=O)}(0,u.$lg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(I=!0,R.metadata.hasPreReleaseVersion=!0),c.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}I&&await this.m.writeFile(l,s.$Ne.fromString(JSON.stringify(S)))}if(r){c=r(c);const I=c.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(l,s.$Ne.fromString(JSON.stringify(I)))}return c})}w(l){const r=new g(`Invalid extensions content in ${l.toString()}`,v.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(l){return this.r.extUri.isEqual(this.r.extUri.dirname(l),this.j)?this.r.extUri.basename(l):void 0}z(l){return this.r.extUri.joinPath(this.j,l)}async D(){return this.C||(this.C=(async()=>{const l=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let h;try{h=(await this.m.readFile(l)).value.toString()}catch(S){if((0,D.$rl)(S)===D.FileOperationResult.FILE_NOT_FOUND)return;throw S}this.t.info("Migrating extensions from old default profile location",l.toString());let c;try{const S=JSON.parse(h);Array.isArray(S)&&S.every(I=>i(I))?c=S:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.t.error(S)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,s.$Ne.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",l.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(S){if((0,D.$rl)(S)===D.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",l.toString(),this.n.defaultProfile.extensionsResource.toString());else throw S}try{await this.m.del(l)}catch(S){(0,D.$rl)(S)!==D.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}try{await this.m.del(r)}catch(S){(0,D.$rl)(S)!==D.FileOperationResult.FILE_NOT_FOUND&&this.t.error(S)}return c})()),this.C}F(l){let r=this.h.get(l);return r||(r=new t.$Mh,this.h.set(l,r)),r}};e.$Kq=b,e.$Kq=b=Be([je(1,D.$al),je(2,$.$Ml),je(3,a.$Kl),je(4,f.$_l),je(5,m.$ak)],b);function i(n){return(0,u.$gg)(n)&&(0,y.$kp)(n.identifier)&&(p(n.location)||(0,u.$eg)(n.location)&&n.location)&&((0,u.$lg)(n.relativeLocation)||(0,u.$eg)(n.relativeLocation))&&n.version&&(0,u.$eg)(n.version)}function p(n){return n?(0,u.$eg)(n.path)&&(0,u.$eg)(n.scheme):!1}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[63],Ae([1,0,17,13,20,14,9,42,192,2,12,8,3,19,62,57,10,4,7,28,38,21,73,15,5,11,29,6,48,53,33,35,200]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Pq=e.$Oq=e.$Nq=e.Translations=void 0,e.$Qq=de,E=Ue(E),w=Ue(w),m=Ue(m),a=Ue(a),u=dt(u);var P;(function(le){function z(Q,M){if(Q===M)return!0;const V=Object.keys(Q),ne=new Set;for(const re of Object.keys(M))ne.add(re);if(V.length!==ne.size)return!1;for(const re of V){if(Q[re]!==M[re])return!1;ne.delete(re)}return ne.size===0}le.equals=z})(P||(e.Translations=P={})),e.$Nq=(0,l.$Fi)("IExtensionsScannerService");let q=class extends o.$Uc{constructor(z,Q,M,V,ne,re,me,oe,ie,x,G,T){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=Q,this.r=M,this.s=V,this.t=ne,this.u=re,this.w=me,this.y=oe,this.z=ie,this.C=x,this.D=G,this.F=T,this.g=this.B(new c.$le),this.onDidChangeCache=this.g.event,this.h=(0,$.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(_,this.s,this.h)),this.m=this.B(this.F.createInstance(_,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Xp)(this.w,this.y)),this.G}async scanAllExtensions(z,Q,M){const[V,ne]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(Q)]),re=M?await this.scanExtensionsUnderDevelopment(z,[...V,...ne]):[];return this.L(V,ne,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const Q=[];Q.push(this.M(!!z.useCache,z.language)),Q.push(this.N(z.language,!!z.checkControlFile));const[M,V]=await Promise.all(Q);return this.J([...M,...V],i.ExtensionType.System,z,!1)}async scanUserExtensions(z){const Q=z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const M=this.D.extUri.isEqual(z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Q,!!z.profileLocation,i.ExtensionType.User,!z.includeUninstalled,z.language,!0,M,z.productVersion??this.R()),ne=z.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let re;try{re=await ne.scanExtensions(V)}catch(me){if(me instanceof I.$Iq&&me.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),re=await ne.scanExtensions(V);else throw me}return re=await this.J(re,i.ExtensionType.User,z,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(z,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===D.Schemas.file).map(async V=>{const ne=await this.P(V,!1,i.ExtensionType.User,!0,z.language,!1,void 0,z.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ne)).map(me=>(me.type=Q.find(oe=>(0,b.$Mp)(oe.identifier,me.identifier))?.type??me.type,this.n.validate(me,ne)))}))).flat();return this.J(M,"development",z,!0)}return[]}async scanExistingExtension(z,Q,M){const V=await this.P(z,!1,Q,!0,M.language,!0,void 0,M.productVersion??this.R()),ne=await this.n.scanExtension(V);return!ne||!M.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(z,Q,M){const V=await this.P(z,!1,Q,!0,M.language,!0,void 0,M.productVersion??this.R()),ne=await this.n.scanOneOrMultipleExtensions(V);return this.J(ne,Q,M,!0)}async scanMultipleExtensions(z,Q,M){const V=[];return await Promise.all(z.map(async ne=>{const re=await this.scanOneOrMultipleExtensions(ne,Q,M);V.push(...re)})),this.J(V,Q,M,!0)}async scanMetadata(z){const Q=(0,$.$gh)(z,"package.json"),M=(await this.w.readFile(Q)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(z,Q){const M=(0,$.$gh)(z,"package.json"),V=(await this.w.readFile(M)).value.toString(),ne=JSON.parse(V);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,ne.__metadata={...ne.__metadata,...Q},await this.w.writeFile((0,$.$gh)(z,"package.json"),k.$Ne.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof I.$Iq&&z.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.u.addExtensionsToProfile(z.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Ne.fromString(JSON.stringify([])))}catch(Q){(0,n.$rl)(Q)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.y.error(z)}finally{this.H=void 0}})()),this.H}async J(z,Q,M,V){return M.includeAllVersions||(z=this.L(Q===i.ExtensionType.System?z:void 0,Q===i.ExtensionType.User?z:void 0,Q==="development"?z:void 0,await this.getTargetPlatform(),V)),M.includeInvalid||(z=z.filter(ne=>ne.isValid)),z.sort((ne,re)=>{const me=w.$nc(ne.location.fsPath),oe=w.$nc(re.location.fsPath);return me<oe?-1:me>oe?1:0})}L(z,Q,M,V,ne){const re=(oe,ie,x)=>{if(oe.isValid&&!ie.isValid)return!1;if(oe.isValid===ie.isValid){if(ne&&a.gt(oe.manifest.version,ie.manifest.version))return this.y.debug(`Skipping extension ${ie.location.path} with lower version ${ie.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(a.eq(oe.manifest.version,ie.manifest.version)){if(oe.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${ie.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===V)return this.y.debug(`Skipping extension ${ie.location.path} from different target platform ${ie.targetPlatform}`),!1}}return x?this.y.warn(`Overwriting user extension ${oe.location.path} with ${ie.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${ie.location.path}.`),!0},me=new i.$tn;return z?.forEach(oe=>{const ie=me.get(oe.identifier.id);(!ie||re(ie,oe,!1))&&me.set(oe.identifier.id,oe)}),Q?.forEach(oe=>{const ie=me.get(oe.identifier.id);if(!ie&&z&&oe.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!ie||re(ie,oe,!1))&&me.set(oe.identifier.id,oe)}),M?.forEach(oe=>{const ie=me.get(oe.identifier.id);(!ie||re(ie,oe,!0))&&me.set(oe.identifier.id,oe),me.set(oe.identifier.id,oe)}),[...me.values()]}async M(z,Q){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Q,!0,void 0,this.R()),ne=await(z&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",ne.length),ne}async N(z,Q){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Q?await this.O():{},ne=[],re=f.URI.file(w.$hc(w.$jc(D.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of M){const ie=V[oe.name]||"marketplace";switch(ie){case"disabled":break;case"marketplace":ne.push((0,$.$gh)(re,oe.name));break;default:ne.push(f.URI.file(ie));break}}const me=await Promise.all(ne.map(async oe=>this.n.scanExtension(await this.P(oe,!1,i.ExtensionType.System,!0,z,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",me.length),(0,t.$Gb)(me)}async O(){try{const z=await this.w.readFile(this.r);return JSON.parse(z.value.toString())}catch{return{}}}async P(z,Q,M,V,ne,re,me,oe){const ie=await this.f(ne??m.$x),x=await this.Q(z),G=Q&&!this.D.extUri.isEqual(z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=G?await this.Q(G):void 0;return new K(z,x,G,T,Q,me,M,V,re,oe.version,oe.date,this.C.commit,!this.z.isBuilt,ne,ie)}async Q(z){try{const Q=await this.w.stat(z);if(typeof Q.mtime=="number")return Q.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Oq=q,e.$Oq=q=Be([je(4,R.$Ml),je(5,I.$Jq),je(6,n.$al),je(7,r.$ak),je(8,g.$Mi),je(9,h.$tk),je(10,L.$Kl),je(11,l.$Ei)],q);class K{constructor(z,Q,M,V,ne,re,me,oe,ie,x,G,T,X,he,B){this.location=z,this.mtime=Q,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=V,this.profile=ne,this.profileScanOptions=re,this.type=me,this.excludeObsolete=oe,this.validate=ie,this.productVersion=x,this.productDate=G,this.productCommit=T,this.devMode=X,this.language=he,this.translations=B}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,Q){return(0,$.$_g)(z.location,Q.location)&&z.mtime===Q.mtime&&(0,$.$_g)(z.applicationExtensionslocation,Q.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&z.profile===Q.profile&&E.$io(z.profileScanOptions,Q.profileScanOptions)&&z.type===Q.type&&z.excludeObsolete===Q.excludeObsolete&&z.validate===Q.validate&&z.productVersion===Q.productVersion&&z.productDate===Q.productDate&&z.productCommit===Q.productCommit&&z.devMode===Q.devMode&&z.language===Q.language&&P.equals(z.translations,Q.translations)}}e.$Pq=K;let J=class extends o.$Uc{constructor(z,Q,M,V,ne,re,me){super(),this.g=z,this.h=Q,this.j=M,this.m=V,this.n=re,this.r=me,this.f=ne.extensionsEnabledWithApiProposalVersion?.map(oe=>oe.toLowerCase())??[]}async scanExtensions(z){const Q=z.profile?await this.t(z):await this.s(z);let M={};if(z.excludeObsolete&&z.type===i.ExtensionType.User)try{const V=(await this.m.readFile(this.g)).value.toString();M=JSON.parse(V)}catch{}return(0,d.$rg)(M)?Q:Q.filter(V=>!M[b.$Np.create(V).toString()])}async s(z){const Q=await this.m.resolve(z.location);if(!Q.children?.length)return[];const M=await Promise.all(Q.children.map(async V=>{if(!V.isDirectory||z.type===i.ExtensionType.User&&(0,$.$dh)(V.resource).indexOf(".")===0)return null;const ne=new K(V.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ne)}));return(0,t.$Gb)(M).sort((V,ne)=>V.location.path<ne.location.path?-1:1)}async t(z){let Q=await this.u(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.j.extUri.isEqual(z.location,z.applicationExtensionslocation)){Q=Q.filter(V=>!V.metadata?.isApplicationScoped);const M=await this.u(z.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,z);Q.push(...M)}return Q}async u(z,Q,M){const V=await this.h.scanProfileExtensions(z,M.profileScanOptions);if(!V.length)return[];const ne=await Promise.all(V.map(async re=>{if(Q(re)){const me=new K(re.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(me,re.metadata)}return null}));return(0,t.$Gb)(ne)}async scanOneOrMultipleExtensions(z){try{if(await this.m.exists((0,$.$gh)(z.location,"package.json"))){const Q=await this.scanExtension(z);return Q?[Q]:[]}else return await this.scanExtensions(z)}catch(Q){return this.r.error(`Error scanning extensions at ${z.location.path}:`,(0,C.$9)(Q)),[]}}async scanExtension(z,Q){try{let M=await this.w(z.location);if(M){M.publisher||(M.publisher=i.$nn),Q=Q??M.__metadata,delete M.__metadata;const V=(0,b.$Rp)(M.publisher,M.name),ne=Q?.id?{id:V,uuid:Q.id}:{id:V},re=Q?.isSystem?i.ExtensionType.System:z.type,me=re===i.ExtensionType.System||!!Q?.isBuiltin;M=await this.y(z.location,M,K.createNlsConfiguration(z));let oe={type:re,identifier:ne,manifest:M,location:z.location,isBuiltin:me,targetPlatform:Q?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Q?.publisherDisplayName,metadata:Q,isValid:!0,validations:[]};return z.validate&&(oe=this.validate(oe,z)),M.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(V.toLowerCase()))&&(M.originalEnabledApiProposals=M.enabledApiProposals,M.enabledApiProposals=(0,i.$zn)([...M.enabledApiProposals])),oe}}catch(M){z.type!==i.ExtensionType.System&&this.r.error(M)}return null}validate(z,Q){let M=!0;const V=this.n.isBuilt&&this.f.includes(z.identifier.id.toLowerCase()),ne=(0,p.$4p)(Q.productVersion,Q.productDate,Q.location,z.manifest,z.isBuiltin,V);for(const[re,me]of ne)re===u.default.Error&&(M=!1,this.r.error(this.F(Q.location,me)));return z.isValid=M,z.validations=ne,z}async w(z){const Q=(0,$.$gh)(z,"package.json");let M;try{M=(await this.m.readFile(Q)).value.toString()}catch(ne){return(0,n.$rl)(ne)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(z,(0,v.localize)(11461,null,Q.path,ne.message))),null}let V;try{V=JSON.parse(M)}catch{const re=[];(0,A.$Yn)(M,re);for(const me of re)this.r.error(this.F(z,(0,v.localize)(11462,null,Q.path,me.offset,me.length,(0,y.$Lq)(me.error))));return null}return(0,A.$7n)(V)!=="object"?(this.r.error(this.F(z,(0,v.localize)(11463,null,Q.path))),null):V}async y(z,Q,M){const V=await this.z(z,Q,M);if(V)try{const ne=[],re=await this.C(V.default,ne);if(ne.length>0)return ne.forEach(oe=>{this.r.error(this.F(z,(0,v.localize)(11464,null,V.default?.path,(0,y.$Lq)(oe.error))))}),Q;if((0,A.$7n)(V)!=="object")return this.r.error(this.F(z,(0,v.localize)(11465,null,V.default?.path))),Q;const me=V.values||Object.create(null);return(0,O.$Mq)(this.r,Q,me,re)}catch{}return Q}async z(z,Q,M){const V=(0,$.$gh)(z,"package.nls.json"),ne=(ie,x)=>{x.forEach(G=>{this.r.error(this.F(z,(0,v.localize)(11466,null,ie?.path,(0,y.$Lq)(G.error))))})},re=ie=>{this.r.error(this.F(z,(0,v.localize)(11467,null,ie?.path)))},me=`${Q.publisher}.${Q.name}`,oe=M.translations[me];if(oe)try{const ie=f.URI.file(oe),x=(await this.m.readFile(ie)).value.toString(),G=[],T=(0,A.$Yn)(x,G);return G.length>0?(ne(ie,G),{values:void 0,default:V}):(0,A.$7n)(T)!=="object"?(re(ie),{values:void 0,default:V}):{values:T.contents?T.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.m.exists(V))return;let x;try{x=await this.D(z,M)}catch{return}if(!x.localized)return{values:void 0,default:x.original};try{const G=(await this.m.readFile(x.localized)).value.toString(),T=[],X=(0,A.$Yn)(G,T);return T.length>0?(ne(x.localized,T),{values:void 0,default:x.original}):(0,A.$7n)(X)!=="object"?(re(x.localized),{values:void 0,default:x.original}):{values:X,default:x.original}}catch{return{values:void 0,default:x.original}}}}async C(z,Q){if(z)try{const M=(await this.m.readFile(z)).value.toString();return(0,A.$Yn)(M,Q)}catch{}}D(z,Q){return new Promise((M,V)=>{const ne=re=>{const me=(0,$.$gh)(z,`package.nls.${re}.json`);this.m.exists(me).then(oe=>{oe&&M({localized:me,original:(0,$.$gh)(z,"package.nls.json")});const ie=re.lastIndexOf("-");ie===-1?M({localized:(0,$.$gh)(z,"package.nls.json"),original:null}):(re=re.substring(0,ie),ne(re))})};if(Q.devMode||Q.pseudo||!Q.language)return M({localized:(0,$.$gh)(z,"package.nls.json"),original:null});ne(Q.language)})}F(z,Q){return`[${z.path}]: ${Q}`}};J=Be([je(1,I.$Jq),je(2,L.$Kl),je(3,n.$al),je(4,h.$tk),je(5,g.$Mi),je(6,r.$ak)],J);let _=class extends J{constructor(z,Q,M,V,ne,re,me,oe,ie){super(Q,V,ne,re,me,oe,ie),this.J=z,this.L=M,this.H=this.B(new s.$Dh(3e3)),this.I=this.B(new c.$le),this.onDidChangeCache=this.I.event}async scanExtensions(z){const Q=this.P(z),M=await this.M(Q);if(this.G=z,M&&M.input&&K.equals(M.input,this.G))return this.r.debug("Using cached extensions scan result",z.type===i.ExtensionType.System?"system":"user",z.location.toString()),this.H.trigger(()=>this.O()),M.result.map(ne=>(ne.location=f.URI.revive(ne.location),ne));const V=await super.scanExtensions(z);return await this.N(Q,{input:z,result:V}),V}async M(z){try{const Q=await this.m.readFile(z),M=JSON.parse(Q.value.toString());return{result:M.result,input:(0,S.$ci)(M.input)}}catch(Q){this.r.debug("Error while reading the extension cache file:",z.path,(0,C.$9)(Q))}return null}async N(z,Q){try{await this.m.writeFile(z,k.$Ne.fromString(JSON.stringify(Q)))}catch(M){this.r.debug("Error while writing the extension cache file:",z.path,(0,C.$9)(M))}}async O(){if(!this.G)return;const z=this.P(this.G),Q=await this.M(z);if(!Q)return;const M=Q.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$io(V,M))try{this.r.info("Invalidating Cache",M,V),await this.m.del(z),this.I.fire()}catch(ne){this.r.error(ne)}}P(z){const Q=this.Q(z);return this.j.extUri.joinPath(Q.cacheHome,z.type===i.ExtensionType.System?i.$mn:i.$ln)}Q(z){return z.type===i.ExtensionType.System?this.L.defaultProfile:z.profile?this.j.extUri.isEqual(z.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Q=>this.j.extUri.isEqual(z.location,Q.extensionsResource))??this.J:this.L.defaultProfile}};_=Be([je(2,R.$Ml),je(3,I.$Jq),je(4,L.$Kl),je(5,n.$al),je(6,h.$tk),je(7,g.$Mi),je(8,r.$ak)],_);function de(le,z){const Q=(0,b.$Pp)(le.manifest.publisher,le.manifest.name);return{id:Q,identifier:new i.$rn(Q),isBuiltin:le.type===i.ExtensionType.System,isUserBuiltin:le.type===i.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:z,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ge extends q{constructor(z,Q,M,V,ne,re,me,oe,ie,x,G,T){super(z,Q,(0,$.$gh)(M,".vscode-oss-dev","extensions","control.json"),V,ne,re,me,oe,ie,x,G,T),this.S=(async()=>{if(m.$A)try{const X=await this.w.readFile(f.URI.file(m.$A));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(z){return this.S}}e.$Rq=ge}),define(Re[243],Ae([1,0,59,13,44,6,2,12,8,26,11,33]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let m=class extends C.$Uc{constructor(a,u){super(),this.b=a,this.f=u,this.a=new s.$Lh(5)}async postUninstall(a){const u=this.g(a,"uninstall");u&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(u.script,"uninstall",u.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(d)}}));try{await o.Promises.rm(this.m(a))}catch(d){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(d)}}g(a,u){const d=`vscode:${u}`;if(a.location.scheme===A.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[d]=="string"){const f=a.manifest.scripts[d].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${d} should be a node script`),null):{script:(0,y.$jc)(a.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(a,u,d,f,v){return new Promise((g,b)=>{const i=this.j(a,u,d,v);let p;const n=l=>{p&&(clearTimeout(p),p=null),l?b(l):g(void 0)};i.on("error",l=>{n((0,E.$qj)(l)||"Unknown")}),i.on("exit",(l,r)=>{n(l?`post-${u} process exited with code ${l}`:void 0)}),f&&(p=setTimeout(()=>{p=null,i.kill(),b("timed out")},5e3))})}j(a,u,d,f){const v={silent:!0,execArgv:void 0},g=(0,t.fork)(a,[`--type=extension-post-${u}`,...d],v);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const b=k.Event.fromNodeEventEmitter(g.stdout,"data"),i=k.Event.fromNodeEventEmitter(g.stderr,"data");this.B(b(l=>this.f.info(f.identifier.id,f.manifest.version,`post-${u}`,l))),this.B(i(l=>this.f.error(f.identifier.id,f.manifest.version,`post-${u}`,l)));const p=k.Event.any(k.Event.map(b,l=>({data:`%c${l}`,format:[""]}),this.q),k.Event.map(i,l=>({data:`%c${l}`,format:["color: red"]}),this.q));return k.Event.debounce(p,(l,r)=>l?{data:l.data+r.data,format:[...l.format,...r.format]}:{data:r.data,format:r.format},100,void 0,void 0,void 0,this.q)(l=>{console.group(f.identifier.id),console.log(l.data,...l.format),console.groupEnd()}),g}m(a){return(0,y.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$Vq=m,e.$Vq=m=Be([je(0,w.$Ml),je(1,D.$ak)],m)}),define(Re[137],Ae([1,0,86,7,98,30]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=C,e.$Tq=A;function C(y){let o=k.ExtensionManagementErrorCode.Extract;return y instanceof t.$Bq&&(y.type==="CorruptZip"?o=k.ExtensionManagementErrorCode.CorruptZip:y.type==="Incomplete"&&(o=k.ExtensionManagementErrorCode.IncompleteZip)),(0,E.$Gq)(y,o)}async function A(y){let o;try{o=await(0,t.$Eq)(y,"extension/package.json")}catch(D){throw C(D)}try{return JSON.parse(o.toString("utf8"))}catch{throw new k.$np((0,s.localize)(11451,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(Re[244],Ae([1,0,13,9,2,12,19,62,10,22,26,86,27,28,98,30,38,137,94,15,11,24]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0,A=Ue(A);let n=class extends E.$Uc{static{p=this}static{this.c=".sigzip"}constructor(r,h,c,S,I,R,L){super(),this.h=h,this.j=c,this.m=S,this.n=I,this.r=R,this.t=L,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(r,h,c,S){await this.g;const I=await this.w(r,h);let R=!1;if(c&&this.u(r)){let L;try{L=await this.y(r)}catch(O){try{await this.delete(I)}catch(P){this.t.error(P)}throw O}try{R=await this.n.verify(r,I.fsPath,L.fsPath,S)}catch(O){if(R=O.code,R===v.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===v.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(I)}catch(P){this.t.error(P)}throw new u.$np(w.$Aq,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(L)}catch(O){this.t.error(O)}}}return{location:I,verificationStatus:R}}u(r){if(!r.isSigned)return this.t.info(`Extension is not signed: ${r.identifier.id}`),!1;const h=this.m.getValue("extensions.verifySignature");return(0,y.$kg)(h)?h:!0}async w(r,h){try{const c=(0,C.$gh)(this.extensionsDownloadDir,this.G(r)),S=await this.C(r,"vsix",async()=>{await this.z(r,c,I=>this.j.download(r,I,h));try{await this.D(c.fsPath,"extension/package.json")}catch(I){try{await this.h.del(c)}catch(R){this.t.warn(`Error while deleting: ${c.path}`,(0,s.$9)(R))}throw I}},2);return S>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:r.identifier.id,attempts:S}),c}catch(c){throw(0,a.$Gq)(c,u.ExtensionManagementErrorCode.Download)}}async y(r){try{const h=(0,C.$gh)(this.extensionsDownloadDir,`.${(0,o.$2g)()}`),c=await this.C(r,"sigzip",async()=>{await this.j.downloadSignatureArchive(r,h);try{await this.D(h.fsPath,".signature.p7s")}catch(S){try{await this.h.del(h)}catch(I){this.t.warn(`Error while deleting: ${h.path}`,(0,s.$9)(I))}throw S}},2);return c>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:r.identifier.id,attempts:c}),h}catch(h){throw(0,a.$Gq)(h,u.ExtensionManagementErrorCode.DownloadSignature)}}async z(r,h,c){if(await this.h.exists(h))return;if(h.scheme!==k.Schemas.file){await c(h);return}const S=(0,C.$gh)(this.extensionsDownloadDir,`.${(0,o.$2g)()}`);try{await c(S)}catch(I){try{await this.h.del(S)}catch{}throw I}try{await D.Promises.rename(S.fsPath,h.fsPath,2*60*1e3)}catch(I){try{await this.h.del(S)}catch{}let R=!1;try{R=await this.h.exists(h)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,h.path);else throw this.t.info(`Rename failed because of ${(0,s.$9)(I)}. Deleted the file from downloaded location`,S.path),I}}async C(r,h,c,S){let I=1;for(;;)try{return await c(),I}catch(R){if(I++>S)throw R;this.t.warn(`Failed downloading ${h}. ${(0,s.$9)(R)}. Retry again...`,r.identifier.id)}}async D(r,h){try{await(0,w.$Eq)(r,h)}catch(c){throw(0,f.$Sq)(c)}}async delete(r){await this.g,await this.h.del(r)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const h=[],c=[],S=[];for(const L of r.children)if(L.name.endsWith(p.c))S.push(L.resource);else{const O=d.$Np.parse(L.name);O&&c.push([O,L])}const I=(0,d.$Sp)(c,([L])=>L),R=[];for(const L of I)L.sort((O,P)=>A.rcompare(O[0].version,P[0].version)),h.push(...L.slice(1).map(O=>O[1].resource)),R.push(L[0][1]);R.sort((L,O)=>L.mtime-O.mtime),h.push(...R.slice(0,Math.max(0,R.length-this.f)).map(L=>L.resource)),h.push(...S),await t.Promises.settled(h.map(L=>(this.t.trace("Deleting from cache",L.path),this.h.del(L))))}}catch(r){this.t.error(r)}}G(r){return this.f?d.$Np.create(r).toString().toLowerCase():(0,o.$2g)()}};e.$Uq=n,e.$Uq=n=p=Be([je(0,$.$Ni),je(1,g.$al),je(2,u.$lp),je(3,m.$_i),je(4,v.$tq),je(5,i.$_l),je(6,b.$ak)],n)}),define(Re[138],Ae([1,0,23,13,14,18,44,9,6,67,2,25,12,8,19,62,10,4,22,26,86,7,87,28,98,30,38,53,63,244,243,137,221,230,21,73,15,5,11,29,24,35,33]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O,P,q,K,J,_,de,ge,le,z,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=void 0,t=Ue(t),$=Ue($),u=Ue(u),g=Ue(g),i=Ue(i),e.$Yq=(0,_.$Gi)(r.$op);const M=".vsctmp";let V=class extends l.$Fq{constructor(ie,x,G,T,X,he,B,U,H,F,W,Y){super(ie,x,W,G,F,Y),this.db=X,this.eb=he,this.fb=B,this.gb=U,this.hb=H,this.cb=new Map,this.sb=new w.$Bc;const ae=this.B(U.createInstance(R.$Vq));this.$=this.B(U.createInstance(ne,Le=>ae.postUninstall(Le))),this.ab=this.B(new O.$Wq(Y,H,W,this,this.F)),this.bb=this.B(U.createInstance(I.$Uq));const Ee=this.B(new P.$Xq(this,this.db,Y,he,W,H,G));this.B(Ee.onDidChangeExtensionsByAnotherSource(Le=>this.rb(Le))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,h.$Xp)(this.hb,this.F)),this.ib}async zip(ie){this.F.trace("ExtensionManagementService#zip",ie.identifier.id);const x=await this.qb(ie),G=await(0,b.zip)((0,a.$gh)(this.bb.extensionsDownloadDir,(0,v.$2g)()).fsPath,x);return f.URI.file(G)}async getManifest(ie){const{location:x,cleanup:G}=await this.kb(ie),T=$.$kc(x.fsPath);try{return await(0,L.$Tq)(T)}finally{await G()}}getInstalled(ie,x=this.H.defaultProfile.extensionsResource,G={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(ie??null,x,G)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(ie){return this.$.scanUserExtensionAtLocation(ie)}async install(ie,x={}){this.F.trace("ExtensionManagementService#install",ie.toString());const{location:G,cleanup:T}=await this.kb(ie);try{const X=await(0,L.$Tq)($.$kc(G.fsPath)),he=(0,h.$Rp)(X.publisher,X.name);if(X.engines&&X.engines.vscode&&!(0,K.$6p)(X.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11452,null,he,this.G.version));const U=(await this.I([{manifest:X,extension:G,options:x}])).find(({identifier:H})=>(0,h.$Mp)(H,{id:he}));if(U?.local)return U.local;throw U?.error?U.error:(0,l.$Gq)(new Error(`Unknown error while installing extension ${he}`))}finally{await T()}}async installFromLocation(ie,x){this.F.trace("ExtensionManagementService#installFromLocation",ie.toString());const G=await this.$.scanUserExtensionAtLocation(ie);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${ie.toString()}`);return await this.vb([[G,{source:"resource"}]],x),this.F.info("Successfully installed extension",G.identifier.id,x.toString()),G}async installExtensionsFromProfile(ie,x,G){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",ie,x.toString(),G.toString());const T=(await this.getInstalled(q.ExtensionType.User,x)).filter(X=>ie.some(he=>(0,h.$Mp)(he,X.identifier)));if(T.length){const X=await Promise.all(T.map(he=>this.$.scanMetadata(he,x)));await this.vb(T.map((he,B)=>[he,X[B]]),G),this.F.info("Successfully installed extensions",T.map(he=>he.identifier.id),G.toString())}return T}async updateMetadata(ie,x,G){return this.F.trace("ExtensionManagementService#updateMetadata",ie.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0,x.hasPreReleaseVersion=!0),x.isMachineScoped===!1&&(x.isMachineScoped=void 0),x.isBuiltin===!1&&(x.isBuiltin=void 0),x.pinned===!1&&(x.pinned=void 0),ie=await this.$.updateMetadata(ie,x,G),this.ab.invalidate(G),this.w.fire({local:ie,profileLocation:G}),ie}async reinstallFromGallery(ie){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",ie.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11453,null));const x=await this.getTargetPlatform(),[G]=await this.z.getExtensions([{...ie.identifier,preRelease:ie.preRelease}],{targetPlatform:x,compatible:!0},k.CancellationToken.None);if(!G)throw new Error(i.localize(11454,null));await this.$.setUninstalled(ie);try{await this.$.removeUninstalledExtension(ie)}catch(T){throw new Error(i.localize(11455,null,(0,C.$qj)(T)))}return this.installFromGallery(G)}Z(ie,x,G,T){return this.$.copyExtension(ie,x,G,T)}copyExtensions(ie,x){return this.$.copyExtensions(ie,x,{version:this.G.version,date:this.G.date})}markAsUninstalled(...ie){return this.$.setUninstalled(...ie)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(ie){this.F.error(ie)}}async download(ie,x,G){const{location:T}=await this.bb.download(ie,x,!G);return T}async kb(ie){if(ie.scheme===m.Schemas.file)return{location:ie,async cleanup(){}};this.F.trace("Downloading extension from",ie.toString());const x=(0,a.$gh)(this.bb.extensionsDownloadDir,(0,v.$2g)());return await this.fb.download(ie,x),this.F.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.hb.del(x)}catch(T){this.F.error(T)}}}}W(){return this.H.defaultProfile.extensionsResource}X(ie,x,G){const T=x instanceof f.URI?new h.$Np({id:(0,h.$Rp)(ie.publisher,ie.name)},ie.version):h.$Np.create(x);return this.gb.createInstance(re,T,ie,x,G,(X,he)=>{if(x instanceof f.URI)return this.pb(T,x,G,he);let B=this.cb.get(T.toString());return B||(this.cb.set(T.toString(),B=this.ob(T,x,X,G,he)),B.finally(()=>this.cb.delete(T.toString()))),B},this.$)}Y(ie,x){return new me(ie,x,this.eb)}async ob(ie,x,G,T,X){const{verificationStatus:he,location:B}=await this.bb.download(x,G,!T.donotVerifySignature,T.context?.[r.$ep]);try{if(X.isCancellationRequested)throw new A.$4;const U=await(0,L.$Tq)(B.fsPath);if(!new h.$Np(x.identifier,x.version).equals(new h.$Np({id:(0,h.$Rp)(U.publisher,U.name)},U.version)))throw new r.$np(i.localize(11456,null,x.identifier.id),r.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(ie,B.fsPath,{id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform,isApplicationScoped:T.isApplicationScoped,isMachineScoped:T.isMachineScoped,isBuiltin:T.isBuiltin,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:T.installGivenVersion?!0:!!T.pinned,preRelease:(0,d.$kg)(T.preRelease)?T.preRelease:T.installPreReleaseVersion||x.properties.isPreReleaseVersion,source:"gallery"},!1,X),verificationStatus:he}}catch(U){try{await this.bb.delete(B)}catch(H){this.F.warn("Error while deleting the downloaded file",B.toString(),(0,A.$9)(H))}throw(0,l.$Gq)(U)}}async pb(ie,x,G,T){return{local:await this.$.extractUserExtension(ie,$.$kc(x.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},G.keepExisting??!0,T)}}async qb(ie){const x=async T=>{let X=await g.Promises.readdir(T);X=X.map(U=>$.$jc(T,U));const he=await Promise.all(X.map(U=>t.promises.stat(U)));let B=Promise.resolve([]);return he.forEach((U,H)=>{const F=X[H];U.isFile()&&(B=B.then(W=>[...W,F])),U.isDirectory()&&(B=B.then(W=>x(F).then(Y=>[...W,...Y])))}),B};return(await x(ie.location.fsPath)).map(T=>({path:`extension/${$.$lc(ie.location.fsPath,T)}`,localPath:T}))}async rb({added:ie,removed:x}){if(x){const G=ie&&this.D.extUri.isEqual(x.profileLocation,ie.profileLocation)?x.extensions.filter(T=>ie.extensions.every(X=>!(0,h.$Mp)(X,T))):x.extensions;for(const T of G)this.F.info("Extensions removed from another source",T.id,x.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:x.profileLocation})}if(ie){const T=(await this.getInstalled(q.ExtensionType.User,ie.profileLocation)).filter(X=>ie.extensions.some(he=>(0,h.$Mp)(he,X.identifier)));this.s.fire(T.map(X=>(this.F.info("Extensions added from another source",X.identifier.id,ie.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:ie.profileLocation,operation:r.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(x=>this.sb.add(x)));const ie=await this.hb.resolve(this.db.userExtensionsLocation);for(const x of ie.children??[])x.isDirectory&&this.sb.add(x.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(x=>this.ub(x)))}async ub(ie){if(!ie.affects(this.db.userExtensionsLocation,J.FileChangeType.ADDED))return;const x=[];for(const G of ie.rawAdded){if(this.sb.has(G)||!this.D.extUri.isEqual(this.D.extUri.dirname(G),this.db.userExtensionsLocation)||this.D.extUri.isEqual(G,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(G).startsWith(".")||!(await this.hb.stat(G)).isDirectory)continue;const T=await this.$.scanUserExtensionAtLocation(G);T&&T.installedTimestamp===void 0&&(this.sb.add(G),x.push(T))}x.length&&(await this.vb(x.map(G=>[G,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",x.map(G=>G.identifier.id)))}async vb(ie,x){const G=ie.map(T=>T[0]);await this.wb(G),await this.eb.addExtensionsToProfile(ie,x),this.s.fire(G.map(T=>({local:T,identifier:T.identifier,operation:r.InstallOperation.None,profileLocation:x})))}async wb(ie){const x=await this.$.getUninstalledExtensions();for(const G of ie){const T=h.$Np.create(G);x[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.$.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$Zq=V,e.$Zq=V=Be([je(0,r.$lp),je(1,le.$_l),je(2,de.$ak),je(3,n.$Ni),je(4,S.$Nq),je(5,c.$Jq),je(6,p.$2o),je(7,_.$Ei),je(8,J.$al),je(9,ge.$tk),je(10,z.$Kl),je(11,Q.$Ml)],V);let ne=class extends D.$Uc{constructor(ie,x,G,T,X,he,B){super(),this.n=ie,this.s=x,this.t=G,this.u=T,this.w=X,this.y=he,this.z=B,this.h=this.B(new y.$le),this.onExtract=this.h.event,this.j=new w.$Ac,this.m=new w.$Ac,this.c=(0,a.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new s.$Mh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(ie,x,G){try{const T={includeInvalid:!0,profileLocation:x,productVersion:G};let X=[];if(ie===null||ie===q.ExtensionType.System){let he=this.j.get(x);he||(he=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},T,!1).finally(()=>this.j.delete(x)),this.j.set(x,he)),X.push(...await he)}else if(ie===q.ExtensionType.User){let he=this.m.get(x);he||(he=this.t.scanUserExtensions(T).finally(()=>this.m.delete(x)),this.m.set(x,he)),X.push(...await he)}return X=ie!==null?X.filter(he=>he.type===ie):X,await Promise.all(X.map(he=>this.H(he)))}catch(T){throw(0,l.$Gq)(T,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(ie){try{const x=await this.t.scanUserExtensions({includeAllVersions:!ie,includeInvalid:!0});return await Promise.all(x.map(G=>this.H(G)))}catch(x){throw(0,l.$Gq)(x,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(ie){try{const x=await this.t.scanExistingExtension(ie,q.ExtensionType.User,{includeInvalid:!0});if(x)return await this.H(x)}catch(x){this.z.error(x)}return null}async extractUserExtension(ie,x,G,T,X){const he=ie.toString(),B=f.URI.file($.$jc(this.t.userExtensionsLocation.fsPath,`.${(0,v.$2g)()}`)),U=f.URI.file($.$jc(this.t.userExtensionsLocation.fsPath,he));if(await this.s.exists(U)){if(!T)try{return await this.scanLocalExtension(U,q.ExtensionType.User)}catch(H){this.z.warn(`Error while scanning the existing extension at ${U.path}. Deleting the existing extension and extracting it.`,(0,A.$9)(H))}try{await this.D(ie.id,U,"removeExisting")}catch{throw new r.$np(i.localize(11457,null,U.fsPath,ie.id),r.ExtensionManagementErrorCode.Delete)}}try{if(X.isCancellationRequested)throw new A.$4;try{this.z.trace(`Started extracting the extension from ${x} to ${U.fsPath}`),await(0,b.$Dq)(x,B.fsPath,{sourcePath:"extension",overwrite:!0},X),this.z.info(`Extracted extension to ${U}:`,ie.id)}catch(H){throw(0,L.$Sq)(H)}try{await this.t.updateMetadata(B,G)}catch(H){throw this.y.publicLog2("extension:extract",{extensionId:ie.id,code:`${(0,J.$rl)(H)}`}),(0,l.$Gq)(H,r.ExtensionManagementErrorCode.UpdateMetadata)}if(X.isCancellationRequested)throw new A.$4;try{this.z.trace(`Started renaming the extension from ${B.fsPath} to ${U.fsPath}`),await this.G(B.fsPath,U.fsPath),this.z.info("Renamed to",U.fsPath)}catch(H){if(H.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",ie.id);try{await this.s.del(B,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,A.$9)(H)}. Deleted from extracted location`,B),H}this.h.fire(U)}catch(H){try{await this.s.del(B,{recursive:!0})}catch{}throw H}return this.scanLocalExtension(U,q.ExtensionType.User)}async scanMetadata(ie,x){return x?(await this.C(ie,x))?.metadata:this.t.scanMetadata(ie.location)}async C(ie,x){return(await this.u.scanProfileExtensions(x)).find(T=>(0,h.$Mp)(T.identifier,ie.identifier))}async updateMetadata(ie,x,G){try{G?await this.u.updateMetadata([[ie,x]],G):await this.t.updateMetadata(ie.location,x)}catch(T){throw this.y.publicLog2("extension:extract",{extensionId:ie.identifier.id,code:`${(0,J.$rl)(T)}`,isProfile:!!G}),(0,l.$Gq)(T,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(ie.location,ie.type,G)}async getUninstalledExtensions(){try{return await this.F()}catch(ie){throw(0,l.$Gq)(ie,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...ie){const x=ie.map(G=>h.$Np.create(G));await this.F(G=>x.forEach(T=>{G[T.toString()]=!0,this.z.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(ie){try{await this.F(x=>delete x[ie.toString()])}catch(x){throw(0,l.$Gq)(x,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(ie,x){if(this.w.extUri.isEqualOrParent(ie.location,this.t.userExtensionsLocation))return this.D(ie.identifier.id,ie.location,x)}async removeUninstalledExtension(ie){await this.removeExtension(ie,"uninstalled"),await this.F(x=>delete x[h.$Np.create(ie).toString()])}async copyExtension(ie,x,G,T){const X=await this.C(ie,x),he=await this.C(ie,G);if(T={...X?.metadata,...T},he)if(this.w.extUri.isEqual(he.location,ie.location))await this.u.updateMetadata([[ie,{...he.metadata,...T}]],G);else{const B=await this.scanLocalExtension(he.location,ie.type,G);await this.u.removeExtensionFromProfile(B,G),await this.u.addExtensionsToProfile([[ie,{...he.metadata,...T}]],G)}else await this.u.addExtensionsToProfile([[ie,T]],G);return this.scanLocalExtension(ie.location,ie.type,G)}async copyExtensions(ie,x,G){const T=await this.scanExtensions(q.ExtensionType.User,ie,G),X=await Promise.all(T.filter(he=>!he.isApplicationScoped).map(async he=>[he,await this.scanMetadata(he,ie)]));await this.u.addExtensionsToProfile(X,x)}async D(ie,x,G){this.z.trace(`Deleting ${G} extension from disk`,ie,x.fsPath);const T=this.w.extUri.joinPath(this.w.extUri.dirname(x),`${this.w.extUri.basename(x)}.${(0,o.$tj)((0,v.$2g)()).toString(16)}${M}`);await this.G(x.fsPath,T.fsPath),await this.s.del(T,{recursive:!0}),this.z.info(`Deleted ${G} extension from disk`,ie,x.fsPath)}F(ie){return this.g.queue(async()=>{let x;try{x=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,J.$rl)(T)!==J.FileOperationResult.FILE_NOT_FOUND)throw T}let G={};if(x)try{G=JSON.parse(x)}catch{}return ie&&(ie(G),Object.keys(G).length?await this.s.writeFile(this.c,E.$Ne.fromString(JSON.stringify(G))):await this.s.del(this.c)),G})}async G(ie,x){try{await g.Promises.rename(ie,x,2*60*1e3)}catch(G){throw(0,l.$Gq)(G,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(ie,x,G){try{if(G){const X=(await this.t.scanUserExtensions({profileLocation:G})).find(he=>this.w.extUri.isEqual(he.location,ie));if(X)return await this.H(X)}else{const T=await this.t.scanExistingExtension(ie,x,{includeInvalid:!0});if(T)return await this.H(T)}throw new r.$np(i.localize(11458,null,ie.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(T){throw(0,l.$Gq)(T,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(ie){const x=await this.s.resolve(ie.location);let G,T;return x.children&&(G=x.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,T=x.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:ie.identifier,type:ie.type,isBuiltin:ie.isBuiltin||!!ie.metadata?.isBuiltin,location:ie.location,manifest:ie.manifest,targetPlatform:ie.targetPlatform,validations:ie.validations,isValid:ie.isValid,readmeUrl:G,changelogUrl:T,publisherDisplayName:ie.metadata?.publisherDisplayName,publisherId:ie.metadata?.publisherId||null,isApplicationScoped:!!ie.metadata?.isApplicationScoped,isMachineScoped:!!ie.metadata?.isMachineScoped,isPreReleaseVersion:!!ie.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!ie.metadata?.hasPreReleaseVersion,preRelease:!!ie.metadata?.preRelease,installedTimestamp:ie.metadata?.installedTimestamp,updated:!!ie.metadata?.updated,pinned:!!ie.metadata?.pinned,isWorkspaceScoped:!1,source:ie.metadata?.source??(ie.identifier.uuid?"gallery":"vsix")}}async I(){const ie=await this.getUninstalledExtensions();if(Object.keys(ie).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(ie));const x=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const X of x)ie[h.$Np.create(X).toString()]||G.add(X.identifier.id.toLowerCase());try{const X=(0,h.$Sp)(x,he=>he.identifier);await s.Promises.settled(X.map(async he=>{const B=he.sort((U,H)=>u.rcompare(U.manifest.version,H.manifest.version))[0];G.has(B.identifier.id.toLowerCase())||await this.n(await this.H(B))}))}catch(X){this.z.error(X)}const T=x.filter(X=>X.metadata&&ie[h.$Np.create(X).toString()]);await Promise.allSettled(T.map(X=>this.removeUninstalledExtension(X)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let ie;try{ie=await this.s.resolve(this.t.userExtensionsLocation)}catch(x){(0,J.$rl)(x)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(x);return}if(ie?.children)try{await Promise.allSettled(ie.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(M))){this.z.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.s.del(x.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(G){(0,J.$rl)(G)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(G)}}}))}catch{}}};e.$1q=ne,e.$1q=ne=Be([je(1,J.$al),je(2,S.$Nq),je(3,c.$Jq),je(4,z.$Kl),je(5,le.$_l),je(6,de.$ak)],ne);let re=class extends l.$Hq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(ie,x,G,T,X,he,B,U,H,F,W,Y){super(),this.l=ie,this.manifest=x,this.source=G,this.options=T,this.m=X,this.n=he,this.o=B,this.p=U,this.q=H,this.s=F,this.t=W,this.u=Y,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(ie){const G=(await this.n.scanExtensions(q.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(B=>(0,h.$Mp)(B.identifier,this.identifier));G&&(this.j=r.InstallOperation.Update);const T={isApplicationScoped:this.options.isApplicationScoped||G?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||G?.isMachineScoped,isBuiltin:this.options.isBuiltin||G?.isBuiltin,isSystem:G?.type===q.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??G?.pinned,source:this.source instanceof f.URI?"vsix":"gallery"};let X;if(this.source instanceof f.URI){if(G&&this.l.equals(new h.$Np(G.identifier,G.manifest.version)))try{await this.n.removeExtension(G,"existing")}catch{throw new Error(i.localize(11459,null,this.manifest.displayName||this.manifest.name))}const B=await this.w(this.l);if(B)try{await this.n.removeExtension(B,"existing")}catch{throw new Error(i.localize(11460,null,this.manifest.displayName||this.manifest.name))}}else{if(T.id=this.source.identifier.uuid,T.publisherId=this.source.publisherId,T.publisherDisplayName=this.source.publisherDisplayName,T.targetPlatform=this.source.properties.targetPlatform,T.updated=!!G,T.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,T.hasPreReleaseVersion=G?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,T.preRelease=(0,d.$kg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||G?.preRelease,G&&G.type!==q.ExtensionType.System&&G.manifest.version===this.source.version)return this.n.updateMetadata(G,T,this.options.profileLocation);X=await this.w(this.l)}if(ie.isCancellationRequested)throw(0,l.$Gq)(new A.$4);if(!X){const B=await this.m(this.operation,ie);X=B.local,this.k=B.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(B){throw(0,l.$Gq)(B,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(ie.isCancellationRequested)throw(0,l.$Gq)(new A.$4);try{await this.t.addExtensionsToProfile([[X,T]],this.options.profileLocation,!X.isValid)}catch(B){throw(0,l.$Gq)(B,r.ExtensionManagementErrorCode.AddToProfile)}const he=await this.n.scanLocalExtension(X.location,q.ExtensionType.User,this.options.profileLocation);if(!he)throw new r.$np("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof f.URI&&this.x(X,ie),he}async w(ie){return(await this.n.getUninstalledExtensions())[ie.toString()]?(this.u.trace("Removing the extension from uninstalled list:",ie.id),await this.n.setInstalled(ie),this.u.info("Removed the extension from uninstalled list:",ie.id),(await this.n.scanAllUserExtensions(!0)).find(T=>h.$Np.create(T).equals(ie))):void 0}async x(ie,x){try{let[G]=await this.p.getExtensions([{id:ie.identifier.id,version:ie.manifest.version}],x);if(G||([G]=await this.p.getExtensions([{id:ie.identifier.id}],x)),G){const T={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:ie.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(ie,T,this.options.profileLocation)}}catch{}}};re=Be([je(6,z.$Kl),je(7,r.$lp),je(8,Q.$Ml),je(9,S.$Nq),je(10,c.$Jq),je(11,de.$ak)],re);class me extends l.$Hq{constructor(ie,x,G){super(),this.extension=ie,this.options=x,this.j=G}async h(ie){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(Re[139],Ae([1,0,11,33,35,24,53,15,28,4]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;let D=class extends C.$Kq{constructor(m,$,a,u,d,f){super(o.URI.file(m.extensionsPath),$,a,u,d,f)}};e.$JR=D,e.$JR=D=Be([je(0,y.$Ni),je(1,A.$al),je(2,s.$Ml),je(3,E.$Kl),je(4,k.$_l),je(5,t.$ak)],D)}),define(Re[99],Ae([1,0,13,6,2,43,10,184,5,33]),function(ue,e,t,s,E,k,C,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$kq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$iq=e.$hq=e.$gq=void 0,e.$jq=$,e.$lq=u,e.$nq=f,e.$gq="__$__isNewStorageMarker",e.$hq="__$__targetStorageMarker",e.$iq=(0,y.$Fi)("storageService");var D;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var w;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var m;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function $(v){const g=v.get(e.$hq);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}class a extends E.$Uc{static{this.a=60*1e3}constructor(g={flushInterval:a.a}){super(),this.m=g,this.b=this.B(new s.$oe),this.c=this.B(new s.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new s.$le),this.onWillSaveState=this.f.event,this.h=this.B(new t.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(g,b,i){return s.Event.filter(this.b.event,p=>p.scope===g&&(b===void 0||p.key===b),i)}n(){this.j.value=(0,t.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(g,b){const{key:i,external:p}=b;if(i===e.$hq){switch(g){case w.APPLICATION:this.H=void 0;break;case w.PROFILE:this.F=void 0;break;case w.WORKSPACE:this.C=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:i,target:this.J(g)[i],external:p})}w(g){this.f.fire({reason:g})}get(g,b,i){return this.P(b)?.get(g,i)}getBoolean(g,b,i){return this.P(b)?.getBoolean(g,i)}getNumber(g,b,i){return this.P(b)?.getNumber(g,i)}getObject(g,b,i){return this.P(b)?.getObject(g,i)}storeAll(g,b){this.y(()=>{for(const i of g)this.store(i.key,i.value,i.scope,i.target,b)})}store(g,b,i,p,n=!1){if((0,C.$ng)(b)){this.remove(g,i,n);return}this.y(()=>{this.z(g,i,p),this.P(i)?.set(g,b,n)})}remove(g,b,i=!1){this.y(()=>{this.z(g,b,void 0),this.P(b)?.delete(g,i)})}y(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,b){const i=[],p=this.J(g);for(const n of Object.keys(p))p[n]===b&&i.push(n);return i}z(g,b,i,p=!1){const n=this.J(b);typeof i=="number"?n[g]!==i&&(n[g]=i,this.P(b)?.set(e.$hq,JSON.stringify(n),p)):typeof n[g]=="number"&&(delete n[g],this.P(b)?.set(e.$hq,JSON.stringify(n),p))}get D(){return this.C||(this.C=this.L(w.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(w.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(w.APPLICATION)),this.H}J(g){switch(g){case w.APPLICATION:return this.I;case w.PROFILE:return this.G;default:return this.D}}L(g){const b=this.P(g);return b?$(b):Object.create(null)}isNew(g){return this.getBoolean(e.$gq,g)===!0}async flush(g=D.NONE){this.f.fire({reason:g});const b=this.P(w.APPLICATION),i=this.P(w.PROFILE),p=this.P(w.WORKSPACE);switch(g){case D.NONE:await t.Promises.settled([b?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await t.Promises.settled([b?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.P(w.APPLICATION)?.items??new Map,b=this.P(w.PROFILE)?.items??new Map,i=this.P(w.WORKSPACE)?.items??new Map;return f(g,b,i,this.Q(w.APPLICATION)??"",this.Q(w.PROFILE)??"",this.Q(w.WORKSPACE)??"")}async optimize(g){return await this.flush(),this.P(g)?.optimize()}async switch(g,b){return this.w(D.NONE),(0,o.$Ll)(g)?this.R(g,b):this.S(g,b)}M(g,b){return!(g.id===b.id||u(b)&&u(g))}N(g,b,i){this.y(()=>{const p=new Set;for(const[n,l]of g)p.add(n),b.get(n)!==l&&this.u(i,{key:n,external:!0});for(const[n]of b.items)p.has(n)||this.u(i,{key:n,external:!0})})}}e.$kq=a;function u(v){return v.isDefault||!!v.useDefaultFlags?.globalState}class d extends a{constructor(){super(),this.U=this.B(new A.$eq(new A.$fq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$eq(new A.$fq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$eq(new A.$fq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(g=>this.u(w.WORKSPACE,g))),this.B(this.W.onDidChangeStorage(g=>this.u(w.PROFILE,g))),this.B(this.U.onDidChangeStorage(g=>this.u(w.APPLICATION,g)))}P(g){switch(g){case w.APPLICATION:return this.U;case w.PROFILE:return this.W;default:return this.X}}Q(g){switch(g){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(g){return!1}}e.$mq=d;async function f(v,g,b,i,p,n){const l=P=>{try{return JSON.parse(P)}catch{return P}},r=new Map,h=new Map;v.forEach((P,q)=>{r.set(q,P),h.set(q,l(P))});const c=new Map,S=new Map;g.forEach((P,q)=>{c.set(q,P),S.set(q,l(P))});const I=new Map,R=new Map;b.forEach((P,q)=>{I.set(q,P),R.set(q,l(P))}),console.group(i!==p?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const L=[];if(r.forEach((P,q)=>{L.push({key:q,value:P})}),console.table(L),console.groupEnd(),console.log(h),i!==p){console.group(`Storage: Profile (path: ${p}, profile specific)`);const P=[];c.forEach((q,K)=>{P.push({key:K,value:q})}),console.table(P),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const O=[];I.forEach((P,q)=>{O.push({key:q,value:P})}),console.table(O),console.groupEnd(),console.log(R)}}),define(Re[245],Ae([1,0,14,22,99]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=k;async function k(C,A,y){let o=y&&y.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(o)return o;try{const w=(await A.readFile(C.serviceMachineIdResource)).value.toString();o=(0,s.$1g)(w)?w:null}catch{o=null}if(!o){o=(0,s.$2g)();try{await A.writeFile(C.serviceMachineIdResource,t.$Ne.fromString(o))}catch{}}return y?.store("storage.serviceMachineId",o,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),o}}),define(Re[246],Ae([1,0,245,24,40]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=k;async function k(C,A,y,o,D,w,m){const $={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${A.nameShort})`};if((0,E.$Ep)(A,y)&&(0,E.$Gp)(o)===s.TelemetryLevel.USAGE){const a=await(0,t.$oq)(y,D,w);$["X-Market-User-Id"]=a,$["VSCode-SessionId"]=m.machineId||a}return $}}),define(Re[140],Ae([1,0,17,18,9,3,31,10,4,27,28,30,38,21,73,15,11,29,46,246,99,24,47]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0,e.$qq=ie;const n=k.$p?$.TargetPlatform.WEB:(0,w.$hp)(k.$v,C.$ec),l="X-Market-Search-Activity-Id";var r;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function h(...B){return String(B.reduce((U,H)=>U|H,0))}var c;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const S={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},I={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},L={pageNumber:1,pageSize:10,sortBy:w.SortBy.NoneOrRelevance,sortOrder:w.SortOrder.Default,flags:r.None,criteria:[],assetTypes:[]};class O{constructor(U=L){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,H=this.d.pageSize){return new O({...this.d,pageNumber:U,pageSize:H})}withFilter(U,...H){const F=[...this.d.criteria,...H.length?H.map(W=>({filterType:U,value:W})):[{filterType:U}]];return new O({...this.d,criteria:F})}withSortBy(U){return new O({...this.d,sortBy:U})}withSortOrder(U){return new O({...this.d,sortOrder:U})}withFlags(...U){return new O({...this.d,flags:U.reduce((H,F)=>H|F,0)})}withAssetTypes(...U){return new O({...this.d,assetTypes:U})}withSource(U){return new O({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:H,pageSize:F,sortBy:W,sortOrder:Y,flags:ae,assetTypes:Ee}=this.d;return{filters:[{criteria:U,pageNumber:H,pageSize:F,sortBy:W,sortOrder:Y}],assetTypes:Ee,flags:ae}}get searchText(){const U=this.d.criteria.filter(H=>H.filterType===c.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function P(B,U){const H=(B||[]).filter(F=>F.statisticName===U)[0];return H?H.value:0}function q(B){const U="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(F=>F.assetType.indexOf(U)===0).reduce((F,W)=>{const Y=_(B,W.assetType);return Y&&F.push([W.assetType.substring(U.length),Y]),F},[])}function K(B){if(B.properties){const U=B.properties.filter(W=>W.key===S.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=U.filter(W=>H.test(W.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return _(B,S.Repository)}function J(B){return{uri:`${B.fallbackAssetUri}/${S.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${S.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function _(B,U){return B.files.filter(F=>F.assetType===U)[0]?{uri:`${B.assetUri}/${U}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${U}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function de(B,U){const H=B.properties?B.properties.filter(W=>W.key===U):[],F=H.length>0&&H[0].value;return F?F.split(",").map(W=>(0,m.$Qp)(W)):[]}function ge(B){const U=B.properties?B.properties.filter(H=>H.key===I.Engine):[];return U.length>0&&U[0].value||""}function le(B){const U=B.properties?B.properties.filter(H=>H.key===I.PreRelease):[];return U.length>0&&U[0].value==="true"}function z(B){const U=B.properties?B.properties.filter(H=>H.key===I.ExecutesCode):[];return U.length>0?U[0].value==="true":void 0}function Q(B){const U=B.properties?B.properties.filter(F=>F.key===I.EnabledApiProposals):[],H=U.length>0&&U[0].value||"";return H?H.split(","):[]}function M(B){const U=B.properties?B.properties.filter(F=>F.key===I.LocalizedLanguages):[],H=U.length>0&&U[0].value||"";return H?H.split(","):[]}function V(B){return B.properties?.find(U=>U.key===I.SponsorLink)?.value}function ne(B){return B.properties?.find(U=>U.key===I.SupportLink)?.value}function re(B){return B.indexOf("preview")!==-1}function me(B){return B.targetPlatform?(0,w.$gp)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function oe(B){const U=(0,t.$Lb)(B.versions.map(me)),H=!!B.tags?.includes(w.$ap),F=U.indexOf($.TargetPlatform.WEB);return H?F===-1&&U.push($.TargetPlatform.WEB):F!==-1&&U.splice(F,1),U}function ie(B,U){for(let H=0;H<B.length;H++){const F=B[H];if(F.version===B[H-1]?.version){let W=H;if(me(F)===U)for(;W>0&&B[W-1].version===F.version;)W--;W!==H&&(B.splice(H,1),B.splice(W,0,F))}}return B}function x(B,U,H){B.telemetryData={index:U,querySource:H,queryActivityId:B.queryContext?.[l]}}function G(B,U,H,F){const W=B.versions[0],Y={manifest:_(U,S.Manifest),readme:_(U,S.Details),changelog:_(U,S.Changelog),license:_(U,S.License),repository:K(U),download:J(U),icon:_(U,S.Icon),signature:_(U,S.Signature),coreTranslations:q(U)};return{type:"gallery",identifier:{id:(0,m.$Rp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:U.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(W),description:B.shortDescription??"",installCount:P(B.statistics,"install"),rating:P(B.statistics,"averagerating"),ratingCount:P(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:H,assets:Y,properties:{dependencies:de(U,I.Dependency),extensionPack:de(U,I.ExtensionPack),engine:ge(U),enabledApiProposals:Q(U),localizedLanguages:M(U),targetPlatform:me(U),isPreReleaseVersion:le(U),executesCode:z(U)},hasPreReleaseVersion:le(W),hasReleaseVersion:!0,preview:re(B.flags),isSigned:!!Y.signature,queryContext:F,supportLink:ne(W)}}let T=class{constructor(U,H,F,W,Y,ae,Ee,Le){this.l=H,this.n=F,this.o=W,this.q=Y,this.u=ae,this.w=Ee,this.x=Le;const be=Ee.extensionsGallery,pe=be?.servicePPEUrl&&Le.getValue("_extensionsGallery.enablePPE");this.d=pe?be.servicePPEUrl:be?.serviceUrl,this.g=pe?void 0:be?.searchUrl,this.h=be?.controlUrl,this.k=Ee.extensionsEnabledWithApiProposalVersion?.map(we=>we.toLowerCase())??[],this.j=(0,g.$pq)(Ee.version,Ee,this.o,this.x,this.u,U,this.q)}y(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,H,F){const W=s.CancellationToken.isCancellationToken(H)?{}:H,Y=s.CancellationToken.isCancellationToken(H)?H:F,ae=[],Ee=[],Le=[],be=[];let pe=!0;for(const ce of U){ce.uuid?Ee.push(ce.uuid):ae.push(ce.id);const ye=!!(ce.version||ce.preRelease);Le.push({id:ce.id,uuid:ce.uuid,includePreRelease:ye}),ce.version&&be.push({id:ce.id,uuid:ce.uuid,version:ce.version}),pe=pe&&!!ce.hasPreRelease&&!ye}if(!Ee.length&&!ae.length)return[];let we=new O().withPage(1,U.length);Ee.length&&(we=we.withFilter(c.ExtensionId,...Ee)),ae.length&&(we=we.withFilter(c.ExtensionName,...ae)),(W.queryAllVersions||pe)&&(we=we.withFlags(we.flags,r.IncludeVersions)),W.source&&(we=we.withSource(W.source));const{extensions:Te}=await this.B(we,{targetPlatform:W.targetPlatform??n,includePreRelease:Le,versions:be,compatible:!!W.compatible,productVersion:W.productVersion??{version:this.w.version,date:this.w.date}},Y);return W.source&&Te.forEach((ce,ye)=>x(ce,ye,W.source)),Te}async getCompatibleExtension(U,H,F,W={version:this.w.version,date:this.w.date}){if((0,w.$ip)(U.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(U,H,F))return U;const Y=new O().withFlags(r.IncludeVersions).withPage(1,1).withFilter(c.ExtensionId,U.identifier.uuid),{extensions:ae}=await this.B(Y,{targetPlatform:F,compatible:!0,includePreRelease:H,productVersion:W},s.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(U,H,F,W={version:this.w.version,date:this.w.date}){if(!(0,w.$jp)(U.properties.targetPlatform,U.allTargetPlatforms,F)||!H&&U.properties.isPreReleaseVersion)return!1;let Y=U.properties.engine;if(!Y){const ae=await this.getManifest(U,s.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return!(!(0,a.$6p)(Y,W.version,W.date)||!this.z(U.identifier,U.properties.enabledApiProposals))}z(U,H){return!H||!this.k.includes(U.id.toLowerCase())?!0:(0,a.$7p)(H)}async A(U,H,F,W,Y,ae,Ee={version:this.w.version,date:this.w.date}){if(!(0,w.$jp)(me(H),Y,ae)||F!=="any"&&le(H)!==(F==="prerelease"))return!1;if(W)try{const Le=await this.G(U,H);if(!(0,a.$6p)(Le,Ee.version,Ee.date))return!1}catch(Le){return this.n.error(`Error while getting the engine for the version ${H.version}.`,(0,E.$9)(Le)),!1}return!0}async query(U,H){let F=U.text||"";const W=U.pageSize??50;let Y=new O().withPage(1,W);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,we,Te)=>(Y=Y.withFilter(c.Category,Te||we),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,we,Te)=>(Y=Y.withFilter(c.Tag,Te||we),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(c.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),Y=Y.withFilter(c.SearchText,F)),Y=Y.withSortBy(w.SortBy.NoneOrRelevance)):U.ids?Y=Y.withFilter(c.ExtensionId,...U.ids):U.names?Y=Y.withFilter(c.ExtensionName,...U.names):Y=Y.withSortBy(w.SortBy.InstallCount),typeof U.sortBy=="number"&&(Y=Y.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(Y=Y.withSortOrder(U.sortOrder)),U.source&&(Y=Y.withSource(U.source));const ae=async(pe,we)=>{const{extensions:Te,total:ce}=await this.B(pe,{targetPlatform:n,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.w.version,date:this.w.date}},we);return Te.forEach((ye,ve)=>x(ye,(pe.pageNumber-1)*pe.pageSize+ve,U.source)),{extensions:Te,total:ce}},{extensions:Ee,total:Le}=await ae(Y,H),be=async(pe,we)=>{if(we.isCancellationRequested)throw new E.$4;const{extensions:Te}=await ae(Y.withPage(pe+1),we);return Te};return{firstPage:Ee,total:Le,pageSize:Y.pageSize,getPage:be}}async B(U,H,F){const W=U.flags;U.flags&r.IncludeLatestVersionOnly&&U.flags&r.IncludeVersions&&(U=U.withFlags(U.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(U.flags&r.IncludeLatestVersionOnly)&&!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags,r.IncludeLatestVersionOnly)),H.versions?.length&&(U=U.withFlags(U.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),U=U.withFlags(U.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:Ee}=await this.D(U,F);if(!(U.flags&r.IncludeLatestVersionOnly)){const we=[];for(const Te of Y){const ce=await this.C(Te,H,Ee);ce&&we.push(ce)}return{extensions:we,total:ae}}const be=[],pe=new Map;for(let we=0;we<Y.length;we++){const Te=Y[we],ce={id:(0,m.$Rp)(Te.publisher.publisherName,Te.extensionName),uuid:Te.extensionId},ye=(0,A.$kg)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(ze=>(0,m.$Mp)(ze,ce))?.includePreRelease;if(H.compatible&&(0,w.$ip)(oe(Te),H.targetPlatform))continue;const ve=await this.C(Te,H,Ee);!ve||ve.properties.isPreReleaseVersion&&(!ye||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==H.targetPlatform&&ve.hasPreReleaseVersion?pe.set(Te.extensionId,we):be.push([we,ve])}if(pe.size){const we=new p.$fe,Te=new O().withFlags(W&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,pe.size).withFilter(c.ExtensionId,...pe.keys()),{extensions:ce}=await this.B(Te,H,F);this.q.publicLog2("galleryService:additionalQuery",{duration:we.elapsed(),count:pe.size});for(const ye of ce){const ve=pe.get(ye.identifier.uuid);be.push([ve,ye])}}return{extensions:be.sort((we,Te)=>we[0]-Te[0]).map(([,we])=>we),total:ae}}async C(U,H,F){const W={id:(0,m.$Rp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},Y=H.versions?.find(be=>(0,m.$Mp)(be,W))?.version,ae=(0,A.$kg)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(be=>(0,m.$Mp)(be,W))?.includePreRelease,Ee=oe(U),Le=ie(U.versions,H.targetPlatform);if(H.compatible&&(0,w.$ip)(Ee,H.targetPlatform))return null;for(let be=0;be<Le.length;be++){const pe=Le[be];if(!(Y&&pe.version!==Y)){if(await this.A(W.id,pe,ae?"any":"release",H.compatible,Ee,H.targetPlatform,H.productVersion))return H.compatible&&!this.z(W,Q(pe))?null:G(U,pe,Ee,F);if(Y&&pe.version===Y)return null}}return Y||H.compatible?null:G(U,U.versions[0],Ee)}async D(U,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,r.ExcludeNonValidated).withFilter(c.Target,"Microsoft.VisualStudio.Code").withFilter(c.ExcludeWithFlags,h(r.Unpublished));const F=await this.j,W=JSON.stringify(U.raw),Y={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ae=new p.$fe;let Ee,Le,be=0;try{if(Ee=await this.l.request({type:"POST",url:this.g&&U.criteria.some(we=>we.filterType===c.SearchText)?this.g:this.y("/extensionquery"),data:W,headers:Y},H),Ee.res.statusCode&&Ee.res.statusCode>=400&&Ee.res.statusCode<500)return{galleryExtensions:[],total:be};const pe=await(0,v.$bq)(Ee);if(pe){const we=pe.results[0],Te=we.extensions,ce=we.resultMetadata&&we.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return be=ce&&ce.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:be,context:Ee.res.headers.activityid?{[l]:Ee.res.headers.activityid}:{}}}return{galleryExtensions:[],total:be}}catch(pe){if((0,E.$3)(pe))throw Le=w.ExtensionGalleryErrorCode.Cancelled,pe;{const we=(0,E.$9)(pe);throw Le=we.startsWith("XHR timeout")?w.ExtensionGalleryErrorCode.Timeout:w.ExtensionGalleryErrorCode.Failed,new w.$mp(we,Le)}}finally{this.q.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(W.length),duration:ae.elapsed(),success:!!Ee&&(0,v.$0p)(Ee),responseBodySize:Ee?.res.headers["Content-Length"],statusCode:Ee?String(Ee.res.statusCode):void 0,errorCode:Le,count:String(be)})}}async reportStatistic(U,H,F,W){if(!this.isEnabled())return;const Y=k.$p?this.y(`/itemName/${U}.${H}/version/${F}/statType/${W===w.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${U}/extensions/${H}/${F}/stats?statType=${W}`),ae=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Le={...await this.j,Accept:ae};try{await this.l.request({type:"POST",url:Y,headers:Le},s.CancellationToken.None)}catch{}}async download(U,H,F){this.n.trace("ExtensionGalleryService#download",U.identifier.id);const W=(0,m.$Up)(U),Y=new Date().getTime(),ae=F===w.InstallOperation.Install?"install":F===w.InstallOperation.Update?"update":"",Ee=ae?{uri:`${U.assets.download.uri}${y.URI.parse(U.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${U.assets.download.fallbackUri}${y.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:U.assets.download,Le=U.queryContext?.[l]?{[l]:U.queryContext[l]}:void 0,be=await this.F(U.identifier.id,Ee,S.VSIX,Le?{headers:Le}:void 0);try{await this.u.writeFile(H,be.stream)}catch(pe){try{await this.u.del(H)}catch(we){this.n.warn(`Error while deleting the file ${H.toString()}`,(0,E.$9)(we))}throw new w.$mp((0,E.$9)(pe),w.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...W,duration:new Date().getTime()-Y})}async downloadSignatureArchive(U,H){if(!U.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const F=await this.F(U.identifier.id,U.assets.signature,S.Signature);try{await this.u.writeFile(H,F.stream)}catch(W){try{await this.u.del(H)}catch(Y){this.n.warn(`Error while deleting the file ${H.toString()}`,(0,E.$9)(Y))}throw new w.$mp((0,E.$9)(W),w.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,H){if(U.assets.readme){const F=await this.F(U.identifier.id,U.assets.readme,S.Details,{},H);return await(0,v.$aq)(F)||""}return""}async getManifest(U,H){if(U.assets.manifest){const F=await this.F(U.identifier.id,U.assets.manifest,S.Manifest,{},H),W=await(0,v.$aq)(F);return W?JSON.parse(W):null}return null}async E(U,H,F){const W=_(H,S.Manifest);if(!W)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.F(U,W,S.Manifest,{headers:Y});return await(0,v.$bq)(ae)}async getCoreTranslation(U,H){const F=U.assets.coreTranslations.filter(W=>W[0]===H.toUpperCase())[0];if(F){const W=await this.F(U.identifier.id,F[1],F[0]),Y=await(0,v.$aq)(W);return Y?JSON.parse(Y):null}return null}async getChangelog(U,H){if(U.assets.changelog){const F=await this.F(U.identifier.id,U.assets.changelog,S.Changelog,{},H);return await(0,v.$aq)(F)||""}return""}async getAllCompatibleVersions(U,H,F){let W=new O().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);U.uuid?W=W.withFilter(c.ExtensionId,U.uuid):W=W.withFilter(c.ExtensionName,U.id);const{galleryExtensions:Y}=await this.D(W,s.CancellationToken.None);if(!Y.length)return[];const ae=oe(Y[0]);if((0,w.$ip)(ae,F))return[];const Ee=[];await Promise.all(Y[0].versions.map(async pe=>{try{await this.A(U.id,pe,H?"any":"release",!0,ae,F)&&this.z(U,Q(pe))&&Ee.push(pe)}catch{}}));const Le=[],be=new Set;for(const pe of ie(Ee,F))be.has(pe.version)||(be.add(pe.version),Le.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:le(pe)}));return Le}async F(U,H,F,W={},Y=s.CancellationToken.None){const ae=await this.j,Ee={type:"GET"},Le={...ae,...W.headers||{}};W={...W,...Ee,headers:Le};const be=H.uri,pe=H.fallbackUri,we={...W,url:be};try{const Te=await this.l.request(we,Y);if(Te.res.statusCode===200)return Te;const ce=await(0,v.$aq)(Te);throw new Error(`Expected 200, got back ${Te.res.statusCode} instead.

${ce}`)}catch(Te){if((0,E.$3)(Te))throw Te;const ce=(0,E.$9)(Te);this.q.publicLog2("galleryService:cdnFallback",{extension:U,assetType:F,message:ce});const ye={...W,url:pe};return this.l.request(ye,Y)}}async G(U,H){let F=ge(H);if(!F){this.q.publicLog2("galleryService:engineFallback",{extension:U,version:H.version});const W=await this.E(U,H,s.CancellationToken.None);if(!W)throw new Error("Manifest was not found");F=W.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const U=await this.l.request({type:"GET",url:this.h},s.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,v.$bq)(U),F=[],W={},Y=[],ae=[];if(H){for(const Ee of H.malicious)F.push({id:Ee});if(H.migrateToPreRelease)for(const[Ee,Le]of Object.entries(H.migrateToPreRelease))(!Le.engine||(0,a.$6p)(Le.engine,this.w.version,this.w.date))&&(W[Ee.toLowerCase()]={disallowInstall:!0,extension:{id:Le.id,displayName:Le.displayName,autoMigrate:{storage:!!Le.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[Ee,Le]of Object.entries(H.deprecated))Le&&(W[Ee.toLowerCase()]=(0,A.$kg)(Le)?{}:Le);if(H.search)for(const Ee of H.search)Y.push(Ee);if(Array.isArray(H.extensionsEnabledWithPreRelease))for(const Ee of H.extensionsEnabledWithPreRelease)ae.push(Ee.toLowerCase())}return{malicious:F,deprecated:W,search:Y,extensionsEnabledWithPreRelease:ae}}};T=Be([je(1,v.$8p),je(2,d.$ak),je(3,D.$Mi),je(4,i.$_l),je(5,u.$al),je(6,f.$tk),je(7,o.$_i)],T);let X=class extends T{constructor(U,H,F,W,Y,ae,Ee,Le){super(U,H,F,W,Y,ae,Ee,Le)}};e.$rq=X,e.$rq=X=Be([je(0,b.$iq),je(1,v.$8p),je(2,d.$ak),je(3,D.$Mi),je(4,i.$_l),je(5,u.$al),je(6,f.$tk),je(7,o.$_i)],X);let he=class extends T{constructor(U,H,F,W,Y,ae,Ee){super(void 0,U,H,F,W,Y,ae,Ee)}};e.$sq=he,e.$sq=he=Be([je(0,v.$8p),je(1,d.$ak),je(2,D.$Mi),je(3,i.$_l),je(4,u.$al),je(5,f.$tk),je(6,o.$_i)],he)}),define(Re[247],Ae([1,0,6,2,33,58]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RR=e.$QR=void 0;class C{constructor(o,D){this.a=o,this.b=D}listen(o,D){const w=this.b(o);switch(D){case"onDidChangeProfiles":return t.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map($=>(0,k.$On)({...$},w)),added:m.added.map($=>(0,k.$On)({...$},w)),removed:m.removed.map($=>(0,k.$On)({...$},w)),updated:m.updated.map($=>(0,k.$On)({...$},w))}))}throw new Error(`Invalid listen ${D}`)}async call(o,D,w){const m=this.b(o);switch(D){case"createProfile":{const $=await this.a.createProfile(w[0],w[1],w[2]);return(0,k.$On)({...$},m)}case"updateProfile":{let $=(0,E.$Nl)((0,k.$Pn)(w[0],m),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,w[1]),(0,k.$On)({...$},m)}case"removeProfile":{const $=(0,E.$Nl)((0,k.$Pn)(w[0],m),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${D}`)}}e.$QR=C;class A extends s.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(o,D,w){super(),this.profilesHome=D,this.f=w,this.a=[],this.b=this.B(new t.$le),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=o.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const $=m.added.map(d=>(0,E.$Nl)(d,this.profilesHome.scheme)),a=m.removed.map(d=>(0,E.$Nl)(d,this.profilesHome.scheme)),u=m.updated.map(d=>(0,E.$Nl)(d,this.profilesHome.scheme));this.a=m.all.map(d=>(0,E.$Nl)(d,this.profilesHome.scheme)),this.b.fire({added:$,removed:a,updated:u,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(o){this.c=o}isEnabled(){return this.c}async createNamedProfile(o,D,w){const m=await this.f.call("createNamedProfile",[o,D,w]);return(0,E.$Nl)(m,this.profilesHome.scheme)}async createProfile(o,D,w,m){const $=await this.f.call("createProfile",[o,D,w,m]);return(0,E.$Nl)($,this.profilesHome.scheme)}async createTransientProfile(o){const D=await this.f.call("createTransientProfile",[o]);return(0,E.$Nl)(D,this.profilesHome.scheme)}async setProfileForWorkspace(o,D){await this.f.call("setProfileForWorkspace",[o,D])}removeProfile(o){return this.f.call("removeProfile",[o])}async updateProfile(o,D){const w=await this.f.call("updateProfile",[o,D]);return(0,E.$Nl)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$RR=A}),define(Re[141],Ae([1,0,4,28,15,11,225,35,33,10,226]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";var w,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$IR=e.$HR=e.$GR=void 0;let $=class extends y.$Pl{static{w=this}static{this.a="profileAssociationsMigration"}constructor(f,v,g,b,i){super(g,b,v,i),this.U=f,this.W=g}O(){return this.U.getItem(w.b,[]).map(v=>({...v,location:(0,o.$eg)(v.location)?this.w.extUri.joinPath(this.profilesHome,v.location):t.URI.revive(v.location)}))}Q(){const f=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(t.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$GR=$,e.$GR=$=w=Be([je(0,C.$BR),je(1,A.$Kl),je(2,s.$Ni),je(3,E.$al),je(4,k.$ak)],$);let a=m=class extends ${constructor(f,v,g,b,i){super(f,v,g,b,i),this.$=f}P(f){f.length?this.$.setItem(m.b,f.map(v=>({...v,location:this.w.extUri.basename(v.location)}))):this.$.removeItem(m.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(m.c,f):this.$.removeItem(m.c)}Q(){const f="workspaceAndProfileInfo",v=this.$.getItem(f,void 0);if(v){this.$.removeItem(f);const b=v.reduce((i,{workspace:p,profile:n})=>(i[t.URI.revive(p).toString()]=t.URI.revive(n).toString(),i),{});this.$.setItem(m.c,{workspaces:b})}const g=super.Q();return this.$.getItem(m.a,!1)||(this.R(g),this.$.setItem(m.a,!0)),g}};e.$HR=a,e.$HR=a=m=Be([je(0,C.$CR),je(1,A.$Kl),je(2,s.$Ni),je(3,E.$al),je(4,k.$ak)],a);let u=class extends a{constructor(f,v,g,b){super(new D.$FR(D.SaveStrategy.IMMEDIATE,v,b,g),f,v,g,b)}async init(){return await this.$.init(),super.init()}};e.$IR=u,e.$IR=u=Be([je(0,A.$Kl),je(1,s.$Ni),je(2,E.$al),je(3,k.$ak)],u)}),define(Re[142],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$Ym=(0,t.$Fi)("extensionHostStatusService");class s{constructor(){this.a=new Map}setExitInfo(k,C){this.a.set(k,C)}getExitInfo(k){return this.a.get(k)||null}}e.$Zm=s}),define(Re[248],Ae([1,0,60,6,13]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0;function k(A){let y=0,o=0,D=0;A>=1e3&&(D=Math.floor(A/1e3),A-=D*1e3),D>=60&&(o=Math.floor(D/60),D-=o*60),o>=60&&(y=Math.floor(o/60),o-=y*60);const w=y?`${y}h`:"",m=o?`${o}m`:"",$=D?`${D}s`:"",a=A?`${A}ms`:"";return`${w}${m}${$}${a}`}class C{constructor(y,o,D,w){this.i=y,this.j=o,this.a=new s.$le,this.onClose=this.a.event,this.b=t.ProtocolConstants.ReconnectionGraceTime,this.c=t.ProtocolConstants.ReconnectionShortGraceTime,this.d=D,this.protocol=w,this.e=!1,this.f=new E.$Sh(()=>{this.k(`The reconnection grace time of ${k(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new E.$Sh(()=>{this.k(`The reconnection short grace time of ${k(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${k(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(y){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${y}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${k(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const y=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),y.end(),this.a.fire(void 0)}acceptReconnection(y,o,D){this.d=y,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(o,D),this.protocol.endAcceptReconnection()}}e.$Fn=C});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[143],Ae([1,0,12,8,180,26,61]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=D,C=dt(C);const A=(0,s.$jc)(t.$Zg.asFileUri("").fsPath),y=(0,s.$jc)(A,"nls.messages.json"),o=new Map;async function D(w,m){if(!C.default.commit||!await k.Promises.exists(y))return{userLocale:"en",osLocale:"en",resolvedLanguage:"en",defaultMessagesFile:y,locale:"en",availableLanguages:{}};const $=`${w}||${m}`;let a=o.get($);return a||(a=(0,E.resolveNLSConfiguration)({userLocale:w,osLocale:w,commit:C.default.commit,userDataPath:m,nlsMetadataPath:A}),o.set($,a)),a}}),define(Re[144],Ae([1,0,19,4,28,53,63,15,5,11,29,35,33,143]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=void 0;let a=class extends C.$Oq{constructor(d,f,v,g,b,i,p,n){super(s.URI.file(b.builtinExtensionsPath),s.URI.file(b.extensionsPath),(0,t.$gh)(b.userHome,".vscode-oss-dev","extensions","control.json"),d.defaultProfile,d,f,v,g,b,i,p,n),this.S=b}async f(d){const f=await(0,$.$1m)(d,this.S.userDataPath);if(f.languagePack)try{const v=await this.w.readFile(s.URI.file(f.languagePack.translationsConfigFile));return JSON.parse(v.value.toString())}catch{}return Object.create(null)}};e.$wR=a,e.$wR=a=Be([je(0,m.$Ml),je(1,k.$Jq),je(2,A.$al),je(3,o.$ak),je(4,E.$Ni),je(5,D.$tk),je(6,w.$Kl),je(7,y.$Ei)],a)}),define(Re[100],Ae([1,0,249,23,8,22,12,26]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Hn=e.$Gn=e.ServerConnectionTokenType=void 0,e.$Jn=$,e.$Kn=a,e.$Ln=u,t=Ue(t),s=Ue(s),E=Ue(E);const y=/^[0-9A-Za-z_-]+$/;var o;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(o||(e.ServerConnectionTokenType=o={}));class D{constructor(){this.type=o.None}validate(f){return!0}}e.$Gn=D;class w{constructor(f){this.value=f,this.type=o.Mandatory}validate(f){return f===this.value}}e.$Hn=w;class m{constructor(f){this.message=f}}e.$In=m;async function $(d,f){const v=d["without-connection-token"],g=d["connection-token"],b=d["connection-token-file"];if(v)return typeof g<"u"||typeof b<"u"?new m("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof b<"u"){if(typeof g<"u")return new m("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let i;try{i=s.readFileSync(b).toString().replace(/\r?\n$/,"")}catch{return new m(`Unable to read the connection token file at '${b}'.`)}return y.test(i)?new w(i):new m(`The connection token defined in '${b} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof g<"u"?y.test(g)?new w(g):new m(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):new w(await f())}async function a(d){return $(d,async()=>{if(!d["user-data-dir"])return(0,k.$2g)();const v=E.$jc(d["user-data-dir"],"token");try{const i=(await s.promises.readFile(v)).toString().replace(/\r?\n$/,"");if(y.test(i))return i}catch{}const g=(0,k.$2g)();try{await A.Promises.writeFile(v,g,{mode:384})}catch{}return g})}function u(d,f,v){if(d.validate(v.query[C.$Rg]))return!0;const g=t.parse(f.headers.cookie||"");return d.validate(g[C.$Qg])}}),define(Re[54],Ae([1,0,7,117,69,5,28,77]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,t=Ue(t),e.$_m={host:{type:"string",cat:"o",args:"ip-address",description:t.localize(12801,null)},port:{type:"string",cat:"o",args:"port | port range",description:t.localize(12802,null)},"socket-path":{type:"string",cat:"o",args:"path",description:t.localize(12803,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:t.localize(12804,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:t.localize(12805,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:t.localize(12806,null)},"without-connection-token":{type:"boolean",cat:"o",description:t.localize(12807,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:t.localize(12808,null)},"server-data-dir":{type:"string",cat:"o",description:t.localize(12809,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:t.localize(12810,null)},"user-data-dir":E.$Cm["user-data-dir"],"enable-smoke-test-driver":E.$Cm["enable-smoke-test-driver"],"disable-telemetry":E.$Cm["disable-telemetry"],"disable-workspace-trust":E.$Cm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:E.$Cm.log,logsPath:E.$Cm.logsPath,"force-disable-user-env":E.$Cm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:t.localize(12811,null)},"default-workspace":{type:"string",description:t.localize(12812,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":E.$Cm["extensions-dir"],"extensions-download-dir":E.$Cm["extensions-download-dir"],"builtin-extensions-dir":E.$Cm["builtin-extensions-dir"],"install-extension":E.$Cm["install-extension"],"install-builtin-extension":E.$Cm["install-builtin-extension"],"update-extensions":E.$Cm["update-extensions"],"uninstall-extension":E.$Cm["uninstall-extension"],"list-extensions":E.$Cm["list-extensions"],"locate-extension":E.$Cm["locate-extension"],"show-versions":E.$Cm["show-versions"],category:E.$Cm.category,force:E.$Cm.force,"do-not-sync":E.$Cm["do-not-sync"],"pre-release":E.$Cm["pre-release"],"start-server":{type:"boolean",cat:"e",description:t.localize(12813,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:E.$Cm.help,version:E.$Cm.version,"locate-shell-integration-path":E.$Cm["locate-shell-integration-path"],compatibility:{type:"string"},_:E.$Cm._},e.$an=(0,k.$Gi)(C.$Mi);class y extends s.$9m{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$bn=y,Be([A.$0h],y.prototype,"userRoamingDataHome",null)}),define(Re[250],Ae([1,0,23,83,92,249,95,36,65,3,11,54,8,12,22,29,100,46,18,4,14,10,34]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=e.CacheControl=void 0,e.$VR=l,e.$WR=h,s=Ue(s),E=Ue(E),k=Ue(k),C=Ue(C);const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function l(I,R,L,O){R.writeHead(L,{"Content-Type":"text/plain"}),R.end(O)}var r;(function(I){I[I.NO_CACHING=0]="NO_CACHING",I[I.ETAG=1]="ETAG",I[I.NO_EXPIRY=2]="NO_EXPIRY"})(r||(e.CacheControl=r={}));async function h(I,R,L,O,P,q){try{const K=await t.promises.stat(I);if(R===r.ETAG){const J=`W/"${[K.ino,K.size,K.mtime.getTime()].join("-")}"`;if(O.headers["if-none-match"]===J)return P.writeHead(304),void P.end();q.Etag=J}else R===r.NO_EXPIRY?q["Cache-Control"]="public, max-age=31536000":R===r.NO_CACHING&&(q["Cache-Control"]="no-store");q["Content-Type"]=n[(0,m.$oc)(I)]||(0,y.$at)(I)||"text/plain",P.writeHead(200,q),(0,t.createReadStream)(I).pipe(P)}catch(K){return K.code!=="ENOENT"?(L.error(K),console.error(K.toString())):console.error(`File not found: ${I}`),P.writeHead(404,{"Content-Type":"text/plain"}),void P.end("Not found")}}const c=(0,m.$mc)($.$Zg.asFileUri("").fsPath);let S=class{constructor(R,L,O,P,q,K,J){this.f=R,this.g=L,this.serverRootPath=O,this.h=P,this.i=q,this.j=K,this.k=J,this.a=this.k.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${O}/static`,this.c=`${O}/callback`,this.d=`${O}/web-extension-resource`}async handle(R,L,O){try{const P=O.pathname;return P.startsWith(this.b)&&P.charCodeAt(this.b.length)===p.CharCode.Slash?this.l(R,L,O):P===this.g?this.o(R,L,O):P===this.c?this.q(L):P.startsWith(this.d)&&P.charCodeAt(this.d.length)===p.CharCode.Slash?this.n(R,L,O):l(R,L,404,"Not found.")}catch(P){return this.i.error(P),console.error(P.toString()),l(R,L,500,"Internal Server Error.")}}async l(R,L,O){const P=Object.create(null),K=decodeURIComponent(O.pathname).substring(this.b.length+1),J=(0,m.$jc)(c,K);return(0,A.$Eg)(J,c,!o.$l)?h(J,this.h.isBuilt?r.NO_EXPIRY:r.ETAG,this.i,R,L,P):l(R,L,400,"Bad request.")}m(R){const L=R.authority.indexOf(".");return L!==-1?R.authority.substring(L+1):void 0}async n(R,L,O){if(!this.a)return l(R,L,500,"No extension gallery service configured.");const P=decodeURIComponent(O.pathname),q=(0,m.$hc)(P.substring(this.d.length+1)),K=g.URI.parse(q).with({scheme:this.a.scheme,authority:q.substring(0,q.indexOf("/")),path:q.substring(q.indexOf("/")+1)});if(this.m(this.a)!==this.m(K))return l(R,L,403,"Request Forbidden");const J={},_=M=>{const V=R.headers[M];V&&((0,i.$eg)(V)||V[0])?J[M]=(0,i.$eg)(V)?V:V[0]:M!==M.toLowerCase()&&_(M.toLowerCase())};_("X-Client-Name"),_("X-Client-Version"),_("X-Machine-Id"),_("X-Client-Commit");const de=await this.j.request({type:"GET",url:K.toString(!0),headers:J},v.CancellationToken.None),ge=de.res.statusCode||500;if(ge!==200){let M=null;try{M=await(0,f.$aq)(de)}catch{}return l(R,L,ge,M||`Request failed with status ${ge}`)}const le=Object.create(null),z=M=>{const V=de.res.headers[M];V?le[M]=V:M!==M.toLowerCase()&&z(M.toLowerCase())};z("Cache-Control"),z("Content-Type"),L.writeHead(200,le);const Q=await(0,b.$Ze)(de.stream);return void L.end(Q.buffer)}async o(R,L,O){const P=O.query[$.$Rg];if(typeof P=="string"){const X=Object.create(null);X["Set-Cookie"]=k.serialize($.$Qg,P,{sameSite:"lax",maxAge:60*60*24*7});const he=Object.create(null);for(const U in O.query)U!==$.$Rg&&(he[U]=O.query[U]);const B=E.format({pathname:O.pathname,query:he});return X.Location=B,L.writeHead(302,X),void L.end()}const q=X=>{const he=R.headers[X];return Array.isArray(he)?he[0]:he},K=!this.h.isBuilt&&this.h.args["use-test-resolver"],J=K?"test+test":q("x-original-host")||q("x-forwarded-host")||R.headers.host;if(!J)return l(R,L,400,"Bad request.");function _(X){return JSON.stringify(X).replace(/"/g,"&quot;")}let de;this.h.args["enable-smoke-test-driver"]&&(de=!1);const ge=X=>X&&g.URI.file(s.resolve(X)).with({scheme:$.Schemas.vscodeRemote,authority:J}),le=$.$Zg.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,z=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,a.$2g)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,Q={embedderIdentifier:"server-distro",extensionsGallery:this.a&&this.k.extensionsGallery?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:J,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const X=JSON.parse((await t.promises.readFile((0,m.$jc)(c,"product.overrides.json"))).toString());Object.assign(Q,X)}catch{}const M={remoteAuthority:J,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:de,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:ge(this.h.args["default-folder"]),workspaceUri:ge(this.h.args["default-workspace"]),productConfiguration:Q,callbackRoute:this.c},ne=k.parse(R.headers.cookie||"")["vscode.nls.locale"]||R.headers["accept-language"]?.split(",")[0]?.toLowerCase()||"en";let re,me;!ne.startsWith("en")&&this.k.nlsCoreBaseUrl?(re=this.k.nlsCoreBaseUrl,me=`${re}${this.k.commit}/${this.k.version}/${ne}/nls.messages.js`):me="";const oe={WORKBENCH_WEB_CONFIGURATION:_(M),WORKBENCH_AUTH_SESSION:z?_(z):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_URL:me,WORKBENCH_NLS_FALLBACK_URL:`${this.b}/out/nls.messages.js`};if(K){const X=[];for(const he of["vscode-test-resolver","github-authentication"]){const B=JSON.parse((await t.promises.readFile($.$Zg.asFileUri(`${$.$Ug}/${he}/package.json`).fsPath)).toString());X.push({extensionPath:he,packageJSON:B})}oe.WORKBENCH_BUILTIN_EXTENSIONS=_(X)}let ie;try{ie=(await t.promises.readFile(le)).toString().replace(/\{\{([^}]+)\}\}/g,(he,B)=>oe[B]??"undefined")}catch{return L.writeHead(404,{"Content-Type":"text/plain"}),void L.end("Not found")}const T={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${re??""} ${this.p(ie).join(" ")} 'sha256-V28GQnL3aYxbwgpV3yW1oJ+VKKe/PBSzWntNyH8zVXA=' ${K?"":`http://${J}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==d.ServerConnectionTokenType.None&&(T["Set-Cookie"]=k.serialize($.$Qg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),L.writeHead(200,T),void L.end(ie)}p(R){const L=/<script>([\s\S]+?)<\/script>/img,O=[];let P;for(;P=L.exec(R);){const q=C.createHash("sha256"),K=P[1].replace(/\r\n/g,`
`),J=q.update(Buffer.from(K)).digest().toString("base64");O.push(`'sha256-${J}'`)}return O}async q(R){const L=$.$Zg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,O=(await t.promises.readFile(L)).toString(),P=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(O).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return R.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":P}),void R.end(O)}};e.$XR=S,e.$XR=S=Be([je(3,w.$an),je(4,D.$ak),je(5,f.$8p),je(6,u.$tk)],S)}),define(Re[251],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=void 0,e.$AQ=(0,t.$Fi)("IExtHostInitDataService")}),define(Re[252],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=e.$kQ=void 0,e.$kQ=(0,t.$Fi)("IExtHostRpcService");class s{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.$lQ=s}),define(Re[74],Ae([1,0,58]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=E;function s(k){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:k,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function E(k){return new t.$Mn(s(k))}}),define(Re[253],Ae([1,0,3,43,4,74,58,113,228,8,100,19]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0,t=Ue(t),s=Ue(s);class m{static{this.a=1}constructor(a,u,d,f){this.b=a,this.c=u,this.d=d,this.e=f}async call(a,u,d){switch(u){case"getEnvironmentData":{const f=d,v=(0,k.$Vs)(f.remoteAuthority);let g=await this.f(f.profile);return g=(0,C.$On)(g,v),g}case"getExtensionHostExitInfo":{const f=d;return this.e.getExitInfo(f.reconnectionToken)}case"getDiagnosticInfo":{const f=d,v={machineInfo:(0,y.$Zs)()},g=f.includeProcesses?(0,A.$Xs)(process.pid):Promise.resolve();let b=[];const i={};if(f.folders){const p=(0,k.$Vs)("");b=f.folders.map(l=>E.URI.revive(p.transformIncoming(l))).filter(l=>l.scheme==="file").map(l=>(0,y.$Ys)(l.fsPath,["node_modules",".git"]).then(r=>{i[(0,o.$nc)(l.fsPath)]=r}))}return Promise.all([g,...b]).then(([p,n])=>(v.processes=p||void 0,v.workspaceMetadata=f.folders?i:void 0,v))}}throw new Error(`IPC Command ${u} not found`)}listen(a,u,d){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(d=>d.id===a)&&await this.d.createProfile(a,a);let u=!1;if(process.platform==="linux"){const d=process.glibcVersion;u=(d?parseInt(d.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==D.ServerConnectionTokenType.None?this.b.value:"",appRoot:E.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,w.$gh)(this.c.logsHome,`exthost${m.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:t.OS,arch:process.arch,marks:s.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(d=>({...d}))},isUnsupportedGlibc:u}}}e.$3s=m}),define(Re[254],Ae([1,0,4,74,71,8,213]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=void 0;class A extends C.$4s{constructor(D,w){super(new E.$tr(D),D),this.N=w,this.M=new Map,this.B(this.a)}c(D){let w=this.M.get(D.remoteAuthority);return w||(w=(0,s.$Vs)(D.remoteAuthority),this.M.set(D.remoteAuthority,w)),w}f(D,w,m=!1){if(m&&w.path==="/vscode-resource"&&w.query){const $=JSON.parse(w.query).requestResourcePath;return t.URI.from({scheme:"file",path:$})}return t.URI.revive(D.transformIncoming(w))}L(D,w){return new y(D,w,this.b,this.N)}}e.$6s=A;class y extends C.$5s{constructor(D,w,m,$){super(D,w,m,$)}j(D){const w=D.args["file-watcher-polling"];if(w){const m=w.split(k.$tc),$=Number(m[0]);if($>0)return{usePolling:m.length>1?m.slice(1):!0,pollingInterval:$}}}m(D){if(D.extensionsPath)return[k.$gc.join(D.extensionsPath,"**")]}}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[101],Ae([1,0,7,10,4,2,5,37,15,12,44,190,57]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$qG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gG=e.EditorInputCapabilities=e.$fG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=void 0,e.$9F=u,e.$0F=d,e.$$F=f,e.$_F=v,e.$aG=g,e.$bG=b,e.$cG=i,e.$dG=p,e.$eG=n,e.$hG=I,e.$iG=L,e.$jG=O,e.$kG=P,e.$lG=q,e.$mG=K,e.$nG=J,e.$oG=_,e.$pG=M,e.$rG=re,e.$sG=oe,e.$tG=ie,e.$uG=x,m=dt(m),e.$4F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5F={id:"default",displayName:(0,t.localize)(12473,null),providerDisplayName:(0,t.localize)(12474,null)},e.$6F="workbench.editor.sidebysideEditor",e.$7F="workbench.editors.textDiffEditor",e.$8F="workbench.editors.binaryResourceDiffEditor";var $;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var a;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function u(G){const T=G;return!!T&&typeof T.getSelection=="function"&&!!T.onDidChangeSelection}function d(G){const T=G;return!!T&&typeof T.getScrollPosition=="function"&&typeof T.setScrollPosition=="function"&&!!T.onDidChangeScroll}function f(G,T,X){for(const he of X.visibleEditorPanes)if(he.group.id===T&&G.matches(he.input))return he.getViewState()}function v(G){if(I(G))return!1;const T=G;return E.URI.isUri(T?.resource)}function g(G){if(I(G))return!1;const T=G;return T?.original!==void 0&&T.modified!==void 0}function b(G){if(I(G))return!1;const T=G;return!T||T.resources&&!Array.isArray(T.resources)?!1:!!T.resources||!!T.multiDiffSource}function i(G){if(I(G)||g(G))return!1;const T=G;return T?.primary!==void 0&&T.secondary!==void 0}function p(G){if(I(G))return!1;const T=G;return T?T.resource===void 0||T.resource.scheme===o.Schemas.untitled||T.forceUntitled===!0:!1}function n(G){if(I(G))return!1;const T=G;return E.URI.isUri(T?.base?.resource)&&E.URI.isUri(T?.input1?.resource)&&E.URI.isUri(T?.input2?.resource)&&E.URI.isUri(T?.result?.resource)}var l;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(l||(e.Verbosity=l={}));var r;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class h{constructor(){this.a=new Map}registerSource(T,X){let he=this.a.get(T);return he||(he={source:T,label:X},this.a.set(T,he)),he.source}getSourceLabel(T){return this.a.get(T)?.label??T}}e.$fG=new h;var c;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors",G[G.Scratchpad=512]="Scratchpad"})(c||(e.EditorInputCapabilities=c={}));class S extends k.$Uc{}e.$gG=S;function I(G){return G instanceof S}function R(G){const T=G;return E.URI.isUri(T?.preferredResource)}function L(G){const T=G;return I(T?.primary)&&I(T?.secondary)}function O(G){const T=G;return I(T?.modified)&&I(T?.original)}function P(G,T,X,he,B){return x(he,[(0,w.$pj)({id:"workbench.action.openLargeFile",label:(0,t.localize)(12475,null),run:()=>{const U={...X,limits:{size:Number.MAX_VALUE}};G.openEditor(T,U)}}),(0,w.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,t.localize)(12476,null),run:()=>B.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}function q(G){return I(G?.editor)}function K(G){const T=G;return q(G)&&T?.group!==void 0}function J(G){const T=G;return typeof T?.groupId=="number"&&I(T.editor)}function _(G){return typeof G?.groupId=="number"}var de;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(de||(e.EditorCloseContext=de={}));var ge;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LABEL=2]="GROUP_LABEL",G[G.GROUP_LOCKED=3]="GROUP_LOCKED",G[G.EDITORS_SELECTION=4]="EDITORS_SELECTION",G[G.EDITOR_OPEN=5]="EDITOR_OPEN",G[G.EDITOR_CLOSE=6]="EDITOR_CLOSE",G[G.EDITOR_MOVE=7]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=9]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=11]="EDITOR_PIN",G[G.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",G[G.EDITOR_STICKY=13]="EDITOR_STICKY",G[G.EDITOR_DIRTY=14]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(ge||(e.GroupModelChangeKind=ge={}));var le;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(le||(e.SideBySideEditor=le={}));class z{getOriginalUri(T,X){if(!T)return;if(n(T))return e.$qG.getOriginalUri(T.result,X);if(X?.supportSideBySide){const{primary:B,secondary:U}=this.a(T);if(B&&U){if(X?.supportSideBySide===le.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===le.ANY)return this.getOriginalUri(B,{filterByScheme:X.filterByScheme})??this.getOriginalUri(U,{filterByScheme:X.filterByScheme});T=X.supportSideBySide===le.PRIMARY?B:U}}if(g(T)||b(T)||i(T)||n(T))return;const he=R(T)?T.preferredResource:T.resource;return!he||!X||!X.filterByScheme?he:this.b(he,X.filterByScheme)}a(T){return L(T)||i(T)?{primary:T.primary,secondary:T.secondary}:O(T)||g(T)?{primary:T.modified,secondary:T.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(T,X){if(!T)return;if(n(T))return e.$qG.getCanonicalUri(T.result,X);if(X?.supportSideBySide){const{primary:B,secondary:U}=this.a(T);if(B&&U){if(X?.supportSideBySide===le.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===le.ANY)return this.getCanonicalUri(B,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:X.filterByScheme});T=X.supportSideBySide===le.PRIMARY?B:U}}if(g(T)||b(T)||i(T)||n(T))return;const he=T.resource;return!he||!X||!X.filterByScheme?he:this.b(he,X.filterByScheme)}b(T,X){if(Array.isArray(X)){if(X.some(he=>T.scheme===he))return T}else if(X===T.scheme)return T}}var Q;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.KEYBOARD=1]="KEYBOARD",G[G.MOUSE=2]="MOUSE"})(Q||(e.EditorCloseMethod=Q={}));function M(G,T,X,he){if(!G.isSticky(T))return!1;switch(he.preventPinnedEditorClose){case"keyboardAndMouse":return X===Q.MOUSE||X===Q.KEYBOARD;case"mouse":return X===Q.MOUSE;case"keyboard":return X===Q.KEYBOARD}return!1}e.$qG=new z;var V;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class ne{constructor(){this.c=new Map,this.d=new Map}start(T){const X=this.a=T.get(C.$Ei);for(const[he,B]of this.c)this.e(he,B,X);this.c.clear()}e(T,X,he){const B=he.createInstance(X);this.d.set(T,B)}registerFileEditorFactory(T){if(this.b)throw new Error("Can only register one file editor factory.");this.b=T}getFileEditorFactory(){return(0,s.$pg)(this.b)}registerEditorSerializer(T,X){if(this.c.has(T)||this.d.has(T))throw new Error(`A editor serializer with type ID '${T}' was already registered.`);return this.a?this.e(T,X,this.a):this.c.set(T,X),(0,k.$Sc)(()=>{this.c.delete(T),this.d.delete(T)})}getEditorSerializer(T){return this.d.get(typeof T=="string"?T:T.typeId)}}A.$ro.add(e.$4F.EditorFactory,new ne);async function re(G,T,X){return!G||!G.length?[]:await Promise.all(G.map(async he=>{const B=E.URI.revive(he.fileUri);if(!B){X.info("Cannot resolve the path because it is not valid.",he);return}if(!await T.canHandleResource(B)){X.info("Cannot resolve the path because it cannot be handled",he);return}let H=he.exists,F=he.type;if(typeof H!="boolean"||typeof F!="number")try{F=(await T.stat(B)).isDirectory?y.FileType.Directory:y.FileType.Unknown,H=!0}catch(Y){X.error(Y),H=!1}if(!H&&he.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",he);return}if(F===y.FileType.Directory){X.info("Cannot resolve the path because it is a directory",he);return}const W={...he.options,pinned:!0};return H?{resource:B,options:W}:{resource:B,options:W,forceUntitled:!0}}))}var me;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function oe(G){const T=G;if(!T)return!1;const X=T;if(X.modified)return oe(X.modified);const he=T;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}function ie(G){return(0,D.$rj)(G)}function x(G,T,X){const he=(0,D.$sj)(G,T);return he.forceMessage=X?.forceMessage,he.forceSeverity=X?.forceSeverity,he.allowDialog=X?.allowDialog,he}}),define(Re[255],Ae([1,0,7,41]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=void 0,e.$GG=new s.$Wj("chatSessionResponseVote","",{type:"string",description:(0,t.localize)(8436,null)}),e.$HG=new s.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,t.localize)(8437,null)}),e.$IG=new s.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,t.localize)(8438,null)}),e.$JG=new s.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,t.localize)(8439,null)}),e.$KG=new s.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,t.localize)(8440,null)}),e.$LG=new s.$Wj("chatResponse",!1,{type:"boolean",description:(0,t.localize)(8441,null)}),e.$MG=new s.$Wj("chatRequest",!1,{type:"boolean",description:(0,t.localize)(8442,null)}),e.$NG=new s.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,t.localize)(8443,null)}),e.$OG=new s.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,t.localize)(8444,null)}),e.$PG=new s.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,t.localize)(8445,null)}),e.$QG=new s.$Wj("inChatInput",!1,{type:"boolean",description:(0,t.localize)(8446,null)}),e.$RG=new s.$Wj("inChat",!1,{type:"boolean",description:(0,t.localize)(8447,null)}),e.$SG=new s.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,t.localize)(8448,null)}),e.$TG=new s.$Wj("chatCursorAtTop",!1),e.$UG=new s.$Wj("chatInputHasAgent",!1),e.$VG=new s.$Wj("chatLocation",void 0),e.$WG=new s.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,t.localize)(8449,null)})}),define(Re[256],Ae([1,0,104,13,18,6,39,2,48,166,16,41,21,5,11,29,46,99,255]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.ChatAgentLocation=void 0,e.$2H=l,e.$3H=r;var b;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(h){function c(S){switch(S){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=c}(b||(e.ChatAgentLocation=b={})),e.$WH=(0,$.$Fi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(c){this.f=c,this.b=new Map,this.d=new k.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=v.$SG.bindTo(this.f)}registerAgent(c,S){if(this.getAgent(c))throw new Error(`Agent already registered: ${JSON.stringify(c)}`);const R=this,L=S.slashCommands;S={...S,get slashCommands(){return L.filter(P=>!P.when||R.f.contextMatchesRules(w.$Dj.deserialize(P.when)))}};const O={data:S};return this.b.set(c,O),(0,A.$Sc)(()=>{this.b.delete(c),this.d.fire(void 0)})}registerAgentImplementation(c,S){const I=this.b.get(c);if(!I)throw new Error(`Unknown agent: ${JSON.stringify(c)}`);if(I.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(c)}`);return I.data.isDefault&&this.e.set(!0),I.impl=S,this.d.fire(new p(I.data,S)),(0,A.$Sc)(()=>{I.impl=void 0,this.d.fire(void 0),I.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(c,S){c.isDynamic=!0;const I={data:c,impl:S};return this.b.set(c.id,I),this.d.fire(new p(c,S)),(0,A.$Sc)(()=>{this.b.delete(c.id),this.d.fire(void 0)})}registerAgentCompletionProvider(c,S){return this.g.set(c,S),{dispose:()=>{this.g.delete(c)}}}async getAgentCompletionItems(c,S,I){return await this.g.get(c)?.(S,I)??[]}updateAgent(c,S){const I=this.b.get(c);if(!I?.impl)throw new Error(`No activated agent with id ${JSON.stringify(c)} registered`);I.data.metadata={...I.data.metadata,...S},this.d.fire(new p(I.data,I.impl))}getDefaultAgent(c){return(0,t.$eb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(c))}getContributedDefaultAgent(c){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(c))}getSecondaryAgent(){return C.Iterable.find(this.b.values(),c=>!!c.data.metadata.isSecondary)?.data}getAgent(c){if(this.h(c))return this.b.get(c)?.data}h(c){const S=this.b.get(c);return!S?.data.when||this.f.contextMatchesRules(w.$Dj.deserialize(S.data.when))}getAgentByFullyQualifiedId(c){const S=C.Iterable.find(this.b.values(),I=>l(I.data)===c)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(c=>c.data).filter(c=>this.h(c.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(c=>!!c.impl).filter(c=>this.h(c.data.id)).map(c=>new p(c.data,c.impl))}getAgentsByName(c){return this.getAgents().filter(S=>S.name===c)}agentHasDupeName(c){const S=this.getAgent(c);return S?this.getAgentsByName(S.name).filter(I=>I.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(c,S,I,R,L){const O=this.b.get(c);if(!O?.impl)throw new Error(`No activated agent with id "${c}"`);return await O.impl.invoke(S,I,R,L)}async getFollowups(c,S,I,R,L){const O=this.b.get(c);if(!O?.impl)throw new Error(`No activated agent with id "${c}"`);return O.impl?.provideFollowups?O.impl.provideFollowups(S,I,R,L):[]}};e.$XH=i,e.$XH=i=Be([je(0,w.$Xj)],i);class p{constructor(c,S){this.b=c,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(c,S,I,R){return this.d.invoke(c,S,I,R)}async provideFollowups(c,S,I,R){return this.d.provideFollowups?this.d.provideFollowups(c,S,I,R):[]}provideWelcomeMessage(c,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(c,S)}provideSampleQuestions(c,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(c,S)}}e.$YH=p,e.$ZH=(0,$.$Fi)("chatAgentNameService");let n=class{static{g=this}static{this.b="chat.participantNameRegistry"}constructor(c,S,I,R){if(this.g=S,this.h=I,this.i=R,this.e=(0,o.$6d)(this,Object.create(null)),this.f=!1,!c.chatParticipantRegistry)return;this.d=c.chatParticipantRegistry;const L=R.get(g.b,f.StorageScope.APPLICATION);try{this.e.set(JSON.parse(L??"{}"),void 0)}catch{R.remove(g.b,f.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(c=>this.h.warn("Failed to fetch chat participant registry",c)).then(()=>(0,s.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const c=await this.g.request({type:"GET",url:this.d},E.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,d.$bq)(c);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const I=S.restrictedChatParticipants;this.e.set(I,void 0),this.i.store(g.b,JSON.stringify(I),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(c){const S=this.l(c.name,c).get(),I=!c.fullName||this.l(c.fullName.replace(/\s/g,""),c).get();return S&&I}l(c,S){return this.e.map(R=>R[c.toLowerCase()]).map(R=>R?R.some(L=>(0,D.$Ff)(L,L.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$1H=n,e.$1H=n=g=Be([je(0,u.$tk),je(1,d.$8p),je(2,a.$ak),je(3,f.$iq)],n);function l(h){return`${h.extensionId.value}.${h.id}`}function r(h){const c="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in c||(c.extensionPublisherId=c.extensionPublisher??""),"extensionDisplayName"in c||(c.extensionDisplayName=""),"extensionId"in c||(c.extensionId=new m.$rn("")),(0,y.$ci)(c)}}),define(Re[257],Ae([1,0,4,7,41,5]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$PK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$NK=e.MemoryRangeType=e.State=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=void 0,e.$MK=y,e.$OK=D,s=Ue(s),e.$AJ="workbench.view.debug",e.$BJ="workbench.debug.variablesView",e.$CJ="workbench.debug.watchExpressionsView",e.$DJ="workbench.debug.callStackView",e.$EJ="workbench.debug.loadedScriptsView",e.$FJ="workbench.debug.breakPointsView",e.$GJ="workbench.debug.disassemblyView",e.$HJ="workbench.panel.repl",e.$IJ="workbench.panel.repl.view",e.$JJ=new E.$Wj("debugType",void 0,{type:"string",description:s.localize(7466,null)}),e.$KJ=new E.$Wj("debugConfigurationType",void 0,{type:"string",description:s.localize(7467,null)}),e.$LJ=new E.$Wj("debugState","inactive",{type:"string",description:s.localize(7468,null)}),e.$MJ="debugUx",e.$NJ=new E.$Wj(e.$MJ,"default",{type:"string",description:s.localize(7469,null)}),e.$OJ=new E.$Wj("hasDebugged",!1,{type:"boolean",description:s.localize(7470,null)}),e.$PJ=new E.$Wj("inDebugMode",!1,{type:"boolean",description:s.localize(7471,null)}),e.$QJ=new E.$Wj("inDebugRepl",!1,{type:"boolean",description:s.localize(7472,null)}),e.$RJ=new E.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:s.localize(7473,null)}),e.$SJ=new E.$Wj("inBreakpointWidget",!1,{type:"boolean",description:s.localize(7474,null)}),e.$TJ=new E.$Wj("breakpointsFocused",!0,{type:"boolean",description:s.localize(7475,null)}),e.$UJ=new E.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:s.localize(7476,null)}),e.$VJ=new E.$Wj("watchExpressionsExist",!1,{type:"boolean",description:s.localize(7477,null)}),e.$WJ=new E.$Wj("variablesFocused",!0,{type:"boolean",description:s.localize(7478,null)}),e.$XJ=new E.$Wj("expressionSelected",!1,{type:"boolean",description:s.localize(7479,null)}),e.$YJ=new E.$Wj("breakpointInputFocused",!1,{type:"boolean",description:s.localize(7480,null)}),e.$ZJ=new E.$Wj("callStackItemType",void 0,{type:"string",description:s.localize(7481,null)}),e.$1J=new E.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:s.localize(7482,null)}),e.$2J=new E.$Wj("callStackItemStopped",!1,{type:"boolean",description:s.localize(7483,null)}),e.$3J=new E.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:s.localize(7484,null)}),e.$4J=new E.$Wj("watchItemType",void 0,{type:"string",description:s.localize(7485,null)}),e.$5J=new E.$Wj("canViewMemory",void 0,{type:"boolean",description:s.localize(7486,null)}),e.$6J=new E.$Wj("breakpointItemType",void 0,{type:"string",description:s.localize(7487,null)}),e.$7J=new E.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:s.localize(7488,null)}),e.$8J=new E.$Wj("breakpointHasModes",!1,{type:"boolean",description:s.localize(7489,null)}),e.$9J=new E.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:s.localize(7490,null)}),e.$0J=new E.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:s.localize(7491,null)}),e.$$J=new E.$Wj("loadedScriptsItemType",void 0,{type:"string",description:s.localize(7492,null)}),e.$_J=new E.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:s.localize(7493,null)}),e.$aK=new E.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:s.localize(7494,null)}),e.$bK=new E.$Wj("stepBackSupported",!1,{type:"boolean",description:s.localize(7495,null)}),e.$cK=new E.$Wj("restartFrameSupported",!1,{type:"boolean",description:s.localize(7496,null)}),e.$dK=new E.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:s.localize(7497,null)}),e.$eK=new E.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:s.localize(7498,null)}),e.$fK=new E.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:s.localize(7499,null)}),e.$gK=new E.$Wj("breakpointsExist",!1,{type:"boolean",description:s.localize(7500,null)}),e.$hK=new E.$Wj("debuggersAvailable",!1,{type:"boolean",description:s.localize(7501,null)}),e.$iK=new E.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:s.localize(7502,null)}),e.$jK=new E.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:s.localize(7503,null)}),e.$kK=new E.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:s.localize(7504,null)}),e.$lK=new E.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:s.localize(7505,null)}),e.$mK=new E.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:s.localize(7506,null)}),e.$nK=new E.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:s.localize(7507,null)}),e.$oK=new E.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:s.localize(7508,null)}),e.$pK=new E.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:s.localize(7509,null)}),e.$qK=new E.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:s.localize(7510,null)}),e.$rK=new E.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:s.localize(7511,null)}),e.$sK=new E.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:s.localize(7512,null)}),e.$tK=new E.$Wj("variableIsReadonly",!1,{type:"boolean",description:s.localize(7513,null)}),e.$uK=new E.$Wj("variableValue",!1,{type:"string",description:s.localize(7514,null)}),e.$vK=new E.$Wj("variableType",!1,{type:"string",description:s.localize(7515,null)}),e.$wK=new E.$Wj("variableInterfaces",!1,{type:"array",description:s.localize(7516,null)}),e.$xK=new E.$Wj("variableName",!1,{type:"string",description:s.localize(7517,null)}),e.$yK=new E.$Wj("variableLanguage",!1,{type:"string",description:s.localize(7518,null)}),e.$zK=new E.$Wj("variableExtensionId",!1,{type:"string",description:s.localize(7519,null)}),e.$AK=new E.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:s.localize(7520,null)}),e.$BK=new E.$Wj("multiSessionRepl",!1,{type:"boolean",description:s.localize(7521,null)}),e.$CK=new E.$Wj("multiSessionDebug",!1,{type:"boolean",description:s.localize(7522,null)}),e.$DK=new E.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:s.localize(7523,null)}),e.$EK=new E.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:s.localize(7524,null)}),e.$FK=new E.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:s.localize(7525,null)}),e.$GK=new E.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:s.localize(7526,null)});const C=g=>s.localize(7527,null,g);e.$HK=C,e.$IK="editor.contrib.debug",e.$JK="editor.contrib.breakpoint",e.$KK="debug",e.$LK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:s.localize(7528,null)};var A;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(A||(e.State=A={}));function y(g){switch(g){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var o;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$NK="vscode-debug-memory";function D(g){const b=g.presentationHint??g.source.presentationHint;return b==="deemphasize"||b==="subtle"}var w;(function(g){g[g.Variable=0]="Variable",g[g.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var m;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(m||(e.DebugConfigurationProviderTriggerKind=m={}));var $;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})($||(e.DebuggerString=$={})),e.$PK=(0,k.$Fi)("debugService");var a;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE",g[g.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var u;(function(g){g[g.Command=0]="Command",g[g.Tree=1]="Tree"})(u||(e.DebugVisualizationType=u={}));var d;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(d||(e.DebugTreeItemCollapsibleState=d={}));var f;(function(g){g.deserialize=b=>b,g.serialize=b=>b})(f||(e.IDebugVisualizationTreeItem=f={}));var v;(function(g){g.deserialize=b=>({id:b.id,name:b.name,iconPath:b.iconPath&&{light:t.URI.revive(b.iconPath.light),dark:t.URI.revive(b.iconPath.dark)},iconClass:b.iconClass,visualization:b.visualization}),g.serialize=b=>b})(v||(e.IDebugVisualization=v={}))}),define(Re[258],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0,e.$NQ=(0,t.$Fi)("environmentVariableService")}),define(Re[145],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$0Q=void 0,e.$0Q="remoteterminal";var t;(function(E){E.OnPtyHostExitEvent="$onPtyHostExitEvent",E.OnPtyHostStartEvent="$onPtyHostStartEvent",E.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",E.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",E.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",E.OnProcessDataEvent="$onProcessDataEvent",E.OnProcessReadyEvent="$onProcessReadyEvent",E.OnProcessExitEvent="$onProcessExitEvent",E.OnProcessReplayEvent="$onProcessReplayEvent",E.OnProcessOrphanQuestion="$onProcessOrphanQuestion",E.OnExecuteCommand="$onExecuteCommand",E.OnDidRequestDetach="$onDidRequestDetach",E.OnDidChangeProperty="$onDidChangeProperty"})(t||(e.RemoteTerminalChannelEvent=t={}));var s;(function(E){E.RestartPtyHost="$restartPtyHost",E.CreateProcess="$createProcess",E.AttachToProcess="$attachToProcess",E.DetachFromProcess="$detachFromProcess",E.ListProcesses="$listProcesses",E.GetLatency="$getLatency",E.GetPerformanceMarks="$getPerformanceMarks",E.OrphanQuestionReply="$orphanQuestionReply",E.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",E.Start="$start",E.Input="$input",E.AcknowledgeDataEvent="$acknowledgeDataEvent",E.Shutdown="$shutdown",E.Resize="$resize",E.ClearBuffer="$clearBuffer",E.GetInitialCwd="$getInitialCwd",E.GetCwd="$getCwd",E.ProcessBinary="$processBinary",E.SendCommandResult="$sendCommandResult",E.InstallAutoReply="$installAutoReply",E.UninstallAllAutoReplies="$uninstallAllAutoReplies",E.GetDefaultSystemShell="$getDefaultSystemShell",E.GetProfiles="$getProfiles",E.GetEnvironment="$getEnvironment",E.GetWslPath="$getWslPath",E.GetTerminalLayoutInfo="$getTerminalLayoutInfo",E.SetTerminalLayoutInfo="$setTerminalLayoutInfo",E.SerializeTerminalState="$serializeTerminalState",E.ReviveTerminalProcesses="$reviveTerminalProcesses",E.GetRevivedPtyNewId="$getRevivedPtyNewId",E.SetUnicodeVersion="$setUnicodeVersion",E.ReduceConnectionGraceTime="$reduceConnectionGraceTime",E.UpdateIcon="$updateIcon",E.UpdateTitle="$updateTitle",E.UpdateProperty="$updateProperty",E.RefreshProperty="$refreshProperty",E.RequestDetachInstance="$requestDetachInstance",E.AcceptDetachInstanceReply="$acceptDetachInstanceReply",E.AcceptDetachedInstance="$acceptDetachedInstance",E.FreePortKillProcess="$freePortKillProcess"})(s||(e.RemoteTerminalChannelRequest=s={}))}),define(Re[259],Ae([1,0,8,4,66,52,3,135,10]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=o,e.$gR=w,e.$hR=a,e.$iR=u,e.$jR=d,e.$kR=v,e.$lR=g,e.$mR=b,e.$nR=i,t=Ue(t);function o(p,n){if(n)if(C.$j)for(const l in n){let r=l;for(const c in p)if(l.toLowerCase()===c.toLowerCase()){r=c;break}const h=n[l];h!==void 0&&D(p,r,h)}else Object.keys(n).forEach(l=>{const r=n[l];r!==void 0&&D(p,l,r)})}function D(p,n,l){typeof l=="string"?p[n]=l:delete p[n]}function w(p,n,l,r){p.TERM_PROGRAM="vscode",n&&(p.TERM_PROGRAM_VERSION=n),a(p,r)&&(p.LANG=u(l)),p.COLORTERM="truecolor"}function m(p,n){if(n)for(const l of Object.keys(n)){const r=n[l];r!=null&&(p[l]=r)}}async function $(p,n){return await Promise.all(Object.entries(n).map(async([l,r])=>{if(typeof r=="string")try{n[l]=await p(r)}catch{n[l]=r}})),n}function a(p,n){if(n==="on")return!0;if(n==="auto"){const l=p.LANG;return!l||l.search(/\.UTF\-8$/)===-1&&l.search(/\.utf8$/)===-1&&l.search(/\.euc.+/)===-1}return!1}function u(p){const n=p?p.split("-"):[],l=n.length;if(l===0)return"en_US.UTF-8";if(l===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in r&&n.push(r[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}async function d(p,n,l,r,h,c){if(p.cwd){const I=typeof p.cwd=="object"?p.cwd.fsPath:p.cwd,R=await f(I,l);return(0,A.$cR)(R||I)}let S;return!p.ignoreConfigurationCwd&&h&&(l&&(h=await f(h,l,c)),h&&(t.$ic(h)?S=h:r&&(S=t.$jc(r.fsPath,h)))),S||(S=r?r.fsPath:n||""),(0,A.$cR)(S)}async function f(p,n,l){if(n)try{return await n(p)}catch(r){l?.error("Could not resolve terminal cwd",r);return}return p}function v(p,n,l){if(l)return r=>l.resolveWithEnvironment(n,p,r)}async function g(p,n,l,r,h,c){const S={};if(p.strictEnv)m(S,p.env);else{m(S,c);const I={...n};l&&(I&&await $(l,I),p.env&&await $(l,p.env)),C.$k&&(S.VSCODE_NODE_OPTIONS&&(S.NODE_OPTIONS=S.VSCODE_NODE_OPTIONS,delete S.VSCODE_NODE_OPTIONS),S.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(S.NODE_REPL_EXTERNAL_MODULE=S.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete S.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,E.$lm)(S,"VSCODE_IPC_HOOK_CLI"),o(S,I),o(S,p.env),w(S,r,C.$x,h)}return S}async function b(p,n,l,r,h,c,S=C.$j){let I;if((0,y.$eg)(p)?I=p:(I=p.fsPath,S&&c!==C.OperatingSystem.Windows?I=I.replace(/\\/g,"/"):!S&&c===C.OperatingSystem.Windows&&(I=I.replace(/\//g,"\\"))),!n)return I;const R=I.includes(" "),L=I.includes("(")||I.includes(")"),O=t.$nc(n,".exe"),P=O==="pwsh"||l==="pwsh"||O==="powershell"||l==="powershell";if(P&&(R||I.includes("'")))return`& '${I.replace(/'/g,"''")}'`;if(L&&P)return`& '${I}'`;if(c===C.OperatingSystem.Windows){if(r!==void 0)return r===k.WindowsShellType.GitBash?(0,A.$aR)(I.replace(/\\/g,"/")):r===k.WindowsShellType.Wsl?h?.getWslPath(I,"win-to-unix")||I:R?`"${I}"`:I;const q=n.toLowerCase();return q.includes("wsl")||q.includes("bash.exe")&&!q.toLowerCase().includes("git")?h?.getWslPath(I,"win-to-unix")||I:R?`"${I}"`:I}return(0,A.$aR)(I)}function i(p,n,l){const r=typeof p=="string"?s.URI.parse(p):p;let h=r?n.getWorkspaceFolder(r)??void 0:void 0;if(!h){const c=l.getLastActiveWorkspaceRoot();h=c?n.getWorkspaceFolder(c)??void 0:void 0}return h}}),define(Re[75],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.TestPosition=e.TestIdPathParts=void 0;var t;(function(k){k.Delimiter="\0"})(t||(e.TestIdPathParts=t={}));var s;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(s||(e.TestPosition=s={}));class E{static fromExtHostTestItem(C,A,y=C.parent){if(C._isRoot)return new E([A]);const o=[C.id];for(let D=y;D&&D.id!==A;D=D.parent)o.push(D.id);return o.push(A),new E(o.reverse())}static isRoot(C){return!C.includes(t.Delimiter)}static root(C){const A=C.indexOf(t.Delimiter);return A===-1?C:C.slice(0,A)}static fromString(C){return new E(C.split(t.Delimiter))}static join(C,A){return new E([...C.path,A])}static joinToString(C,A){return C.toString()+t.Delimiter+A}static parentId(C){const A=C.lastIndexOf(t.Delimiter);return A===-1?void 0:C.slice(0,A)}static localId(C){const A=C.lastIndexOf(t.Delimiter);return A===-1?C:C.slice(A+t.Delimiter.length)}static isChild(C,A){return A[C.length]===t.Delimiter&&A.startsWith(C)}static compare(C,A){return C===A?s.IsSame:E.isChild(C,A)?s.IsChild:E.isChild(A,C)?s.IsParent:s.Disconnected}static getLengthOfCommonPrefix(C,A){if(C===0)return 0;let y=0;for(;y<C-1;){for(let o=1;o<C;o++){const D=A(o-1),w=A(o);if(D.path[y]!==w.path[y])return y}y++}return y}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new E(this.path,1)}get parentId(){return this.d>1?new E(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new E(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new E(this.path,C)}compare(C){if(typeof C=="string")return E.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return s.Disconnected;return C.d>this.d?s.IsChild:C.d<this.d?s.IsParent:s.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+=t.Delimiter,this.c+=this.path[C]}return this.c}}e.$7I=E}),define(Re[102],Ae([1,0,4,85,50,75]),function(ue,e,t,s,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$cJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$bJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aJ=e.$_I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$0I=e.$9I=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$8I=e.TestResultState=void 0;var C;(function(le){le[le.Unset=0]="Unset",le[le.Queued=1]="Queued",le[le.Running=2]="Running",le[le.Passed=3]="Passed",le[le.Failed=4]="Failed",le[le.Skipped=5]="Skipped",le[le.Errored=6]="Errored"})(C||(e.TestResultState=C={})),e.$8I={[C.Unset]:"unset",[C.Queued]:"queued",[C.Running]:"running",[C.Passed]:"passed",[C.Failed]:"failed",[C.Skipped]:"skipped",[C.Errored]:"errored"};var A;(function(le){le[le.Run=1]="Run",le[le.Debug=2]="Debug",le[le.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var y;(function(le){le[le.Refresh=2]="Refresh",le[le.CodeRelatedToTest=4]="CodeRelatedToTest",le[le.TestRelatedToCode=8]="TestRelatedToCode"})(y||(e.TestControllerCapability=y={}));var o;(function(le){le[le.Run=2]="Run",le[le.Debug=4]="Debug",le[le.Coverage=8]="Coverage",le[le.HasNonDefaultProfile=16]="HasNonDefaultProfile",le[le.HasConfigurable=32]="HasConfigurable",le[le.SupportsContinuousRun=64]="SupportsContinuousRun"})(o||(e.TestRunProfileBitset=o={})),e.$9I=[o.Run,o.Debug,o.Coverage,o.HasNonDefaultProfile,o.HasConfigurable,o.SupportsContinuousRun];const D=le=>"runId"in le;e.$0I=D;var w;(function(le){le.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),le.deserialize=(z,Q)=>({range:E.$Ot.lift(Q.range),uri:z.asCanonicalUri(t.URI.revive(Q.uri))})})(w||(e.IRichLocation=w={}));var m;(function(le){le[le.Error=0]="Error",le[le.Output=1]="Output"})(m||(e.TestMessageType=m={}));var $;(function(le){le.serialize=z=>({label:z.label,uri:z.uri?.toJSON(),position:z.position?.toJSON()}),le.deserialize=(z,Q)=>({label:Q.label,uri:Q.uri?z.asCanonicalUri(t.URI.revive(Q.uri)):void 0,position:Q.position?s.$Nt.lift(Q.position):void 0})})($||(e.ITestMessageStackFrame=$={}));var a;(function(le){le.serialize=z=>({message:z.message,type:m.Error,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&w.serialize(z.location),stackTrace:z.stackTrace?.map($.serialize)}),le.deserialize=(z,Q)=>({message:Q.message,type:m.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&w.deserialize(z,Q.location),stackTrace:Q.stackTrace&&Q.stackTrace.map(M=>$.deserialize(z,M))})})(a||(e.ITestErrorMessage=a={}));const u=(le,z)=>`${z?"s":"e"}${le}`;e.$$I=u;var d;(function(le){le.serialize=z=>({message:z.message,type:m.Output,offset:z.offset,length:z.length,location:z.location&&w.serialize(z.location)}),le.deserialize=(z,Q)=>({message:Q.message,type:m.Output,offset:Q.offset,length:Q.length,location:Q.location&&w.deserialize(z,Q.location)})})(d||(e.ITestOutputMessage=d={}));var f;(function(le){le.serialize=z=>z.type===m.Error?a.serialize(z):d.serialize(z),le.deserialize=(z,Q)=>Q.type===m.Error?a.deserialize(z,Q):d.deserialize(z,Q),le.isDiffable=z=>z.type===m.Error&&z.actual!==void 0&&z.expected!==void 0})(f||(e.ITestMessage=f={}));var v;(function(le){le.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),le.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(f.serialize)}),le.deserialize=(z,Q)=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(M=>f.deserialize(z,M))})})(v||(e.ITestTaskState=v={}));const g="\0",b=(le,z)=>le+g+z;e.$_I=b;const i=le=>{const z=le.indexOf(g);return{ctrlId:le.slice(0,z),tagId:le.slice(z+1)}};e.$aJ=i;var p;(function(le){le.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),le.deserialize=(z,Q)=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?z.asCanonicalUri(t.URI.revive(Q.uri)):void 0,range:Q.range?E.$Ot.lift(Q.range):null,description:Q.description,error:Q.error,sortText:Q.sortText})})(p||(e.ITestItem=p={}));var n;(function(le){le[le.NotExpandable=0]="NotExpandable",le[le.Expandable=1]="Expandable",le[le.BusyExpanding=2]="BusyExpanding",le[le.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var l;(function(le){le.serialize=z=>({expand:z.expand,item:p.serialize(z.item)}),le.deserialize=(z,Q)=>({controllerId:k.$7I.root(Q.item.extId),expand:Q.expand,item:p.deserialize(z,Q.item)})})(l||(e.InternalTestItem=l={}));var r;(function(le){le.serialize=z=>{let Q;return z.item&&(Q={},z.item.label!==void 0&&(Q.label=z.item.label),z.item.tags!==void 0&&(Q.tags=z.item.tags),z.item.busy!==void 0&&(Q.busy=z.item.busy),z.item.uri!==void 0&&(Q.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(Q.range=z.item.range?.toJSON()),z.item.description!==void 0&&(Q.description=z.item.description),z.item.error!==void 0&&(Q.error=z.item.error),z.item.sortText!==void 0&&(Q.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:Q}},le.deserialize=z=>{let Q;return z.item&&(Q={},z.item.label!==void 0&&(Q.label=z.item.label),z.item.tags!==void 0&&(Q.tags=z.item.tags),z.item.busy!==void 0&&(Q.busy=z.item.busy),z.item.range!==void 0&&(Q.range=z.item.range?E.$Ot.lift(z.item.range):null),z.item.description!==void 0&&(Q.description=z.item.description),z.item.error!==void 0&&(Q.error=z.item.error),z.item.sortText!==void 0&&(Q.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:Q}}})(r||(e.ITestItemUpdate=r={}));const h=(le,z)=>{z.expand!==void 0&&(le.expand=z.expand),z.item!==void 0&&(le.item=le.item?Object.assign(le.item,z.item):z.item)};e.$bJ=h;var c;(function(le){le.serializeWithoutMessages=z=>({...l.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(v.serializeWithoutMessages)}),le.serialize=z=>({...l.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(v.serialize)}),le.deserialize=(z,Q)=>({...l.deserialize(z,Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(M=>v.deserialize(z,M)),retired:!0})})(c||(e.TestResultItem=c={}));var S;(function(le){le.empty=()=>({covered:0,total:0}),le.sum=(z,Q)=>{z.covered+=Q.covered,z.total+=Q.total}})(S||(e.ICoverageCount=S={}));var I;(function(le){le.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testIds:z.testIds,uri:z.uri.toJSON()}),le.deserialize=(z,Q)=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:z.asCanonicalUri(t.URI.revive(Q.uri))}),le.empty=(z,Q)=>({id:z,uri:Q,statement:S.empty()})})(I||(e.IFileCoverage=I={}));function R(le){return{...le,location:le.location?.toJSON()}}function L(le){return le.location=le.location?s.$Nt.isIPosition(le.location)?s.$Nt.lift(le.location):E.$Ot.lift(le.location):void 0,le}e.$cJ=3;var O;(function(le){le[le.Declaration=0]="Declaration",le[le.Statement=1]="Statement",le[le.Branch=2]="Branch"})(O||(e.DetailType=O={}));var P;(function(le){le.serialize=z=>z.type===O.Declaration?K.serialize(z):J.serialize(z),le.deserialize=z=>z.type===O.Declaration?K.deserialize(z):J.deserialize(z)})(P||(e.CoverageDetails=P={}));var q;(function(le){le.serialize=R,le.deserialize=L})(q||(e.IBranchCoverage=q={}));var K;(function(le){le.serialize=R,le.deserialize=L})(K||(e.IDeclarationCoverage=K={}));var J;(function(le){le.serialize=z=>({...R(z),branches:z.branches?.map(q.serialize)}),le.deserialize=z=>({...L(z),branches:z.branches?.map(q.deserialize)})})(J||(e.IStatementCoverage=J={}));var _;(function(le){le[le.Add=0]="Add",le[le.Update=1]="Update",le[le.DocumentSynced=2]="DocumentSynced",le[le.Remove=3]="Remove",le[le.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",le[le.Retire=5]="Retire",le[le.AddTag=6]="AddTag",le[le.RemoveTag=7]="RemoveTag"})(_||(e.TestDiffOpType=_={}));var de;(function(le){le.deserialize=(z,Q)=>Q.op===_.Add?{op:Q.op,item:l.deserialize(z,Q.item)}:Q.op===_.Update?{op:Q.op,item:r.deserialize(Q.item)}:Q.op===_.DocumentSynced?{op:Q.op,uri:z.asCanonicalUri(t.URI.revive(Q.uri)),docv:Q.docv}:Q,le.serialize=z=>z.op===_.Add?{op:z.op,item:l.serialize(z.item)}:z.op===_.Update?{op:z.op,item:r.serialize(z.item)}:z})(de||(e.TestsDiffOp=de={}));class ge{constructor(z){this.l=z,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(z){const Q=this.x();for(const M of z)switch(M.op){case _.Add:this.p(l.deserialize(this.l,M.item),Q);break;case _.Update:this.q(r.deserialize(M.item),Q);break;case _.Remove:this.v(M.itemId,Q);break;case _.Retire:this.w(M.itemId);break;case _.IncrementPendingExtHosts:this.updatePendingRoots(M.amount);break;case _.AddTag:this.f.set(M.tag.id,M.tag);break;case _.RemoveTag:this.f.delete(M.id);break}Q.complete?.()}p(z,Q){const M=k.$7I.parentId(z.item.extId)?.toString();let V;if(!M)V=this.y(z),this.h.add(V),this.g.set(z.item.extId,V);else if(this.g.has(M)){const ne=this.g.get(M);ne.children.add(z.item.extId),V=this.y(z,ne),this.g.set(z.item.extId,V)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return Q.add?.(V),z.expand===n.BusyExpanding&&this.j++,V}q(z,Q){const M=this.g.get(z.extId);if(M)return z.expand!==void 0&&(M.expand===n.BusyExpanding&&this.j--,z.expand===n.BusyExpanding&&this.j++),(0,e.$bJ)(M,z),Q.update?.(M),M}v(z,Q){const M=this.g.get(z);if(!M)return;const V=k.$7I.parentId(M.item.extId)?.toString();V?this.g.get(V).children.delete(M.item.extId):this.h.delete(M);const ne=[[z]];for(;ne.length;)for(const re of ne.pop()){const me=this.g.get(re);me&&(ne.push(me.children),this.g.delete(re),Q.remove?.(me,me!==M),me.expand===n.BusyExpanding&&this.j--)}}w(z){}updatePendingRoots(z){this.k+=z}x(){return{}}}e.$dJ=ge}),define(Re[146],Ae([1,0,13,6,2,105,102,75]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.TestItemEventOp=void 0;var y;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const o=(v,g)=>v===g,w=Object.entries({range:(v,g)=>v===g?!0:!v||!g?!1:v.equalsRange(g),busy:o,label:o,description:o,error:o,sortText:o,tags:(v,g)=>!(v.length!==g.length||v.some(b=>!g.includes(b)))}),m=(v,g)=>{let b;for(const[i,p]of w)p(v[i],g[i])||(b?b[i]=g[i]:b={[i]:g[i]});return b};class $ extends E.$Uc{get root(){return this.s.root}constructor(g){super(),this.s=g,this.f=this.B(new t.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new s.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(g){this.h=g;for(const b of this.tree.values())this.J(b)}get resolveHandler(){return this.h}collectDiff(){const g=this.m;return this.m=[],g}pushDiff(g){switch(g.op){case C.TestDiffOpType.DocumentSynced:{for(const b of this.m)if(b.op===C.TestDiffOpType.DocumentSynced&&b.uri===g.uri){b.docv=g.docv;return}break}case C.TestDiffOpType.Update:{const b=this.m[this.m.length-1];if(b){if(b.op===C.TestDiffOpType.Update&&b.item.extId===g.item.extId){(0,C.$bJ)(b.item,g.item);return}if(b.op===C.TestDiffOpType.Add&&b.item.item.extId===g.item.extId){(0,C.$bJ)(b.item,g.item);return}}break}}this.m.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,b){const i=this.tree.get(g);if(i){if((i.expandLevels===void 0||b>i.expandLevels)&&(i.expandLevels=b),i.expand===C.TestItemExpandState.Expandable){const p=this.M(i);return p.isOpen()?this.L(i,b-1):p.wait().then(()=>this.L(i,b-1))}else if(i.expand===C.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,b-1)):this.L(i,b-1)}}dispose(){for(const g of this.tree.values())this.s.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(g,b){switch(b.op){case y.RemoveChild:this.O(A.$7I.joinToString(g.fullId,b.id));break;case y.Upsert:this.z(b.item,g);break;case y.Bulk:for(const i of b.ops)this.w(g,i);break;case y.SetTags:this.C(b.new,b.old,g.fullId.toString());break;case y.UpdateCanResolveChildren:this.J(g);break;case y.SetProp:this.pushDiff({op:C.TestDiffOpType.Update,item:{extId:g.fullId.toString(),item:b.update}});break;case y.DocumentSynced:this.y(g.actual.uri);break;default:(0,k.$ed)(b)}}y(g){g&&this.pushDiff({op:C.TestDiffOpType.DocumentSynced,uri:g,docv:this.s.getDocumentVersion(g)})}z(g,b){const i=A.$7I.fromExtHostTestItem(g,this.root.id,b?.actual),p=this.s.getApiFor(g);p.parent&&p.parent!==b?.actual&&this.s.getChildren(p.parent).delete(g.id);let n=this.tree.get(i.toString());if(!n){n={fullId:i,actual:g,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:C.TestItemExpandState.NotExpandable},g.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(g,b),this.pushDiff({op:C.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(g)}}),this.I(g,n,b);return}if(n.actual===g){this.H(g,n,b);return}if(n.actual.uri?.toString()!==g.uri?.toString())return this.O(i.toString()),this.z(g,b);const l=this.s.getChildren(n.actual),r=n.actual,h=m(this.s.toITestItem(r),this.s.toITestItem(g));this.s.getApiFor(r).listener=void 0,n.actual=g,n.resolveBarrier=void 0,n.expand=C.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(g.tags,r.tags,i.toString()),delete h.tags),this.w(n,{op:y.SetProp,update:h})),this.I(g,n,b);for(const[S,I]of l)this.s.getChildren(g).get(I.id)||this.O(A.$7I.joinToString(i,I.id));const c=n.expandLevels;c!==void 0&&queueMicrotask(()=>{n.expand===C.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(i.toString(),c))}),this.y(n.actual.uri)}C(g,b,i){const p=new Set(b.map(n=>n.id));for(const n of g)p.delete(n.id)||this.D(n);this.pushDiff({op:C.TestDiffOpType.Update,item:{extId:i,item:{tags:g.map(n=>(0,C.$_I)(this.s.controllerId,n.id))}}}),p.forEach(this.F,this)}D(g){const b=this.j.get(g.id);b?b.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:C.TestDiffOpType.AddTag,tag:{id:(0,C.$_I)(this.s.controllerId,g.id)}}))}F(g){const b=this.j.get(g);b&&!--b.refCount&&(this.j.delete(g),this.pushDiff({op:C.TestDiffOpType.RemoveTag,id:(0,C.$_I)(this.s.controllerId,g)}))}G(g,b){this.s.getApiFor(g).parent=b&&b.actual!==this.root?b.actual:void 0}H(g,b,i){this.G(g,i);const p=this.s.getApiFor(g);p.parent=i?.actual,p.listener=n=>this.w(b,n),this.J(b)}I(g,b,i){this.H(g,b,i);for(const[p,n]of this.s.getChildren(g))this.z(n,b)}J(g){let b;this.h?g.resolveBarrier?b=g.resolveBarrier.isOpen()?C.TestItemExpandState.Expanded:C.TestItemExpandState.BusyExpanding:b=g.actual.canResolveChildren?C.TestItemExpandState.Expandable:C.TestItemExpandState.NotExpandable:b=C.TestItemExpandState.NotExpandable,b!==g.expand&&(g.expand=b,this.pushDiff({op:C.TestDiffOpType.Update,item:{extId:g.fullId.toString(),expand:b}}),b===C.TestItemExpandState.Expandable&&g.expandLevels!==void 0&&this.M(g))}L(g,b){if(b<0)return;const i=[];for(const[p,n]of this.s.getChildren(g.actual)){const l=this.expand(A.$7I.joinToString(g.fullId,n.id),b);(0,t.$rh)(l)&&i.push(l)}if(i.length)return Promise.all(i).then(()=>{})}M(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const n=new t.$Eh;return n.open(),n}g.expand=C.TestItemExpandState.BusyExpanding,this.N(g);const b=g.resolveBarrier=new t.$Eh,i=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let p;try{p=this.h(g.actual===this.root?void 0:g.actual)}catch(n){i(n)}return(0,t.$rh)(p)?p.catch(i).then(()=>{b.open(),this.J(g)}):(b.open(),this.J(g)),g.resolveBarrier}N(g){this.pushDiff({op:C.TestDiffOpType.Update,item:{extId:g.fullId.toString(),expand:g.expand}})}O(g){const b=this.tree.get(g);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:C.TestDiffOpType.Remove,itemId:g});const i=[b];for(;i.length;){const p=i.pop();if(p){this.s.getApiFor(p.actual).listener=void 0;for(const n of p.actual.tags)this.F(n.id);this.tree.delete(p.fullId.toString());for(const[n,l]of this.s.getChildren(p.actual))i.push(this.tree.get(A.$7I.joinToString(p.fullId,l.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$aQ=$;class a extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$bQ=a;class u extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$cQ=u;class d extends Error{constructor(g,b,i){super(`TestItem with ID "${g}" is from controller "${b}" and cannot be added as a child of an item from controller "${i}".`)}}e.$dQ=d;const f=(v,g,b)=>{let i=new Map;return{get size(){return i.size},forEach(p,n){for(const l of i.values())p.call(n,l,this)},[Symbol.iterator](){return i.entries()},replace(p){const n=new Map,l=new Set(i.keys()),r={op:y.Bulk,ops:[]};for(const h of p){if(!(h instanceof b))throw new u(h.id);const c=g(h).controllerId;if(c!==v.controllerId)throw new d(h.id,c,v.controllerId);if(n.has(h.id))throw new a(h.id);n.set(h.id,h),l.delete(h.id),r.ops.push({op:y.Upsert,item:h})}for(const h of l.keys())r.ops.push({op:y.RemoveChild,id:h});v.listener?.(r),i=n},add(p){if(!(p instanceof b))throw new u(p.id);i.set(p.id,p),v.listener?.({op:y.Upsert,item:p})},delete(p){i.delete(p)&&v.listener?.({op:y.RemoveChild,id:p})},get(p){return i.get(p)},toJSON(){return Array.from(i.values())}}};e.$eQ=f}),define(Re[147],Ae([1,0,146]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0;const s=new WeakMap,E=(C,A)=>{const y={controllerId:A};return s.set(C,y),y};e.$fQ=E;const k=C=>{const A=s.get(C);if(!A)throw new t.$cQ(C?.id||"<unknown>");return A};e.$gQ=k}),define(Re[260],Ae([1,0,45,27,5]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0,e.$mF=".vscode",e.$nF="settings",e.$oF=`${e.$mF}/${e.$nF}.json`,e.$pF="vscode://schemas/settings/default",e.$qF="vscode://schemas/settings/user",e.$rF="vscode://schemas/settings/profile",e.$sF="vscode://schemas/settings/machine",e.$tF="vscode://schemas/settings/workspace",e.$uF="vscode://schemas/settings/folder",e.$vF="vscode://schemas/launch",e.$wF="vscode://schemas/tasks",e.$xF=[t.ConfigurationScope.APPLICATION],e.$yF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$zF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$AF=[t.ConfigurationScope.APPLICATION,...e.$zF],e.$BF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$CF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$DF=[t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$EF="tasks",e.$FF="launch",e.$GF=Object.create(null),e.$GF[e.$EF]=`${e.$mF}/${e.$EF}.json`,e.$GF[e.$FF]=`${e.$mF}/${e.$FF}.json`,e.$HF=Object.create(null),e.$HF[e.$EF]=`${e.$EF}.json`,e.$IF=(0,E.$Gi)(s.$_i),e.$JF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$KF="workbench.settings.applyToAllProfiles"}),define(Re[148],Ae([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.VariableKind=e.$$Q=void 0,e.$$Q=(0,t.$Fi)("configurationResolverService");var s;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(s||(e.VariableKind=s={}));class E extends Error{constructor(C,A){super(A),this.variable=C}}e.$_Q=E}),define(Re[261],Ae([1,0,8,31,10,20,3,177,7,148,16]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=void 0,t=Ue(t),s=Ue(s),E=Ue(E),k=Ue(k);class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,a,u,d){this.h=new Map,this.a=$,this.b=a,this.g=u,d&&(this.c=d.then(f=>this.i(f)))}i($){if(C.$j){const a=Object.create(null);return Object.keys($).forEach(u=>{a[u.toLowerCase()]=$[u]}),a}return $}resolveWithEnvironment($,a,u){return this.l({env:this.i($),userHome:void 0},a?a.uri:void 0,u)}async resolveAsync($,a){const u={env:await this.c,userHome:await this.g};return this.l(u,$?$.uri:void 0,a)}async j($,a,u,d){const f=k.$eo(a);C.$j&&f.windows?Object.keys(f.windows).forEach(g=>f[g]=f.windows[g]):C.$k&&f.osx?Object.keys(f.osx).forEach(g=>f[g]=f.osx[g]):C.$l&&f.linux&&Object.keys(f.linux).forEach(g=>f[g]=f.linux[g]),delete f.windows,delete f.osx,delete f.linux;const v={env:await this.c,userHome:await this.g};return this.l(v,$?$.uri:void 0,f,u,d)}async resolveAnyAsync($,a,u){return this.j($,a,u)}async resolveAnyMap($,a,u){const d=new Map;return{newConfig:await this.j($,a,u,d),resolvedVariables:d}}resolveWithInteractionReplace($,a,u,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,a,u,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,a){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,a)}async l($,a,u,d,f){if(E.$eg(u))return this.m($,a,u,d,f);if(Array.isArray(u))return Promise.all(u.map(v=>this.l($,a,v,d,f)));if(E.$gg(u)){const v=Object.create(null),g=await Promise.all(Object.keys(u).map(async b=>[await this.m($,a,b,d,f),await this.l($,a,u[b],d,f)]));for(const[b,i]of g)v[b]=i;return v}return u}m($,a,u,d,f){return(0,D.$xf)(u,w.VARIABLE_REGEXP,async(v,g)=>{if(g.includes(w.VARIABLE_LHS))return v;let b=await this.o($,v,g,a,d);return f?.set(g,b),b!==v&&E.$eg(b)&&b.match(w.VARIABLE_REGEXP)&&(b=await this.m($,a,b,d,f)),b})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,a,u,d,f){let v;const g=u.split(":");g.length>1&&(u=g[0],v=g[1]);const b=n=>{const l=this.a.getFilePath();if(l)return(0,A.$1w)(l);throw new o.$_Q(n,(0,y.localize)(2078,null,a))},i=n=>{const l=b(n);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,A.$1w)(r)}throw new o.$_Q(n,(0,y.localize)(2079,null,a,t.$nc(l)))},p=n=>{if(v){const l=this.a.getFolderUri(v);if(l)return l;throw new o.$_Q(n,(0,y.localize)(2080,null,a,v))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new o.$_Q(n,(0,y.localize)(2081,null,a)):new o.$_Q(n,(0,y.localize)(2082,null,a))};switch(u){case"env":if(v){if($.env){const n=$.env[C.$j?v.toLowerCase():v];if(E.$eg(n))return n}return""}throw new o.$_Q(o.VariableKind.Env,(0,y.localize)(2083,null,a));case"config":if(v){const n=this.a.getConfigurationValue(d,v);if(E.$ng(n))throw new o.$_Q(o.VariableKind.Config,(0,y.localize)(2084,null,a,v));if(E.$gg(n))throw new o.$_Q(o.VariableKind.Config,(0,y.localize)(2085,null,a,v));return n}throw new o.$_Q(o.VariableKind.Config,(0,y.localize)(2086,null,a));case"command":return this.p(o.VariableKind.Command,a,v,f,"command");case"input":return this.p(o.VariableKind.Input,a,v,f,"input");case"extensionInstallFolder":if(v){const n=await this.a.getExtension(v);if(!n)throw new o.$_Q(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(2087,null,a,v));return this.n(n.extensionLocation)}throw new o.$_Q(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(2088,null,a));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,A.$1w)(this.n(p(o.VariableKind.WorkspaceFolder)));case"cwd":return d||v?(0,A.$1w)(this.n(p(o.VariableKind.Cwd))):s.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$1w)(t.$nc(this.n(p(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new o.$_Q(o.VariableKind.UserHome,(0,y.localize)(2089,null,a))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new o.$_Q(o.VariableKind.LineNumber,(0,y.localize)(2090,null,a))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new o.$_Q(o.VariableKind.SelectedText,(0,y.localize)(2091,null,a))}case"file":return b(o.VariableKind.File);case"fileWorkspaceFolder":return i(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return t.$nc(i(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||v?t.$lc(this.n(p(o.VariableKind.RelativeFile)),b(o.VariableKind.RelativeFile)):b(o.VariableKind.RelativeFile);case"relativeFileDirname":{const n=t.$mc(b(o.VariableKind.RelativeFileDirname));if(d||v){const l=t.$lc(this.n(p(o.VariableKind.RelativeFileDirname)),n);return l.length===0?".":l}return n}case"fileDirname":return t.$mc(b(o.VariableKind.FileDirname));case"fileExtname":return t.$oc(b(o.VariableKind.FileExtname));case"fileBasename":return t.$nc(b(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=t.$nc(b(o.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-t.$oc(n).length)}case"fileDirnameBasename":return t.$nc(t.$mc(b(o.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||a}case"execInstallFolder":{const n=this.a.getAppRoot();return n||a}case"pathSeparator":case"/":return t.sep;default:try{const n=v?`${u}:${v}`:u;return this.p(o.VariableKind.Unknown,a,n,f,void 0)}catch{return a}}}}p($,a,u,d,f){if(u&&d){const v=f===void 0?d[u]:d[f+":"+u];if(typeof v=="string")return v;throw new o.$_Q($,(0,y.localize)(2092,null,a))}return a}}e.$oR=w}),define(Re[262],Ae([1,0,5,101]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$tE=void 0,e.$uE=o,e.$vE=m,e.$wE=$,e.$tE=(0,t.$Fi)("editorGroupsService");var E;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(E||(e.GroupDirection=E={}));var k;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var C;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(C||(e.GroupLocation=C={}));var A;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var y;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function o(a){const u=a;return(0,s.$hG)(u?.editor)&&(0,s.$hG)(u?.replacement)}var D;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D||(e.GroupsOrder=D={}));var w;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function m(a){const u=a;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}function $(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?E.DOWN:E.RIGHT}}),define(Re[149],Ae([1,0,5,262]),function(ue,e,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.$xE=void 0,e.$BE=E,e.$xE=(0,t.$Fi)("editorService"),e.$yE=-1,e.$zE=-2,e.$AE=-3;function E(k){const C=k;return typeof k=="number"||(0,s.$vE)(C)}}),define(Re[263],Ae([1,0,260,89,97,96,148,101,149,12,211,258,52,145]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=e.$qR=void 0,e.$qR="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen($.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen($.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen($.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(d,f,v,g,b,i,p,n,l,r){this.a=d,this.b=f,this.c=v,this.d=g,this.e=b,this.f=i,this.g=p,this.h=n,this.i=l,this.j=r}restartPtyHost(){return this.b.call($.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(d,f,v,g,b,i,p,n){await this.c.whenRemoteConfigurationLoaded();const l=Object.create(null),r=v?this.d.getWorkspaceFolder(v)??void 0:void 0;let h;try{h=(await this.e.resolveAnyMap(r,{shellLaunchConfig:d,configuration:f})).resolvedVariables}catch(K){this.h.error(K)}if(h)for(const[K,J]of h.entries())(/^config:/.test(K)||K==="selectedText"||K==="lineNumber")&&(l[K]=J);const c=[];for(const[K,J]of this.f.collections.entries())c.push([K,(0,k.$Fs)(J.map),(0,k.$Gs)(J.descriptionMap)]);const S=await this.g.resolveAuthority(this.a),I=S.options&&S.options.extensionHostEnv,R=this.d.getWorkspace(),L=R.folders,O=v?this.d.getWorkspaceFolder(v):null,P=A.$qG.getOriginalUri(this.i.activeEditor,{supportSideBySide:A.SideBySideEditor.PRIMARY,filterByScheme:[o.Schemas.file,o.Schemas.vscodeUserData,o.Schemas.vscodeRemote]}),q={configuration:f,resolvedVariables:l,envVariableCollections:c,shellLaunchConfig:d,workspaceId:R.id,workspaceName:this.j.getWorkspaceLabel(R),workspaceFolders:L,activeWorkspaceFolder:O,activeFileResource:P,shouldPersistTerminal:b,options:g,cols:i,rows:p,unicodeVersion:n,resolverEnv:I};return await this.b.call($.RemoteTerminalChannelRequest.CreateProcess,q)}requestDetachInstance(d,f){return this.b.call($.RemoteTerminalChannelRequest.RequestDetachInstance,[d,f])}acceptDetachInstanceReply(d,f){return this.b.call($.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[d,f])}attachToProcess(d){return this.b.call($.RemoteTerminalChannelRequest.AttachToProcess,[d])}detachFromProcess(d,f){return this.b.call($.RemoteTerminalChannelRequest.DetachFromProcess,[d,f])}listProcesses(){return this.b.call($.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call($.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call($.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call($.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(d,f){return this.b.call($.RemoteTerminalChannelRequest.ProcessBinary,[d,f])}start(d){return this.b.call($.RemoteTerminalChannelRequest.Start,[d])}input(d,f){return this.b.call($.RemoteTerminalChannelRequest.Input,[d,f])}acknowledgeDataEvent(d,f){return this.b.call($.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[d,f])}setUnicodeVersion(d,f){return this.b.call($.RemoteTerminalChannelRequest.SetUnicodeVersion,[d,f])}shutdown(d,f){return this.b.call($.RemoteTerminalChannelRequest.Shutdown,[d,f])}resize(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.Resize,[d,f,v])}clearBuffer(d){return this.b.call($.RemoteTerminalChannelRequest.ClearBuffer,[d])}getInitialCwd(d){return this.b.call($.RemoteTerminalChannelRequest.GetInitialCwd,[d])}getCwd(d){return this.b.call($.RemoteTerminalChannelRequest.GetCwd,[d])}orphanQuestionReply(d){return this.b.call($.RemoteTerminalChannelRequest.OrphanQuestionReply,[d])}sendCommandResult(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.SendCommandResult,[d,f,v])}freePortKillProcess(d){return this.b.call($.RemoteTerminalChannelRequest.FreePortKillProcess,[d])}installAutoReply(d,f){return this.b.call($.RemoteTerminalChannelRequest.InstallAutoReply,[d,f])}uninstallAllAutoReplies(){return this.b.call($.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(d){return this.b.call($.RemoteTerminalChannelRequest.GetDefaultSystemShell,[d])}getProfiles(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,d,f,v])}acceptPtyHostResolvedVariables(d,f){return this.b.call($.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[d,f])}getEnvironment(){return this.b.call($.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(d,f){return this.b.call($.RemoteTerminalChannelRequest.GetWslPath,[d,f])}setTerminalLayoutInfo(d){const v={workspaceId:this.d.getWorkspace().id,tabs:d?d.tabs:[]};return this.b.call($.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,v)}updateTitle(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.UpdateTitle,[d,f,v])}updateIcon(d,f,v,g){return this.b.call($.RemoteTerminalChannelRequest.UpdateIcon,[d,f,v,g])}refreshProperty(d,f){return this.b.call($.RemoteTerminalChannelRequest.RefreshProperty,[d,f])}updateProperty(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.UpdateProperty,[d,f,v])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call($.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,f)}reviveTerminalProcesses(d,f,v){return this.b.call($.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[d,f,v])}getRevivedPtyNewId(d){return this.b.call($.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[d])}serializeTerminalState(d){return this.b.call($.RemoteTerminalChannelRequest.SerializeTerminalState,[d])}};e.$rR=a,e.$rR=a=Be([je(2,t.$IF),je(3,E.$Oi),je(4,C.$$Q),je(5,w.$NQ),je(6,s.$Rl),je(7,m.$ss),je(8,y.$xE),je(9,D.$sw)],a)}),define(Re[264],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.ExtHostConnectionType=void 0,e.$fn=A,e.$gn=y;var t;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(t||(e.ExtHostConnectionType=t={}));class s{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(w){this.pipeName=w,this.type=t.IPC}serialize(w){w[s.ENV_KEY]=this.pipeName}}e.$cn=s;class E{constructor(){this.type=t.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(w){w[E.ENV_KEY]="1"}}e.$dn=E;class k{constructor(){this.type=t.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(w){w[k.ENV_KEY]="1"}}e.$en=k;function C(D){delete D[s.ENV_KEY],delete D[E.ENV_KEY],delete D[k.ENV_KEY]}function A(D,w){C(w),D.serialize(w)}function y(D){if(D[s.ENV_KEY])return o(D,new s(D[s.ENV_KEY]));if(D[E.ENV_KEY])return o(D,new E);if(D[k.ENV_KEY])return o(D,new k);throw new Error("No connection information defined in environment!")}function o(D,w){return C(D),w}}),define(Re[265],Ae([1,0,14]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Bn=C,e.$Cn=A;var s;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(s||(e.UIKind=s={}));var E;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(E||(e.ExtensionHostExitCode=E={}));var k;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function C(o){const D=t.$Ne.alloc(1);switch(o){case k.Initialized:D.writeUInt8(1,0);break;case k.Ready:D.writeUInt8(2,0);break;case k.Terminate:D.writeUInt8(3,0);break}return D}function A(o,D){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return D===k.Initialized;case 2:return D===k.Ready;case 3:return D===k.Terminate;default:return!1}}var y;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Re[266],Ae([1,0,5,6,24,11,251,265,90,40,20,4,2,7]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$CQ=e.$BQ=void 0,e.$DQ=d;let a=class extends m.$Uc{constructor(v,g){super(),this.s=v,this.t=g,this.a=this.B(new s.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new s.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=E.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=w.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=g.createLogger(this.m,{id:o.$Cp,name:(0,$.localize)(10825,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(g.onDidChangeLogLevel(b=>{(0,k.$ck)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===E.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=E.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=E.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=E.TelemetryLevel.USAGE:!1}}instantiateLogger(v,g,b){const i=this.getTelemetryDetails(),p=new u(g,b,v,this.n,this.j,this.getBuiltInCommonProperties(v),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),n=this.r.get(v.identifier.value)??[];return this.r.set(v.identifier.value,[...n,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(v,g,b){this.f=v,this.g=g,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(v){const g=Object.create(null);switch(g["common.extname"]=`${v.publisher}.${v.name}`,g["common.extversion"]=v.version,g["common.vscodemachineid"]=this.s.telemetryInfo.machineId,g["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,g["common.sqmid"]=this.s.telemetryInfo.sqmId,g["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,g["common.vscodeversion"]=this.s.version,g["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),g["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:g["common.uikind"]="web";break;case A.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,y.$in)((0,o.$Ip)(this.s.remote.authority)),g}$onDidChangeTelemetryLevel(v){this.h=this.getTelemetryConfiguration(),this.f=v;const g=this.getTelemetryDetails();this.r.forEach((b,i)=>{const p=b.filter(n=>!n.isDisposed);p.length===0?this.r.delete(i):this.r.set(i,p)}),this.r.forEach(b=>{for(const i of b)i.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(v,g){const i=this.r.get(v.value)?.filter(n=>!n.isDisposed);if(!i)return this.r.delete(v.value),!1;let p=!1;for(const n of i)n.ignoreUnhandledExtHostErrors||(n.logError(g),p=!0);return p}};e.$BQ=a,e.$BQ=a=Be([je(0,C.$AQ),je(1,k.$bk)],a);class u{static validateSender(v){if(typeof v!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof v.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof v.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof v.flush<"u"&&typeof v.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(v,g,b,i,p,n,l){this.g=b,this.h=i,this.i=p,this.j=n,this.a=new s.$le,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=v,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(v,g){this.e&&(this.d={isUsageEnabled:v,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(v){let g="properties"in v?v.properties??{}:v;return g=(0,o.$Lp)(g,[]),this.c&&(g=(0,D.$ho)(g,this.c)),this.b||(g=(0,D.$ho)(g,this.j)),"properties"in v?v.properties=g:v=g,v}k(v,g){this.f&&(this.g.publisher==="vscode"?v=this.g.name+"/"+v:v=this.g.identifier.value+"/"+v,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(v,g),this.h.trace(v,g))}logUsage(v,g){this.d.isUsageEnabled&&this.k(v,g)}logError(v,g){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof v=="string")this.k(v,g);else{const b={name:v.name,message:v.message,stack:v.stack,cause:v.cause},i=(0,o.$Lp)(b,[]),p=new Error(i.message,{cause:i.cause});p.stack=i.stack,p.name=i.name,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f.sendErrorData(p,g),this.h.trace("exception",g)}}get apiTelemetryLogger(){if(!this.e){const v=this,g={logUsage:v.logUsage.bind(v),get isUsageEnabled(){return v.d.isUsageEnabled},get isErrorsEnabled(){return v.d.isErrorsEnabled},logError:v.logError.bind(v),dispose:v.dispose.bind(v),onDidChangeEnableStates:v.a.event.bind(v)};this.e=Object.freeze(g)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let v=this.f;this.f=void 0,Promise.resolve(v.flush()).then(v=void 0),this.e=void 0}else this.f=void 0}}e.$CQ=u;function d(f){const v=Date.now()-new Date(f).getTime();return isNaN(v)?!1:v<1e3*60*60*24}e.$EQ=(0,t.$Fi)("IExtHostTelemetry")}),define(Re[267],Ae([1,0,6,4,38,129,21,5]),function(ue,e,t,s,E,k,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.ActivationKind=e.$iH=e.$hH=e.$eH=e.ExtensionHostStartup=e.$dH=e.$cH=e.$bH=e.$aH=void 0,e.$fH=m,e.$gH=$,e.$jH=f,e.$kH=v,e.$aH=Object.freeze({identifier:new C.$rn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:s.URI.parse("void:location"),isBuiltin:!1,targetPlatform:C.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$bH="extensions.webWorker",e.$cH=(0,A.$Fi)("extensionService");class y{constructor(i){this.dependency=i}}e.$dH=y;var o;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class D{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,p,n){this.c=i,this.d=p.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:k.$YG.createActivationEventsMap(this.d)}}set(i,p,n){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const l=[],r=[],h=[],c=[],S=w(this.d),I=w(p),R=(K,J)=>K.extensionLocation.toString()===J.extensionLocation.toString()||K.isBuiltin===J.isBuiltin||K.isUserBuiltin===J.isUserBuiltin||K.isUnderDevelopment===J.isUnderDevelopment;for(const K of this.d){const J=I.get(K.identifier);if(!J){l.push(K.identifier),S.delete(K.identifier);continue}if(!R(K,J)){l.push(K.identifier),S.delete(K.identifier);continue}}for(const K of p){const J=S.get(K.identifier);if(!J){r.push(K);continue}if(!R(J,K)){l.push(J.identifier),S.delete(J.identifier);continue}}const L=new C.$sn(this.e),O=new C.$sn(n);for(const K of this.e)O.has(K)||h.push(K);for(const K of n)L.has(K)||c.push(K);const P=k.$YG.createActivationEventsMap(r),q={versionId:i,toRemove:l,toAdd:r,addActivationEvents:P,myToRemove:h,myToAdd:c};return this.delta(q),q}delta(i){if(this.c>=i.versionId)return null;const{toRemove:p,toAdd:n,myToRemove:l,myToAdd:r}=i,h=new C.$sn(p),c=new C.$sn(l);for(let S=0;S<this.d.length;S++)h.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)c.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of n)this.d.push(S);for(const S of r)this.e.push(S);return this.f=null,i}containsExtension(i){for(const p of this.e)if(C.$rn.equals(p,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const p of this.d){if(!this.containsExtension(p.identifier))continue;const n=k.$YG.readActivationEvents(p);for(const l of n)i.add(l)}return i}}e.$eH=D;function w(b){const i=new C.$tn;for(const p of b)i.set(p.identifier,p);return i}function m(b,i){return b.enabledApiProposals?b.enabledApiProposals.includes(i):!1}function $(b,i){if(!m(b,i))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}class a{constructor(i,p,n,l){this.codeLoadingTime=i,this.activateCallTime=p,this.activateResolvedTime=n,this.activationReason=l}}e.$hH=a;class u{constructor(i,p){this.description=i,this.value=p}}e.$iH=u;var d;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function f(b){return{type:b.isBuiltin?C.ExtensionType.System:C.ExtensionType.User,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,E.$Rp)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}function v(b,i){const p=(0,E.$Pp)(b.manifest.publisher,b.manifest.name);return{id:p,identifier:new C.$rn(p),isBuiltin:b.type===C.ExtensionType.System,isUserBuiltin:b.type===C.ExtensionType.User&&b.isBuiltin,isUnderDevelopment:!!i,extensionLocation:b.location,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform,publisherDisplayName:b.publisherDisplayName,...b.manifest}}class g{constructor(){this.onDidRegisterExtensions=t.Event.None,this.onDidChangeExtensionsStatus=t.Event.None,this.onDidChangeExtensions=t.Event.None,this.onWillActivateByEvent=t.Event.None,this.onDidChangeResponsiveChange=t.Event.None,this.onWillStop=t.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,p){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,p){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$lH=g});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[268],Ae([1,0,7,9,57,30,126,37,21,29,129,118]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=void 0,t=Ue(t),E=dt(E);const m=A.$ro.as(C.$so.JSONContribution);class ${constructor(i,p,n){this.a=i,this.b=p,this.c=n}d(i,p){this.a({type:i,message:p,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(E.default.Error,i)}warn(i){this.d(E.default.Warning,i)}info(i){this.d(E.default.Info,i)}}e.$7G=$;class a{static a(i){const p=new y.$sn;for(let n=0,l=i.length;n<l;n++)p.add(i[n].description.identifier);return p}static compute(i,p){if(!i||!i.length)return new a(p,[]);if(!p||!p.length)return new a([],i);const n=this.a(i),l=this.a(p),r=p.filter(c=>!n.has(c.description.identifier)),h=i.filter(c=>!l.has(c.description.identifier));return new a(r,h)}constructor(i,p){this.added=i,this.removed=p}}e.$8G=a;class u{constructor(i,p){this.name=i,this.defaultExtensionKind=p,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=a.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,s.$Y)(i)}}}e.$9G=u;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[t.localize(1843,null),t.localize(1844,null)]},f="vscode://schemas/vscode-extensions";e.$0G={properties:{engines:{type:"object",description:t.localize(1845,null),properties:{vscode:{type:"string",description:t.localize(1846,null),default:"^1.22.0"}}},publisher:{description:t.localize(1847,null),type:"string"},displayName:{description:t.localize(1848,null),type:"string"},categories:{description:t.localize(1849,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$qn},{type:"string",const:"Languages",deprecationMessage:t.localize(1850,null)}]}},galleryBanner:{type:"object",description:t.localize(1851,null),properties:{color:{description:t.localize(1852,null),type:"string"},theme:{description:t.localize(1853,null),type:"string",enum:["dark","light"]}}},contributes:{description:t.localize(1854,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:t.localize(1855,null)},enableProposedApi:{type:"boolean",deprecationMessage:t.localize(1856,null)},enabledApiProposals:{markdownDescription:t.localize(1857,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals).map(b=>b),markdownEnumDescriptions:Object.values(w.allApiProposals).map(b=>b.proposal)}},api:{markdownDescription:t.localize(1858,null),type:"string",enum:["none"],enumDescriptions:[t.localize(1859,null)]},activationEvents:{description:t.localize(1860,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:t.localize(1861,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:t.localize(1862,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:t.localize(1863,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:t.localize(1864,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:t.localize(1865,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:t.localize(1866,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:t.localize(1867,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:t.localize(1868,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:t.localize(1869,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:t.localize(1870,null),body:"onStartupFinished"},{label:"onTaskType",description:t.localize(1871,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:t.localize(1872,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:t.localize(1873,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:t.localize(1874,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:t.localize(1875,null)},{label:"onUri",body:"onUri",description:t.localize(1876,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:t.localize(1877,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:t.localize(1878,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:t.localize(1879,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:t.localize(1880,null)},{label:"onRenderer",description:t.localize(1881,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:t.localize(1882,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:t.localize(1883,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:t.localize(1884,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:t.localize(1885,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:t.localize(1886,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:t.localize(1887,null)},{label:"*",description:t.localize(1888,null),body:"*"}]}},badges:{type:"array",description:t.localize(1889,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:t.localize(1890,null)},href:{type:"string",description:t.localize(1891,null)},description:{type:"string",description:t.localize(1892,null)}}}},markdown:{type:"string",description:t.localize(1893,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:t.localize(1894,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:t.localize(1895,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$$o}},extensionPack:{description:t.localize(1896,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$$o}},extensionKind:{description:t.localize(1897,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:t.localize(1898,null)},{body:["workspace"],description:t.localize(1899,null)},{body:["ui","workspace"],description:t.localize(1900,null)},{body:["workspace","ui"],description:t.localize(1901,null)},{body:[],description:t.localize(1902,null)}]},capabilities:{description:t.localize(1903,null),type:"object",properties:{virtualWorkspaces:{description:t.localize(1904,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:t.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(1906,null),t.localize(1907,null),t.localize(1908,null)]},description:{type:"string",markdownDescription:t.localize(1909,null)}}},untrustedWorkspaces:{description:t.localize(1910,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:t.localize(1911,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(1912,null),t.localize(1913,null),t.localize(1914,null)]},restrictedConfigurations:{description:t.localize(1915,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:t.localize(1916,null)}}}}},sponsor:{description:t.localize(1917,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:t.localize(1918,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:t.localize(1919,null),type:"string"},"vscode:uninstall":{description:t.localize(1920,null),type:"string"}}},icon:{type:"string",description:t.localize(1921,null)},l10n:{type:"string",description:t.localize(1922,null)},pricing:{type:"string",markdownDescription:t.localize(1923,null),enum:["Free","Trial"],default:"Free"}}};class v{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const p=new u(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,p),i.activationEventsGenerator&&D.$YG.register(i.extensionPoint,i.activationEventsGenerator),e.$0G.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,m.registerSchema(f,e.$0G),p}getExtensionPoints(){return Array.from(this.a.values())}}e.$$G=v;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.$ro.add(g.ExtensionsRegistry,new v),e.$_G=A.$ro.as(g.ExtensionsRegistry),m.registerSchema(f,e.$0G),m.registerSchema(o.$uk,{properties:{extensionEnabledApiProposals:{description:t.localize(1924,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals).map(b=>b.proposal)}}]}}}})}),define(Re[269],Ae([1,0,6,39,2,16,7,21,5,11,267,268]),function(ue,e,t,s,E,k,C,A,y,o,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oH=e.$nH=e.$mH=e.ChatMessageRole=void 0;var m;(function(u){u[u.System=0]="System",u[u.User=1]="User",u[u.Assistant=2]="Assistant"})(m||(e.ChatMessageRole=m={})),e.$mH=(0,y.$Fi)("ILanguageModelsService");const $={type:"object",properties:{vendor:{type:"string",description:(0,C.localize)(8424,null)}}};e.$nH=w.$_G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,C.localize)(8425,null),oneOf:[$,{type:"array",items:$}]},activationEventsGenerator:(u,d)=>{for(const f of u)d.push(`onLanguageModelChat:${f.vendor}`)}});let a=class{constructor(d,f){this.e=d,this.f=f,this.a=new E.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new t.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$nH.setHandler(v=>{this.c.clear();for(const b of v){if(!(0,D.$fH)(b.description,"chatProvider")){b.collector.error((0,C.localize)(8426,null));continue}for(const i of s.Iterable.wrap(b.value)){if(this.c.has(i.vendor)){b.collector.error((0,C.localize)(8427,null,i.vendor));continue}if((0,k.$cf)(i.vendor)){b.collector.error((0,C.localize)(8428,null));continue}if(i.vendor.trim()!==i.vendor){b.collector.error((0,C.localize)(8429,null));continue}this.c.add(i.vendor)}}const g=[];for(const[b,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(b),g.push(b));g.length>0&&this.d.fire({removed:g})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(d){return this.b.get(d)?.metadata}async selectLanguageModels(d){if(d.vendor)await this.e.activateByEvent(`onLanguageModelChat:${d.vendor}}`);else{const v=Array.from(this.c).map(g=>this.e.activateByEvent(`onLanguageModelChat:${g}`));await Promise.all(v)}const f=[];for(const[v,g]of this.b)(d.vendor===void 0||g.metadata.vendor===d.vendor)&&(d.family===void 0||g.metadata.family===d.family)&&(d.version===void 0||g.metadata.version===d.version)&&(d.identifier===void 0||g.metadata.id===d.identifier)&&(!g.metadata.targetExtensions||g.metadata.targetExtensions.some(b=>A.$rn.equals(b,d.extension)))&&f.push(v);return this.f.trace("[LM] selected language models",d,f),f}registerLanguageModelChat(d,f){if(this.f.trace("[LM] registering language model chat",d,f.metadata),!this.c.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this.b.has(d))throw new Error(`Chat response provider with identifier ${d} is already registered.`);return this.b.set(d,f),this.d.fire({added:[{identifier:d,metadata:f.metadata}]}),(0,E.$Sc)(()=>{this.b.delete(d)&&(this.d.fire({removed:[d]}),this.f.trace("[LM] UNregistered language model chat",d,f.metadata))})}async sendChatRequest(d,f,v,g,b){const i=this.b.get(d);if(!i)throw new Error(`Chat response provider with identifier ${d} is not registered.`);return i.sendChatRequest(v,f,g,b)}computeTokenLength(d,f,v){const g=this.b.get(d);if(!g)throw new Error(`Chat response provider with identifier ${d} is not registered.`);return g.provideTokenCount(f,v)}};e.$oH=a,e.$oH=a=Be([je(0,D.$cH),je(1,o.$ak)],a)}),define(Re[270],Ae([1,0,21,7,62]),function(ue,e,t,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LR=k,E=Ue(E);function k(C,A,y,o,D){const w=new t.$tn;return C.forEach(m=>{const $=w.get(m.identifier);$&&D.warn((0,s.localize)(1839,null,$.extensionLocation.fsPath,m.extensionLocation.fsPath)),w.set(m.identifier,m)}),A.forEach(m=>{const $=w.get(m.identifier);if($)if($.isBuiltin){if(E.gte($.version,m.version)){D.warn(`Skipping extension ${m.extensionLocation.path} in favour of the builtin extension ${$.extensionLocation.path}.`);return}m.isBuiltin=!0}else D.warn((0,s.localize)(1840,null,$.extensionLocation.fsPath,m.extensionLocation.fsPath));else if(m.isBuiltin){D.warn(`Skipping obsolete builtin extension ${m.extensionLocation.path}`);return}w.set(m.identifier,m)}),y.forEach(m=>{const $=w.get(m.identifier);$&&D.warn((0,s.localize)(1841,null,$.extensionLocation.fsPath,m.extensionLocation.fsPath)),w.set(m.identifier,m)}),o.forEach(m=>{D.info((0,s.localize)(1842,null,m.extensionLocation.fsPath));const $=w.get(m.identifier);$&&$.isBuiltin&&(m.isBuiltin=!0),w.set(m.identifier,m)}),Array.from(w.values())}}),define(Re[271],Ae([1,0,8,3,31,4,43,58,41,63,21,270,12]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PR=e.$OR=void 0,s=Ue(s),C=Ue(C);class ${constructor(d,f,v,g,b,i,p){this.c=d,this.d=v,this.f=g,this.g=b,this.h=i,this.i=p,this.a=Promise.resolve(),this.b=Promise.resolve();const n=f.args["install-builtin-extension"];if(n){b.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"]};C.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=d.installExtensions([],this.j(n),r,!!f.args.force).then(()=>{C.mark("code/server/didInstallBuiltinExtensions"),b.trace("Finished installing builtin extensions")},h=>{b.error(h)})}const l=f.args["install-extension"];l&&(b.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>d.installExtensions(this.j(l),[],{isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"],isApplicationScoped:!0},!!f.args.force)).then(()=>{b.trace("Finished installing extensions")},r=>{b.error(r)}))}j(d){return d.map(f=>/\.vsix$/i.test(f)?k.URI.file((0,t.$ic)(f)?f:(0,t.$jc)((0,E.cwd)(),f)):f)}whenExtensionsReady(){return this.b}async scanExtensions(d,f,v,g,b){C.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${d}`),await this.a;const i=g?g.filter(n=>n.scheme===m.Schemas.file).map(n=>n.fsPath):void 0;f=f??this.d.defaultProfile.extensionsResource;const p=await this.k(f,d??s.$x,v,i,b);return this.g.trace("Scanned Extensions",p),this.r(p),C.mark("code/server/didScanExtensions"),p}async k(d,f,v,g,b){await this.q(f,b);const[i,p,n,l]=await Promise.all([this.n(f),this.o(d,f),this.m(f,v),this.l(f,g)]);return(0,w.$LR)(i,p,n,l,this.g)}async l(d,f){return f?(await Promise.all(f.map(v=>this.f.scanOneOrMultipleExtensions(k.URI.file((0,t.$kc)(v)),D.ExtensionType.User,{language:d})))).flat().map(v=>(0,o.$Qq)(v,!0)):[]}async m(d,f){const v=[];if(f?.length){const g=await Promise.all(f.map(b=>this.f.scanExistingExtension(b,D.ExtensionType.User,{language:d})));for(const b of g)b&&v.push((0,o.$Qq)(b,!1))}return v}async n(d){return(await this.f.scanSystemExtensions({language:d,useCache:!0})).map(v=>(0,o.$Qq)(v,!1))}async o(d,f){return(await this.f.scanUserExtensions({profileLocation:d,language:f,useCache:!0})).map(g=>(0,o.$Qq)(g,!1))}async q(d,f){if(!(d===s.$h||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(g=>g.id===d)){this.g.trace(`Language Pack ${d} is already installed. Skipping language pack installation.`);return}}catch(v){this.g.error(v)}if(!f){this.g.trace(`No language pack id provided for language ${d}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${f} for language ${d} is not installed. It will be installed now.`);try{await this.c.installExtensions([f],[],{isMachineScoped:!0},!0)}catch(v){this.g.error(v)}}}r(d){const f=(n,l)=>n.replace(/file/g,"vscode-remote"),v=n=>{let l="";return l+=n.global?"g":"",l+=n.ignoreCase?"i":"",l+=n.multiline?"m":"",new RegExp(f(n.source,!0),l)},g=new class{mapDefined(n){return y.$Ij.create(n)}mapNot(n){return y.$Nj.create(n)}mapEquals(n,l){return n==="resourceScheme"&&typeof l=="string"?y.$Jj.create(n,f(l,!1)):y.$Jj.create(n,l)}mapNotEquals(n,l){return n==="resourceScheme"&&typeof l=="string"?y.$Mj.create(n,f(l,!1)):y.$Mj.create(n,l)}mapGreater(n,l){return y.$Oj.create(n,l)}mapGreaterEquals(n,l){return y.$Pj.create(n,l)}mapSmaller(n,l){return y.$Qj.create(n,l)}mapSmallerEquals(n,l){return y.$Rj.create(n,l)}mapRegex(n,l){return n==="resourceScheme"&&l?y.$Sj.create(n,v(l)):y.$Sj.create(n,l)}mapIn(n,l){return y.$Kj.create(n,l)}mapNotIn(n,l){return y.$Lj.create(n,l)}},b=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const l=y.$Dj.deserialize(n.when);if(!l)return;const r=l.map(g);n.when=r.serialize()},i=n=>{if(Array.isArray(n))for(const l of n)b(l);else b(n)},p=n=>{for(const l in n)i(n[l])};d.forEach(n=>{n.contributes&&(n.contributes.menus&&p(n.contributes.menus),n.contributes.keybindings&&i(n.contributes.keybindings),n.contributes.views&&p(n.contributes.views))})}}e.$OR=$;class a{constructor(d,f){this.a=d,this.b=f}listen(d,f){throw new Error("Invalid listen")}async call(d,f,v){const g=this.b(d);switch(f){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const b=v[0],i=v[1]?k.URI.revive(g.transformIncoming(v[1])):void 0,p=Array.isArray(v[2])?v[2].map(h=>k.URI.revive(g.transformIncoming(h))):void 0,n=Array.isArray(v[3])?v[3].map(h=>k.URI.revive(g.transformIncoming(h))):void 0,l=v[4];return(await this.a.scanExtensions(b,i,p,n,l)).map(h=>(0,A.$On)(h,g))}}throw new Error("Invalid call")}}e.$PR=a}),define(Re[150],Ae([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=e.$Uw=void 0,e.$Vw=E,e.$Ww=k;class t{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++t.count}}e.$Uw=t;const s=[];function E(A){const y=new t(A);return s[y.nid]=y,y}function k(A){return s[A].sid}class C{constructor(y){this.value=y}}e.$Xw=C}),define(Re[272],Ae([1,0,150]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var s;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(s||(e.TextEditorRevealType=s={}));var E;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput",u[u.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(E||(e.TabInputKind=E={}));var k;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C||(e.WebviewEditorCapabilities=C={}));var A;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var y;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var o;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var D;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output",u[u.Hybrid=3]="Hybrid"})(D||(e.CandidatePortSource=D={}));class w{static{this.a=0}static mixin(d){return d._id=w.a++,d}}e.$JN=w;var m;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var $;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})($||(e.ISuggestResultDtoField=$={}));var a;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$KN={MainThreadAuthentication:(0,t.$Vw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.$Vw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,t.$Vw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,t.$Vw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,t.$Vw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,t.$Vw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,t.$Vw)("MainThreadChatSkills"),MainThreadClipboard:(0,t.$Vw)("MainThreadClipboard"),MainThreadCommands:(0,t.$Vw)("MainThreadCommands"),MainThreadComments:(0,t.$Vw)("MainThreadComments"),MainThreadConfiguration:(0,t.$Vw)("MainThreadConfiguration"),MainThreadConsole:(0,t.$Vw)("MainThreadConsole"),MainThreadDebugService:(0,t.$Vw)("MainThreadDebugService"),MainThreadDecorations:(0,t.$Vw)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.$Vw)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.$Vw)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.$Vw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.$Vw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.$Vw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.$Vw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.$Vw)("MainThreadEditorTabs"),MainThreadErrors:(0,t.$Vw)("MainThreadErrors"),MainThreadTreeViews:(0,t.$Vw)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.$Vw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,t.$Vw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.$Vw)("MainThreadLanguages"),MainThreadLogger:(0,t.$Vw)("MainThreadLogger"),MainThreadMessageService:(0,t.$Vw)("MainThreadMessageService"),MainThreadOutputService:(0,t.$Vw)("MainThreadOutputService"),MainThreadProgress:(0,t.$Vw)("MainThreadProgress"),MainThreadQuickDiff:(0,t.$Vw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,t.$Vw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.$Vw)("MainThreadStatusBar"),MainThreadSecretState:(0,t.$Vw)("MainThreadSecretState"),MainThreadStorage:(0,t.$Vw)("MainThreadStorage"),MainThreadSpeech:(0,t.$Vw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,t.$Vw)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.$Vw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,t.$Vw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,t.$Vw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.$Vw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.$Vw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.$Vw)("MainThreadCustomEditors"),MainThreadUrls:(0,t.$Vw)("MainThreadUrls"),MainThreadUriOpeners:(0,t.$Vw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,t.$Vw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,t.$Vw)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.$Vw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,t.$Vw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,t.$Vw)("MainThreadExtensionService"),MainThreadSCM:(0,t.$Vw)("MainThreadSCM"),MainThreadSearch:(0,t.$Vw)("MainThreadSearch"),MainThreadShare:(0,t.$Vw)("MainThreadShare"),MainThreadTask:(0,t.$Vw)("MainThreadTask"),MainThreadWindow:(0,t.$Vw)("MainThreadWindow"),MainThreadLabelService:(0,t.$Vw)("MainThreadLabelService"),MainThreadNotebook:(0,t.$Vw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.$Vw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.$Vw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.$Vw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.$Vw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.$Vw)("MainThreadInteractive"),MainThreadTheming:(0,t.$Vw)("MainThreadTheming"),MainThreadTunnelService:(0,t.$Vw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,t.$Vw)("MainThreadManagedSockets"),MainThreadTimeline:(0,t.$Vw)("MainThreadTimeline"),MainThreadTesting:(0,t.$Vw)("MainThreadTesting"),MainThreadLocalization:(0,t.$Vw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,t.$Vw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,t.$Vw)("MainThreadAiEmbeddingVector")},e.$LN={ExtHostCommands:(0,t.$Vw)("ExtHostCommands"),ExtHostConfiguration:(0,t.$Vw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.$Vw)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.$Vw)("ExtHostDebugService"),ExtHostDecorations:(0,t.$Vw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.$Vw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.$Vw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.$Vw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.$Vw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.$Vw)("ExtHostEditors"),ExtHostTreeViews:(0,t.$Vw)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.$Vw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.$Vw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.$Vw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.$Vw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.$Vw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.$Vw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,t.$Vw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,t.$Vw)("ExtHostStatusBar"),ExtHostShare:(0,t.$Vw)("ExtHostShare"),ExtHostExtensionService:(0,t.$Vw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.$Vw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.$Vw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,t.$Vw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,t.$Vw)("ExtHostSCM"),ExtHostSearch:(0,t.$Vw)("ExtHostSearch"),ExtHostTask:(0,t.$Vw)("ExtHostTask"),ExtHostWorkspace:(0,t.$Vw)("ExtHostWorkspace"),ExtHostWindow:(0,t.$Vw)("ExtHostWindow"),ExtHostWebviews:(0,t.$Vw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.$Vw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.$Vw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.$Vw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.$Vw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.$Vw)("ExtHostEditorTabs"),ExtHostProgress:(0,t.$Vw)("ExtHostProgress"),ExtHostComments:(0,t.$Vw)("ExtHostComments"),ExtHostSecretState:(0,t.$Vw)("ExtHostSecretState"),ExtHostStorage:(0,t.$Vw)("ExtHostStorage"),ExtHostUrls:(0,t.$Vw)("ExtHostUrls"),ExtHostUriOpeners:(0,t.$Vw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,t.$Vw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,t.$Vw)("ExtHostOutputService"),ExtHostLabelService:(0,t.$Vw)("ExtHostLabelService"),ExtHostNotebook:(0,t.$Vw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.$Vw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.$Vw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.$Vw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.$Vw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,t.$Vw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,t.$Vw)("ExtHostInteractive"),ExtHostChatAgents2:(0,t.$Vw)("ExtHostChatAgents"),ExtHostChatVariables:(0,t.$Vw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,t.$Vw)("ExtHostChatSkills"),ExtHostChatProvider:(0,t.$Vw)("ExtHostChatProvider"),ExtHostSpeech:(0,t.$Vw)("ExtHostSpeech"),ExtHostEmbeddings:(0,t.$Vw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,t.$Vw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,t.$Vw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,t.$Vw)("ExtHostTheming"),ExtHostTunnelService:(0,t.$Vw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,t.$Vw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,t.$Vw)("ExtHostAuthentication"),ExtHostTimeline:(0,t.$Vw)("ExtHostTimeline"),ExtHostTesting:(0,t.$Vw)("ExtHostTesting"),ExtHostTelemetry:(0,t.$Vw)("ExtHostTelemetry"),ExtHostLocalization:(0,t.$Vw)("ExtHostLocalization")}}),define(Re[273],Ae([1,0,14,25,12,119,5]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=e.$rL=void 0,e.$sL=D,e.$tL=w,e.$rL=(0,C.$Fi)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],y=new RegExp(`^[${A.join("")}]+`),o=7;function D($){if($.scheme!==E.Schemas.vscodeNotebookCell)return;const a=$.fragment.indexOf("s");if(a<0)return;const u=parseInt($.fragment.substring(0,a).replace(y,""),o),d=(0,t.$7e)($.fragment.substring(a+1)).toString();if(!isNaN(u))return{handle:u,notebook:$.with({scheme:d,fragment:null})}}function w($,a){const u=a.toString(o),f=`${u.length<A.length?A[u.length-1]:"z"}${u}s${(0,t.$8e)(t.$Ne.fromString($.scheme),!0,!0)}`;return $.with({scheme:E.Schemas.vscodeNotebookCell,fragment:f})}class m{constructor(){this.a=new s.$Ac}getNotebook(a){if(a.scheme===E.Schemas.vscodeNotebookCell){const u=D(a);if(u){const d=this.a.get(u.notebook);if(d)return d}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$uL=m,(0,k.$Rs)(e.$rL,m,k.InstantiationType.Delayed)}),define(Re[151],Ae([1,0,14,82,39,65,12,8,3,41,273]),function(ue,e,t,s,E,k,C,A,y,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$LL=e.CellStatusbarAlignment=e.$KL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$HL=e.$GL=e.$EL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DL=e.$CL=e.$BL=e.$AL=e.CellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$FL=n,e.$IL=h,e.$JL=c,e.$ML=R,e.$NL=O,s=Ue(s),e.$vL="workbench.editor.notebook",e.$wL="workbench.editor.notebookTextDiffEditor",e.$xL="workbench.editor.interactive",e.$yL="workbench.editor.repl",e.$zL="replNotebook.input.execute";var w;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(w||(e.CellKind=w={})),e.$AL=["application/json","application/javascript","text/html","image/svg+xml",k.$$s.latex,k.$$s.markdown,"image/png","image/jpeg",k.$$s.text],e.$BL=[k.$$s.latex,k.$$s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.$$s.text],e.$CL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DL="_notAvailable";var m;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var $;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var a;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var u;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var d;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var f;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var v;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(v||(e.SelectionStateType=v={}));var g;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(g||(e.CellEditType=g={}));var b;(function(z){z.scheme=C.Schemas.vscodeNotebookCell;function Q(oe,ie){return(0,D.$tL)(oe,ie)}z.generate=Q;function M(oe){return(0,D.$sL)(oe)}z.parse=M;function V(oe,ie){return oe.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${oe.scheme!==C.Schemas.file?oe.scheme:""}`})}z.generateCellOutputUri=V;function ne(oe){if(oe.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!ie)return;const x=ie[1]&&ie[1]!==""?ie[1]:void 0,G=ie[2];return{outputId:x,notebook:oe.with({scheme:G||C.Schemas.file,fragment:null})}}z.parseCellOutputUri=ne;function re(oe,ie,x){return z.generate(oe,ie).with({scheme:x})}z.generateCellPropertyUri=re;function me(oe,ie){if(oe.scheme===ie)return z.parse(oe.with({scheme:z.scheme}))}z.parseCellPropertyUri=me})(b||(e.CellUri=b={}));const i=z=>y.$j?z.replace(/\//g,"\\"):z;class p{constructor(Q=[],M=e.$AL){this.e=M,this.d=[...new Set(Q)].map(V=>({pattern:V,matches:s.$Ak(i(V))}))}sort(Q){const M=new Map(E.Iterable.map(Q,ne=>[ne,i(ne)]));let V=[];for(const{matches:ne}of this.d)for(const[re,me]of M)if(ne(me)){V.push(re),M.delete(re);break}return M.size&&(V=V.concat([...M.keys()].sort((ne,re)=>this.e.indexOf(ne)-this.e.indexOf(re)))),V}prioritize(Q,M){const V=this.f(Q);if(V===-1){this.d.unshift({pattern:Q,matches:s.$Ak(i(Q))});return}const ne=new Set(M.map(me=>this.f(me,V)));ne.delete(-1);const re=Array.from(ne).sort();this.d.splice(V+1,0,...re.map(me=>this.d[me]));for(let me=re.length-1;me>=0;me--)this.d.splice(re[me],1)}toArray(){return this.d.map(Q=>Q.pattern)}f(Q,M=this.d.length){const V=i(Q);for(let ne=0;ne<M;ne++)if(this.d[ne].matches(V))return ne;return-1}}e.$EL=p;function n(z,Q,M,V=(ne,re)=>ne===re){const ne=[];function re(ie,x,G){if(x===0&&G.length===0)return;const T=ne[ne.length-1];T&&T.start+T.deleteCount===ie?(T.deleteCount+=x,T.toInsert.push(...G)):ne.push({start:ie,deleteCount:x,toInsert:G})}let me=0,oe=0;for(;;){if(me===z.length){re(me,0,Q.slice(oe));break}if(oe===Q.length){re(me,z.length-me,[]);break}const ie=z[me],x=Q[oe];if(V(ie,x)){me+=1,oe+=1;continue}M(x)?(re(me,1,[]),me+=1):(re(me,0,[x]),oe+=1)}return ne}e.$GL=new o.$Wj("notebookEditorCursorAtBoundary","none"),e.$HL=new o.$Wj("notebookEditorCursorAtLineBoundary","none");var l;(function(z){z.default="default",z.option="option"})(l||(e.NotebookEditorPriority=l={}));var r;(function(z){z.Cells="cells",z.Text="text",z.None="none"})(r||(e.NotebookFindScopeType=r={}));function h(z){const Q=z;return!!((typeof Q.include=="string"||s.$Bk(Q.include))&&(typeof Q.exclude=="string"||s.$Bk(Q.exclude)))}function c(z,Q,M){if(Array.isArray(z.viewType)&&z.viewType.indexOf(Q)>=0||z.viewType===Q)return!0;if(z.filenamePattern){const V=h(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,ne=h(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(s.$zk(V,(0,A.$nc)(M.fsPath).toLowerCase()))return!(ne&&s.$zk(ne,(0,A.$nc)(M.fsPath).toLowerCase()))}return!1}e.$KL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class I{static{this.d="notebook/"}static create(Q){return`${I.d}${Q}`}static parse(Q){if(Q.startsWith(I.d))return Q.substring(I.d.length)}}e.$LL=I;function R(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}const L=new TextDecoder;function O(z){const Q=[];let M=!1;for(const me of z)(Q.length===0||M)&&(Q.push(me),M=!0);let V=K(Q);const ne=t.$Ne.concat(Q.map(me=>t.$Ne.wrap(me))),re=le(ne);return V=V||re.byteLength!==ne.byteLength,{data:re,didCompression:V}}e.$OL="\x1B[A";const P=e.$OL.split("").map(z=>z.charCodeAt(0)),q=10;function K(z){let Q=!1;return z.forEach((M,V)=>{if(V===0||M.length<e.$OL.length)return;const ne=z[V-1],re=M.subarray(0,e.$OL.length);if(re[0]===P[0]&&re[1]===P[1]&&re[2]===P[2]){const me=ne.lastIndexOf(q);if(me===-1)return;Q=!0,z[V-1]=ne.subarray(0,me),z[V]=M.subarray(e.$OL.length)}}),Q}function J(z){let Q=z;do z=Q,Q=z.replace(/[^\n]\x08/gm,"");while(Q.length<z.length);return z}function _(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const Q=z.match(/^(.*)\r+/m)[1];let M=z.match(/\r+(.*)$/m)[1];M=M+Q.slice(M.length,Q.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,M)}return z}const de=8,ge=13;function le(z){return!z.buffer.includes(de)&&!z.buffer.includes(ge)?z:t.$Ne.fromString(_(J(L.decode(z.buffer))))}}),define(Re[152],Ae([1,0,17,9,109,25,65,16,10,4,22,21,15,89,151]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a){"use strict";var u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$_P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.LanguageModelChatMessageRole=e.$3P=e.$2P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$1P=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$LP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yP=e.$xP=e.$wP=e.$vP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.TestRunProfileKind=e.TestResultState=e.$oP=e.$nP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$mP=e.NotebookVariablesRequestKind=e.$lP=e.$kP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$jP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.ColorThemeKind=e.$dP=e.$cP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$bP=e.QuickInputButtonLocation=e.$aP=e.DebugConsoleMode=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$7O=e.$6O=e.FileChangeType=e.$5O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$4O=e.$3O=e.$2O=e.$1O=e.InlineCompletionTriggerKind=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$NO=e.ConfigurationTarget=e.$MO=e.$LO=e.$KO=e.$JO=e.DocumentPasteTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$CO=e.ViewBadge=e.ProgressLocation=e.$BO=e.$AO=e.TaskScope=e.ShellQuoting=e.$zO=e.$yO=e.$xO=e.TaskPanelKind=e.TaskRevealKind=e.$wO=e.TerminalLocation=e.$vO=e.$uO=e.$tO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$sO=e.$rO=e.$qO=e.$pO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$nO=e.$mO=e.$lO=e.$kO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$jO=e.$iO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.LanguageStatusSeverity=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CodeActionTriggerKind=e.$9N=e.$8N=e.SymbolTag=e.SymbolKind=e.$7N=e.$6N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZN=e.$YN=e.FileEditType=e.$XN=e.$WN=e.$VN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UN=e.$TN=e.$SN=e.$PN=e.$ON=e.$NN=e.$MN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$QN=ge,e.$RN=le,e.$oO=st,e.$OO=En,e.$uP=gi;function O(j){return Object.assign(j,{apply:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const Ie=se.length===1?[]:se[1];return Reflect.construct(j,Ie,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const[Ie,...Ve]=se;return Reflect.construct(j,Ve,Ie.constructor)}}})}var P;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var q;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(q||(e.TerminalQuickFixType=q={}));let K=u=class{static from(...N){let se=N;return new u(function(){if(se){for(const Ie of se)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();se=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$MN=K,e.$MN=K=u=Be([O],K);let J=d=class{static Min(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Ie=1;Ie<N.length;Ie++){const Ve=N[Ie];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(N){if(!N)return!1;if(N instanceof d)return!0;const{line:se,character:Ie}=N;return typeof se=="number"&&typeof Ie=="number"}static of(N){if(N instanceof d)return N;if(this.isPosition(N))return new d(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,se){if(N<0)throw(0,s.$6)("line must be non-negative");if(se<0)throw(0,s.$6)("character must be non-negative");this.c=N,this.e=se}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,se=0){if(N===null||se===null)throw(0,s.$6)();let Ie;return typeof N>"u"?Ie=0:typeof N=="number"?Ie=N:(Ie=typeof N.lineDelta=="number"?N.lineDelta:0,se=typeof N.characterDelta=="number"?N.characterDelta:0),Ie===0&&se===0?this:new d(this.line+Ie,this.character+se)}with(N,se=this.character){if(N===null||se===null)throw(0,s.$6)();let Ie;return typeof N>"u"?Ie=this.line:typeof N=="number"?Ie=N:(Ie=typeof N.line=="number"?N.line:this.line,se=typeof N.character=="number"?N.character:this.character),Ie===this.line&&se===this.character?this:new d(Ie,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$NN=J,e.$NN=J=d=Be([O],J);let _=f=class{static isRange(N){return N instanceof f?!0:N?J.isPosition(N.start)&&J.isPosition(N.end):!1}static of(N){if(N instanceof f)return N;if(this.isRange(N))return new f(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,se,Ie,Ve){let xe,at;if(typeof N=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(xe=new J(N,se),at=new J(Ie,Ve)):J.isPosition(N)&&J.isPosition(se)&&(xe=J.of(N),at=J.of(se)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(N){return f.isRange(N)?this.contains(N.start)&&this.contains(N.end):J.isPosition(N)?!(J.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const se=J.Max(N.start,this.c),Ie=J.Min(N.end,this.e);if(!se.isAfter(Ie))return new f(se,Ie)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const se=J.Min(N.start,this.c),Ie=J.Max(N.end,this.end);return new f(se,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,se=this.end){if(N===null||se===null)throw(0,s.$6)();let Ie;return N?J.isPosition(N)?Ie=N:(Ie=N.start||this.start,se=N.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&se.isEqual(this.end)?this:new f(Ie,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return ge(this)}};e.$ON=_,e.$ON=_=f=Be([O],_);let de=v=class extends _{static isSelection(N){return N instanceof v?!0:N?_.isRange(N)&&J.isPosition(N.anchor)&&J.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,se,Ie,Ve){let xe,at;if(typeof N=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ve=="number"?(xe=new J(N,se),at=new J(Ie,Ve)):J.isPosition(N)&&J.isPosition(se)&&(xe=J.of(N),at=J.of(se)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return le(this)}};e.$PN=de,e.$PN=de=v=Be([O],de);function ge(j){return j.isEmpty?`[${j.start.line}:${j.start.character})`:`[${j.start.line}:${j.start.character} -> ${j.end.line}:${j.end.character})`}function le(j){let N=ge(j);return j.isEmpty||(j.active.isEqual(j.start)?N=`|${N}`:N=`${N}|`),N}const z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,s.$6)("connectionToken")};class Q{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se,Ie){if(typeof N!="string"||N.length===0)throw(0,s.$6)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,s.$6)("port");typeof Ie<"u"&&z(Ie),this.host=N,this.port=Math.round(se),this.connectionToken=Ie}}e.$SN=Q;class M{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se){this.makeConnection=N,this.connectionToken=se,typeof se<"u"&&z(se)}}e.$TN=M;class V extends Error{static NotAvailable(N,se){return new V(N,$.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(N){return new V(N,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,se=$.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(N),this._message=N,this._code=se,this._detail=Ie,Object.setPrototypeOf(this,V.prototype)}}e.$UN=V;var ne;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ne||(e.EndOfLine=ne={}));var re;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(re||(e.EnvironmentVariableMutatorType=re={}));let me=g=class{static isTextEdit(N){return N instanceof g?!0:N?_.isRange(N)&&typeof N.newText=="string":!1}static replace(N,se){return new g(N,se)}static insert(N,se){return g.replace(new _(N,N),se)}static delete(N){return g.replace(N,"")}static setEndOfLine(N){const se=new g(new _(new J(0,0),new J(0,0)),"");return se.newEol=N,se}get range(){return this.c}set range(N){if(N&&!_.isRange(N))throw(0,s.$6)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,s.$6)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,s.$6)("newEol");this.f=N}constructor(N,se){this.c=N,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VN=me,e.$VN=me=g=Be([O],me);let oe=b=class{static isNotebookCellEdit(N){return N instanceof b?!0:N?cn.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,se){return new b(N,se)}static insertCells(N,se){return new b(new cn(N,N),se)}static deleteCells(N){return new b(N,[])}static updateCellMetadata(N,se){const Ie=new b(new cn(N,N),[]);return Ie.newCellMetadata=se,Ie}static updateNotebookMetadata(N){const se=new b(new cn(0,0),[]);return se.newNotebookMetadata=N,se}constructor(N,se){this.range=N,this.newCells=se}};e.$WN=oe,e.$WN=oe=b=Be([O],oe);class ie{static isSnippetTextEdit(N){return N instanceof ie?!0:N?_.isRange(N.range)&&T.isSnippetString(N.snippet):!1}static replace(N,se){return new ie(N,se)}static insert(N,se){return ie.replace(new _(N,N),se)}constructor(N,se){this.range=N,this.snippet=se}}e.$XN=ie;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(x||(e.FileEditType=x={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,se,Ie,Ve){this.c.push({_type:x.File,from:N,to:se,options:Ie,metadata:Ve})}createFile(N,se,Ie){this.c.push({_type:x.File,from:void 0,to:N,options:se,metadata:Ie})}deleteFile(N,se,Ie){this.c.push({_type:x.File,from:N,to:void 0,options:se,metadata:Ie})}e(N,se,Ie){this.c.push({_type:x.Cell,metadata:Ie,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(N,se,Ie,Ve){const xe=se.start,at=se.end;(xe!==at||Ie.length>0)&&this.c.push({_type:x.CellReplace,uri:N,index:xe,count:at-xe,cells:Ie,metadata:Ve})}g(N,se,Ie,Ve){this.c.push({_type:x.Cell,metadata:Ve,uri:N,edit:{editType:a.CellEditType.Metadata,index:se,metadata:Ie}})}replace(N,se,Ie,Ve){this.c.push({_type:x.Text,uri:N,edit:new me(se,Ie),metadata:Ve})}insert(N,se,Ie,Ve){this.replace(N,new _(se,se),Ie,Ve)}delete(N,se,Ie){this.replace(N,se,"",Ie)}has(N){return this.c.some(se=>se._type===x.Text&&se.uri.toString()===N.toString())}set(N,se){if(se)for(const Ie of se){if(!Ie)continue;let Ve,xe;Array.isArray(Ie)?(Ve=Ie[0],xe=Ie[1]):Ve=Ie,oe.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.g(N,Ve.range.start,Ve.newCellMetadata,xe):Ve.newNotebookMetadata?this.e(N,Ve.newNotebookMetadata,xe):this.f(N,Ve.range,Ve.newCells,xe):ie.isSnippetTextEdit(Ve)?this.c.push({_type:x.Snippet,uri:N,range:Ve.range,edit:Ve.snippet,metadata:xe}):this.c.push({_type:x.Text,uri:N,edit:Ve,metadata:xe})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Ve=this.c[Ie];switch(Ve._type){case x.Text:case x.Snippet:case x.Cell:case x.CellReplace:Ve.uri.toString()===N.toString()&&(this.c[Ie]=void 0);break}}(0,t.$Hb)(this.c)}}get(N){const se=[];for(const Ie of this.c)Ie._type===x.Text&&Ie.uri.toString()===N.toString()&&se.push(Ie.edit);return se}entries(){const N=new k.$Ac;for(const se of this.c)if(se._type===x.Text){let Ie=N.get(se.uri);Ie||(Ie=[se.uri,[]],N.set(se.uri,Ie)),Ie[1].push(se.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YN=G,e.$YN=G=Be([O],G);let T=i=class{static isSnippetString(N){return N instanceof i?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=i.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,se=this.e++){if(typeof N=="function"){const Ie=new i;Ie.e=this.e,N(Ie),this.e=Ie.e,N=Ie.value}else N=i.c(N);return this.value+="${",this.value+=se,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,se=this.e++){const Ie=N.map(Ve=>Ve.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(N,se){if(typeof se=="function"){const Ie=new i;Ie.e=this.e,se(Ie),this.e=Ie.e,se=Ie.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$ZN=T,e.$ZN=T=i=Be([O],T);var X;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var he;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(he||(e.DiagnosticSeverity=he={}));let B=p=class{static isLocation(N){return N instanceof p?!0:N?_.isRange(N.range)&&o.URI.isUri(N.uri):!1}constructor(N,se){if(this.uri=N,se)if(_.isRange(se))this.range=_.of(se);else if(J.isPosition(se))this.range=new _(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1N=B,e.$1N=B=p=Be([O],B);let U=class{static is(N){return N?typeof N.message=="string"&&N.location&&_.isRange(N.location.range)&&o.URI.isUri(N.location.uri):!1}constructor(N,se){this.location=N,this.message=se}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.location.range.isEqual(se.location.range)&&N.location.uri.toString()===se.location.uri.toString()}};e.$2N=U,e.$2N=U=Be([O],U);let H=class{constructor(N,se,Ie=he.Error){if(!_.isRange(N))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=N,this.message=se,this.severity=Ie}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.severity===se.severity&&N.code===se.code&&N.severity===se.severity&&N.source===se.source&&N.range.isEqual(se.range)&&(0,t.$tb)(N.tags,se.tags)&&(0,t.$tb)(N.relatedInformation,se.relatedInformation,U.isEqual)}};e.$3N=H,e.$3N=H=Be([O],H);let F=class{constructor(N,se){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=se}};e.$4N=F,e.$4N=F=Be([O],F);let W=class extends F{constructor(N,se,Ie,Ve){super(N,se),this.canIncreaseVerbosity=Ie,this.canDecreaseVerbosity=Ve}};e.$5N=W,e.$5N=W=Be([O],W);var Y;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Y||(e.HoverVerbosityAction=Y={}));var ae;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let Ee=class{constructor(N,se=ae.Text){this.range=N,this.kind=se}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$6N=Ee,e.$6N=Ee=Be([O],Ee);let Le=class{constructor(N,se){this.uri=N,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$7N=Le,e.$7N=Le=Be([O],Le);var be;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(be||(e.SymbolKind=be={}));var pe;(function(j){j[j.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let we=n=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,se,Ie,Ve,xe){this.name=N,this.kind=se,this.containerName=xe,typeof Ie=="string"&&(this.containerName=Ie),Ve instanceof B?this.location=Ve:Ie instanceof _&&(this.location=new B(Ve,Ie)),n.validate(this)}toJSON(){return{name:this.name,kind:be[this.kind],location:this.location,containerName:this.containerName}}};e.$8N=we,e.$8N=we=n=Be([O],we);let Te=l=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(l.validate)}constructor(N,se,Ie,Ve,xe){this.name=N,this.detail=se,this.kind=Ie,this.range=Ve,this.selectionRange=xe,this.children=[],l.validate(this)}};e.$9N=Te,e.$9N=Te=l=Be([O],Te);var ce;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(ce||(e.CodeActionTriggerKind=ce={}));let ye=class{constructor(N,se){this.title=N,this.kind=se}};e.$0N=ye,e.$0N=ye=Be([O],ye);let ve=class{static{r=this}static{this.c="."}constructor(N){this.value=N}append(N){return new r(this.value?this.value+r.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+r.c)}};e.$$N=ve,e.$$N=ve=r=Be([O],ve),ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll"),ve.Notebook=ve.Empty.append("notebook");let ze=class{constructor(N,se){if(this.range=N,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$_N=ze,e.$_N=ze=Be([O],ze);class qe{constructor(N,se,Ie,Ve,xe,at){this.kind=N,this.name=se,this.detail=Ie,this.uri=Ve,this.range=xe,this.selectionRange=at}}e.$aO=qe;class Je{constructor(N,se){this.fromRanges=se,this.from=N}}e.$bO=Je;class Ge{constructor(N,se){this.fromRanges=se,this.to=N}}e.$cO=Ge;var Ze;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ze||(e.LanguageStatusSeverity=Ze={}));let Ye=class{constructor(N,se){this.range=N,this.command=se}get isResolved(){return!!this.command}};e.$dO=Ye,e.$dO=Ye=Be([O],Ye);let it=h=class{#e;static isMarkdownString(N){return N instanceof h?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,se=!1){this.#e=new E.$4k(N,{supportThemeIcons:se})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,se){return this.#e.appendCodeblock(se??"",N),this}};e.$eO=it,e.$eO=it=h=Be([O],it);let lt=class{constructor(N,se){this.label=N,this.documentation=se}};e.$fO=lt,e.$fO=lt=Be([O],lt);let rt=class{constructor(N,se){this.label=N,this.documentation=se,this.parameters=[]}};e.$gO=rt,e.$gO=rt=Be([O],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$hO=nt,e.$hO=nt=Be([O],nt);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var et;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let Xe=class{constructor(N){this.value=N}};e.$iO=Xe,e.$iO=Xe=Be([O],Xe);let $e=class{constructor(N,se,Ie){this.position=N,this.label=se,this.kind=Ie}};e.$jO=$e,e.$jO=$e=Be([O],$e);var Ne;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ne||(e.CompletionTriggerKind=Ne={}));var Fe;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Fe||(e.CompletionItemKind=Fe={}));var ke;(function(j){j[j.Deprecated=1]="Deprecated"})(ke||(e.CompletionItemTag=ke={}));let Ce=class{constructor(N,se){this.label=N,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Fe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$kO=Ce,e.$kO=Ce=Be([O],Ce);let te=class{constructor(N=[],se=!1){this.items=N,this.isIncomplete=se}};e.$lO=te,e.$lO=te=Be([O],te);let ee=class{constructor(N,se,Ie){this.insertText=N,this.range=se,this.command=Ie}};e.$mO=ee,e.$mO=ee=Be([O],ee);let Se=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$nO=Se,e.$nO=Se=Be([O],Se);var We;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(We||(e.PartialAcceptTriggerKind=We={}));var Ke;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ke||(e.ViewColumn=Ke={}));var _e;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(_e||(e.StatusBarAlignment=_e={}));function st(j,N){return`${w.$rn.toKey(j)}.${N}`}var ut;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(ut||(e.TextEditorLineNumbersStyle=ut={}));var gt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var wt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Pt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Pt||(e.TextEditorSelectionChangeKind=Pt={}));var Mt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Mt||(e.TextDocumentChangeReason=Mt={}));var ft;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ft||(e.DecorationRangeBehavior=ft={})),function(j){function N(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=N}(Pt||(e.TextEditorSelectionChangeKind=Pt={}));var vt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(vt||(e.SyntaxTokenType=vt={})),function(j){function N(se){switch(se){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=N}(vt||(e.SyntaxTokenType=vt={}));let Et=class{constructor(N,se){if(se&&!o.URI.isUri(se))throw(0,s.$6)("target");if(!_.isRange(N)||N.isEmpty)throw(0,s.$6)("range");this.range=N,this.target=se}};e.$pO=Et,e.$pO=Et=Be([O],Et);let St=class{constructor(N,se,Ie,Ve){this.red=N,this.green=se,this.blue=Ie,this.alpha=Ve}};e.$qO=St,e.$qO=St=Be([O],St);let Vt=class{constructor(N,se){if(se&&!(se instanceof St))throw(0,s.$6)("color");if(!_.isRange(N)||N.isEmpty)throw(0,s.$6)("range");this.range=N,this.color=se}};e.$rO=Vt,e.$rO=Vt=Be([O],Vt);let Rt=class{constructor(N){if(!N||typeof N!="string")throw(0,s.$6)("label");this.label=N}};e.$sO=Rt,e.$sO=Rt=Be([O],Rt);var ht;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ht||(e.ColorFormat=ht={}));var $t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var bt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Dt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Dt||(e.TerminalShellExecutionCommandLineConfidence=Dt={}));class zt{constructor(N,se,Ie){if(this.startIndex=N,this.length=se,this.tooltip=Ie,typeof N!="number"||N<0)throw(0,s.$6)("startIndex");if(typeof se!="number"||se<1)throw(0,s.$6)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,s.$6)("tooltip")}}e.$tO=zt;class Ot{constructor(N){this.uri=N}}e.$uO=Ot;class en{constructor(N){this.terminalCommand=N}}e.$vO=en;var kt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class Bt{constructor(N){if(this.options=N,typeof N!="object")throw(0,s.$6)("options")}}e.$wO=Bt;var Gt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Gt||(e.TaskRevealKind=Gt={}));var Tt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let Lt=class{static{c=this}static{this.Clean=new c("clean","Clean")}static{this.Build=new c("build","Build")}static{this.Rebuild=new c("rebuild","Rebuild")}static{this.Test=new c("test","Test")}static from(N){switch(N){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}constructor(N,se){if(this.label=se,typeof N!="string"||typeof se!="string")throw(0,s.$6)("name");this.c=N}get id(){return this.c}};e.$xO=Lt,e.$xO=Lt=c=Be([O],Lt);function At(j){let N="";for(let se=0;se<j.length;se++)N+=j[se].replace(/,/g,",,")+",";return N}let Ct=class{constructor(N,se,Ie){if(typeof N!="string")throw(0,s.$6)("process");this.e=[],this.c=N,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Ie):this.f=se)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,s.$6)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const se of this.e)N.push(se);return At(N)}};e.$yO=Ct,e.$yO=Ct=Be([O],Ct);let Zt=class{constructor(N,se,Ie){if(this.f=[],Array.isArray(se)){if(!N)throw(0,s.$6)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,s.$6)("command");this.e=N,this.f=se,this.g=Ie}else{if(typeof N!="string")throw(0,s.$6)("commandLine");this.c=N,this.g=se}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,s.$6)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,s.$6)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)N.push(typeof se=="string"?se:se.value);return At(N)}};e.$zO=Zt,e.$zO=Zt=Be([O],Zt);var Kt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Kt||(e.ShellQuoting=Kt={}));var Ut;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ut||(e.TaskScope=Ut={}));class xt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,D.$2g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$AO=xt;let Jt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,se,Ie,Ve,xe,at){this.k=!1,this.l=this.definition=N;let ct;typeof se=="string"?(this.o=this.name=se,this.w=this.source=Ie,this.execution=Ve,ct=xe,this.k=!0):se===Ut.Global||se===Ut.Workspace?(this.target=se,this.o=this.name=Ie,this.w=this.source=Ve,this.execution=xe,ct=at):(this.target=se,this.o=this.name=Ie,this.w=this.source=Ve,this.execution=xe,ct=at),typeof ct=="string"?(this.r=[ct],this.t=!0):Array.isArray(ct)?(this.r=ct,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ct?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof xt?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,D.$2g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,s.$6)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,s.$6)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const se=this.l.type;(S.g===se||S.e===se||S.f===se||S.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,s.$6)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$BO=Jt,e.$BO=Jt=S=Be([O],Jt);var Xt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var Nt;(function(j){function N(se){const Ie=se;return(0,y.$ig)(Ie.value)?Ie.tooltip&&!(0,y.$eg)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}j.isViewBadge=N})(Nt||(e.ViewBadge=Nt={}));let Ht=I=class{static isTreeItem(N,se){const Ie=N;if(Ie.checkboxState!==void 0){const Ve=(0,y.$ig)(Ie.checkboxState)?Ie.checkboxState:(0,y.$gg)(Ie.checkboxState)&&(0,y.$ig)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,xe=!(0,y.$ig)(Ie.checkboxState)&&(0,y.$gg)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==qt.Checked&&Ve!==qt.Unchecked||xe!==void 0&&!(0,y.$eg)(xe))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(N instanceof I)return!0;if(Ie.label!==void 0&&!(0,y.$eg)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,y.$eg)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,y.$eg)(Ie.iconPath)&&!o.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,y.$eg)(Ie.iconPath.id))){const Ve=Ie.iconPath;if(!Ve||!(0,y.$eg)(Ve.light)&&!o.URI.isUri(Ve.light)&&!(0,y.$eg)(Ve.dark)&&!o.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,y.$eg)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!o.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,y.$eg)(Ie.tooltip)&&!(Ie.tooltip instanceof it)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<pt.None&&Ie.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,y.$eg)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(N,se=pt.None){this.collapsibleState=se,o.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$CO=Ht,e.$CO=Ht=I=Be([O],Ht);var pt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var qt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qt||(e.TreeItemCheckboxState=qt={}));let Ft=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$DO=Ft,e.$DO=Ft=Be([O],Ft);class rn extends Ft{}e.$EO=rn;class hn extends rn{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$FO=hn;class mn{constructor(N,se,Ie,Ve){this.name=N,this.uri=se,this._itemId=Ie,this.c=Ve}data(){return this.c()}}e.$GO=mn;let fn=class{#e=new Map;constructor(N){for(const[se,Ie]of N??[]){const Ve=this.#e.get(this.#t(se));Ve?Ve.push(Ie):this.#e.set(this.#t(se),[Ie])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,se){this.#e.set(this.#t(N),[se])}forEach(N,se){for(const[Ie,Ve]of this.#e)for(const xe of Ve)N.call(se,xe,Ie,this)}*[Symbol.iterator](){for(const[N,se]of this.#e)for(const Ie of se)yield[N,Ie]}#t(N){return N.toLowerCase()}};e.$HO=fn,e.$HO=fn=Be([O],fn);let gn=class{constructor(N,se,Ie){this.insertText=N,this.title=se,this.kind=Ie}};e.$IO=gn,e.$IO=gn=Be([O],gn);var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(bn||(e.DocumentPasteTriggerKind=bn={}));class tn{static{this.c="."}constructor(N){this.value=N}append(...N){return new tn((this.value?[this.value,...N]:N).join(tn.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+tn.c)}}e.$JO=tn,tn.Empty=new tn("");class wn{constructor(N,se,Ie){this.title=se,this.insertText=N,this.kind=Ie}}e.$KO=wn;let Yt=class{constructor(N,se){this.id=N,this.color=se}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$LO=Yt,e.$LO=Yt=Be([O],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let dn=class{constructor(N){this.id=N}};e.$MO=dn,e.$MO=dn=Be([O],dn);var vn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(vn||(e.ConfigurationTarget=vn={}));let pn=class{get base(){return this.c}set base(N){this.c=N,this.e=o.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,se){if(typeof N!="string"&&(!N||!o.URI.isUri(N)&&!o.URI.isUri(N.uri)))throw(0,s.$6)("base");if(typeof se!="string")throw(0,s.$6)("pattern");typeof N=="string"?this.baseUri=o.URI.file(N):o.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$NO=pn,e.$NO=pn=Be([O],pn);const yn=new WeakMap;function En(j,N){yn.set(j,N)}let an=class{constructor(N,se,Ie,Ve,xe){this.enabled=typeof N=="boolean"?N:!0,typeof se=="string"&&(this.condition=se),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ve=="string"&&(this.logMessage=Ve),typeof xe=="string"&&(this.mode=xe)}get id(){return this.c||(this.c=yn.get(this)??(0,D.$2g)()),this.c}};e.$PO=an,e.$PO=an=Be([O],an);let $n=class extends an{constructor(N,se,Ie,Ve,xe,at){if(super(se,Ie,Ve,xe,at),N===null)throw(0,s.$6)("location");this.location=N}};e.$QO=$n,e.$QO=$n=Be([O],$n);let De=class extends an{constructor(N,se,Ie,Ve,xe,at){super(se,Ie,Ve,xe,at),this.functionName=N}};e.$RO=De,e.$RO=De=Be([O],De);let Oe=class extends an{constructor(N,se,Ie,Ve,xe,at,ct,It){if(super(Ve,xe,at,ct,It),!se)throw(0,s.$6)("dataId");this.label=N,this.dataId=se,this.canPersist=Ie}};e.$SO=Oe,e.$SO=Oe=Be([O],Oe);let fe=class{constructor(N,se,Ie){this.command=N,this.args=se||[],this.options=Ie}};e.$TO=fe,e.$TO=fe=Be([O],fe);let Z=class{constructor(N,se){this.port=N,this.host=se}};e.$UO=Z,e.$UO=Z=Be([O],Z);let Pe=class{constructor(N){this.path=N}};e.$VO=Pe,e.$VO=Pe=Be([O],Pe);let Me=class{constructor(N){this.implementation=N}};e.$WO=Me,e.$WO=Me=Be([O],Me);class Qe{constructor(N,se,Ie){this.session=N,this.threadId=se,this.frameId=Ie}}e.$XO=Qe;class He{constructor(N,se){this.session=N,this.threadId=se}}e.$YO=He;let ot=class{constructor(N,se){this.range=N,this.expression=se}};e.$ZO=ot,e.$ZO=ot=Be([O],ot);var mt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(mt||(e.InlineCompletionTriggerKind=mt={}));let jt=class{constructor(N,se){this.range=N,this.text=se}};e.$1O=jt,e.$1O=jt=Be([O],jt);let Qt=class{constructor(N,se,Ie=!0){this.range=N,this.variableName=se,this.caseSensitiveLookup=Ie}};e.$2O=Qt,e.$2O=Qt=Be([O],Qt);let yt=class{constructor(N,se){this.range=N,this.expression=se}};e.$3O=yt,e.$3O=yt=Be([O],yt);let Wt=class{constructor(N,se){this.frameId=N,this.stoppedLocation=se}};e.$4O=Wt,e.$4O=Wt=Be([O],Wt);var Hn;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Hn||(e.NewSymbolNameTag=Hn={}));var qn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(qn||(e.NewSymbolNameTriggerKind=qn={}));class Ni{constructor(N,se){this.newSymbolName=N,this.tags=se}}e.$5O=Ni;var Wn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Wn||(e.FileChangeType=Wn={}));let Cn=R=class extends Error{static FileExists(N){return new R(N,m.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(N){return new R(N,m.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(N){return new R(N,m.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(N){return new R(N,m.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(N){return new R(N,m.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(N){return new R(N,m.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(N,se=m.FileSystemProviderErrorCode.Unknown,Ie){super(o.URI.isUri(N)?N.toString(!0):N),this.code=Ie?.name??"Unknown",(0,m.$pl)(this,se),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$6O=Cn,e.$6O=Cn=R=Be([O],Cn);let On=class{constructor(N,se,Ie){this.start=N,this.end=se,this.kind=Ie}};e.$7O=On,e.$7O=On=Be([O],On);var Vn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Vn||(e.FoldingRangeKind=Vn={}));var Gn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Gn||(e.CommentThreadCollapsibleState=Gn={}));var Zn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var Kn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Kn||(e.CommentState=Kn={}));var Jn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Jn||(e.CommentThreadState=Jn={}));var Qn;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(Qn||(e.CommentThreadApplicability=Qn={}));var xn;(function(j){j[j.Reply=1]="Reply",j[j.Comment=2]="Comment"})(xn||(e.CommentThreadFocus=xn={}));class Fi{constructor(N,se=[]){this.tokenTypes=N,this.tokenModifiers=se}}e.$8O=Fi;function ji(j){return typeof j>"u"||(0,y.$fg)(j)}class Tn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let se=0,Ie=N.tokenTypes.length;se<Ie;se++)this.k.set(N.tokenTypes[se],se);for(let se=0,Ie=N.tokenModifiers.length;se<Ie;se++)this.l.set(N.tokenModifiers[se],se)}}push(N,se,Ie,Ve,xe){if(typeof N=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ve=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(N,se,Ie,Ve,xe);if(_.isRange(N)&&typeof se=="string"&&ji(Ie))return this.o(N,se,Ie);throw(0,s.$6)()}o(N,se,Ie){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=N.start.line,xe=N.start.character,at=N.end.character-N.start.character,ct=this.k.get(se);let It=0;if(Ie)for(const _t of Ie){if(!this.l.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const nn=this.l.get(_t);It|=1<<nn>>>0}this.q(Ve,xe,at,ct,It)}q(N,se,Ie,Ve,xe){if(this.f&&(N<this.c||N===this.c&&se<this.e)){this.f=!1;const It=this.g.length/5|0;let _t=0,nn=0;for(let on=0;on<It;on++){let ln=this.g[5*on],Sn=this.g[5*on+1];ln===0?(ln=_t,Sn+=nn):ln+=_t,this.g[5*on]=ln,this.g[5*on+1]=Sn,_t=ln,nn=Sn}}let at=N,ct=se;this.f&&this.j>0&&(at-=this.c,at===0&&(ct-=this.e)),this.g[this.j++]=at,this.g[this.j++]=ct,this.g[this.j++]=Ie,this.g[this.j++]=Ve,this.g[this.j++]=xe,this.c=N,this.e=se}static r(N){const se=[],Ie=N.length/5|0;for(let ct=0;ct<Ie;ct++)se[ct]=ct;se.sort((ct,It)=>{const _t=N[5*ct],nn=N[5*It];if(_t===nn){const on=N[5*ct+1],ln=N[5*It+1];return on-ln}return _t-nn});const Ve=new Uint32Array(N.length);let xe=0,at=0;for(let ct=0;ct<Ie;ct++){const It=5*se[ct],_t=N[It+0],nn=N[It+1],on=N[It+2],ln=N[It+3],Sn=N[It+4],Oi=_t-xe,Nr=Oi===0?nn-at:nn,Dn=5*ct;Ve[Dn+0]=Oi,Ve[Dn+1]=Nr,Ve[Dn+2]=on,Ve[Dn+3]=ln,Ve[Dn+4]=Sn,xe=_t,at=nn}return Ve}build(N){return this.f?new Ln(new Uint32Array(this.g),N):new Ln(Tn.r(this.g),N)}}e.$9O=Tn;class Ln{constructor(N,se){this.resultId=se,this.data=N}}e.$0O=Ln;class Mi{constructor(N,se,Ie){this.start=N,this.deleteCount=se,this.data=Ie}}e.$$O=Mi;class zi{constructor(N,se){this.resultId=se,this.edits=N}}e.$_O=zi;var Xn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Xn||(e.DebugConsoleMode=Xn={}));class Bi{constructor(N){this.name=N}}e.$aP=Bi;var Yn;(function(j){j[j.Title=1]="Title",j[j.Inline=2]="Inline"})(Yn||(e.QuickInputButtonLocation=Yn={}));let Nn=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$bP=Nn,e.$bP=Nn=Be([O],Nn);var _n;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(_n||(e.QuickPickItemKind=_n={}));var ei;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(ei||(e.InputBoxValidationSeverity=ei={}));var ti;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ti||(e.ExtensionKind=ti={}));class Ui{static validate(N){if(typeof N.badge=="string"){let se=(0,A.$Pf)(N.badge,0);if(se<N.badge.length&&(se+=(0,A.$Pf)(N.badge,se)),N.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Yt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,se,Ie){this.badge=N,this.tooltip=se,this.color=Ie}}e.$cP=Ui;let Fn=class{constructor(N){this.kind=N}};e.$dP=Fn,e.$dP=Fn=Be([O],Fn);var ni;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(ni||(e.ColorThemeKind=ni={}));class cn{static isNotebookRange(N){return N instanceof cn?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,se){if(N<0)throw(0,s.$6)("start must be positive");if(se<0)throw(0,s.$6)("end must be positive");N<=se?(this.c=N,this.e=se):(this.c=se,this.e=N)}with(N){let se=this.c,Ie=this.e;return N.start!==void 0&&(se=N.start),N.end!==void 0&&(Ie=N.end),se===this.c&&Ie===this.e?this:new cn(se,Ie)}}e.$eP=cn;class kn{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(se=>kn.isNotebookCellData(se))}static isNotebookCellData(N){return!0}constructor(N,se,Ie,Ve,xe,at,ct){this.kind=N,this.value=se,this.languageId=Ie,this.mime=Ve,this.outputs=xe??[],this.metadata=at,this.executionSummary=ct,kn.validate(this)}}e.$fP=kn;class Hi{constructor(N){this.cells=N}}e.$gP=Hi;class sn{static isNotebookCellOutputItem(N){return N instanceof sn?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const se={name:N.name,message:N.message,stack:N.stack};return sn.json(se,"application/vnd.code.notebook.error")}static stdout(N){return sn.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return sn.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,se="application/octet-stream"){return new sn(N,se)}static#e=new TextEncoder;static text(N,se=C.$$s.text){const Ie=sn.#e.encode(String(N));return new sn(Ie,se)}static json(N,se="text/x-json"){const Ie=JSON.stringify(N,void 0,"	");return sn.text(Ie,se)}constructor(N,se){this.data=N,this.mime=se;const Ie=(0,C.$ct)(se,!0);if(!Ie)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$hP=sn;class In{static isNotebookCellOutput(N){return N instanceof In?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,se=!1){const Ie=new Set,Ve=new Set;for(let xe=0;xe<N.length;xe++){const at=N[xe],ct=(0,C.$ct)(at.mime);if(!Ie.has(ct)||(0,a.$ML)(ct)){Ie.add(ct);continue}Ve.add(xe),se&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?N:N.filter((xe,at)=>!Ve.has(at))}constructor(N,se,Ie){this.items=In.ensureUniqueMimeTypes(N,!0),typeof se=="string"?(this.id=se,this.metadata=Ie):(this.id=(0,D.$2g)(),this.metadata=se??Ie)}}e.$iP=In;var ii;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ii||(e.NotebookCellKind=ii={}));var ri;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ri||(e.NotebookCellExecutionState=ri={}));var si;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(si||(e.NotebookCellStatusBarAlignment=si={}));var oi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(oi||(e.NotebookEditorRevealType=oi={}));class qi{constructor(N,se){this.text=N,this.alignment=se}}e.$jP=qi;var ai;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ai||(e.NotebookControllerAffinity=ai={}));var li;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(li||(e.NotebookControllerAffinity2=li={}));class Wi{constructor(N,se=[]){this.uri=N,this.provides=(0,t.$1b)(se)}}e.$kP=Wi;class Vi{constructor(N){this.label=N}}e.$lP=Vi;var ci;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(ci||(e.NotebookVariablesRequestKind=ci={}));let jn=class{constructor(N,se){this.label=N,this.timestamp=se}};e.$mP=jn,e.$mP=jn=Be([O],jn);var ui;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(ui||(e.ExtensionMode=ui={}));var hi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(hi||(e.ExtensionRuntime=hi={}));var fi;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(fi||(e.StandardTokenType=fi={}));class Gi{constructor(N,se){this.ranges=N,this.wordPattern=se}}e.$nP=Gi;class Zi{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$oP=Zi;var di;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(di||(e.TestResultState=di={}));var mi;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(mi||(e.TestRunProfileKind=mi={}));let Mn=class{constructor(N=void 0,se=void 0,Ie=void 0,Ve=!1,xe=!0){this.include=N,this.exclude=se,this.profile=Ie,this.continuous=Ve,this.preserveFocus=xe}};e.$pP=Mn,e.$pP=Mn=Be([O],Mn);let zn=L=class{static diff(N,se,Ie){const Ve=new L(N);return Ve.expectedOutput=se,Ve.actualOutput=Ie,Ve}constructor(N){this.message=N}};e.$qP=zn,e.$qP=zn=L=Be([O],zn);let Bn=class{constructor(N){this.id=N}};e.$rP=Bn,e.$rP=Bn=Be([O],Bn);class Ki{constructor(N,se,Ie){this.label=N,this.file=se,this.position=Ie}}e.$sP=Ki;class Pn{constructor(N,se){this.covered=N,this.total=se,gi(this)}}e.$tP=Pn;function gi(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Un{static fromDetails(N,se){const Ie=new Pn(0,0),Ve=new Pn(0,0),xe=new Pn(0,0);for(const ct of se)if("branches"in ct){Ie.total+=1,Ie.covered+=ct.executed?1:0;for(const It of ct.branches)Ve.total+=1,Ve.covered+=It.executed?1:0}else xe.total+=1,xe.covered+=ct.executed?1:0;const at=new Un(N,Ie,Ve.total>0?Ve:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=se,at}constructor(N,se,Ie,Ve,xe=[]){this.uri=N,this.statementCoverage=se,this.branchCoverage=Ie,this.declarationCoverage=Ve,this.fromTests=xe}}e.$vP=Un;class Ji{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,se,Ie=[]){this.executed=N,this.location=se,this.branches=Ie}}e.$wP=Ji;class Qi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,se,Ie){this.executed=N,this.location=se,this.label=Ie}}e.$xP=Qi;class xi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,se,Ie){this.name=N,this.executed=se,this.location=Ie}}e.$yP=xi;var pi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(pi||(e.ExternalUriOpenerPriority=pi={}));var $i;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})($i||(e.WorkspaceTrustState=$i={}));var bi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(bi||(e.PortAutoForwardAction=bi={}));class Xi{constructor(N,se,Ie,Ve,xe,at){this.kind=N,this.name=se,this.detail=Ie,this.uri=Ve,this.range=xe,this.selectionRange=at}}e.$zP=Xi;class Yi{constructor(N){this.uri=N}}e.$AP=Yi;class _i{constructor(N,se){this.original=N,this.modified=se}}e.$BP=_i;class er{constructor(N,se,Ie,Ve){this.base=N,this.input1=se,this.input2=Ie,this.result=Ve}}e.$CP=er;class tr{constructor(N,se){this.uri=N,this.viewType=se}}e.$DP=tr;class nr{constructor(N){this.viewType=N}}e.$EP=nr;class ir{constructor(N,se){this.uri=N,this.notebookType=se}}e.$FP=ir;class rr{constructor(N,se,Ie){this.original=N,this.modified=se,this.notebookType=Ie}}e.$GP=rr;class sr{constructor(){}}e.$HP=sr;class or{constructor(N,se){this.uri=N,this.inputBoxUri=se}}e.$IP=or;class ar{constructor(){}}e.$JP=ar;class lr{constructor(N){this.textDiffs=N}}e.$KP=lr;var wi;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(wi||(e.InteractiveSessionVoteDirection=wi={}));var vi;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vi||(e.ChatCopyKind=vi={}));var yi;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(yi||(e.ChatVariableLevel=yi={}));class cr{constructor(N,se,Ie){this.id=N,this.label=se,this.values=Ie}}e.$LP=cr;var Ei;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Ei||(e.InteractiveEditorResponseFeedbackKind=Ei={}));var Si;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Si||(e.ChatResultFeedbackKind=Si={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new it(N):N}}e.$MP=ur;class hr{constructor(N,se){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new it(N):N,this.vulnerabilities=se}}e.$NP=hr;class fr{constructor(N,se){this.participant=N,this.command=se}}e.$OP=fr;class dr{constructor(N,se,Ie,Ve){this.title=N,this.message=se,this.data=Ie,this.buttons=Ve}}e.$PP=dr;class mr{constructor(N,se){this.value=N,this.baseUri=se}}e.$QP=mr;class gr{constructor(N,se){this.value=N,this.title=se}}e.$RP=gr;class pr{constructor(N){this.value=N}}e.$SP=pr;class $r{constructor(N,se){this.value=N,this.task=se}}e.$TP=$r;class br{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new it(N):N}}e.$UP=br;class wr{constructor(N){this.value=N}}e.$VP=wr;class vr{constructor(N,se,Ie){this.value=N,this.iconPath=se,this.options=Ie}}e.$WP=vr;class yr{constructor(N,se,Ie){this.value=N,this.license=se,this.snippet=Ie}}e.$XP=yr;class Er{constructor(N,se){this.uri=N,this.edits=Array.isArray(se)?se:[se]}}e.$YP=Er;class Sr{constructor(N,se,Ie,Ve){this.prompt=N,this.command=se,this.references=Ie,this.participant=Ve}}e.$ZP=Sr;class Dr{constructor(N,se,Ie,Ve){this.response=N,this.result=se,this.participant=Ie,this.command=Ve}}e.$1P=Dr;var Di;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Di||(e.ChatLocation=Di={}));var ki;(function(j){j[j.Complete=1]="Complete",j[j.Partial=2]="Partial",j[j.Omitted=3]="Omitted"})(ki||(e.ChatResponseReferencePartStatusKind=ki={}));class kr{constructor(N,se,Ie){this.document=N,this.selection=se,this.wholeRange=Ie}}e.$2P=kr;class Ir{constructor(N){this.cell=N}}e.$3P=Ir;var Rn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(Rn||(e.LanguageModelChatMessageRole=Rn={}));class Pr{constructor(N,se,Ie){this.name=N,this.content=se,this.isError=Ie??!1}}e.$4P=Pr;class An{static User(N,se){const Ie=new An(Rn.User,typeof N=="string"?N:"",se);return Ie.content2=N,Ie}static Assistant(N,se){return new An(Rn.Assistant,N,se)}constructor(N,se,Ie){this.role=N,this.content=se,this.content2=se,this.name=Ie}}e.$5P=An;class Rr{constructor(N,se){this.name=N,this.parameters=se}}e.$6P=Rr;class Ar{constructor(N){this.value=N}}e.$7P=Ar;class Cr{constructor(N){this.content=N}}e.$8P=Cr;class Or{constructor(N,se){this.content=N,this.name=se}}e.$9P=Or;class Tr{constructor(N,se){this.content=N,this.name=se}}e.$0P=Tr;class un extends Error{static NotFound(N){return new un(N,un.NotFound.name)}static NoPermissions(N){return new un(N,un.NoPermissions.name)}static Blocked(N){return new un(N,un.Blocked.name)}constructor(N,se,Ie){super(N,{cause:Ie}),this.name="LanguageModelError",this.code=se??""}}e.$$P=un;var Ii;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Ii||(e.RelatedInformationType=Ii={}));var Pi;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Pi||(e.SpeechToTextStatus=Pi={}));var Ri;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Ri||(e.TextToSpeechStatus=Ri={}));var Ai;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Ai||(e.KeywordRecognitionStatus=Ai={}));class Lr{constructor(N,se){this.text=N,this.range=se}}e.$_P=Lr;var Ci;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ci||(e.InlineEditTriggerKind=Ci={}))}),define(Re[153],Ae([1,0,17,14,178,78,109,25,161,48,65,20,167,19,81,10,4,203,50,116,193,188,215,216,147,101,256,269,257,151,75,102,149,152]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$hQ=re,e.$iQ=oe,e.$jQ=ie,C=Ue(C),v=Ue(v),g=Ue(g),b=Ue(b),c=Ue(c),I=Ue(I),P=Ue(P);var q;(function(De){function Oe(Z){const{selectionStartLineNumber:Pe,selectionStartColumn:Me,positionLineNumber:Qe,positionColumn:He}=Z,ot=new P.$NN(Pe-1,Me-1),mt=new P.$NN(Qe-1,He-1);return new P.$PN(ot,mt)}De.to=Oe;function fe(Z){const{anchor:Pe,active:Me}=Z;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}De.from=fe})(q||(e.Selection=q={}));var K;(function(De){function Oe(Z){if(!Z)return;const{start:Pe,end:Me}=Z;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}De.from=Oe;function fe(Z){if(!Z)return;const{startLineNumber:Pe,startColumn:Me,endLineNumber:Qe,endColumn:He}=Z;return new P.$ON(Pe-1,Me-1,Qe-1,He-1)}De.to=fe})(K||(e.Range=K={}));var J;(function(De){function Oe(Z){return{uri:Z.uri,range:K.from(Z.range)}}De.from=Oe;function fe(Z){return new P.$1N(d.URI.revive(Z.uri),K.to(Z.range))}De.to=fe})(J||(e.Location=J={}));var _;(function(De){function Oe(fe){switch(fe){case g.StandardTokenType.Comment:return P.StandardTokenType.Comment;case g.StandardTokenType.Other:return P.StandardTokenType.Other;case g.StandardTokenType.RegEx:return P.StandardTokenType.RegEx;case g.StandardTokenType.String:return P.StandardTokenType.String}}De.to=Oe})(_||(e.TokenType=_={}));var de;(function(De){function Oe(Z){return new P.$NN(Z.lineNumber-1,Z.column-1)}De.to=Oe;function fe(Z){return{lineNumber:Z.line+1,column:Z.character+1}}De.from=fe})(de||(e.Position=de={}));var ge;(function(De){function Oe(Pe,Me,Qe){return(0,t.$Gb)((0,t.$1b)(Pe).map(He=>fe(He,Me,Qe)))}De.from=Oe;function fe(Pe,Me,Qe){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Qe?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Z(Pe.scheme,Me),pattern:Ke.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Qe?.isBuiltin}}function Z(Pe,Me){return Me&&typeof Pe=="string"?Me.transformOutgoingScheme(Pe):Pe}})(ge||(e.DocumentSelector=ge={}));var le;(function(De){function Oe(Z){switch(Z){case P.DiagnosticTag.Unnecessary:return p.MarkerTag.Unnecessary;case P.DiagnosticTag.Deprecated:return p.MarkerTag.Deprecated}}De.from=Oe;function fe(Z){switch(Z){case p.MarkerTag.Unnecessary:return P.DiagnosticTag.Unnecessary;case p.MarkerTag.Deprecated:return P.DiagnosticTag.Deprecated;default:return}}De.to=fe})(le||(e.DiagnosticTag=le={}));var z;(function(De){function Oe(Z){let Pe;return Z.code&&((0,u.$eg)(Z.code)||(0,u.$ig)(Z.code)?Pe=String(Z.code):Pe={value:String(Z.code.value),target:Z.code.target}),{...K.from(Z.range),message:Z.message,source:Z.source,code:Pe,severity:M.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(Q.from),tags:Array.isArray(Z.tags)?(0,t.$Gb)(Z.tags.map(le.from)):void 0}}De.from=Oe;function fe(Z){const Pe=new P.$3N(K.to(Z),Z.message,M.to(Z.severity));return Pe.source=Z.source,Pe.code=(0,u.$eg)(Z.code)?Z.code:Z.code?.value,Pe.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(Q.to),Pe.tags=Z.tags&&(0,t.$Gb)(Z.tags.map(le.to)),Pe}De.to=fe})(z||(e.Diagnostic=z={}));var Q;(function(De){function Oe(Z){return{...K.from(Z.location.range),message:Z.message,resource:Z.location.uri}}De.from=Oe;function fe(Z){return new P.$2N(new P.$1N(Z.resource,K.to(Z)),Z.message)}De.to=fe})(Q||(e.DiagnosticRelatedInformation=Q={}));var M;(function(De){function Oe(Z){switch(Z){case P.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case P.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case P.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case P.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}De.from=Oe;function fe(Z){switch(Z){case p.MarkerSeverity.Info:return P.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return P.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return P.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return P.DiagnosticSeverity.Hint;default:return P.DiagnosticSeverity.Error}}De.to=fe})(M||(e.DiagnosticSeverity=M={}));var V;(function(De){function Oe(Z){return typeof Z=="number"&&Z>=P.ViewColumn.One?Z-1:Z===P.ViewColumn.Beside?O.$zE:O.$yE}De.from=Oe;function fe(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=fe})(V||(e.ViewColumn=V={}));function ne(De){return typeof De.range<"u"}function re(De){return De.length===0?!0:!!ne(De[0])}var me;(function(De){function Oe(He){return He.map(De.from)}De.fromMany=Oe;function fe(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function Z(He){let ot;if(fe(He)){const{language:yt,value:Wt}=He;ot={value:"```"+yt+`
`+Wt+"\n```\n"}}else P.$eO.isMarkdownString(He)?ot={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ot={value:He}:ot={value:""};const mt=Object.create(null);ot.uris=mt;const jt=yt=>{try{let Wt=d.URI.parse(yt,!0);Wt=Wt.with({query:Pe(Wt.query,mt)}),mt[yt]=Wt}catch{}return""},Qt=new y.marked.Renderer;return Qt.link=jt,Qt.image=yt=>typeof yt=="string"?jt(C.$_k(yt).href):"",(0,y.marked)(ot.value,{renderer:Qt}),ot}De.from=Z;function Pe(He,ot){if(!He)return He;let mt;try{mt=(0,o.$bi)(He)}catch{}if(!mt)return He;let jt=!1;return mt=(0,w.$go)(mt,Qt=>{if(d.URI.isUri(Qt)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[yt]=Qt,jt=!0,yt}else return}),jt?JSON.stringify(mt):He}function Me(He){const ot=new P.$eO(He.value,He.supportThemeIcons);return ot.isTrusted=He.isTrusted,ot.supportHtml=He.supportHtml,ot.baseUri=He.baseUri?d.URI.from(He.baseUri):void 0,ot}De.to=Me;function Qe(He){if(He)return typeof He=="string"?He:De.from(He)}De.fromStrict=Qe})(me||(e.MarkdownString=me={}));function oe(De){return re(De)?De.map(Oe=>({range:K.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?me.fromMany(Oe.hoverMessage):Oe.hoverMessage?me.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):De.map(Oe=>({range:K.from(Oe)}))}function ie(De){return typeof De>"u"?De:typeof De=="string"?d.URI.file(De):De}var x;(function(De){function Oe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ie(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}De.from=Oe})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var G;(function(De){function Oe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ie(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}De.from=Oe})(G||(e.ThemableDecorationRenderOptions=G={}));var T;(function(De){function Oe(fe){if(typeof fe>"u")return fe;switch(fe){case P.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case P.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Oe})(T||(e.DecorationRangeBehavior=T={}));var X;(function(De){function Oe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?T.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?G.from(fe.light):void 0,dark:fe.dark?G.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ie(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?x.from(fe.before):void 0,after:fe.after?x.from(fe.after):void 0}}De.from=Oe})(X||(e.DecorationRenderOptions=X={}));var he;(function(De){function Oe(Z){return{text:Z.newText,eol:Z.newEol&&Ce.from(Z.newEol),range:K.from(Z.range)}}De.from=Oe;function fe(Z){const Pe=new P.$VN(K.to(Z.range),Z.text);return Pe.newEol=typeof Z.eol>"u"?void 0:Ce.to(Z.eol),Pe}De.to=fe})(he||(e.TextEdit=he={}));var B;(function(De){function Oe(Z,Pe){const Me={edits:[]};if(Z instanceof P.$YN){const Qe=new A.$Bc;for(const He of Z._allEntries())He._type===P.FileEditType.File&&d.URI.isUri(He.to)&&He.from===void 0&&Qe.add(He.to);for(const He of Z._allEntries())if(He._type===P.FileEditType.File){let ot;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ot={type:"base64",value:(0,s.$8e)(s.$Ne.wrap(He.options.contents))}:ot={type:"dataTransferItem",id:He.options.contents._itemId}),Me.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ot},metadata:He.metadata})}else He._type===P.FileEditType.Text?Me.edits.push({resource:He.uri,textEdit:he.from(He.edit),versionId:Qe.has(He.uri)?void 0:Pe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===P.FileEditType.Snippet?Me.edits.push({resource:He.uri,textEdit:{range:K.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Qe.has(He.uri)?void 0:Pe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===P.FileEditType.Cell?Me.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(He.uri)}):He._type===P.FileEditType.CellReplace&&Me.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:I.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(ft.from)}})}return Me}De.from=Oe;function fe(Z){const Pe=new P.$YN,Me=new A.$Ac;for(const Qe of Z.edits)if(Qe.textEdit){const He=Qe,ot=d.URI.revive(He.resource),mt=K.to(He.textEdit.range),jt=He.textEdit.text,Qt=He.textEdit.insertAsSnippet;let yt;Qt?yt=P.$XN.replace(mt,new P.$ZN(jt)):yt=P.$VN.replace(mt,jt);const Wt=Me.get(ot);Wt?Wt.push(yt):Me.set(ot,[yt])}else Pe.renameFile(d.URI.revive(Qe.oldResource),d.URI.revive(Qe.newResource),Qe.options);for(const[Qe,He]of Me)Pe.set(Qe,He);return Pe}De.to=fe})(B||(e.WorkspaceEdit=B={}));var U;(function(De){const Oe=Object.create(null);Oe[P.SymbolKind.File]=b.SymbolKind.File,Oe[P.SymbolKind.Module]=b.SymbolKind.Module,Oe[P.SymbolKind.Namespace]=b.SymbolKind.Namespace,Oe[P.SymbolKind.Package]=b.SymbolKind.Package,Oe[P.SymbolKind.Class]=b.SymbolKind.Class,Oe[P.SymbolKind.Method]=b.SymbolKind.Method,Oe[P.SymbolKind.Property]=b.SymbolKind.Property,Oe[P.SymbolKind.Field]=b.SymbolKind.Field,Oe[P.SymbolKind.Constructor]=b.SymbolKind.Constructor,Oe[P.SymbolKind.Enum]=b.SymbolKind.Enum,Oe[P.SymbolKind.Interface]=b.SymbolKind.Interface,Oe[P.SymbolKind.Function]=b.SymbolKind.Function,Oe[P.SymbolKind.Variable]=b.SymbolKind.Variable,Oe[P.SymbolKind.Constant]=b.SymbolKind.Constant,Oe[P.SymbolKind.String]=b.SymbolKind.String,Oe[P.SymbolKind.Number]=b.SymbolKind.Number,Oe[P.SymbolKind.Boolean]=b.SymbolKind.Boolean,Oe[P.SymbolKind.Array]=b.SymbolKind.Array,Oe[P.SymbolKind.Object]=b.SymbolKind.Object,Oe[P.SymbolKind.Key]=b.SymbolKind.Key,Oe[P.SymbolKind.Null]=b.SymbolKind.Null,Oe[P.SymbolKind.EnumMember]=b.SymbolKind.EnumMember,Oe[P.SymbolKind.Struct]=b.SymbolKind.Struct,Oe[P.SymbolKind.Event]=b.SymbolKind.Event,Oe[P.SymbolKind.Operator]=b.SymbolKind.Operator,Oe[P.SymbolKind.TypeParameter]=b.SymbolKind.TypeParameter;function fe(Pe){return typeof Oe[Pe]=="number"?Oe[Pe]:b.SymbolKind.Property}De.from=fe;function Z(Pe){for(const Me in Oe)if(Oe[Me]===Pe)return Number(Me);return P.SymbolKind.Property}De.to=Z})(U||(e.SymbolKind=U={}));var H;(function(De){function Oe(Z){switch(Z){case P.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}De.from=Oe;function fe(Z){switch(Z){case b.SymbolTag.Deprecated:return P.SymbolTag.Deprecated}}De.to=fe})(H||(e.SymbolTag=H={}));var F;(function(De){function Oe(Z){return{name:Z.name,kind:U.from(Z.kind),tags:Z.tags&&Z.tags.map(H.from),containerName:Z.containerName,location:Le.from(Z.location)}}De.from=Oe;function fe(Z){const Pe=new P.$8N(Z.name,U.to(Z.kind),Z.containerName,Le.to(Z.location));return Pe.tags=Z.tags&&Z.tags.map(H.to),Pe}De.to=fe})(F||(e.WorkspaceSymbol=F={}));var W;(function(De){function Oe(Z){const Pe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:K.from(Z.range),selectionRange:K.from(Z.selectionRange),kind:U.from(Z.kind),tags:Z.tags?.map(H.from)??[]};return Z.children&&(Pe.children=Z.children.map(Oe)),Pe}De.from=Oe;function fe(Z){const Pe=new P.$9N(Z.name,Z.detail,U.to(Z.kind),K.to(Z.range),K.to(Z.selectionRange));return(0,t.$Kb)(Z.tags)&&(Pe.tags=Z.tags.map(H.to)),Z.children&&(Pe.children=Z.children.map(fe)),Pe}De.to=fe})(W||(e.DocumentSymbol=W={}));var Y;(function(De){function Oe(Z){const Pe=new P.$aO(U.to(Z.kind),Z.name,Z.detail||"",d.URI.revive(Z.uri),K.to(Z.range),K.to(Z.selectionRange));return Pe._sessionId=Z._sessionId,Pe._itemId=Z._itemId,Pe}De.to=Oe;function fe(Z,Pe,Me){if(Pe=Pe??Z._sessionId,Me=Me??Z._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,name:Z.name,detail:Z.detail,kind:U.from(Z.kind),uri:Z.uri,range:K.from(Z.range),selectionRange:K.from(Z.selectionRange),tags:Z.tags?.map(H.from)}}De.from=fe})(Y||(e.CallHierarchyItem=Y={}));var ae;(function(De){function Oe(fe){return new P.$bO(Y.to(fe.from),fe.fromRanges.map(Z=>K.to(Z)))}De.to=Oe})(ae||(e.CallHierarchyIncomingCall=ae={}));var Ee;(function(De){function Oe(fe){return new P.$cO(Y.to(fe.to),fe.fromRanges.map(Z=>K.to(Z)))}De.to=Oe})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var Le;(function(De){function Oe(Z){return{range:Z.range&&K.from(Z.range),uri:Z.uri}}De.from=Oe;function fe(Z){return new P.$1N(d.URI.revive(Z.uri),K.to(Z.range))}De.to=fe})(Le||(e.location=Le={}));var be;(function(De){function Oe(Z){const Pe=Z,Me=Z;return{originSelectionRange:Pe.originSelectionRange?K.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Me.uri,range:K.from(Pe.targetRange?Pe.targetRange:Me.range),targetSelectionRange:Pe.targetSelectionRange?K.from(Pe.targetSelectionRange):void 0}}De.from=Oe;function fe(Z){return{targetUri:d.URI.revive(Z.uri),targetRange:K.to(Z.range),targetSelectionRange:Z.targetSelectionRange?K.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?K.to(Z.originSelectionRange):void 0}}De.to=fe})(be||(e.DefinitionLink=be={}));var pe;(function(De){function Oe(Z){return{range:K.from(Z.range),contents:me.fromMany(Z.contents),canIncreaseVerbosity:Z.canIncreaseVerbosity,canDecreaseVerbosity:Z.canDecreaseVerbosity}}De.from=Oe;function fe(Z){const Pe=Z.contents.map(me.to),Me=K.to(Z.range),Qe=Z.canIncreaseVerbosity,He=Z.canDecreaseVerbosity;return new P.$5N(Pe,Me,Qe,He)}De.to=fe})(pe||(e.Hover=pe={}));var we;(function(De){function Oe(Z){return{range:K.from(Z.range),expression:Z.expression}}De.from=Oe;function fe(Z){return new P.$ZO(K.to(Z.range),Z.expression)}De.to=fe})(we||(e.EvaluatableExpression=we={}));var Te;(function(De){function Oe(Z){if(Z instanceof P.$1O)return{type:"text",range:K.from(Z.range),text:Z.text};if(Z instanceof P.$2O)return{type:"variable",range:K.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof P.$3O)return{type:"expression",range:K.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Oe;function fe(Z){switch(Z.type){case"text":return{range:K.to(Z.range),text:Z.text};case"variable":return{range:K.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:K.to(Z.range),expression:Z.expression}}}De.to=fe})(Te||(e.InlineValue=Te={}));var ce;(function(De){function Oe(Z){return{frameId:Z.frameId,stoppedLocation:K.from(Z.stoppedLocation)}}De.from=Oe;function fe(Z){return new P.$4O(Z.frameId,K.to(Z.stoppedLocation))}De.to=fe})(ce||(e.InlineValueContext=ce={}));var ye;(function(De){function Oe(Z){return{range:K.from(Z.range),kind:Z.kind}}De.from=Oe;function fe(Z){return new P.$6N(K.to(Z.range),Z.kind)}De.to=fe})(ye||(e.DocumentHighlight=ye={}));var ve;(function(De){function Oe(Z){return{uri:Z.uri,highlights:Z.highlights.map(ye.from)}}De.from=Oe;function fe(Z){return new P.$7N(d.URI.revive(Z.uri),Z.highlights.map(ye.to))}De.to=fe})(ve||(e.MultiDocumentHighlight=ve={}));var ze;(function(De){function Oe(fe){switch(fe){case b.CompletionTriggerKind.TriggerCharacter:return P.CompletionTriggerKind.TriggerCharacter;case b.CompletionTriggerKind.TriggerForIncompleteCompletions:return P.CompletionTriggerKind.TriggerForIncompleteCompletions;case b.CompletionTriggerKind.Invoke:default:return P.CompletionTriggerKind.Invoke}}De.to=Oe})(ze||(e.CompletionTriggerKind=ze={}));var qe;(function(De){function Oe(fe){return{triggerKind:ze.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}De.to=Oe})(qe||(e.CompletionContext=qe={}));var Je;(function(De){function Oe(Z){switch(Z){case P.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}De.from=Oe;function fe(Z){switch(Z){case b.CompletionItemTag.Deprecated:return P.CompletionItemTag.Deprecated}}De.to=fe})(Je||(e.CompletionItemTag=Je={}));var Ge;(function(De){const Oe=new Map([[P.CompletionItemKind.Method,b.CompletionItemKind.Method],[P.CompletionItemKind.Function,b.CompletionItemKind.Function],[P.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[P.CompletionItemKind.Field,b.CompletionItemKind.Field],[P.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[P.CompletionItemKind.Class,b.CompletionItemKind.Class],[P.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[P.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[P.CompletionItemKind.Module,b.CompletionItemKind.Module],[P.CompletionItemKind.Property,b.CompletionItemKind.Property],[P.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[P.CompletionItemKind.Value,b.CompletionItemKind.Value],[P.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[P.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[P.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[P.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[P.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[P.CompletionItemKind.Text,b.CompletionItemKind.Text],[P.CompletionItemKind.Color,b.CompletionItemKind.Color],[P.CompletionItemKind.File,b.CompletionItemKind.File],[P.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[P.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[P.CompletionItemKind.Event,b.CompletionItemKind.Event],[P.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[P.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[P.CompletionItemKind.Issue,b.CompletionItemKind.Issue],[P.CompletionItemKind.User,b.CompletionItemKind.User]]);function fe(Me){return Oe.get(Me)??b.CompletionItemKind.Property}De.from=fe;const Z=new Map([[b.CompletionItemKind.Method,P.CompletionItemKind.Method],[b.CompletionItemKind.Function,P.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,P.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,P.CompletionItemKind.Field],[b.CompletionItemKind.Variable,P.CompletionItemKind.Variable],[b.CompletionItemKind.Class,P.CompletionItemKind.Class],[b.CompletionItemKind.Interface,P.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,P.CompletionItemKind.Struct],[b.CompletionItemKind.Module,P.CompletionItemKind.Module],[b.CompletionItemKind.Property,P.CompletionItemKind.Property],[b.CompletionItemKind.Unit,P.CompletionItemKind.Unit],[b.CompletionItemKind.Value,P.CompletionItemKind.Value],[b.CompletionItemKind.Constant,P.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,P.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,P.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,P.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,P.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,P.CompletionItemKind.Text],[b.CompletionItemKind.Color,P.CompletionItemKind.Color],[b.CompletionItemKind.File,P.CompletionItemKind.File],[b.CompletionItemKind.Reference,P.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,P.CompletionItemKind.Folder],[b.CompletionItemKind.Event,P.CompletionItemKind.Event],[b.CompletionItemKind.Operator,P.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,P.CompletionItemKind.TypeParameter],[b.CompletionItemKind.User,P.CompletionItemKind.User],[b.CompletionItemKind.Issue,P.CompletionItemKind.Issue]]);function Pe(Me){return Z.get(Me)??P.CompletionItemKind.Property}De.to=Pe})(Ge||(e.CompletionItemKind=Ge={}));var Ze;(function(De){function Oe(fe,Z){const Pe=new P.$kO(fe.label);return Pe.insertText=fe.insertText,Pe.kind=Ge.to(fe.kind),Pe.tags=fe.tags?.map(Je.to),Pe.detail=fe.detail,Pe.documentation=C.$6k(fe.documentation)?me.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,v.$Ot.isIRange(fe.range)?Pe.range=K.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:K.to(fe.range.insert),replacing:K.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&b.CompletionItemInsertTextRule.KeepWhitespace),typeof fe.insertTextRules<"u"&&fe.insertTextRules&b.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new P.$ZN(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof P.$ON?new P.$VN(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Me=>he.to(Me))),Pe.command=Z&&fe.command?Z.fromInternal(fe.command):void 0,Pe}De.to=Oe})(Ze||(e.CompletionItem=Ze={}));var Ye;(function(De){function Oe(Z){if(typeof Z.label!="string"&&!Array.isArray(Z.label))throw new TypeError("Invalid label");return{label:Z.label,documentation:me.fromStrict(Z.documentation)}}De.from=Oe;function fe(Z){return{label:Z.label,documentation:C.$6k(Z.documentation)?me.to(Z.documentation):Z.documentation}}De.to=fe})(Ye||(e.ParameterInformation=Ye={}));var it;(function(De){function Oe(Z){return{label:Z.label,documentation:me.fromStrict(Z.documentation),parameters:Array.isArray(Z.parameters)?Z.parameters.map(Ye.from):[],activeParameter:Z.activeParameter}}De.from=Oe;function fe(Z){return{label:Z.label,documentation:C.$6k(Z.documentation)?me.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(Ye.to):[],activeParameter:Z.activeParameter}}De.to=fe})(it||(e.SignatureInformation=it={}));var lt;(function(De){function Oe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(it.from):[]}}De.from=Oe;function fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(it.to):[]}}De.to=fe})(lt||(e.SignatureHelp=lt={}));var rt;(function(De){function Oe(fe,Z){const Pe=new P.$jO(de.to(Z.position),typeof Z.label=="string"?Z.label:Z.label.map(nt.to.bind(void 0,fe)),Z.kind&&tt.to(Z.kind));return Pe.textEdits=Z.textEdits&&Z.textEdits.map(he.to),Pe.tooltip=C.$6k(Z.tooltip)?me.to(Z.tooltip):Z.tooltip,Pe.paddingLeft=Z.paddingLeft,Pe.paddingRight=Z.paddingRight,Pe}De.to=Oe})(rt||(e.InlayHint=rt={}));var nt;(function(De){function Oe(fe,Z){const Pe=new P.$iO(Z.label);return Pe.tooltip=C.$6k(Z.tooltip)?me.to(Z.tooltip):Z.tooltip,b.Command.is(Z.command)&&(Pe.command=fe.fromInternal(Z.command)),Z.location&&(Pe.location=Le.to(Z.location)),Pe}De.to=Oe})(nt||(e.InlayHintLabelPart=nt={}));var tt;(function(De){function Oe(Z){return Z}De.from=Oe;function fe(Z){return Z}De.to=fe})(tt||(e.InlayHintKind=tt={}));var et;(function(De){function Oe(Z){return{range:K.from(Z.range),url:Z.target,tooltip:Z.tooltip}}De.from=Oe;function fe(Z){let Pe;if(Z.url)try{Pe=typeof Z.url=="string"?d.URI.parse(Z.url,!0):d.URI.revive(Z.url)}catch{}const Me=new P.$pO(K.to(Z.range),Pe);return Me.tooltip=Z.tooltip,Me}De.to=fe})(et||(e.DocumentLink=et={}));var Xe;(function(De){function Oe(Z){const Pe=new P.$sO(Z.label);return Z.textEdit&&(Pe.textEdit=he.to(Z.textEdit)),Z.additionalTextEdits&&(Pe.additionalTextEdits=Z.additionalTextEdits.map(Me=>he.to(Me))),Pe}De.to=Oe;function fe(Z){return{label:Z.label,textEdit:Z.textEdit?he.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Pe=>he.from(Pe)):void 0}}De.from=fe})(Xe||(e.ColorPresentation=Xe={}));var $e;(function(De){function Oe(Z){return new P.$qO(Z[0],Z[1],Z[2],Z[3])}De.to=Oe;function fe(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}De.from=fe})($e||(e.Color=$e={}));var Ne;(function(De){function Oe(Z){return{range:K.from(Z.range)}}De.from=Oe;function fe(Z){return new P.$_N(K.to(Z.range))}De.to=fe})(Ne||(e.SelectionRange=Ne={}));var Fe;(function(De){function Oe(fe){switch(fe){case r.SaveReason.AUTO:return P.TextDocumentSaveReason.AfterDelay;case r.SaveReason.EXPLICIT:return P.TextDocumentSaveReason.Manual;case r.SaveReason.FOCUS_CHANGE:case r.SaveReason.WINDOW_CHANGE:return P.TextDocumentSaveReason.FocusOut}}De.to=Oe})(Fe||(e.TextDocumentSaveReason=Fe={}));var ke;(function(De){function Oe(Z){switch(Z){case P.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case P.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case P.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case P.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}De.from=Oe;function fe(Z){switch(Z){case f.RenderLineNumbersType.Off:return P.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return P.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return P.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return P.TextEditorLineNumbersStyle.On}}De.to=fe})(ke||(e.TextEditorLineNumbersStyle=ke={}));var Ce;(function(De){function Oe(Z){if(Z===P.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(Z===P.EndOfLine.LF)return i.EndOfLineSequence.LF}De.from=Oe;function fe(Z){if(Z===i.EndOfLineSequence.CRLF)return P.EndOfLine.CRLF;if(Z===i.EndOfLineSequence.LF)return P.EndOfLine.LF}De.to=fe})(Ce||(e.EndOfLine=Ce={}));var te;(function(De){function Oe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case P.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case P.ProgressLocation.Window:return n.ProgressLocation.Window;case P.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Oe})(te||(e.ProgressLocation=te={}));var ee;(function(De){function Oe(Z){const Pe={start:Z.start+1,end:Z.end+1};return Z.kind&&(Pe.kind=Se.from(Z.kind)),Pe}De.from=Oe;function fe(Z){const Pe={start:Z.start-1,end:Z.end-1};return Z.kind&&(Pe.kind=Se.to(Z.kind)),Pe}De.to=fe})(ee||(e.FoldingRange=ee={}));var Se;(function(De){function Oe(Z){if(Z)switch(Z){case P.FoldingRangeKind.Comment:return b.$Pu.Comment;case P.FoldingRangeKind.Imports:return b.$Pu.Imports;case P.FoldingRangeKind.Region:return b.$Pu.Region}}De.from=Oe;function fe(Z){if(Z)switch(Z.value){case b.$Pu.Comment.value:return P.FoldingRangeKind.Comment;case b.$Pu.Imports.value:return P.FoldingRangeKind.Imports;case b.$Pu.Region.value:return P.FoldingRangeKind.Region}}De.to=fe})(Se||(e.FoldingRangeKind=Se={}));var We;(function(De){function Oe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?K.from(fe.selection):void 0,override:typeof fe.override=="boolean"?r.$5F.id:void 0}}De.from=Oe})(We||(e.TextEditorOpenOptions=We={}));var Ke;(function(De){function Oe(Me){return Me instanceof P.$NO?Me.toJSON():typeof Me=="string"?Me:fe(Me)||Z(Me)?new P.$NO(Me.baseUri??Me.base,Me.pattern).toJSON():Me}De.from=Oe;function fe(Me){const Qe=Me;return Qe?d.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function Z(Me){const Qe=Me;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Pe(Me){return typeof Me=="string"?Me:new P.$NO(d.URI.revive(Me.baseUri),Me.pattern)}De.to=Pe})(Ke||(e.GlobPattern=Ke={}));var _e;(function(De){function Oe(fe){if(fe){if(Array.isArray(fe))return fe.map(Oe);if(typeof fe=="string")return fe;{const Z=fe;return{language:Z.language,scheme:Z.scheme,pattern:Ke.from(Z.pattern),exclusive:Z.exclusive,notebookType:Z.notebookType}}}else return}De.from=Oe})(_e||(e.LanguageSelector=_e={}));var st;(function(De){function Oe(Z){return!!Z&&typeof Z=="object"&&"documents"in Z&&Array.isArray(Z.documents)&&Z.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Me=>Me&&typeof Me=="object"&&"uri"in Me&&d.URI.isUri(Me.uri)&&"version"in Me&&typeof Me.version=="number"&&"ranges"in Me&&Array.isArray(Me.ranges)&&Me.ranges.every(Qe=>Qe instanceof P.$ON)))}De.is=Oe;function fe(Z){return{documents:Z.documents.map(Pe=>Pe.map(Me=>({uri:d.URI.from(Me.uri),version:Me.version,ranges:Me.ranges.map(Qe=>K.from(Qe))})))}}De.from=fe})(st||(e.MappedEditsContext=st={}));var ut;(function(De){function Oe(Z){return{start:Z.start,end:Z.end}}De.from=Oe;function fe(Z){return new P.$eP(Z.start,Z.end)}De.to=fe})(ut||(e.NotebookRange=ut={}));var gt;(function(De){function Oe(Z){return{timing:typeof Z.runStartTime=="number"&&typeof Z.runEndTime=="number"?{startTime:Z.runStartTime,endTime:Z.runEndTime}:void 0,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}De.to=Oe;function fe(Z){return{lastRunSuccess:Z.success,runStartTime:Z.timing?.startTime,runEndTime:Z.timing?.endTime,executionOrder:Z.executionOrder}}De.from=fe})(gt||(e.NotebookCellExecutionSummary=gt={}));var wt;(function(De){function Oe(fe){if(fe===I.NotebookCellExecutionState.Unconfirmed)return P.NotebookCellExecutionState.Pending;if(fe===I.NotebookCellExecutionState.Pending)return;if(fe===I.NotebookCellExecutionState.Executing)return P.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}De.to=Oe})(wt||(e.NotebookCellExecutionState=wt={}));var Pt;(function(De){function Oe(Z){switch(Z){case P.NotebookCellKind.Markup:return I.CellKind.Markup;case P.NotebookCellKind.Code:default:return I.CellKind.Code}}De.from=Oe;function fe(Z){switch(Z){case I.CellKind.Markup:return P.NotebookCellKind.Markup;case I.CellKind.Code:default:return P.NotebookCellKind.Code}}De.to=fe})(Pt||(e.NotebookCellKind=Pt={}));var Mt;(function(De){function Oe(Z){const Pe={metadata:Z.metadata??Object.create(null),cells:[]};for(const Me of Z.cells)P.$fP.validate(Me),Pe.cells.push(ft.from(Me));return Pe}De.from=Oe;function fe(Z){const Pe=new P.$gP(Z.cells.map(ft.to));return(0,u.$rg)(Z.metadata)||(Pe.metadata=Z.metadata),Pe}De.to=fe})(Mt||(e.NotebookData=Mt={}));var ft;(function(De){function Oe(Z){return{cellKind:Pt.from(Z.kind),language:Z.languageId,mime:Z.mime,source:Z.value,metadata:Z.metadata,internalMetadata:gt.from(Z.executionSummary??{}),outputs:Z.outputs?Z.outputs.map(Et.from):[]}}De.from=Oe;function fe(Z){return new P.$fP(Pt.to(Z.cellKind),Z.source,Z.language,Z.mime,Z.outputs?Z.outputs.map(Et.to):void 0,Z.metadata,Z.internalMetadata?gt.to(Z.internalMetadata):void 0)}De.to=fe})(ft||(e.NotebookCellData=ft={}));var vt;(function(De){function Oe(Z){return{mime:Z.mime,valueBytes:s.$Ne.wrap(Z.data)}}De.from=Oe;function fe(Z){return new P.$hP(Z.valueBytes.buffer,Z.mime)}De.to=fe})(vt||(e.NotebookCellOutputItem=vt={}));var Et;(function(De){function Oe(Z){return{outputId:Z.id,items:Z.items.map(vt.from),metadata:Z.metadata}}De.from=Oe;function fe(Z){const Pe=Z.items.map(vt.to);return new P.$iP(Pe,Z.outputId,Z.metadata)}De.to=fe})(Et||(e.NotebookCellOutput=Et={}));var St;(function(De){function Oe(Pe){return Z(Pe)?{include:Ke.from(Pe.include)??void 0,exclude:Ke.from(Pe.exclude)??void 0}:Ke.from(Pe)??void 0}De.from=Oe;function fe(Pe){return Z(Pe)?{include:Ke.to(Pe.include),exclude:Ke.to(Pe.exclude)}:Ke.to(Pe)}De.to=fe;function Z(Pe){const Me=Pe;return Me?!(0,u.$ng)(Me.include)&&!(0,u.$ng)(Me.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var Vt;(function(De){function Oe(fe,Z,Pe){const Me=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===P.NotebookCellStatusBarAlignment.Left?I.CellStatusbarAlignment.Left:I.CellStatusbarAlignment.Right,command:Z.toInternal(Me,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}De.from=Oe})(Vt||(e.NotebookStatusBarItem=Vt={}));var Rt;(function(De){function Oe(fe,Z,Pe){const Me=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:Z.toInternal(Me,Pe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}De.from=Oe})(Rt||(e.NotebookKernelSourceAction=Rt={}));var ht;(function(De){function Oe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}De.from=Oe})(ht||(e.NotebookDocumentContentOptions=ht={}));var $t;(function(De){function Oe(Z){return{uri:Z.uri,provides:Z.provides}}De.from=Oe;function fe(Z){return new P.$kP(d.URI.revive(Z.uri),Z.provides)}De.to=fe})($t||(e.NotebookRendererScript=$t={}));var bt;(function(De){function Oe(Z){return{message:me.fromStrict(Z.message)||"",type:L.TestMessageType.Error,expected:Z.expectedOutput,actual:Z.actualOutput,contextValue:Z.contextValue,location:Z.location&&{range:K.from(Z.location.range),uri:Z.location.uri},stackTrace:Z.stackTrace?.map(Pe=>({label:Pe.label,position:Pe.position&&de.from(Pe.position),uri:Pe.file&&d.URI.revive(Pe.file).toJSON()}))}}De.from=Oe;function fe(Z){const Pe=new P.$qP(typeof Z.message=="string"?Z.message:me.to(Z.message));return Pe.actualOutput=Z.actual,Pe.expectedOutput=Z.expected,Pe.contextValue=Z.contextValue,Pe.location=Z.location?Le.to(Z.location):void 0,Pe}De.to=fe})(bt||(e.TestMessage=bt={}));var Dt;(function(De){De.namespace=L.$_I,De.denamespace=L.$aJ})(Dt||(e.TestTag=Dt={}));var zt;(function(De){function Oe(Z){const Pe=(0,l.$gQ)(Z).controllerId;return{extId:R.$7I.fromExtHostTestItem(Z,Pe).toString(),label:Z.label,uri:d.URI.revive(Z.uri),busy:Z.busy,tags:Z.tags.map(Me=>Dt.namespace(Pe,Me.id)),range:v.$Ot.lift(K.from(Z.range)),description:Z.description||null,sortText:Z.sortText||null,error:Z.error&&me.fromStrict(Z.error)||null}}De.from=Oe;function fe(Z){return{parent:void 0,error:void 0,id:R.$7I.fromString(Z.extId).localId,label:Z.label,uri:d.URI.revive(Z.uri),tags:(Z.tags||[]).map(Pe=>{const{tagId:Me}=Dt.denamespace(Pe);return new P.$rP(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:K.to(Z.range||void 0),canResolveChildren:!1,busy:Z.busy,description:Z.description||void 0,sortText:Z.sortText||void 0}}De.toPlain=fe})(zt||(e.TestItem=zt={})),function(De){function Oe(Z){return{id:Z.id}}De.from=Oe;function fe(Z){return new P.$rP(Z.id)}De.to=fe}(Dt||(e.TestTag=Dt={}));var Ot;(function(De){const Oe=(Z,Pe)=>{const Me=Z.value;if(!Me)return;const Qe={...zt.toPlain(Me.item),parent:Pe,taskStates:Me.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ot=>ot.type===L.TestMessageType.Error).map(bt.to)})),children:[]};if(Z.children)for(const He of Z.children.values()){const ot=Oe(He,Qe);ot&&Qe.children.push(ot)}return Qe};function fe(Z){const Pe=new m.$6I;for(const He of Z.items)Pe.insert(R.$7I.fromString(He.item.extId).path,He);const Me=[Pe.nodes],Qe=[];for(;Me.length;)for(const He of Me.pop())He.value?Qe.push(He):He.children&&Me.push(He.children.values());return{completedAt:Z.completedAt,results:Qe.map(He=>Oe(He)).filter(u.$mg)}}De.to=fe})(Ot||(e.TestResults=Ot={}));var en;(function(De){function Oe(Me){return{covered:Me.covered,total:Me.total}}function fe(Me){return"line"in Me?de.from(Me):K.from(Me)}function Z(Me){if(typeof Me.executed=="number"&&Me.executed<0)throw new Error(`Invalid coverage count ${Me.executed}`);return"branches"in Me?{count:Me.executed,location:fe(Me.location),type:L.DetailType.Statement,branches:Me.branches.length?Me.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&fe(Qe.location),label:Qe.label})):void 0}:{type:L.DetailType.Declaration,name:Me.name,count:Me.executed,location:fe(Me.location)}}De.fromDetails=Z;function Pe(Me,Qe,He){return P.$uP(He.statementCoverage),P.$uP(He.branchCoverage),P.$uP(He.declarationCoverage),{id:Qe,uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),declaration:He.declarationCoverage&&Oe(He.declarationCoverage),testIds:He instanceof P.$vP&&He.fromTests.length?He.fromTests.map(ot=>R.$7I.fromExtHostTestItem(ot,Me).toString()):void 0}}De.fromFile=Pe})(en||(e.TestCoverage=en={}));var kt;(function(De){function Oe(fe){switch(fe){case b.CodeActionTriggerType.Invoke:return P.CodeActionTriggerKind.Invoke;case b.CodeActionTriggerType.Auto:return P.CodeActionTriggerKind.Automatic}}De.to=Oe})(kt||(e.CodeActionTriggerKind=kt={}));var Bt;(function(De){function Oe(Z){const Pe=new P.$zP(U.to(Z.kind),Z.name,Z.detail||"",d.URI.revive(Z.uri),K.to(Z.range),K.to(Z.selectionRange));return Pe._sessionId=Z._sessionId,Pe._itemId=Z._itemId,Pe}De.to=Oe;function fe(Z,Pe,Me){if(Pe=Pe??Z._sessionId,Me=Me??Z._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,kind:U.from(Z.kind),name:Z.name,detail:Z.detail??"",uri:Z.uri,range:K.from(Z.range),selectionRange:K.from(Z.selectionRange),tags:Z.tags?.map(H.from)}}De.from=fe})(Bt||(e.TypeHierarchyItem=Bt={}));var Gt;(function(De){function Oe(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}De.from=Oe})(Gt||(e.ViewBadge=Gt={}));var Tt;(function(De){function Oe(Me,Qe,He){const ot=Qe.fileData;return ot?new P.$FO(new P.$GO(ot.name,d.URI.revive(ot.uri),ot.id,(0,k.$cb)(()=>He(ot.id)))):Me===D.$$s.uriList&&Qe.uriListData?new P.$EO(Pe(Qe.uriListData)):new P.$EO(Qe.asString)}De.to=Oe;async function fe(Me,Qe){const He=await Qe.asString();if(Me===D.$$s.uriList)return{asString:He,fileData:void 0,uriListData:Z(He)};const ot=Qe.asFile();return{asString:He,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}De.from=fe;function Z(Me){return E.$tu.split(Me).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return d.URI.parse(Qe)}catch{}return Qe})}function Pe(Me){return E.$tu.create(Me.map(Qe=>typeof Qe=="string"?Qe:d.URI.revive(Qe)))}})(Tt||(e.DataTransferItem=Tt={}));var Lt;(function(De){function Oe(Z,Pe){const Me=Z.items.map(([Qe,He])=>[Qe,Tt.to(Qe,He,Pe)]);return new P.$HO(Me)}De.toDataTransfer=Oe;async function fe(Z){const Pe={items:[]},Me=[];for(const[Qe,He]of Z)Me.push((async()=>{Pe.items.push([Qe,await Tt.from(Qe,He)])})());return await Promise.all(Me),Pe}De.from=fe})(Lt||(e.DataTransfer=Lt={}));var At;(function(De){function Oe(Z,Pe){return{kind:"reply",agentId:Z.participant??Pe?.agentId??"",subCommand:Z.command??Pe?.command,message:Z.prompt,title:Z.label}}De.from=Oe;function fe(Z){return{prompt:Z.message,label:Z.title,participant:Z.agentId,command:Z.subCommand}}De.to=fe})(At||(e.ChatFollowup=At={}));var Ct;(function(De){function Oe(Z){switch(Z){case c.ChatMessageRole.System:return P.LanguageModelChatMessageRole.System;case c.ChatMessageRole.User:return P.LanguageModelChatMessageRole.User;case c.ChatMessageRole.Assistant:return P.LanguageModelChatMessageRole.Assistant}}De.to=Oe;function fe(Z){switch(Z){case P.LanguageModelChatMessageRole.System:return c.ChatMessageRole.System;case P.LanguageModelChatMessageRole.User:return c.ChatMessageRole.User;case P.LanguageModelChatMessageRole.Assistant:return c.ChatMessageRole.Assistant}return c.ChatMessageRole.User}De.from=fe})(Ct||(e.LanguageModelChatMessageRole=Ct={}));var Zt;(function(De){function Oe(Z){let Pe="",Me;Z.content.type==="text"?Pe=Z.content.value:Me=new P.$4P(Z.content.name,Z.content.value,Z.content.isError);const Qe=Ct.to(Z.role),He=new P.$5P(Qe,Pe,Z.name);return Me!==void 0&&(He.content2=Me),He}De.to=Oe;function fe(Z){const Pe=Ct.from(Z.role),Me=Z.name;let Qe;return Z.content2 instanceof P.$4P?Qe={type:"function_result",name:Z.content2.name,value:Z.content2.content,isError:Z.content2.isError}:Qe={type:"text",value:Z.content},{role:Pe,name:Me,content:Qe}}De.from=fe})(Zt||(e.LanguageModelChatMessage=Zt={}));var Kt;(function(De){function Oe(Z){return{kind:"markdownContent",content:me.from(Z.value)}}De.from=Oe;function fe(Z){return new P.$MP(me.to(Z.content))}De.to=fe})(Kt||(e.ChatResponseMarkdownPart=Kt={}));var Ut;(function(De){function Oe(Z){return{kind:"markdownVuln",content:me.from(Z.value),vulnerabilities:Z.vulnerabilities}}De.from=Oe;function fe(Z){return new P.$NP(me.to(Z.content),Z.vulnerabilities)}De.to=fe})(Ut||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ut={}));var xt;(function(De){function Oe(Z){return{kind:"agentDetection",agentId:Z.participant,command:Z.command}}De.from=Oe;function fe(Z){return new P.$OP(Z.agentId,Z.command)}De.to=fe})(xt||(e.ChatResponseDetectedParticipantPart=xt={}));var Jt;(function(De){function Oe(fe){return{kind:"confirmation",title:fe.title,message:fe.message,data:fe.data,buttons:fe.buttons}}De.from=Oe})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var Xt;(function(De){function Oe(Z){const{value:Pe,baseUri:Me}=Z;function Qe(He,ot){return He.map(mt=>{const jt=d.URI.joinPath(ot,mt.name);return{label:mt.name,uri:jt,children:mt.children&&Qe(mt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,$.$dh)(Me),uri:Me,children:Qe(Pe,Me)}}}De.from=Oe;function fe(Z){const Pe=(0,o.$ci)(Z.treeData);function Me(ot){return ot.map(mt=>({name:mt.label,children:mt.children&&Me(mt.children)}))}const Qe=Pe.uri,He=Pe.children?Me(Pe.children):[];return new P.$QP(He,Qe)}De.to=fe})(Xt||(e.ChatResponseFilesPart=Xt={}));var Nt;(function(De){function Oe(Z){const Pe=Me=>d.URI.isUri(Me);return{kind:"inlineReference",name:Z.title,inlineReference:Pe(Z.value)?Z.value:J.from(Z.value)}}De.from=Oe;function fe(Z){const Pe=(0,o.$ci)(Z);return new P.$RP(d.URI.isUri(Pe.inlineReference)?Pe.inlineReference:J.to(Pe.inlineReference),Z.name)}De.to=fe})(Nt||(e.ChatResponseAnchorPart=Nt={}));var Ht;(function(De){function Oe(Z){return{kind:"progressMessage",content:me.from(Z.value)}}De.from=Oe;function fe(Z){return new P.$SP(Z.content.value)}De.to=fe})(Ht||(e.ChatResponseProgressPart=Ht={}));var pt;(function(De){function Oe(Z){return{kind:"warning",content:me.from(Z.value)}}De.from=Oe;function fe(Z){return new P.$UP(Z.content.value)}De.to=fe})(pt||(e.ChatResponseWarningPart=pt={}));var qt;(function(De){function Oe(fe){return{kind:"progressTask",content:me.from(fe.value)}}De.from=Oe})(qt||(e.ChatTask=qt={}));var Ft;(function(De){function Oe(fe){return{kind:"progressTaskResult",content:typeof fe=="string"?me.from(fe):void 0}}De.from=Oe})(Ft||(e.ChatTaskResult=Ft={}));var rn;(function(De){function Oe(Z,Pe,Me){return{kind:"command",command:Pe.toInternal(Z.value,Me)??{command:Z.value.command,title:Z.value.title}}}De.from=Oe;function fe(Z,Pe){return new P.$VP(Pe.fromInternal(Z.command)??{command:Z.command.id,title:Z.command.title})}De.to=fe})(rn||(e.ChatResponseCommandButtonPart=rn={}));var hn;(function(De){function Oe(Z){return{kind:"textEdit",uri:Z.uri,edits:Z.edits.map(Pe=>he.from(Pe))}}De.from=Oe;function fe(Z){return new P.$YP(d.URI.revive(Z.uri),Z.edits.map(Pe=>he.to(Pe)))}De.to=fe})(hn||(e.ChatResponseTextEditPart=hn={}));var mn;(function(De){function Oe(Z){const Pe=a.ThemeIcon.isThemeIcon(Z.iconPath)?Z.iconPath:d.URI.isUri(Z.iconPath)?{light:d.URI.revive(Z.iconPath)}:Z.iconPath&&"light"in Z.iconPath&&"dark"in Z.iconPath&&d.URI.isUri(Z.iconPath.light)&&d.URI.isUri(Z.iconPath.dark)?{light:d.URI.revive(Z.iconPath.light),dark:d.URI.revive(Z.iconPath.dark)}:void 0;return"variableName"in Z.value?{kind:"reference",reference:{variableName:Z.value.variableName,value:d.URI.isUri(Z.value.value)||!Z.value.value?Z.value.value:J.from(Z.value.value)},iconPath:Pe,options:Z.options}:{kind:"reference",reference:d.URI.isUri(Z.value)?Z.value:J.from(Z.value),iconPath:Pe,options:Z.options}}De.from=Oe;function fe(Z){const Pe=(0,o.$ci)(Z),Me=Qe=>d.URI.isUri(Qe)?Qe:J.to(Qe);return new P.$WP("variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&Me(Pe.reference.value)}:Me(Pe.reference))}De.to=fe})(mn||(e.ChatResponseReferencePart=mn={}));var fn;(function(De){function Oe(fe){return{kind:"codeCitation",value:fe.value,license:fe.license,snippet:fe.snippet}}De.from=Oe})(fn||(e.ChatResponseCodeCitationPart=fn={}));var gn;(function(De){function Oe(Pe,Me,Qe){return Pe instanceof P.$MP?Kt.from(Pe):Pe instanceof P.$RP?Nt.from(Pe):Pe instanceof P.$WP?mn.from(Pe):Pe instanceof P.$SP?Ht.from(Pe):Pe instanceof P.$QP?Xt.from(Pe):Pe instanceof P.$VP?rn.from(Pe,Me,Qe):Pe instanceof P.$YP?hn.from(Pe):Pe instanceof P.$NP?Ut.from(Pe):Pe instanceof P.$OP?xt.from(Pe):Pe instanceof P.$UP?pt.from(Pe):Pe instanceof P.$PP?Jt.from(Pe):Pe instanceof P.$XP?fn.from(Pe):{kind:"markdownContent",content:me.from("")}}De.from=Oe;function fe(Pe,Me){switch(Pe.kind){case"reference":return mn.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Z(Pe,Me)}}De.to=fe;function Z(Pe,Me){switch(Pe.kind){case"markdownContent":return Kt.to(Pe);case"inlineReference":return Nt.to(Pe);case"progressMessage":return;case"treeData":return Xt.to(Pe);case"command":return rn.to(Pe,Me)}}De.toContent=Z})(gn||(e.ChatResponsePart=gn={}));var bn;(function(De){function Oe(fe,Z){const Pe=fe.variables.variables.filter(Qe=>Qe.isTool).map(Qe=>Qe.id),Me=fe.variables.variables.filter(Qe=>!Qe.isTool);return{prompt:fe.message,command:fe.command,attempt:fe.attempt??0,enableCommandDetection:fe.enableCommandDetection??!0,references:Me.map(wn.to),location:tn.to(fe.location),acceptedConfirmationData:fe.acceptedConfirmationData,rejectedConfirmationData:fe.rejectedConfirmationData,location2:Z,requestedTools:Pe}}De.to=Oe})(bn||(e.ChatAgentRequest=bn={}));var tn;(function(De){function Oe(Z){switch(Z){case h.ChatAgentLocation.Notebook:return P.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return P.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return P.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return P.ChatLocation.Editor}}De.to=Oe;function fe(Z){switch(Z){case P.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case P.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case P.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case P.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}De.from=fe})(tn||(e.ChatLocation=tn={}));var wn;(function(De){function Oe(fe){const Z=fe.value;if(!Z)throw new Error("Invalid value reference");return{id:fe.id,name:fe.name,range:fe.range&&[fe.range.start,fe.range.endExclusive],value:(0,d.$vc)(Z)?d.URI.revive(Z):Z&&typeof Z=="object"&&"uri"in Z&&"range"in Z&&(0,d.$vc)(Z.uri)?J.to((0,o.$ci)(Z)):Z,modelDescription:fe.modelDescription}}De.to=Oe})(wn||(e.ChatAgentValueReference=wn={}));var Yt;(function(De){function Oe(fe,Z,Pe){return{id:fe.id,label:fe.label,fullName:fe.fullName,icon:fe.icon?.id,value:fe.values[0].value,insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation,command:Z.toInternal(fe.command,Pe)}}De.from=Oe})(Yt||(e.ChatAgentCompletionItem=Yt={}));var dn;(function(De){function Oe(fe){return{errorDetails:fe.errorDetails,metadata:fe.metadata}}De.to=Oe})(dn||(e.ChatAgentResult=dn={}));var vn;(function(De){function Oe(fe,Z,Pe){if(Z.action.kind==="vote")return;const Me=dn.to(fe);if(Z.action.kind==="command"){const Qe=Z.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:Me}}else return Z.action.kind==="followUp"?{action:{kind:"followUp",followup:At.to(Z.action.followup)},result:Me}:Z.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Z.action.action==="accepted"},result:Me}:{action:Z.action,result:Me}}De.to=Oe})(vn||(e.ChatAgentUserActionEvent=vn={}));var pn;(function(De){function Oe(fe,Z,Pe){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:Z.toInternal(fe,Pe)}De.from=Oe})(pn||(e.TerminalQuickFix=pn={}));var yn;(function(De){function Oe(fe){return{kind:En.to(fe.kind)}}De.to=Oe})(yn||(e.PartialAcceptInfo=yn={}));var En;(function(De){function Oe(fe){switch(fe){case b.PartialAcceptTriggerKind.Word:return P.PartialAcceptTriggerKind.Word;case b.PartialAcceptTriggerKind.Line:return P.PartialAcceptTriggerKind.Line;case b.PartialAcceptTriggerKind.Suggest:return P.PartialAcceptTriggerKind.Suggest;default:return P.PartialAcceptTriggerKind.Unknown}}De.to=Oe})(En||(e.PartialAcceptTriggerKind=En={}));var an;(function(De){function Oe(fe,Z){return{id:Z,label:fe.label,description:fe.description,canEdit:fe.canEdit,collapsibleState:fe.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:fe.contextValue}}De.from=Oe})(an||(e.DebugTreeItem=an={}));var $n;(function(De){function Oe(fe){return{name:fe.name,description:fe.description,parametersSchema:fe.parametersSchema}}De.to=Oe})($n||(e.LanguageModelToolDescription=$n={}))}),define(Re[274],Ae([1,0,50,147,75,146,102,153,4]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.$yQ=e.$xQ=e.$wQ=void 0,t=Ue(t),A=Ue(A);const o=(g,b,i,p)=>{let n=b;return{enumerable:!0,configurable:!1,get(){return n},set(l){if(!i(n,l)){const r=n;n=l,g.listener?.(p(l,r))}}}},D=(g,b)=>g===b,w={range:(g,b)=>g===b?!0:!g||!b?!1:g.isEqual(b),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(g,b)=>!(g.length!==b.length||g.some(i=>!b.find(p=>i.id===p.id)))},m=g=>b=>({op:k.TestItemEventOp.SetProp,update:g(b)}),$=(g,b)=>({range:(()=>{let i;const p=m(n=>({range:t.$Ot.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return i},set(n){g.listener?.({op:k.TestItemEventOp.DocumentSynced}),w.range(i,n)||(i=n,g.listener?.(p(n)))}}})(),label:o(g,b,w.label,m(i=>({label:i}))),description:o(g,void 0,w.description,m(i=>({description:i}))),sortText:o(g,void 0,w.sortText,m(i=>({sortText:i}))),canResolveChildren:o(g,!1,w.canResolveChildren,i=>({op:k.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:o(g,!1,w.busy,m(i=>({busy:i}))),error:o(g,void 0,w.error,m(i=>({error:A.MarkdownString.fromStrict(i)||null}))),tags:o(g,[],w.tags,(i,p)=>({op:k.TestItemEventOp.SetTags,new:i.map(A.TestTag.from),old:p.map(A.TestTag.from)}))}),a=g=>{const b=E.$7I.fromString(g.extId),i=new d(b.controllerId,b.localId,g.label,y.URI.revive(g.uri)||void 0);return i.range=A.Range.to(g.range||void 0),i.description=g.description||void 0,i.sortText=g.sortText||void 0,i.tags=g.tags.map(p=>A.TestTag.to({id:(0,C.$aJ)(p).tagId})),i},u=g=>{let b;for(const i of g.tests){const p=a(i.item);(0,s.$gQ)(p).parent=b,b=p}return b};e.$wQ=u;class d{constructor(b,i,p,n){if(i.includes(E.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const l=(0,s.$fQ)(this,b);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof f?void 0:l.parent}},children:{value:(0,k.$eQ)(l,s.$gQ,d),enumerable:!0,writable:!1},...$(l,p)})}}e.$xQ=d;class f extends d{constructor(b,i){super(b,b,i,void 0),this._isRoot=!0}}e.$yQ=f;class v extends k.$aQ{constructor(b,i,p){super({controllerId:b,getDocumentVersion:n=>n&&p.getDocument(n)?.version,getApiFor:s.$gQ,getChildren:n=>n.children,root:new f(b,i),toITestItem:A.TestItem.from})}}e.$zQ=v}),define(Re[275],Ae([1,0,10,152,153,20,272,17,11,48,50,85,4,2,5,252,274,14,150,44,47,40,266,22]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=void 0,s=Ue(s),E=Ue(E);let l=class{#e;#t;#n;constructor(R,L,O){this.b=new Map,this.c=new Map,this.#e=R.getProxy(C.$KN.MainThreadCommands),this.d=L,this.#n=O,this.#t=R.getProxy(C.$KN.MainThreadTelemetry),this.converter=new r(this,P=>{const q=this.c.get(P);return q?.result===c.Void?q:void 0},L),this.f=[{processArgument(P){return(0,o.$ci)(P)}},{processArgument(P){return(0,k.$go)(P,function(q){if(D.$Ot.isIRange(q))return E.Range.to(q);if(w.$Nt.isIPosition(q))return E.Position.to(q);if(D.$Ot.isIRange(q.range)&&m.URI.isUri(q.uri))return E.location.to(q);if(q instanceof f.$Ne)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(R){this.f.push(R)}registerApiCommand(R){const L=this.registerCommand(!1,R.id,async(...O)=>{const P=R.args.map((K,J)=>{if(!K.validate(O[J]))throw new Error(`Invalid argument '${K.name}' when running '${R.id}', received: ${typeof O[J]=="object"?JSON.stringify(O[J],null,"	"):O[J]} `);return K.convert(O[J])}),q=await this.executeCommand(R.internalId,...P);return R.result.convert(q,O,this.converter)},void 0,{description:R.description,args:R.args,returns:R.result.description});return this.c.set(R.id,R),new s.$MN(()=>{L.dispose(),this.c.delete(R.id)})}registerCommand(R,L,O,P,q,K){if(this.d.trace("ExtHostCommands#registerCommand",L),!L.trim().length)throw new Error("invalid id");if(this.b.has(L))throw new Error(`command '${L}' already exists`);return this.b.set(L,{callback:O,thisArg:P,metadata:q,extension:K}),R&&this.#e.$registerCommand(L),new s.$MN(()=>{this.b.delete(L)&&R&&this.#e.$unregisterCommand(L)})}executeCommand(R,...L){return this.d.trace("ExtHostCommands#executeCommand",R),this.g(R,L,!0)}async g(R,L,O){if(this.b.has(R))return this.#e.$fireCommandActivationEvent(R),this.h(R,L,!1);{let P=!1;const q=(0,k.$go)(L,function(K){if(K instanceof s.$NN)return E.Position.from(K);if(K instanceof s.$ON)return E.Range.from(K);if(K instanceof s.$1N)return E.location.from(K);if(s.$eP.isNotebookRange(K))return E.NotebookRange.from(K);if(K instanceof ArrayBuffer)return P=!0,f.$Ne.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return P=!0,f.$Ne.wrap(K);if(K instanceof f.$Ne)return P=!0,K;if(!Array.isArray(K))return K});try{const K=await this.#e.$executeCommand(R,P?new v.$Xw(q):q,O);return(0,o.$ci)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(R,L,!1);throw K}}}async h(R,L,O){const P=this.b.get(R);if(!P)throw new Error("Unknown command");const{callback:q,thisArg:K,metadata:J}=P;if(J?.args)for(let de=0;de<J.args.length;de++)try{(0,t.$vg)(L[de],J.args[de].constraint)}catch{throw new Error(`Running the contributed command: '${R}' failed. Illegal argument '${J.args[de].name}' - ${J.args[de].description}`)}const _=b.$fe.create();try{return await q.apply(K,L)}catch(de){if(R===this.converter.delegatingCommandId){const ge=this.converter.getActualCommand(...L);ge&&(R=ge.command)}if(this.d.error(de,R,P.extension?.identifier),!O)throw de;if(P.extension?.identifier){const ge=this.#n.onExtensionError(P.extension.identifier,de);this.d.trace("forwarded error to extension?",ge,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$qj)(de)),this.id=R,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,R,_.elapsed())}}j(R,L,O){R.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:R.extension.identifier.value,id:new i.$xp(L),duration:O})}$executeContributedCommand(R,...L){this.d.trace("ExtHostCommands#$executeContributedCommand",R);const O=this.b.get(R);return O?(L=L.map(P=>this.f.reduce((q,K)=>K.processArgument(q,O.extension?.identifier),P)),this.h(R,L,!0)):Promise.reject(new Error(`Contributed command '${R}' does not exist.`))}getCommands(R=!1){return this.d.trace("ExtHostCommands#getCommands",R),this.#e.$getCommands().then(L=>(R&&(L=L.filter(O=>O[0]!=="_")),L))}$getContributedCommandMetadata(){const R=Object.create(null);for(const[L,O]of this.b){const{metadata:P}=O;P&&(R[L]=P)}return Promise.resolve(R)}};e.$FQ=l,e.$FQ=l=Be([je(0,u.$kQ),je(1,y.$ak),je(2,p.$EQ)],l),e.$GQ=(0,a.$Fi)("IExtHostCommands");class r{constructor(R,L,O){this.d=R,this.f=L,this.g=O,this.delegatingCommandId=`__vsc${(0,n.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(R,L){if(!R)return;const O={$ident:void 0,id:R.command,title:R.title,tooltip:R.tooltip};if(!R.command)return O;const P=this.f(R.command);if(P)O.id=P.internalId,O.arguments=P.args.map((q,K)=>q.convert(R.arguments&&R.arguments[K]));else if((0,A.$Kb)(R.arguments)){const q=`${R.command} /${++this.c}`;this.b.set(q,R),L.add((0,$.$Sc)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),O.$ident=q,O.id=this.delegatingCommandId,O.arguments=[q],this.g.trace("CommandsConverter#CREATE",R.command,q)}return O}fromInternal(R){return typeof R.$ident=="string"?this.b.get(R.$ident):{command:R.id,title:R.title,arguments:R.arguments}}getActualCommand(...R){return this.b.get(R[0])}h(...R){const L=this.getActualCommand(...R);return this.g.trace("CommandsConverter#EXECUTE",R[0],L?L.command:"MISSING"),L?this.d.executeCommand(L.command,...L.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${R[0]}`)}}e.$HQ=r;class h{static{this.Uri=new h("uri","Uri of a text document",R=>m.URI.isUri(R),R=>R)}static{this.Position=new h("position","A position in a text document",R=>s.$NN.isPosition(R),E.Position.from)}static{this.Range=new h("range","A range in a text document",R=>s.$ON.isRange(R),E.Range.from)}static{this.Selection=new h("selection","A selection in a text document",R=>s.$PN.isSelection(R),E.Selection.from)}static{this.Number=new h("number","",R=>typeof R=="number",R=>R)}static{this.String=new h("string","",R=>typeof R=="string",R=>R)}static{this.StringArray=h.Arr(h.String)}static Arr(R){return new h(`${R.name}_array`,`Array of ${R.name}, ${R.description}`,L=>Array.isArray(L)&&L.every(O=>R.validate(O)),L=>L.map(O=>R.convert(O)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",R=>R instanceof s.$aO,E.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",R=>R instanceof s.$zP,E.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",R=>R instanceof d.$xQ,E.TestItem.from)}constructor(R,L,O,P){this.name=R,this.description=L,this.validate=O,this.convert=P}optional(){return new h(this.name,`(optional) ${this.description}`,R=>R==null||this.validate(R),R=>R===void 0?void 0:R===null?null:this.convert(R))}with(R,L){return new h(R??this.name,L??this.description,this.validate,this.convert)}}e.$IQ=h;class c{static{this.Void=new c("no result",R=>R)}constructor(R,L){this.description=R,this.convert=L}}e.$JQ=c;class S{constructor(R,L,O,P,q){this.id=R,this.internalId=L,this.description=O,this.args=P,this.result=q}}e.$KQ=S}),define(Re[276],Ae([1,0,9,2,12,3,205]),function(ue,e,t,s,E,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0,e.$uR="remoteFilesystem";class A extends C.$tR{static register(o,D,w){const m=o.getConnection();if(!m)return s.$Uc.None;const $=new s.$Tc,a=(async()=>{try{const u=await o.getRawEnvironment();u?D.registerProvider(E.Schemas.vscodeRemote,$.add(new A(u,m))):w.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(u){w.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,t.$9)(u))}})();return $.add(D.onWillActivateFileSystemProvider(u=>{u.scheme===E.Schemas.vscodeRemote&&u.join(a)})),$}constructor(o,D){super(D.getChannel(e.$uR),{pathCaseSensitive:o.os===k.OperatingSystem.Linux})}}e.$vR=A}),define(Re[76],Ae([1,0,95,84,32,277,14,9,6,2,8,3,22,49,60]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=r,e.$yi=h,e.$Ai=I,e.$Bi=R;const u=3e4;class d{traceSocketEvent(O,P){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,O,P)}constructor(O,P=""){this.f=!0,this.debugLabel=P,this.socket=O,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=K=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:K?.code,message:K?.message}),K){if(K.code==="EPIPE")return;(0,A.$Y)(K)}},this.socket.on("error",this.a);let q;this.b=K=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:K}),this.f=!1,q&&clearTimeout(q)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,q=setTimeout(()=>O.destroy(),u)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(O){const P=q=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,q),O(C.$Ne.wrap(q))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(O){const P=q=>{O({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:q,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(O){const P=()=>{O()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(O){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,O),this.socket.write(O.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,A.$Y)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,A.$Y)(P)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((O,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),O();return}const q=()=>{this.socket.off("close",q),this.socket.off("end",q),this.socket.off("error",q),this.socket.off("timeout",q),this.socket.off("drain",q),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),O()};this.socket.on("close",q),this.socket.on("end",q),this.socket.on("error",q),this.socket.on("timeout",q),this.socket.on("drain",q)})}}e.$ui=d;var f;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var v;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(v||(v={}));class g extends o.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(O,P){this.socket.traceSocketEvent(O,P)}constructor(O,P,q,K){super(),this.f=this.B(new y.$le),this.g=this.B(new y.$le),this.h=!1,this.j={state:v.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=O,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:q?.byteLength||0,recordInflateBytes:K}),this.a=this.B(new b(this,P,q,K,this.f,(J,_)=>this.m(J,_))),this.B(this.a.onError(J=>{console.error(J),(0,A.$Y)(J),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:J})})),this.b=new a.$pi,this.B(this.socket.onData(J=>this.n(J))),this.B(this.socket.onClose(async J=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(J)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(O){return this.f.event(O)}onClose(O){return this.g.event(O)}onEnd(O){return this.socket.onEnd(O)}write(O){let P=0;for(;P<O.byteLength;)this.a.writeMessage(O.slice(P,Math.min(P+f.MaxWebSocketMessageLength,O.byteLength)),{compressed:!0,opcode:2}),P+=f.MaxWebSocketMessageLength}m(O,{compressed:P,opcode:q}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,O);let K=f.MinHeaderByteSize;O.byteLength<126?K+=0:O.byteLength<2**16?K+=2:K+=8;const J=C.$Ne.alloc(K),_=P?64:0,de=q&15;if(J.writeUInt8(128|_|de,0),O.byteLength<126)J.writeUInt8(O.byteLength,1);else if(O.byteLength<2**16){J.writeUInt8(126,1);let ge=1;J.writeUInt8(O.byteLength>>>8&255,++ge),J.writeUInt8(O.byteLength>>>0&255,++ge)}else{J.writeUInt8(127,1);let ge=1;J.writeUInt8(0,++ge),J.writeUInt8(0,++ge),J.writeUInt8(0,++ge),J.writeUInt8(0,++ge),J.writeUInt8(O.byteLength>>>24&255,++ge),J.writeUInt8(O.byteLength>>>16&255,++ge),J.writeUInt8(O.byteLength>>>8&255,++ge),J.writeUInt8(O.byteLength>>>0&255,++ge)}this.socket.write(C.$Ne.concat([J,O]))}end(){this.h=!0,this.socket.end()}n(O){if(O.byteLength!==0){for(this.b.acceptChunk(O);this.b.byteLength>=this.j.readLen;)if(this.j.state===v.PeekHeader){const P=this.b.peek(this.j.readLen),q=P.readUInt8(0),K=(q&128)>>>7,J=(q&64)>>>6,_=q&15,de=P.readUInt8(1),ge=(de&128)>>>7,le=de&127;this.j.state=v.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(ge?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=K,this.j.firstFrameOfMessage&&(this.j.compressed=!!J),this.j.firstFrameOfMessage=!!K,this.j.mask=0,this.j.opcode=_,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===v.ReadHeader){const P=this.b.read(this.j.readLen),q=P.readUInt8(1),K=(q&128)>>>7;let J=q&127,_=1;J===126?J=P.readUInt8(++_)*2**8+P.readUInt8(++_):J===127&&(J=P.readUInt8(++_)*0+P.readUInt8(++_)*0+P.readUInt8(++_)*0+P.readUInt8(++_)*0+P.readUInt8(++_)*2**24+P.readUInt8(++_)*2**16+P.readUInt8(++_)*2**8+P.readUInt8(++_));let de=0;K&&(de=P.readUInt8(++_)*2**24+P.readUInt8(++_)*2**16+P.readUInt8(++_)*2**8+P.readUInt8(++_)),this.j.state=v.ReadBody,this.j.readLen=J,this.j.mask=de,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===v.ReadBody){const P=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,P),n(P,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,P),this.j.state=v.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(P,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(P,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=g;class b extends o.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$Ne.alloc(0)}constructor(O,P,q,K,J,_){super(),this.n=O,this.r=J,this.s=_,this.a=this.B(new y.$le),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$le),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$le),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,P?(this.b=this.B(new i(this.n,K,q,{windowBits:15})),this.f=this.B(new p(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(O,P){this.g.push({data:O,options:P}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:O,options:P}=this.g.shift();if(this.f&&P.compressed){const q=await this.w(this.f,O);this.s(q,P)}else this.s(O,{...P,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(O,P){return new Promise((q,K)=>{O.write(P),O.flush(J=>q(J))})}acceptFrame(O,P,q){this.h.push({data:O,isCompressed:P,isLastFrameOfMessage:q}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const O=this.h.shift();if(this.b&&O.isCompressed){const P=await this.C(this.b,O.data,O.isLastFrameOfMessage);this.r.fire(P)}else this.r.fire(O.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(O,P,q){return new Promise((K,J)=>{O.write(P),q&&O.write(C.$Ne.fromByteArray([0,0,255,255])),O.flush(_=>K(_))})}}class i extends o.$Uc{get recordedInflateBytes(){return this.j?C.$Ne.concat(this.f):C.$Ne.alloc(0)}constructor(O,P,q,K){super(),this.h=O,this.j=P,this.a=this.B(new y.$le),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(K),this.b.on("error",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:J?.message,code:J?.code}),this.a.fire(J)}),this.b.on("data",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,J),this.g.push(C.$Ne.wrap(J))}),q&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,q.buffer),this.b.write(q.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(O){this.j&&this.f.push(O.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,O),this.b.write(O.buffer)}flush(O){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const P=C.$Ne.concat(this.g);this.g.length=0,O(P)})}}class p extends o.$Uc{constructor(O,P){super(),this.g=O,this.a=this.B(new y.$le),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,q),this.f.push(C.$Ne.wrap(q))})}write(O){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,O.buffer),this.b.write(O.buffer)}flush(O){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let P=C.$Ne.concat(this.f);this.f.length=0,P=P.slice(0,P.byteLength-4),O(P)})}}function n(L,O){if(O===0)return;const P=L.byteLength>>>2;for(let ge=0;ge<P;ge++){const le=L.readUInt32BE(ge*4);L.writeUInt32BE(le^O,ge*4)}const q=P*4,K=L.byteLength-q,J=O>>>24&255,_=O>>>16&255,de=O>>>8&255;K>=1&&L.writeUInt8(L.readUInt8(q)^J,q),K>=2&&L.writeUInt8(L.readUInt8(q+1)^_,q+1),K>=3&&L.writeUInt8(L.readUInt8(q+2)^de,q+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const l={[w.Platform.Linux]:107,[w.Platform.Mac]:103};function r(){const L=(0,m.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const O=process.platform!=="darwin"&&e.$wi?e.$wi:(0,E.tmpdir)(),P=(0,D.$jc)(O,`vscode-ipc-${L}.sock`);return c(P),P}function h(L,O,P){const K=(0,t.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${K}-${P}-${O}-sock`;const J=P.substr(0,4),_=O.substr(0,6);let de;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?de=(0,D.$jc)(e.$wi,`vscode-${K}-${J}-${_}.sock`):de=(0,D.$jc)(L,`${J}-${_}.sock`),c(de),de}function c(L){const O=l[w.$v];typeof O=="number"&&L.length>=O&&console.warn(`WARNING: IPC handle "${L}" is longer than ${O} chars, try a shorter --user-data-dir`)}class S extends $.$ji{static b(O){const P=y.Event.fromNodeEventEmitter(O,"connection");return y.Event.map(P,q=>({protocol:new a.$qi(new d(q,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(q,"close"))}))}constructor(O){super(S.b(O)),this.d=O}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=S;function I(L){return new Promise((O,P)=>{const q=(0,s.createServer)();q.on("error",P),q.listen(L,()=>{q.removeListener("error",P),O(new S(q))})})}function R(L,O){return new Promise((P,q)=>{const K=(0,s.createConnection)(L,()=>{K.removeListener("error",q),P(a.$ri.fromSocket(new d(K,`ipc-client${O}`),O))});K.once("error",q)})}}),define(Re[154],Ae([1,0,92,13,14,9,10,27,28,93,11,46,224,277]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,e.$gs=d;let a=class extends w.$9p{constructor(v,g,b,i){super(i),this.m=v,this.n=g,this.r=b,this.s(),this.B(v.onDidChangeConfiguration(p=>{p.affectsConfiguration("http")&&this.s()}))}s(){const v=this.m.getValue("http");this.f=v?.proxy,this.g=!!v?.proxyStrictSSL,this.h=v?.proxyAuthorization}async request(v,g){const{f:b,g:i}=this;let p;try{p=await(0,o.$Rm)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$9)(r)))}const n={...process.env,...p},l=v.agent?v.agent:await(0,m.$es)(v.url||"",n,{proxyUrl:b,strictSSL:i});return v.agent=l,v.strictSSL=i,this.h&&(v.headers={...v.headers||{},"Proxy-Authorization":this.h}),this.c(v.isChromiumNetwork?"electron":"node",v,()=>d(v,g))}async resolveProxy(v){}async lookupAuthorization(v){}async lookupKerberosAuthorization(v){try{const g=await new Promise((l,r)=>{ue(["kerberos"],l,r)}).then(Ue),b=new URL(v),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${b}`,`spn:${i}`),"Negotiate "+await(await g.initializeClient(i)).step("")}catch(g){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",g);return}}async loadCertificates(){return(await new Promise((g,b)=>{ue(["@vscode/proxy-agent"],g,b)}).then(Ue)).loadSystemCertificates({log:this.r})}};e.$fs=a,e.$fs=a=Be([je(0,A.$_i),je(1,y.$Ni),je(2,D.$ak),je(3,D.$bk)],a);async function u(f){return((0,t.parse)(f.url).protocol==="https:"?await new Promise((b,i)=>{ue(["https"],b,i)}).then(Ue):await new Promise((b,i)=>{ue(["http"],b,i)}).then(Ue)).request}async function d(f,v){return s.Promises.withAsyncBody(async(g,b)=>{const i=(0,t.parse)(f.url),p=f.getRawRequest?f.getRawRequest(f):await u(f),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,C.$kg)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const l=p(n,r=>{const h=(0,C.$ig)(f.followRedirects)?f.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&h>0&&r.headers.location)d({...f,url:r.headers.location,followRedirects:h-1},v).then(g,b);else{let c=r;!f.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(c=r.pipe((0,$.createGunzip)())),g({res:r,stream:(0,E.$3e)(c)})}});l.on("error",b),f.timeout&&l.setTimeout(f.timeout),f.isChromiumNetwork&&l.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&l.write(f.data),l.end(),v.onCancellationRequested(()=>{l.abort(),b(new k.$4)})})}}),define(Re[155],Ae([1,0,59,84,14,6,2,12,8,3,66,76,27,11,93,142,143,54,264]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Dn=g,t=Ue(t),s=Ue(s);async function g(r={},h,c,S,I,R){const L=await(0,d.$1m)(c,S.userDataPath);let O={};if(h)try{O=await(0,a.$Rm)(R,I,S.args,process.env)}catch(de){I.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",de)}const q={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(L),...r},K=S.isBuilt?(0,y.$jc)(S.appRoot,"bin"):(0,y.$jc)(S.appRoot,"resources","server","bin-dev"),J=(0,y.$jc)(K,"remote-cli");let _=p(q,"PATH");return _?_=J+y.$tc+_:_=J,n(q,"PATH",_),S.args["without-browser-env-var"]||(q.BROWSER=(0,y.$jc)(K,"helpers",o.$j?"browser.cmd":"browser.sh")),l(q),q}class b{constructor(h,c){this.socket=h,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let h,c,S;return this.socket instanceof w.$ui?(h=!0,c=!1,S=E.$Ne.alloc(0)):(h=!1,c=this.socket.permessageDeflate,S=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:h,permessageDeflate:c,inflateBytes:S.buffer.toString("base64")}}}let i=class extends C.$Uc{constructor(h,c,S,I,R,L,O,P){super(),this.m=h,this.n=R,this.r=L,this.s=O,this.t=P,this.b=new k.$le,this.onClose=this.b.event,this.c=!o.$j||!this.n.args["socket-path"],this.f=!1,this.g=c,this.h=null,this.j=new b(S,I),this.w("New connection established.")}dispose(){this.D(),super.dispose()}get u(){return`[${this.g}][${this.m.substr(0,8)}][ExtensionHostConnection] `}w(h){this.r.info(`${this.u}${h}`)}y(h){this.r.error(`${this.u}${h}`)}async z(h,c){const S=new C.$Tc;S.add(c.socket),S.add((0,C.$Sc)(()=>{h.destroy()}));const I=()=>{S.dispose()};S.add(c.socket.onEnd(I)),S.add(c.socket.onClose(I)),S.add(k.Event.fromNodeEventEmitter(h,"end")(I)),S.add(k.Event.fromNodeEventEmitter(h,"close")(I)),S.add(k.Event.fromNodeEventEmitter(h,"error")(I)),S.add(c.socket.onData(R=>h.write(R.buffer))),S.add(k.Event.fromNodeEventEmitter(h,"data")(R=>{c.socket.write(E.$Ne.wrap(R))})),c.initialDataChunk.byteLength>0&&h.write(c.initialDataChunk.buffer)}async C(h,c){await c.socketDrain();const S=c.toIExtHostSocketMessage();let I;c.socket instanceof w.$ui?I=c.socket.socket:I=c.socket.socket.socket,h.send(S,I)}shortenReconnectionGraceTimeIfNecessary(){if(!this.h)return;const h={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.h.send(h)}acceptReconnection(h,c,S){this.g=h,this.w("The client has reconnected.");const I=new b(c,S);if(!this.h){this.j=I;return}this.C(this.h,I)}D(){this.f||(this.f=!0,this.j&&(this.j.socket.end(),this.j=null),this.h&&(this.h.kill(),this.h=null),this.b.fire(void 0))}async start(h){try{let c=process.execArgv?process.execArgv.filter(J=>!/^--inspect(-brk)?=/.test(J)):[];h.port&&!process.pkg&&(c=[`--inspect${h.break?"-brk":""}=${h.port}`]);const S=await g(h.env,!0,h.language,this.n,this.r,this.t);(0,D.$mm)(S);let I;if(this.c)(0,v.$fn)(new v.$dn,S),I=null;else{const{namedPipeServer:J,pipeName:_}=await this.F();(0,v.$fn)(new v.$cn(_),S),I=J}const R={env:S,execArgv:c,silent:!0};R.execArgv.unshift("--dns-result-order=ipv4first");const L=["--type=extensionHost","--transformURIs"],O=this.n.args["use-host-proxy"];L.push(`--useHostProxy=${O?"true":"false"}`),this.h=t.fork(A.$Zg.asFileUri("bootstrap-fork").fsPath,L,R);const P=this.h.pid;this.w(`<${P}> Launched Extension Host Process.`),this.h.stdout.setEncoding("utf8"),this.h.stderr.setEncoding("utf8");const q=k.Event.fromNodeEventEmitter(this.h.stdout,"data"),K=k.Event.fromNodeEventEmitter(this.h.stderr,"data");if(this.B(q(J=>this.w(`<${P}> ${J}`))),this.B(K(J=>this.w(`<${P}><stderr> ${J}`))),this.h.on("error",J=>{this.y(`<${P}> Extension Host Process had an error`),this.r.error(J),this.D()}),this.h.on("exit",(J,_)=>{this.s.setExitInfo(this.m,{code:J,signal:_}),this.w(`<${P}> Extension Host Process exited with code: ${J}, signal: ${_}.`),this.D()}),I)I.on("connection",J=>{I.close(),this.z(J,this.j)});else{const J=_=>{_.type==="VSCODE_EXTHOST_IPC_READY"&&(this.h.removeListener("message",J),this.C(this.h,this.j),this.j=null)};this.h.on("message",J)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}F(){return new Promise((h,c)=>{const S=(0,w.$xi)(),I=s.createServer();I.on("error",c),I.listen(S,()=>{I?.removeListener("error",c),h({pipeName:S,namedPipeServer:I})})})}};e.$En=i,e.$En=i=Be([je(4,f.$an),je(5,$.$ak),je(6,u.$Ym),je(7,m.$_i)],i);function p(r,h){const c=Object.keys(r).filter(I=>I.toLowerCase()===h.toLowerCase()),S=c.length>0?c[0]:h;return r[S]}function n(r,h,c){const S=Object.keys(r).filter(R=>R.toLowerCase()===h.toLowerCase()),I=S.length>0?S[0]:h;r[I]=c}function l(r){for(const h of Object.keys(r))r[h]===null&&delete r[h]}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[278],Ae([1,0,88,11,70,128,27,46,154,40,24,30,140,138,94,121,61,2,122,71,12,15,29,54,131,91,132,9,4,8,31,222,87,35,136,69,3,63,144,33,53,72,141,139,124,125,7,279]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O,P,q,K,J,_,de,ge,le,z,Q,M,V,ne,re,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=x,d=dt(d);class oe extends f.$Uc{constructor(T,X){super(),this.a=T,this.b=X,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const T=await this.f();await T.invokeFunction(async X=>{const he=X.get(C.$_i),B=X.get(s.$ak);J.$j&&(he.getValue("security.restrictUNCAccess")===!1?(0,me.disableUNCAccessRestrictions)():(0,me.addUNCHostToAllowlist)(he.getValue("security.allowedUNCHosts")));try{await this.g(T.createInstance(l.$wq,new s.$ik(B.getLevel(),!1)))}catch(U){throw B.error(U),console.error((0,c.$9)(U)),U}})}async f(){const T=new t.$Di,X={_serviceBrand:void 0,...d.default};T.set(p.$tk,X);const he=new n.$bn(this.a,X);T.set(n.$an,he);const B=new ne.$AR((0,s.$ok)(he),he.logsHome);T.set(s.$bk,B);const U=new V.$KR(this.B(B.createLogger("remoteCLI",{name:(0,re.localize)(12814,null)})));T.set(s.$ak,U),U.trace(`Remote configuration data at ${this.b}`),U.trace("process arguments:",this.a);const H=this.B(new v.$3q(U));T.set(i.$al,H),H.registerProvider(b.Schemas.file,this.B(new g.$tr(U)));const F=new q.$Us(H);T.set(P.$Kl,F);const W=this.B(new Q.$IR(F,he,H,U));T.set(ge.$Ml,W);const Y=this.B(new k.$Xo(W.defaultProfile.settingsResource,H,new z.$vo,U));return T.set(C.$_i,Y),await Promise.all([Y.initialize(),W.init()]),T.set(A.$8p,new E.$Ci(y.$fs)),T.set(O.$2o,new E.$Ci(L.$ZR)),T.set(D.$_l,o.$zp),T.set(w.$lp,new E.$Ci(m.$sq)),T.set(le.$Jq,new E.$Ci(M.$JR)),T.set(_.$Nq,new E.$Ci(de.$wR)),T.set(a.$tq,new E.$Ci(a.$vq)),T.set($.$Yq,new E.$Ci($.$Zq)),T.set(r.$_r,new E.$Ci(h.$bs)),new u.$wr(T)}async g(T){if(this.a["list-extensions"])return T.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const X={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return T.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),X,!!this.a.force)}else{if(this.a["uninstall-extension"])return T.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return T.updateExtensions();if(this.a["locate-extension"])return T.locateExtension(this.a["locate-extension"])}}h(T){return T.map(X=>/\.vsix$/i.test(X)?S.URI.file((0,I.$ic)(X)?X:(0,I.$jc)((0,R.cwd)(),X)):X)}}function ie(G){setTimeout(()=>process.exit(G),0)}async function x(G,T,X){if(G.help){const B=d.default.serverApplicationName+(J.$j?".cmd":"");console.log((0,K.$Fm)(d.default.nameLong,B,d.default.version,X,{noInputFiles:!0,noPipe:!0}));return}if(G.version){console.log((0,K.$Gm)(d.default.version,d.default.commit));return}const he=new oe(G,T);try{await he.run(),ie(0)}catch{ie(1)}finally{he.dispose()}}}),define(Re[280],Ae([1,0,76,290,23,275,4,11,97]),function(ue,e,t,s,E,k,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0,s=Ue(s),E=Ue(E);class o{constructor(m,$,a){this.b=m,this.c=$,this.f=a,this.a=s.createServer((u,d)=>this.h(u,d)),this.g().catch(u=>($.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,$){const a=(d,f)=>{$.writeHead(d,{"content-type":"application/json"}),$.end(JSON.stringify(f||null),v=>v&&this.c.error(v))},u=[];m.setEncoding("utf8"),m.on("data",d=>u.push(d)),m.on("end",async()=>{try{const d=JSON.parse(u.join(""));let f;switch(d.type){case"open":f=await this.i(d);break;case"openExternal":f=await this.j(d);break;case"status":f=await this.l(d);break;case"extensionManagement":f=await this.k(d);break;default:a(404,`Unknown message type: ${d.type}`);break}a(200,f)}catch(d){const f=d instanceof Error?d.message:JSON.stringify(d);a(500,f),this.c.error("Error while processing pipe request",d)}})}async i(m){const{fileURIs:$,folderURIs:a,forceNewWindow:u,diffMode:d,mergeMode:f,addMode:v,forceReuseWindow:g,gotoLineMode:b,waitMarkerFilePath:i,remoteAuthority:p}=m,n=[];if(Array.isArray(a))for(const c of a)try{n.push({folderUri:C.URI.parse(c)})}catch{}if(Array.isArray($))for(const c of $)try{(0,y.$$i)(c)?n.push({workspaceUri:C.URI.parse(c)}):n.push({fileUri:C.URI.parse(c)})}catch{}const l=i?C.URI.file(i):void 0,h={forceNewWindow:u,diffMode:d,mergeMode:f,addMode:v,gotoLineMode:b,forceReuseWindow:g,preferNewWindow:!g&&!l&&!v,waitMarkerFileURI:l,remoteAuthority:p};this.b.executeCommand("_remoteCLI.windowOpen",n,h)}async j(m){for(const $ of m.uris){const a=C.URI.parse($),u=a.scheme==="file"?a:$;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(m){const $=u=>u?.map(d=>/\.vsix$/i.test(d)?C.URI.parse(d):d),a={list:m.list,install:$(m.install),uninstall:$(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&E.existsSync(this.f)&&E.unlinkSync(this.f)}}e.$LQ=o;let D=class extends o{constructor(m,$){super(m,$,(0,t.$xi)())}};e.$MQ=D,e.$MQ=D=Be([je(0,k.$GQ),je(1,A.$ak)],D)}),define(Re[281],Ae([1,0,32,6,20,2,8,3,4,76,74,280,134,96,145,259,261,155,13,135]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=void 0,t=Ue(t),C=Ue(C),A=Ue(A),u=Ue(u);class b extends d.$oR{constructor(n,l,r,h,c){super({getFolderUri:S=>{const I=l.filter(R=>R.name===S);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(S,I)=>h[`config:${I}`],getExecPath:()=>n.VSCODE_EXEC_PATH,getAppRoot:()=>n.VSCODE_CWD,getFilePath:()=>{if(r)return C.$hc(r.fsPath)},getSelectedText:()=>h.selectedText,getLineNumber:()=>h.lineNumber,getExtension:async S=>{const R=(await c.getInstalled()).find(L=>L.identifier.id===S);return R&&{extensionLocation:R.location}}},void 0,Promise.resolve(t.homedir()),Promise.resolve(n))}}class i extends k.$Uc{constructor(n,l,r,h,c,S){super(),this.g=n,this.h=l,this.j=r,this.m=h,this.n=c,this.r=S,this.a=0,this.b=new Map,this.c=this.B(new s.$le),this.onExecuteCommand=this.c.event}async call(n,l,r){switch(l){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,r);case a.RemoteTerminalChannelRequest.CreateProcess:{const h=(0,D.$Vs)(n.remoteAuthority);return this.s(h,r)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,r);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,r);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,r);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,r);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,r);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,r);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,r);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(r[0],r[1],r[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,r);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,r);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,r);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(r[0],r[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(r);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(r);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,r);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,r);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,r);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,r);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,r);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,r);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,r);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(r[0],r[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(r[0],r[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${l} not found`)}listen(n,l,r){switch(l){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||s.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||s.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||s.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||s.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||s.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||s.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${l} not found`)}async s(n,l){const r={name:l.shellLaunchConfig.name,executable:l.shellLaunchConfig.executable,args:l.shellLaunchConfig.args,cwd:typeof l.shellLaunchConfig.cwd=="string"||typeof l.shellLaunchConfig.cwd>"u"?l.shellLaunchConfig.cwd:y.URI.revive(n.transformIncoming(l.shellLaunchConfig.cwd)),env:l.shellLaunchConfig.env,useShellEnvironment:l.shellLaunchConfig.useShellEnvironment,reconnectionProperties:l.shellLaunchConfig.reconnectionProperties,type:l.shellLaunchConfig.type,isFeatureTerminal:l.shellLaunchConfig.isFeatureTerminal},h=await(0,f.$Dn)(l.resolverEnv,!!l.shellLaunchConfig.useShellEnvironment,A.$x,this.g,this.h,this.r);this.h.trace("baseEnv",h);const c=z=>({uri:y.URI.revive(n.transformIncoming(z.uri)),name:z.name,index:z.index,toResource:()=>{throw new Error("Not implemented")}}),S=l.workspaceFolders.map(c),I=l.activeWorkspaceFolder?c(l.activeWorkspaceFolder):void 0,R=l.activeFileResource?y.URI.revive(n.transformIncoming(l.activeFileResource)):void 0,L=new b(h,S,R,l.resolvedVariables,this.n),O=u.$kR(I,process.env,L),P=await u.$jR(r,t.homedir(),O,I?.uri,l.configuration["terminal.integrated.cwd"],this.h);r.cwd=P;const q=A.$j?"terminal.integrated.env.windows":A.$k?"terminal.integrated.env.osx":"terminal.integrated.env.linux",K=l.configuration[q],J=await u.$lR(r,K,O,this.m.version,l.configuration["terminal.integrated.detectLocale"],h);if((0,g.$dR)(r)){const z=[];for(const[ne,re,me]of l.envVariableCollections)z.push([ne,{map:(0,$.$Hs)(re),descriptionMap:(0,$.$Is)(me)}]);const Q=new Map(z),M=new m.$Ls(Q),V=I?I??void 0:void 0;await M.applyToProcessEnvironment(J,{workspaceFolder:V},O)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:P,cols:l.cols,rows:l.rows,env:J});const _=(0,o.$xi)();J.VSCODE_IPC_HOOK_CLI=_;const de=await this.j.createProcess(r,P,l.cols,l.rows,l.unicodeVersion,J,h,l.options,l.shouldPersistTerminal,l.workspaceId,l.workspaceName),ge={executeCommand:(z,...Q)=>this.t(de,z,Q,n)},le=new w.$LQ(ge,this.h,_);return this.j.onProcessExit(z=>z.id===de&&le.dispose()),{persistentTerminalId:de,resolvedShellLaunchConfig:r}}t(n,l,r,h){const{resolve:c,reject:S,promise:I}=(0,v.$yh)(),R=++this.a;this.b.set(R,{resolve:c,reject:S,uriTransformer:h});const L=(0,E.$go)(r,O=>{if(O&&O.$mid===1)return h.transformOutgoing(O);if(O&&O instanceof y.URI)return h.transformOutgoingURI(O)});return this.c.fire({reqId:R,persistentProcessId:n,commandId:l,commandArgs:L}),I}u(n,l,r){const h=this.b.get(n);if(!h)return;this.b.delete(n);const c=(0,E.$go)(r,S=>{if(S&&S.$mid===1)return h.uriTransformer.transformIncoming(S)});l?h.reject(c):h.resolve(c)}w(n){return this.j.getDefaultSystemShell(n)}async y(n,l,r,h){return this.j.getProfiles(n,l,r,h)||[]}z(){return{...process.env}}C(n,l){return this.j.getWslPath(n,l)}D(){return this.j.reduceConnectionGraceTime()}}e.$pR=i});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[282],Ae([1,0,32,6,2,12,8,110,26,49,60,27,128,195,87,196,28,140,30,94,131,220,138,15,122,71,70,121,88,91,132,11,61,29,46,223,154,130,24,40,235,52,242,35,136,253,254,229,233,281,74,54,263,276,142,63,144,53,33,72,234,125,141,139,124,123,7,271,219,247,239]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O,P,q,K,J,_,de,ge,le,z,Q,M,V,ne,re,me,oe,ie,x,G,T,X,he,B,U,H,F,W,Y,ae,Ee,Le,be,pe,we,Te,ce,ye,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UR=void 0,e.$TR=qe,C=Ue(C),O=dt(O),le=dt(le);const ze="monacoworkbench";async function qe(nt,tt,et,Xe){const $e=new S.$Di,Ne=new Ze,Fe={_serviceBrand:void 0,...O.default};$e.set(P.$tk,Fe);const ke=new G.$bn(tt,Fe);$e.set(d.$Mi,ke),$e.set(d.$Ni,ke);const Ce=new ae.$AR((0,L.$ok)(ke),ke.logsHome);$e.set(L.$bk,Ce),Ne.registerChannel("logger",new pe.$us(Ce,ht=>Ge(ht.remoteAuthority)));const te=Ce.createLogger("remoteagent",{name:(0,we.localize)(12800,null)}),ee=new be.$KR(te,[new Ye((0,L.$ok)(ke))]);$e.set(L.$ak,ee),setTimeout(()=>rt(ke.logsHome.with({scheme:k.Schemas.file}).fsPath).then(null,ht=>ee.error(ht)),1e4),ee.onDidChangeLogLevel(ht=>(0,L.log)(ee,ht,`Log level changed to ${(0,L.$pk)(ee.getLevel())}`)),ee.trace(`Remote configuration data at ${et}`),ee.trace("process arguments:",ke.args),Array.isArray(Fe.serverGreeting)&&ee.info(`

${Fe.serverGreeting.join(`
`)}

`),Ne.registerChannel($.$Zo.ChannelName,new $.$Zo);const Se=new o.$ni(ht=>ht.clientId==="renderer"),We=Xe.add(new l.$3q(ee));$e.set(n.$al,We),We.registerProvider(k.Schemas.file,Xe.add(new r.$tr(ee)));const Ke=new V.$Us(We);$e.set(M.$Kl,Ke);const _e=new m.$Xo(ke.machineSettingsResource,We,new W.$vo,ee);$e.set(w.$_i,_e);const st=new Ee.$IR(Ke,ke,We,ee);$e.set(F.$Ml,st),Ne.registerChannel("userDataProfiles",new ye.$QR(st,ht=>Ge(ht.remoteAuthority)));const[,,ut,gt,wt]=await Promise.all([_e.initialize(),st.init(),(0,A.$Tn)(ee.error.bind(ee)),(0,A.$Un)(ee.error.bind(ee)),(0,A.$Vn)(ee.error.bind(ee))]),Pt=new he.$Zm;$e.set(he.$Ym,Pt);const Mt=new J.$fs(_e,ke,ee,Ce);$e.set(q.$8p,Mt);let ft=ge.$Dp;const vt=(0,ge.$Jp)(Fe,_e);if((0,ge.$Ep)(Fe,ke)){!(0,ge.$Fp)(Fe,ke)&&Fe.aiConfig?.ariaKey&&(ft=new Y.$yR(Mt,vt,ze,null,Fe.aiConfig.ariaKey),Xe.add((0,E.$Sc)(()=>ft?.flush())));const ht={appenders:[ft],commonProperties:(0,_.$vp)((0,t.release)(),(0,t.hostname)(),process.arch,Fe.commit,Fe.version+"-remote",ut,gt,wt,vt,"remoteAgent"),piiPaths:(0,ge.$Kp)(ke)},$t=ke.args["telemetry-level"];let bt=de.TelemetryLevel.USAGE;$t==="all"?bt=de.TelemetryLevel.USAGE:$t==="error"?bt=de.TelemetryLevel.ERROR:$t==="crash"?bt=de.TelemetryLevel.CRASH:$t!==void 0&&(bt=de.TelemetryLevel.NONE),$e.set(oe.$9s,new h.$Ci(oe.$7s,[ht,bt]))}else $e.set(oe.$9s,oe.$8s);$e.set(v.$lp,new h.$Ci(f.$sq));const Et=Ne.getChannel("download",Se);$e.set(a.$2o,new u.$4o(Et,()=>Ge("renderer"))),$e.set(H.$Jq,new h.$Ci(Le.$JR)),$e.set(B.$Nq,new h.$Ci(U.$wR)),$e.set(g.$tq,new h.$Ci(g.$vq)),$e.set(p.$Yq,new h.$Ci(p.$Zq));const St=new c.$wr($e);$e.set(I.$_r,St.createInstance(R.$bs));const Vt=St.createInstance(ve.$SR,{graceTime:D.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:D.ProtocolConstants.ReconnectionShortGraceTime,scrollback:_e.getValue(z.TerminalSettingId.PersistentSessionScrollback)??100}),Rt=St.createInstance(Q.$Qs,Vt);return $e.set(z.$ps,Rt),St.invokeFunction(ht=>{const $t=ht.get(p.$Yq),bt=ht.get(B.$Nq),Dt=ht.get(v.$lp),zt=ht.get(I.$_r),Ot=new ne.$3s(nt,ke,st,Pt);Ne.registerChannel("remoteextensionsenvironment",Ot);const en=new me.$0s(ht.get(oe.$9s),ft);Ne.registerChannel("telemetry",en),Ne.registerChannel(T.$qR,new ie.$pR(ke,ee,Rt,Fe,$t,_e));const kt=new Te.$OR(St.createInstance(b.$wq,ee),ke,st,bt,ee,Dt,zt);Ne.registerChannel(ce.$NR,new Te.$PR(kt,Tt=>Ge(Tt.remoteAuthority)));const Bt=Xe.add(new re.$6s(ee,ke));Ne.registerChannel(X.$uR,Bt),Ne.registerChannel("request",new K.$cs(ht.get(q.$8p)));const Gt=new i.$xq($t,Tt=>Ge(Tt.remoteAuthority));return Ne.registerChannel("extensions",Gt),kt.whenExtensionsReady().then(()=>$t.cleanUp()),Xe.add(new le.default(ht.get(de.$_l))),{telemetryService:ht.get(de.$_l)}}),{socketServer:Ne,instantiationService:St}}const Je=Object.create(null);function Ge(nt){return Je[nt]||(Je[nt]=(0,x.$Vs)(nt)),Je[nt]}class Ze extends o.$ji{constructor(){const tt=new s.$le;super(tt.event),this.b=tt}acceptConnection(tt,et){this.b.fire({protocol:tt,onDidClientDisconnect:et})}}e.$UR=Ze;class Ye extends L.$fk{constructor(tt=L.$dk){super(),this.setLevel(tt),this.g=!!process.stdout.isTTY}trace(tt,...et){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${it()}]\x1B[0m`,tt,...et):console.log(`[${it()}]`,tt,...et))}debug(tt,...et){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${it()}]\x1B[0m`,tt,...et):console.log(`[${it()}]`,tt,...et))}info(tt,...et){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${it()}]\x1B[0m`,tt,...et):console.log(`[${it()}]`,tt,...et))}warn(tt,...et){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${it()}]\x1B[0m`,tt,...et):console.warn(`[${it()}]`,tt,...et))}error(tt,...et){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${it()}]\x1B[0m`,tt,...et):console.error(`[${it()}]`,tt,...et))}flush(){}}function it(){const nt=new Date;return`${lt(nt.getHours())}:${lt(nt.getMinutes())}:${lt(nt.getSeconds())}`}function lt(nt){return nt<10?`0${nt}`:String(nt)}async function rt(nt){const tt=C.$nc(nt),et=C.$mc(nt),Ne=(await y.Promises.readdir(et)).filter(ke=>/^\d{8}T\d{6}$/.test(ke)).sort().filter(ke=>ke!==tt),Fe=Ne.slice(0,Math.max(0,Ne.length-9));await Promise.all(Fe.map(ke=>y.Promises.rm(C.$jc(et,ke))))}}),define(Re[283],Ae([1,0,95,23,84,284,92,103,14,34,9,36,2,12,8,43,3,16,4,22,181,183,279,60,76,27,5,11,29,218,24,155,248,100,54,282,250]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m,$,a,u,d,f,v,g,b,i,p,n,l,r,h,c,S,I,R,L,O,P,q,K,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=ge,t=Ue(t),s=Ue(s),E=Ue(E),C=Ue(C),u=Ue(u),d=Ue(d);const _=5*60*1e3;let de=class extends m.$Uc{constructor(Q,M,V,ne,re,me,oe,ie,x){super(),this.n=Q,this.r=M,this.s=V,this.t=me,this.u=oe,this.w=ie,this.y=x,this.h=le.create(this.u),this.j=(0,$.$Tg)(oe,re),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ne?this.y.createInstance(J.$XR,this.r,re??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(Q,M){if(Q.method!=="GET")return(0,J.$VR)(Q,M,405,`Unsupported method ${Q.method}`);if(!Q.url)return(0,J.$VR)(Q,M,400,"Bad request.");const V=C.parse(Q.url,!0);let ne=V.pathname;if(!ne)return(0,J.$VR)(Q,M,400,"Bad request.");if(ne.startsWith(this.j)&&ne.charCodeAt(this.j.length)===o.CharCode.Slash&&(ne=ne.substring(this.j.length)),ne==="/version")return M.writeHead(200,{"Content-Type":"text/plain"}),void M.end(this.u.commit||"");if(ne==="/delay-shutdown")return this.N(),M.writeHead(200),void M.end("OK");if(!(0,P.$Ln)(this.r,Q,V))return(0,J.$VR)(Q,M,403,"Forbidden.");if(ne==="/vscode-remote-resource"){const re=V.query.path;if(typeof re!="string")return(0,J.$VR)(Q,M,400,"Bad request.");let me;try{me=v.URI.from({scheme:$.Schemas.file,path:re}).fsPath}catch{return(0,J.$VR)(Q,M,400,"Bad request.")}const oe=Object.create(null);this.t.isBuilt&&((0,w.$Eg)(me,this.t.builtinExtensionsPath,!d.$l)||(0,w.$Eg)(me,this.t.extensionsPath,!d.$l))&&(oe["Cache-Control"]="public, max-age=31536000"),oe.Vary="Origin";const ie=Q.headers.origin;return ie&&this.h.matches(ie)&&(oe["Access-Control-Allow-Origin"]=ie),(0,J.$WR)(me,J.CacheControl.ETAG,this.w,Q,M,oe)}if(this.g){this.g.handle(Q,M,V);return}return M.writeHead(404,{"Content-Type":"text/plain"}),void M.end("Not found")}handleUpgrade(Q,M){let V=(0,g.$2g)(),ne=!1,re=!1;if(Q.url){const T=C.parse(Q.url,!0).query;typeof T.reconnectionToken=="string"&&(V=T.reconnectionToken),T.reconnection==="true"&&(ne=!0),T.skipWebSocketFrames==="true"&&(re=!0)}if(Q.headers.upgrade===void 0||Q.headers.upgrade.toLowerCase()!=="websocket"){M.end("HTTP/1.1 400 Bad Request");return}const me=Q.headers["sec-websocket-key"],oe=t.createHash("sha1");oe.update(me+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const x=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${oe.digest("base64")}`];let G=!1;if(!re&&!this.t.args["disable-websocket-compression"]&&Q.headers["sec-websocket-extensions"]){const T=Array.isArray(Q.headers["sec-websocket-extensions"])?Q.headers["sec-websocket-extensions"]:[Q.headers["sec-websocket-extensions"]];for(const X of T)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(X)){if(/\b(permessage-deflate)\b/.test(X)){G=!0,x.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(X)){G=!0,x.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}M.write(x.join(`\r
`)+`\r
\r
`),M.setTimeout(0),M.setNoDelay(!0),re?this.D(new l.$ui(M,`server-connection-${V}`),ne,V):this.D(new l.$vi(new l.$ui(M,`server-connection-${V}`),G,null,!0),ne,V)}handleServerError(Q){this.w.error("Error occurred in server"),this.w.error(Q)}z(Q){let M;return Q instanceof l.$ui?M=Q.socket:M=Q.socket.socket,M.remoteAddress||"<unknown>"}async C(Q,M,V){const ne=M.getSocket();this.w.error(`${Q} ${V}.`);const re={type:"error",reason:V};M.sendControl(y.$Ne.fromString(JSON.stringify(re))),M.dispose(),await ne.drain(),ne.dispose()}D(Q,M,V){const ne=this.z(Q),re=`[${ne}][${V.substr(0,8)}]`,me=new n.$ti({socket:Q}),oe=this.s?new this.s.validator:null,ie=this.s?new this.s.signer:null;let x;(function(he){he[he.WaitingForAuth=0]="WaitingForAuth",he[he.WaitingForConnectionType=1]="WaitingForConnectionType",he[he.Done=2]="Done",he[he.Error=3]="Error"})(x||(x={}));let G=x.WaitingForAuth;const T=he=>{G=x.Error,X.dispose(),this.C(re,me,he)},X=me.onControlMessage(he=>{if(G===x.WaitingForAuth){let B;try{B=JSON.parse(he.toString())}catch{return T("Malformed first message")}if(B.type!=="auth")return T("Invalid first message");if(this.r.type===P.ServerConnectionTokenType.Mandatory&&!this.r.validate(B.auth))return T("Unauthorized client refused: auth mismatch");let U=(0,g.$2g)();if(ie)try{U=ie.sign(B.data)}catch{}let H=(0,g.$2g)();if(oe)try{H=oe.createNewMessage(H)}catch{}const F={type:"sign",data:H,signedData:U};me.sendControl(y.$Ne.fromString(JSON.stringify(F))),G=x.WaitingForConnectionType}else if(G===x.WaitingForConnectionType){let B;try{B=JSON.parse(he.toString())}catch{return T("Malformed second message")}if(B.type!=="connectionType")return T("Invalid second message");if(typeof B.signedData!="string")return T("Invalid second message field type");const U=B.commit,H=this.u.commit;if(U&&H&&U!==H)return T("Client refused: version mismatch");let F=!1;if(!oe)F=!0;else if(this.r.validate(B.signedData))F=!0;else try{F=oe.validate(B.signedData)==="ok"}catch{}if(!F){if(this.t.isBuilt)return T("Unauthorized client refused");this.w.error(`${re} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const W in this.b)this.b[W].shortenReconnectionGraceTimeIfNecessary();for(const W in this.a)this.a[W].shortenReconnectionGraceTimeIfNecessary();G=x.Done,X.dispose(),this.F(ne,re,me,Q,M,V,B)}})}async F(Q,M,V,ne,re,me,oe){const ie=oe.desiredConnectionType===I.ConnectionType.Management?`${M}[ManagementConnection]`:oe.desiredConnectionType===I.ConnectionType.ExtensionHost?`${M}[ExtensionHostConnection]`:M;if(oe.desiredConnectionType===I.ConnectionType.Management)if(re){if(!this.b[me])return this.f.has(me)?this.C(ie,V,"Unknown reconnection token (seen before)"):this.C(ie,V,"Unknown reconnection token (never seen)");V.sendControl(y.$Ne.fromString(JSON.stringify({type:"ok"})));const x=V.readEntireBuffer();V.dispose(),this.b[me].acceptReconnection(Q,ne,x)}else{if(this.b[me])return this.C(ie,V,"Duplicate reconnection token");V.sendControl(y.$Ne.fromString(JSON.stringify({type:"ok"})));const x=new O.$Fn(this.w,me,Q,V);this.n.acceptConnection(x.protocol,x.onClose),this.b[me]=x,this.f.add(me),x.onClose(()=>{delete this.b[me]})}else if(oe.desiredConnectionType===I.ConnectionType.ExtensionHost){const x=oe.args||{language:"en"},G=await this.I(x);if(G.port&&this.w.trace(`${ie} - startParams debug port ${G.port}`),this.w.trace(`${ie} - startParams language: ${G.language}`),this.w.trace(`${ie} - startParams env: ${JSON.stringify(G.env)}`),re){if(!this.a[me])return this.f.has(me)?this.C(ie,V,"Unknown reconnection token (seen before)"):this.C(ie,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(y.$Ne.fromString(JSON.stringify(G.port?{debugPort:G.port}:{})));const T=V.readEntireBuffer();V.dispose(),this.a[me].acceptReconnection(Q,ne,T)}else{if(this.a[me])return this.C(ie,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(y.$Ne.fromString(JSON.stringify(G.port?{debugPort:G.port}:{})));const T=V.readEntireBuffer();V.dispose();const X=this.y.createInstance(L.$En,me,Q,ne,T);this.a[me]=X,this.f.add(me),X.onClose(()=>{X.dispose(),delete this.a[me],this.J()}),X.start(G)}}else if(oe.desiredConnectionType===I.ConnectionType.Tunnel){const x=oe.args;this.G(V,x)}else return this.C(ie,V,"Unknown initial data received")}async G(Q,M){const V=Q.getSocket().socket,ne=Q.readEntireBuffer();Q.dispose(),V.pause();const re=await this.H(M.host,M.port);ne.byteLength>0&&re.write(ne.buffer),re.on("end",()=>V.end()),re.on("close",()=>V.end()),re.on("error",()=>V.destroy()),V.on("end",()=>re.end()),V.on("close",()=>re.end()),V.on("error",()=>re.destroy()),re.pipe(V),V.pipe(re)}H(Q,M){return new Promise((V,ne)=>{const re=E.createConnection({host:Q,port:M,autoSelectFamily:!0},()=>{re.removeListener("error",ne),re.pause(),V(re)});re.once("error",ne)})}I(Q){return typeof Q.port=="number"?(0,i.$4g)(Q.port,10,5e3).then(M=>(Q.port=M,Q)):(Q.debugId=void 0,Q.port=void 0,Q.break=void 0,Promise.resolve(Q))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(Q=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!Q?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},_))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};de=Be([je(5,q.$an),je(6,S.$tk),je(7,c.$ak),je(8,h.$Ei)],de);async function ge(z,Q,M){const V=await(0,P.$Kn)(Q);V instanceof P.$In&&(console.warn(V.message),process.exit(1));function ne(W){(0,D.setUnexpectedErrorHandler)(Y=>{(0,D.$X)(Y)&&Y.stack&&/unexpectedErrorHandler/.test(Y.stack)||W(Y)})}const re=[];ne(W=>{re.push(W),console.error(W)});let me=!1;process.on("SIGPIPE",()=>{me||(me=!0,(0,D.$Y)(new Error("Unexpected SIGPIPE")))});const oe=new m.$Tc,{socketServer:ie,instantiationService:x}=await(0,K.$TR)(V,Q,M,oe);x.invokeFunction(W=>{const Y=W.get(c.$ak);re.forEach(ae=>Y.error(ae)),re.length=0,ne(ae=>Y.error(ae))}),x.invokeFunction(W=>{const Y=W.get(r.$_i);d.$j&&(Y.getValue("security.restrictUNCAccess")===!1?(0,p.disableUNCAccessRestrictions)():(0,p.addUNCHostToAllowlist)(Y.getValue("security.allowedUNCHosts")))}),x.invokeFunction(W=>{const Y=W.get(c.$ak);if(d.$j&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const ae=(0,a.$jc)(process.env.HOMEDRIVE,"node_modules"),Ee=(0,a.$mc)((0,a.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Le=(0,a.$jc)(Ee,"node_modules");if(s.existsSync(ae)||s.existsSync(Le)){const be=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${ae}
* ${Le}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Y.warn(be),console.warn(be),process.exit(0)}}});const G=x.invokeFunction(W=>{const Y=W.get(c.$ak);if(s.existsSync((0,a.$jc)($.$Zg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Ee){Y.error(Ee)}return null});let T=Q["server-base-path"];T&&!T.startsWith("/")&&(T=`/${T}`);const X=s.existsSync($.$Zg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(X&&z&&typeof z!="string"){const W=V.type!==P.ServerConnectionTokenType.None?`?${$.$Rg}=${V.value}`:"";console.log(`Web UI available at http://localhost${z.port===80?"":`:${z.port}`}${T??""}${W}`)}const he=x.createInstance(de,ie,V,G,X,T);u.mark("code/server/ready");const B=k.performance.now(),U=global.vscodeServerStartTime,H=global.vscodeServerListenTime,F=global.vscodeServerCodeLoadedTime;if(x.invokeFunction(async W=>{const Y=W.get(R.$_l);if(Y.publicLog2("serverStart",{startTime:U,startedTime:H,codeLoadedTime:F,readyTime:B}),d.$l){const ae=W.get(c.$ak),Ee=await(0,b.$3g)(ae.error.bind(ae));Ee&&Y.publicLog2("serverPlatformInfo",{platformId:Ee.id,platformVersionId:Ee.version_id,platformIdLike:Ee.id_like})}}),Q["print-startup-performance"]){const W=A.$S.get();let Y="";Y+=`

### Load AMD-module
`,Y+=A.$S.toMarkdownTable(["Module","Duration"],W.amdLoad),Y+=`

### Load commonjs-module
`,Y+=A.$S.toMarkdownTable(["Module","Duration"],W.nodeRequire),Y+=`

### Invoke AMD-module factory
`,Y+=A.$S.toMarkdownTable(["Module","Duration"],W.amdInvoke),Y+=`

### Invoke commonjs-module
`,Y+=A.$S.toMarkdownTable(["Module","Duration"],W.nodeEval),Y+=`Start-up time: ${H-U}
`,Y+=`Code loading time: ${F-U}
`,Y+=`Initialized time: ${B-U}
`,Y+=`
`,console.log(Y)}return he}class le{static create(Q){const M=Q.webEndpointUrlTemplate,V=Q.commit,ne=Q.quality;if(!M||!V||!ne)return new le(null);const re=(0,g.$2g)(),oe=new URL(M.replace("{{uuid}}",re).replace("{{commit}}",V).replace("{{quality}}",ne)).origin,ie=(0,f.$hf)(oe).replace(re,"[a-zA-Z0-9\\-]+");try{const x=(0,f.$qf)(`^${ie}$`,!0,{matchCase:!1});return new le(x)}catch{return new le(null)}}constructor(Q){this.a=Q}matches(Q){return this.a?this.a.test(Q):!1}}});var dt=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Re[291],Ae([1,0,32,23,12,278,283,69,8,284,54,61,43]),function(ue,e,t,s,E,k,C,A,y,o,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=n,e.createServer=l,t=Ue(t),s=Ue(s),w=dt(w),m=Ue(m),m.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=o.performance.now();const $={onMultipleValues:(r,h)=>{console.error(`Option '${r}' can only be defined once. Using value ${h}.`)},onEmptyValue:r=>{console.error(`Ignoring option '${r}': Value must not be empty.`)},onUnknownOption:r=>{console.error(`Ignoring option '${r}': not supported for server.`)},onDeprecatedOption:(r,h)=>{console.warn(`Option '${r}' is deprecated: ${h}`)}},a=(0,A.$Dm)(process.argv.slice(2),D.$_m,$),u=a["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.$jc)(t.homedir(),w.default.serverDataFolderName||".vscode-remote"),d=(0,y.$jc)(u,"data"),f=(0,y.$jc)(d,"User"),v=(0,y.$jc)(f,"globalStorage"),g=(0,y.$jc)(f,"History"),b=(0,y.$jc)(d,"Machine");a["user-data-dir"]=d;const i=(0,y.$mc)(E.$Zg.asFileUri("").fsPath),p=(0,y.$jc)(i,"extensions");a["builtin-extensions-dir"]=p,a["extensions-dir"]=a["extensions-dir"]||(0,y.$jc)(u,"extensions"),[u,a["extensions-dir"],d,f,b,v,g].forEach(r=>{try{s.existsSync(r)||s.mkdirSync(r,{mode:448})}catch(h){console.error(h)}});function n(){(0,k.run)(a,u,D.$_m)}function l(r){return(0,C.$YR)(r,a,u)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/eaa41d57266683296de7d118f574d0c2652e1fc4/core/vs/server/node/server.main.js.map
